<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_io.C</h1>  </div>
</div>
<div class="contents">
<a href="xdr__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_io.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;xdr_io.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;legacy_xdr_io.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;xdr_cxx.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;enum_xdr_mode.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;node.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;partitioner.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">//-----------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// anonymous namespace for implementation details</span>
<a name="l00046"></a>00046 <span class="keyword">namespace </span>{
<a name="l00047"></a>00047   <span class="keyword">struct </span>ElemBCData
<a name="l00048"></a>00048   {
<a name="l00049"></a>00049     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>       elem_id;
<a name="l00050"></a>00050     <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side;
<a name="l00051"></a>00051     <span class="keywordtype">short</span> <span class="keywordtype">int</span>          bc_id;
<a name="l00052"></a>00052     
<a name="l00053"></a>00053     <span class="comment">// Default constructor</span>
<a name="l00054"></a>00054     ElemBCData (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>       elem_id_in=0,
<a name="l00055"></a>00055                 <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side_in=0,
<a name="l00056"></a>00056                 <span class="keywordtype">short</span> <span class="keywordtype">int</span>          bc_id_in=0) :
<a name="l00057"></a>00057       elem_id(elem_id_in),
<a name="l00058"></a>00058       side(side_in),
<a name="l00059"></a>00059       bc_id(bc_id_in)
<a name="l00060"></a>00060     {}
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     <span class="comment">// comparison operator</span>
<a name="l00063"></a>00063     <span class="keywordtype">bool</span> operator &lt; (<span class="keyword">const</span> ElemBCData &amp;other)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword">    </span>{
<a name="l00065"></a>00065       <span class="keywordflow">if</span> (this-&gt;elem_id == other.elem_id)
<a name="l00066"></a>00066         <span class="keywordflow">return</span> (this-&gt;side &lt; other.side);
<a name="l00067"></a>00067       
<a name="l00068"></a>00068       <span class="keywordflow">return</span> this-&gt;elem_id &lt; other.elem_id;
<a name="l00069"></a>00069     }  
<a name="l00070"></a>00070   };
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">// comparison operator</span>
<a name="l00073"></a>00073   <span class="keywordtype">bool</span> operator &lt; (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;other_elem_id,
<a name="l00074"></a>00074                    <span class="keyword">const</span> ElemBCData &amp;elem_bc)
<a name="l00075"></a>00075   {
<a name="l00076"></a>00076     <span class="keywordflow">return</span> other_elem_id &lt; elem_bc.elem_id;
<a name="l00077"></a>00077   }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="keywordtype">bool</span> operator &lt; (<span class="keyword">const</span> ElemBCData &amp;elem_bc,
<a name="l00080"></a>00080                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;other_elem_id)
<a name="l00081"></a>00081     
<a name="l00082"></a>00082   {
<a name="l00083"></a>00083     <span class="keywordflow">return</span> elem_bc.elem_id &lt; other_elem_id;
<a name="l00084"></a>00084   }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="comment">// For some reason SunStudio does not seem to accept the above</span>
<a name="l00088"></a>00088   <span class="comment">// comparison functions for use in</span>
<a name="l00089"></a>00089   <span class="comment">// std::equal_range (ElemBCData::iterator, ElemBCData::iterator, unsigned int);</span>
<a name="l00090"></a>00090 <span class="preprocessor">#if defined(__SUNPRO_CC) || defined(__PGI)</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>  <span class="keyword">struct </span>CompareIntElemBCData
<a name="l00092"></a>00092   {
<a name="l00093"></a>00093     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;other_elem_id,
<a name="l00094"></a>00094                     <span class="keyword">const</span> ElemBCData &amp;elem_bc)
<a name="l00095"></a>00095     {
<a name="l00096"></a>00096       <span class="keywordflow">return</span> other_elem_id &lt; elem_bc.elem_id;
<a name="l00097"></a>00097     }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> ElemBCData &amp;elem_bc,
<a name="l00100"></a>00100                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;other_elem_id)    
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <span class="keywordflow">return</span> elem_bc.elem_id &lt; other_elem_id;
<a name="l00103"></a>00103     }
<a name="l00104"></a>00104   };
<a name="l00105"></a>00105 <span class="preprocessor">#endif</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>}
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00111"></a>00111 <span class="comment">// XdrIO static data</span>
<a name="l00112"></a>00112 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classXdrIO.php#a15b4a5e6f9a2981a80e871288059e699">XdrIO::io_blksize</a> = 128000;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00117"></a>00117 <span class="comment">// XdrIO members</span>
<a name="l00118"></a><a class="code" href="classXdrIO.php#ac572facda9e11513a63291ce7ed5a838">00118</a> <a class="code" href="classXdrIO.php#ac572facda9e11513a63291ce7ed5a838">XdrIO::XdrIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keyword">const</span> <span class="keywordtype">bool</span> binary) :
<a name="l00119"></a>00119   <a class="code" href="classMeshInput.php">MeshInput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt; (mesh,<span class="comment">/* is_parallel_format = */</span> true),
<a name="l00120"></a>00120   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh,<span class="comment">/* is_parallel_format = */</span> true),
<a name="l00121"></a>00121   _binary             (binary),
<a name="l00122"></a>00122   _legacy             (false),
<a name="l00123"></a>00123   _version            (<span class="stringliteral">&quot;libMesh-0.7.0+&quot;</span>),
<a name="l00124"></a>00124   _bc_file_name       (<span class="stringliteral">&quot;n/a&quot;</span>),
<a name="l00125"></a>00125   _partition_map_file (<span class="stringliteral">&quot;n/a&quot;</span>),
<a name="l00126"></a>00126   _subdomain_map_file (<span class="stringliteral">&quot;n/a&quot;</span>),
<a name="l00127"></a>00127   _p_level_file       (<span class="stringliteral">&quot;n/a&quot;</span>)
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classXdrIO.php#a0ee62fc3d2fbdd880c87c0e385305557">00133</a> <a class="code" href="classXdrIO.php#ac572facda9e11513a63291ce7ed5a838">XdrIO::XdrIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh, <span class="keyword">const</span> <span class="keywordtype">bool</span> binary) :
<a name="l00134"></a>00134   <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classMeshBase.php">MeshBase</a>&gt;(mesh,<span class="comment">/* is_parallel_format = */</span> true),
<a name="l00135"></a>00135   _binary (binary)
<a name="l00136"></a>00136 {
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a><a class="code" href="classXdrIO.php#a30a45d0fbc3db8768dbc70baac8c91e6">00141</a> <a class="code" href="classXdrIO.php#a30a45d0fbc3db8768dbc70baac8c91e6">XdrIO::~XdrIO</a> ()
<a name="l00142"></a>00142 {
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a><a class="code" href="classXdrIO.php#ad291a0b4cd3338da79e625474f192e5c">00147</a> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#ad291a0b4cd3338da79e625474f192e5c">XdrIO::write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00148"></a>00148 {
<a name="l00149"></a>00149   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classXdrIO.php#a3b61626fc0c3b9781262ea0f8d7f985b">legacy</a>())
<a name="l00150"></a>00150     {
<a name="l00151"></a>00151       libmesh_deprecated();
<a name="l00152"></a>00152       <a class="code" href="classLegacyXdrIO.php">LegacyXdrIO</a>(<a class="code" href="classMeshOutput.php">MeshOutput&lt;MeshBase&gt;::mesh</a>(), this-&gt;<a class="code" href="classXdrIO.php#adb181910c1820f41d8528b11ee92e6d0">binary</a>()).<a class="code" href="classLegacyXdrIO.php#a49f322f1ff1b7d8a1051b474d23d0cbf">write</a>(name);
<a name="l00153"></a>00153       <span class="keywordflow">return</span>;
<a name="l00154"></a>00154     }
<a name="l00155"></a>00155   
<a name="l00156"></a>00156   <a class="code" href="classXdr.php">Xdr</a> io ((<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) ? name : <span class="stringliteral">&quot;&quot;</span>, this-&gt;<a class="code" href="classXdrIO.php#adb181910c1820f41d8528b11ee92e6d0">binary</a>() ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   START_LOG(<span class="stringliteral">&quot;write()&quot;</span>,<span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00159"></a>00159   
<a name="l00160"></a>00160   <span class="comment">// convenient reference to our mesh</span>
<a name="l00161"></a>00161   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00162"></a>00162   
<a name="l00163"></a>00163   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00164"></a>00164     <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>     = mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>(),
<a name="l00165"></a>00165     <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>    = mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>(),
<a name="l00166"></a>00166     n_bcs      = mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;n_boundary_conds(),
<a name="l00167"></a>00167     <a class="code" href="namespaceMeshTools.php#a7c26061d17e6cbc7122fe92b8d349772">n_p_levels</a> = <a class="code" href="namespaceMeshTools.php#a7c26061d17e6cbc7122fe92b8d349772">MeshTools::n_p_levels</a> (mesh); 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00171"></a>00171   <span class="comment">// For all the optional files -- the default file name is &quot;n/a&quot;.</span>
<a name="l00172"></a>00172   <span class="comment">// However, the user may specify an optional external file. </span>
<a name="l00173"></a>00173   
<a name="l00174"></a>00174   <span class="comment">// If there are BCs and the user has not already provided a</span>
<a name="l00175"></a>00175   <span class="comment">// file name then write to &quot;.&quot;</span>
<a name="l00176"></a>00176   <span class="keywordflow">if</span> (n_bcs &amp;&amp;
<a name="l00177"></a>00177       this-&gt;<a class="code" href="classXdrIO.php#a66b8fa755de36072901878ab85b7b521">boundary_condition_file_name</a>() == <span class="stringliteral">&quot;n/a&quot;</span>)
<a name="l00178"></a>00178     this-&gt;<a class="code" href="classXdrIO.php#a66b8fa755de36072901878ab85b7b521">boundary_condition_file_name</a>() = <span class="stringliteral">&quot;.&quot;</span>;
<a name="l00179"></a>00179   
<a name="l00180"></a>00180   <span class="comment">// If there are more than one subdomains and the user has not specified an </span>
<a name="l00181"></a>00181   <span class="comment">// external file then write the subdomain mapping to the default file &quot;.&quot;  </span>
<a name="l00182"></a>00182   <span class="keywordflow">if</span> ((mesh.<a class="code" href="classMeshBase.php#a1f288668ce5a732f9946f08c73166d73">n_subdomains</a>() &gt; 0) &amp;&amp; 
<a name="l00183"></a>00183       (this-&gt;<a class="code" href="classXdrIO.php#ac9aafea778ff51fcbe499b437ff12445">subdomain_map_file_name</a>() == <span class="stringliteral">&quot;n/a&quot;</span>))
<a name="l00184"></a>00184     this-&gt;<a class="code" href="classXdrIO.php#ac9aafea778ff51fcbe499b437ff12445">subdomain_map_file_name</a>() = <span class="stringliteral">&quot;.&quot;</span>;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// In general we don&#39;t write the partition information.</span>
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   <span class="comment">// If we have p levels and the user has not already provided</span>
<a name="l00189"></a>00189   <span class="comment">// a file name then write to &quot;.&quot;</span>
<a name="l00190"></a>00190   <span class="keywordflow">if</span> ((<a class="code" href="namespaceMeshTools.php#a7c26061d17e6cbc7122fe92b8d349772">n_p_levels</a> &gt; 1) &amp;&amp;
<a name="l00191"></a>00191       (this-&gt;<a class="code" href="classXdrIO.php#a30371679b31186e42aaf8547079758e1">polynomial_level_file_name</a>() == <span class="stringliteral">&quot;n/a&quot;</span>))
<a name="l00192"></a>00192     this-&gt;<a class="code" href="classXdrIO.php#a30371679b31186e42aaf8547079758e1">polynomial_level_file_name</a>() = <span class="stringliteral">&quot;.&quot;</span>;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="comment">// write the header</span>
<a name="l00195"></a>00195   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00196"></a>00196     {
<a name="l00197"></a>00197       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#af2ae571e0fdec4fa5ac4fc50b20e9261">version</a>());
<a name="l00198"></a>00198       
<a name="l00199"></a>00199       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_elem,  <span class="stringliteral">&quot;# number of elements&quot;</span>);
<a name="l00200"></a>00200       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>, <span class="stringliteral">&quot;# number of nodes&quot;</span>);
<a name="l00201"></a>00201       
<a name="l00202"></a>00202       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#a66b8fa755de36072901878ab85b7b521">boundary_condition_file_name</a>(), <span class="stringliteral">&quot;# boundary condition specification file&quot;</span>);
<a name="l00203"></a>00203       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#ac9aafea778ff51fcbe499b437ff12445">subdomain_map_file_name</a>(),      <span class="stringliteral">&quot;# subdomain id specification file&quot;</span>);
<a name="l00204"></a>00204       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#aefd6832ee480c9c1da7bcd568e4adf2d">partition_map_file_name</a>(),      <span class="stringliteral">&quot;# processor id specification file&quot;</span>);
<a name="l00205"></a>00205       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#a30371679b31186e42aaf8547079758e1">polynomial_level_file_name</a>(),   <span class="stringliteral">&quot;# p-level specification file&quot;</span>);      
<a name="l00206"></a>00206     }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="comment">// write connectivity</span>
<a name="l00209"></a>00209   this-&gt;<a class="code" href="classXdrIO.php#a0aac5a767e1dc420f9b81587d872a18e">write_serialized_connectivity</a> (io, n_elem);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="comment">// write the nodal locations</span>
<a name="l00212"></a>00212   this-&gt;<a class="code" href="classXdrIO.php#a5004adb5a38cf71608ca2d95a71ab86e">write_serialized_nodes</a> (io, <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="comment">// write the boundary condition information</span>
<a name="l00215"></a>00215   this-&gt;<a class="code" href="classXdrIO.php#a76ed46446719fd66319a2981afd79ab0">write_serialized_bcs</a> (io, n_bcs);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   STOP_LOG(<span class="stringliteral">&quot;write()&quot;</span>,<span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00218"></a>00218   
<a name="l00219"></a>00219   <span class="comment">// pause all processes until the write ends -- this will </span>
<a name="l00220"></a>00220   <span class="comment">// protect for the pathological case where a write is </span>
<a name="l00221"></a>00221   <span class="comment">// followed immediately by a read.  The write must be</span>
<a name="l00222"></a>00222   <span class="comment">// guaranteed to complete first.</span>
<a name="l00223"></a>00223   io.<a class="code" href="classXdr.php#a68dc02dd44f5f69b76813967d1d611cf">close</a>();
<a name="l00224"></a>00224   Parallel::barrier();
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a><a class="code" href="classXdrIO.php#a0aac5a767e1dc420f9b81587d872a18e">00229</a> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a0aac5a767e1dc420f9b81587d872a18e">XdrIO::write_serialized_connectivity</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>)<span class="keyword"> const</span>
<a name="l00230"></a>00230 <span class="keyword"></span>{
<a name="l00231"></a>00231   libmesh_assert (io.<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>());
<a name="l00232"></a>00232   
<a name="l00233"></a>00233   <span class="keyword">const</span> <span class="keywordtype">bool</span>
<a name="l00234"></a>00234     write_p_level      = (<span class="stringliteral">&quot;.&quot;</span> == this-&gt;<a class="code" href="classXdrIO.php#a30371679b31186e42aaf8547079758e1">polynomial_level_file_name</a>()),
<a name="l00235"></a>00235     write_partitioning = (<span class="stringliteral">&quot;.&quot;</span> == this-&gt;<a class="code" href="classXdrIO.php#aefd6832ee480c9c1da7bcd568e4adf2d">partition_map_file_name</a>()),
<a name="l00236"></a>00236     write_subdomain_id = (<span class="stringliteral">&quot;.&quot;</span> == this-&gt;<a class="code" href="classXdrIO.php#ac9aafea778ff51fcbe499b437ff12445">subdomain_map_file_name</a>());
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="comment">// convenient reference to our mesh</span>
<a name="l00239"></a>00239   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00240"></a>00240   libmesh_assert (n_elem == mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>());
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   <span class="comment">// We will only write active elements and their parents.</span>
<a name="l00243"></a>00243   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#ac7347516a0e8d16e18b72870f87bfac9">n_active_levels</a> = <a class="code" href="namespaceMeshTools.php#ac7347516a0e8d16e18b72870f87bfac9">MeshTools::n_active_levels</a> (mesh);
<a name="l00244"></a>00244   std::vector&lt;unsigned int&gt; 
<a name="l00245"></a>00245     n_global_elem_at_level(n_active_levels), n_local_elem_at_level(n_active_levels);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it  = mesh.<a class="code" href="classMeshBase.php#a8184d52812b82a9a38b66a0c89f04b17">local_elements_end</a>(), end=it;
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   <span class="comment">// Find the number of local and global elements at each level</span>
<a name="l00250"></a>00250   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0, tot_n_elem=0; level&lt;<a class="code" href="namespaceMeshTools.php#ac7347516a0e8d16e18b72870f87bfac9">n_active_levels</a>; level++)
<a name="l00251"></a>00251     {
<a name="l00252"></a>00252       it  = mesh.<a class="code" href="classMeshBase.php#a7df701cd3172c65bf147d0fafe002a39">local_level_elements_begin</a>(level);
<a name="l00253"></a>00253       end = mesh.<a class="code" href="classMeshBase.php#a80fe21ac40ace65369a25040f91ab1b4">local_level_elements_end</a>(level);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255       n_local_elem_at_level[level] = n_global_elem_at_level[level] = <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">MeshTools::n_elem</a>(it, end);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257       Parallel::sum(n_global_elem_at_level[level]);
<a name="l00258"></a>00258       tot_n_elem += n_global_elem_at_level[level];
<a name="l00259"></a>00259       libmesh_assert (n_global_elem_at_level[level] &lt;= n_elem);
<a name="l00260"></a>00260       libmesh_assert (tot_n_elem &lt;= n_elem);
<a name="l00261"></a>00261     }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   std::vector&lt;unsigned int&gt; 
<a name="l00264"></a>00264     xfer_conn, recv_conn, output_buffer, 
<a name="l00265"></a>00265     n_elem_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()), 
<a name="l00266"></a>00266     processor_offsets(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()), 
<a name="l00267"></a>00267     xfer_buf_sizes(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="keyword">typedef</span> std::map&lt;unsigned int, std::pair&lt;unsigned int, unsigned int&gt; &gt; id_map_type;
<a name="l00270"></a>00270   id_map_type parent_id_map, child_id_map;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_next_elem=0, next_global_elem=0;
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">//-------------------------------------------</span>
<a name="l00275"></a>00275   <span class="comment">// First write the level-0 elements directly.</span>
<a name="l00276"></a>00276   it  = mesh.<a class="code" href="classMeshBase.php#a7df701cd3172c65bf147d0fafe002a39">local_level_elements_begin</a>(0);
<a name="l00277"></a>00277   end = mesh.<a class="code" href="classMeshBase.php#a80fe21ac40ace65369a25040f91ab1b4">local_level_elements_end</a>(0);
<a name="l00278"></a>00278   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00279"></a>00279     {
<a name="l00280"></a>00280       <a class="code" href="classXdrIO.php#aaae814f408b28aef140b3eb839f8d987">pack_element</a> (xfer_conn, *it);
<a name="l00281"></a>00281       parent_id_map[(*it)-&gt;id()] = std::make_pair(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(), 
<a name="l00282"></a>00282                                                   my_next_elem++);
<a name="l00283"></a>00283     }
<a name="l00284"></a>00284   xfer_conn.push_back(my_next_elem); <span class="comment">// toss in the number of elements transferred.</span>
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_size = xfer_conn.size();
<a name="l00287"></a>00287   Parallel::gather (0, my_next_elem, n_elem_on_proc);
<a name="l00288"></a>00288   Parallel::gather (0, my_size,      xfer_buf_sizes);
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   processor_offsets[0] = 0;
<a name="l00291"></a>00291   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=1; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00292"></a>00292     processor_offsets[pid] = processor_offsets[pid-1] + n_elem_on_proc[pid-1];
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="comment">// All processors send their xfer buffers to processor 0.</span>
<a name="l00295"></a>00295   <span class="comment">// Processor 0 will receive the data and write out the elements. </span>
<a name="l00296"></a>00296   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00297"></a>00297     {
<a name="l00298"></a>00298       <span class="comment">// Write the number of elements at this level.      </span>
<a name="l00299"></a>00299       {
<a name="l00300"></a>00300         std::string comment = <span class="stringliteral">&quot;# n_elem at level 0&quot;</span>, legend  = <span class="stringliteral">&quot;, [ type &quot;</span>;
<a name="l00301"></a>00301         <span class="keywordflow">if</span> (write_partitioning)
<a name="l00302"></a>00302           legend += <span class="stringliteral">&quot;pid &quot;</span>;
<a name="l00303"></a>00303         <span class="keywordflow">if</span> (write_subdomain_id)
<a name="l00304"></a>00304           legend += <span class="stringliteral">&quot;sid &quot;</span>;
<a name="l00305"></a>00305         <span class="keywordflow">if</span> (write_p_level)
<a name="l00306"></a>00306           legend += <span class="stringliteral">&quot;p_level &quot;</span>;
<a name="l00307"></a>00307         legend += <span class="stringliteral">&quot;(n0 ... nN-1) ]&quot;</span>;
<a name="l00308"></a>00308         comment += legend;
<a name="l00309"></a>00309         io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_global_elem_at_level[0], comment.c_str());
<a name="l00310"></a>00310       }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00313"></a>00313         {
<a name="l00314"></a>00314           recv_conn.resize(xfer_buf_sizes[pid]);
<a name="l00315"></a>00315           <span class="keywordflow">if</span> (pid == 0)
<a name="l00316"></a>00316             recv_conn = xfer_conn;
<a name="l00317"></a>00317           <span class="keywordflow">else</span>
<a name="l00318"></a>00318             Parallel::receive (pid, recv_conn); 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320           <span class="comment">// at a minimum, the buffer should contain the number of elements,</span>
<a name="l00321"></a>00321           <span class="comment">// which could be 0.</span>
<a name="l00322"></a>00322           libmesh_assert (!recv_conn.empty());
<a name="l00323"></a>00323           
<a name="l00324"></a>00324           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_received = recv_conn.back();
<a name="l00325"></a>00325           std::vector&lt;unsigned int&gt;::const_iterator it = recv_conn.begin();
<a name="l00326"></a>00326           
<a name="l00327"></a>00327           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem=0; elem&lt;n_elem_received; elem++, next_global_elem++)
<a name="l00328"></a>00328             {
<a name="l00329"></a>00329               output_buffer.clear();
<a name="l00330"></a>00330               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = *it; ++it;
<a name="l00331"></a>00331               output_buffer.push_back(*it);     <span class="comment">/* type       */</span> ++it;        
<a name="l00332"></a>00332               <span class="comment">/*output_buffer.push_back(*it);*/</span> <span class="comment">/* id         */</span> ++it;
<a name="l00333"></a>00333               
<a name="l00334"></a>00334               <span class="keywordflow">if</span> (write_partitioning)
<a name="l00335"></a>00335                 output_buffer.push_back(*it); <span class="comment">/* processor id */</span> ++it;
<a name="l00336"></a>00336 
<a name="l00337"></a>00337               <span class="keywordflow">if</span> (write_subdomain_id)
<a name="l00338"></a>00338                 output_buffer.push_back(*it); <span class="comment">/* subdomain id */</span> ++it;
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00341"></a>00341 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (write_p_level)
<a name="l00342"></a>00342                 output_buffer.push_back(*it); <span class="comment">/* p level      */</span> ++it;
<a name="l00343"></a>00343 <span class="preprocessor">#endif</span>
<a name="l00344"></a>00344 <span class="preprocessor"></span>              <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node=0; node&lt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; node++, ++it)
<a name="l00345"></a>00345                 output_buffer.push_back(*it);
<a name="l00346"></a>00346               
<a name="l00347"></a>00347               io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (&amp;output_buffer[0], output_buffer.size(), output_buffer.size());
<a name="l00348"></a>00348             }           
<a name="l00349"></a>00349         }
<a name="l00350"></a>00350     }
<a name="l00351"></a>00351   <span class="keywordflow">else</span>
<a name="l00352"></a>00352     Parallel::send (0, xfer_conn);
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR  </span>
<a name="l00355"></a>00355 <span class="preprocessor"></span>  <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00356"></a>00356   <span class="comment">// Next write the remaining elements indirectly through their parents.</span>
<a name="l00357"></a>00357   <span class="comment">// This will insure that the children are written in the proper order</span>
<a name="l00358"></a>00358   <span class="comment">// so they can be reconstructed properly.</span>
<a name="l00359"></a>00359   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=1, my_n_elem_written_at_level=0; level&lt;<a class="code" href="namespaceMeshTools.php#ac7347516a0e8d16e18b72870f87bfac9">n_active_levels</a>; level++)
<a name="l00360"></a>00360     {
<a name="l00361"></a>00361       xfer_conn.clear();
<a name="l00362"></a>00362 
<a name="l00363"></a>00363       it  = mesh.<a class="code" href="classMeshBase.php#a7df701cd3172c65bf147d0fafe002a39">local_level_elements_begin</a>(level-1);
<a name="l00364"></a>00364       end = mesh.<a class="code" href="classMeshBase.php#a80fe21ac40ace65369a25040f91ab1b4">local_level_elements_end</a>  (level-1);
<a name="l00365"></a>00365       
<a name="l00366"></a>00366       <span class="keywordflow">for</span> (my_n_elem_written_at_level=0; it != end; ++it)
<a name="l00367"></a>00367         <span class="keywordflow">if</span> (!(*it)-&gt;active()) <span class="comment">// we only want the parents elements at this level, and</span>
<a name="l00368"></a>00368           {                   <span class="comment">// there is no direct iterator for this obscure use</span>
<a name="l00369"></a>00369             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *parent = *it;
<a name="l00370"></a>00370             id_map_type::iterator pos = parent_id_map.find(parent-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l00371"></a>00371             libmesh_assert (pos != parent_id_map.end());
<a name="l00372"></a>00372             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_pid = pos-&gt;second.first;
<a name="l00373"></a>00373             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_id  = pos-&gt;second.second;
<a name="l00374"></a>00374             parent_id_map.erase(pos);
<a name="l00375"></a>00375 
<a name="l00376"></a>00376             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;parent-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++, my_next_elem++)
<a name="l00377"></a>00377               {
<a name="l00378"></a>00378                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *child = parent-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l00379"></a>00379                 <a class="code" href="classXdrIO.php#aaae814f408b28aef140b3eb839f8d987">pack_element</a> (xfer_conn, child, parent_id, parent_pid);
<a name="l00380"></a>00380 
<a name="l00381"></a>00381                 <span class="comment">// this aproach introduces the possibility that we write</span>
<a name="l00382"></a>00382                 <span class="comment">// non-local elements.  These elements may well be parents</span>
<a name="l00383"></a>00383                 <span class="comment">// at the next step</span>
<a name="l00384"></a>00384                 child_id_map[child-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = std::make_pair (child-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>(), 
<a name="l00385"></a>00385                                                             my_n_elem_written_at_level++);
<a name="l00386"></a>00386               }
<a name="l00387"></a>00387           }
<a name="l00388"></a>00388       xfer_conn.push_back(my_n_elem_written_at_level);
<a name="l00389"></a>00389       my_size = xfer_conn.size();
<a name="l00390"></a>00390       Parallel::gather (0, my_size,   xfer_buf_sizes);
<a name="l00391"></a>00391       
<a name="l00392"></a>00392       <span class="comment">// Processor 0 will receive the data and write the elements.</span>
<a name="l00393"></a>00393       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00394"></a>00394         {
<a name="l00395"></a>00395           <span class="comment">// Write the number of elements at this level.      </span>
<a name="l00396"></a>00396           {
<a name="l00397"></a>00397             <span class="keywordtype">char</span> buf[80];
<a name="l00398"></a>00398             std::sprintf(buf, <span class="stringliteral">&quot;# n_elem at level %d&quot;</span>, level);
<a name="l00399"></a>00399             std::string comment(buf), legend  = <span class="stringliteral">&quot;, [ type parent &quot;</span>;
<a name="l00400"></a>00400 
<a name="l00401"></a>00401             <span class="keywordflow">if</span> (write_partitioning)
<a name="l00402"></a>00402               legend += <span class="stringliteral">&quot;pid &quot;</span>;
<a name="l00403"></a>00403             <span class="keywordflow">if</span> (write_subdomain_id)
<a name="l00404"></a>00404               legend += <span class="stringliteral">&quot;sid &quot;</span>;
<a name="l00405"></a>00405             <span class="keywordflow">if</span> (write_p_level)
<a name="l00406"></a>00406               legend += <span class="stringliteral">&quot;p_level &quot;</span>;
<a name="l00407"></a>00407             legend += <span class="stringliteral">&quot;(n0 ... nN-1) ]&quot;</span>;
<a name="l00408"></a>00408             comment += legend;
<a name="l00409"></a>00409             io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_global_elem_at_level[level], comment.c_str());
<a name="l00410"></a>00410           }
<a name="l00411"></a>00411           
<a name="l00412"></a>00412           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00413"></a>00413             {
<a name="l00414"></a>00414               recv_conn.resize(xfer_buf_sizes[pid]);
<a name="l00415"></a>00415               <span class="keywordflow">if</span> (pid == 0)
<a name="l00416"></a>00416                 recv_conn = xfer_conn;
<a name="l00417"></a>00417               <span class="keywordflow">else</span>
<a name="l00418"></a>00418                 Parallel::receive (pid, recv_conn);     
<a name="l00419"></a>00419 
<a name="l00420"></a>00420               <span class="comment">// at a minimum, the buffer should contain the number of elements,</span>
<a name="l00421"></a>00421               <span class="comment">// which could be 0.</span>
<a name="l00422"></a>00422               libmesh_assert (!recv_conn.empty());
<a name="l00423"></a>00423               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_received = recv_conn.back();
<a name="l00424"></a>00424               std::vector&lt;unsigned int&gt;::const_iterator it = recv_conn.begin();
<a name="l00425"></a>00425               
<a name="l00426"></a>00426               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem=0; elem&lt;n_elem_received; elem++, next_global_elem++)
<a name="l00427"></a>00427                 {
<a name="l00428"></a>00428                   output_buffer.clear();
<a name="l00429"></a>00429                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a> = *it; ++it;
<a name="l00430"></a>00430                   output_buffer.push_back(*it);                   <span class="comment">/* type          */</span> ++it;
<a name="l00431"></a>00431                   <span class="comment">/*output_buffer.push_back(*it);*/</span>               <span class="comment">/* id            */</span> ++it;
<a name="l00432"></a>00432                   
<a name="l00433"></a>00433                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_local_id = *it; ++it; 
<a name="l00434"></a>00434                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_pid      = *it; ++it; 
<a name="l00435"></a>00435                       
<a name="l00436"></a>00436                   output_buffer.push_back (parent_local_id+processor_offsets[parent_pid]);
<a name="l00437"></a>00437 
<a name="l00438"></a>00438                   <span class="keywordflow">if</span> (write_partitioning)
<a name="l00439"></a>00439                     output_buffer.push_back(*it); <span class="comment">/* processor id */</span> ++it;
<a name="l00440"></a>00440 
<a name="l00441"></a>00441                   <span class="keywordflow">if</span> (write_subdomain_id)
<a name="l00442"></a>00442                     output_buffer.push_back(*it); <span class="comment">/* subdomain id */</span> ++it;
<a name="l00443"></a>00443                   
<a name="l00444"></a>00444                   <span class="keywordflow">if</span> (write_p_level)
<a name="l00445"></a>00445                     output_buffer.push_back(*it); <span class="comment">/* p level       */</span> ++it;
<a name="l00446"></a>00446                   
<a name="l00447"></a>00447                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node=0; node&lt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; node++, ++it)
<a name="l00448"></a>00448                     output_buffer.push_back(*it);
<a name="l00449"></a>00449                   
<a name="l00450"></a>00450                   io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (&amp;output_buffer[0], output_buffer.size(), output_buffer.size());
<a name="l00451"></a>00451                 }                           
<a name="l00452"></a>00452             }
<a name="l00453"></a>00453         }  
<a name="l00454"></a>00454       <span class="keywordflow">else</span>
<a name="l00455"></a>00455         Parallel::send  (0, xfer_conn);
<a name="l00456"></a>00456   
<a name="l00457"></a>00457       <span class="comment">// update the processor_offsets</span>
<a name="l00458"></a>00458       processor_offsets[0] = processor_offsets.back() + n_elem_on_proc.back();    
<a name="l00459"></a>00459       Parallel::gather (0, my_n_elem_written_at_level, n_elem_on_proc);
<a name="l00460"></a>00460       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=1; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00461"></a>00461         processor_offsets[pid] = processor_offsets[pid-1] + n_elem_on_proc[pid-1];          
<a name="l00462"></a>00462 
<a name="l00463"></a>00463       <span class="comment">// Now, at the next level we will again iterate over local parents.  However, </span>
<a name="l00464"></a>00464       <span class="comment">// those parents may have been written by other processors (at this step), </span>
<a name="l00465"></a>00465       <span class="comment">// so we need to gather them into our *_id_maps.</span>
<a name="l00466"></a>00466       {
<a name="l00467"></a>00467         std::vector&lt;std::vector&lt;unsigned int&gt; &gt; requested_ids(libMesh::n_processors());
<a name="l00468"></a>00468         std::vector&lt;unsigned int&gt; request_to_fill;      
<a name="l00469"></a>00469 
<a name="l00470"></a>00470         it  = mesh.<a class="code" href="classMeshBase.php#a7df701cd3172c65bf147d0fafe002a39">local_level_elements_begin</a>(level);
<a name="l00471"></a>00471         end = mesh.<a class="code" href="classMeshBase.php#a80fe21ac40ace65369a25040f91ab1b4">local_level_elements_end</a>(level);
<a name="l00472"></a>00472 
<a name="l00473"></a>00473         <span class="keywordflow">for</span> (; it!=end; ++it)
<a name="l00474"></a>00474           <span class="keywordflow">if</span> (!child_id_map.count((*it)-&gt;id()))
<a name="l00475"></a>00475             {
<a name="l00476"></a>00476               libmesh_assert ((*it)-&gt;parent()-&gt;processor_id() != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00477"></a>00477               requested_ids[(*it)-&gt;parent()-&gt;processor_id()].push_back((*it)-&gt;id());
<a name="l00478"></a>00478             }
<a name="l00479"></a>00479 
<a name="l00480"></a>00480         <span class="comment">// Next set the child_ids </span>
<a name="l00481"></a>00481         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00482"></a>00482           {
<a name="l00483"></a>00483             <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00484"></a>00484             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00485"></a>00485                                    libMesh::n_processors();
<a name="l00486"></a>00486             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00487"></a>00487                                      <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00488"></a>00488                                      libMesh::n_processors();
<a name="l00489"></a>00489 
<a name="l00490"></a>00490             Parallel::send_receive(procup, requested_ids[procup],
<a name="l00491"></a>00491                                    procdown, request_to_fill);
<a name="l00492"></a>00492 
<a name="l00493"></a>00493             <span class="comment">// Fill those requests by overwriting the requested ids</span>
<a name="l00494"></a>00494             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;request_to_fill.size(); i++)          
<a name="l00495"></a>00495               {
<a name="l00496"></a>00496                 libmesh_assert (child_id_map.count(request_to_fill[i]));
<a name="l00497"></a>00497                 libmesh_assert (child_id_map[request_to_fill[i]].first == procdown);
<a name="l00498"></a>00498 
<a name="l00499"></a>00499                 request_to_fill[i] = child_id_map[request_to_fill[i]].second;
<a name="l00500"></a>00500               }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502             <span class="comment">// Trade back the results</span>
<a name="l00503"></a>00503             std::vector&lt;unsigned int&gt; filled_request;
<a name="l00504"></a>00504             Parallel::send_receive(procdown, request_to_fill,
<a name="l00505"></a>00505                                    procup, filled_request);
<a name="l00506"></a>00506 
<a name="l00507"></a>00507             libmesh_assert (filled_request.size() == requested_ids[procup].size());
<a name="l00508"></a>00508             
<a name="l00509"></a>00509             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;filled_request.size(); i++)
<a name="l00510"></a>00510               child_id_map[requested_ids[procup][i]] = 
<a name="l00511"></a>00511                 std::make_pair (procup,
<a name="l00512"></a>00512                                 filled_request[i]);
<a name="l00513"></a>00513           }
<a name="l00514"></a>00514         <span class="comment">// overwrite the parent_id_map with the child_id_map, but</span>
<a name="l00515"></a>00515         <span class="comment">// use std::map::swap() for efficiency.</span>
<a name="l00516"></a>00516         parent_id_map.swap(child_id_map);  child_id_map.clear();
<a name="l00517"></a>00517       }
<a name="l00518"></a>00518     }
<a name="l00519"></a>00519 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00520"></a>00520 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00521"></a>00521     libmesh_assert (next_global_elem == n_elem);
<a name="l00522"></a>00522   
<a name="l00523"></a>00523 }
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a><a class="code" href="classXdrIO.php#a5004adb5a38cf71608ca2d95a71ab86e">00527</a> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a5004adb5a38cf71608ca2d95a71ab86e">XdrIO::write_serialized_nodes</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>)<span class="keyword"> const</span>
<a name="l00528"></a>00528 <span class="keyword"></span>{
<a name="l00529"></a>00529   <span class="comment">// convenient reference to our mesh</span>
<a name="l00530"></a>00530   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00531"></a>00531   libmesh_assert (n_nodes == mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l00532"></a>00532 
<a name="l00533"></a>00533   std::vector&lt;unsigned int&gt; xfer_ids;
<a name="l00534"></a>00534   std::vector&lt;Real&gt;         xfer_coords, &amp;coords=xfer_coords;
<a name="l00535"></a>00535 
<a name="l00536"></a>00536   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; recv_ids   (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());;
<a name="l00537"></a>00537   std::vector&lt;std::vector&lt;Real&gt; &gt;         recv_coords(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_written=0;
<a name="l00540"></a>00540 
<a name="l00541"></a>00541   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> blk=0, last_node=0; last_node&lt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; blk++)
<a name="l00542"></a>00542     {
<a name="l00543"></a>00543       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_node = blk*<a class="code" href="classXdrIO.php#a15b4a5e6f9a2981a80e871288059e699">io_blksize</a>;
<a name="l00544"></a>00544                           last_node = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((blk+1)*io_blksize, n_nodes);
<a name="l00545"></a>00545 
<a name="l00546"></a>00546       <span class="comment">// Build up the xfer buffers on each processor</span>
<a name="l00547"></a>00547       <a class="code" href="structMeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>
<a name="l00548"></a>00548         it  = mesh.<a class="code" href="classMeshBase.php#a6485de7e7d67f36dec274f512d10fc15">local_nodes_begin</a>(),
<a name="l00549"></a>00549         end = mesh.<a class="code" href="classMeshBase.php#ae23ced52382b7238f9182c8593f5cdd5">local_nodes_end</a>();
<a name="l00550"></a>00550 
<a name="l00551"></a>00551       xfer_ids.clear(); xfer_coords.clear();
<a name="l00552"></a>00552       
<a name="l00553"></a>00553       <span class="keywordflow">for</span> (; it!=end; ++it)
<a name="l00554"></a>00554         <span class="keywordflow">if</span> (((*it)-&gt;id() &gt;= first_node) &amp;&amp; <span class="comment">// node in [first_node, last_node)</span>
<a name="l00555"></a>00555             ((*it)-&gt;id() &lt;  last_node))
<a name="l00556"></a>00556           {
<a name="l00557"></a>00557             xfer_ids.push_back((*it)-&gt;id());
<a name="l00558"></a>00558             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp;p = **it;
<a name="l00559"></a>00559             xfer_coords.push_back(p(0));
<a name="l00560"></a>00560             xfer_coords.push_back(p(1));
<a name="l00561"></a>00561             xfer_coords.push_back(p(2));
<a name="l00562"></a>00562           }
<a name="l00563"></a>00563 
<a name="l00564"></a>00564       <span class="comment">//-------------------------------------</span>
<a name="l00565"></a>00565       <span class="comment">// Send the xfer buffers to processor 0</span>
<a name="l00566"></a>00566       std::vector&lt;unsigned int&gt; ids_size, coords_size;
<a name="l00567"></a>00567 
<a name="l00568"></a>00568       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_ids_size = xfer_ids.size();
<a name="l00569"></a>00569 
<a name="l00570"></a>00570       <span class="comment">// explicitly gather ids_size</span>
<a name="l00571"></a>00571       Parallel::gather (0, my_ids_size, ids_size);
<a name="l00572"></a>00572 
<a name="l00573"></a>00573       <span class="comment">// infer coords_size on processor 0</span>
<a name="l00574"></a>00574       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00575"></a>00575         {
<a name="l00576"></a>00576           coords_size.reserve(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00577"></a>00577           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;ids_size.size(); p++)
<a name="l00578"></a>00578             coords_size.push_back(3*ids_size[p]);
<a name="l00579"></a>00579         }                         
<a name="l00580"></a>00580 
<a name="l00581"></a>00581       <span class="comment">// We will have lots of simultaneous receives if we are</span>
<a name="l00582"></a>00582       <span class="comment">// processor 0, so let&#39;s use nonblocking receives.</span>
<a name="l00583"></a>00583       std::vector&lt;Parallel::request&gt;
<a name="l00584"></a>00584         id_request_handles(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1),
<a name="l00585"></a>00585         coord_request_handles(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1);
<a name="l00586"></a>00586 
<a name="l00587"></a>00587       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> id_tag=0, coord_tag=1;
<a name="l00588"></a>00588       
<a name="l00589"></a>00589       <span class="comment">// Post the receives -- do this on processor 0 only.</span>
<a name="l00590"></a>00590       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00591"></a>00591         {
<a name="l00592"></a>00592           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00593"></a>00593             {
<a name="l00594"></a>00594               recv_ids[pid].resize(ids_size[pid]);
<a name="l00595"></a>00595               recv_coords[pid].resize(coords_size[pid]);
<a name="l00596"></a>00596             
<a name="l00597"></a>00597               <span class="keywordflow">if</span> (pid == 0)
<a name="l00598"></a>00598                 {
<a name="l00599"></a>00599                   recv_ids[0] = xfer_ids;
<a name="l00600"></a>00600                   recv_coords[0] = xfer_coords;
<a name="l00601"></a>00601                 }
<a name="l00602"></a>00602               <span class="keywordflow">else</span>
<a name="l00603"></a>00603                 {
<a name="l00604"></a>00604                   Parallel::nonblocking_receive (pid, recv_ids[pid],
<a name="l00605"></a>00605                                                  id_request_handles[pid-1],
<a name="l00606"></a>00606                                                  id_tag);
<a name="l00607"></a>00607                   Parallel::nonblocking_receive (pid, recv_coords[pid],
<a name="l00608"></a>00608                                                  coord_request_handles[pid-1],
<a name="l00609"></a>00609                                                  coord_tag);
<a name="l00610"></a>00610                 }
<a name="l00611"></a>00611             }
<a name="l00612"></a>00612         }
<a name="l00613"></a>00613       <span class="keywordflow">else</span>
<a name="l00614"></a>00614         {
<a name="l00615"></a>00615           <span class="comment">// Send -- do this on all other processors.</span>
<a name="l00616"></a>00616           Parallel::send(0, xfer_ids,    id_tag);
<a name="l00617"></a>00617           Parallel::send(0, xfer_coords, coord_tag);
<a name="l00618"></a>00618         }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620       <span class="comment">// -------------------------------------------------------</span>
<a name="l00621"></a>00621       <span class="comment">// Receive the messages and write the output on processor 0.</span>
<a name="l00622"></a>00622       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00623"></a>00623         {
<a name="l00624"></a>00624           <span class="comment">// Wait for all the receives to complete. We have no</span>
<a name="l00625"></a>00625           <span class="comment">// need for the statuses since we already know the</span>
<a name="l00626"></a>00626           <span class="comment">// buffer sizes.</span>
<a name="l00627"></a>00627           Parallel::wait (id_request_handles);
<a name="l00628"></a>00628           Parallel::wait (coord_request_handles);
<a name="l00629"></a>00629           
<a name="l00630"></a>00630           <span class="comment">// Write the coordinates in this block.</span>
<a name="l00631"></a>00631           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot_id_size=0, tot_coord_size=0;
<a name="l00632"></a>00632           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00633"></a>00633             {
<a name="l00634"></a>00634               tot_id_size    += recv_ids[pid].size();
<a name="l00635"></a>00635               tot_coord_size += recv_coords[pid].size();
<a name="l00636"></a>00636             }
<a name="l00637"></a>00637 
<a name="l00638"></a>00638           libmesh_assert (tot_id_size &lt;= <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(io_blksize, n_nodes));
<a name="l00639"></a>00639           libmesh_assert (tot_coord_size == 3*tot_id_size);
<a name="l00640"></a>00640 
<a name="l00641"></a>00641           coords.resize (tot_coord_size);
<a name="l00642"></a>00642           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00643"></a>00643             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;recv_ids[pid].size(); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++)
<a name="l00644"></a>00644               {
<a name="l00645"></a>00645                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_idx = recv_ids[pid][<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>] - first_node;
<a name="l00646"></a>00646                 libmesh_assert ((3*local_idx+2) &lt; coords.size());
<a name="l00647"></a>00647                 libmesh_assert ((3*<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+2)      &lt; recv_coords[pid].size());
<a name="l00648"></a>00648                 
<a name="l00649"></a>00649                 coords[3*local_idx+0] = recv_coords[pid][3*<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+0];
<a name="l00650"></a>00650                 coords[3*local_idx+1] = recv_coords[pid][3*<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+1];
<a name="l00651"></a>00651                 coords[3*local_idx+2] = recv_coords[pid][3*<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+2];
<a name="l00652"></a>00652 
<a name="l00653"></a>00653                 n_written++;
<a name="l00654"></a>00654               }
<a name="l00655"></a>00655 
<a name="l00656"></a>00656           io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (coords.empty() ? NULL : &amp;coords[0], coords.size(), 3);
<a name="l00657"></a>00657         }
<a name="l00658"></a>00658     }
<a name="l00659"></a>00659   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00660"></a>00660     libmesh_assert (n_written == n_nodes);
<a name="l00661"></a>00661 }
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 
<a name="l00665"></a><a class="code" href="classXdrIO.php#a76ed46446719fd66319a2981afd79ab0">00665</a> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a76ed46446719fd66319a2981afd79ab0">XdrIO::write_serialized_bcs</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs)<span class="keyword"> const</span>
<a name="l00666"></a>00666 <span class="keyword"></span>{
<a name="l00667"></a>00667   libmesh_assert (io.<a class="code" href="classXdr.php#a697f12c5036ad61caae2ef98b6a480f1">writing</a>());
<a name="l00668"></a>00668   
<a name="l00669"></a>00669   <span class="keywordflow">if</span> (!n_bcs) <span class="keywordflow">return</span>;
<a name="l00670"></a>00670   
<a name="l00671"></a>00671   <span class="comment">// convenient reference to our mesh</span>
<a name="l00672"></a>00672   <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00673"></a>00673   
<a name="l00674"></a>00674   <span class="comment">// and our boundary info object</span>
<a name="l00675"></a>00675   <span class="keyword">const</span> <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a> &amp;boundary_info = *mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>;
<a name="l00676"></a>00676 
<a name="l00677"></a>00677   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs_out = n_bcs;
<a name="l00678"></a>00678   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00679"></a>00679     io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_bcs_out, <span class="stringliteral">&quot;# number of boundary conditions&quot;</span>);
<a name="l00680"></a>00680   n_bcs_out = 0;
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   std::vector&lt;int&gt; xfer_bcs, recv_bcs;
<a name="l00683"></a>00683   std::vector&lt;unsigned int&gt; bc_sizes(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());;
<a name="l00684"></a>00684   
<a name="l00685"></a>00685   <span class="comment">// Boundary conditions are only specified for level-0 elements</span>
<a name="l00686"></a>00686   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l00687"></a>00687     it  = mesh.<a class="code" href="classMeshBase.php#a7df701cd3172c65bf147d0fafe002a39">local_level_elements_begin</a>(0),
<a name="l00688"></a>00688     end = mesh.<a class="code" href="classMeshBase.php#a80fe21ac40ace65369a25040f91ab1b4">local_level_elements_end</a>(0);
<a name="l00689"></a>00689 
<a name="l00690"></a>00690   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local_level_0_elem=0;
<a name="l00691"></a>00691   <span class="keywordflow">for</span> (; it!=end; ++it, n_local_level_0_elem++)
<a name="l00692"></a>00692     {
<a name="l00693"></a>00693       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = *it;
<a name="l00694"></a>00694 
<a name="l00695"></a>00695       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l00696"></a>00696         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL)
<a name="l00697"></a>00697           {
<a name="l00698"></a>00698             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> bc_id = 
<a name="l00699"></a>00699               boundary_info.<a class="code" href="classBoundaryInfo.php#a800c9cb9f884fbe11705729f9517e01f">boundary_id</a> (elem, s);
<a name="l00700"></a>00700 
<a name="l00701"></a>00701             <span class="keywordflow">if</span> (bc_id != <a class="code" href="classBoundaryInfo.php#a2a9670c3471907601fb62ae9dcce2eb4">BoundaryInfo::invalid_id</a>)
<a name="l00702"></a>00702               {
<a name="l00703"></a>00703                 xfer_bcs.push_back (n_local_level_0_elem); 
<a name="l00704"></a>00704                 xfer_bcs.push_back (s) ;
<a name="l00705"></a>00705                 xfer_bcs.push_back (bc_id);
<a name="l00706"></a>00706               }
<a name="l00707"></a>00707           }
<a name="l00708"></a>00708     }
<a name="l00709"></a>00709 
<a name="l00710"></a>00710   xfer_bcs.push_back(n_local_level_0_elem);
<a name="l00711"></a>00711   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_size = xfer_bcs.size();
<a name="l00712"></a>00712   Parallel::gather (0, my_size, bc_sizes);
<a name="l00713"></a>00713   
<a name="l00714"></a>00714   <span class="comment">// All processors send their xfer buffers to processor 0</span>
<a name="l00715"></a>00715   <span class="comment">// Processor 0 will receive all buffers and write out the bcs</span>
<a name="l00716"></a>00716   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00717"></a>00717     {
<a name="l00718"></a>00718       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0, elem_offset=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00719"></a>00719         {
<a name="l00720"></a>00720           recv_bcs.resize(bc_sizes[pid]);
<a name="l00721"></a>00721           <span class="keywordflow">if</span> (pid == 0)
<a name="l00722"></a>00722             recv_bcs = xfer_bcs;
<a name="l00723"></a>00723           <span class="keywordflow">else</span>
<a name="l00724"></a>00724             Parallel::receive (pid, recv_bcs);
<a name="l00725"></a>00725 
<a name="l00726"></a>00726           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local_level_0_elem 
<a name="l00727"></a>00727             = recv_bcs.back(); recv_bcs.pop_back();
<a name="l00728"></a>00728           
<a name="l00729"></a>00729           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;recv_bcs.size(); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a> += 3, n_bcs_out++)
<a name="l00730"></a>00730             recv_bcs[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+0] += elem_offset;
<a name="l00731"></a>00731 
<a name="l00732"></a>00732           io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (recv_bcs.empty() ? NULL : &amp;recv_bcs[0], recv_bcs.size(), 3);
<a name="l00733"></a>00733           elem_offset += n_local_level_0_elem;
<a name="l00734"></a>00734         }    
<a name="l00735"></a>00735       libmesh_assert (n_bcs == n_bcs_out);
<a name="l00736"></a>00736     }
<a name="l00737"></a>00737   <span class="keywordflow">else</span>
<a name="l00738"></a>00738     Parallel::send (0, xfer_bcs);
<a name="l00739"></a>00739 } 
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 
<a name="l00743"></a><a class="code" href="classXdrIO.php#a6e77c8d1f5d2bfb2702ba8fe1b1fc217">00743</a> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a6e77c8d1f5d2bfb2702ba8fe1b1fc217">XdrIO::read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00744"></a>00744 {
<a name="l00745"></a>00745   <span class="comment">// Only open the file on processor 0 -- this is especially important because</span>
<a name="l00746"></a>00746   <span class="comment">// there may be an underlying bzip/bunzip going on, and multiple simultaneous</span>
<a name="l00747"></a>00747   <span class="comment">// calls will produce a race condition.</span>
<a name="l00748"></a>00748   <a class="code" href="classXdr.php">Xdr</a> io (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0 ? name : <span class="stringliteral">&quot;&quot;</span>, this-&gt;<a class="code" href="classXdrIO.php#adb181910c1820f41d8528b11ee92e6d0">binary</a>() ? <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a> : <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l00749"></a>00749    
<a name="l00750"></a>00750   <span class="comment">// convenient reference to our mesh</span>
<a name="l00751"></a>00751   <a class="code" href="classMeshBase.php">MeshBase</a> &amp;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00752"></a>00752 
<a name="l00753"></a>00753   <span class="comment">// get the version string.   </span>
<a name="l00754"></a>00754   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)    
<a name="l00755"></a>00755     io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#af2ae571e0fdec4fa5ac4fc50b20e9261">version</a>());
<a name="l00756"></a>00756   Parallel::broadcast (this-&gt;<a class="code" href="classXdrIO.php#af2ae571e0fdec4fa5ac4fc50b20e9261">version</a>());  
<a name="l00757"></a>00757   
<a name="l00758"></a>00758   <span class="comment">// note that for &quot;legacy&quot; files the first entry is an</span>
<a name="l00759"></a>00759   <span class="comment">// integer -- not a string at all.</span>
<a name="l00760"></a>00760   this-&gt;<a class="code" href="classXdrIO.php#a3b61626fc0c3b9781262ea0f8d7f985b">legacy</a>() = !(this-&gt;<a class="code" href="classXdrIO.php#af2ae571e0fdec4fa5ac4fc50b20e9261">version</a>().find(<span class="stringliteral">&quot;libMesh&quot;</span>) &lt; this-&gt;<a class="code" href="classXdrIO.php#af2ae571e0fdec4fa5ac4fc50b20e9261">version</a>().size());
<a name="l00761"></a>00761 
<a name="l00762"></a>00762   <span class="comment">// Check for a legacy version format.</span>
<a name="l00763"></a>00763   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classXdrIO.php#a3b61626fc0c3b9781262ea0f8d7f985b">legacy</a>())
<a name="l00764"></a>00764     {
<a name="l00765"></a>00765       io.<a class="code" href="classXdr.php#a68dc02dd44f5f69b76813967d1d611cf">close</a>();
<a name="l00766"></a>00766       <a class="code" href="classLegacyXdrIO.php">LegacyXdrIO</a>(mesh, this-&gt;<a class="code" href="classXdrIO.php#adb181910c1820f41d8528b11ee92e6d0">binary</a>()).<a class="code" href="classLegacyXdrIO.php#aafa2ae95dcc72c51d3aad725db09cb73">read</a>(name);
<a name="l00767"></a>00767       <span class="keywordflow">return</span>;
<a name="l00768"></a>00768     }
<a name="l00769"></a>00769 
<a name="l00770"></a>00770   START_LOG(<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00771"></a>00771   
<a name="l00772"></a>00772   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>, <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>;
<a name="l00773"></a>00773   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00774"></a>00774     {
<a name="l00775"></a>00775       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_elem);
<a name="l00776"></a>00776       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_nodes);
<a name="l00777"></a>00777       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#a66b8fa755de36072901878ab85b7b521">boundary_condition_file_name</a>()); <span class="comment">// std::cout &lt;&lt; &quot;bc_file=&quot;  &lt;&lt; this-&gt;boundary_condition_file_name() &lt;&lt; std::endl;</span>
<a name="l00778"></a>00778       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#ac9aafea778ff51fcbe499b437ff12445">subdomain_map_file_name</a>());      <span class="comment">// std::cout &lt;&lt; &quot;sid_file=&quot; &lt;&lt; this-&gt;subdomain_map_file_name()      &lt;&lt; std::endl;</span>
<a name="l00779"></a>00779       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#aefd6832ee480c9c1da7bcd568e4adf2d">partition_map_file_name</a>());      <span class="comment">// std::cout &lt;&lt; &quot;pid_file=&quot; &lt;&lt; this-&gt;partition_map_file_name()      &lt;&lt; std::endl;</span>
<a name="l00780"></a>00780       io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (this-&gt;<a class="code" href="classXdrIO.php#a30371679b31186e42aaf8547079758e1">polynomial_level_file_name</a>());   <span class="comment">// std::cout &lt;&lt; &quot;pl_file=&quot;  &lt;&lt; this-&gt;polynomial_level_file_name()   &lt;&lt; std::endl;</span>
<a name="l00781"></a>00781     }
<a name="l00782"></a>00782 
<a name="l00783"></a>00783   <span class="comment">//TODO:[BSK] a little extra effort here could change this to two broadcasts...</span>
<a name="l00784"></a>00784   Parallel::broadcast (n_elem);
<a name="l00785"></a>00785   Parallel::broadcast (n_nodes);
<a name="l00786"></a>00786   Parallel::broadcast (this-&gt;<a class="code" href="classXdrIO.php#a66b8fa755de36072901878ab85b7b521">boundary_condition_file_name</a>());
<a name="l00787"></a>00787   Parallel::broadcast (this-&gt;<a class="code" href="classXdrIO.php#ac9aafea778ff51fcbe499b437ff12445">subdomain_map_file_name</a>());
<a name="l00788"></a>00788   Parallel::broadcast (this-&gt;<a class="code" href="classXdrIO.php#aefd6832ee480c9c1da7bcd568e4adf2d">partition_map_file_name</a>());
<a name="l00789"></a>00789   Parallel::broadcast (this-&gt;<a class="code" href="classXdrIO.php#a30371679b31186e42aaf8547079758e1">polynomial_level_file_name</a>());
<a name="l00790"></a>00790   
<a name="l00791"></a>00791   <span class="comment">// Tell the mesh how many nodes/elements to expect. Depending on the mesh type,</span>
<a name="l00792"></a>00792   <span class="comment">// this may allow for efficient adding of nodes/elements.</span>
<a name="l00793"></a>00793   mesh.<a class="code" href="classMeshBase.php#ae034eb4ecaa04c32b89909d9eee85411">reserve_elem</a>(n_elem);
<a name="l00794"></a>00794   mesh.<a class="code" href="classMeshBase.php#a641a3da2df67396c48c9a9b2434b4d68">reserve_nodes</a>(n_nodes);
<a name="l00795"></a>00795 
<a name="l00796"></a>00796   <span class="comment">// read connectivity</span>
<a name="l00797"></a>00797   this-&gt;<a class="code" href="classXdrIO.php#a9b8bb9dd6f6af372293143a99010a246">read_serialized_connectivity</a> (io, n_elem);
<a name="l00798"></a>00798 
<a name="l00799"></a>00799   <span class="comment">// read the nodal locations</span>
<a name="l00800"></a>00800   this-&gt;<a class="code" href="classXdrIO.php#a8d597eb96e0ce442869347455bb8ed71">read_serialized_nodes</a> (io, n_nodes);  
<a name="l00801"></a>00801 
<a name="l00802"></a>00802   <span class="comment">// read the boundary conditions</span>
<a name="l00803"></a>00803   this-&gt;<a class="code" href="classXdrIO.php#a1243f776fc3c3871b6c9c6d23db094e6">read_serialized_bcs</a> (io);
<a name="l00804"></a>00804 
<a name="l00805"></a>00805   STOP_LOG(<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00806"></a>00806    
<a name="l00807"></a>00807   <span class="comment">// set the node processor ids</span>
<a name="l00808"></a>00808   <a class="code" href="classPartitioner.php#adc818fcff7a1cdc8c2eff63c72ac7a42">Partitioner::set_node_processor_ids</a>(mesh);
<a name="l00809"></a>00809 }
<a name="l00810"></a>00810 
<a name="l00811"></a>00811 
<a name="l00812"></a>00812 
<a name="l00813"></a><a class="code" href="classXdrIO.php#a9b8bb9dd6f6af372293143a99010a246">00813</a> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a9b8bb9dd6f6af372293143a99010a246">XdrIO::read_serialized_connectivity</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>)
<a name="l00814"></a>00814 {
<a name="l00815"></a>00815   libmesh_assert (io.<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>());
<a name="l00816"></a>00816 
<a name="l00817"></a>00817   <span class="keywordflow">if</span> (!n_elem) <span class="keywordflow">return</span>;
<a name="l00818"></a>00818   
<a name="l00819"></a>00819   <span class="keyword">const</span> <span class="keywordtype">bool</span>
<a name="l00820"></a>00820     read_p_level      = (<span class="stringliteral">&quot;.&quot;</span> == this-&gt;<a class="code" href="classXdrIO.php#a30371679b31186e42aaf8547079758e1">polynomial_level_file_name</a>()),
<a name="l00821"></a>00821     read_partitioning = (<span class="stringliteral">&quot;.&quot;</span> == this-&gt;<a class="code" href="classXdrIO.php#aefd6832ee480c9c1da7bcd568e4adf2d">partition_map_file_name</a>()),
<a name="l00822"></a>00822     read_subdomain_id = (<span class="stringliteral">&quot;.&quot;</span> == this-&gt;<a class="code" href="classXdrIO.php#ac9aafea778ff51fcbe499b437ff12445">subdomain_map_file_name</a>());
<a name="l00823"></a>00823   
<a name="l00824"></a>00824   <span class="comment">// convenient reference to our mesh</span>
<a name="l00825"></a>00825   <a class="code" href="classMeshBase.php">MeshBase</a> &amp;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00826"></a>00826 
<a name="l00827"></a>00827   std::vector&lt;unsigned int&gt; conn, input_buffer(100 <span class="comment">/* oversized ! */</span>);
<a name="l00828"></a>00828 
<a name="l00829"></a>00829   <span class="keywordtype">int</span> level=-1;
<a name="l00830"></a>00830   
<a name="l00831"></a>00831   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> blk=0, first_elem=0, last_elem=0, n_elem_at_level=0, n_processed_at_level=0;
<a name="l00832"></a>00832        last_elem&lt;<a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>; blk++)
<a name="l00833"></a>00833     {
<a name="l00834"></a>00834       first_elem = blk*<a class="code" href="classXdrIO.php#a15b4a5e6f9a2981a80e871288059e699">io_blksize</a>;
<a name="l00835"></a>00835       last_elem  = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((blk+1)*io_blksize, n_elem);
<a name="l00836"></a>00836 
<a name="l00837"></a>00837       conn.clear();
<a name="l00838"></a>00838 
<a name="l00839"></a>00839       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00840"></a>00840         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=first_elem; e&lt;last_elem; e++, n_processed_at_level++)
<a name="l00841"></a>00841           {
<a name="l00842"></a>00842             <span class="keywordflow">if</span> (n_processed_at_level == n_elem_at_level)
<a name="l00843"></a>00843               {
<a name="l00844"></a>00844                 <span class="comment">// get the number of elements to read at this level</span>
<a name="l00845"></a>00845                 io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_elem_at_level);
<a name="l00846"></a>00846                 n_processed_at_level = 0;
<a name="l00847"></a>00847                 level++;
<a name="l00848"></a>00848               }
<a name="l00849"></a>00849             
<a name="l00850"></a>00850             <span class="comment">// get the element type, </span>
<a name="l00851"></a>00851             io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (&amp;input_buffer[0], 1);
<a name="l00852"></a>00852 
<a name="l00853"></a>00853             <span class="comment">// maybe the parent</span>
<a name="l00854"></a>00854             <span class="keywordflow">if</span> (level)
<a name="l00855"></a>00855               io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (&amp;input_buffer[1], 1);
<a name="l00856"></a>00856             <span class="keywordflow">else</span>
<a name="l00857"></a>00857               input_buffer[1] = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00858"></a>00858 
<a name="l00859"></a>00859             <span class="comment">// maybe the processor id</span>
<a name="l00860"></a>00860             <span class="keywordflow">if</span> (read_partitioning)
<a name="l00861"></a>00861               io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (&amp;input_buffer[2], 1);
<a name="l00862"></a>00862             <span class="keywordflow">else</span>
<a name="l00863"></a>00863               input_buffer[2] = 0;
<a name="l00864"></a>00864 
<a name="l00865"></a>00865             <span class="comment">// maybe the subdomain id</span>
<a name="l00866"></a>00866             <span class="keywordflow">if</span> (read_subdomain_id)
<a name="l00867"></a>00867               io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (&amp;input_buffer[3], 1);
<a name="l00868"></a>00868             <span class="keywordflow">else</span> 
<a name="l00869"></a>00869               input_buffer[3] = 0;
<a name="l00870"></a>00870 
<a name="l00871"></a>00871             <span class="comment">// maybe the p level</span>
<a name="l00872"></a>00872             <span class="keywordflow">if</span> (read_p_level)
<a name="l00873"></a>00873               io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (&amp;input_buffer[4], 1);
<a name="l00874"></a>00874             <span class="keywordflow">else</span>
<a name="l00875"></a>00875               input_buffer[4] = 0;
<a name="l00876"></a>00876             
<a name="l00877"></a>00877             <span class="comment">// and all the nodes</span>
<a name="l00878"></a>00878             libmesh_assert (5+<a class="code" href="classElem.php#aef05e33c03cee6724a1e26b8fb9d19fd">Elem::type_to_n_nodes_map</a>[input_buffer[0]] &lt; input_buffer.size());
<a name="l00879"></a>00879             io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (&amp;input_buffer[5], <a class="code" href="classElem.php#aef05e33c03cee6724a1e26b8fb9d19fd">Elem::type_to_n_nodes_map</a>[input_buffer[0]]);
<a name="l00880"></a>00880             conn.insert (conn.end(),
<a name="l00881"></a>00881                          input_buffer.begin(),
<a name="l00882"></a>00882                          input_buffer.begin() + 5 + <a class="code" href="classElem.php#aef05e33c03cee6724a1e26b8fb9d19fd">Elem::type_to_n_nodes_map</a>[input_buffer[0]]);
<a name="l00883"></a>00883           }
<a name="l00884"></a>00884       
<a name="l00885"></a>00885       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> conn_size = conn.size();
<a name="l00886"></a>00886       Parallel::broadcast(conn_size);       
<a name="l00887"></a>00887       conn.resize (conn_size);
<a name="l00888"></a>00888       Parallel::broadcast (conn);
<a name="l00889"></a>00889 
<a name="l00890"></a>00890       <span class="comment">// All processors now have the connectivity for this block.</span>
<a name="l00891"></a>00891       std::vector&lt;unsigned int&gt;::const_iterator it = conn.begin();      
<a name="l00892"></a>00892       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=first_elem; e&lt;last_elem; e++)
<a name="l00893"></a>00893         {
<a name="l00894"></a>00894           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> elem_type        = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a><span class="keyword">&gt;</span>(*it); ++it;
<a name="l00895"></a>00895           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_id    = *it; ++it;
<a name="l00896"></a>00896           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a> = *it; ++it;
<a name="l00897"></a>00897           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id = *it; ++it;
<a name="l00898"></a>00898 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00899"></a>00899 <span class="preprocessor"></span>          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level      = *it;
<a name="l00900"></a>00900 <span class="preprocessor">#endif</span>
<a name="l00901"></a>00901 <span class="preprocessor"></span>          ++it;
<a name="l00902"></a>00902 
<a name="l00903"></a>00903           <a class="code" href="classElem.php">Elem</a> *parent = (parent_id == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) ? NULL : mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(parent_id);
<a name="l00904"></a>00904 
<a name="l00905"></a>00905           <a class="code" href="classElem.php">Elem</a> *elem = <a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">Elem::build</a> (elem_type, parent).release();
<a name="l00906"></a>00906           elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>() = e;
<a name="l00907"></a>00907           elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>;
<a name="l00908"></a>00908           elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>() = subdomain_id;
<a name="l00909"></a>00909 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00910"></a>00910 <span class="preprocessor"></span>          elem-&gt;<a class="code" href="classElem.php#aa9e1248d65ada8cd61e5af270d01cf53">hack_p_level</a>(p_level);
<a name="l00911"></a>00911 
<a name="l00912"></a>00912           <span class="keywordflow">if</span> (parent)
<a name="l00913"></a>00913             {
<a name="l00914"></a>00914               parent-&gt;<a class="code" href="classElem.php#a791ed16f88c661c7ed22e10e0cf8d8ff">add_child</a>(elem);
<a name="l00915"></a>00915               parent-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a> (<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00916"></a>00916               elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>   (<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>);
<a name="l00917"></a>00917             }
<a name="l00918"></a>00918 <span class="preprocessor">#endif</span>
<a name="l00919"></a>00919 <span class="preprocessor"></span>
<a name="l00920"></a>00920           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++, ++it)
<a name="l00921"></a>00921             {
<a name="l00922"></a>00922               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_node_number = *it;
<a name="l00923"></a>00923 
<a name="l00924"></a>00924               elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(n) = 
<a name="l00925"></a>00925                 mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> (<a class="code" href="classPoint.php">Point</a>(), global_node_number);
<a name="l00926"></a>00926             }
<a name="l00927"></a>00927           
<a name="l00928"></a>00928           mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l00929"></a>00929         }
<a name="l00930"></a>00930     }
<a name="l00931"></a>00931 }
<a name="l00932"></a>00932 
<a name="l00933"></a>00933 
<a name="l00934"></a>00934 
<a name="l00935"></a><a class="code" href="classXdrIO.php#a8d597eb96e0ce442869347455bb8ed71">00935</a> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a8d597eb96e0ce442869347455bb8ed71">XdrIO::read_serialized_nodes</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>)
<a name="l00936"></a>00936 {
<a name="l00937"></a>00937   libmesh_assert (io.<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>());
<a name="l00938"></a>00938   
<a name="l00939"></a>00939   <span class="comment">// convenient reference to our mesh</span>
<a name="l00940"></a>00940   <a class="code" href="classMeshBase.php">MeshBase</a> &amp;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00941"></a>00941   
<a name="l00942"></a>00942   <span class="keywordflow">if</span> (!mesh.n_nodes()) <span class="keywordflow">return</span>;
<a name="l00943"></a>00943 
<a name="l00944"></a>00944   <span class="comment">// At this point the elements have been read from file and placeholder nodes</span>
<a name="l00945"></a>00945   <span class="comment">// have been assigned.  These nodes, however, do not have the proper (x,y,z)</span>
<a name="l00946"></a>00946   <span class="comment">// locations.  This method will read all the nodes from disk, and each processor</span>
<a name="l00947"></a>00947   <span class="comment">// can then grab the individual values it needs.</span>
<a name="l00948"></a>00948 
<a name="l00949"></a>00949   <span class="comment">// build up a list of the nodes contained in our local mesh.  These are the nodes</span>
<a name="l00950"></a>00950   <span class="comment">// stored on the local processor whose (x,y,z) values need to be corrected.</span>
<a name="l00951"></a>00951   std::vector&lt;unsigned int&gt; needed_nodes; needed_nodes.reserve (mesh.n_nodes());
<a name="l00952"></a>00952   {
<a name="l00953"></a>00953     <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>
<a name="l00954"></a>00954       it  = mesh.nodes_begin(),
<a name="l00955"></a>00955       end = mesh.nodes_end();
<a name="l00956"></a>00956 
<a name="l00957"></a>00957     <span class="keywordflow">for</span> (; it!=end; ++it)
<a name="l00958"></a>00958       needed_nodes.push_back((*it)-&gt;id());
<a name="l00959"></a>00959 
<a name="l00960"></a>00960     std::sort (needed_nodes.begin(), needed_nodes.end());
<a name="l00961"></a>00961 
<a name="l00962"></a>00962     <span class="comment">// We should not have any duplicate node-&gt;id()s</span>
<a name="l00963"></a>00963     libmesh_assert (std::unique(needed_nodes.begin(), needed_nodes.end()) == needed_nodes.end());
<a name="l00964"></a>00964   }
<a name="l00965"></a>00965 
<a name="l00966"></a>00966   <span class="comment">// Get the nodes in blocks.</span>
<a name="l00967"></a>00967   std::vector&lt;Real&gt; coords;
<a name="l00968"></a>00968   std::pair&lt;std::vector&lt;unsigned int&gt;::iterator,
<a name="l00969"></a>00969             std::vector&lt;unsigned int&gt;::iterator&gt; pos;
<a name="l00970"></a>00970   pos.first = needed_nodes.begin();
<a name="l00971"></a>00971 
<a name="l00972"></a>00972   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> blk=0, first_node=0, last_node=0; last_node&lt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>; blk++)
<a name="l00973"></a>00973     {
<a name="l00974"></a>00974       first_node = blk*<a class="code" href="classXdrIO.php#a15b4a5e6f9a2981a80e871288059e699">io_blksize</a>;
<a name="l00975"></a>00975       last_node  = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((blk+1)*io_blksize, n_nodes);
<a name="l00976"></a>00976       
<a name="l00977"></a>00977       coords.resize(3*(last_node - first_node));
<a name="l00978"></a>00978         
<a name="l00979"></a>00979       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00980"></a>00980         io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (coords.empty() ? NULL : &amp;coords[0], coords.size());
<a name="l00981"></a>00981 
<a name="l00982"></a>00982       <span class="comment">// For large numbers of processors the majority of processors at any given</span>
<a name="l00983"></a>00983       <span class="comment">// block may not actually need these data.  It may be worth profiling this,</span>
<a name="l00984"></a>00984       <span class="comment">// although it is expected that disk IO will be the bottleneck</span>
<a name="l00985"></a>00985       Parallel::broadcast (coords);
<a name="l00986"></a>00986       
<a name="l00987"></a>00987       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=first_node, <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; n&lt;last_node; n++, <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+=3)
<a name="l00988"></a>00988         {
<a name="l00989"></a>00989           <span class="comment">// first see if we need this node.  use pos.first as a smart lower</span>
<a name="l00990"></a>00990           <span class="comment">// bound, this will ensure that the size of the searched range</span>
<a name="l00991"></a>00991           <span class="comment">// decreases as we match nodes.</span>
<a name="l00992"></a>00992           pos = std::equal_range (pos.first, needed_nodes.end(), n);
<a name="l00993"></a>00993 
<a name="l00994"></a>00994           <span class="keywordflow">if</span> (pos.first != pos.second) <span class="comment">// we need this node.</span>
<a name="l00995"></a>00995             {
<a name="l00996"></a>00996               libmesh_assert (*pos.first == n);
<a name="l00997"></a>00997               mesh.node(n) = 
<a name="l00998"></a>00998                 <a class="code" href="classPoint.php">Point</a> (coords[idx+0],
<a name="l00999"></a>00999                        coords[idx+1],
<a name="l01000"></a>01000                        coords[idx+2]);
<a name="l01001"></a>01001 
<a name="l01002"></a>01002             }
<a name="l01003"></a>01003         }         
<a name="l01004"></a>01004     }    
<a name="l01005"></a>01005 }
<a name="l01006"></a>01006 
<a name="l01007"></a>01007 
<a name="l01008"></a>01008 
<a name="l01009"></a><a class="code" href="classXdrIO.php#a1243f776fc3c3871b6c9c6d23db094e6">01009</a> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a1243f776fc3c3871b6c9c6d23db094e6">XdrIO::read_serialized_bcs</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io)
<a name="l01010"></a>01010 {
<a name="l01011"></a>01011   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classXdrIO.php#a66b8fa755de36072901878ab85b7b521">boundary_condition_file_name</a>() == <span class="stringliteral">&quot;n/a&quot;</span>) <span class="keywordflow">return</span>;
<a name="l01012"></a>01012 
<a name="l01013"></a>01013   libmesh_assert (io.<a class="code" href="classXdr.php#a7092df3f10040c5a39a14385cc4888af">reading</a>());
<a name="l01014"></a>01014   
<a name="l01015"></a>01015   <span class="comment">// convenient reference to our mesh</span>
<a name="l01016"></a>01016   <a class="code" href="classMeshBase.php">MeshBase</a> &amp;<a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">mesh</a> = <a class="code" href="classMeshInput.php#a2e8be596b1583aa3348740f461562d24">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l01017"></a>01017   
<a name="l01018"></a>01018   <span class="comment">// and our boundary info object</span>
<a name="l01019"></a>01019   <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a> &amp;boundary_info = *mesh.boundary_info;
<a name="l01020"></a>01020 
<a name="l01021"></a>01021   std::vector&lt;ElemBCData&gt; elem_bc_data;
<a name="l01022"></a>01022   std::vector&lt;int&gt; input_buffer;
<a name="l01023"></a>01023 
<a name="l01024"></a>01024   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs=0;
<a name="l01025"></a>01025   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) 
<a name="l01026"></a>01026     io.<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a> (n_bcs);
<a name="l01027"></a>01027   Parallel::broadcast (n_bcs);
<a name="l01028"></a>01028 
<a name="l01029"></a>01029   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> blk=0, first_bc=0, last_bc=0; last_bc&lt;n_bcs; blk++)
<a name="l01030"></a>01030     {
<a name="l01031"></a>01031       first_bc = blk*<a class="code" href="classXdrIO.php#a15b4a5e6f9a2981a80e871288059e699">io_blksize</a>;
<a name="l01032"></a>01032       last_bc  = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((blk+1)*io_blksize, n_bcs);
<a name="l01033"></a>01033 
<a name="l01034"></a>01034       input_buffer.resize (3*(last_bc - first_bc));
<a name="l01035"></a>01035 
<a name="l01036"></a>01036       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01037"></a>01037         io.<a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">data_stream</a> (input_buffer.empty() ? NULL : &amp;input_buffer[0], input_buffer.size());
<a name="l01038"></a>01038       
<a name="l01039"></a>01039       Parallel::broadcast (input_buffer);
<a name="l01040"></a>01040       elem_bc_data.clear();  elem_bc_data.reserve (input_buffer.size()/3);
<a name="l01041"></a>01041 
<a name="l01042"></a>01042       <span class="comment">// convert the input_buffer to ElemBCData to facilitate searching</span>
<a name="l01043"></a>01043       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>&lt;input_buffer.size(); <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+=3)
<a name="l01044"></a>01044         elem_bc_data.push_back (ElemBCData(input_buffer[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+0],
<a name="l01045"></a>01045                                            input_buffer[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+1],
<a name="l01046"></a>01046                                            input_buffer[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>+2]));
<a name="l01047"></a>01047       input_buffer.clear();
<a name="l01048"></a>01048       <span class="comment">// note that while the files *we* write should already be sorted by</span>
<a name="l01049"></a>01049       <span class="comment">// element id this is not necessarily guaranteed.</span>
<a name="l01050"></a>01050       std::sort (elem_bc_data.begin(), elem_bc_data.end());
<a name="l01051"></a>01051 
<a name="l01052"></a>01052       <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l01053"></a>01053         it  = mesh.level_elements_begin(0),
<a name="l01054"></a>01054         end = mesh.level_elements_end(0);
<a name="l01055"></a>01055 
<a name="l01056"></a>01056       <span class="comment">// Look for BCs in this block for all the level-0 elements we have </span>
<a name="l01057"></a>01057       <span class="comment">// (not just local ones).  Do this by finding all the entries</span>
<a name="l01058"></a>01058       <span class="comment">// in elem_bc_data whose elem_id match the ID of the current element.</span>
<a name="l01059"></a>01059       <span class="comment">// We cannot rely on NULL neighbors at this point since the neighbor</span>
<a name="l01060"></a>01060       <span class="comment">// data structure has not been initialized.</span>
<a name="l01061"></a>01061       <span class="keywordflow">for</span> (std::pair&lt;std::vector&lt;ElemBCData&gt;::iterator,
<a name="l01062"></a>01062                      std::vector&lt;ElemBCData&gt;::iterator&gt; pos; it!=end; ++it)
<a name="l01063"></a>01063 #<span class="keywordflow">if</span> defined(__SUNPRO_CC) || defined(__PGI)
<a name="l01064"></a>01064         <span class="keywordflow">for</span> (pos = std::equal_range (elem_bc_data.begin(), elem_bc_data.end(), (*it)-&gt;id(), CompareIntElemBCData());
<a name="l01065"></a>01065 <span class="preprocessor">#else</span>
<a name="l01066"></a>01066 <span class="preprocessor"></span>        <span class="keywordflow">for</span> (pos = std::equal_range (elem_bc_data.begin(), elem_bc_data.end(), (*it)-&gt;id());
<a name="l01067"></a>01067 <span class="preprocessor">#endif</span>
<a name="l01068"></a>01068 <span class="preprocessor"></span>             pos.first != pos.second; ++pos.first)
<a name="l01069"></a>01069           {
<a name="l01070"></a>01070             libmesh_assert (pos.first-&gt;elem_id == (*it)-&gt;id());
<a name="l01071"></a>01071             libmesh_assert (pos.first-&gt;side &lt; (*it)-&gt;n_sides());
<a name="l01072"></a>01072 
<a name="l01073"></a>01073             boundary_info.<a class="code" href="classBoundaryInfo.php#a98ca8858756f9d549cbf8b3bb324f363">add_side</a> (*it, pos.first-&gt;side, pos.first-&gt;bc_id);
<a name="l01074"></a>01074           }     
<a name="l01075"></a>01075     }
<a name="l01076"></a>01076 }
<a name="l01077"></a>01077 
<a name="l01078"></a>01078 
<a name="l01079"></a>01079 
<a name="l01080"></a><a class="code" href="classXdrIO.php#aaae814f408b28aef140b3eb839f8d987">01080</a> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#aaae814f408b28aef140b3eb839f8d987">XdrIO::pack_element</a> (std::vector&lt;unsigned int&gt; &amp;conn, <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem, 
<a name="l01081"></a>01081                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_id, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_pid)<span class="keyword"> const</span>
<a name="l01082"></a>01082 <span class="keyword"></span>{
<a name="l01083"></a>01083   libmesh_assert (elem != NULL);
<a name="l01084"></a>01084   libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>() == <a class="code" href="classElem.php#aef05e33c03cee6724a1e26b8fb9d19fd">Elem::type_to_n_nodes_map</a>[elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()]);
<a name="l01085"></a>01085   
<a name="l01086"></a>01086   conn.push_back(elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l01087"></a>01087 
<a name="l01088"></a>01088   conn.push_back (elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l01089"></a>01089   conn.push_back (elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l01090"></a>01090   
<a name="l01091"></a>01091   <span class="keywordflow">if</span> (parent_id != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l01092"></a>01092     {
<a name="l01093"></a>01093       conn.push_back (parent_id);
<a name="l01094"></a>01094       libmesh_assert (parent_pid != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l01095"></a>01095       conn.push_back (parent_pid);
<a name="l01096"></a>01096     }
<a name="l01097"></a>01097   
<a name="l01098"></a>01098   conn.push_back (elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>());
<a name="l01099"></a>01099   conn.push_back (elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>());
<a name="l01100"></a>01100   
<a name="l01101"></a>01101 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01102"></a>01102 <span class="preprocessor"></span>  conn.push_back (elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l01103"></a>01103 <span class="preprocessor">#endif</span>
<a name="l01104"></a>01104 <span class="preprocessor"></span>  
<a name="l01105"></a>01105   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l01106"></a>01106     conn.push_back (elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n));                 
<a name="l01107"></a>01107 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
