<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_io.h</h1>  </div>
</div>
<div class="contents">
<a href="xdr__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_io.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __xdr_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;libmesh.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span><a class="code" href="classMeshBase.php">MeshBase</a>;
<a name="l00037"></a>00037 <span class="keyword">class </span><a class="code" href="classMeshData.php">MeshData</a>;
<a name="l00038"></a>00038 <span class="keyword">class </span><a class="code" href="classXdr.php">Xdr</a>;
<a name="l00039"></a>00039 <span class="keyword">class </span><a class="code" href="classElem.php">Elem</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// XdrIO class definition</span>
<a name="l00049"></a><a class="code" href="classXdrIO.php">00049</a> <span class="keyword">class </span><a class="code" href="classXdrIO.php">XdrIO</a> : <span class="keyword">public</span> <a class="code" href="classMeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00050"></a>00050               <span class="keyword">public</span> <a class="code" href="classMeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 
<a name="l00053"></a>00053  <span class="keyword">public</span>:
<a name="l00054"></a>00054 
<a name="l00062"></a>00062   <a class="code" href="classXdrIO.php#ac572facda9e11513a63291ce7ed5a838">XdrIO</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp;,       <span class="keyword">const</span> <span class="keywordtype">bool</span>=<span class="keyword">false</span>);
<a name="l00063"></a>00063 
<a name="l00071"></a>00071   <a class="code" href="classXdrIO.php#ac572facda9e11513a63291ce7ed5a838">XdrIO</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span>=<span class="keyword">false</span>);
<a name="l00072"></a>00072   
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <a class="code" href="classXdrIO.php#a30a45d0fbc3db8768dbc70baac8c91e6">~XdrIO</a> ();
<a name="l00077"></a>00077   
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a6e77c8d1f5d2bfb2702ba8fe1b1fc217">read</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00082"></a>00082     
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#ad291a0b4cd3338da79e625474f192e5c">write</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00087"></a>00087 
<a name="l00091"></a><a class="code" href="classXdrIO.php#adb181910c1820f41d8528b11ee92e6d0">00091</a>   <span class="keywordtype">bool</span>   <a class="code" href="classXdrIO.php#adb181910c1820f41d8528b11ee92e6d0">binary</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#a093b262fe17ae1aada1a0b3607384ade">_binary</a>; };
<a name="l00092"></a><a class="code" href="classXdrIO.php#a7bad84b323f451f14badee365ea245ac">00092</a>   <span class="keywordtype">bool</span> &amp; <a class="code" href="classXdrIO.php#a7bad84b323f451f14badee365ea245ac">binary</a>()       { <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#a093b262fe17ae1aada1a0b3607384ade">_binary</a>; };
<a name="l00093"></a>00093   
<a name="l00097"></a><a class="code" href="classXdrIO.php#a3b61626fc0c3b9781262ea0f8d7f985b">00097</a>   <span class="keywordtype">bool</span>   <a class="code" href="classXdrIO.php#a3b61626fc0c3b9781262ea0f8d7f985b">legacy</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#afe0b7d1b0bf5ae6dfa997d66d0a3f74e">_legacy</a>; };
<a name="l00098"></a><a class="code" href="classXdrIO.php#a679e454b1efe5fb1693350f29285075b">00098</a>   <span class="keywordtype">bool</span> &amp; <a class="code" href="classXdrIO.php#a679e454b1efe5fb1693350f29285075b">legacy</a>()       { <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#afe0b7d1b0bf5ae6dfa997d66d0a3f74e">_legacy</a>; };
<a name="l00099"></a>00099   
<a name="l00112"></a><a class="code" href="classXdrIO.php#af2ae571e0fdec4fa5ac4fc50b20e9261">00112</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classXdrIO.php#af2ae571e0fdec4fa5ac4fc50b20e9261">version</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#a71c0416e15483dbbf5a4ec0350439bd7">_version</a>; };
<a name="l00113"></a><a class="code" href="classXdrIO.php#a7599496eef698aaec74604ee6b79e20d">00113</a>   std::string &amp;       <a class="code" href="classXdrIO.php#a7599496eef698aaec74604ee6b79e20d">version</a> ()       { <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#a71c0416e15483dbbf5a4ec0350439bd7">_version</a>; };
<a name="l00114"></a>00114 
<a name="l00118"></a><a class="code" href="classXdrIO.php#a66b8fa755de36072901878ab85b7b521">00118</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classXdrIO.php#a66b8fa755de36072901878ab85b7b521">boundary_condition_file_name</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#ae688f657c7b754cb4d4591c78339e9c5">_bc_file_name</a>; };
<a name="l00119"></a><a class="code" href="classXdrIO.php#a6033002f2b208f3cc349f6589c2de840">00119</a>   std::string &amp;       <a class="code" href="classXdrIO.php#a6033002f2b208f3cc349f6589c2de840">boundary_condition_file_name</a>()       { <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#ae688f657c7b754cb4d4591c78339e9c5">_bc_file_name</a>; };
<a name="l00120"></a>00120 
<a name="l00124"></a><a class="code" href="classXdrIO.php#aefd6832ee480c9c1da7bcd568e4adf2d">00124</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classXdrIO.php#aefd6832ee480c9c1da7bcd568e4adf2d">partition_map_file_name</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#a97d39f44ac4f1627aa863f70ff869ff1">_partition_map_file</a>; };
<a name="l00125"></a><a class="code" href="classXdrIO.php#afa3b663edbb4c100c784b030f0595da5">00125</a>   std::string &amp;       <a class="code" href="classXdrIO.php#afa3b663edbb4c100c784b030f0595da5">partition_map_file_name</a>()       { <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#a97d39f44ac4f1627aa863f70ff869ff1">_partition_map_file</a>; };
<a name="l00126"></a>00126 
<a name="l00130"></a><a class="code" href="classXdrIO.php#ac9aafea778ff51fcbe499b437ff12445">00130</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classXdrIO.php#ac9aafea778ff51fcbe499b437ff12445">subdomain_map_file_name</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#aa4ac699847140bac49cf929dbe870832">_subdomain_map_file</a>; };
<a name="l00131"></a><a class="code" href="classXdrIO.php#a4cafa3c495ac89a3569ebf6251995f3b">00131</a>   std::string &amp;       <a class="code" href="classXdrIO.php#a4cafa3c495ac89a3569ebf6251995f3b">subdomain_map_file_name</a>()       { <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#aa4ac699847140bac49cf929dbe870832">_subdomain_map_file</a>; };
<a name="l00132"></a>00132 
<a name="l00136"></a><a class="code" href="classXdrIO.php#a30371679b31186e42aaf8547079758e1">00136</a>   <span class="keyword">const</span> std::string &amp; <a class="code" href="classXdrIO.php#a30371679b31186e42aaf8547079758e1">polynomial_level_file_name</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#a8eacb3c62dc63f44322168ec09da07ee">_p_level_file</a>; };
<a name="l00137"></a><a class="code" href="classXdrIO.php#a90acc4dfe9bcd46c9062ad3127cd13d2">00137</a>   std::string &amp;       <a class="code" href="classXdrIO.php#a90acc4dfe9bcd46c9062ad3127cd13d2">polynomial_level_file_name</a>()       { <span class="keywordflow">return</span> <a class="code" href="classXdrIO.php#a8eacb3c62dc63f44322168ec09da07ee">_p_level_file</a>; };
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140  <span class="keyword">private</span>:
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00144"></a>00144   <span class="comment">// Write Implementation  </span>
<a name="l00148"></a>00148 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a0aac5a767e1dc420f9b81587d872a18e">write_serialized_connectivity</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>) <span class="keyword">const</span>;
<a name="l00149"></a>00149 
<a name="l00153"></a>00153   <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a5004adb5a38cf71608ca2d95a71ab86e">write_serialized_nodes</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>) <span class="keyword">const</span>;
<a name="l00154"></a>00154 
<a name="l00158"></a>00158   <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a76ed46446719fd66319a2981afd79ab0">write_serialized_bcs</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs) <span class="keyword">const</span>;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   
<a name="l00162"></a>00162   <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00163"></a>00163   <span class="comment">// Read Implementation</span>
<a name="l00167"></a>00167 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a9b8bb9dd6f6af372293143a99010a246">read_serialized_connectivity</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>);
<a name="l00168"></a>00168 
<a name="l00172"></a>00172   <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a8d597eb96e0ce442869347455bb8ed71">read_serialized_nodes</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>);
<a name="l00173"></a>00173 
<a name="l00177"></a>00177   <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#a1243f776fc3c3871b6c9c6d23db094e6">read_serialized_bcs</a> (<a class="code" href="classXdr.php">Xdr</a> &amp;io);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00183"></a>00183 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classXdrIO.php#aaae814f408b28aef140b3eb839f8d987">pack_element</a> (std::vector&lt;unsigned int&gt; &amp;conn, 
<a name="l00184"></a>00184                      <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem, 
<a name="l00185"></a>00185                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_id  = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>,
<a name="l00186"></a>00186                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_pid = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00187"></a>00187 
<a name="l00188"></a><a class="code" href="classXdrIO.php#a093b262fe17ae1aada1a0b3607384ade">00188</a>   <span class="keywordtype">bool</span> <a class="code" href="classXdrIO.php#a093b262fe17ae1aada1a0b3607384ade">_binary</a>;
<a name="l00189"></a><a class="code" href="classXdrIO.php#afe0b7d1b0bf5ae6dfa997d66d0a3f74e">00189</a>   <span class="keywordtype">bool</span> <a class="code" href="classXdrIO.php#afe0b7d1b0bf5ae6dfa997d66d0a3f74e">_legacy</a>;
<a name="l00190"></a><a class="code" href="classXdrIO.php#a71c0416e15483dbbf5a4ec0350439bd7">00190</a>   std::string <a class="code" href="classXdrIO.php#a71c0416e15483dbbf5a4ec0350439bd7">_version</a>;
<a name="l00191"></a><a class="code" href="classXdrIO.php#ae688f657c7b754cb4d4591c78339e9c5">00191</a>   std::string <a class="code" href="classXdrIO.php#ae688f657c7b754cb4d4591c78339e9c5">_bc_file_name</a>;
<a name="l00192"></a><a class="code" href="classXdrIO.php#a97d39f44ac4f1627aa863f70ff869ff1">00192</a>   std::string <a class="code" href="classXdrIO.php#a97d39f44ac4f1627aa863f70ff869ff1">_partition_map_file</a>;
<a name="l00193"></a><a class="code" href="classXdrIO.php#aa4ac699847140bac49cf929dbe870832">00193</a>   std::string <a class="code" href="classXdrIO.php#aa4ac699847140bac49cf929dbe870832">_subdomain_map_file</a>;
<a name="l00194"></a><a class="code" href="classXdrIO.php#a8eacb3c62dc63f44322168ec09da07ee">00194</a>   std::string <a class="code" href="classXdrIO.php#a8eacb3c62dc63f44322168ec09da07ee">_p_level_file</a>;
<a name="l00195"></a>00195 
<a name="l00199"></a><a class="code" href="classXdrIO.php#a15b4a5e6f9a2981a80e871288059e699">00199</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classXdrIO.php#a15b4a5e6f9a2981a80e871288059e699">io_blksize</a>;
<a name="l00200"></a>00200 };
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="preprocessor">#endif // #define __xdr_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
