<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_mesh.C</h1>  </div>
</div>
<div class="contents">
<a href="xdr__mesh_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_mesh.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;xdr_mesh.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;xdr_mhead.h&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span> <span class="comment">// for ElemType</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">// XdrMESH members</span>
<a name="l00027"></a><a class="code" href="classXdrMESH.php#a56ffaabfcfe3ca998154f3a2f5585f52">00027</a> <span class="keywordtype">int</span> <a class="code" href="classXdrMESH.php#a56ffaabfcfe3ca998154f3a2f5585f52">XdrMESH::header</a>(<a class="code" href="classXdrMHEAD.php">XdrMHEAD</a> *hd)
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029   <span class="comment">// Temporary variables to facilitate stream reading</span>
<a name="l00030"></a>00030   <span class="keyword">const</span> <span class="keywordtype">int</span> comm_len= 256;  
<a name="l00031"></a>00031   <span class="keywordtype">char</span> comment[comm_len];
<a name="l00032"></a>00032   
<a name="l00033"></a>00033   <span class="keywordflow">switch</span> (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a>)
<a name="l00034"></a>00034     {
<a name="l00035"></a>00035       
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>      
<a name="l00038"></a>00038     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">XdrMGF::DECODE</a>):
<a name="l00039"></a>00039     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>): 
<a name="l00040"></a>00040       {
<a name="l00041"></a>00041         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#aa6614145e5a33854a3be764445085a93">m_numel</a>));
<a name="l00042"></a>00042         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a>));
<a name="l00043"></a>00043         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#a9e6fb8f20c89ee79c3f340f8d6b38df2">m_sumWghts</a>));
<a name="l00044"></a>00044         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#acc1c4c5f2b0bdb02c0dcd4053e9f7c1e">m_numBCs</a>));
<a name="l00045"></a>00045         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>));
<a name="l00046"></a>00046         <span class="keywordflow">break</span>;
<a name="l00047"></a>00047       }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>      
<a name="l00051"></a>00051     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">XdrMGF::W_ASCII</a>):
<a name="l00052"></a>00052       {
<a name="l00053"></a>00053         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#aa6614145e5a33854a3be764445085a93">m_numel</a>    &lt;&lt; <span class="stringliteral">&quot;\t # Num. Elements\n&quot;</span>;
<a name="l00054"></a>00054         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a> &lt;&lt; <span class="stringliteral">&quot;\t # Num. Nodes\n&quot;</span>;
<a name="l00055"></a>00055         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#a9e6fb8f20c89ee79c3f340f8d6b38df2">m_sumWghts</a> &lt;&lt; <span class="stringliteral">&quot;\t # Sum of Element Weights\n&quot;</span>;
<a name="l00056"></a>00056         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#acc1c4c5f2b0bdb02c0dcd4053e9f7c1e">m_numBCs</a>   &lt;&lt; <span class="stringliteral">&quot;\t # Num. Boundary Conds.\n&quot;</span>;
<a name="l00057"></a>00057         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>  &lt;&lt; <span class="stringliteral">&quot;\t # String Size (ignore)\n&quot;</span>;
<a name="l00058"></a>00058         <span class="keywordflow">break</span>;
<a name="l00059"></a>00059       }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">XdrMGF::R_ASCII</a>):
<a name="l00062"></a>00062       {
<a name="l00063"></a>00063         libmesh_assert (<a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.good());
<a name="l00064"></a>00064         
<a name="l00065"></a>00065         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classXdrHEAD.php#aa6614145e5a33854a3be764445085a93">m_numel</a>    ; <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00066"></a>00066         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a> ; <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00067"></a>00067         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classXdrHEAD.php#a9e6fb8f20c89ee79c3f340f8d6b38df2">m_sumWghts</a> ; <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00068"></a>00068         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classXdrHEAD.php#acc1c4c5f2b0bdb02c0dcd4053e9f7c1e">m_numBCs</a>   ; <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00069"></a>00069         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>  ; <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071         libmesh_assert(<a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.good());
<a name="l00072"></a>00072 
<a name="l00073"></a>00073         <span class="keywordflow">break</span>;
<a name="l00074"></a>00074       }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keywordflow">default</span>:
<a name="l00077"></a>00077       <span class="comment">// Unknown access type</span>
<a name="l00078"></a>00078       libmesh_error();
<a name="l00079"></a>00079       
<a name="l00080"></a>00080     }
<a name="l00081"></a>00081   
<a name="l00082"></a>00082   <span class="comment">// Let&#39;s write the augmented header information</span>
<a name="l00083"></a>00083   <span class="comment">// before we write the title and id string</span>
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// Both DEAL and LIBM style files have augmented headers.</span>
<a name="l00086"></a>00086   <span class="keywordflow">if</span> ((<a class="code" href="classXdrMGF.php#a7ae03d62d21451cbcaba62d1357c8743">orig_flag</a> == 0) || (<a class="code" href="classXdrMGF.php#a7ae03d62d21451cbcaba62d1357c8743">orig_flag</a> == 2)) 
<a name="l00087"></a>00087     {
<a name="l00088"></a>00088 
<a name="l00089"></a>00089       <span class="keywordflow">switch</span> (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a>)
<a name="l00090"></a>00090         {
<a name="l00091"></a>00091           
<a name="l00092"></a>00092 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>          
<a name="l00094"></a>00094         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>):
<a name="l00095"></a>00095         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">XdrMGF::DECODE</a>):
<a name="l00096"></a>00096           {
<a name="l00097"></a>00097             <span class="comment">// this used to be 0.  How did that work?</span>
<a name="l00098"></a>00098             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp_n_blocks = hd-&gt;<a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>(); 
<a name="l00099"></a>00099             xdr_u_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>, &amp;temp_n_blocks);
<a name="l00100"></a>00100             hd-&gt;<a class="code" href="classXdrMHEAD.php#a8c70bef23afbc4a2c9f07b938663caed">set_n_blocks</a>(temp_n_blocks);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102             <span class="comment">// The number of blocks (i.e. the number of element types)</span>
<a name="l00103"></a>00103             <span class="comment">// for any mesh must always</span>
<a name="l00104"></a>00104             <span class="comment">// be at least 1.</span>
<a name="l00105"></a>00105             libmesh_assert(hd-&gt;<a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>() != 0);
<a name="l00106"></a>00106             <span class="keywordflow">break</span>;
<a name="l00107"></a>00107           }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="preprocessor">#endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>          
<a name="l00111"></a>00111         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">XdrMGF::W_ASCII</a>):
<a name="l00112"></a>00112           {
<a name="l00113"></a>00113             <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>() &lt;&lt; <span class="stringliteral">&quot;\t # Num. Element Blocks.\n&quot;</span>;
<a name="l00114"></a>00114             <span class="keywordflow">break</span>;
<a name="l00115"></a>00115           }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">XdrMGF::R_ASCII</a>):
<a name="l00118"></a>00118           {
<a name="l00119"></a>00119             libmesh_assert (<a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.good());
<a name="l00120"></a>00120             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp_n_blocks=0;
<a name="l00121"></a>00121             <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; temp_n_blocks;
<a name="l00122"></a>00122             hd-&gt;<a class="code" href="classXdrMHEAD.php#a8c70bef23afbc4a2c9f07b938663caed">set_n_blocks</a>(temp_n_blocks);
<a name="l00123"></a>00123             <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00124"></a>00124             <span class="keywordflow">break</span>;
<a name="l00125"></a>00125           }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127         <span class="keywordflow">default</span>:
<a name="l00128"></a>00128           <span class="comment">// Unknown access type</span>
<a name="l00129"></a>00129           libmesh_error();
<a name="l00130"></a>00130         }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132       
<a name="l00133"></a>00133       std::vector&lt;ElemType&gt; et;
<a name="l00134"></a>00134       hd-&gt;<a class="code" href="classXdrMHEAD.php#a9115e7ed79e8dbb4185accd55880cff2">get_block_elt_types</a>(et);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136       
<a name="l00137"></a>00137       <span class="comment">// Note:  If DECODING or READING, allocate space in the vector</span>
<a name="l00138"></a>00138       <span class="keywordflow">if</span> ((<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">DECODE</a>) || (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">R_ASCII</a>))
<a name="l00139"></a>00139         et.resize(hd-&gt;<a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>());  
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142       <span class="keywordflow">switch</span> (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a>)
<a name="l00143"></a>00143         {
<a name="l00144"></a>00144           
<a name="l00145"></a>00145 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>          
<a name="l00147"></a>00147         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>):
<a name="l00148"></a>00148         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">XdrMGF::DECODE</a>):
<a name="l00149"></a>00149           {
<a name="l00150"></a>00150             xdr_vector(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,
<a name="l00151"></a>00151                        (<span class="keywordtype">char</span> *) &amp;et[0],
<a name="l00152"></a>00152                        et.size(), 
<a name="l00153"></a>00153                        <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> int),
<a name="l00154"></a>00154                        (xdrproc_t) xdr_u_int);
<a name="l00155"></a>00155             <span class="keywordflow">break</span>;
<a name="l00156"></a>00156           }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="preprocessor">#endif</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>
<a name="l00160"></a>00160         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">XdrMGF::W_ASCII</a>):
<a name="l00161"></a>00161           {
<a name="l00162"></a>00162             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;hd-&gt;<a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>(); i++)
<a name="l00163"></a>00163               <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; et[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00164"></a>00164               
<a name="l00165"></a>00165             <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; <span class="stringliteral">&quot;\t # Element types in each block.\n&quot;</span>;
<a name="l00166"></a>00166             <span class="keywordflow">break</span>;
<a name="l00167"></a>00167           }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">XdrMGF::R_ASCII</a>):
<a name="l00170"></a>00170           {
<a name="l00171"></a>00171             libmesh_assert (<a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.good());
<a name="l00172"></a>00172         
<a name="l00173"></a>00173             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;hd-&gt;<a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>(); i++)
<a name="l00174"></a>00174               {
<a name="l00175"></a>00175                 <span class="comment">// convoluted way of doing it to</span>
<a name="l00176"></a>00176                 <span class="comment">// satisfy icc</span>
<a name="l00177"></a>00177                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> type;
<a name="l00178"></a>00178                 
<a name="l00179"></a>00179                 <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; type ;
<a name="l00180"></a>00180                 
<a name="l00181"></a>00181                 et[i] = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a><span class="keyword">&gt;</span>(type) ;
<a name="l00182"></a>00182               }
<a name="l00183"></a>00183             <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00184"></a>00184             <span class="keywordflow">break</span>;
<a name="l00185"></a>00185           }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187         <span class="keywordflow">default</span>:
<a name="l00188"></a>00188           <span class="comment">// Unknown access type</span>
<a name="l00189"></a>00189           libmesh_error();
<a name="l00190"></a>00190         }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193       
<a name="l00194"></a>00194       <span class="comment">// Note:  If DECODING or READING, you need to set the value </span>
<a name="l00195"></a>00195       <span class="comment">// in the header data structure.</span>
<a name="l00196"></a>00196       <span class="keywordflow">if</span> ((<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">DECODE</a>) || (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">R_ASCII</a>)) 
<a name="l00197"></a>00197         hd-&gt;<a class="code" href="classXdrMHEAD.php#af779d69308db4f5768bf0194e2a6b8cf">set_block_elt_types</a>(et);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200       std::vector&lt;unsigned int&gt; neeb;
<a name="l00201"></a>00201       hd-&gt;<a class="code" href="classXdrMHEAD.php#a40332e90eb2b724e846620c2222e3055">get_num_elem_each_block</a>(neeb);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203       <span class="comment">// If DECODING or READING, allocate space for the vector </span>
<a name="l00204"></a>00204       <span class="keywordflow">if</span> ((<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">DECODE</a>) || (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">R_ASCII</a>))
<a name="l00205"></a>00205         neeb.resize( hd-&gt;<a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>()*(this-&gt;<a class="code" href="classXdrMGF.php#aa53260d28bcccb931637d572d0f063ea">get_num_levels</a>()+1) );
<a name="l00206"></a>00206 
<a name="l00207"></a>00207       <span class="keywordflow">switch</span> (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a>)
<a name="l00208"></a>00208         {
<a name="l00209"></a>00209           
<a name="l00210"></a>00210 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span>          
<a name="l00212"></a>00212         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>):
<a name="l00213"></a>00213         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">XdrMGF::DECODE</a>):
<a name="l00214"></a>00214           {
<a name="l00215"></a>00215             xdr_vector(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,
<a name="l00216"></a>00216                        (<span class="keywordtype">char</span> *) &amp;neeb[0],
<a name="l00217"></a>00217                        neeb.size(), 
<a name="l00218"></a>00218                        <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> int),
<a name="l00219"></a>00219                        (xdrproc_t) xdr_u_int);
<a name="l00220"></a>00220           }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 <span class="preprocessor">#endif</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span>          
<a name="l00224"></a>00224         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">XdrMGF::W_ASCII</a>):
<a name="l00225"></a>00225           {
<a name="l00226"></a>00226             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;neeb.size(); i++)
<a name="l00227"></a>00227               <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; neeb[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00228"></a>00228               
<a name="l00229"></a>00229             <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; <span class="stringliteral">&quot;\t # Num. of elements in each block at each level.\n&quot;</span>;
<a name="l00230"></a>00230             <span class="keywordflow">break</span>;
<a name="l00231"></a>00231           }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233         <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">XdrMGF::R_ASCII</a>):
<a name="l00234"></a>00234           {
<a name="l00235"></a>00235 
<a name="l00236"></a>00236             <span class="comment">// We will treat this line as containing</span>
<a name="l00237"></a>00237             <span class="comment">// 1.) The number of elements in each block OR</span>
<a name="l00238"></a>00238             <span class="comment">// 2.) The number of elements at each level in each block</span>
<a name="l00239"></a>00239             <span class="comment">// Therefore, we don&#39;t know a-priori how many ints to read.</span>
<a name="l00240"></a>00240 
<a name="l00241"></a>00241             <span class="comment">// Get the full line from the stream up to the newline</span>
<a name="l00242"></a>00242             <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244             <span class="comment">// Construct a char buffer to hold the tokens as we</span>
<a name="l00245"></a>00245             <span class="comment">// process them, and construct a std::string object and</span>
<a name="l00246"></a>00246             <span class="comment">// a std::stringstream object for tokenizing this line.</span>
<a name="l00247"></a>00247             <span class="keywordtype">char</span> token[comm_len];
<a name="l00248"></a>00248             std::string s_temp(comment);
<a name="l00249"></a>00249             std::stringstream ss(s_temp);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251             <span class="comment">// Resize the neeb vector to zero so we can push back</span>
<a name="l00252"></a>00252             <span class="comment">// values onto it.  Note that we are using a tokenizer</span>
<a name="l00253"></a>00253             <span class="comment">// scheme again here to read the line, but it&#39;s not entirely</span>
<a name="l00254"></a>00254             <span class="comment">// necessary since we know the size neeb should have.</span>
<a name="l00255"></a>00255             neeb.resize(0);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257             <span class="comment">// Process the tokens one at a time</span>
<a name="l00258"></a>00258             <span class="keywordflow">while</span> (ss &gt;&gt; token)
<a name="l00259"></a>00259               {
<a name="l00260"></a>00260                 <span class="comment">// If you reach the hash, the rest of the line is a comment,</span>
<a name="l00261"></a>00261                 <span class="comment">// so quit reading.</span>
<a name="l00262"></a>00262                 <span class="keywordflow">if</span> (token[0] == <span class="charliteral">&#39;#&#39;</span>)
<a name="l00263"></a>00263                   <span class="keywordflow">break</span>;
<a name="l00264"></a>00264 
<a name="l00265"></a>00265                 <span class="comment">// If you reach an alphabetic character, this is an error</span>
<a name="l00266"></a>00266                 <span class="keywordflow">if</span> (!isdigit(token[0]))
<a name="l00267"></a>00267                   {
<a name="l00268"></a>00268                     std::cerr &lt;&lt; <span class="stringliteral">&quot;Error: Unrecognized character detected.&quot;</span> 
<a name="l00269"></a>00269                               &lt;&lt; std::endl;
<a name="l00270"></a>00270                     libmesh_error();
<a name="l00271"></a>00271                   }
<a name="l00272"></a>00272 
<a name="l00273"></a>00273                 <span class="comment">// Otherwise, add the value to the neeb vector</span>
<a name="l00274"></a>00274                 neeb.push_back( std::atoi(token) );
<a name="l00275"></a>00275               }
<a name="l00276"></a>00276               
<a name="l00277"></a>00277             <span class="comment">// Be sure you have the right number of entries in neeb</span>
<a name="l00278"></a>00278             libmesh_assert (neeb.size() == (hd-&gt;<a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>() * (this-&gt;<a class="code" href="classXdrMGF.php#aa53260d28bcccb931637d572d0f063ea">get_num_levels</a>()+1)));
<a name="l00279"></a>00279 
<a name="l00280"></a>00280             <span class="keywordflow">break</span>;
<a name="l00281"></a>00281           }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283         <span class="keywordflow">default</span>:
<a name="l00284"></a>00284           <span class="comment">// Unknown access type</span>
<a name="l00285"></a>00285           libmesh_error();
<a name="l00286"></a>00286         }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288       <span class="keywordflow">if</span> ((<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">DECODE</a>) || (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">R_ASCII</a>)) 
<a name="l00289"></a>00289         hd-&gt;<a class="code" href="classXdrMHEAD.php#a8a6f5fb8a429cb7ae1eb79f2a246c451">set_num_elem_each_block</a>(neeb);      
<a name="l00290"></a>00290     }
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classXdrMGF.php#a7ae03d62d21451cbcaba62d1357c8743">orig_flag</a> == 1) <span class="comment">// MGF originator</span>
<a name="l00294"></a>00294     {
<a name="l00295"></a>00295     }
<a name="l00296"></a>00296   <span class="keywordflow">else</span>  <span class="comment">// Unknown Originator!</span>
<a name="l00297"></a>00297     {
<a name="l00298"></a>00298       libmesh_error();
<a name="l00299"></a>00299     }
<a name="l00300"></a>00300   
<a name="l00301"></a>00301   
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   <span class="comment">// Write the ID and TITLE strings (can be safely ignored)</span>
<a name="l00305"></a>00305   <span class="keywordflow">switch</span> (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a>)
<a name="l00306"></a>00306     {
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00309"></a>00309 <span class="preprocessor"></span>      
<a name="l00310"></a>00310     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>):
<a name="l00311"></a>00311     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">XdrMGF::DECODE</a>):
<a name="l00312"></a>00312       {
<a name="l00313"></a>00313         <span class="keywordtype">char</span>* temp = hd-&gt;<a class="code" href="classXdrHEAD.php#af3f2516d6140aa889be32be392d7433d">cpyString</a>(hd-&gt;<a class="code" href="classXdrHEAD.php#a9a6f09b86d6727193f188388a3163ff2">getId</a>());
<a name="l00314"></a>00314         xdr_string(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,&amp;temp, ((<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>) ? std::strlen(temp) : hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>));
<a name="l00315"></a>00315         hd-&gt;<a class="code" href="classXdrHEAD.php#aeb16debcad0ecb4eb73111d3b9094acf">setId</a>(temp);
<a name="l00316"></a>00316         <span class="keyword">delete</span> [] temp;
<a name="l00317"></a>00317 
<a name="l00318"></a>00318         temp = hd-&gt;<a class="code" href="classXdrHEAD.php#af3f2516d6140aa889be32be392d7433d">cpyString</a>(hd-&gt;<a class="code" href="classXdrHEAD.php#a6bbf612bfea8cfacfa2a80da0bbb2bb4">getTitle</a>());
<a name="l00319"></a>00319 
<a name="l00320"></a>00320         xdr_string(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,&amp;temp, ((<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>) ? std::strlen(temp) : hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>));
<a name="l00321"></a>00321         hd-&gt;<a class="code" href="classXdrHEAD.php#afb33d2828af0a74f460e0042cf5dc685">setTitle</a>(temp);
<a name="l00322"></a>00322         <span class="keyword">delete</span> [] temp;
<a name="l00323"></a>00323         <span class="keywordflow">break</span>;
<a name="l00324"></a>00324       }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 <span class="preprocessor">#endif</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span>      
<a name="l00328"></a>00328     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">XdrMGF::W_ASCII</a>):
<a name="l00329"></a>00329       {
<a name="l00330"></a>00330         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#ab035b1f627467cb2596ff33241d23066">mp_id</a>    &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00331"></a>00331         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#afdd2b89c79ace9409cb86fb5c13bbcab">mp_title</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00332"></a>00332         <span class="keywordflow">break</span>;
<a name="l00333"></a>00333       }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">XdrMGF::R_ASCII</a>):
<a name="l00336"></a>00336       {
<a name="l00337"></a>00337         libmesh_assert (<a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.good());
<a name="l00338"></a>00338         
<a name="l00339"></a>00339         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00340"></a>00340         hd-&gt;<a class="code" href="classXdrHEAD.php#aeb16debcad0ecb4eb73111d3b9094acf">setId</a>(comment);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342         libmesh_assert (<a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.good());
<a name="l00343"></a>00343         
<a name="l00344"></a>00344         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00345"></a>00345         hd-&gt;<a class="code" href="classXdrHEAD.php#afb33d2828af0a74f460e0042cf5dc685">setTitle</a>(comment);
<a name="l00346"></a>00346 
<a name="l00347"></a>00347         <span class="keywordflow">break</span>;
<a name="l00348"></a>00348       }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350     <span class="keywordflow">default</span>:
<a name="l00351"></a>00351       <span class="comment">// Unknown access type</span>
<a name="l00352"></a>00352       libmesh_error();
<a name="l00353"></a>00353     }
<a name="l00354"></a>00354   
<a name="l00355"></a>00355   <span class="keywordflow">return</span> 1;
<a name="l00356"></a>00356 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
