<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_mgf.h</h1>  </div>
</div>
<div class="contents">
<a href="xdr__mgf_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_mgf.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __xdr_mgf_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_mgf_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// C++ includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;cstdio&gt;</span>  <span class="comment">// for std::FILE</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cstring&gt;</span> <span class="comment">// std::strlen, std::strcmp</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;fstream&gt;</span> <span class="comment">// for std::ifstream</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="legacy__xdr__io_8h.php">legacy_xdr_io.h</a>&quot;</span>          <span class="comment">// for LegacyXdrIO::FileFormat</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>  <span class="comment">// for LIBMESH_HAVE_XDR</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;o_f_stream.h&quot;</span>      <span class="comment">// for OFStream</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;rpc/rpc.h&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#  ifndef SINGLE_PRECISION</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#    ifdef TRIPLE_PRECISION</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="comment">// #      define xdr_REAL xdr_quadruple</span>
<a name="l00042"></a>00042 <span class="comment">// For some reason my xdr implementation doesn&#39;t define</span>
<a name="l00043"></a>00043 <span class="comment">// xdr_quadruple... - RHS</span>
<a name="l00044"></a>00044 <span class="preprocessor">#      define xdr_REAL xdr_double</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#      define xdr_Real double</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#    else</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#      define xdr_REAL xdr_double</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#      define xdr_Real Real</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#    endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#  else</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#    define xdr_REAL xdr_float</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#    define xdr_Real Real</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#  endif</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#  define xdr_Real Real</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058 
<a name="l00081"></a><a class="code" href="classXdrMGF.php">00081</a> <span class="keyword">class </span><a class="code" href="classXdrMGF.php">XdrMGF</a>
<a name="l00082"></a>00082 {
<a name="l00083"></a>00083 <span class="keyword">public</span>:
<a name="l00094"></a><a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759">00094</a>   <span class="keyword">enum</span> <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759">XdrIO_TYPE</a> {<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a564fbaf95286bc3a8675b60f3b2a0af4">UNKNOWN</a> = -1, <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">ENCODE</a>=0, <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">DECODE</a>,
<a name="l00095"></a><a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">00095</a>                    <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">W_ASCII</a> , <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">R_ASCII</a>};
<a name="l00096"></a>00096 
<a name="l00097"></a>00097      
<a name="l00110"></a>00110 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00111"></a><a class="code" href="classXdrMGF.php#a4db179f6986b3227575630e32fe34420">00111</a> <span class="preprocessor"></span>  <a class="code" href="classXdrMGF.php#a4db179f6986b3227575630e32fe34420">XdrMGF</a>() : <a class="code" href="classXdrMGF.php#ab178ee3bafd23b5eba16976d4129b06d">_num_levels</a>(0), <a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a>(<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a564fbaf95286bc3a8675b60f3b2a0af4">UNKNOWN</a>), <a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>(0), <a class="code" href="classXdrMGF.php#a7ae03d62d21451cbcaba62d1357c8743">orig_flag</a>(<a class="code" href="classLegacyXdrIO.php">LegacyXdrIO</a>::LIBM), <a class="code" href="classXdrMGF.php#abee2776cde1c6943d9e4cbf0540c9741">mp_fp</a>(0) {}
<a name="l00112"></a>00112 <span class="preprocessor">#else</span>
<a name="l00113"></a><a class="code" href="classXdrMGF.php#a4db179f6986b3227575630e32fe34420">00113</a> <span class="preprocessor"></span>  <a class="code" href="classXdrMGF.php#a4db179f6986b3227575630e32fe34420">XdrMGF</a>() : <a class="code" href="classXdrMGF.php#ab178ee3bafd23b5eba16976d4129b06d">_num_levels</a>(0), <a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a>(<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a564fbaf95286bc3a8675b60f3b2a0af4">UNKNOWN</a>), <a class="code" href="classXdrMGF.php#a7ae03d62d21451cbcaba62d1357c8743">orig_flag</a>(<a class="code" href="classLegacyXdrIO.php">LegacyXdrIO</a>::LIBM), <a class="code" href="classXdrMGF.php#abee2776cde1c6943d9e4cbf0540c9741">mp_fp</a>(0) {}
<a name="l00114"></a>00114 <span class="preprocessor">#endif</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span>    
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="classXdrMGF.php#a7ceae086d98f2638694648145f682956">init</a>(<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759">XdrIO_TYPE</a> t, <span class="keyword">const</span> <span class="keywordtype">char</span>* fn, <span class="keyword">const</span> <span class="keywordtype">char</span>* type, <span class="keywordtype">int</span> icnt);
<a name="l00132"></a>00132 
<a name="l00138"></a>00138   <span class="keyword">virtual</span> <a class="code" href="classXdrMGF.php#aa1c587b3750f3ca5c10c7ba8a75b4321">~XdrMGF</a>();
<a name="l00139"></a>00139 
<a name="l00148"></a>00148   <span class="keywordtype">void</span> <a class="code" href="classXdrMGF.php#ab6df5ff281ea732b16467d11e940aaf2">fini</a>();
<a name="l00149"></a>00149 
<a name="l00158"></a>00158   <span class="keywordtype">int</span> <a class="code" href="classXdrMGF.php#a5680d36e267918b95d95ea1f0c137a6d">dataBlk</a>(<span class="keywordtype">int</span>*  array, <span class="keywordtype">int</span> numvar, <span class="keywordtype">int</span> size);
<a name="l00159"></a>00159 
<a name="l00165"></a>00165   <span class="keywordtype">int</span> <a class="code" href="classXdrMGF.php#a5680d36e267918b95d95ea1f0c137a6d">dataBlk</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>* array, <span class="keywordtype">int</span> numvar, <span class="keywordtype">int</span> size);
<a name="l00166"></a>00166 
<a name="l00170"></a><a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">00170</a>   <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> <a class="code" href="classXdrMGF.php#a38c46d070b70b3cdcf00c42ffff9b0c8">get_orig_flag</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrMGF.php#a7ae03d62d21451cbcaba62d1357c8743">orig_flag</a>; }
<a name="l00171"></a>00171 
<a name="l00175"></a><a class="code" href="classXdrMGF.php#a429208021d453abbe95b4d019b92552b">00175</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMGF.php#a429208021d453abbe95b4d019b92552b">set_orig_flag</a>(<a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> in_orig_flag) { <a class="code" href="classXdrMGF.php#a7ae03d62d21451cbcaba62d1357c8743">orig_flag</a> = in_orig_flag; }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00181"></a><a class="code" href="classXdrMGF.php#a8e5c5d512de516fda12b311dfb648dc1">00181</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMGF.php#a8e5c5d512de516fda12b311dfb648dc1">set_num_levels</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_levels) { <a class="code" href="classXdrMGF.php#ab178ee3bafd23b5eba16976d4129b06d">_num_levels</a> = num_levels; }
<a name="l00182"></a>00182 
<a name="l00186"></a><a class="code" href="classXdrMGF.php#aa53260d28bcccb931637d572d0f063ea">00186</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classXdrMGF.php#aa53260d28bcccb931637d572d0f063ea">get_num_levels</a>() { <span class="keywordflow">return</span> <a class="code" href="classXdrMGF.php#ab178ee3bafd23b5eba16976d4129b06d">_num_levels</a>; }
<a name="l00187"></a>00187   
<a name="l00188"></a>00188 <span class="keyword">protected</span>:
<a name="l00189"></a>00189 
<a name="l00193"></a><a class="code" href="classXdrMGF.php#ab178ee3bafd23b5eba16976d4129b06d">00193</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classXdrMGF.php#ab178ee3bafd23b5eba16976d4129b06d">_num_levels</a>;
<a name="l00194"></a>00194 
<a name="l00206"></a><a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">00206</a>   <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759">XdrIO_TYPE</a> <a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a>;
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>  
<a name="l00216"></a><a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">00216</a>   XDR*  <a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>;
<a name="l00217"></a>00217   
<a name="l00218"></a>00218 <span class="preprocessor">#endif</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span>  
<a name="l00235"></a><a class="code" href="classXdrMGF.php#a7ae03d62d21451cbcaba62d1357c8743">00235</a>   <a class="code" href="classLegacyXdrIO.php#a74a20eaad9c71114e59860399906fc74">LegacyXdrIO::FileFormat</a> <a class="code" href="classXdrMGF.php#a7ae03d62d21451cbcaba62d1357c8743">orig_flag</a>;
<a name="l00236"></a>00236 
<a name="l00240"></a><a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">00240</a>   std::ifstream <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>;
<a name="l00241"></a>00241 
<a name="l00248"></a><a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">00248</a>   <a class="code" href="classOFStream.php">OFStream</a> <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a>;
<a name="l00249"></a>00249   
<a name="l00250"></a>00250 <span class="keyword">private</span>:
<a name="l00251"></a><a class="code" href="classXdrMGF.php#abee2776cde1c6943d9e4cbf0540c9741">00251</a>   std::FILE* <a class="code" href="classXdrMGF.php#abee2776cde1c6943d9e4cbf0540c9741">mp_fp</a>;
<a name="l00252"></a>00252 
<a name="l00257"></a><a class="code" href="classXdrMGF.php#afc03769e95988d91c37e8d0c41a720f1">00257</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMGF.php#afc03769e95988d91c37e8d0c41a720f1">tokenize_first_line</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* p)
<a name="l00258"></a>00258   {
<a name="l00259"></a>00259     std::string buf_str(p);
<a name="l00260"></a>00260     std::stringstream ss(buf_str);
<a name="l00261"></a>00261 
<a name="l00262"></a>00262     <span class="keywordtype">char</span> token[256];
<a name="l00263"></a>00263     ss &gt;&gt; token;
<a name="l00264"></a>00264     <span class="keywordflow">if</span>(std::strcmp(token,<span class="stringliteral">&quot;LIBM&quot;</span>) == 0)
<a name="l00265"></a>00265       {
<a name="l00266"></a>00266         ss &gt;&gt; token;
<a name="l00267"></a>00267         <a class="code" href="classXdrMGF.php#ab178ee3bafd23b5eba16976d4129b06d">_num_levels</a> = std::atoi(token);
<a name="l00268"></a>00268       }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   }
<a name="l00271"></a>00271 };
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   
<a name="l00275"></a>00275 <span class="preprocessor">#endif // #ifndef __xdr_mgf_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
