<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_mhead.h</h1>  </div>
</div>
<div class="contents">
<a href="xdr__mhead_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_mhead.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __xdr_mhead_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_mhead_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// C++ includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="xdr__head_8h.php">xdr_head.h</a>&quot;</span> <span class="comment">// for base class</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="xdr__mesh_8h.php">xdr_mesh.h</a>&quot;</span> <span class="comment">// for friend</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;enum_elem_type.h&quot;</span> <span class="comment">// for ElemType</span>
<a name="l00030"></a>00030 
<a name="l00038"></a><a class="code" href="classXdrMHEAD.php">00038</a> <span class="keyword">class </span><a class="code" href="classXdrMHEAD.php">XdrMHEAD</a> : <span class="keyword">public</span> <a class="code" href="classXdrHEAD.php">XdrHEAD</a>
<a name="l00039"></a>00039 {
<a name="l00040"></a><a class="code" href="classXdrMHEAD.php#ab2797be1cf03c27b41802ca50a10ae23">00040</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classXdrMESH.php">XdrMESH</a>;
<a name="l00041"></a>00041 <span class="keyword">public</span>:
<a name="l00046"></a><a class="code" href="classXdrMHEAD.php#a2cd4cd4719ce86bcf03c28b003c1ad3e">00046</a>   <a class="code" href="classXdrMHEAD.php#a2cd4cd4719ce86bcf03c28b003c1ad3e">XdrMHEAD</a>() : <a class="code" href="classXdrMHEAD.php#a5a5bdace36f08dad63dc35f58d8d6ce8">_n_blocks</a>(1) {}
<a name="l00047"></a>00047 
<a name="l00051"></a><a class="code" href="classXdrMHEAD.php#a5927bb85aa7e364e716261ef785e179c">00051</a>   <a class="code" href="classXdrMHEAD.php#a5927bb85aa7e364e716261ef785e179c">~XdrMHEAD</a>()                          {}
<a name="l00052"></a>00052 
<a name="l00057"></a><a class="code" href="classXdrMHEAD.php#accda625bf371709a39dcd31a794b042c">00057</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMHEAD.php#accda625bf371709a39dcd31a794b042c">setNumEl</a>(<span class="keywordtype">int</span> numel)             { <a class="code" href="classXdrHEAD.php#aa6614145e5a33854a3be764445085a93">m_numel</a> = numel; }
<a name="l00058"></a>00058 
<a name="l00063"></a><a class="code" href="classXdrMHEAD.php#ac422b8ab01815a399ab0e868036f298a">00063</a>   <span class="keywordtype">int</span>  <a class="code" href="classXdrMHEAD.php#ac422b8ab01815a399ab0e868036f298a">getNumEl</a>()<span class="keyword"> const                </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrHEAD.php#aa6614145e5a33854a3be764445085a93">m_numel</a>; }
<a name="l00064"></a>00064 
<a name="l00070"></a><a class="code" href="classXdrMHEAD.php#a53526919868204444357e7b3cad3d7f8">00070</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMHEAD.php#a53526919868204444357e7b3cad3d7f8">setSumWghts</a>(<span class="keywordtype">int</span> sumWghts)       { <a class="code" href="classXdrHEAD.php#a9e6fb8f20c89ee79c3f340f8d6b38df2">m_sumWghts</a> = sumWghts; }
<a name="l00071"></a>00071 
<a name="l00077"></a><a class="code" href="classXdrMHEAD.php#a7e5a99aee69c2d5356ce187f515784f8">00077</a>   <span class="keywordtype">int</span>  <a class="code" href="classXdrMHEAD.php#a7e5a99aee69c2d5356ce187f515784f8">getSumWghts</a>()<span class="keyword"> const             </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrHEAD.php#a9e6fb8f20c89ee79c3f340f8d6b38df2">m_sumWghts</a>; }
<a name="l00078"></a>00078 
<a name="l00085"></a><a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">00085</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classXdrMHEAD.php#a264ddaee09b21822fd0a850582b57253">get_n_blocks</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrMHEAD.php#a5a5bdace36f08dad63dc35f58d8d6ce8">_n_blocks</a>; }
<a name="l00086"></a>00086 
<a name="l00090"></a><a class="code" href="classXdrMHEAD.php#a8c70bef23afbc4a2c9f07b938663caed">00090</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMHEAD.php#a8c70bef23afbc4a2c9f07b938663caed">set_n_blocks</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nb) { this-&gt;<a class="code" href="classXdrMHEAD.php#a5a5bdace36f08dad63dc35f58d8d6ce8">_n_blocks</a> = nb; }
<a name="l00091"></a>00091 
<a name="l00098"></a><a class="code" href="classXdrMHEAD.php#a9115e7ed79e8dbb4185accd55880cff2">00098</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMHEAD.php#a9115e7ed79e8dbb4185accd55880cff2">get_block_elt_types</a>(std::vector&lt;ElemType&gt;&amp; bet)<span class="keyword"> const </span>{ bet = <a class="code" href="classXdrMHEAD.php#aa193d98834acc133088c85861e9bb121">block_elt_types</a>; }
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classXdrMHEAD.php#af779d69308db4f5768bf0194e2a6b8cf">00103</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMHEAD.php#af779d69308db4f5768bf0194e2a6b8cf">set_block_elt_types</a>(<span class="keyword">const</span> std::vector&lt;ElemType&gt;&amp; bet) { <a class="code" href="classXdrMHEAD.php#aa193d98834acc133088c85861e9bb121">block_elt_types</a> = bet; }
<a name="l00104"></a>00104 
<a name="l00112"></a><a class="code" href="classXdrMHEAD.php#a40332e90eb2b724e846620c2222e3055">00112</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMHEAD.php#a40332e90eb2b724e846620c2222e3055">get_num_elem_each_block</a>(std::vector&lt;unsigned int&gt;&amp; neeb)<span class="keyword"> const </span>{ neeb = <a class="code" href="classXdrMHEAD.php#ade8191c208ee453b2a02f73f70247bc0">num_elem_each_block</a>; }
<a name="l00113"></a>00113 
<a name="l00117"></a><a class="code" href="classXdrMHEAD.php#a8a6f5fb8a429cb7ae1eb79f2a246c451">00117</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrMHEAD.php#a8a6f5fb8a429cb7ae1eb79f2a246c451">set_num_elem_each_block</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; neeb) { <a class="code" href="classXdrMHEAD.php#ade8191c208ee453b2a02f73f70247bc0">num_elem_each_block</a> = neeb; }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119     
<a name="l00120"></a>00120 <span class="keyword">private</span>:
<a name="l00121"></a>00121     
<a name="l00131"></a><a class="code" href="classXdrMHEAD.php#a5a5bdace36f08dad63dc35f58d8d6ce8">00131</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classXdrMHEAD.php#a5a5bdace36f08dad63dc35f58d8d6ce8">_n_blocks</a>;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00143"></a><a class="code" href="classXdrMHEAD.php#aa193d98834acc133088c85861e9bb121">00143</a>   std::vector&lt;ElemType&gt; <a class="code" href="classXdrMHEAD.php#aa193d98834acc133088c85861e9bb121">block_elt_types</a>;
<a name="l00144"></a>00144 
<a name="l00150"></a><a class="code" href="classXdrMHEAD.php#ade8191c208ee453b2a02f73f70247bc0">00150</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classXdrMHEAD.php#ade8191c208ee453b2a02f73f70247bc0">num_elem_each_block</a>;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 };
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="preprocessor">#endif // #ifndef __xdr_mhead_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
