<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_shead.h</h1>  </div>
</div>
<div class="contents">
<a href="xdr__shead_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_shead.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __xdr_shead_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_shead_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="xdr__head_8h.php">xdr_head.h</a>&quot;</span> <span class="comment">// for base class</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="xdr__soln_8h.php">xdr_soln.h</a>&quot;</span> <span class="comment">// for friend</span>
<a name="l00026"></a>00026 
<a name="l00033"></a><a class="code" href="classXdrSHEAD.php">00033</a> <span class="keyword">class </span><a class="code" href="classXdrSHEAD.php">XdrSHEAD</a> : <span class="keyword">public</span> <a class="code" href="classXdrHEAD.php">XdrHEAD</a>
<a name="l00034"></a>00034 {
<a name="l00035"></a><a class="code" href="classXdrSHEAD.php#a72e2d9a52a2b621de213d920e0edbce7">00035</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classXdrSOLN.php">XdrSOLN</a>;
<a name="l00036"></a>00036 <span class="keyword">public</span>:
<a name="l00040"></a><a class="code" href="classXdrSHEAD.php#a050d002dce60420d7382157138ef74f4">00040</a>   <a class="code" href="classXdrSHEAD.php#a050d002dce60420d7382157138ef74f4">XdrSHEAD</a>()                                    {}
<a name="l00041"></a>00041 
<a name="l00045"></a><a class="code" href="classXdrSHEAD.php#a726e1e3491246b997619f8280ae59ed3">00045</a>   <a class="code" href="classXdrSHEAD.php#a726e1e3491246b997619f8280ae59ed3">~XdrSHEAD</a>()                                   {}
<a name="l00046"></a>00046 
<a name="l00051"></a><a class="code" href="classXdrSHEAD.php#a8d8e7fa7f902b9ce3239ac545db2655a">00051</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrSHEAD.php#a8d8e7fa7f902b9ce3239ac545db2655a">setNumVar</a>(<span class="keywordtype">int</span> numvar)                    { <a class="code" href="classXdrHEAD.php#a3ffced6b091b8c588c5be66e48982aa7">m_numvar</a> = numvar; }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="comment">//     /**</span>
<a name="l00054"></a>00054   <span class="comment">//      * Get the total number of</span>
<a name="l00055"></a>00055   <span class="comment">//      * solution variables.</span>
<a name="l00056"></a>00056   <span class="comment">//      */</span>
<a name="l00057"></a>00057   <span class="comment">//     int  getNumVar() const                        { return m_numvar; }</span>
<a name="l00058"></a>00058 
<a name="l00063"></a><a class="code" href="classXdrSHEAD.php#ac1ee8b1325807cc78e859a100726c791">00063</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrSHEAD.php#ac1ee8b1325807cc78e859a100726c791">setWrtVar</a>(<span class="keywordtype">int</span> wrtVar)                    { <a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a> = wrtVar; }
<a name="l00064"></a>00064 
<a name="l00069"></a><a class="code" href="classXdrSHEAD.php#a536542364ba24a8dcdcfaa298f6097de">00069</a>   <span class="keywordtype">int</span>  <a class="code" href="classXdrSHEAD.php#a536542364ba24a8dcdcfaa298f6097de">getWrtVar</a>()<span class="keyword"> const                        </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>; }
<a name="l00070"></a>00070 
<a name="l00074"></a><a class="code" href="classXdrSHEAD.php#afd9d6b86bb08867369586260b12bb830">00074</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrSHEAD.php#afd9d6b86bb08867369586260b12bb830">setMeshCnt</a>(<span class="keywordtype">int</span> meshCnt)                  { <a class="code" href="classXdrHEAD.php#a0b9bef29b079e2d65bed8e618d9b00fb">m_meshCnt</a> = meshCnt; }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">//     /**</span>
<a name="l00077"></a>00077   <span class="comment">//      * Get the mesh file number.</span>
<a name="l00078"></a>00078   <span class="comment">//      */</span>
<a name="l00079"></a>00079   <span class="comment">//     int  getMeshCnt() const                       { return m_meshCnt; }</span>
<a name="l00080"></a>00080 
<a name="l00085"></a><a class="code" href="classXdrSHEAD.php#a30cd063356f04537535525986deea7f7">00085</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrSHEAD.php#a30cd063356f04537535525986deea7f7">setKstep</a>(<span class="keywordtype">int</span> kstep)                      { <a class="code" href="classXdrHEAD.php#a7566f85e92e2aa921e1876bf3138520e">m_kstep</a> = kstep; }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="comment">//     /**</span>
<a name="l00088"></a>00088   <span class="comment">//      * Get the solution step</span>
<a name="l00089"></a>00089   <span class="comment">//      * number.</span>
<a name="l00090"></a>00090   <span class="comment">//      */</span>
<a name="l00091"></a>00091   <span class="comment">//     int  getKstep() const                         { return m_kstep; }</span>
<a name="l00092"></a>00092 
<a name="l00096"></a><a class="code" href="classXdrSHEAD.php#a70b93680f77b283bdd0f4c46b8268bdd">00096</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrSHEAD.php#a70b93680f77b283bdd0f4c46b8268bdd">setTime</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> time)                       { <a class="code" href="classXdrHEAD.php#ad31ef084953312f6d47d26f9ba63f44c">m_time</a> = time; }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">//     /**</span>
<a name="l00099"></a>00099   <span class="comment">//      * Get the solution time.</span>
<a name="l00100"></a>00100   <span class="comment">//      */</span>
<a name="l00101"></a>00101   <span class="comment">//     Real getTime() const                          { return m_time; }</span>
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classXdrSHEAD.php#ae68f13ec8401cf506f2bab34dab1fbda">00106</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrSHEAD.php#ae68f13ec8401cf506f2bab34dab1fbda">setUserTitle</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* title)          { <span class="keyword">delete</span> [] <a class="code" href="classXdrHEAD.php#a5ec0f7dbd17dca2a040810979c035dba">mp_userTitle</a>; <a class="code" href="classXdrHEAD.php#a5ec0f7dbd17dca2a040810979c035dba">mp_userTitle</a> = <a class="code" href="classXdrHEAD.php#af3f2516d6140aa889be32be392d7433d">cpyString</a>(title); }
<a name="l00107"></a>00107 
<a name="l00111"></a><a class="code" href="classXdrSHEAD.php#adbb69e020b4908bae8e23cbe332e4686">00111</a>   <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdrSHEAD.php#adbb69e020b4908bae8e23cbe332e4686">getUserTitle</a>()<span class="keyword"> const              </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrHEAD.php#a5ec0f7dbd17dca2a040810979c035dba">mp_userTitle</a>; }
<a name="l00112"></a>00112 
<a name="l00117"></a><a class="code" href="classXdrSHEAD.php#afca190cd39a17940e90d11016501361f">00117</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrSHEAD.php#afca190cd39a17940e90d11016501361f">setVarTitle</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* titles, <span class="keywordtype">int</span> len) { <span class="keyword">delete</span> [] <a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">mp_varTitle</a>; <a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">mp_varTitle</a> = <a class="code" href="classXdrHEAD.php#af3f2516d6140aa889be32be392d7433d">cpyString</a>(titles, len); }
<a name="l00118"></a>00118 
<a name="l00123"></a><a class="code" href="classXdrSHEAD.php#afc2ffddf806584f67384472a70b73520">00123</a>   <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classXdrSHEAD.php#afc2ffddf806584f67384472a70b73520">getVarTitle</a>()<span class="keyword"> const               </span>{ <span class="keywordflow">return</span> <a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">mp_varTitle</a>; }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 };
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="preprocessor">#endif // #ifndef __xdr_shead_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
