<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_soln.C</h1>  </div>
</div>
<div class="contents">
<a href="xdr__soln_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_soln.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;xdr_soln.h&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;xdr_shead.h&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// System includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// XdrSOLN members</span>
<a name="l00031"></a><a class="code" href="classXdrSOLN.php#ad4068e5bfc6924804b2feaf3d090ba8b">00031</a> <span class="keywordtype">int</span> <a class="code" href="classXdrSOLN.php#ad4068e5bfc6924804b2feaf3d090ba8b">XdrSOLN::header</a>(<a class="code" href="classXdrSHEAD.php">XdrSHEAD</a> *hd)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <span class="comment">// Temporary variables to facilitate stream reading</span>
<a name="l00034"></a>00034   <span class="keyword">const</span> <span class="keywordtype">int</span> comm_len= 80;  
<a name="l00035"></a>00035   <span class="keywordtype">char</span> comment[comm_len];
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   
<a name="l00039"></a>00039   <span class="keywordflow">switch</span> (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a>)
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041       
<a name="l00042"></a>00042 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>      
<a name="l00044"></a>00044     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>):
<a name="l00045"></a>00045     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">XdrMGF::DECODE</a>):
<a name="l00046"></a>00046       {
<a name="l00047"></a>00047   
<a name="l00048"></a>00048         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,  &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>));
<a name="l00049"></a>00049         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,  &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#a3ffced6b091b8c588c5be66e48982aa7">m_numvar</a>));
<a name="l00050"></a>00050         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,  &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a>));
<a name="l00051"></a>00051         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,  &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#a0b9bef29b079e2d65bed8e618d9b00fb">m_meshCnt</a>));
<a name="l00052"></a>00052         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,  &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#a7566f85e92e2aa921e1876bf3138520e">m_kstep</a>));
<a name="l00053"></a>00053         xdr_int(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,  &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>));
<a name="l00054"></a>00054         xdr_REAL(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>, &amp;(hd-&gt;<a class="code" href="classXdrHEAD.php#ad31ef084953312f6d47d26f9ba63f44c">m_time</a>));
<a name="l00055"></a>00055         
<a name="l00056"></a>00056         <a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a>=hd-&gt;<a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058         <span class="keywordtype">char</span>* temp = <span class="keyword">const_cast&lt;</span><span class="keywordtype">char</span> *<span class="keyword">&gt;</span>(hd-&gt;<a class="code" href="classXdrHEAD.php#a9a6f09b86d6727193f188388a3163ff2">getId</a>());
<a name="l00059"></a>00059         xdr_string(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,&amp;(temp),
<a name="l00060"></a>00060                    ((<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>) ? std::strlen(temp)    : hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>));
<a name="l00061"></a>00061         hd-&gt;<a class="code" href="classXdrHEAD.php#aeb16debcad0ecb4eb73111d3b9094acf">setId</a>(temp);
<a name="l00062"></a>00062         
<a name="l00063"></a>00063         temp = <span class="keyword">const_cast&lt;</span><span class="keywordtype">char</span> *<span class="keyword">&gt;</span>(hd-&gt;<a class="code" href="classXdrHEAD.php#a6bbf612bfea8cfacfa2a80da0bbb2bb4">getTitle</a>());
<a name="l00064"></a>00064         xdr_string(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,&amp;(temp),
<a name="l00065"></a>00065                    ((<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>) ? std::strlen(temp) : hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>));
<a name="l00066"></a>00066         hd-&gt;<a class="code" href="classXdrHEAD.php#afb33d2828af0a74f460e0042cf5dc685">setTitle</a>(temp);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068         temp = <span class="keyword">const_cast&lt;</span><span class="keywordtype">char</span> *<span class="keyword">&gt;</span>(hd-&gt;<a class="code" href="classXdrSHEAD.php#adbb69e020b4908bae8e23cbe332e4686">getUserTitle</a>());
<a name="l00069"></a>00069         xdr_string(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>,&amp;(temp),
<a name="l00070"></a>00070                    ((<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>) ? std::strlen(temp) : hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>));
<a name="l00071"></a>00071         hd-&gt;<a class="code" href="classXdrSHEAD.php#ae68f13ec8401cf506f2bab34dab1fbda">setUserTitle</a>(temp);
<a name="l00072"></a>00072                 
<a name="l00073"></a>00073         
<a name="l00074"></a>00074         <span class="keywordtype">char</span> * tempTitle = <span class="keyword">new</span> <span class="keywordtype">char</span>[hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>*<a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a>];
<a name="l00075"></a>00075   
<a name="l00076"></a>00076   
<a name="l00077"></a>00077         <span class="keywordflow">if</span> (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a2e25ec755026e9cc0d07a2773e908d1a">XdrMGF::DECODE</a>)
<a name="l00078"></a>00078           {
<a name="l00079"></a>00079             <span class="keywordtype">int</span> tempSize = 0;
<a name="l00080"></a>00080             xdr_string(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>, &amp;tempTitle, hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>*<a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a>);
<a name="l00081"></a>00081             <span class="keywordtype">int</span> olen= std::strlen(tempTitle);
<a name="l00082"></a>00082             <span class="keywordtype">char</span> *p;
<a name="l00083"></a>00083             <span class="keywordtype">char</span> *top = tempTitle;
<a name="l00084"></a>00084             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> ivar = 0; ivar &lt; <a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a>; ++ivar)
<a name="l00085"></a>00085               {
<a name="l00086"></a>00086                 p = strchr(tempTitle,<span class="charliteral">&#39; &#39;</span>);
<a name="l00087"></a>00087                 *p = <span class="charliteral">&#39;\0&#39;</span>;
<a name="l00088"></a>00088                 tempSize = std::strlen(tempTitle) ;
<a name="l00089"></a>00089                 tempTitle+=tempSize+1;
<a name="l00090"></a>00090               }
<a name="l00091"></a>00091             tempTitle = top;
<a name="l00092"></a>00092             hd-&gt;<a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">mp_varTitle</a> = <span class="keyword">new</span> <span class="keywordtype">char</span>[olen];
<a name="l00093"></a>00093             std::memcpy(hd-&gt;<a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">mp_varTitle</a>,tempTitle,olen*<span class="keyword">sizeof</span>(<span class="keywordtype">char</span>));
<a name="l00094"></a>00094           }
<a name="l00095"></a>00095         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classXdrMGF.php#a55757ee0ff57695f0640ef5b1510495b">m_type</a> == <a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759aca15a85ac1052a9c12cd00c6a7c3bba6">XdrMGF::ENCODE</a>)
<a name="l00096"></a>00096           {
<a name="l00097"></a>00097             <span class="keywordtype">char</span> *p = hd-&gt;<a class="code" href="classXdrHEAD.php#a86d8da1ba890a36171317ab3208b7b43">mp_varTitle</a>;
<a name="l00098"></a>00098             <span class="keywordtype">char</span> *top = tempTitle;
<a name="l00099"></a>00099             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> ivar = 0; ivar &lt; <a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a>; ++ivar)
<a name="l00100"></a>00100               {
<a name="l00101"></a>00101                 <span class="keywordtype">int</span> tempSize = std::strlen(p) + 1;
<a name="l00102"></a>00102                 std::memcpy(tempTitle,p,tempSize*<span class="keyword">sizeof</span>(<span class="keywordtype">char</span>));
<a name="l00103"></a>00103                 tempSize = std::strlen(tempTitle);
<a name="l00104"></a>00104                 tempTitle[tempSize] = <span class="charliteral">&#39; &#39;</span>;
<a name="l00105"></a>00105                 tempTitle += tempSize+1;
<a name="l00106"></a>00106                 p += tempSize+1;
<a name="l00107"></a>00107               }
<a name="l00108"></a>00108             tempTitle = top;
<a name="l00109"></a>00109             xdr_string(<a class="code" href="classXdrMGF.php#addf6d7af070b34e5f14378fc9336914b">mp_xdr_handle</a>, &amp;tempTitle, hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>*m_wrtVar);
<a name="l00110"></a>00110           }
<a name="l00111"></a>00111         <span class="keyword">delete</span> [] tempTitle;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113         <span class="keywordflow">return</span> 0;
<a name="l00114"></a>00114       }
<a name="l00115"></a>00115 <span class="preprocessor">#endif</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759adec8f583f9a4a6a6d97dfb07f2f8ccd0">XdrMGF::R_ASCII</a>):
<a name="l00119"></a>00119       {
<a name="l00120"></a>00120         libmesh_assert (<a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.good());
<a name="l00121"></a>00121         
<a name="l00122"></a>00122         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a> ; <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00123"></a>00123         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>   ; <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00124"></a>00124         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>  ; <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00125"></a>00125         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; hd-&gt;<a class="code" href="classXdrHEAD.php#ad31ef084953312f6d47d26f9ba63f44c">m_time</a>     ; <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00126"></a>00126         
<a name="l00127"></a>00127         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00128"></a>00128         hd-&gt;<a class="code" href="classXdrHEAD.php#aeb16debcad0ecb4eb73111d3b9094acf">setId</a>(comment);
<a name="l00129"></a>00129 
<a name="l00130"></a>00130         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00131"></a>00131         hd-&gt;<a class="code" href="classXdrHEAD.php#afb33d2828af0a74f460e0042cf5dc685">setTitle</a>(comment);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133         <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00134"></a>00134         hd-&gt;<a class="code" href="classXdrSHEAD.php#ae68f13ec8401cf506f2bab34dab1fbda">setUserTitle</a>(comment);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136         <a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a> = hd-&gt;<a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138         <span class="comment">// Read the variable names</span>
<a name="l00139"></a>00139         {
<a name="l00140"></a>00140           std::string var_name;
<a name="l00141"></a>00141           <span class="keywordtype">char</span>* titles = <span class="keyword">new</span> <span class="keywordtype">char</span>[hd-&gt;<a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>*hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>];
<a name="l00142"></a>00142           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0;
<a name="l00143"></a>00143           
<a name="l00144"></a>00144           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> var=0; var &lt; hd-&gt;<a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>; var++)
<a name="l00145"></a>00145             {
<a name="l00146"></a>00146               <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a> &gt;&gt; var_name;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;var_name.size(); l++)
<a name="l00149"></a>00149                 titles[c++] = var_name[l];
<a name="l00150"></a>00150 
<a name="l00151"></a>00151               titles[c++] = <span class="charliteral">&#39;\0&#39;</span>;
<a name="l00152"></a>00152             }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154           <a class="code" href="classXdrMGF.php#a7ff352726c1a8759dce8ddb886a74dc4">mp_in</a>.getline(comment, comm_len);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156           hd-&gt;<a class="code" href="classXdrSHEAD.php#afca190cd39a17940e90d11016501361f">setVarTitle</a>(titles, c);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158           <span class="keyword">delete</span> [] titles;
<a name="l00159"></a>00159         }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161         
<a name="l00162"></a>00162         <span class="keywordflow">return</span> 0;
<a name="l00163"></a>00163       }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165       
<a name="l00166"></a>00166     <span class="keywordflow">case</span> (<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759a4abf31037aca9aabba9b65e45ebc4744">XdrMGF::W_ASCII</a>):
<a name="l00167"></a>00167       {
<a name="l00168"></a>00168         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#a1f0eb297b78a331b02c95bb9269243f1">m_numNodes</a>   &lt;&lt; <span class="stringliteral">&quot;\t # Num. Nodes\n&quot;</span>;
<a name="l00169"></a>00169         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>     &lt;&lt; <span class="stringliteral">&quot;\t # Num. of Vars\n&quot;</span>;
<a name="l00170"></a>00170         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#a60cd9ef0718761d4398c058b067f4d33">m_strSize</a>    &lt;&lt; <span class="stringliteral">&quot;\t # String Size (ignore)\n&quot;</span>;
<a name="l00171"></a>00171         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#ad31ef084953312f6d47d26f9ba63f44c">m_time</a>       &lt;&lt; <span class="stringliteral">&quot;\t # Current Time\n&quot;</span>;
<a name="l00172"></a>00172         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#ab035b1f627467cb2596ff33241d23066">mp_id</a>        &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00173"></a>00173         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#afdd2b89c79ace9409cb86fb5c13bbcab">mp_title</a>     &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00174"></a>00174         <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; hd-&gt;<a class="code" href="classXdrHEAD.php#a5ec0f7dbd17dca2a040810979c035dba">mp_userTitle</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00175"></a>00175 
<a name="l00176"></a>00176         <span class="comment">// write the variable names</span>
<a name="l00177"></a>00177         {
<a name="l00178"></a>00178           <span class="keyword">const</span> <span class="keywordtype">char</span>* p = hd-&gt;<a class="code" href="classXdrSHEAD.php#afc2ffddf806584f67384472a70b73520">getVarTitle</a>();
<a name="l00179"></a>00179 
<a name="l00180"></a>00180           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> var=0; var&lt;hd-&gt;<a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a> ; var++)
<a name="l00181"></a>00181             {
<a name="l00182"></a>00182               <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; p &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00183"></a>00183               p += std::strlen(p)+1;
<a name="l00184"></a>00184             }     
<a name="l00185"></a>00185           <a class="code" href="classXdrMGF.php#a7dc4bd8708bff35fde3c4e1a215d002a">mp_out</a> &lt;&lt; <span class="stringliteral">&quot;\t # Variable Names\n&quot;</span>;
<a name="l00186"></a>00186         }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188         <a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a> = hd-&gt;<a class="code" href="classXdrHEAD.php#a1a2f50716aecde404db9d86103d91a2d">m_wrtVar</a>;
<a name="l00189"></a>00189 
<a name="l00190"></a>00190         <span class="keywordflow">return</span> 0;
<a name="l00191"></a>00191       }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194       
<a name="l00195"></a>00195     <span class="keywordflow">default</span>:
<a name="l00196"></a>00196       <span class="comment">// Unknown access type</span>
<a name="l00197"></a>00197       libmesh_error();
<a name="l00198"></a>00198 
<a name="l00199"></a>00199     }
<a name="l00200"></a>00200   
<a name="l00201"></a>00201   <span class="keywordflow">return</span> 1;
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203   
<a name="l00204"></a>00204 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
