<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fabddba319d89a4455af58c54b50937a.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_soln.h</h1>  </div>
</div>
<div class="contents">
<a href="xdr__soln_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: xdr_soln.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __xdr_soln_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __xdr_soln_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="xdr__mgf_8h.php">xdr_mgf.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// forward declarations</span>
<a name="l00027"></a>00027 <span class="keyword">class </span><a class="code" href="classXdrSHEAD.php">XdrSHEAD</a>; 
<a name="l00028"></a>00028 
<a name="l00038"></a><a class="code" href="classXdrSOLN.php">00038</a> <span class="keyword">class </span><a class="code" href="classXdrSOLN.php">XdrSOLN</a>: <span class="keyword">public</span> <a class="code" href="classXdrMGF.php">XdrMGF</a>
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 <span class="keyword">public</span>:
<a name="l00045"></a><a class="code" href="classXdrSOLN.php#ade5781c5a17d532925d85ff244271b04">00045</a>   <a class="code" href="classXdrSOLN.php#ade5781c5a17d532925d85ff244271b04">XdrSOLN</a>() : <a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a>(-1) {}
<a name="l00046"></a>00046 
<a name="l00056"></a><a class="code" href="classXdrSOLN.php#a22d23b35b69a02078a0c219cba391aaa">00056</a>   <span class="keywordtype">void</span> <a class="code" href="classXdrSOLN.php#a22d23b35b69a02078a0c219cba391aaa">init</a>(<a class="code" href="classXdrMGF.php#af46666c38e84caecb815afcabb1c2759">XdrIO_TYPE</a> type, <span class="keyword">const</span> <span class="keywordtype">char</span>* fn, <span class="keywordtype">int</span> icnt) 
<a name="l00057"></a>00057   {<a class="code" href="classXdrSOLN.php#a22d23b35b69a02078a0c219cba391aaa">XdrMGF::init</a> (type, fn, <span class="stringliteral">&quot;soln&quot;</span>,icnt);}
<a name="l00058"></a>00058 
<a name="l00062"></a><a class="code" href="classXdrSOLN.php#ac14b5dfba26fed433033671060008475">00062</a>   <a class="code" href="classXdrSOLN.php#ac14b5dfba26fed433033671060008475">~XdrSOLN</a>() {}
<a name="l00063"></a>00063 
<a name="l00072"></a>00072   <span class="keywordtype">int</span> <a class="code" href="classXdrSOLN.php#ad4068e5bfc6924804b2feaf3d090ba8b">header</a>(<a class="code" href="classXdrSHEAD.php">XdrSHEAD</a> *hd);
<a name="l00073"></a>00073 
<a name="l00081"></a><a class="code" href="classXdrSOLN.php#ada56474bbd9746990ba43953ebf5429c">00081</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrSOLN.php#ada56474bbd9746990ba43953ebf5429c">values</a>(<a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>* array, <span class="keywordtype">int</span> size) { <span class="keywordflow">return</span> <a class="code" href="classXdrMGF.php#a5680d36e267918b95d95ea1f0c137a6d">dataBlk</a>(array, <a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a>, size);}
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="keyword">private</span>:
<a name="l00084"></a><a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">00084</a>   <span class="keywordtype">int</span> <a class="code" href="classXdrSOLN.php#afa9f830dcd071ba4acc7bdb146f2adfe">m_wrtVar</a>;
<a name="l00085"></a>00085 };
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="preprocessor">#endif // #ifndef __xdr_soln_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
