<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1665b3ccb6c776ec6797fe204e2359e5.php">geom</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>elem.C</h1>  </div>
</div>
<div class="contents">
<a href="elem_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: elem.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::sort</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;iterator&gt;</span>  <span class="comment">// for std::ostream_iterator</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;fe_type.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;edge_edge2.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;edge_edge3.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;edge_edge4.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;edge_inf_edge2.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;face_tri3.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;face_tri6.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;face_quad4.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;face_quad8.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;face_quad9.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;face_inf_quad4.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;face_inf_quad6.h&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;cell_tet4.h&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;cell_tet10.h&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;cell_hex8.h&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;cell_hex20.h&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;cell_hex27.h&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;cell_inf_hex8.h&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;cell_inf_hex16.h&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &quot;cell_inf_hex18.h&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#include &quot;cell_prism6.h&quot;</span>
<a name="l00050"></a>00050 <span class="preprocessor">#include &quot;cell_prism15.h&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor">#include &quot;cell_prism18.h&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor">#include &quot;cell_inf_prism6.h&quot;</span>
<a name="l00053"></a>00053 <span class="preprocessor">#include &quot;cell_inf_prism12.h&quot;</span>
<a name="l00054"></a>00054 <span class="preprocessor">#include &quot;cell_pyramid5.h&quot;</span>
<a name="l00055"></a>00055 <span class="preprocessor">#include &quot;fe_base.h&quot;</span>
<a name="l00056"></a>00056 <span class="preprocessor">#include &quot;quadrature_gauss.h&quot;</span>
<a name="l00057"></a>00057 <span class="preprocessor">#include &quot;remote_elem.h&quot;</span>
<a name="l00058"></a>00058 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="comment">// Initialize static member variables</span>
<a name="l00061"></a>00061 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a50fdd3a0d5528931f0168689b1e6a2cd">Elem::_bp1</a> = 65449;
<a name="l00062"></a>00062 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a39777f85fbd4c499d89378fb84f01ed8">Elem::_bp2</a> = 48661;
<a name="l00063"></a>00063 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#aef05e33c03cee6724a1e26b8fb9d19fd">Elem::type_to_n_nodes_map</a> [] =
<a name="l00064"></a>00064   {
<a name="l00065"></a>00065     2,  <span class="comment">// EDGE2</span>
<a name="l00066"></a>00066     3,  <span class="comment">// EDGE3</span>
<a name="l00067"></a>00067     4,  <span class="comment">// EDGE4</span>
<a name="l00068"></a>00068                  
<a name="l00069"></a>00069     3,  <span class="comment">// TRI3</span>
<a name="l00070"></a>00070     6,  <span class="comment">// TRI6</span>
<a name="l00071"></a>00071                  
<a name="l00072"></a>00072     4,  <span class="comment">// QUAD4</span>
<a name="l00073"></a>00073     8,  <span class="comment">// QUAD8</span>
<a name="l00074"></a>00074     9,  <span class="comment">// QUAD9</span>
<a name="l00075"></a>00075     
<a name="l00076"></a>00076     4,  <span class="comment">// TET4</span>
<a name="l00077"></a>00077     10, <span class="comment">// TET10</span>
<a name="l00078"></a>00078                  
<a name="l00079"></a>00079     8,  <span class="comment">// HEX8</span>
<a name="l00080"></a>00080     20, <span class="comment">// HEX20</span>
<a name="l00081"></a>00081     27, <span class="comment">// HEX27</span>
<a name="l00082"></a>00082                  
<a name="l00083"></a>00083     6,  <span class="comment">// PRISM6</span>
<a name="l00084"></a>00084     15, <span class="comment">// PRISM15</span>
<a name="l00085"></a>00085     18, <span class="comment">// PRISM18</span>
<a name="l00086"></a>00086     
<a name="l00087"></a>00087     5,  <span class="comment">// PYRAMID5</span>
<a name="l00088"></a>00088     
<a name="l00089"></a>00089     2,  <span class="comment">// INFEDGE2</span>
<a name="l00090"></a>00090     
<a name="l00091"></a>00091     4,  <span class="comment">// INFQUAD4</span>
<a name="l00092"></a>00092     6,  <span class="comment">// INFQUAD6</span>
<a name="l00093"></a>00093                  
<a name="l00094"></a>00094     8,  <span class="comment">// INFHEX8</span>
<a name="l00095"></a>00095     16, <span class="comment">// INFHEX16</span>
<a name="l00096"></a>00096     18, <span class="comment">// INFHEX18</span>
<a name="l00097"></a>00097                  
<a name="l00098"></a>00098     6,  <span class="comment">// INFPRISM6</span>
<a name="l00099"></a>00099     16, <span class="comment">// INFPRISM12</span>
<a name="l00100"></a>00100 
<a name="l00101"></a>00101     1,  <span class="comment">// NODEELEM</span>
<a name="l00102"></a>00102   };
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00107"></a>00107 <span class="comment">// Elem class member funcions</span>
<a name="l00108"></a><a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">00108</a> <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">Elem::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00109"></a>00109                           <a class="code" href="classElem.php">Elem</a>* p)
<a name="l00110"></a>00110 {
<a name="l00111"></a>00111   <a class="code" href="classElem.php">Elem</a>* elem = NULL;
<a name="l00112"></a>00112  
<a name="l00113"></a>00113   <span class="keywordflow">switch</span> (type)
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115       <span class="comment">// 1D elements </span>
<a name="l00116"></a>00116     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00117"></a>00117       {
<a name="l00118"></a>00118         elem = <span class="keyword">new</span> <a class="code" href="classEdge2.php">Edge2</a>(p);
<a name="l00119"></a>00119         <span class="keywordflow">break</span>;
<a name="l00120"></a>00120       }
<a name="l00121"></a>00121     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00122"></a>00122       {
<a name="l00123"></a>00123         elem = <span class="keyword">new</span> <a class="code" href="classEdge3.php">Edge3</a>(p);
<a name="l00124"></a>00124         <span class="keywordflow">break</span>;
<a name="l00125"></a>00125       }
<a name="l00126"></a>00126     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00127"></a>00127       {
<a name="l00128"></a>00128         elem = <span class="keyword">new</span> <a class="code" href="classEdge4.php">Edge4</a>(p);
<a name="l00129"></a>00129         <span class="keywordflow">break</span>;
<a name="l00130"></a>00130       }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133       
<a name="l00134"></a>00134       <span class="comment">// 2D elements</span>
<a name="l00135"></a>00135     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00136"></a>00136       {
<a name="l00137"></a>00137         elem = <span class="keyword">new</span> <a class="code" href="classTri3.php">Tri3</a>(p);
<a name="l00138"></a>00138         <span class="keywordflow">break</span>;
<a name="l00139"></a>00139       }
<a name="l00140"></a>00140     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00141"></a>00141       {
<a name="l00142"></a>00142         elem = <span class="keyword">new</span> <a class="code" href="classTri6.php">Tri6</a>(p);
<a name="l00143"></a>00143         <span class="keywordflow">break</span>;
<a name="l00144"></a>00144       }
<a name="l00145"></a>00145     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00146"></a>00146       {
<a name="l00147"></a>00147         elem = <span class="keyword">new</span> <a class="code" href="classQuad4.php">Quad4</a>(p);
<a name="l00148"></a>00148         <span class="keywordflow">break</span>;
<a name="l00149"></a>00149       }
<a name="l00150"></a>00150     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00151"></a>00151       {
<a name="l00152"></a>00152         elem = <span class="keyword">new</span> <a class="code" href="classQuad8.php">Quad8</a>(p);
<a name="l00153"></a>00153         <span class="keywordflow">break</span>;
<a name="l00154"></a>00154       }
<a name="l00155"></a>00155     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00156"></a>00156       {
<a name="l00157"></a>00157         elem = <span class="keyword">new</span> <a class="code" href="classQuad9.php">Quad9</a>(p);
<a name="l00158"></a>00158         <span class="keywordflow">break</span>;
<a name="l00159"></a>00159       }
<a name="l00160"></a>00160    
<a name="l00161"></a>00161 
<a name="l00162"></a>00162       <span class="comment">// 3D elements</span>
<a name="l00163"></a>00163     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00164"></a>00164       {
<a name="l00165"></a>00165         elem = <span class="keyword">new</span> <a class="code" href="classTet4.php">Tet4</a>(p);
<a name="l00166"></a>00166         <span class="keywordflow">break</span>;
<a name="l00167"></a>00167       }
<a name="l00168"></a>00168     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00169"></a>00169       {
<a name="l00170"></a>00170         elem = <span class="keyword">new</span> <a class="code" href="classTet10.php">Tet10</a>(p);
<a name="l00171"></a>00171         <span class="keywordflow">break</span>;
<a name="l00172"></a>00172       }
<a name="l00173"></a>00173     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00174"></a>00174       {
<a name="l00175"></a>00175         elem = <span class="keyword">new</span> <a class="code" href="classHex8.php">Hex8</a>(p);
<a name="l00176"></a>00176         <span class="keywordflow">break</span>;
<a name="l00177"></a>00177       }
<a name="l00178"></a>00178     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00179"></a>00179       {
<a name="l00180"></a>00180         elem = <span class="keyword">new</span> <a class="code" href="classHex20.php">Hex20</a>(p);
<a name="l00181"></a>00181         <span class="keywordflow">break</span>;
<a name="l00182"></a>00182       }
<a name="l00183"></a>00183     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00184"></a>00184       {
<a name="l00185"></a>00185         elem = <span class="keyword">new</span> <a class="code" href="classHex27.php">Hex27</a>(p);
<a name="l00186"></a>00186         <span class="keywordflow">break</span>;
<a name="l00187"></a>00187       }
<a name="l00188"></a>00188     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00189"></a>00189       {
<a name="l00190"></a>00190         elem = <span class="keyword">new</span> <a class="code" href="classPrism6.php">Prism6</a>(p);
<a name="l00191"></a>00191         <span class="keywordflow">break</span>;
<a name="l00192"></a>00192       }
<a name="l00193"></a>00193     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00194"></a>00194       {
<a name="l00195"></a>00195         elem = <span class="keyword">new</span> <a class="code" href="classPrism15.php">Prism15</a>(p);
<a name="l00196"></a>00196         <span class="keywordflow">break</span>;
<a name="l00197"></a>00197       }
<a name="l00198"></a>00198     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00199"></a>00199       {
<a name="l00200"></a>00200         elem = <span class="keyword">new</span> <a class="code" href="classPrism18.php">Prism18</a>(p);
<a name="l00201"></a>00201         <span class="keywordflow">break</span>;
<a name="l00202"></a>00202       }
<a name="l00203"></a>00203     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00204"></a>00204       {
<a name="l00205"></a>00205         elem = <span class="keyword">new</span> <a class="code" href="classPyramid5.php">Pyramid5</a>(p);
<a name="l00206"></a>00206         <span class="keywordflow">break</span>;
<a name="l00207"></a>00207       }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>
<a name="l00213"></a>00213       <span class="comment">// 1D infinite elements</span>
<a name="l00214"></a>00214     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00215"></a>00215       {
<a name="l00216"></a>00216         elem = <span class="keyword">new</span> <a class="code" href="classInfEdge2.php">InfEdge2</a>(p);
<a name="l00217"></a>00217         <span class="keywordflow">break</span>;
<a name="l00218"></a>00218       }
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221       <span class="comment">// 2D infinite elements</span>
<a name="l00222"></a>00222     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00223"></a>00223       {
<a name="l00224"></a>00224         elem = <span class="keyword">new</span> <a class="code" href="classInfQuad4.php">InfQuad4</a>(p);
<a name="l00225"></a>00225         <span class="keywordflow">break</span>;
<a name="l00226"></a>00226       }
<a name="l00227"></a>00227     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00228"></a>00228       {
<a name="l00229"></a>00229         elem = <span class="keyword">new</span> <a class="code" href="classInfQuad6.php">InfQuad6</a>(p);
<a name="l00230"></a>00230         <span class="keywordflow">break</span>;
<a name="l00231"></a>00231       }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233    
<a name="l00234"></a>00234     <span class="comment">// 3D infinite elements</span>
<a name="l00235"></a>00235     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00236"></a>00236       {
<a name="l00237"></a>00237         elem = <span class="keyword">new</span> <a class="code" href="classInfHex8.php">InfHex8</a>(p);
<a name="l00238"></a>00238         <span class="keywordflow">break</span>;
<a name="l00239"></a>00239       }
<a name="l00240"></a>00240     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00241"></a>00241       {
<a name="l00242"></a>00242         elem = <span class="keyword">new</span> <a class="code" href="classInfHex16.php">InfHex16</a>(p);
<a name="l00243"></a>00243         <span class="keywordflow">break</span>;
<a name="l00244"></a>00244       }
<a name="l00245"></a>00245     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00246"></a>00246       {
<a name="l00247"></a>00247         elem = <span class="keyword">new</span> <a class="code" href="classInfHex18.php">InfHex18</a>(p);
<a name="l00248"></a>00248         <span class="keywordflow">break</span>;
<a name="l00249"></a>00249       }
<a name="l00250"></a>00250     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00251"></a>00251       {
<a name="l00252"></a>00252         elem = <span class="keyword">new</span> <a class="code" href="classInfPrism6.php">InfPrism6</a>(p);
<a name="l00253"></a>00253         <span class="keywordflow">break</span>;
<a name="l00254"></a>00254       }
<a name="l00255"></a>00255     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00256"></a>00256       {
<a name="l00257"></a>00257         elem = <span class="keyword">new</span> <a class="code" href="classInfPrism12.php">InfPrism12</a>(p);
<a name="l00258"></a>00258         <span class="keywordflow">break</span>;
<a name="l00259"></a>00259       }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="preprocessor">#endif</span>
<a name="l00262"></a>00262 <span class="preprocessor"></span>           
<a name="l00263"></a>00263     <span class="keywordflow">default</span>:
<a name="l00264"></a>00264       {
<a name="l00265"></a>00265         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Undefined element type!.&quot;</span> &lt;&lt; std::endl;
<a name="l00266"></a>00266         libmesh_error();
<a name="l00267"></a>00267       }
<a name="l00268"></a>00268     }
<a name="l00269"></a>00269   
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> ap(elem);
<a name="l00272"></a>00272   <span class="keywordflow">return</span> ap;
<a name="l00273"></a>00273 }
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a><a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">00277</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classElem.php#a46ce080150f08ce9d367b69f16dd0452">Elem::centroid</a>()<span class="keyword"> const</span>
<a name="l00278"></a>00278 <span class="keyword"></span>{
<a name="l00279"></a>00279   <a class="code" href="classPoint.php">Point</a> cp;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>(); n++)
<a name="l00282"></a>00282     cp.<a class="code" href="classTypeVector.php#a5a491e5c665118253b6e2f65141c8922">add</a> (this-&gt;point(n));
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <span class="keywordflow">return</span> (cp /= static_cast&lt;Real&gt;(this-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>()));    
<a name="l00285"></a>00285 }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a><a class="code" href="classElem.php#a8483eb75ec4ccc49b41596557a3a367b">00289</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#a8483eb75ec4ccc49b41596557a3a367b">Elem::hmin</a>()<span class="keyword"> const</span>
<a name="l00290"></a>00290 <span class="keyword"></span>{
<a name="l00291"></a>00291   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> h_min=1.e30;
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_outer=0; n_outer&lt;this-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>(); n_outer++)
<a name="l00294"></a>00294     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_inner=n_outer+1; n_inner&lt;this-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>(); n_inner++)
<a name="l00295"></a>00295       {
<a name="l00296"></a>00296         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> diff = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n_outer) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n_inner));
<a name="l00297"></a>00297         
<a name="l00298"></a>00298         h_min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(h_min,diff.<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>());
<a name="l00299"></a>00299       }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="keywordflow">return</span> h_min;
<a name="l00302"></a>00302 }
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a><a class="code" href="classElem.php#aed45dccf181d13107eab2c2947d1afe6">00306</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#aed45dccf181d13107eab2c2947d1afe6">Elem::hmax</a>()<span class="keyword"> const</span>
<a name="l00307"></a>00307 <span class="keyword"></span>{
<a name="l00308"></a>00308   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> h_max=0;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_outer=0; n_outer&lt;this-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>(); n_outer++)
<a name="l00311"></a>00311     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_inner=n_outer+1; n_inner&lt;this-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>(); n_inner++)
<a name="l00312"></a>00312       {
<a name="l00313"></a>00313         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> diff = (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n_outer) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n_inner));
<a name="l00314"></a>00314         
<a name="l00315"></a>00315         h_max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(h_max,diff.<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>());
<a name="l00316"></a>00316       }
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   <span class="keywordflow">return</span> h_max;
<a name="l00319"></a>00319 }
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a><a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">00323</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#ada047a313e28ffaf59120641937a5c8e">Elem::length</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n1, 
<a name="l00324"></a>00324                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n2)<span class="keyword"> const</span>
<a name="l00325"></a>00325 <span class="keyword"></span>{
<a name="l00326"></a>00326   libmesh_assert ( n1 &lt; this-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>() );
<a name="l00327"></a>00327   libmesh_assert ( n2 &lt; this-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>() );
<a name="l00328"></a>00328 
<a name="l00329"></a>00329   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n1) - this-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n2)).size();
<a name="l00330"></a>00330 }
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 
<a name="l00334"></a><a class="code" href="classElem.php#acab7543901989ae1f909101f89f3d4d4">00334</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#acab7543901989ae1f909101f89f3d4d4">Elem::operator == </a>(<span class="keyword">const</span> <a class="code" href="classDofObject.php">DofObject</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00335"></a>00335 <span class="keyword"></span>{
<a name="l00336"></a>00336 
<a name="l00337"></a>00337     <span class="comment">// Cast rhs to an Elem*</span>
<a name="l00338"></a>00338     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* rhs_elem = <span class="keyword">dynamic_cast&lt;</span><span class="keyword">const </span><a class="code" href="classElem.php">Elem</a>*<span class="keyword">&gt;</span>(&amp;rhs);
<a name="l00339"></a>00339 
<a name="l00340"></a>00340     <span class="comment">// If we cannot cast to an Elem*, rhs must be a Node</span>
<a name="l00341"></a>00341     <span class="keywordflow">if</span>(rhs_elem == static_cast&lt;const Elem*&gt;(NULL))
<a name="l00342"></a>00342         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 <span class="comment">//   libmesh_assert (n_nodes());</span>
<a name="l00345"></a>00345 <span class="comment">//   libmesh_assert (rhs.n_nodes());</span>
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 <span class="comment">//   // Elements can only be equal if they</span>
<a name="l00348"></a>00348 <span class="comment">//   // contain the same number of nodes.</span>
<a name="l00349"></a>00349 <span class="comment">//   if (this-&gt;n_nodes() == rhs.n_nodes())</span>
<a name="l00350"></a>00350 <span class="comment">//     {</span>
<a name="l00351"></a>00351 <span class="comment">//       // Create a set that contains our global</span>
<a name="l00352"></a>00352 <span class="comment">//       // node numbers and those of our neighbor.</span>
<a name="l00353"></a>00353 <span class="comment">//       // If the set is the same size as the number</span>
<a name="l00354"></a>00354 <span class="comment">//       // of nodes in both elements then they must</span>
<a name="l00355"></a>00355 <span class="comment">//       // be connected to the same nodes.     </span>
<a name="l00356"></a>00356 <span class="comment">//       std::set&lt;unsigned int&gt; nodes_set;</span>
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="comment">//       for (unsigned int n=0; n&lt;this-&gt;n_nodes(); n++)</span>
<a name="l00359"></a>00359 <span class="comment">//         {</span>
<a name="l00360"></a>00360 <span class="comment">//           nodes_set.insert(this-&gt;node(n));</span>
<a name="l00361"></a>00361 <span class="comment">//           nodes_set.insert(rhs.node(n));</span>
<a name="l00362"></a>00362 <span class="comment">//         }</span>
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 <span class="comment">//       // If this passes the elements are connected</span>
<a name="l00365"></a>00365 <span class="comment">//       // to the same global nodes</span>
<a name="l00366"></a>00366 <span class="comment">//       if (nodes_set.size() == this-&gt;n_nodes())</span>
<a name="l00367"></a>00367 <span class="comment">//         return true;</span>
<a name="l00368"></a>00368 <span class="comment">//     }</span>
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 <span class="comment">//   // If we get here it is because the elements either</span>
<a name="l00371"></a>00371 <span class="comment">//   // do not have the same number of nodes or they are</span>
<a name="l00372"></a>00372 <span class="comment">//   // connected to different nodes.  Either way they</span>
<a name="l00373"></a>00373 <span class="comment">//   // are not the same element</span>
<a name="l00374"></a>00374 <span class="comment">//   return false;</span>
<a name="l00375"></a>00375   
<a name="l00376"></a>00376   <span class="comment">// Useful typedefs</span>
<a name="l00377"></a>00377   <span class="keyword">typedef</span> std::vector&lt;unsigned int&gt;::iterator <a class="code" href="classstd_1_1iterator.php">iterator</a>;
<a name="l00378"></a>00378 
<a name="l00379"></a>00379   
<a name="l00380"></a>00380   <span class="comment">// Elements can only be equal if they</span>
<a name="l00381"></a>00381   <span class="comment">// contain the same number of nodes.</span>
<a name="l00382"></a>00382   <span class="comment">// However, we will only test the vertices,</span>
<a name="l00383"></a>00383   <span class="comment">// which is sufficient &amp; cheaper</span>
<a name="l00384"></a>00384   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>() == rhs_elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>())
<a name="l00385"></a>00385     {
<a name="l00386"></a>00386       <span class="comment">// The number of nodes in the element</span>
<a name="l00387"></a>00387       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn = this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00388"></a>00388       
<a name="l00389"></a>00389       <span class="comment">// Create a vector that contains our global</span>
<a name="l00390"></a>00390       <span class="comment">// node numbers and those of our neighbor.</span>
<a name="l00391"></a>00391       <span class="comment">// If the sorted, unique vector is the same size</span>
<a name="l00392"></a>00392       <span class="comment">// as the number of nodes in both elements then</span>
<a name="l00393"></a>00393       <span class="comment">// they must be connected to the same nodes.</span>
<a name="l00394"></a>00394       <span class="comment">//</span>
<a name="l00395"></a>00395       <span class="comment">// The vector will be no larger than 2*n_nodes(),</span>
<a name="l00396"></a>00396       <span class="comment">// so we might as well reserve the space.</span>
<a name="l00397"></a>00397       std::vector&lt;unsigned int&gt; common_nodes;
<a name="l00398"></a>00398       common_nodes.reserve (2*nn);
<a name="l00399"></a>00399 
<a name="l00400"></a>00400       <span class="comment">// Add the global indices of the nodes</span>
<a name="l00401"></a>00401       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nn; n++)
<a name="l00402"></a>00402         {
<a name="l00403"></a>00403           common_nodes.push_back (this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n));
<a name="l00404"></a>00404           common_nodes.push_back (rhs_elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n));
<a name="l00405"></a>00405         }
<a name="l00406"></a>00406 
<a name="l00407"></a>00407       <span class="comment">// Sort the vector and find out how long</span>
<a name="l00408"></a>00408       <span class="comment">// the sorted vector is.</span>
<a name="l00409"></a>00409       std::sort (common_nodes.begin(), common_nodes.end());
<a name="l00410"></a>00410       
<a name="l00411"></a>00411       iterator new_end = std::unique (common_nodes.begin(),
<a name="l00412"></a>00412                                       common_nodes.end());
<a name="l00413"></a>00413       
<a name="l00414"></a>00414       <span class="keyword">const</span> <span class="keywordtype">int</span> new_size = std::distance (common_nodes.begin(),
<a name="l00415"></a>00415                                           new_end);
<a name="l00416"></a>00416       
<a name="l00417"></a>00417       <span class="comment">// If this passes the elements are connected</span>
<a name="l00418"></a>00418       <span class="comment">// to the same global vertex nodes</span>
<a name="l00419"></a>00419       <span class="keywordflow">if</span> (new_size == static_cast&lt;int&gt;(nn))
<a name="l00420"></a>00420         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00421"></a>00421     }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="comment">// If we get here it is because the elements either</span>
<a name="l00424"></a>00424   <span class="comment">// do not have the same number of nodes or they are</span>
<a name="l00425"></a>00425   <span class="comment">// connected to different nodes.  Either way they</span>
<a name="l00426"></a>00426   <span class="comment">// are not the same element</span>
<a name="l00427"></a>00427   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a><a class="code" href="classElem.php#a9fedc0a0b8f1671e9fc67d2d297131b0">00432</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a9fedc0a0b8f1671e9fc67d2d297131b0">Elem::contains_vertex_of</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *e)<span class="keyword"> const</span>
<a name="l00433"></a>00433 <span class="keyword"></span>{
<a name="l00434"></a>00434   <span class="comment">// Our vertices are the first numbered nodes</span>
<a name="l00435"></a>00435   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != e-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>(); ++n)
<a name="l00436"></a>00436     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#ace5226376cf53804d20073a0d21b0cbc">contains_point</a>(e-&gt;<a class="code" href="classElem.php#a91e17d2a368e1b2606ec395399d5800d">point</a>(n)))
<a name="l00437"></a>00437       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00438"></a>00438   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00439"></a>00439 }
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 
<a name="l00443"></a><a class="code" href="classElem.php#ab7749393ce65ac42d075e53c86e698bd">00443</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#ab7749393ce65ac42d075e53c86e698bd">Elem::find_point_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set)<span class="keyword"> const</span>
<a name="l00444"></a>00444 <span class="keyword"></span>{
<a name="l00445"></a>00445   neighbor_set.clear();
<a name="l00446"></a>00446   neighbor_set.insert(<span class="keyword">this</span>);
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_size;
<a name="l00449"></a>00449   <span class="keywordflow">do</span>
<a name="l00450"></a>00450     {
<a name="l00451"></a>00451       old_size = neighbor_set.size();
<a name="l00452"></a>00452 
<a name="l00453"></a>00453       <span class="comment">// Loop over all the elements in the patch</span>
<a name="l00454"></a>00454       std::set&lt;const Elem*&gt;::const_iterator       it  = neighbor_set.begin();
<a name="l00455"></a>00455       <span class="keyword">const</span> std::set&lt;const Elem*&gt;::const_iterator end = neighbor_set.end();
<a name="l00456"></a>00456 
<a name="l00457"></a>00457       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00458"></a>00458         {
<a name="l00459"></a>00459           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l00460"></a>00460 
<a name="l00461"></a>00461           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l00462"></a>00462             {
<a name="l00463"></a>00463               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a> = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s);
<a name="l00464"></a>00464               <span class="keywordflow">if</span> (neighbor &amp;&amp;
<a name="l00465"></a>00465                   neighbor != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)    <span class="comment">// we have a real neighbor on this side</span>
<a name="l00466"></a>00466                 {
<a name="l00467"></a>00467                   <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())                <span class="comment">// ... if it is active</span>
<a name="l00468"></a>00468                     {
<a name="l00469"></a>00469                       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a9fedc0a0b8f1671e9fc67d2d297131b0">contains_vertex_of</a>(neighbor) <span class="comment">// ... and touches us</span>
<a name="l00470"></a>00470                           || neighbor-&gt;<a class="code" href="classElem.php#a9fedc0a0b8f1671e9fc67d2d297131b0">contains_vertex_of</a>(<span class="keyword">this</span>))  
<a name="l00471"></a>00471                         neighbor_set.insert (neighbor);  <span class="comment">// ... then add it</span>
<a name="l00472"></a>00472                     }
<a name="l00473"></a>00473 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00474"></a>00474 <span class="preprocessor"></span>                  <span class="keywordflow">else</span>                                 <span class="comment">// ... the neighbor is *not* active,</span>
<a name="l00475"></a>00475                     {                                  <span class="comment">// ... so add *all* neighboring</span>
<a name="l00476"></a>00476                                                        <span class="comment">// active children</span>
<a name="l00477"></a>00477                       std::vector&lt;const Elem*&gt; active_neighbor_children;
<a name="l00478"></a>00478   
<a name="l00479"></a>00479                       neighbor-&gt;<a class="code" href="classElem.php#a26ca00dd9c91f9f086d755eb3f58d4ff">active_family_tree_by_neighbor</a>
<a name="l00480"></a>00480                         (active_neighbor_children, elem);
<a name="l00481"></a>00481 
<a name="l00482"></a>00482                       std::vector&lt;const Elem*&gt;::const_iterator
<a name="l00483"></a>00483                         child_it = active_neighbor_children.begin();
<a name="l00484"></a>00484                       <span class="keyword">const</span> std::vector&lt;const Elem*&gt;::const_iterator
<a name="l00485"></a>00485                         child_end = active_neighbor_children.end();
<a name="l00486"></a>00486                       <span class="keywordflow">for</span> (; child_it != child_end; ++child_it)
<a name="l00487"></a>00487                         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a9fedc0a0b8f1671e9fc67d2d297131b0">contains_vertex_of</a>(*child_it) ||
<a name="l00488"></a>00488                             (*child_it)-&gt;contains_vertex_of(<span class="keyword">this</span>))
<a name="l00489"></a>00489                           neighbor_set.insert (*child_it);
<a name="l00490"></a>00490                     }
<a name="l00491"></a>00491 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00492"></a>00492 <span class="preprocessor"></span>                }
<a name="l00493"></a>00493             }
<a name="l00494"></a>00494         }
<a name="l00495"></a>00495     }
<a name="l00496"></a>00496   <span class="keywordflow">while</span> (old_size != neighbor_set.size());
<a name="l00497"></a>00497 }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00502"></a>00502 <span class="preprocessor"></span>
<a name="l00503"></a><a class="code" href="classElem.php#a527c92ecb5322b14ef5649c3970cab87">00503</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a527c92ecb5322b14ef5649c3970cab87">Elem::libmesh_assert_valid_node_pointers</a>()<span class="keyword"> const</span>
<a name="l00504"></a>00504 <span class="keyword"></span>{
<a name="l00505"></a>00505   libmesh_assert(this-&gt;<a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">valid_id</a>());
<a name="l00506"></a>00506   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l00507"></a>00507     {
<a name="l00508"></a>00508       libmesh_assert(this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n));
<a name="l00509"></a>00509       libmesh_assert(this-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n)-&gt;<a class="code" href="classDofObject.php#a941814a36472764092ae352543f3ecd7">valid_id</a>());
<a name="l00510"></a>00510     }
<a name="l00511"></a>00511 }
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 
<a name="l00515"></a><a class="code" href="classElem.php#a8130d32feced4528a2a08cfb3d8270af">00515</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a8130d32feced4528a2a08cfb3d8270af">Elem::libmesh_assert_valid_neighbors</a>()<span class="keyword"> const</span>
<a name="l00516"></a>00516 <span class="keyword"></span>{
<a name="l00517"></a>00517   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); s++)
<a name="l00518"></a>00518     {
<a name="l00519"></a>00519       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *neigh = this-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s);
<a name="l00520"></a>00520 
<a name="l00521"></a>00521       <span class="comment">// Any element might have a remote neighbor; checking</span>
<a name="l00522"></a>00522       <span class="comment">// to make sure that&#39;s not inaccurate is tough.</span>
<a name="l00523"></a>00523       <span class="keywordflow">if</span> (neigh == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00524"></a>00524         <span class="keywordflow">continue</span>;
<a name="l00525"></a>00525 
<a name="l00526"></a>00526       <span class="keywordflow">if</span> (neigh)
<a name="l00527"></a>00527         {
<a name="l00528"></a>00528           <span class="comment">// Only subactive elements have subactive neighbors</span>
<a name="l00529"></a>00529           libmesh_assert (this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>() || !neigh-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l00530"></a>00530 
<a name="l00531"></a>00531           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = <span class="keyword">this</span>;
<a name="l00532"></a>00532 
<a name="l00533"></a>00533           <span class="comment">// If we&#39;re subactive but our neighbor isn&#39;t, its</span>
<a name="l00534"></a>00534           <span class="comment">// return neighbor link will be to our first active</span>
<a name="l00535"></a>00535           <span class="comment">// ancestor OR to our inactive ancestor of the same</span>
<a name="l00536"></a>00536           <span class="comment">// level as neigh, </span>
<a name="l00537"></a>00537           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>() &amp;&amp; !neigh-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>())
<a name="l00538"></a>00538             {
<a name="l00539"></a>00539               <span class="keywordflow">for</span> (elem = <span class="keyword">this</span>; !elem-&gt;active();
<a name="l00540"></a>00540                    elem = elem-&gt;parent())
<a name="l00541"></a>00541                 libmesh_assert(elem);
<a name="l00542"></a>00542             }
<a name="l00543"></a>00543 
<a name="l00544"></a>00544           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rev = neigh-&gt;<a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">which_neighbor_am_i</a>(elem);
<a name="l00545"></a>00545           libmesh_assert (rev &lt; neigh-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>());
<a name="l00546"></a>00546 
<a name="l00547"></a>00547           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>() &amp;&amp; !neigh-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>())
<a name="l00548"></a>00548             {
<a name="l00549"></a>00549               <span class="keywordflow">while</span> (neigh-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(rev) != elem)
<a name="l00550"></a>00550                 {
<a name="l00551"></a>00551                   libmesh_assert(elem-&gt;parent());
<a name="l00552"></a>00552                   elem = elem-&gt;parent();
<a name="l00553"></a>00553                 }
<a name="l00554"></a>00554             }
<a name="l00555"></a>00555           <span class="keywordflow">else</span>
<a name="l00556"></a>00556             {
<a name="l00557"></a>00557               <a class="code" href="classElem.php">Elem</a> *nn = neigh-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(rev);
<a name="l00558"></a>00558               libmesh_assert(nn);
<a name="l00559"></a>00559 
<a name="l00560"></a>00560               <span class="keywordflow">for</span> (; elem != nn; elem = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>())
<a name="l00561"></a>00561                 libmesh_assert(elem);
<a name="l00562"></a>00562             }
<a name="l00563"></a>00563         }
<a name="l00564"></a>00564       <span class="keywordflow">else</span>
<a name="l00565"></a>00565         {
<a name="l00566"></a>00566           <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a> = this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00567"></a>00567           <span class="keywordflow">if</span> (parent)
<a name="l00568"></a>00568             libmesh_assert (!parent-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s));
<a name="l00569"></a>00569         }
<a name="l00570"></a>00570     }
<a name="l00571"></a>00571 }
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00574"></a>00574 <span class="preprocessor"></span>
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 
<a name="l00577"></a><a class="code" href="classElem.php#aa4989bf7c952831c59b6204075f7b8ab">00577</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#aa4989bf7c952831c59b6204075f7b8ab">Elem::make_links_to_me_remote</a>()
<a name="l00578"></a>00578 {
<a name="l00579"></a>00579   libmesh_assert (<span class="keyword">this</span> != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l00580"></a>00580 
<a name="l00581"></a>00581   <span class="comment">// We need to have handled any children first</span>
<a name="l00582"></a>00582 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) &amp;&amp; defined(DEBUG)</span>
<a name="l00583"></a>00583 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>())
<a name="l00584"></a>00584     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c = 0; c != this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); ++c)
<a name="l00585"></a>00585       {
<a name="l00586"></a>00586         <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l00587"></a>00587         libmesh_assert (child == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l00588"></a>00588       }
<a name="l00589"></a>00589 <span class="preprocessor">#endif</span>
<a name="l00590"></a>00590 <span class="preprocessor"></span>
<a name="l00591"></a>00591   <span class="comment">// Remotify any neighbor links</span>
<a name="l00592"></a>00592   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s = 0; s != this-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); ++s)
<a name="l00593"></a>00593     {
<a name="l00594"></a>00594       <a class="code" href="classElem.php">Elem</a> *neigh = this-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s);
<a name="l00595"></a>00595       <span class="keywordflow">if</span> (neigh &amp;&amp; neigh != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00596"></a>00596         {
<a name="l00597"></a>00597           <span class="comment">// My neighbor should never be more refined than me; my real</span>
<a name="l00598"></a>00598           <span class="comment">// neighbor would have been its parent in that case.</span>
<a name="l00599"></a>00599           libmesh_assert(this-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &gt;= neigh-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>());
<a name="l00600"></a>00600           
<a name="l00601"></a>00601           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == neigh-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &amp;&amp;
<a name="l00602"></a>00602               neigh-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(<span class="keyword">this</span>))
<a name="l00603"></a>00603             {
<a name="l00604"></a>00604 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00605"></a>00605 <span class="preprocessor"></span>              <span class="comment">// My neighbor may have descendants which also consider me a</span>
<a name="l00606"></a>00606               <span class="comment">// neighbor</span>
<a name="l00607"></a>00607               std::vector&lt;const Elem*&gt; family;
<a name="l00608"></a>00608               neigh-&gt;<a class="code" href="classElem.php#a69eebe1336fd5446432172a7f30fcc97">family_tree_by_neighbor</a> (family, <span class="keyword">this</span>);
<a name="l00609"></a>00609 
<a name="l00610"></a>00610               <span class="comment">// FIXME - There&#39;s a lot of ugly const_casts here; we</span>
<a name="l00611"></a>00611               <span class="comment">// may want to make remote_elem non-const and create</span>
<a name="l00612"></a>00612               <span class="comment">// non-const versions of the family_tree methods</span>
<a name="l00613"></a>00613               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != family.size(); ++i)
<a name="l00614"></a>00614                 {
<a name="l00615"></a>00615                   <a class="code" href="classElem.php">Elem</a> *n = <span class="keyword">const_cast&lt;</span><a class="code" href="classElem.php">Elem</a>*<span class="keyword">&gt;</span>(family[i]);
<a name="l00616"></a>00616                   libmesh_assert (n);
<a name="l00617"></a>00617                   <span class="keywordflow">if</span> (n == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00618"></a>00618                     <span class="keywordflow">continue</span>;
<a name="l00619"></a>00619                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_s = n-&gt;<a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">which_neighbor_am_i</a>(<span class="keyword">this</span>);
<a name="l00620"></a>00620                   libmesh_assert (my_s &lt; n-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>());
<a name="l00621"></a>00621                   libmesh_assert (n-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(my_s) == <span class="keyword">this</span>);
<a name="l00622"></a>00622                   n-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(my_s, const_cast&lt;RemoteElem*&gt;(<a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>));
<a name="l00623"></a>00623                 }
<a name="l00624"></a>00624 <span class="preprocessor">#else</span>
<a name="l00625"></a>00625 <span class="preprocessor"></span>              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_s = neigh-&gt;<a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">which_neighbor_am_i</a>(<span class="keyword">this</span>);
<a name="l00626"></a>00626               libmesh_assert (my_s &lt; neigh-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>());
<a name="l00627"></a>00627               libmesh_assert (neigh-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(my_s) == <span class="keyword">this</span>);
<a name="l00628"></a>00628               neigh-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(my_s, const_cast&lt;RemoteElem*&gt;(<a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>));
<a name="l00629"></a>00629 <span class="preprocessor">#endif</span>
<a name="l00630"></a>00630 <span class="preprocessor"></span>            }
<a name="l00631"></a>00631 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00632"></a>00632 <span class="preprocessor"></span>          <span class="comment">// Even if my neighbor doesn&#39;t link back to me, it might</span>
<a name="l00633"></a>00633           <span class="comment">// have subactive descendants which do</span>
<a name="l00634"></a>00634           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>())
<a name="l00635"></a>00635             {
<a name="l00636"></a>00636               <span class="comment">// If my neighbor at the same level doesn&#39;t have me as a</span>
<a name="l00637"></a>00637               <span class="comment">// neighbor, I must be subactive</span>
<a name="l00638"></a>00638               libmesh_assert(this-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &gt; neigh-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() ||
<a name="l00639"></a>00639                              this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l00640"></a>00640 
<a name="l00641"></a>00641               <span class="comment">// My neighbor must have some ancestor of mine as a</span>
<a name="l00642"></a>00642               <span class="comment">// neighbor</span>
<a name="l00643"></a>00643               <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">ancestor</a> = this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00644"></a>00644               libmesh_assert(ancestor);
<a name="l00645"></a>00645               <span class="keywordflow">while</span> (!neigh-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(ancestor))
<a name="l00646"></a>00646                 {
<a name="l00647"></a>00647                   ancestor = ancestor-&gt;parent();
<a name="l00648"></a>00648                   libmesh_assert(ancestor);
<a name="l00649"></a>00649                 }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651               <span class="comment">// My neighbor may have descendants which consider me a</span>
<a name="l00652"></a>00652               <span class="comment">// neighbor</span>
<a name="l00653"></a>00653               std::vector&lt;const Elem*&gt; family;
<a name="l00654"></a>00654               neigh-&gt;<a class="code" href="classElem.php#ab4446eecc9b887765a7d47ddb009a875">family_tree_by_subneighbor</a> (family, ancestor, <span class="keyword">this</span>);
<a name="l00655"></a>00655 
<a name="l00656"></a>00656               <span class="comment">// FIXME - There&#39;s a lot of ugly const_casts here; we</span>
<a name="l00657"></a>00657               <span class="comment">// may want to make remote_elem non-const and create</span>
<a name="l00658"></a>00658               <span class="comment">// non-const versions of the family_tree methods</span>
<a name="l00659"></a>00659               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != family.size(); ++i)
<a name="l00660"></a>00660                 {
<a name="l00661"></a>00661                   <a class="code" href="classElem.php">Elem</a> *n = <span class="keyword">const_cast&lt;</span><a class="code" href="classElem.php">Elem</a>*<span class="keyword">&gt;</span>(family[i]);
<a name="l00662"></a>00662                   libmesh_assert (n);
<a name="l00663"></a>00663                   <span class="keywordflow">if</span> (n == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00664"></a>00664                     <span class="keywordflow">continue</span>;
<a name="l00665"></a>00665                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_s = n-&gt;<a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">which_neighbor_am_i</a>(<span class="keyword">this</span>);
<a name="l00666"></a>00666                   libmesh_assert (my_s &lt; n-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>());
<a name="l00667"></a>00667                   libmesh_assert (n-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(my_s) == <span class="keyword">this</span>);
<a name="l00668"></a>00668                   n-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(my_s, const_cast&lt;RemoteElem*&gt;(<a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>));
<a name="l00669"></a>00669                 }
<a name="l00670"></a>00670             }
<a name="l00671"></a>00671 <span class="preprocessor">#endif</span>
<a name="l00672"></a>00672 <span class="preprocessor"></span>        }
<a name="l00673"></a>00673     }
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>  <span class="comment">// Remotify parent&#39;s child link</span>
<a name="l00677"></a>00677   <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a> = this-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00678"></a>00678   <span class="keywordflow">if</span> (parent &amp;&amp; parent != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00679"></a>00679     {
<a name="l00680"></a>00680       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> me = parent-&gt;<a class="code" href="classElem.php#a72cd45e535e8bebac68a57a362a60fef">which_child_am_i</a>(<span class="keyword">this</span>);
<a name="l00681"></a>00681       libmesh_assert (parent-&gt;<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[me] == <span class="keyword">this</span>);
<a name="l00682"></a>00682       parent-&gt;<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[me] = <span class="keyword">const_cast&lt;</span><a class="code" href="classRemoteElem.php">RemoteElem</a>*<span class="keyword">&gt;</span>(<a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l00683"></a>00683     }
<a name="l00684"></a>00684 <span class="preprocessor">#endif</span>
<a name="l00685"></a>00685 <span class="preprocessor"></span>}
<a name="l00686"></a>00686 
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 
<a name="l00689"></a><a class="code" href="classElem.php#a4f4c796a0808855560c6119e22796146">00689</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a4f4c796a0808855560c6119e22796146">Elem::write_connectivity</a> (std::ostream&amp; out,
<a name="l00690"></a>00690                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop)<span class="keyword"> const</span>
<a name="l00691"></a>00691 <span class="keyword"></span>{
<a name="l00692"></a>00692   libmesh_assert (out.good());
<a name="l00693"></a>00693   libmesh_assert (<a class="code" href="classElem.php#ac830c9153335c2d73068975eb99e0ace">_nodes</a> != NULL);
<a name="l00694"></a>00694   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00695"></a>00695 
<a name="l00696"></a>00696   <span class="keywordflow">switch</span> (iop)
<a name="l00697"></a>00697     {
<a name="l00698"></a>00698     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00699"></a>00699       {
<a name="l00700"></a>00700         <span class="comment">// This connectivity vector will be used repeatedly instead</span>
<a name="l00701"></a>00701         <span class="comment">// of being reconstructed inside the loop.</span>
<a name="l00702"></a>00702         std::vector&lt;unsigned int&gt; conn;
<a name="l00703"></a>00703         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc=0; sc &lt;this-&gt;<a class="code" href="classElem.php#a493c7cbea2731fbc218a65ceed27efbd">n_sub_elem</a>(); sc++)
<a name="l00704"></a>00704           {
<a name="l00705"></a>00705             this-&gt;<a class="code" href="classElem.php#a7bef5c7f5ff5cc734c3d27c42da78ed9">connectivity</a>(sc, <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>, conn);
<a name="l00706"></a>00706             
<a name="l00707"></a>00707             std::copy(conn.begin(),
<a name="l00708"></a>00708                       conn.end(),
<a name="l00709"></a>00709                       std::ostream_iterator&lt;unsigned int&gt;(out, <span class="stringliteral">&quot; &quot;</span>));
<a name="l00710"></a>00710             
<a name="l00711"></a>00711             out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00712"></a>00712           }
<a name="l00713"></a>00713         <span class="keywordflow">return</span>;
<a name="l00714"></a>00714       }
<a name="l00715"></a>00715 
<a name="l00716"></a>00716     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa602f692ea59febe36c106d912a443d1">UCD</a>:
<a name="l00717"></a>00717       {
<a name="l00718"></a>00718         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); i++)
<a name="l00719"></a>00719           out &lt;&lt; this-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(i)+1 &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span>;
<a name="l00720"></a>00720         
<a name="l00721"></a>00721         out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00722"></a>00722         <span class="keywordflow">return</span>;
<a name="l00723"></a>00723       }
<a name="l00724"></a>00724 
<a name="l00725"></a>00725     <span class="keywordflow">default</span>:
<a name="l00726"></a>00726       libmesh_error();
<a name="l00727"></a>00727     }
<a name="l00728"></a>00728 
<a name="l00729"></a>00729   libmesh_error();
<a name="l00730"></a>00730 }
<a name="l00731"></a>00731 
<a name="l00732"></a>00732 
<a name="l00733"></a>00733 <span class="comment">// void Elem::write_tecplot_connectivity(std::ostream&amp; out) const</span>
<a name="l00734"></a>00734 <span class="comment">// {</span>
<a name="l00735"></a>00735 <span class="comment">//   libmesh_assert (!out.bad());</span>
<a name="l00736"></a>00736 <span class="comment">//   libmesh_assert (_nodes != NULL);</span>
<a name="l00737"></a>00737 
<a name="l00738"></a>00738 <span class="comment">//   // This connectivity vector will be used repeatedly instead</span>
<a name="l00739"></a>00739 <span class="comment">//   // of being reconstructed inside the loop.</span>
<a name="l00740"></a>00740 <span class="comment">//   std::vector&lt;unsigned int&gt; conn;</span>
<a name="l00741"></a>00741 <span class="comment">//   for (unsigned int sc=0; sc &lt;this-&gt;n_sub_elem(); sc++)</span>
<a name="l00742"></a>00742 <span class="comment">//     {</span>
<a name="l00743"></a>00743 <span class="comment">//       this-&gt;connectivity(sc, TECPLOT, conn);</span>
<a name="l00744"></a>00744       
<a name="l00745"></a>00745 <span class="comment">//       std::copy(conn.begin(),</span>
<a name="l00746"></a>00746 <span class="comment">//              conn.end(),</span>
<a name="l00747"></a>00747 <span class="comment">//              std::ostream_iterator&lt;unsigned int&gt;(out, &quot; &quot;));</span>
<a name="l00748"></a>00748       
<a name="l00749"></a>00749 <span class="comment">//       out &lt;&lt; std::endl;</span>
<a name="l00750"></a>00750 <span class="comment">//     }</span>
<a name="l00751"></a>00751 <span class="comment">// }</span>
<a name="l00752"></a>00752 
<a name="l00753"></a>00753 
<a name="l00754"></a>00754 
<a name="l00755"></a>00755 <span class="comment">// void Elem::write_ucd_connectivity(std::ostream &amp;out) const</span>
<a name="l00756"></a>00756 <span class="comment">// {</span>
<a name="l00757"></a>00757 <span class="comment">//   libmesh_assert (out);</span>
<a name="l00758"></a>00758 <span class="comment">//   libmesh_assert (_nodes != NULL);</span>
<a name="l00759"></a>00759 
<a name="l00760"></a>00760 <span class="comment">//   for (unsigned int i=0; i&lt;this-&gt;n_nodes(); i++)</span>
<a name="l00761"></a>00761 <span class="comment">//     out &lt;&lt; this-&gt;node(i)+1 &lt;&lt; &quot;\t&quot;;</span>
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 <span class="comment">//   out &lt;&lt; std::endl;</span>
<a name="l00764"></a>00764 <span class="comment">// }</span>
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 
<a name="l00767"></a>00767 
<a name="l00768"></a><a class="code" href="classElem.php#a52f2b13c389f06b9a8e9d969ddf7ffe7">00768</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#a52f2b13c389f06b9a8e9d969ddf7ffe7">Elem::quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00769"></a>00769 <span class="keyword"></span>{
<a name="l00770"></a>00770   <span class="keywordflow">switch</span> (q)
<a name="l00771"></a>00771     {    
<a name="l00775"></a>00775     <span class="keywordflow">default</span>:
<a name="l00776"></a>00776       {
<a name="l00777"></a>00777         libmesh_here();
<a name="l00778"></a>00778 
<a name="l00779"></a>00779         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  unknown quality metric: &quot;</span>
<a name="l00780"></a>00780                   &lt;&lt; q 
<a name="l00781"></a>00781                   &lt;&lt; std::endl
<a name="l00782"></a>00782                   &lt;&lt; <span class="stringliteral">&quot;Cowardly returning 1.&quot;</span>
<a name="l00783"></a>00783                   &lt;&lt; std::endl;
<a name="l00784"></a>00784 
<a name="l00785"></a>00785         <span class="keywordflow">return</span> 1.;
<a name="l00786"></a>00786       }
<a name="l00787"></a>00787     }
<a name="l00788"></a>00788 
<a name="l00789"></a>00789     
<a name="l00790"></a>00790     <span class="comment">// Will never get here...</span>
<a name="l00791"></a>00791     libmesh_error();
<a name="l00792"></a>00792     <span class="keywordflow">return</span> 0.;
<a name="l00793"></a>00793 }
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 
<a name="l00796"></a>00796 
<a name="l00797"></a><a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">00797</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">Elem::ancestor</a>()<span class="keyword"> const</span>
<a name="l00798"></a>00798 <span class="keyword"></span>{
<a name="l00799"></a>00799 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00800"></a>00800 <span class="preprocessor"></span>
<a name="l00801"></a>00801   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00802"></a>00802     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>())
<a name="l00805"></a>00805     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00806"></a>00806   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(0)-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00807"></a>00807     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00808"></a>00808 
<a name="l00809"></a>00809   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(0)-&gt;<a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">ancestor</a>();
<a name="l00810"></a>00810 <span class="preprocessor">#else</span>
<a name="l00811"></a>00811 <span class="preprocessor"></span>  <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00812"></a>00812 <span class="preprocessor">#endif</span>
<a name="l00813"></a>00813 <span class="preprocessor"></span>}
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00818"></a>00818 <span class="preprocessor"></span>
<a name="l00819"></a><a class="code" href="classElem.php#a791ed16f88c661c7ed22e10e0cf8d8ff">00819</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a791ed16f88c661c7ed22e10e0cf8d8ff">Elem::add_child</a> (<a class="code" href="classElem.php">Elem</a>* elem)
<a name="l00820"></a>00820 {
<a name="l00821"></a>00821   <span class="keywordflow">if</span>(<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> == NULL)
<a name="l00822"></a>00822     {
<a name="l00823"></a>00823       <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> = <span class="keyword">new</span> <a class="code" href="classElem.php">Elem</a>*[this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>()];
<a name="l00824"></a>00824       
<a name="l00825"></a>00825       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00826"></a>00826         <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c] = NULL;
<a name="l00827"></a>00827     }
<a name="l00828"></a>00828   
<a name="l00829"></a>00829   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00830"></a>00830     {
<a name="l00831"></a>00831       <span class="keywordflow">if</span>(<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c] == NULL || <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c] == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00832"></a>00832         {
<a name="l00833"></a>00833           libmesh_assert (<span class="keyword">this</span> == elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>());
<a name="l00834"></a>00834           <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c] = elem;
<a name="l00835"></a>00835           <span class="keywordflow">return</span>;
<a name="l00836"></a>00836         }
<a name="l00837"></a>00837     }
<a name="l00838"></a>00838 
<a name="l00839"></a>00839   std::cerr &lt;&lt; <span class="stringliteral">&quot;Error: Tried to add a child to an element with full children array&quot;</span>
<a name="l00840"></a>00840             &lt;&lt; std::endl;
<a name="l00841"></a>00841   libmesh_error();
<a name="l00842"></a>00842 }
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 
<a name="l00846"></a><a class="code" href="classElem.php#a2fcea278ff61d6905eeabb1ad832c352">00846</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a791ed16f88c661c7ed22e10e0cf8d8ff">Elem::add_child</a> (<a class="code" href="classElem.php">Elem</a>* elem, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c)
<a name="l00847"></a>00847 {
<a name="l00848"></a>00848   <span class="keywordflow">if</span>(<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> == NULL)
<a name="l00849"></a>00849     {
<a name="l00850"></a>00850       <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a> = <span class="keyword">new</span> <a class="code" href="classElem.php">Elem</a>*[this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>()];
<a name="l00851"></a>00851       
<a name="l00852"></a>00852       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); i++)
<a name="l00853"></a>00853         <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[i] = NULL;
<a name="l00854"></a>00854     }
<a name="l00855"></a>00855   
<a name="l00856"></a>00856   libmesh_assert (<a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c] == NULL || <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c] == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l00857"></a>00857   libmesh_assert (<span class="keyword">this</span> == elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>());
<a name="l00858"></a>00858 
<a name="l00859"></a>00859   <a class="code" href="classElem.php#a13a9736ebb8911966797567a647aca81">_children</a>[c] = elem;
<a name="l00860"></a>00860 }
<a name="l00861"></a>00861 
<a name="l00862"></a>00862 
<a name="l00863"></a>00863 
<a name="l00864"></a><a class="code" href="classElem.php#a17cad0bd2ceef85bb9696c01d2b16802">00864</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#a17cad0bd2ceef85bb9696c01d2b16802">Elem::is_child_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00865"></a>00865                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00866"></a>00866 <span class="keyword"></span>{
<a name="l00867"></a>00867   libmesh_assert (c &lt; this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>());
<a name="l00868"></a>00868   libmesh_assert (e &lt; this-&gt;<a class="code" href="classElem.php#a99de950a1c73b7bcdd63fc2535bb8adf">n_edges</a>());
<a name="l00869"></a>00869 
<a name="l00870"></a>00870   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> my_edge = this-&gt;<a class="code" href="classElem.php#a53d7b548eddc81a770c6459264a07115">build_edge</a>(e);
<a name="l00871"></a>00871   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> child_edge = this-&gt;<a class="code" href="classElem.php#a53d7b548eddc81a770c6459264a07115">build_edge</a>(e);
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   <span class="comment">// We&#39;re assuming that an overlapping child edge has the same</span>
<a name="l00874"></a>00874   <span class="comment">// number and orientation as its parent</span>
<a name="l00875"></a>00875   <span class="keywordflow">return</span> (child_edge-&gt;node(0) == my_edge-&gt;node(0) ||
<a name="l00876"></a>00876       child_edge-&gt;node(1) == my_edge-&gt;node(1));
<a name="l00877"></a>00877 }
<a name="l00878"></a>00878 
<a name="l00879"></a>00879 
<a name="l00880"></a><a class="code" href="classElem.php#abafd34cacabfdf831cc86e781c211fa1">00880</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#abafd34cacabfdf831cc86e781c211fa1">Elem::family_tree</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00881"></a>00881                         <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l00882"></a>00882 <span class="keyword"></span>{
<a name="l00883"></a>00883   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l00884"></a>00884   libmesh_assert(!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l00885"></a>00885 
<a name="l00886"></a>00886   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l00887"></a>00887   <span class="keywordflow">if</span> (reset)
<a name="l00888"></a>00888     family.clear();
<a name="l00889"></a>00889 
<a name="l00890"></a>00890   <span class="comment">// Add this element to the family tree.</span>
<a name="l00891"></a>00891   family.push_back(<span class="keyword">this</span>);
<a name="l00892"></a>00892 
<a name="l00893"></a>00893   <span class="comment">// Recurse into the elements children, if it has them.</span>
<a name="l00894"></a>00894   <span class="comment">// Do not clear the vector any more.</span>
<a name="l00895"></a>00895   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00896"></a>00896     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00897"></a>00897       <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#a42551a956e815faffedd7a634c731bff">is_remote</a>())
<a name="l00898"></a>00898         this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#abafd34cacabfdf831cc86e781c211fa1">family_tree</a> (family, <span class="keyword">false</span>);
<a name="l00899"></a>00899 }
<a name="l00900"></a>00900 
<a name="l00901"></a>00901 
<a name="l00902"></a>00902 
<a name="l00903"></a><a class="code" href="classElem.php#a51ae47d8c3c024b8dc1098b9392a1161">00903</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a51ae47d8c3c024b8dc1098b9392a1161">Elem::active_family_tree</a> (std::vector&lt;const Elem*&gt;&amp; active_family,
<a name="l00904"></a>00904                                <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l00905"></a>00905 <span class="keyword"></span>{
<a name="l00906"></a>00906   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l00907"></a>00907   libmesh_assert(!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l00908"></a>00908 
<a name="l00909"></a>00909   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l00910"></a>00910   <span class="keywordflow">if</span> (reset)
<a name="l00911"></a>00911     active_family.clear();
<a name="l00912"></a>00912 
<a name="l00913"></a>00913   <span class="comment">// Add this element to the family tree if it is active</span>
<a name="l00914"></a>00914   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00915"></a>00915     active_family.push_back(<span class="keyword">this</span>);
<a name="l00916"></a>00916 
<a name="l00917"></a>00917   <span class="comment">// Otherwise recurse into the element&#39;s children.</span>
<a name="l00918"></a>00918   <span class="comment">// Do not clear the vector any more.</span>
<a name="l00919"></a>00919   <span class="keywordflow">else</span> 
<a name="l00920"></a>00920     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00921"></a>00921       <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#a42551a956e815faffedd7a634c731bff">is_remote</a>())
<a name="l00922"></a>00922         this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#a51ae47d8c3c024b8dc1098b9392a1161">active_family_tree</a> (active_family, <span class="keyword">false</span>);
<a name="l00923"></a>00923 }
<a name="l00924"></a>00924 
<a name="l00925"></a>00925 
<a name="l00926"></a>00926 
<a name="l00927"></a><a class="code" href="classElem.php#af8c9a0eda098174dfe1ee49901c229dd">00927</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#af8c9a0eda098174dfe1ee49901c229dd">Elem::family_tree_by_side</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00928"></a>00928                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00929"></a>00929                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword">  const</span>
<a name="l00930"></a>00930 <span class="keyword"></span>{
<a name="l00931"></a>00931   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l00932"></a>00932   libmesh_assert(!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l00933"></a>00933 
<a name="l00934"></a>00934   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l00935"></a>00935   <span class="keywordflow">if</span> (reset)
<a name="l00936"></a>00936     family.clear();
<a name="l00937"></a>00937 
<a name="l00938"></a>00938   libmesh_assert(s &lt; this-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>());
<a name="l00939"></a>00939 
<a name="l00940"></a>00940   <span class="comment">// Add this element to the family tree.</span>
<a name="l00941"></a>00941   family.push_back(<span class="keyword">this</span>);
<a name="l00942"></a>00942 
<a name="l00943"></a>00943   <span class="comment">// Recurse into the elements children, if it has them.</span>
<a name="l00944"></a>00944   <span class="comment">// Do not clear the vector any more.</span>
<a name="l00945"></a>00945   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00946"></a>00946     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00947"></a>00947       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#ad62bfc036a0b1303dad54d20e9fd86b6">is_child_on_side</a>(c, s))
<a name="l00948"></a>00948         this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#af8c9a0eda098174dfe1ee49901c229dd">family_tree_by_side</a> (family, s, <span class="keyword">false</span>);
<a name="l00949"></a>00949 
<a name="l00950"></a>00950 }
<a name="l00951"></a>00951 
<a name="l00952"></a>00952 
<a name="l00953"></a>00953 
<a name="l00954"></a><a class="code" href="classElem.php#a5c362d52b5c393691357633fb337ced0">00954</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a5c362d52b5c393691357633fb337ced0">Elem::active_family_tree_by_side</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00955"></a>00955                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00956"></a>00956                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l00957"></a>00957 <span class="keyword"></span>{
<a name="l00958"></a>00958   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l00959"></a>00959   libmesh_assert(!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l00960"></a>00960 
<a name="l00961"></a>00961   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l00962"></a>00962   <span class="keywordflow">if</span> (reset)
<a name="l00963"></a>00963     family.clear();
<a name="l00964"></a>00964 
<a name="l00965"></a>00965   libmesh_assert(s &lt; this-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>());
<a name="l00966"></a>00966 
<a name="l00967"></a>00967   <span class="comment">// Add an active element to the family tree.</span>
<a name="l00968"></a>00968   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00969"></a>00969     family.push_back(<span class="keyword">this</span>);
<a name="l00970"></a>00970 
<a name="l00971"></a>00971   <span class="comment">// Or recurse into an ancestor element&#39;s children.</span>
<a name="l00972"></a>00972   <span class="comment">// Do not clear the vector any more.</span>
<a name="l00973"></a>00973   <span class="keywordflow">else</span>
<a name="l00974"></a>00974     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l00975"></a>00975       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#ad62bfc036a0b1303dad54d20e9fd86b6">is_child_on_side</a>(c, s))
<a name="l00976"></a>00976         this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classElem.php#a5c362d52b5c393691357633fb337ced0">active_family_tree_by_side</a> (family, s, <span class="keyword">false</span>);
<a name="l00977"></a>00977 }
<a name="l00978"></a>00978 
<a name="l00979"></a>00979 
<a name="l00980"></a>00980 
<a name="l00981"></a><a class="code" href="classElem.php#a69eebe1336fd5446432172a7f30fcc97">00981</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a69eebe1336fd5446432172a7f30fcc97">Elem::family_tree_by_neighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l00982"></a>00982                                     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor,
<a name="l00983"></a>00983                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l00984"></a>00984 <span class="keyword"></span>{
<a name="l00985"></a>00985   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l00986"></a>00986   libmesh_assert(!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l00987"></a>00987 
<a name="l00988"></a>00988   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l00989"></a>00989   <span class="keywordflow">if</span> (reset)
<a name="l00990"></a>00990     family.clear();
<a name="l00991"></a>00991 
<a name="l00992"></a>00992   <span class="comment">// This only makes sense if we&#39;re already a neighbor</span>
<a name="l00993"></a>00993   libmesh_assert (this-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(neighbor));
<a name="l00994"></a>00994 
<a name="l00995"></a>00995   <span class="comment">// Add this element to the family tree.</span>
<a name="l00996"></a>00996   family.push_back(<span class="keyword">this</span>);
<a name="l00997"></a>00997 
<a name="l00998"></a>00998   <span class="comment">// Recurse into the elements children, if it&#39;s not active.</span>
<a name="l00999"></a>00999   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01000"></a>01000   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01001"></a>01001     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01002"></a>01002       {
<a name="l01003"></a>01003         <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01004"></a>01004         <span class="keywordflow">if</span> (child != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a> &amp;&amp; child-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(neighbor))
<a name="l01005"></a>01005           child-&gt;<a class="code" href="classElem.php#a69eebe1336fd5446432172a7f30fcc97">family_tree_by_neighbor</a> (family, neighbor, <span class="keyword">false</span>);
<a name="l01006"></a>01006       }
<a name="l01007"></a>01007 }
<a name="l01008"></a>01008 
<a name="l01009"></a>01009 
<a name="l01010"></a>01010 
<a name="l01011"></a><a class="code" href="classElem.php#ab4446eecc9b887765a7d47ddb009a875">01011</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#ab4446eecc9b887765a7d47ddb009a875">Elem::family_tree_by_subneighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l01012"></a>01012                                        <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor,
<a name="l01013"></a>01013                                        <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* subneighbor,
<a name="l01014"></a>01014                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l01015"></a>01015 <span class="keyword"></span>{
<a name="l01016"></a>01016   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l01017"></a>01017   libmesh_assert(!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l01018"></a>01018 
<a name="l01019"></a>01019   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l01020"></a>01020   <span class="keywordflow">if</span> (reset)
<a name="l01021"></a>01021     family.clear();
<a name="l01022"></a>01022 
<a name="l01023"></a>01023   <span class="comment">// To simplifly this function we need an existing neighbor</span>
<a name="l01024"></a>01024   libmesh_assert (neighbor);
<a name="l01025"></a>01025   libmesh_assert (neighbor != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l01026"></a>01026   libmesh_assert (this-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(neighbor));
<a name="l01027"></a>01027 
<a name="l01028"></a>01028   <span class="comment">// This only makes sense if subneighbor descends from neighbor</span>
<a name="l01029"></a>01029   libmesh_assert (subneighbor);
<a name="l01030"></a>01030   libmesh_assert (subneighbor != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>);
<a name="l01031"></a>01031   libmesh_assert (neighbor-&gt;<a class="code" href="classElem.php#aa7fc177516bf85923273fef18cad56bd">is_ancestor_of</a>(subneighbor));
<a name="l01032"></a>01032 
<a name="l01033"></a>01033   <span class="comment">// Add this element to the family tree if applicable.</span>
<a name="l01034"></a>01034   <span class="keywordflow">if</span> (neighbor == subneighbor)
<a name="l01035"></a>01035     family.push_back(<span class="keyword">this</span>);
<a name="l01036"></a>01036 
<a name="l01037"></a>01037   <span class="comment">// Recurse into the elements children, if it&#39;s not active.</span>
<a name="l01038"></a>01038   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01039"></a>01039   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01040"></a>01040     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); ++c)
<a name="l01041"></a>01041       {
<a name="l01042"></a>01042         <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01043"></a>01043         <span class="keywordflow">if</span> (child != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l01044"></a>01044           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s != child-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); ++s)
<a name="l01045"></a>01045             {
<a name="l01046"></a>01046               <a class="code" href="classElem.php">Elem</a> *child_neigh = child-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s);
<a name="l01047"></a>01047               <span class="keywordflow">if</span> (child_neigh &amp;&amp;
<a name="l01048"></a>01048                   (child_neigh == neighbor ||
<a name="l01049"></a>01049                    (child_neigh-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() == neighbor &amp;&amp;
<a name="l01050"></a>01050                     child_neigh-&gt;<a class="code" href="classElem.php#aa7fc177516bf85923273fef18cad56bd">is_ancestor_of</a>(subneighbor))))
<a name="l01051"></a>01051                 child-&gt;<a class="code" href="classElem.php#ab4446eecc9b887765a7d47ddb009a875">family_tree_by_subneighbor</a> (family, child_neigh,
<a name="l01052"></a>01052                                                    subneighbor, <span class="keyword">false</span>);
<a name="l01053"></a>01053             }
<a name="l01054"></a>01054       }
<a name="l01055"></a>01055 }
<a name="l01056"></a>01056 
<a name="l01057"></a>01057 
<a name="l01058"></a>01058 
<a name="l01059"></a><a class="code" href="classElem.php#a26ca00dd9c91f9f086d755eb3f58d4ff">01059</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a26ca00dd9c91f9f086d755eb3f58d4ff">Elem::active_family_tree_by_neighbor</a> (std::vector&lt;const Elem*&gt;&amp; family,
<a name="l01060"></a>01060                                            <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor,
<a name="l01061"></a>01061                                            <span class="keyword">const</span> <span class="keywordtype">bool</span> reset)<span class="keyword"> const</span>
<a name="l01062"></a>01062 <span class="keyword"></span>{
<a name="l01063"></a>01063   <span class="comment">// The &quot;family tree&quot; doesn&#39;t include subactive elements</span>
<a name="l01064"></a>01064   libmesh_assert(!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l01065"></a>01065 
<a name="l01066"></a>01066   <span class="comment">// Clear the vector if the flag reset tells us to.</span>
<a name="l01067"></a>01067   <span class="keywordflow">if</span> (reset)
<a name="l01068"></a>01068     family.clear();
<a name="l01069"></a>01069 
<a name="l01070"></a>01070   <span class="comment">// This only makes sense if we&#39;re already a neighbor</span>
<a name="l01071"></a>01071   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() &gt;= neighbor-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>())
<a name="l01072"></a>01072     libmesh_assert (this-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(neighbor));
<a name="l01073"></a>01073 
<a name="l01074"></a>01074   <span class="comment">// Add an active element to the family tree.</span>
<a name="l01075"></a>01075   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01076"></a>01076     family.push_back(<span class="keyword">this</span>);
<a name="l01077"></a>01077 
<a name="l01078"></a>01078   <span class="comment">// Or recurse into an ancestor element&#39;s children.</span>
<a name="l01079"></a>01079   <span class="comment">// Do not clear the vector any more.</span>
<a name="l01080"></a>01080   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01081"></a>01081     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01082"></a>01082       {
<a name="l01083"></a>01083         <a class="code" href="classElem.php">Elem</a> *<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01084"></a>01084         <span class="keywordflow">if</span> (child != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a> &amp;&amp; child-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(neighbor))
<a name="l01085"></a>01085           child-&gt;<a class="code" href="classElem.php#a26ca00dd9c91f9f086d755eb3f58d4ff">active_family_tree_by_neighbor</a> (family, neighbor, <span class="keyword">false</span>);
<a name="l01086"></a>01086       }
<a name="l01087"></a>01087 }
<a name="l01088"></a>01088 
<a name="l01089"></a>01089 
<a name="l01090"></a>01090 
<a name="l01091"></a><a class="code" href="classElem.php#af0de16afb3e685147942b802d0f57a14">01091</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#af0de16afb3e685147942b802d0f57a14">Elem::min_p_level_by_neighbor</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor,
<a name="l01092"></a>01092                                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_min)<span class="keyword"> const</span>
<a name="l01093"></a>01093 <span class="keyword"></span>{
<a name="l01094"></a>01094   libmesh_assert(!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l01095"></a>01095   libmesh_assert(neighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l01096"></a>01096 
<a name="l01097"></a>01097   <span class="comment">// If we&#39;re an active element this is simple</span>
<a name="l01098"></a>01098   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01099"></a>01099     <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(current_min, this-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l01100"></a>01100 
<a name="l01101"></a>01101   libmesh_assert(<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(neighbor));
<a name="l01102"></a>01102 
<a name="l01103"></a>01103   <span class="comment">// The p_level() of an ancestor element is already the minimum</span>
<a name="l01104"></a>01104   <span class="comment">// p_level() of its children - so if that&#39;s high enough, we don&#39;t</span>
<a name="l01105"></a>01105   <span class="comment">// need to examine any children.</span>
<a name="l01106"></a>01106   <span class="keywordflow">if</span> (current_min &lt;= this-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>())
<a name="l01107"></a>01107     <span class="keywordflow">return</span> current_min;
<a name="l01108"></a>01108 
<a name="l01109"></a>01109   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_p_level = current_min;
<a name="l01110"></a>01110 
<a name="l01111"></a>01111   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01112"></a>01112     {
<a name="l01113"></a>01113       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> <a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01114"></a>01114       <span class="keywordflow">if</span> (child != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a> &amp;&amp; child-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(neighbor))
<a name="l01115"></a>01115         min_p_level =
<a name="l01116"></a>01116           child-&gt;<a class="code" href="classElem.php#af0de16afb3e685147942b802d0f57a14">min_p_level_by_neighbor</a>(neighbor,
<a name="l01117"></a>01117                                          min_p_level);
<a name="l01118"></a>01118     }
<a name="l01119"></a>01119 
<a name="l01120"></a>01120   <span class="keywordflow">return</span> min_p_level;
<a name="l01121"></a>01121 }
<a name="l01122"></a>01122 
<a name="l01123"></a>01123 
<a name="l01124"></a><a class="code" href="classElem.php#a85d83dead47981e29ec191e0701e6147">01124</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a85d83dead47981e29ec191e0701e6147">Elem::min_new_p_level_by_neighbor</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor,
<a name="l01125"></a>01125                                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_min)<span class="keyword"> const</span>
<a name="l01126"></a>01126 <span class="keyword"></span>{
<a name="l01127"></a>01127   libmesh_assert(!this-&gt;<a class="code" href="classElem.php#ac7670d1bbe386a307b22d24d9bea0887">subactive</a>());
<a name="l01128"></a>01128   libmesh_assert(neighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l01129"></a>01129 
<a name="l01130"></a>01130   <span class="comment">// If we&#39;re an active element this is simple</span>
<a name="l01131"></a>01131   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01132"></a>01132     {
<a name="l01133"></a>01133       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_p_level = this-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l01134"></a>01134       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)
<a name="l01135"></a>01135         new_p_level += 1;
<a name="l01136"></a>01136       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l01137"></a>01137         {
<a name="l01138"></a>01138           libmesh_assert (new_p_level &gt; 0);
<a name="l01139"></a>01139           new_p_level -= 1;
<a name="l01140"></a>01140         }
<a name="l01141"></a>01141       <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(current_min, new_p_level);
<a name="l01142"></a>01142     }
<a name="l01143"></a>01143 
<a name="l01144"></a>01144   libmesh_assert(<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(neighbor));
<a name="l01145"></a>01145 
<a name="l01146"></a>01146   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_p_level = current_min;
<a name="l01147"></a>01147 
<a name="l01148"></a>01148   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01149"></a>01149     {
<a name="l01150"></a>01150       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> <a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a> = this-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01151"></a>01151       <span class="keywordflow">if</span> (child &amp;&amp; child != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l01152"></a>01152         <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(neighbor))
<a name="l01153"></a>01153           min_p_level =
<a name="l01154"></a>01154             child-&gt;<a class="code" href="classElem.php#a85d83dead47981e29ec191e0701e6147">min_new_p_level_by_neighbor</a>(neighbor,
<a name="l01155"></a>01155                                                min_p_level);
<a name="l01156"></a>01156     }
<a name="l01157"></a>01157 
<a name="l01158"></a>01158   <span class="keywordflow">return</span> min_p_level;
<a name="l01159"></a>01159 }
<a name="l01160"></a>01160 
<a name="l01161"></a>01161 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01162"></a>01162 <span class="preprocessor"></span>
<a name="l01163"></a>01163 
<a name="l01164"></a>01164 
<a name="l01165"></a><a class="code" href="classElem.php#ace5226376cf53804d20073a0d21b0cbc">01165</a> <span class="keywordtype">bool</span> <a class="code" href="classElem.php#ace5226376cf53804d20073a0d21b0cbc">Elem::contains_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l01166"></a>01166 <span class="keyword"></span>{
<a name="l01167"></a>01167   <span class="comment">// Declare a basic FEType.  Will ue a Lagrange</span>
<a name="l01168"></a>01168   <span class="comment">// element by default.</span>
<a name="l01169"></a>01169   <a class="code" href="classFEType.php">FEType</a> fe_type(this-&gt;<a class="code" href="classElem.php#a6cef8ca882c2fc1081fd27132851627a">default_order</a>());
<a name="l01170"></a>01170   
<a name="l01171"></a>01171   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> mapped_point = <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a>(this-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>(),
<a name="l01172"></a>01172                                                       fe_type,
<a name="l01173"></a>01173                                                       <span class="keyword">this</span>,
<a name="l01174"></a>01174                                                       p,
<a name="l01175"></a>01175                                                       1.e-4,
<a name="l01176"></a>01176                                                       <span class="keyword">false</span>);
<a name="l01177"></a>01177 
<a name="l01178"></a>01178   <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a74fa7b62c80d4740411a97560988211a">FEInterface::on_reference_element</a>(mapped_point, this-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l01179"></a>01179 }
<a name="l01180"></a>01180 
<a name="l01181"></a>01181 
<a name="l01182"></a>01182 
<a name="l01183"></a><a class="code" href="classElem.php#a0c6afe5c0a0f5b304bb3846098c30a85">01183</a> <span class="keywordtype">void</span> <a class="code" href="classElem.php#a0c6afe5c0a0f5b304bb3846098c30a85">Elem::nullify_neighbors</a> ()
<a name="l01184"></a>01184 {
<a name="l01185"></a>01185   <span class="comment">// Tell any of my neighbors about my death...</span>
<a name="l01186"></a>01186   <span class="comment">// Looks strange, huh?</span>
<a name="l01187"></a>01187   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); n++)
<a name="l01188"></a>01188     {
<a name="l01189"></a>01189       <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a> = this-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n);
<a name="l01190"></a>01190       <span class="keywordflow">if</span> (neighbor &amp;&amp; neighbor != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l01191"></a>01191         {
<a name="l01192"></a>01192           <span class="comment">// Note:  it is possible that I see the neighbor</span>
<a name="l01193"></a>01193           <span class="comment">// (which is coarser than me)</span>
<a name="l01194"></a>01194           <span class="comment">// but they don&#39;t see me, so avoid that case.</span>
<a name="l01195"></a>01195           <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == this-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>())
<a name="l01196"></a>01196             {   
<a name="l01197"></a>01197               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> w_n_a_i = neighbor-&gt;<a class="code" href="classElem.php#acab8fea073846b18b149ed2b88d43aff">which_neighbor_am_i</a>(<span class="keyword">this</span>);
<a name="l01198"></a>01198               libmesh_assert (w_n_a_i &lt; neighbor-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>());
<a name="l01199"></a>01199               neighbor-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(w_n_a_i, NULL);
<a name="l01200"></a>01200               this-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(n, NULL);
<a name="l01201"></a>01201             }
<a name="l01202"></a>01202         }
<a name="l01203"></a>01203     }
<a name="l01204"></a>01204 }
<a name="l01205"></a>01205 
<a name="l01206"></a>01206 
<a name="l01207"></a>01207 
<a name="l01208"></a>01208 
<a name="l01209"></a><a class="code" href="classElem.php#a9f073eee0a8cd4d87e72f0834b4b1815">01209</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a9f073eee0a8cd4d87e72f0834b4b1815">Elem::n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l01210"></a>01210 <span class="keyword"></span>{
<a name="l01211"></a>01211   <span class="comment">// for linear elements, always return 0</span>
<a name="l01212"></a>01212   <span class="keywordflow">return</span> 0;
<a name="l01213"></a>01213 }
<a name="l01214"></a>01214 
<a name="l01215"></a>01215 
<a name="l01216"></a>01216 
<a name="l01217"></a><a class="code" href="classElem.php#a51e4bd9931fa1378113784f76ac13d6a">01217</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classElem.php#a51e4bd9931fa1378113784f76ac13d6a">Elem::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l01218"></a>01218                                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l01219"></a>01219 <span class="keyword"></span>{
<a name="l01220"></a>01220   <span class="comment">// for linear elements, always return 0</span>
<a name="l01221"></a>01221   <span class="keywordflow">return</span> 0;
<a name="l01222"></a>01222 }
<a name="l01223"></a>01223 
<a name="l01224"></a>01224 
<a name="l01225"></a>01225 
<a name="l01226"></a>01226 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l01227"></a><a class="code" href="classElem.php#a82dfd0c1670e2718e6f5bd9485f45547">01227</a> <a class="code" href="classElem.php#a82dfd0c1670e2718e6f5bd9485f45547">Elem::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l01228"></a>01228 <span class="keyword"></span>{
<a name="l01229"></a>01229   <span class="comment">// for linear elements, always return 0</span>
<a name="l01230"></a>01230   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;(0,0);
<a name="l01231"></a>01231 }
<a name="l01232"></a>01232 
<a name="l01233"></a>01233 
<a name="l01234"></a>01234 
<a name="l01235"></a><a class="code" href="classElem.php#a58feb7c95394c30be3ef4d991d8bfc7e">01235</a> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classElem.php#a58feb7c95394c30be3ef4d991d8bfc7e">Elem::first_order_equivalent_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et)
<a name="l01236"></a>01236 { 
<a name="l01237"></a>01237   <span class="keywordflow">switch</span> (et)
<a name="l01238"></a>01238     {
<a name="l01239"></a>01239     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l01240"></a>01240     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l01241"></a>01241     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l01242"></a>01242       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>;
<a name="l01243"></a>01243     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l01244"></a>01244     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01245"></a>01245       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>;
<a name="l01246"></a>01246     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l01247"></a>01247     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01248"></a>01248     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01249"></a>01249       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>;
<a name="l01250"></a>01250     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l01251"></a>01251     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l01252"></a>01252       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>;
<a name="l01253"></a>01253     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l01254"></a>01254     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l01255"></a>01255     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l01256"></a>01256       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>;
<a name="l01257"></a>01257     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l01258"></a>01258     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l01259"></a>01259     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l01260"></a>01260       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>;
<a name="l01261"></a>01261 
<a name="l01262"></a>01262 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01263"></a>01263 <span class="preprocessor"></span>
<a name="l01264"></a>01264     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l01265"></a>01265     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l01266"></a>01266       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>;
<a name="l01267"></a>01267     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l01268"></a>01268     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l01269"></a>01269     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l01270"></a>01270       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>;
<a name="l01271"></a>01271     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l01272"></a>01272     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l01273"></a>01273       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>;
<a name="l01274"></a>01274 
<a name="l01275"></a>01275 <span class="preprocessor">#endif</span>
<a name="l01276"></a>01276 <span class="preprocessor"></span>
<a name="l01277"></a>01277     <span class="keywordflow">default</span>:
<a name="l01278"></a>01278       <span class="comment">// unknown element</span>
<a name="l01279"></a>01279       <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l01280"></a>01280     }
<a name="l01281"></a>01281 }
<a name="l01282"></a>01282 
<a name="l01283"></a>01283 
<a name="l01284"></a>01284 
<a name="l01285"></a><a class="code" href="classElem.php#a8d206442321a9b73bdbf58e72eb9e82b">01285</a> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classElem.php#a8d206442321a9b73bdbf58e72eb9e82b">Elem::second_order_equivalent_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et,
<a name="l01286"></a>01286                                              <span class="keyword">const</span> <span class="keywordtype">bool</span> full_ordered)
<a name="l01287"></a>01287 { 
<a name="l01288"></a>01288   <span class="comment">/* for second-order elements, always return \p INVALID_ELEM</span>
<a name="l01289"></a>01289 <span class="comment">   * since second-order elements should not be converted</span>
<a name="l01290"></a>01290 <span class="comment">   * into something else.  Only linear elements should </span>
<a name="l01291"></a>01291 <span class="comment">   * return something sensible here</span>
<a name="l01292"></a>01292 <span class="comment">   */</span>
<a name="l01293"></a>01293   <span class="keywordflow">switch</span> (et)
<a name="l01294"></a>01294     {
<a name="l01295"></a>01295     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l01296"></a>01296       {
<a name="l01297"></a>01297         <span class="comment">// full_ordered not relevant</span>
<a name="l01298"></a>01298         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>;
<a name="l01299"></a>01299       }
<a name="l01300"></a>01300 
<a name="l01301"></a>01301     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l01302"></a>01302       {
<a name="l01303"></a>01303         <span class="comment">// full_ordered not relevant</span>
<a name="l01304"></a>01304         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>;
<a name="l01305"></a>01305       }
<a name="l01306"></a>01306 
<a name="l01307"></a>01307     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l01308"></a>01308       {
<a name="l01309"></a>01309         <span class="keywordflow">if</span> (full_ordered)
<a name="l01310"></a>01310           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>;
<a name="l01311"></a>01311         <span class="keywordflow">else</span> 
<a name="l01312"></a>01312           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>;
<a name="l01313"></a>01313       }
<a name="l01314"></a>01314 
<a name="l01315"></a>01315     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l01316"></a>01316       {
<a name="l01317"></a>01317         <span class="comment">// full_ordered not relevant</span>
<a name="l01318"></a>01318         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>;
<a name="l01319"></a>01319       }
<a name="l01320"></a>01320 
<a name="l01321"></a>01321     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l01322"></a>01322       {
<a name="l01323"></a>01323         <span class="comment">// see below how this correlates with INFHEX8</span>
<a name="l01324"></a>01324         <span class="keywordflow">if</span> (full_ordered)
<a name="l01325"></a>01325           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>;
<a name="l01326"></a>01326         <span class="keywordflow">else</span> 
<a name="l01327"></a>01327           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>;
<a name="l01328"></a>01328       }
<a name="l01329"></a>01329 
<a name="l01330"></a>01330     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l01331"></a>01331       {
<a name="l01332"></a>01332         <span class="keywordflow">if</span> (full_ordered)
<a name="l01333"></a>01333           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>;
<a name="l01334"></a>01334         <span class="keywordflow">else</span> 
<a name="l01335"></a>01335           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>;
<a name="l01336"></a>01336       }
<a name="l01337"></a>01337 
<a name="l01338"></a>01338     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l01339"></a>01339       {
<a name="l01340"></a>01340         <span class="comment">// libmesh_error(); </span>
<a name="l01341"></a>01341         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l01342"></a>01342       }
<a name="l01343"></a>01343 
<a name="l01344"></a>01344 
<a name="l01345"></a>01345 
<a name="l01346"></a>01346 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01347"></a>01347 <span class="preprocessor"></span>
<a name="l01348"></a>01348     <span class="comment">// infinite elements</span>
<a name="l01349"></a>01349     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l01350"></a>01350       {
<a name="l01351"></a>01351         <span class="comment">// libmesh_error(); </span>
<a name="l01352"></a>01352         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l01353"></a>01353       }
<a name="l01354"></a>01354 
<a name="l01355"></a>01355     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l01356"></a>01356       {
<a name="l01357"></a>01357         <span class="comment">// full_ordered not relevant</span>
<a name="l01358"></a>01358         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>;
<a name="l01359"></a>01359       }
<a name="l01360"></a>01360 
<a name="l01361"></a>01361     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l01362"></a>01362       {
<a name="l01363"></a>01363         <span class="comment">/*</span>
<a name="l01364"></a>01364 <span class="comment">         * Note that this matches with \p Hex8:</span>
<a name="l01365"></a>01365 <span class="comment">         * For full-ordered, \p InfHex18 and \p Hex27</span>
<a name="l01366"></a>01366 <span class="comment">         * belong together, and for not full-ordered,</span>
<a name="l01367"></a>01367 <span class="comment">         * \p InfHex16 and \p Hex20 belong together.</span>
<a name="l01368"></a>01368 <span class="comment">         */</span>
<a name="l01369"></a>01369         <span class="keywordflow">if</span> (full_ordered)
<a name="l01370"></a>01370           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>;
<a name="l01371"></a>01371         <span class="keywordflow">else</span> 
<a name="l01372"></a>01372           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>;
<a name="l01373"></a>01373       }
<a name="l01374"></a>01374 
<a name="l01375"></a>01375     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l01376"></a>01376       {
<a name="l01377"></a>01377         <span class="comment">// full_ordered not relevant</span>
<a name="l01378"></a>01378         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>;
<a name="l01379"></a>01379       }
<a name="l01380"></a>01380 
<a name="l01381"></a>01381 <span class="preprocessor">#endif</span>
<a name="l01382"></a>01382 <span class="preprocessor"></span>
<a name="l01383"></a>01383 
<a name="l01384"></a>01384     <span class="keywordflow">default</span>:
<a name="l01385"></a>01385       {
<a name="l01386"></a>01386         <span class="comment">// second-order element</span>
<a name="l01387"></a>01387         <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l01388"></a>01388       }
<a name="l01389"></a>01389     }
<a name="l01390"></a>01390 }
<a name="l01391"></a>01391 
<a name="l01392"></a>01392 
<a name="l01393"></a>01393 
<a name="l01394"></a><a class="code" href="classElem.php#abaf5f7c64e723cb6e83ee2b710c6e76a">01394</a> Elem::side_iterator <a class="code" href="classElem.php#abaf5f7c64e723cb6e83ee2b710c6e76a">Elem::boundary_sides_begin</a>()
<a name="l01395"></a>01395 {
<a name="l01396"></a>01396   <a class="code" href="structPredicates_1_1BoundarySide.php">Predicates::BoundarySide&lt;SideIter&gt;</a> bsp;
<a name="l01397"></a>01397   <span class="keywordflow">return</span> side_iterator(this-&gt;<a class="code" href="classElem.php#ad956038473223519d323d3cb50d92622">_first_side</a>(), this-&gt;<a class="code" href="classElem.php#a4616bd8795259ad31ffe346a2abbb8df">_last_side</a>(), bsp);
<a name="l01398"></a>01398 }
<a name="l01399"></a>01399 
<a name="l01400"></a>01400 
<a name="l01401"></a>01401 
<a name="l01402"></a>01402 
<a name="l01403"></a><a class="code" href="classElem.php#a7448c298c2f8c4fce6348039e923fc91">01403</a> Elem::side_iterator <a class="code" href="classElem.php#a7448c298c2f8c4fce6348039e923fc91">Elem::boundary_sides_end</a>()
<a name="l01404"></a>01404 {
<a name="l01405"></a>01405   <a class="code" href="structPredicates_1_1BoundarySide.php">Predicates::BoundarySide&lt;SideIter&gt;</a> bsp;
<a name="l01406"></a>01406   <span class="keywordflow">return</span> side_iterator(this-&gt;<a class="code" href="classElem.php#a4616bd8795259ad31ffe346a2abbb8df">_last_side</a>(), this-&gt;<a class="code" href="classElem.php#a4616bd8795259ad31ffe346a2abbb8df">_last_side</a>(), bsp);
<a name="l01407"></a>01407 }
<a name="l01408"></a>01408 
<a name="l01409"></a>01409 
<a name="l01410"></a>01410 
<a name="l01411"></a>01411 
<a name="l01412"></a><a class="code" href="classElem.php#a685f1f6f6fa337eda690b115e66858f4">01412</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classElem.php#a685f1f6f6fa337eda690b115e66858f4">Elem::volume</a> ()<span class="keyword"> const</span>
<a name="l01413"></a>01413 <span class="keyword"></span>{
<a name="l01414"></a>01414   <span class="comment">// The default implementation builds a finite element of the correct</span>
<a name="l01415"></a>01415   <span class="comment">// order and sums up the JxW contributions.  This can be expensive,</span>
<a name="l01416"></a>01416   <span class="comment">// so the various element types can overload this method and compute</span>
<a name="l01417"></a>01417   <span class="comment">// the volume more efficiently.</span>
<a name="l01418"></a>01418   <a class="code" href="classFEType.php">FEType</a> fe_type (this-&gt;<a class="code" href="classElem.php#a6cef8ca882c2fc1081fd27132851627a">default_order</a>() , <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>);
<a name="l01419"></a>01419 
<a name="l01420"></a>01420   <a class="code" href="classAutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classFEBase.php#a3e86219b79ce4f881e9c48f4fd7b860e">FEBase::build</a>(this-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>(),
<a name="l01421"></a>01421                                     fe_type));
<a name="l01422"></a>01422 
<a name="l01423"></a>01423    <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; JxW = fe-&gt;get_JxW();
<a name="l01424"></a>01424    
<a name="l01425"></a>01425   <span class="comment">// The default quadrature rule should integrate the mass matrix,</span>
<a name="l01426"></a>01426   <span class="comment">// thus it should be plenty to compute the area</span>
<a name="l01427"></a>01427   <a class="code" href="classQGauss.php">QGauss</a> qrule (this-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>(), fe_type.<a class="code" href="classFEType.php#a523905bbc072eaa4664c6c1434a0c4e4">default_quadrature_order</a>());
<a name="l01428"></a>01428 
<a name="l01429"></a>01429   fe-&gt;attach_quadrature_rule(&amp;qrule);
<a name="l01430"></a>01430 
<a name="l01431"></a>01431   fe-&gt;reinit(<span class="keyword">this</span>);
<a name="l01432"></a>01432 
<a name="l01433"></a>01433   <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> vol=0.;
<a name="l01434"></a>01434   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;qrule.n_points(); ++qp)
<a name="l01435"></a>01435     vol += JxW[qp];
<a name="l01436"></a>01436   
<a name="l01437"></a>01437   <span class="keywordflow">return</span> vol;
<a name="l01438"></a>01438   
<a name="l01439"></a>01439 }
<a name="l01440"></a>01440 
<a name="l01441"></a>01441 
<a name="l01442"></a>01442 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01443"></a>01443 <span class="comment">// Elem::PackedElem static data</span>
<a name="l01444"></a>01444 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Elem::PackedElem::header_size = 10;
<a name="l01445"></a>01445 
<a name="l01446"></a>01446 
<a name="l01447"></a>01447 <span class="comment">// Elem::PackedElem member funcions</span>
<a name="l01448"></a>01448 <span class="keywordtype">void</span> Elem::PackedElem::pack (std::vector&lt;int&gt; &amp;conn, <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)
<a name="l01449"></a>01449 {
<a name="l01450"></a>01450   libmesh_assert (elem != NULL);
<a name="l01451"></a>01451   
<a name="l01452"></a>01452   <span class="comment">// we can do at least this good. note that hopefully in general</span>
<a name="l01453"></a>01453   <span class="comment">// the user will already have reserved the full space, which will render</span>
<a name="l01454"></a>01454   <span class="comment">// this redundant</span>
<a name="l01455"></a>01455   conn.reserve (conn.size() + Elem::PackedElem::header_size + elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>());
<a name="l01456"></a>01456 
<a name="l01457"></a>01457 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01458"></a>01458 <span class="preprocessor"></span>  conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>()));
<a name="l01459"></a>01459   conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>()));
<a name="l01460"></a>01460   conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()));
<a name="l01461"></a>01461   conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>()));
<a name="l01462"></a>01462 <span class="preprocessor">#else</span>
<a name="l01463"></a>01463 <span class="preprocessor"></span>  conn.push_back (0);
<a name="l01464"></a>01464   conn.push_back (0);
<a name="l01465"></a>01465   conn.push_back (0);
<a name="l01466"></a>01466   conn.push_back (0);
<a name="l01467"></a>01467 <span class="preprocessor">#endif</span>
<a name="l01468"></a>01468 <span class="preprocessor"></span>  conn.push_back (static_cast&lt;int&gt;(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()));
<a name="l01469"></a>01469   conn.push_back (elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>());
<a name="l01470"></a>01470   conn.push_back (elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>());
<a name="l01471"></a>01471   conn.push_back (elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l01472"></a>01472                 
<a name="l01473"></a>01473 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01474"></a>01474 <span class="preprocessor"></span>  <span class="comment">// use parent_ID of -1 to indicate a level 0 element</span>
<a name="l01475"></a>01475   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == 0)
<a name="l01476"></a>01476     {
<a name="l01477"></a>01477       conn.push_back(-1);
<a name="l01478"></a>01478       conn.push_back(-1);
<a name="l01479"></a>01479     }
<a name="l01480"></a>01480   <span class="keywordflow">else</span>
<a name="l01481"></a>01481     {
<a name="l01482"></a>01482       conn.push_back(elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>());
<a name="l01483"></a>01483       conn.push_back(elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a72cd45e535e8bebac68a57a362a60fef">which_child_am_i</a>(elem));
<a name="l01484"></a>01484     }
<a name="l01485"></a>01485 <span class="preprocessor">#else</span>
<a name="l01486"></a>01486 <span class="preprocessor"></span>  conn.push_back (-1);
<a name="l01487"></a>01487   conn.push_back (-1);
<a name="l01488"></a>01488 <span class="preprocessor">#endif</span>
<a name="l01489"></a>01489 <span class="preprocessor"></span>  
<a name="l01490"></a>01490   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l01491"></a>01491     conn.push_back (elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n));             
<a name="l01492"></a>01492 }
<a name="l01493"></a>01493 
<a name="l01494"></a>01494 
<a name="l01495"></a>01495 
<a name="l01496"></a>01496 <a class="code" href="classElem.php">Elem</a> * Elem::PackedElem::unpack (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh, <a class="code" href="classElem.php">Elem</a> *parent)<span class="keyword"> const</span>
<a name="l01497"></a>01497 <span class="keyword"></span>{  
<a name="l01498"></a>01498   
<a name="l01499"></a>01499   <a class="code" href="classElem.php">Elem</a> *elem = <a class="code" href="classElem.php#a7f46524fbd44a76f940435d6a1434a9d">Elem::build</a>(this-&gt;type(),parent).release();
<a name="l01500"></a>01500   libmesh_assert (elem);
<a name="l01501"></a>01501 
<a name="l01502"></a>01502 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01503"></a>01503 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;level() != 0) 
<a name="l01504"></a>01504     {
<a name="l01505"></a>01505       libmesh_assert (parent != NULL);
<a name="l01506"></a>01506       parent-&gt;<a class="code" href="classElem.php#a791ed16f88c661c7ed22e10e0cf8d8ff">add_child</a>(elem, this-&gt;which_child_am_i());
<a name="l01507"></a>01507       libmesh_assert (parent-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>() == elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l01508"></a>01508       libmesh_assert (parent-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(this-&gt;which_child_am_i()) == elem);
<a name="l01509"></a>01509     }
<a name="l01510"></a>01510 <span class="preprocessor">#endif</span>
<a name="l01511"></a>01511 <span class="preprocessor"></span>
<a name="l01512"></a>01512   <span class="comment">// Assign the IDs</span>
<a name="l01513"></a>01513 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01514"></a>01514 <span class="preprocessor"></span>  elem-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(this-&gt;p_level());
<a name="l01515"></a>01515   elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(this-&gt;refinement_flag());
<a name="l01516"></a>01516   elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(this-&gt;p_refinement_flag());
<a name="l01517"></a>01517   libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == this-&gt;level());
<a name="l01518"></a>01518 <span class="preprocessor">#endif</span>
<a name="l01519"></a>01519 <span class="preprocessor"></span>  elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>() = this-&gt;subdomain_id();
<a name="l01520"></a>01520   elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = this-&gt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>();
<a name="l01521"></a>01521   elem-&gt;<a class="code" href="classDofObject.php#a4cfb417ba0d1aaf992be36797d2cb7d3">set_id</a>()       = this-&gt;id();
<a name="l01522"></a>01522   
<a name="l01523"></a>01523   <span class="comment">// Assign the connectivity</span>
<a name="l01524"></a>01524   libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>() == this-&gt;<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>());
<a name="l01525"></a>01525 
<a name="l01526"></a>01526   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l01527"></a>01527     elem-&gt;<a class="code" href="classElem.php#a135cbd216d30a1abaa52e43f4abe7329">set_node</a>(n) = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a> (this-&gt;node(n));
<a name="l01528"></a>01528   
<a name="l01529"></a>01529   <span class="keywordflow">return</span> elem;
<a name="l01530"></a>01530 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
