<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_a0136eca6b184c0d854bbc4a8414e31c.php">fe</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>fe_interface.C</h1>  </div>
</div>
<div class="contents">
<a href="fe__interface_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_interface.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;fe_interface.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;fe.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;fe_compute_data.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;dof_map.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">//------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">//FEInterface class members</span>
<a name="l00031"></a><a class="code" href="classFEInterface.php#a0620c253d47b7c31bf29948d0374833b">00031</a> <a class="code" href="classFEInterface.php#a0620c253d47b7c31bf29948d0374833b">FEInterface::FEInterface</a>()
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Do not define an object of this type.&quot;</span> 
<a name="l00034"></a>00034             &lt;&lt; std::endl;
<a name="l00035"></a>00035   libmesh_error();
<a name="l00036"></a>00036 }
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">00041</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FEInterface::n_shape_functions</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00042"></a>00042                                             <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00043"></a>00043                                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>  <span class="comment">/*</span>
<a name="l00048"></a>00048 <span class="comment">   * Since the FEType, stored in DofMap/(some System child), has to</span>
<a name="l00049"></a>00049 <span class="comment">   * be the _same_ for InfFE and FE, we have to catch calls</span>
<a name="l00050"></a>00050 <span class="comment">   * to infinite elements through the element type.</span>
<a name="l00051"></a>00051 <span class="comment">   */</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(t) )
<a name="l00054"></a>00054     <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5cc4efdc035c4e9f625bc58737458426">ifem_n_shape_functions</a>(dim, fe_t, t);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o = fe_t.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00059"></a>00059   
<a name="l00060"></a>00060   <span class="keywordflow">switch</span> (dim)
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062       <span class="comment">// 1D</span>
<a name="l00063"></a>00063     <span class="keywordflow">case</span> 1:
<a name="l00064"></a>00064       {
<a name="l00065"></a>00065         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00066"></a>00066           {
<a name="l00067"></a>00067           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00068"></a>00068             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;1,CLOUGH&gt;::n_shape_functions</a>(t, o);
<a name="l00069"></a>00069             
<a name="l00070"></a>00070           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00071"></a>00071             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;1,HERMITE&gt;::n_shape_functions</a>(t, o);
<a name="l00072"></a>00072             
<a name="l00073"></a>00073           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00074"></a>00074             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;1,HIERARCHIC&gt;::n_shape_functions</a>(t, o);
<a name="l00075"></a>00075             
<a name="l00076"></a>00076           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00077"></a>00077             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;1,LAGRANGE&gt;::n_shape_functions</a>(t, o);
<a name="l00078"></a>00078             
<a name="l00079"></a>00079           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00080"></a>00080             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;1,MONOMIAL&gt;::n_shape_functions</a>(t, o);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00083"></a>00083             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;1,SCALAR&gt;::n_shape_functions</a>(t, o);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>
<a name="l00087"></a>00087           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00088"></a>00088             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;1,BERNSTEIN&gt;::n_shape_functions</a>(t, o);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00091"></a>00091             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;1,SZABAB&gt;::n_shape_functions</a>(t, o);
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="preprocessor">#endif</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span>            
<a name="l00095"></a>00095           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00096"></a>00096             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FEXYZ&lt;1&gt;::n_shape_functions</a>(t, o);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099           <span class="keywordflow">default</span>:
<a name="l00100"></a>00100             libmesh_error();
<a name="l00101"></a>00101           }
<a name="l00102"></a>00102       }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104       
<a name="l00105"></a>00105       <span class="comment">// 2D</span>
<a name="l00106"></a>00106     <span class="keywordflow">case</span> 2:
<a name="l00107"></a>00107       {
<a name="l00108"></a>00108         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00109"></a>00109           {
<a name="l00110"></a>00110           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00111"></a>00111             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;2,CLOUGH&gt;::n_shape_functions</a>(t, o);
<a name="l00112"></a>00112             
<a name="l00113"></a>00113           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00114"></a>00114             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;2,HERMITE&gt;::n_shape_functions</a>(t, o);
<a name="l00115"></a>00115             
<a name="l00116"></a>00116           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00117"></a>00117             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;2,HIERARCHIC&gt;::n_shape_functions</a>(t, o);
<a name="l00118"></a>00118             
<a name="l00119"></a>00119           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00120"></a>00120             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;2,LAGRANGE&gt;::n_shape_functions</a>(t, o);
<a name="l00121"></a>00121             
<a name="l00122"></a>00122           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00123"></a>00123             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;2,MONOMIAL&gt;::n_shape_functions</a>(t, o);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00126"></a>00126             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;2,SCALAR&gt;::n_shape_functions</a>(t, o);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00130"></a>00130           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00131"></a>00131             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;2,BERNSTEIN&gt;::n_shape_functions</a>(t, o);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00134"></a>00134             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;2,SZABAB&gt;::n_shape_functions</a>(t, o);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="preprocessor">#endif</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>            
<a name="l00138"></a>00138           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00139"></a>00139             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FEXYZ&lt;2&gt;::n_shape_functions</a>(t, o);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141           <span class="keywordflow">default</span>:
<a name="l00142"></a>00142             libmesh_error();
<a name="l00143"></a>00143           }
<a name="l00144"></a>00144       }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146       
<a name="l00147"></a>00147       <span class="comment">// 3D</span>
<a name="l00148"></a>00148     <span class="keywordflow">case</span> 3:
<a name="l00149"></a>00149       {
<a name="l00150"></a>00150         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00151"></a>00151           {
<a name="l00152"></a>00152           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00153"></a>00153             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;3,HERMITE&gt;::n_shape_functions</a>(t, o);
<a name="l00154"></a>00154             
<a name="l00155"></a>00155           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00156"></a>00156             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;3,HIERARCHIC&gt;::n_shape_functions</a>(t, o);
<a name="l00157"></a>00157             
<a name="l00158"></a>00158           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00159"></a>00159             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;3,LAGRANGE&gt;::n_shape_functions</a>(t, o);
<a name="l00160"></a>00160             
<a name="l00161"></a>00161           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00162"></a>00162             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;3,MONOMIAL&gt;::n_shape_functions</a>(t, o);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00165"></a>00165             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;3,SCALAR&gt;::n_shape_functions</a>(t, o);
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>
<a name="l00169"></a>00169           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00170"></a>00170             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;3,BERNSTEIN&gt;::n_shape_functions</a>(t, o);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00173"></a>00173             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FE&lt;3,SZABAB&gt;::n_shape_functions</a>(t, o);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="preprocessor">#endif</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>            
<a name="l00177"></a>00177           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00178"></a>00178             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#ad495fdff07716533173790be2032a475">FEXYZ&lt;3&gt;::n_shape_functions</a>(t, o);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180           <span class="keywordflow">default</span>:
<a name="l00181"></a>00181             libmesh_error();
<a name="l00182"></a>00182           }
<a name="l00183"></a>00183       }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186     <span class="keywordflow">default</span>:
<a name="l00187"></a>00187       libmesh_error();
<a name="l00188"></a>00188     }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   
<a name="l00191"></a>00191   libmesh_error();
<a name="l00192"></a>00192   <span class="keywordflow">return</span> 0;
<a name="l00193"></a>00193 }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">00199</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FEInterface::n_dofs</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00200"></a>00200                                  <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00201"></a>00201                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00202"></a>00202 {
<a name="l00203"></a>00203 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span>
<a name="l00205"></a>00205   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(t) )
<a name="l00206"></a>00206     <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a166e8bf05290d5d849a8c1c03a25b649">ifem_n_dofs</a>(dim, fe_t, t);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 <span class="preprocessor">#endif</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>
<a name="l00210"></a>00210   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o = fe_t.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="keywordflow">switch</span> (dim)
<a name="l00213"></a>00213     {
<a name="l00214"></a>00214       <span class="comment">// 1D</span>
<a name="l00215"></a>00215     <span class="keywordflow">case</span> 1:
<a name="l00216"></a>00216       {
<a name="l00217"></a>00217         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00218"></a>00218           {
<a name="l00219"></a>00219           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00220"></a>00220             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;1,CLOUGH&gt;::n_dofs</a>(t, o);
<a name="l00221"></a>00221             
<a name="l00222"></a>00222           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00223"></a>00223             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;1,HERMITE&gt;::n_dofs</a>(t, o);
<a name="l00224"></a>00224             
<a name="l00225"></a>00225           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00226"></a>00226             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;1,HIERARCHIC&gt;::n_dofs</a>(t, o);
<a name="l00227"></a>00227             
<a name="l00228"></a>00228           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00229"></a>00229             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;1,LAGRANGE&gt;::n_dofs</a>(t, o);
<a name="l00230"></a>00230             
<a name="l00231"></a>00231           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00232"></a>00232             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;1,MONOMIAL&gt;::n_dofs</a>(t, o);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00235"></a>00235             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;1,SCALAR&gt;::n_dofs</a>(t, o);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00238"></a>00238 <span class="preprocessor"></span>
<a name="l00239"></a>00239           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00240"></a>00240             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;1,BERNSTEIN&gt;::n_dofs</a>(t, o);
<a name="l00241"></a>00241 
<a name="l00242"></a>00242           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00243"></a>00243             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;1,SZABAB&gt;::n_dofs</a>(t, o);
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 <span class="preprocessor">#endif</span>
<a name="l00246"></a>00246 <span class="preprocessor"></span>            
<a name="l00247"></a>00247           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00248"></a>00248             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FEXYZ&lt;1&gt;::n_dofs</a>(t, o);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250           <span class="keywordflow">default</span>:
<a name="l00251"></a>00251             libmesh_error();
<a name="l00252"></a>00252           }
<a name="l00253"></a>00253       }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255       
<a name="l00256"></a>00256       <span class="comment">// 2D</span>
<a name="l00257"></a>00257     <span class="keywordflow">case</span> 2:
<a name="l00258"></a>00258       {
<a name="l00259"></a>00259         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00260"></a>00260           {
<a name="l00261"></a>00261           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00262"></a>00262             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;2,CLOUGH&gt;::n_dofs</a>(t, o);
<a name="l00263"></a>00263             
<a name="l00264"></a>00264           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00265"></a>00265             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;2,HERMITE&gt;::n_dofs</a>(t, o);
<a name="l00266"></a>00266             
<a name="l00267"></a>00267           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00268"></a>00268             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;2,HIERARCHIC&gt;::n_dofs</a>(t, o);
<a name="l00269"></a>00269             
<a name="l00270"></a>00270           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00271"></a>00271             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;2,LAGRANGE&gt;::n_dofs</a>(t, o);
<a name="l00272"></a>00272             
<a name="l00273"></a>00273           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00274"></a>00274             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;2,MONOMIAL&gt;::n_dofs</a>(t, o);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00277"></a>00277             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;2,SCALAR&gt;::n_dofs</a>(t, o);
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00280"></a>00280 <span class="preprocessor"></span>
<a name="l00281"></a>00281           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00282"></a>00282             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;2,BERNSTEIN&gt;::n_dofs</a>(t, o);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00285"></a>00285             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;2,SZABAB&gt;::n_dofs</a>(t, o);
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 <span class="preprocessor">#endif</span>
<a name="l00288"></a>00288 <span class="preprocessor"></span>            
<a name="l00289"></a>00289           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00290"></a>00290             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FEXYZ&lt;2&gt;::n_dofs</a>(t, o);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292           <span class="keywordflow">default</span>:
<a name="l00293"></a>00293             libmesh_error();
<a name="l00294"></a>00294           }
<a name="l00295"></a>00295       }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297       
<a name="l00298"></a>00298       <span class="comment">// 3D</span>
<a name="l00299"></a>00299     <span class="keywordflow">case</span> 3:
<a name="l00300"></a>00300       {
<a name="l00301"></a>00301         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00302"></a>00302           {
<a name="l00303"></a>00303           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00304"></a>00304             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;3,HERMITE&gt;::n_dofs</a>(t, o);
<a name="l00305"></a>00305             
<a name="l00306"></a>00306           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00307"></a>00307             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;3,HIERARCHIC&gt;::n_dofs</a>(t, o);
<a name="l00308"></a>00308             
<a name="l00309"></a>00309           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00310"></a>00310             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;3,LAGRANGE&gt;::n_dofs</a>(t, o);
<a name="l00311"></a>00311             
<a name="l00312"></a>00312           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00313"></a>00313             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;3,MONOMIAL&gt;::n_dofs</a>(t, o);
<a name="l00314"></a>00314 
<a name="l00315"></a>00315           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00316"></a>00316             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;3,SCALAR&gt;::n_dofs</a>(t, o);
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00319"></a>00319 <span class="preprocessor"></span>
<a name="l00320"></a>00320           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00321"></a>00321             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;3,BERNSTEIN&gt;::n_dofs</a>(t, o);
<a name="l00322"></a>00322 
<a name="l00323"></a>00323           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00324"></a>00324             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FE&lt;3,SZABAB&gt;::n_dofs</a>(t, o);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 <span class="preprocessor">#endif</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span>            
<a name="l00328"></a>00328           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00329"></a>00329             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">FEXYZ&lt;3&gt;::n_dofs</a>(t, o);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331           <span class="keywordflow">default</span>:
<a name="l00332"></a>00332             libmesh_error();
<a name="l00333"></a>00333           }
<a name="l00334"></a>00334       }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337     <span class="keywordflow">default</span>:
<a name="l00338"></a>00338       libmesh_error();
<a name="l00339"></a>00339     }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   
<a name="l00342"></a>00342   libmesh_error();
<a name="l00343"></a>00343   <span class="keywordflow">return</span> 0;
<a name="l00344"></a>00344 }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346                 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a><a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">00349</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FEInterface::n_dofs_at_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00350"></a>00350                                          <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00351"></a>00351                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00352"></a>00352                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00353"></a>00353 {
<a name="l00354"></a>00354 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00355"></a>00355 <span class="preprocessor"></span>
<a name="l00356"></a>00356   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(t) )
<a name="l00357"></a>00357     <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a54eeef852b5494748e19b264541b0146">ifem_n_dofs_at_node</a>(dim, fe_t, t, n);
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 <span class="preprocessor">#endif</span>
<a name="l00360"></a>00360 <span class="preprocessor"></span>
<a name="l00361"></a>00361   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o = fe_t.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00362"></a>00362   
<a name="l00363"></a>00363   <span class="keywordflow">switch</span> (dim)
<a name="l00364"></a>00364     {
<a name="l00365"></a>00365       <span class="comment">// 1D</span>
<a name="l00366"></a>00366     <span class="keywordflow">case</span> 1:
<a name="l00367"></a>00367       {
<a name="l00368"></a>00368         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00369"></a>00369           {
<a name="l00370"></a>00370           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00371"></a>00371             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;1,CLOUGH&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00372"></a>00372             
<a name="l00373"></a>00373           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00374"></a>00374             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;1,HERMITE&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00375"></a>00375             
<a name="l00376"></a>00376           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00377"></a>00377             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;1,HIERARCHIC&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00378"></a>00378             
<a name="l00379"></a>00379           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00380"></a>00380             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;1,LAGRANGE&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00381"></a>00381             
<a name="l00382"></a>00382           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00383"></a>00383             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;1,MONOMIAL&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00384"></a>00384 
<a name="l00385"></a>00385           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00386"></a>00386             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;1,SCALAR&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00389"></a>00389 <span class="preprocessor"></span>
<a name="l00390"></a>00390           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00391"></a>00391             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;1,BERNSTEIN&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00392"></a>00392 
<a name="l00393"></a>00393           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00394"></a>00394             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;1,SZABAB&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 <span class="preprocessor">#endif</span>
<a name="l00397"></a>00397 <span class="preprocessor"></span>            
<a name="l00398"></a>00398           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00399"></a>00399             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FEXYZ&lt;1&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00400"></a>00400 
<a name="l00401"></a>00401           <span class="keywordflow">default</span>:
<a name="l00402"></a>00402             libmesh_error();
<a name="l00403"></a>00403           }
<a name="l00404"></a>00404       }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406       
<a name="l00407"></a>00407       <span class="comment">// 2D</span>
<a name="l00408"></a>00408     <span class="keywordflow">case</span> 2:
<a name="l00409"></a>00409       {
<a name="l00410"></a>00410         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00411"></a>00411           {
<a name="l00412"></a>00412           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00413"></a>00413             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;2,CLOUGH&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00414"></a>00414             
<a name="l00415"></a>00415           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00416"></a>00416             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;2,HERMITE&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00417"></a>00417             
<a name="l00418"></a>00418           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00419"></a>00419             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;2,HIERARCHIC&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00420"></a>00420             
<a name="l00421"></a>00421           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00422"></a>00422             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;2,LAGRANGE&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00423"></a>00423             
<a name="l00424"></a>00424           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00425"></a>00425             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;2,MONOMIAL&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00426"></a>00426 
<a name="l00427"></a>00427           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00428"></a>00428             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;2,SCALAR&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00431"></a>00431 <span class="preprocessor"></span>
<a name="l00432"></a>00432           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00433"></a>00433             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;2,BERNSTEIN&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00434"></a>00434 
<a name="l00435"></a>00435           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00436"></a>00436             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;2,SZABAB&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 <span class="preprocessor">#endif</span>
<a name="l00439"></a>00439 <span class="preprocessor"></span>            
<a name="l00440"></a>00440           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00441"></a>00441             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FEXYZ&lt;2&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00442"></a>00442 
<a name="l00443"></a>00443           <span class="keywordflow">default</span>:
<a name="l00444"></a>00444             libmesh_error();
<a name="l00445"></a>00445           }
<a name="l00446"></a>00446       }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448       
<a name="l00449"></a>00449       <span class="comment">// 3D</span>
<a name="l00450"></a>00450     <span class="keywordflow">case</span> 3:
<a name="l00451"></a>00451       {
<a name="l00452"></a>00452         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00453"></a>00453           {
<a name="l00454"></a>00454           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00455"></a>00455             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;3,HERMITE&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00456"></a>00456             
<a name="l00457"></a>00457           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00458"></a>00458             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;3,HIERARCHIC&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00459"></a>00459             
<a name="l00460"></a>00460           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00461"></a>00461             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;3,LAGRANGE&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00462"></a>00462             
<a name="l00463"></a>00463           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00464"></a>00464             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;3,MONOMIAL&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00465"></a>00465 
<a name="l00466"></a>00466           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00467"></a>00467             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;3,SCALAR&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00470"></a>00470 <span class="preprocessor"></span>
<a name="l00471"></a>00471           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00472"></a>00472             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;3,BERNSTEIN&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00473"></a>00473 
<a name="l00474"></a>00474           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00475"></a>00475             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FE&lt;3,SZABAB&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 <span class="preprocessor">#endif</span>
<a name="l00478"></a>00478 <span class="preprocessor"></span>            
<a name="l00479"></a>00479           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00480"></a>00480             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a67e0d0d4c13c51f66c65ae9c2c4114c4">FEXYZ&lt;3&gt;::n_dofs_at_node</a>(t, o, n);
<a name="l00481"></a>00481 
<a name="l00482"></a>00482           <span class="keywordflow">default</span>:
<a name="l00483"></a>00483             libmesh_error();
<a name="l00484"></a>00484           }
<a name="l00485"></a>00485       }
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488     <span class="keywordflow">default</span>:
<a name="l00489"></a>00489       libmesh_error();
<a name="l00490"></a>00490     }
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   
<a name="l00493"></a>00493   libmesh_error();
<a name="l00494"></a>00494   <span class="keywordflow">return</span> 0;
<a name="l00495"></a>00495 }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a><a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">00501</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FEInterface::n_dofs_per_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00502"></a>00502                                           <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00503"></a>00503                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00504"></a>00504 {
<a name="l00505"></a>00505 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00506"></a>00506 <span class="preprocessor"></span>
<a name="l00507"></a>00507   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(t) )
<a name="l00508"></a>00508     <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#abafd644a74d292ae1ad395312f2553eb">ifem_n_dofs_per_elem</a>(dim, fe_t, t);
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 <span class="preprocessor">#endif</span>
<a name="l00511"></a>00511 <span class="preprocessor"></span>
<a name="l00512"></a>00512   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o = fe_t.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00513"></a>00513 
<a name="l00514"></a>00514   <span class="keywordflow">switch</span> (dim)
<a name="l00515"></a>00515     {
<a name="l00516"></a>00516       <span class="comment">// 1D</span>
<a name="l00517"></a>00517     <span class="keywordflow">case</span> 1:
<a name="l00518"></a>00518       {
<a name="l00519"></a>00519         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00520"></a>00520           {
<a name="l00521"></a>00521           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00522"></a>00522             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;1,CLOUGH&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00523"></a>00523             
<a name="l00524"></a>00524           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00525"></a>00525             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;1,HERMITE&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00526"></a>00526             
<a name="l00527"></a>00527           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00528"></a>00528             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;1,HIERARCHIC&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00529"></a>00529             
<a name="l00530"></a>00530           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00531"></a>00531             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;1,LAGRANGE&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00532"></a>00532             
<a name="l00533"></a>00533           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00534"></a>00534             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;1,MONOMIAL&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00535"></a>00535 
<a name="l00536"></a>00536           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00537"></a>00537             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;1,SCALAR&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00540"></a>00540 <span class="preprocessor"></span>
<a name="l00541"></a>00541           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00542"></a>00542             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;1,BERNSTEIN&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00543"></a>00543 
<a name="l00544"></a>00544           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00545"></a>00545             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;1,SZABAB&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 <span class="preprocessor">#endif</span>
<a name="l00548"></a>00548 <span class="preprocessor"></span>            
<a name="l00549"></a>00549           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00550"></a>00550             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FEXYZ&lt;1&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00551"></a>00551 
<a name="l00552"></a>00552           <span class="keywordflow">default</span>:
<a name="l00553"></a>00553             libmesh_error();
<a name="l00554"></a>00554           }
<a name="l00555"></a>00555       }
<a name="l00556"></a>00556 
<a name="l00557"></a>00557       
<a name="l00558"></a>00558       <span class="comment">// 2D</span>
<a name="l00559"></a>00559     <span class="keywordflow">case</span> 2:
<a name="l00560"></a>00560       {
<a name="l00561"></a>00561         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00562"></a>00562           {
<a name="l00563"></a>00563           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00564"></a>00564             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;2,CLOUGH&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00565"></a>00565             
<a name="l00566"></a>00566           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00567"></a>00567             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;2,HERMITE&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00568"></a>00568             
<a name="l00569"></a>00569           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00570"></a>00570             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;2,HIERARCHIC&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00571"></a>00571             
<a name="l00572"></a>00572           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00573"></a>00573             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;2,LAGRANGE&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00574"></a>00574             
<a name="l00575"></a>00575           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00576"></a>00576             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;2,MONOMIAL&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00577"></a>00577 
<a name="l00578"></a>00578           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00579"></a>00579             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;2,SCALAR&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00582"></a>00582 <span class="preprocessor"></span>
<a name="l00583"></a>00583           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00584"></a>00584             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;2,BERNSTEIN&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00585"></a>00585 
<a name="l00586"></a>00586           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00587"></a>00587             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;2,SZABAB&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 <span class="preprocessor">#endif</span>
<a name="l00590"></a>00590 <span class="preprocessor"></span>            
<a name="l00591"></a>00591           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00592"></a>00592             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FEXYZ&lt;2&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00593"></a>00593 
<a name="l00594"></a>00594           <span class="keywordflow">default</span>:
<a name="l00595"></a>00595             libmesh_error();
<a name="l00596"></a>00596           }
<a name="l00597"></a>00597       }
<a name="l00598"></a>00598 
<a name="l00599"></a>00599       
<a name="l00600"></a>00600       <span class="comment">// 3D</span>
<a name="l00601"></a>00601     <span class="keywordflow">case</span> 3:
<a name="l00602"></a>00602       {
<a name="l00603"></a>00603         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00604"></a>00604           {
<a name="l00605"></a>00605           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00606"></a>00606             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;3,HERMITE&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00607"></a>00607             
<a name="l00608"></a>00608           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00609"></a>00609             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;3,HIERARCHIC&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00610"></a>00610             
<a name="l00611"></a>00611           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00612"></a>00612             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;3,LAGRANGE&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00613"></a>00613             
<a name="l00614"></a>00614           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00615"></a>00615             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;3,MONOMIAL&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00616"></a>00616 
<a name="l00617"></a>00617           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00618"></a>00618             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;3,SCALAR&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00621"></a>00621 <span class="preprocessor"></span>
<a name="l00622"></a>00622           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00623"></a>00623             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;3,BERNSTEIN&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00624"></a>00624 
<a name="l00625"></a>00625           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00626"></a>00626             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FE&lt;3,SZABAB&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00627"></a>00627 
<a name="l00628"></a>00628 <span class="preprocessor">#endif</span>
<a name="l00629"></a>00629 <span class="preprocessor"></span>            
<a name="l00630"></a>00630           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00631"></a>00631             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#af3b7b306ff86eb750b9f5a3c2d807045">FEXYZ&lt;3&gt;::n_dofs_per_elem</a>(t, o);
<a name="l00632"></a>00632 
<a name="l00633"></a>00633           <span class="keywordflow">default</span>:
<a name="l00634"></a>00634             libmesh_error();
<a name="l00635"></a>00635           }
<a name="l00636"></a>00636       }
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 
<a name="l00639"></a>00639     <span class="keywordflow">default</span>:
<a name="l00640"></a>00640       libmesh_error();
<a name="l00641"></a>00641     }
<a name="l00642"></a>00642 
<a name="l00643"></a>00643   
<a name="l00644"></a>00644   libmesh_error();
<a name="l00645"></a>00645   <span class="keywordflow">return</span> 0;
<a name="l00646"></a>00646 }
<a name="l00647"></a>00647 
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 
<a name="l00651"></a><a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">00651</a> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FEInterface::dofs_on_side</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00652"></a>00652                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00653"></a>00653                                <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00654"></a>00654                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00655"></a>00655                                std::vector&lt;unsigned int&gt;&amp; di)
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o = fe_t.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00658"></a>00658 
<a name="l00659"></a>00659   <span class="keywordflow">switch</span> (dim)
<a name="l00660"></a>00660     {
<a name="l00661"></a>00661       <span class="comment">// 1D</span>
<a name="l00662"></a>00662     <span class="keywordflow">case</span> 1:
<a name="l00663"></a>00663       {
<a name="l00664"></a>00664         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00665"></a>00665           {
<a name="l00666"></a>00666           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00667"></a>00667             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;1,CLOUGH&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00668"></a>00668             <span class="keywordflow">return</span>;
<a name="l00669"></a>00669             
<a name="l00670"></a>00670           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00671"></a>00671             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;1,HERMITE&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00672"></a>00672             <span class="keywordflow">return</span>;
<a name="l00673"></a>00673             
<a name="l00674"></a>00674           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00675"></a>00675             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;1,HIERARCHIC&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00676"></a>00676             <span class="keywordflow">return</span>;
<a name="l00677"></a>00677             
<a name="l00678"></a>00678           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00679"></a>00679             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;1,LAGRANGE&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00680"></a>00680             <span class="keywordflow">return</span>;
<a name="l00681"></a>00681             
<a name="l00682"></a>00682           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00683"></a>00683             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;1,MONOMIAL&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00684"></a>00684             <span class="keywordflow">return</span>;
<a name="l00685"></a>00685 
<a name="l00686"></a>00686           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00687"></a>00687             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;1,SCALAR&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00688"></a>00688             <span class="keywordflow">return</span>;
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00691"></a>00691 <span class="preprocessor"></span>
<a name="l00692"></a>00692           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00693"></a>00693             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;1,BERNSTEIN&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00694"></a>00694             <span class="keywordflow">return</span>;
<a name="l00695"></a>00695 
<a name="l00696"></a>00696           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00697"></a>00697             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;1,SZABAB&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00698"></a>00698             <span class="keywordflow">return</span>;
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 <span class="preprocessor">#endif</span>
<a name="l00701"></a>00701 <span class="preprocessor"></span>            
<a name="l00702"></a>00702           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00703"></a>00703             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FEXYZ&lt;1&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00704"></a>00704             <span class="keywordflow">return</span>;
<a name="l00705"></a>00705 
<a name="l00706"></a>00706           <span class="keywordflow">default</span>:
<a name="l00707"></a>00707             libmesh_error();
<a name="l00708"></a>00708           }
<a name="l00709"></a>00709       }
<a name="l00710"></a>00710 
<a name="l00711"></a>00711       
<a name="l00712"></a>00712       <span class="comment">// 2D</span>
<a name="l00713"></a>00713     <span class="keywordflow">case</span> 2:
<a name="l00714"></a>00714       {
<a name="l00715"></a>00715         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00716"></a>00716           {
<a name="l00717"></a>00717           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00718"></a>00718             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;2,CLOUGH&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00719"></a>00719             <span class="keywordflow">return</span>;
<a name="l00720"></a>00720             
<a name="l00721"></a>00721           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00722"></a>00722             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;2,HERMITE&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00723"></a>00723             <span class="keywordflow">return</span>;
<a name="l00724"></a>00724             
<a name="l00725"></a>00725           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00726"></a>00726             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;2,HIERARCHIC&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00727"></a>00727             <span class="keywordflow">return</span>;
<a name="l00728"></a>00728             
<a name="l00729"></a>00729           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00730"></a>00730             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;2,LAGRANGE&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00731"></a>00731             <span class="keywordflow">return</span>;
<a name="l00732"></a>00732             
<a name="l00733"></a>00733           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00734"></a>00734             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;2,MONOMIAL&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00735"></a>00735             <span class="keywordflow">return</span>;
<a name="l00736"></a>00736 
<a name="l00737"></a>00737           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00738"></a>00738             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;2,SCALAR&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00739"></a>00739             <span class="keywordflow">return</span>;
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00742"></a>00742 <span class="preprocessor"></span>
<a name="l00743"></a>00743           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00744"></a>00744             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;2,BERNSTEIN&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00745"></a>00745             <span class="keywordflow">return</span>;
<a name="l00746"></a>00746 
<a name="l00747"></a>00747           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00748"></a>00748             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;2,SZABAB&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00749"></a>00749             <span class="keywordflow">return</span>;
<a name="l00750"></a>00750 
<a name="l00751"></a>00751 <span class="preprocessor">#endif</span>
<a name="l00752"></a>00752 <span class="preprocessor"></span>            
<a name="l00753"></a>00753           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00754"></a>00754             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FEXYZ&lt;2&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00755"></a>00755             <span class="keywordflow">return</span>;
<a name="l00756"></a>00756 
<a name="l00757"></a>00757           <span class="keywordflow">default</span>:
<a name="l00758"></a>00758             libmesh_error();
<a name="l00759"></a>00759           }
<a name="l00760"></a>00760       }
<a name="l00761"></a>00761 
<a name="l00762"></a>00762       
<a name="l00763"></a>00763       <span class="comment">// 3D</span>
<a name="l00764"></a>00764     <span class="keywordflow">case</span> 3:
<a name="l00765"></a>00765       {
<a name="l00766"></a>00766         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00767"></a>00767           {
<a name="l00768"></a>00768           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00769"></a>00769             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;3,HERMITE&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00770"></a>00770             <span class="keywordflow">return</span>;
<a name="l00771"></a>00771             
<a name="l00772"></a>00772           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00773"></a>00773             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;3,HIERARCHIC&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00774"></a>00774             <span class="keywordflow">return</span>;
<a name="l00775"></a>00775             
<a name="l00776"></a>00776           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00777"></a>00777             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;3,LAGRANGE&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00778"></a>00778             <span class="keywordflow">return</span>;
<a name="l00779"></a>00779             
<a name="l00780"></a>00780           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00781"></a>00781             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;3,MONOMIAL&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00782"></a>00782             <span class="keywordflow">return</span>;
<a name="l00783"></a>00783 
<a name="l00784"></a>00784           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00785"></a>00785             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;3,SCALAR&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00786"></a>00786             <span class="keywordflow">return</span>;
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00789"></a>00789 <span class="preprocessor"></span>
<a name="l00790"></a>00790           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00791"></a>00791             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;3,BERNSTEIN&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00792"></a>00792             <span class="keywordflow">return</span>;
<a name="l00793"></a>00793 
<a name="l00794"></a>00794           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00795"></a>00795             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FE&lt;3,SZABAB&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00796"></a>00796             <span class="keywordflow">return</span>;
<a name="l00797"></a>00797 
<a name="l00798"></a>00798 <span class="preprocessor">#endif</span>
<a name="l00799"></a>00799 <span class="preprocessor"></span>            
<a name="l00800"></a>00800           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00801"></a>00801             <a class="code" href="classFEInterface.php#a77321807cfe526cea01a21fc6287bc0e">FEXYZ&lt;3&gt;::dofs_on_side</a>(elem, o, s, di);
<a name="l00802"></a>00802             <span class="keywordflow">return</span>;
<a name="l00803"></a>00803 
<a name="l00804"></a>00804           <span class="keywordflow">default</span>:
<a name="l00805"></a>00805             libmesh_error();
<a name="l00806"></a>00806           }
<a name="l00807"></a>00807       }
<a name="l00808"></a>00808 
<a name="l00809"></a>00809 
<a name="l00810"></a>00810     <span class="keywordflow">default</span>:
<a name="l00811"></a>00811       libmesh_error();
<a name="l00812"></a>00812     }
<a name="l00813"></a>00813 
<a name="l00814"></a>00814   libmesh_error();
<a name="l00815"></a>00815 }
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 
<a name="l00818"></a>00818 
<a name="l00819"></a><a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">00819</a> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FEInterface::dofs_on_edge</a>(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00820"></a>00820                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00821"></a>00821                                <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00822"></a>00822                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00823"></a>00823                                std::vector&lt;unsigned int&gt;&amp; di)
<a name="l00824"></a>00824 {
<a name="l00825"></a>00825   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o = fe_t.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l00826"></a>00826 
<a name="l00827"></a>00827   <span class="keywordflow">switch</span> (dim)
<a name="l00828"></a>00828     {
<a name="l00829"></a>00829       <span class="comment">// 1D</span>
<a name="l00830"></a>00830     <span class="keywordflow">case</span> 1:
<a name="l00831"></a>00831       {
<a name="l00832"></a>00832         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00833"></a>00833           {
<a name="l00834"></a>00834           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00835"></a>00835             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;1,CLOUGH&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00836"></a>00836             <span class="keywordflow">return</span>;
<a name="l00837"></a>00837             
<a name="l00838"></a>00838           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00839"></a>00839             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;1,HERMITE&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00840"></a>00840             <span class="keywordflow">return</span>;
<a name="l00841"></a>00841             
<a name="l00842"></a>00842           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00843"></a>00843             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;1,HIERARCHIC&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00844"></a>00844             <span class="keywordflow">return</span>;
<a name="l00845"></a>00845             
<a name="l00846"></a>00846           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00847"></a>00847             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;1,LAGRANGE&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00848"></a>00848             <span class="keywordflow">return</span>;
<a name="l00849"></a>00849             
<a name="l00850"></a>00850           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00851"></a>00851             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;1,MONOMIAL&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00852"></a>00852             <span class="keywordflow">return</span>;
<a name="l00853"></a>00853 
<a name="l00854"></a>00854           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00855"></a>00855             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;1,SCALAR&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00856"></a>00856             <span class="keywordflow">return</span>;
<a name="l00857"></a>00857 
<a name="l00858"></a>00858 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00859"></a>00859 <span class="preprocessor"></span>
<a name="l00860"></a>00860           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00861"></a>00861             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;1,BERNSTEIN&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00862"></a>00862             <span class="keywordflow">return</span>;
<a name="l00863"></a>00863 
<a name="l00864"></a>00864           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00865"></a>00865             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;1,SZABAB&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00866"></a>00866             <span class="keywordflow">return</span>;
<a name="l00867"></a>00867 
<a name="l00868"></a>00868 <span class="preprocessor">#endif</span>
<a name="l00869"></a>00869 <span class="preprocessor"></span>            
<a name="l00870"></a>00870           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00871"></a>00871             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FEXYZ&lt;1&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00872"></a>00872             <span class="keywordflow">return</span>;
<a name="l00873"></a>00873 
<a name="l00874"></a>00874           <span class="keywordflow">default</span>:
<a name="l00875"></a>00875             libmesh_error();
<a name="l00876"></a>00876           }
<a name="l00877"></a>00877       }
<a name="l00878"></a>00878 
<a name="l00879"></a>00879       
<a name="l00880"></a>00880       <span class="comment">// 2D</span>
<a name="l00881"></a>00881     <span class="keywordflow">case</span> 2:
<a name="l00882"></a>00882       {
<a name="l00883"></a>00883         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00884"></a>00884           {
<a name="l00885"></a>00885           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l00886"></a>00886             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;2,CLOUGH&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00887"></a>00887             <span class="keywordflow">return</span>;
<a name="l00888"></a>00888             
<a name="l00889"></a>00889           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00890"></a>00890             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;2,HERMITE&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00891"></a>00891             <span class="keywordflow">return</span>;
<a name="l00892"></a>00892             
<a name="l00893"></a>00893           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00894"></a>00894             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;2,HIERARCHIC&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00895"></a>00895             <span class="keywordflow">return</span>;
<a name="l00896"></a>00896             
<a name="l00897"></a>00897           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00898"></a>00898             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;2,LAGRANGE&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00899"></a>00899             <span class="keywordflow">return</span>;
<a name="l00900"></a>00900             
<a name="l00901"></a>00901           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00902"></a>00902             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;2,MONOMIAL&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00903"></a>00903             <span class="keywordflow">return</span>;
<a name="l00904"></a>00904 
<a name="l00905"></a>00905           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00906"></a>00906             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;2,SCALAR&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00907"></a>00907             <span class="keywordflow">return</span>;
<a name="l00908"></a>00908 
<a name="l00909"></a>00909 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00910"></a>00910 <span class="preprocessor"></span>
<a name="l00911"></a>00911           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00912"></a>00912             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;2,BERNSTEIN&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00913"></a>00913             <span class="keywordflow">return</span>;
<a name="l00914"></a>00914 
<a name="l00915"></a>00915           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00916"></a>00916             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;2,SZABAB&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00917"></a>00917             <span class="keywordflow">return</span>;
<a name="l00918"></a>00918 
<a name="l00919"></a>00919 <span class="preprocessor">#endif</span>
<a name="l00920"></a>00920 <span class="preprocessor"></span>            
<a name="l00921"></a>00921           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00922"></a>00922             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FEXYZ&lt;2&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00923"></a>00923             <span class="keywordflow">return</span>;
<a name="l00924"></a>00924 
<a name="l00925"></a>00925           <span class="keywordflow">default</span>:
<a name="l00926"></a>00926             libmesh_error();
<a name="l00927"></a>00927           }
<a name="l00928"></a>00928       }
<a name="l00929"></a>00929 
<a name="l00930"></a>00930       
<a name="l00931"></a>00931       <span class="comment">// 3D</span>
<a name="l00932"></a>00932     <span class="keywordflow">case</span> 3:
<a name="l00933"></a>00933       {
<a name="l00934"></a>00934         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l00935"></a>00935           {
<a name="l00936"></a>00936           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l00937"></a>00937             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;3,HERMITE&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00938"></a>00938             <span class="keywordflow">return</span>;
<a name="l00939"></a>00939             
<a name="l00940"></a>00940           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l00941"></a>00941             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;3,HIERARCHIC&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00942"></a>00942             <span class="keywordflow">return</span>;
<a name="l00943"></a>00943             
<a name="l00944"></a>00944           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00945"></a>00945             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;3,LAGRANGE&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00946"></a>00946             <span class="keywordflow">return</span>;
<a name="l00947"></a>00947             
<a name="l00948"></a>00948           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l00949"></a>00949             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;3,MONOMIAL&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00950"></a>00950             <span class="keywordflow">return</span>;
<a name="l00951"></a>00951 
<a name="l00952"></a>00952           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l00953"></a>00953             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;3,SCALAR&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00954"></a>00954             <span class="keywordflow">return</span>;
<a name="l00955"></a>00955 
<a name="l00956"></a>00956 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00957"></a>00957 <span class="preprocessor"></span>
<a name="l00958"></a>00958           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l00959"></a>00959             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;3,BERNSTEIN&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00960"></a>00960             <span class="keywordflow">return</span>;
<a name="l00961"></a>00961 
<a name="l00962"></a>00962           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l00963"></a>00963             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FE&lt;3,SZABAB&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00964"></a>00964             <span class="keywordflow">return</span>;
<a name="l00965"></a>00965 
<a name="l00966"></a>00966 <span class="preprocessor">#endif</span>
<a name="l00967"></a>00967 <span class="preprocessor"></span>            
<a name="l00968"></a>00968           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l00969"></a>00969             <a class="code" href="classFEInterface.php#a20c729989abb1c730f48949f13289ef5">FEXYZ&lt;3&gt;::dofs_on_edge</a>(elem, o, e, di);
<a name="l00970"></a>00970             <span class="keywordflow">return</span>;
<a name="l00971"></a>00971 
<a name="l00972"></a>00972           <span class="keywordflow">default</span>:
<a name="l00973"></a>00973             libmesh_error();
<a name="l00974"></a>00974           }
<a name="l00975"></a>00975       }
<a name="l00976"></a>00976 
<a name="l00977"></a>00977 
<a name="l00978"></a>00978     <span class="keywordflow">default</span>:
<a name="l00979"></a>00979       libmesh_error();
<a name="l00980"></a>00980     }
<a name="l00981"></a>00981 
<a name="l00982"></a>00982   libmesh_error();
<a name="l00983"></a>00983 }
<a name="l00984"></a>00984 
<a name="l00985"></a>00985 
<a name="l00986"></a>00986 
<a name="l00987"></a>00987 
<a name="l00988"></a><a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">00988</a> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEInterface::nodal_soln</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00989"></a>00989                              <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l00990"></a>00990                              <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l00991"></a>00991                              <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00992"></a>00992                              std::vector&lt;Number&gt;&amp;       nodal_soln)
<a name="l00993"></a>00993 {
<a name="l00994"></a>00994 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00995"></a>00995 <span class="preprocessor"></span>
<a name="l00996"></a>00996   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()) )
<a name="l00997"></a>00997   {
<a name="l00998"></a>00998     <a class="code" href="classFEInterface.php#a66e3fbb5ddd660f7f1c0c62ed31446f0">ifem_nodal_soln</a>(dim, fe_t, elem, elem_soln, nodal_soln);
<a name="l00999"></a>00999     <span class="keywordflow">return</span>;
<a name="l01000"></a>01000   }
<a name="l01001"></a>01001 
<a name="l01002"></a>01002 <span class="preprocessor">#endif</span>
<a name="l01003"></a>01003 <span class="preprocessor"></span>
<a name="l01004"></a>01004   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order = fe_t.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l01005"></a>01005   
<a name="l01006"></a>01006   <span class="keywordflow">switch</span> (dim)
<a name="l01007"></a>01007     {
<a name="l01008"></a>01008       <span class="comment">// 1D</span>
<a name="l01009"></a>01009     <span class="keywordflow">case</span> 1:
<a name="l01010"></a>01010       {
<a name="l01011"></a>01011         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01012"></a>01012           {
<a name="l01013"></a>01013           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01014"></a>01014             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;1,CLOUGH&gt;::nodal_soln</a>(elem, order,
<a name="l01015"></a>01015                                      elem_soln, nodal_soln);
<a name="l01016"></a>01016             <span class="keywordflow">return</span>;
<a name="l01017"></a>01017             
<a name="l01018"></a>01018           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01019"></a>01019             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;1,HERMITE&gt;::nodal_soln</a>(elem, order,
<a name="l01020"></a>01020                                      elem_soln, nodal_soln);
<a name="l01021"></a>01021             <span class="keywordflow">return</span>;
<a name="l01022"></a>01022             
<a name="l01023"></a>01023           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01024"></a>01024             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;1,HIERARCHIC&gt;::nodal_soln</a>(elem, order,
<a name="l01025"></a>01025                                          elem_soln, nodal_soln);
<a name="l01026"></a>01026             <span class="keywordflow">return</span>;
<a name="l01027"></a>01027 
<a name="l01028"></a>01028           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01029"></a>01029             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;1,LAGRANGE&gt;::nodal_soln</a>(elem, order,
<a name="l01030"></a>01030                                        elem_soln, nodal_soln);
<a name="l01031"></a>01031             <span class="keywordflow">return</span>;
<a name="l01032"></a>01032    
<a name="l01033"></a>01033           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01034"></a>01034             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;1,MONOMIAL&gt;::nodal_soln</a>(elem, order,
<a name="l01035"></a>01035                                        elem_soln, nodal_soln);
<a name="l01036"></a>01036             <span class="keywordflow">return</span>;
<a name="l01037"></a>01037 
<a name="l01038"></a>01038           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01039"></a>01039             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;1,SCALAR&gt;::nodal_soln</a>(elem, order,
<a name="l01040"></a>01040                                        elem_soln, nodal_soln);
<a name="l01041"></a>01041             <span class="keywordflow">return</span>;
<a name="l01042"></a>01042 
<a name="l01043"></a>01043 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01044"></a>01044 <span class="preprocessor"></span>
<a name="l01045"></a>01045           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01046"></a>01046             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;1,BERNSTEIN&gt;::nodal_soln</a>(elem, order,
<a name="l01047"></a>01047                                      elem_soln, nodal_soln);
<a name="l01048"></a>01048             <span class="keywordflow">return</span>;
<a name="l01049"></a>01049 
<a name="l01050"></a>01050           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01051"></a>01051             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;1,SZABAB&gt;::nodal_soln</a>(elem, order,
<a name="l01052"></a>01052                                      elem_soln, nodal_soln);
<a name="l01053"></a>01053             <span class="keywordflow">return</span>;
<a name="l01054"></a>01054 
<a name="l01055"></a>01055 <span class="preprocessor">#endif</span>
<a name="l01056"></a>01056 <span class="preprocessor"></span>
<a name="l01057"></a>01057           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01058"></a>01058             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEXYZ&lt;1&gt;::nodal_soln</a>(elem, order,
<a name="l01059"></a>01059                                  elem_soln, nodal_soln);
<a name="l01060"></a>01060             <span class="keywordflow">return</span>;
<a name="l01061"></a>01061 
<a name="l01062"></a>01062           <span class="keywordflow">default</span>:
<a name="l01063"></a>01063             libmesh_error();
<a name="l01064"></a>01064           }
<a name="l01065"></a>01065       }
<a name="l01066"></a>01066 
<a name="l01067"></a>01067       
<a name="l01068"></a>01068       <span class="comment">// 2D</span>
<a name="l01069"></a>01069     <span class="keywordflow">case</span> 2:
<a name="l01070"></a>01070       {
<a name="l01071"></a>01071         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01072"></a>01072           {
<a name="l01073"></a>01073           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01074"></a>01074             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;2,CLOUGH&gt;::nodal_soln</a>(elem, order,
<a name="l01075"></a>01075                                      elem_soln, nodal_soln);
<a name="l01076"></a>01076             <span class="keywordflow">return</span>;
<a name="l01077"></a>01077             
<a name="l01078"></a>01078           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01079"></a>01079             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;2,HERMITE&gt;::nodal_soln</a>(elem, order,
<a name="l01080"></a>01080                                      elem_soln, nodal_soln);
<a name="l01081"></a>01081             <span class="keywordflow">return</span>;
<a name="l01082"></a>01082             
<a name="l01083"></a>01083           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01084"></a>01084             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;2,HIERARCHIC&gt;::nodal_soln</a>(elem, order,
<a name="l01085"></a>01085                                          elem_soln, nodal_soln);
<a name="l01086"></a>01086             <span class="keywordflow">return</span>;
<a name="l01087"></a>01087             
<a name="l01088"></a>01088           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01089"></a>01089             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;2,LAGRANGE&gt;::nodal_soln</a>(elem, order,
<a name="l01090"></a>01090                                        elem_soln, nodal_soln);
<a name="l01091"></a>01091             <span class="keywordflow">return</span>;
<a name="l01092"></a>01092    
<a name="l01093"></a>01093           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01094"></a>01094             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;2,MONOMIAL&gt;::nodal_soln</a>(elem, order,
<a name="l01095"></a>01095                                        elem_soln, nodal_soln);
<a name="l01096"></a>01096             <span class="keywordflow">return</span>;
<a name="l01097"></a>01097 
<a name="l01098"></a>01098           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01099"></a>01099             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;2,SCALAR&gt;::nodal_soln</a>(elem, order,
<a name="l01100"></a>01100                                        elem_soln, nodal_soln);
<a name="l01101"></a>01101             <span class="keywordflow">return</span>;
<a name="l01102"></a>01102 
<a name="l01103"></a>01103 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01104"></a>01104 <span class="preprocessor"></span>
<a name="l01105"></a>01105           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01106"></a>01106             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;2,BERNSTEIN&gt;::nodal_soln</a>(elem, order,
<a name="l01107"></a>01107                                      elem_soln, nodal_soln);
<a name="l01108"></a>01108             <span class="keywordflow">return</span>;
<a name="l01109"></a>01109 
<a name="l01110"></a>01110           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01111"></a>01111             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;2,SZABAB&gt;::nodal_soln</a>(elem, order,
<a name="l01112"></a>01112                                      elem_soln, nodal_soln);
<a name="l01113"></a>01113             <span class="keywordflow">return</span>;
<a name="l01114"></a>01114 
<a name="l01115"></a>01115 <span class="preprocessor">#endif</span>
<a name="l01116"></a>01116 <span class="preprocessor"></span>
<a name="l01117"></a>01117           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01118"></a>01118             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEXYZ&lt;2&gt;::nodal_soln</a>(elem, order,
<a name="l01119"></a>01119                                  elem_soln, nodal_soln);
<a name="l01120"></a>01120             <span class="keywordflow">return</span>;
<a name="l01121"></a>01121 
<a name="l01122"></a>01122           <span class="keywordflow">default</span>:
<a name="l01123"></a>01123             libmesh_error();
<a name="l01124"></a>01124           }
<a name="l01125"></a>01125       }
<a name="l01126"></a>01126 
<a name="l01127"></a>01127       
<a name="l01128"></a>01128       <span class="comment">// 3D</span>
<a name="l01129"></a>01129     <span class="keywordflow">case</span> 3:
<a name="l01130"></a>01130       {
<a name="l01131"></a>01131         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01132"></a>01132           {
<a name="l01133"></a>01133           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01134"></a>01134             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;3,HERMITE&gt;::nodal_soln</a>(elem, order,
<a name="l01135"></a>01135                                      elem_soln, nodal_soln);
<a name="l01136"></a>01136             <span class="keywordflow">return</span>;
<a name="l01137"></a>01137             
<a name="l01138"></a>01138           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01139"></a>01139             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;3,HIERARCHIC&gt;::nodal_soln</a>(elem, order,
<a name="l01140"></a>01140                                          elem_soln, nodal_soln);
<a name="l01141"></a>01141             <span class="keywordflow">return</span>;
<a name="l01142"></a>01142             
<a name="l01143"></a>01143           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01144"></a>01144             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;3,LAGRANGE&gt;::nodal_soln</a>(elem, order,
<a name="l01145"></a>01145                                        elem_soln, nodal_soln);
<a name="l01146"></a>01146             <span class="keywordflow">return</span>;
<a name="l01147"></a>01147             
<a name="l01148"></a>01148           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01149"></a>01149             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;3,MONOMIAL&gt;::nodal_soln</a>(elem, order,
<a name="l01150"></a>01150                                        elem_soln, nodal_soln);
<a name="l01151"></a>01151             <span class="keywordflow">return</span>;
<a name="l01152"></a>01152 
<a name="l01153"></a>01153           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01154"></a>01154             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;3,SCALAR&gt;::nodal_soln</a>(elem, order,
<a name="l01155"></a>01155                                        elem_soln, nodal_soln);
<a name="l01156"></a>01156             <span class="keywordflow">return</span>;
<a name="l01157"></a>01157 
<a name="l01158"></a>01158 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01159"></a>01159 <span class="preprocessor"></span>
<a name="l01160"></a>01160           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01161"></a>01161             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;3,BERNSTEIN&gt;::nodal_soln</a>(elem, order,
<a name="l01162"></a>01162                                      elem_soln, nodal_soln);
<a name="l01163"></a>01163             <span class="keywordflow">return</span>;
<a name="l01164"></a>01164 
<a name="l01165"></a>01165           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01166"></a>01166             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FE&lt;3,SZABAB&gt;::nodal_soln</a>(elem, order,
<a name="l01167"></a>01167                                      elem_soln, nodal_soln);
<a name="l01168"></a>01168             <span class="keywordflow">return</span>;
<a name="l01169"></a>01169 
<a name="l01170"></a>01170 <span class="preprocessor">#endif</span>
<a name="l01171"></a>01171 <span class="preprocessor"></span>
<a name="l01172"></a>01172           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01173"></a>01173             <a class="code" href="classFEInterface.php#a7f444eb3e2853a42bba176c0eeba8b49">FEXYZ&lt;3&gt;::nodal_soln</a>(elem, order,
<a name="l01174"></a>01174                                  elem_soln, nodal_soln);
<a name="l01175"></a>01175             <span class="keywordflow">return</span>;
<a name="l01176"></a>01176 
<a name="l01177"></a>01177           <span class="keywordflow">default</span>:
<a name="l01178"></a>01178             libmesh_error();
<a name="l01179"></a>01179           }
<a name="l01180"></a>01180       }
<a name="l01181"></a>01181 
<a name="l01182"></a>01182 
<a name="l01183"></a>01183     <span class="keywordflow">default</span>:
<a name="l01184"></a>01184       libmesh_error();
<a name="l01185"></a>01185     }
<a name="l01186"></a>01186 }
<a name="l01187"></a>01187 
<a name="l01188"></a>01188 
<a name="l01189"></a>01189 
<a name="l01190"></a>01190 
<a name="l01191"></a><a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">01191</a> <a class="code" href="classPoint.php">Point</a> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l01192"></a>01192                                 <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l01193"></a>01193                                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l01194"></a>01194                                 <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l01195"></a>01195                                 <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance,
<a name="l01196"></a>01196                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> secure)
<a name="l01197"></a>01197 {
<a name="l01198"></a>01198 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01199"></a>01199 <span class="preprocessor"></span>
<a name="l01200"></a>01200   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()) )
<a name="l01201"></a>01201     <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a15e50e6ceb8ebc9b602bf80ad4f57858">ifem_inverse_map</a>(dim, fe_t, elem, p,tolerance, secure);
<a name="l01202"></a>01202 
<a name="l01203"></a>01203 <span class="preprocessor">#endif</span>
<a name="l01204"></a>01204 <span class="preprocessor"></span>
<a name="l01205"></a>01205   <span class="keywordflow">switch</span> (dim)
<a name="l01206"></a>01206     {
<a name="l01207"></a>01207       <span class="comment">// 1D</span>
<a name="l01208"></a>01208     <span class="keywordflow">case</span> 1:
<a name="l01209"></a>01209       {
<a name="l01210"></a>01210         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01211"></a>01211           {
<a name="l01212"></a>01212           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01213"></a>01213             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,CLOUGH&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01214"></a>01214             
<a name="l01215"></a>01215           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01216"></a>01216             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,HERMITE&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01217"></a>01217             
<a name="l01218"></a>01218           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01219"></a>01219             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,HIERARCHIC&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01220"></a>01220             
<a name="l01221"></a>01221           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01222"></a>01222             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,LAGRANGE&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01223"></a>01223             
<a name="l01224"></a>01224           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01225"></a>01225             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,MONOMIAL&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01226"></a>01226 
<a name="l01227"></a>01227           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01228"></a>01228             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,SCALAR&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01229"></a>01229 
<a name="l01230"></a>01230 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01231"></a>01231 <span class="preprocessor"></span>
<a name="l01232"></a>01232           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01233"></a>01233             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,BERNSTEIN&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01234"></a>01234 
<a name="l01235"></a>01235           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01236"></a>01236             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,SZABAB&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01237"></a>01237 
<a name="l01238"></a>01238 <span class="preprocessor">#endif</span>
<a name="l01239"></a>01239 <span class="preprocessor"></span>          <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01240"></a>01240             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEXYZ&lt;1&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01241"></a>01241 
<a name="l01242"></a>01242 
<a name="l01243"></a>01243           <span class="keywordflow">default</span>:
<a name="l01244"></a>01244             libmesh_error();
<a name="l01245"></a>01245           }
<a name="l01246"></a>01246       }
<a name="l01247"></a>01247 
<a name="l01248"></a>01248       
<a name="l01249"></a>01249       <span class="comment">// 2D</span>
<a name="l01250"></a>01250     <span class="keywordflow">case</span> 2:
<a name="l01251"></a>01251       {
<a name="l01252"></a>01252         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01253"></a>01253           {
<a name="l01254"></a>01254           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01255"></a>01255             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,CLOUGH&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01256"></a>01256             
<a name="l01257"></a>01257           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01258"></a>01258             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,HERMITE&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01259"></a>01259             
<a name="l01260"></a>01260           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01261"></a>01261             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,HIERARCHIC&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01262"></a>01262             
<a name="l01263"></a>01263           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01264"></a>01264             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,LAGRANGE&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01265"></a>01265             
<a name="l01266"></a>01266           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01267"></a>01267             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,MONOMIAL&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01268"></a>01268 
<a name="l01269"></a>01269           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01270"></a>01270             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,SCALAR&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01271"></a>01271 
<a name="l01272"></a>01272 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01273"></a>01273 <span class="preprocessor"></span>
<a name="l01274"></a>01274           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01275"></a>01275             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,BERNSTEIN&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01276"></a>01276 
<a name="l01277"></a>01277           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01278"></a>01278             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,SZABAB&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01279"></a>01279 
<a name="l01280"></a>01280 <span class="preprocessor">#endif</span>
<a name="l01281"></a>01281 <span class="preprocessor"></span>          <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01282"></a>01282             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEXYZ&lt;2&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01283"></a>01283 
<a name="l01284"></a>01284           <span class="keywordflow">default</span>:
<a name="l01285"></a>01285             libmesh_error();
<a name="l01286"></a>01286           }
<a name="l01287"></a>01287       }
<a name="l01288"></a>01288 
<a name="l01289"></a>01289       
<a name="l01290"></a>01290       <span class="comment">// 3D</span>
<a name="l01291"></a>01291     <span class="keywordflow">case</span> 3:
<a name="l01292"></a>01292       {
<a name="l01293"></a>01293         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01294"></a>01294           {
<a name="l01295"></a>01295           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01296"></a>01296             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,HERMITE&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01297"></a>01297             
<a name="l01298"></a>01298           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01299"></a>01299             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,HIERARCHIC&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01300"></a>01300             
<a name="l01301"></a>01301           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01302"></a>01302             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,LAGRANGE&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01303"></a>01303             
<a name="l01304"></a>01304           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01305"></a>01305             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,MONOMIAL&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01306"></a>01306 
<a name="l01307"></a>01307           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01308"></a>01308             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,SCALAR&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01309"></a>01309 
<a name="l01310"></a>01310 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01311"></a>01311 <span class="preprocessor"></span>
<a name="l01312"></a>01312           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01313"></a>01313             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,BERNSTEIN&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01314"></a>01314 
<a name="l01315"></a>01315           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01316"></a>01316             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,SZABAB&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01317"></a>01317 
<a name="l01318"></a>01318 <span class="preprocessor">#endif</span>
<a name="l01319"></a>01319 <span class="preprocessor"></span>          <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01320"></a>01320             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEXYZ&lt;3&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l01321"></a>01321 
<a name="l01322"></a>01322           <span class="keywordflow">default</span>:
<a name="l01323"></a>01323             libmesh_error();
<a name="l01324"></a>01324           }
<a name="l01325"></a>01325       }
<a name="l01326"></a>01326 
<a name="l01327"></a>01327 
<a name="l01328"></a>01328     <span class="keywordflow">default</span>:
<a name="l01329"></a>01329       libmesh_error();
<a name="l01330"></a>01330     }
<a name="l01331"></a>01331 
<a name="l01332"></a>01332   
<a name="l01333"></a>01333   libmesh_error();
<a name="l01334"></a>01334   <a class="code" href="classPoint.php">Point</a> pt;
<a name="l01335"></a>01335   <span class="keywordflow">return</span> pt;
<a name="l01336"></a>01336 }
<a name="l01337"></a>01337 
<a name="l01338"></a>01338 
<a name="l01339"></a>01339 
<a name="l01340"></a>01340 
<a name="l01341"></a><a class="code" href="classFEInterface.php#a2be5fd957d81b5b49a5e06942141b543">01341</a> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEInterface::inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l01342"></a>01342                                <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l01343"></a>01343                                <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l01344"></a>01344                                <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l01345"></a>01345                                std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l01346"></a>01346                                <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tolerance,
<a name="l01347"></a>01347                                <span class="keyword">const</span> <span class="keywordtype">bool</span> secure)
<a name="l01348"></a>01348 {
<a name="l01349"></a>01349   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pts = physical_points.<a class="code" href="classTypeVector.php#a34f47a12e12990aad2910a934bdaac7d">size</a>();
<a name="l01350"></a>01350 
<a name="l01351"></a>01351   <span class="comment">// Resize the vector</span>
<a name="l01352"></a>01352   reference_points.resize(n_pts);
<a name="l01353"></a>01353   
<a name="l01354"></a>01354   <span class="keywordflow">if</span> (n_pts == 0)
<a name="l01355"></a>01355     {
<a name="l01356"></a>01356       std::cerr &lt;&lt; <span class="stringliteral">&quot;WARNING: empty vector physical_points!&quot;</span>
<a name="l01357"></a>01357                 &lt;&lt; std::endl;
<a name="l01358"></a>01358       libmesh_here();
<a name="l01359"></a>01359       <span class="keywordflow">return</span>;
<a name="l01360"></a>01360     }
<a name="l01361"></a>01361   
<a name="l01362"></a>01362 
<a name="l01363"></a>01363 
<a name="l01364"></a>01364 
<a name="l01365"></a>01365   
<a name="l01366"></a>01366 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01367"></a>01367 <span class="preprocessor"></span>
<a name="l01368"></a>01368   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()) )
<a name="l01369"></a>01369     {
<a name="l01370"></a>01370       <a class="code" href="classFEInterface.php#a15e50e6ceb8ebc9b602bf80ad4f57858">ifem_inverse_map</a>(dim, fe_t, elem, physical_points, reference_points, tolerance, secure);
<a name="l01371"></a>01371       <span class="keywordflow">return</span>;
<a name="l01372"></a>01372 
<a name="l01373"></a>01373 <span class="comment">//       std::cerr &lt;&lt; &quot;ERROR: Not implemented!&quot;</span>
<a name="l01374"></a>01374 <span class="comment">//              &lt;&lt; std::endl;</span>
<a name="l01375"></a>01375 <span class="comment">//       libmesh_error();</span>
<a name="l01376"></a>01376     }
<a name="l01377"></a>01377   
<a name="l01378"></a>01378 <span class="preprocessor">#endif</span>
<a name="l01379"></a>01379 <span class="preprocessor"></span>
<a name="l01380"></a>01380   <span class="keywordflow">switch</span> (dim)
<a name="l01381"></a>01381     {
<a name="l01382"></a>01382       <span class="comment">// 1D</span>
<a name="l01383"></a>01383     <span class="keywordflow">case</span> 1:
<a name="l01384"></a>01384       {
<a name="l01385"></a>01385         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01386"></a>01386           {
<a name="l01387"></a>01387           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01388"></a>01388             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,CLOUGH&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01389"></a>01389             <span class="keywordflow">return</span>;
<a name="l01390"></a>01390             
<a name="l01391"></a>01391           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01392"></a>01392             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,HERMITE&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01393"></a>01393             <span class="keywordflow">return</span>;
<a name="l01394"></a>01394             
<a name="l01395"></a>01395           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01396"></a>01396             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,HIERARCHIC&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01397"></a>01397             <span class="keywordflow">return</span>;
<a name="l01398"></a>01398             
<a name="l01399"></a>01399           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01400"></a>01400             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,LAGRANGE&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01401"></a>01401             <span class="keywordflow">return</span>;
<a name="l01402"></a>01402             
<a name="l01403"></a>01403           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01404"></a>01404             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,MONOMIAL&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01405"></a>01405             <span class="keywordflow">return</span>;
<a name="l01406"></a>01406 
<a name="l01407"></a>01407           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01408"></a>01408             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,SCALAR&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01409"></a>01409             <span class="keywordflow">return</span>;
<a name="l01410"></a>01410             
<a name="l01411"></a>01411 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01412"></a>01412 <span class="preprocessor"></span>
<a name="l01413"></a>01413           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01414"></a>01414             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,BERNSTEIN&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01415"></a>01415             <span class="keywordflow">return</span>;
<a name="l01416"></a>01416 
<a name="l01417"></a>01417           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01418"></a>01418             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;1,SZABAB&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01419"></a>01419             <span class="keywordflow">return</span>;
<a name="l01420"></a>01420 
<a name="l01421"></a>01421 <span class="preprocessor">#endif</span>
<a name="l01422"></a>01422 <span class="preprocessor"></span>            
<a name="l01423"></a>01423           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01424"></a>01424             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEXYZ&lt;1&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01425"></a>01425             <span class="keywordflow">return</span>;
<a name="l01426"></a>01426 
<a name="l01427"></a>01427           <span class="keywordflow">default</span>:
<a name="l01428"></a>01428             libmesh_error();
<a name="l01429"></a>01429           }
<a name="l01430"></a>01430       }
<a name="l01431"></a>01431 
<a name="l01432"></a>01432       
<a name="l01433"></a>01433       <span class="comment">// 2D</span>
<a name="l01434"></a>01434     <span class="keywordflow">case</span> 2:
<a name="l01435"></a>01435       {
<a name="l01436"></a>01436         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01437"></a>01437           {
<a name="l01438"></a>01438           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01439"></a>01439             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,CLOUGH&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01440"></a>01440             <span class="keywordflow">return</span>;
<a name="l01441"></a>01441             
<a name="l01442"></a>01442           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01443"></a>01443             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,HERMITE&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01444"></a>01444             <span class="keywordflow">return</span>;
<a name="l01445"></a>01445             
<a name="l01446"></a>01446           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01447"></a>01447             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,HIERARCHIC&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01448"></a>01448             <span class="keywordflow">return</span>;
<a name="l01449"></a>01449             
<a name="l01450"></a>01450           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01451"></a>01451             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,LAGRANGE&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01452"></a>01452             <span class="keywordflow">return</span>;
<a name="l01453"></a>01453             
<a name="l01454"></a>01454           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01455"></a>01455             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,MONOMIAL&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01456"></a>01456             <span class="keywordflow">return</span>;
<a name="l01457"></a>01457 
<a name="l01458"></a>01458           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01459"></a>01459             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,SCALAR&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01460"></a>01460             <span class="keywordflow">return</span>;
<a name="l01461"></a>01461             
<a name="l01462"></a>01462 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01463"></a>01463 <span class="preprocessor"></span>
<a name="l01464"></a>01464           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01465"></a>01465             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,BERNSTEIN&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01466"></a>01466             <span class="keywordflow">return</span>;
<a name="l01467"></a>01467 
<a name="l01468"></a>01468           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01469"></a>01469             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;2,SZABAB&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01470"></a>01470             <span class="keywordflow">return</span>;
<a name="l01471"></a>01471 
<a name="l01472"></a>01472 <span class="preprocessor">#endif</span>
<a name="l01473"></a>01473 <span class="preprocessor"></span>            
<a name="l01474"></a>01474           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01475"></a>01475             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEXYZ&lt;2&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01476"></a>01476             <span class="keywordflow">return</span>;
<a name="l01477"></a>01477 
<a name="l01478"></a>01478           <span class="keywordflow">default</span>:
<a name="l01479"></a>01479             libmesh_error();
<a name="l01480"></a>01480           }
<a name="l01481"></a>01481       }
<a name="l01482"></a>01482 
<a name="l01483"></a>01483       
<a name="l01484"></a>01484       <span class="comment">// 3D</span>
<a name="l01485"></a>01485     <span class="keywordflow">case</span> 3:
<a name="l01486"></a>01486       {
<a name="l01487"></a>01487         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01488"></a>01488           {
<a name="l01489"></a>01489           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01490"></a>01490             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,HERMITE&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01491"></a>01491             <span class="keywordflow">return</span>;
<a name="l01492"></a>01492             
<a name="l01493"></a>01493           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01494"></a>01494             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,HIERARCHIC&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01495"></a>01495             <span class="keywordflow">return</span>;
<a name="l01496"></a>01496             
<a name="l01497"></a>01497           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01498"></a>01498             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,LAGRANGE&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01499"></a>01499             <span class="keywordflow">return</span>;
<a name="l01500"></a>01500             
<a name="l01501"></a>01501           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01502"></a>01502             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,MONOMIAL&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01503"></a>01503             <span class="keywordflow">return</span>;
<a name="l01504"></a>01504 
<a name="l01505"></a>01505           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01506"></a>01506             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,SCALAR&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01507"></a>01507             <span class="keywordflow">return</span>;
<a name="l01508"></a>01508             
<a name="l01509"></a>01509 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01510"></a>01510 <span class="preprocessor"></span>
<a name="l01511"></a>01511           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01512"></a>01512             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,BERNSTEIN&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01513"></a>01513             <span class="keywordflow">return</span>;
<a name="l01514"></a>01514 
<a name="l01515"></a>01515           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01516"></a>01516             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FE&lt;3,SZABAB&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01517"></a>01517             <span class="keywordflow">return</span>;
<a name="l01518"></a>01518 
<a name="l01519"></a>01519 <span class="preprocessor">#endif</span>
<a name="l01520"></a>01520 <span class="preprocessor"></span>            
<a name="l01521"></a>01521           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01522"></a>01522             <a class="code" href="classFEInterface.php#a5768784144fcef4a41a5dd90a225a9a2">FEXYZ&lt;3&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l01523"></a>01523             <span class="keywordflow">return</span>;
<a name="l01524"></a>01524             
<a name="l01525"></a>01525           <span class="keywordflow">default</span>:
<a name="l01526"></a>01526             libmesh_error();
<a name="l01527"></a>01527           }
<a name="l01528"></a>01528       }
<a name="l01529"></a>01529 
<a name="l01530"></a>01530 
<a name="l01531"></a>01531     <span class="keywordflow">default</span>:
<a name="l01532"></a>01532       libmesh_error();
<a name="l01533"></a>01533     }
<a name="l01534"></a>01534 
<a name="l01535"></a>01535   
<a name="l01536"></a>01536   libmesh_error();
<a name="l01537"></a>01537   <span class="keywordflow">return</span>;
<a name="l01538"></a>01538 }
<a name="l01539"></a>01539 
<a name="l01540"></a>01540 
<a name="l01541"></a>01541 
<a name="l01542"></a><a class="code" href="classFEInterface.php#a74fa7b62c80d4740411a97560988211a">01542</a> <span class="keywordtype">bool</span> <a class="code" href="classFEInterface.php#a74fa7b62c80d4740411a97560988211a">FEInterface::on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l01543"></a>01543                                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l01544"></a>01544                                        <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> eps)
<a name="l01545"></a>01545 {
<a name="l01546"></a>01546   <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a74fa7b62c80d4740411a97560988211a">FEBase::on_reference_element</a>(p,t,eps);
<a name="l01547"></a>01547 }
<a name="l01548"></a>01548 
<a name="l01549"></a>01549 
<a name="l01550"></a>01550 
<a name="l01551"></a>01551 
<a name="l01552"></a><a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">01552</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEInterface::shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l01553"></a>01553                         <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l01554"></a>01554                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l01555"></a>01555                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l01556"></a>01556                         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)
<a name="l01557"></a>01557 {
<a name="l01558"></a>01558 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01559"></a>01559 <span class="preprocessor"></span>
<a name="l01560"></a>01560   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(t) )
<a name="l01561"></a>01561     <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5720b471c00c2d4b19081072864311af">ifem_shape</a>(dim, fe_t, t, i, p);
<a name="l01562"></a>01562 
<a name="l01563"></a>01563 <span class="preprocessor">#endif</span>
<a name="l01564"></a>01564 <span class="preprocessor"></span>
<a name="l01565"></a>01565   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o = fe_t.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l01566"></a>01566   
<a name="l01567"></a>01567   <span class="keywordflow">switch</span> (dim)
<a name="l01568"></a>01568     {
<a name="l01569"></a>01569       <span class="comment">// 1D</span>
<a name="l01570"></a>01570     <span class="keywordflow">case</span> 1:
<a name="l01571"></a>01571       {
<a name="l01572"></a>01572         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01573"></a>01573           {
<a name="l01574"></a>01574           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01575"></a>01575             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,CLOUGH&gt;::shape</a>(t,o,i,p);
<a name="l01576"></a>01576             
<a name="l01577"></a>01577           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01578"></a>01578             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,HERMITE&gt;::shape</a>(t,o,i,p);
<a name="l01579"></a>01579             
<a name="l01580"></a>01580           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01581"></a>01581             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,HIERARCHIC&gt;::shape</a>(t,o,i,p);
<a name="l01582"></a>01582             
<a name="l01583"></a>01583           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01584"></a>01584             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,LAGRANGE&gt;::shape</a>(t,o,i,p);
<a name="l01585"></a>01585             
<a name="l01586"></a>01586           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01587"></a>01587             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,MONOMIAL&gt;::shape</a>(t,o,i,p);
<a name="l01588"></a>01588 
<a name="l01589"></a>01589           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01590"></a>01590             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,SCALAR&gt;::shape</a>(t,o,i,p);
<a name="l01591"></a>01591 
<a name="l01592"></a>01592 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01593"></a>01593 <span class="preprocessor"></span>
<a name="l01594"></a>01594           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01595"></a>01595             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,BERNSTEIN&gt;::shape</a>(t,o,i,p);
<a name="l01596"></a>01596 
<a name="l01597"></a>01597           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01598"></a>01598             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,SZABAB&gt;::shape</a>(t,o,i,p);
<a name="l01599"></a>01599 
<a name="l01600"></a>01600 <span class="preprocessor">#endif</span>
<a name="l01601"></a>01601 <span class="preprocessor"></span>            
<a name="l01602"></a>01602           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01603"></a>01603             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEXYZ&lt;1&gt;::shape</a>(t,o,i,p);
<a name="l01604"></a>01604 
<a name="l01605"></a>01605           <span class="keywordflow">default</span>:
<a name="l01606"></a>01606             libmesh_error();
<a name="l01607"></a>01607           }
<a name="l01608"></a>01608       }
<a name="l01609"></a>01609 
<a name="l01610"></a>01610       
<a name="l01611"></a>01611       <span class="comment">// 2D</span>
<a name="l01612"></a>01612     <span class="keywordflow">case</span> 2:
<a name="l01613"></a>01613       {
<a name="l01614"></a>01614         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01615"></a>01615           {
<a name="l01616"></a>01616           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01617"></a>01617             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,CLOUGH&gt;::shape</a>(t,o,i,p);
<a name="l01618"></a>01618             
<a name="l01619"></a>01619           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01620"></a>01620             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,HERMITE&gt;::shape</a>(t,o,i,p);
<a name="l01621"></a>01621             
<a name="l01622"></a>01622           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01623"></a>01623             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,HIERARCHIC&gt;::shape</a>(t,o,i,p);
<a name="l01624"></a>01624             
<a name="l01625"></a>01625           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01626"></a>01626             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,LAGRANGE&gt;::shape</a>(t,o,i,p);
<a name="l01627"></a>01627             
<a name="l01628"></a>01628           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01629"></a>01629             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,MONOMIAL&gt;::shape</a>(t,o,i,p);
<a name="l01630"></a>01630 
<a name="l01631"></a>01631           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01632"></a>01632             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,SCALAR&gt;::shape</a>(t,o,i,p);
<a name="l01633"></a>01633 
<a name="l01634"></a>01634 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01635"></a>01635 <span class="preprocessor"></span>
<a name="l01636"></a>01636           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01637"></a>01637             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,BERNSTEIN&gt;::shape</a>(t,o,i,p);
<a name="l01638"></a>01638 
<a name="l01639"></a>01639           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01640"></a>01640             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,SZABAB&gt;::shape</a>(t,o,i,p);
<a name="l01641"></a>01641 
<a name="l01642"></a>01642 <span class="preprocessor">#endif</span>
<a name="l01643"></a>01643 <span class="preprocessor"></span>            
<a name="l01644"></a>01644           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01645"></a>01645             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEXYZ&lt;2&gt;::shape</a>(t,o,i,p);
<a name="l01646"></a>01646 
<a name="l01647"></a>01647           <span class="keywordflow">default</span>:
<a name="l01648"></a>01648             libmesh_error();
<a name="l01649"></a>01649           }
<a name="l01650"></a>01650       }
<a name="l01651"></a>01651 
<a name="l01652"></a>01652       
<a name="l01653"></a>01653       <span class="comment">// 3D</span>
<a name="l01654"></a>01654     <span class="keywordflow">case</span> 3:
<a name="l01655"></a>01655       {
<a name="l01656"></a>01656         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01657"></a>01657           {
<a name="l01658"></a>01658           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01659"></a>01659             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,HERMITE&gt;::shape</a>(t,o,i,p);
<a name="l01660"></a>01660             
<a name="l01661"></a>01661           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01662"></a>01662             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,HIERARCHIC&gt;::shape</a>(t,o,i,p);
<a name="l01663"></a>01663             
<a name="l01664"></a>01664           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01665"></a>01665             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,LAGRANGE&gt;::shape</a>(t,o,i,p);
<a name="l01666"></a>01666             
<a name="l01667"></a>01667           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01668"></a>01668             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,MONOMIAL&gt;::shape</a>(t,o,i,p);
<a name="l01669"></a>01669 
<a name="l01670"></a>01670           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01671"></a>01671             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,SCALAR&gt;::shape</a>(t,o,i,p);
<a name="l01672"></a>01672 
<a name="l01673"></a>01673 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01674"></a>01674 <span class="preprocessor"></span>
<a name="l01675"></a>01675           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01676"></a>01676             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,BERNSTEIN&gt;::shape</a>(t,o,i,p);
<a name="l01677"></a>01677 
<a name="l01678"></a>01678           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01679"></a>01679             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,SZABAB&gt;::shape</a>(t,o,i,p);
<a name="l01680"></a>01680 
<a name="l01681"></a>01681 <span class="preprocessor">#endif</span>
<a name="l01682"></a>01682 <span class="preprocessor"></span>            
<a name="l01683"></a>01683           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01684"></a>01684             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEXYZ&lt;3&gt;::shape</a>(t,o,i,p);
<a name="l01685"></a>01685 
<a name="l01686"></a>01686           <span class="keywordflow">default</span>:
<a name="l01687"></a>01687             libmesh_error();
<a name="l01688"></a>01688           }
<a name="l01689"></a>01689       }
<a name="l01690"></a>01690 
<a name="l01691"></a>01691 
<a name="l01692"></a>01692     <span class="keywordflow">default</span>:
<a name="l01693"></a>01693       libmesh_error();
<a name="l01694"></a>01694     }
<a name="l01695"></a>01695 
<a name="l01696"></a>01696   
<a name="l01697"></a>01697   libmesh_error();
<a name="l01698"></a>01698   <span class="keywordflow">return</span> 0.;
<a name="l01699"></a>01699 }
<a name="l01700"></a>01700 
<a name="l01701"></a>01701 
<a name="l01702"></a>01702 
<a name="l01703"></a>01703 
<a name="l01704"></a><a class="code" href="classFEInterface.php#acbcbd67da120e4210aa6d9d6f17a3847">01704</a> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEInterface::shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l01705"></a>01705                         <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l01706"></a>01706                         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l01707"></a>01707                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l01708"></a>01708                         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p)
<a name="l01709"></a>01709 {
<a name="l01710"></a>01710 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01711"></a>01711 <span class="preprocessor"></span>
<a name="l01712"></a>01712   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()) )
<a name="l01713"></a>01713     <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a5720b471c00c2d4b19081072864311af">ifem_shape</a>(dim, fe_t, elem, i, p);
<a name="l01714"></a>01714 
<a name="l01715"></a>01715 <span class="preprocessor">#endif</span>
<a name="l01716"></a>01716 <span class="preprocessor"></span>
<a name="l01717"></a>01717   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o = fe_t.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a>;
<a name="l01718"></a>01718 
<a name="l01719"></a>01719   <span class="keywordflow">switch</span> (dim)
<a name="l01720"></a>01720     {
<a name="l01721"></a>01721       <span class="comment">// 1D</span>
<a name="l01722"></a>01722     <span class="keywordflow">case</span> 1:
<a name="l01723"></a>01723       {
<a name="l01724"></a>01724         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01725"></a>01725           {
<a name="l01726"></a>01726           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01727"></a>01727             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,CLOUGH&gt;::shape</a>(elem,o,i,p);
<a name="l01728"></a>01728             
<a name="l01729"></a>01729           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01730"></a>01730             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,HERMITE&gt;::shape</a>(elem,o,i,p);
<a name="l01731"></a>01731             
<a name="l01732"></a>01732           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01733"></a>01733             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,HIERARCHIC&gt;::shape</a>(elem,o,i,p);
<a name="l01734"></a>01734             
<a name="l01735"></a>01735           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01736"></a>01736             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,LAGRANGE&gt;::shape</a>(elem,o,i,p);
<a name="l01737"></a>01737             
<a name="l01738"></a>01738           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01739"></a>01739             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,MONOMIAL&gt;::shape</a>(elem,o,i,p);
<a name="l01740"></a>01740 
<a name="l01741"></a>01741           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01742"></a>01742             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,SCALAR&gt;::shape</a>(elem,o,i,p);
<a name="l01743"></a>01743 
<a name="l01744"></a>01744 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01745"></a>01745 <span class="preprocessor"></span>
<a name="l01746"></a>01746           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01747"></a>01747             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,BERNSTEIN&gt;::shape</a>(elem,o,i,p);
<a name="l01748"></a>01748 
<a name="l01749"></a>01749           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01750"></a>01750             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;1,SZABAB&gt;::shape</a>(elem,o,i,p);
<a name="l01751"></a>01751 
<a name="l01752"></a>01752 <span class="preprocessor">#endif</span>
<a name="l01753"></a>01753 <span class="preprocessor"></span>            
<a name="l01754"></a>01754           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01755"></a>01755             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEXYZ&lt;1&gt;::shape</a>(elem,o,i,p);
<a name="l01756"></a>01756 
<a name="l01757"></a>01757           <span class="keywordflow">default</span>:
<a name="l01758"></a>01758             libmesh_error();
<a name="l01759"></a>01759           }
<a name="l01760"></a>01760       }
<a name="l01761"></a>01761 
<a name="l01762"></a>01762       
<a name="l01763"></a>01763       <span class="comment">// 2D</span>
<a name="l01764"></a>01764     <span class="keywordflow">case</span> 2:
<a name="l01765"></a>01765       {
<a name="l01766"></a>01766         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01767"></a>01767           {
<a name="l01768"></a>01768           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01769"></a>01769             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,CLOUGH&gt;::shape</a>(elem,o,i,p);
<a name="l01770"></a>01770             
<a name="l01771"></a>01771           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01772"></a>01772             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,HERMITE&gt;::shape</a>(elem,o,i,p);
<a name="l01773"></a>01773             
<a name="l01774"></a>01774           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01775"></a>01775             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,HIERARCHIC&gt;::shape</a>(elem,o,i,p);
<a name="l01776"></a>01776             
<a name="l01777"></a>01777           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01778"></a>01778             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,LAGRANGE&gt;::shape</a>(elem,o,i,p);
<a name="l01779"></a>01779             
<a name="l01780"></a>01780           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01781"></a>01781             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,MONOMIAL&gt;::shape</a>(elem,o,i,p);
<a name="l01782"></a>01782 
<a name="l01783"></a>01783           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01784"></a>01784             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,SCALAR&gt;::shape</a>(elem,o,i,p);
<a name="l01785"></a>01785 
<a name="l01786"></a>01786 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01787"></a>01787 <span class="preprocessor"></span>
<a name="l01788"></a>01788           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01789"></a>01789             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,BERNSTEIN&gt;::shape</a>(elem,o,i,p);
<a name="l01790"></a>01790 
<a name="l01791"></a>01791           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01792"></a>01792             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;2,SZABAB&gt;::shape</a>(elem,o,i,p);
<a name="l01793"></a>01793 
<a name="l01794"></a>01794 <span class="preprocessor">#endif</span>
<a name="l01795"></a>01795 <span class="preprocessor"></span>            
<a name="l01796"></a>01796           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01797"></a>01797             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEXYZ&lt;2&gt;::shape</a>(elem,o,i,p);
<a name="l01798"></a>01798 
<a name="l01799"></a>01799           <span class="keywordflow">default</span>:
<a name="l01800"></a>01800             libmesh_error();
<a name="l01801"></a>01801           }
<a name="l01802"></a>01802       }
<a name="l01803"></a>01803 
<a name="l01804"></a>01804       
<a name="l01805"></a>01805       <span class="comment">// 3D</span>
<a name="l01806"></a>01806     <span class="keywordflow">case</span> 3:
<a name="l01807"></a>01807       {
<a name="l01808"></a>01808         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01809"></a>01809           {
<a name="l01810"></a>01810           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01811"></a>01811             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,HERMITE&gt;::shape</a>(elem,o,i,p);
<a name="l01812"></a>01812             
<a name="l01813"></a>01813           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01814"></a>01814             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,HIERARCHIC&gt;::shape</a>(elem,o,i,p);
<a name="l01815"></a>01815             
<a name="l01816"></a>01816           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01817"></a>01817             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,LAGRANGE&gt;::shape</a>(elem,o,i,p);
<a name="l01818"></a>01818             
<a name="l01819"></a>01819           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l01820"></a>01820             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,MONOMIAL&gt;::shape</a>(elem,o,i,p);
<a name="l01821"></a>01821 
<a name="l01822"></a>01822           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>:
<a name="l01823"></a>01823             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,SCALAR&gt;::shape</a>(elem,o,i,p);
<a name="l01824"></a>01824 
<a name="l01825"></a>01825 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l01826"></a>01826 <span class="preprocessor"></span>
<a name="l01827"></a>01827           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l01828"></a>01828             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,BERNSTEIN&gt;::shape</a>(elem,o,i,p);
<a name="l01829"></a>01829 
<a name="l01830"></a>01830           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l01831"></a>01831             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FE&lt;3,SZABAB&gt;::shape</a>(elem,o,i,p);
<a name="l01832"></a>01832 
<a name="l01833"></a>01833 <span class="preprocessor">#endif</span>
<a name="l01834"></a>01834 <span class="preprocessor"></span>            
<a name="l01835"></a>01835           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l01836"></a>01836             <span class="keywordflow">return</span> <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">FEXYZ&lt;3&gt;::shape</a>(elem,o,i,p);
<a name="l01837"></a>01837 
<a name="l01838"></a>01838           <span class="keywordflow">default</span>:
<a name="l01839"></a>01839             libmesh_error();
<a name="l01840"></a>01840           }
<a name="l01841"></a>01841       }
<a name="l01842"></a>01842 
<a name="l01843"></a>01843 
<a name="l01844"></a>01844     <span class="keywordflow">default</span>:
<a name="l01845"></a>01845       libmesh_error();
<a name="l01846"></a>01846     }
<a name="l01847"></a>01847 
<a name="l01848"></a>01848   
<a name="l01849"></a>01849   libmesh_error();
<a name="l01850"></a>01850   <span class="keywordflow">return</span> 0.;
<a name="l01851"></a>01851 }
<a name="l01852"></a>01852 
<a name="l01853"></a>01853 
<a name="l01854"></a>01854 
<a name="l01855"></a>01855 
<a name="l01856"></a><a class="code" href="classFEInterface.php#a6ae681af86208c304eb7d45b8a712e3c">01856</a> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a6ae681af86208c304eb7d45b8a712e3c">FEInterface::compute_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l01857"></a>01857                                <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l01858"></a>01858                                <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem,
<a name="l01859"></a>01859                                <a class="code" href="classFEComputeData.php">FEComputeData</a>&amp; data)
<a name="l01860"></a>01860 {
<a name="l01861"></a>01861 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01862"></a>01862 <span class="preprocessor"></span>
<a name="l01863"></a>01863   <span class="keywordflow">if</span> ( <a class="code" href="classFEInterface.php#a490850a95469eaf9a14d56c93bc99679">is_InfFE_elem</a>(elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()) )
<a name="l01864"></a>01864     {
<a name="l01865"></a>01865       data.<a class="code" href="classFEComputeData.php#a2766da5c11ee60472b6f39dc177b2229">init</a>();
<a name="l01866"></a>01866       <a class="code" href="classFEInterface.php#a93dc7080b53c474a76ae585749808f63">ifem_compute_data</a>(dim, fe_t, elem, data);
<a name="l01867"></a>01867       <span class="keywordflow">return</span>;
<a name="l01868"></a>01868     }
<a name="l01869"></a>01869 
<a name="l01870"></a>01870 <span class="preprocessor">#endif</span>
<a name="l01871"></a>01871 <span class="preprocessor"></span>
<a name="l01872"></a>01872   <a class="code" href="classFEType.php">FEType</a> p_refined = fe_t;
<a name="l01873"></a>01873   p_refined.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(p_refined.<a class="code" href="classFEType.php#a72c29a6dbf3f2a84728111122cec4742">order</a> + elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>());
<a name="l01874"></a>01874 
<a name="l01875"></a>01875   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dof = <a class="code" href="classFEInterface.php#a1de238979fb1d4b85293aaedc493bc4d">n_dofs</a> (dim, p_refined, elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>());
<a name="l01876"></a>01876   <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp;       p     = data.<a class="code" href="classFEComputeData.php#a7bf9026e9cb744cc23354c50d5e9658d">p</a>;
<a name="l01877"></a>01877   data.<a class="code" href="classFEComputeData.php#ae9bf9a37c12e74af8a28cebb10e5610b">shape</a>.resize(n_dof);
<a name="l01878"></a>01878 
<a name="l01879"></a>01879   <span class="comment">// set default values for all the output fields</span>
<a name="l01880"></a>01880   data.<a class="code" href="classFEComputeData.php#a2766da5c11ee60472b6f39dc177b2229">init</a>();
<a name="l01881"></a>01881 
<a name="l01882"></a>01882   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_dof; n++)
<a name="l01883"></a>01883       data.<a class="code" href="classFEComputeData.php#ae9bf9a37c12e74af8a28cebb10e5610b">shape</a>[n] = <a class="code" href="classFEInterface.php#a626e655d56916777d075e72be2017523">shape</a>(dim, p_refined, elem, n, p);
<a name="l01884"></a>01884 
<a name="l01885"></a>01885    <span class="keywordflow">return</span>;
<a name="l01886"></a>01886 }
<a name="l01887"></a>01887 
<a name="l01888"></a>01888 
<a name="l01889"></a>01889 
<a name="l01890"></a>01890 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01891"></a>01891 <span class="preprocessor"></span>
<a name="l01892"></a><a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">01892</a> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">FEInterface::compute_constraints</a> (<a class="code" href="classDofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l01893"></a>01893                                        <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map,
<a name="l01894"></a>01894                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l01895"></a>01895                                        <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)
<a name="l01896"></a>01896 {
<a name="l01897"></a>01897   libmesh_assert (elem != NULL);
<a name="l01898"></a>01898 
<a name="l01899"></a>01899   <span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t = dof_map.<a class="code" href="classDofMap.php#ae3c63266417020f38af6e5cc40efca76">variable_type</a>(variable_number);
<a name="l01900"></a>01900   
<a name="l01901"></a>01901   <span class="keywordflow">switch</span> (elem-&gt;<a class="code" href="classElem.php#a72c710c9b4ebbbdebb707e74165d9625">dim</a>())
<a name="l01902"></a>01902     {
<a name="l01903"></a>01903     <span class="keywordflow">case</span> 1:
<a name="l01904"></a>01904       {
<a name="l01905"></a>01905         <span class="comment">// No constraints in 1D.</span>
<a name="l01906"></a>01906         <span class="keywordflow">return</span>;
<a name="l01907"></a>01907       }
<a name="l01908"></a>01908 
<a name="l01909"></a>01909       
<a name="l01910"></a>01910     <span class="keywordflow">case</span> 2:
<a name="l01911"></a>01911       {
<a name="l01912"></a>01912         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01913"></a>01913           {
<a name="l01914"></a>01914           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l01915"></a>01915             <a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">FE&lt;2,CLOUGH&gt;::compute_constraints</a> (constraints,
<a name="l01916"></a>01916                                                dof_map,
<a name="l01917"></a>01917                                                variable_number,
<a name="l01918"></a>01918                                                elem); <span class="keywordflow">return</span>;
<a name="l01919"></a>01919 
<a name="l01920"></a>01920           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01921"></a>01921             <a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">FE&lt;2,HERMITE&gt;::compute_constraints</a> (constraints,
<a name="l01922"></a>01922                                                 dof_map,
<a name="l01923"></a>01923                                                 variable_number,
<a name="l01924"></a>01924                                                 elem); <span class="keywordflow">return</span>;
<a name="l01925"></a>01925 
<a name="l01926"></a>01926           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01927"></a>01927             <a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">FE&lt;2,LAGRANGE&gt;::compute_constraints</a> (constraints,
<a name="l01928"></a>01928                                                  dof_map,
<a name="l01929"></a>01929                                                  variable_number,
<a name="l01930"></a>01930                                                  elem); <span class="keywordflow">return</span>;
<a name="l01931"></a>01931 
<a name="l01932"></a>01932           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01933"></a>01933             <a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">FE&lt;2,HIERARCHIC&gt;::compute_constraints</a> (constraints,
<a name="l01934"></a>01934                                                    dof_map,
<a name="l01935"></a>01935                                                    variable_number,
<a name="l01936"></a>01936                                                    elem); <span class="keywordflow">return</span>;
<a name="l01937"></a>01937 
<a name="l01938"></a>01938           <span class="keywordflow">default</span>:
<a name="l01939"></a>01939             <span class="keywordflow">return</span>;
<a name="l01940"></a>01940           }
<a name="l01941"></a>01941       }
<a name="l01942"></a>01942 
<a name="l01943"></a>01943 
<a name="l01944"></a>01944     <span class="keywordflow">case</span> 3:
<a name="l01945"></a>01945       {
<a name="l01946"></a>01946         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l01947"></a>01947           {
<a name="l01948"></a>01948           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l01949"></a>01949             <a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">FE&lt;3,HERMITE&gt;::compute_constraints</a> (constraints,
<a name="l01950"></a>01950                                                 dof_map,
<a name="l01951"></a>01951                                                 variable_number,
<a name="l01952"></a>01952                                                 elem); <span class="keywordflow">return</span>;
<a name="l01953"></a>01953 
<a name="l01954"></a>01954           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l01955"></a>01955             <a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">FE&lt;3,LAGRANGE&gt;::compute_constraints</a> (constraints,
<a name="l01956"></a>01956                                                  dof_map,
<a name="l01957"></a>01957                                                  variable_number,
<a name="l01958"></a>01958                                                  elem); <span class="keywordflow">return</span>;      
<a name="l01959"></a>01959 
<a name="l01960"></a>01960           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l01961"></a>01961             <a class="code" href="classFEInterface.php#a5c4a1f291fedb8641a3c58220f94b5b3">FE&lt;3,HIERARCHIC&gt;::compute_constraints</a> (constraints,
<a name="l01962"></a>01962                                                    dof_map,
<a name="l01963"></a>01963                                                    variable_number,
<a name="l01964"></a>01964                                                    elem); <span class="keywordflow">return</span>;
<a name="l01965"></a>01965           <span class="keywordflow">default</span>:
<a name="l01966"></a>01966             <span class="keywordflow">return</span>;
<a name="l01967"></a>01967           }
<a name="l01968"></a>01968       }
<a name="l01969"></a>01969 
<a name="l01970"></a>01970       
<a name="l01971"></a>01971     <span class="keywordflow">default</span>:
<a name="l01972"></a>01972       libmesh_error();
<a name="l01973"></a>01973     }
<a name="l01974"></a>01974 }
<a name="l01975"></a>01975 
<a name="l01976"></a>01976 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01977"></a>01977 <span class="preprocessor"></span>
<a name="l01978"></a>01978 
<a name="l01979"></a>01979 
<a name="l01980"></a>01980 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l01981"></a>01981 <span class="preprocessor"></span>
<a name="l01982"></a><a class="code" href="classFEInterface.php#a5d15bd861ecf0a755eabf1e4695d5c3b">01982</a> <span class="keywordtype">void</span> <a class="code" href="classFEInterface.php#a5d15bd861ecf0a755eabf1e4695d5c3b">FEInterface::compute_periodic_constraints</a> (<a class="code" href="classDofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l01983"></a>01983                                                 <a class="code" href="classDofMap.php">DofMap</a> &amp;dof_map,
<a name="l01984"></a>01984                                                 <a class="code" href="classPeriodicBoundaries.php">PeriodicBoundaries</a> &amp;boundaries,
<a name="l01985"></a>01985                                                 <span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l01986"></a>01986                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l01987"></a>01987                                                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem)
<a name="l01988"></a>01988 {
<a name="l01989"></a>01989   <span class="comment">// No element-specific optimizations currently exist</span>
<a name="l01990"></a>01990   <a class="code" href="classFEInterface.php#a5d15bd861ecf0a755eabf1e4695d5c3b">FEBase::compute_periodic_constraints</a> (constraints,
<a name="l01991"></a>01991                                         dof_map,
<a name="l01992"></a>01992                                         boundaries,
<a name="l01993"></a>01993                                         mesh,
<a name="l01994"></a>01994                                         variable_number,
<a name="l01995"></a>01995                                         elem);
<a name="l01996"></a>01996 }
<a name="l01997"></a>01997 
<a name="l01998"></a>01998 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l01999"></a>01999 <span class="preprocessor"></span>  
<a name="l02000"></a>02000 
<a name="l02001"></a>02001 
<a name="l02002"></a><a class="code" href="classFEInterface.php#aa5e5dfcfc5a000f3fe044153aa068bba">02002</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classFEInterface.php#aa5e5dfcfc5a000f3fe044153aa068bba">FEInterface::max_order</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t,
<a name="l02003"></a>02003                                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>&amp; el_t)
<a name="l02004"></a>02004 {
<a name="l02005"></a>02005   <span class="comment">// Yeah, I know, infinity is much larger than 11, but our</span>
<a name="l02006"></a>02006   <span class="comment">// solvers don&#39;t seem to like high degree polynomials, and our</span>
<a name="l02007"></a>02007   <span class="comment">// quadrature rules and number_lookups tables</span>
<a name="l02008"></a>02008   <span class="comment">// need to go up higher.</span>
<a name="l02009"></a>02009   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> unlimited = 11;
<a name="l02010"></a>02010 
<a name="l02011"></a>02011   <span class="comment">// If we used 0 as a default, then elements missing from this </span>
<a name="l02012"></a>02012   <span class="comment">// table (e.g. infinite elements) would be considered broken.</span>
<a name="l02013"></a>02013   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> unknown = unlimited;
<a name="l02014"></a>02014 
<a name="l02015"></a>02015   <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l02016"></a>02016     {
<a name="l02017"></a>02017       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l02018"></a>02018         <span class="keywordflow">switch</span> (el_t)
<a name="l02019"></a>02019           {
<a name="l02020"></a>02020             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l02021"></a>02021             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l02022"></a>02022             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l02023"></a>02023               <span class="keywordflow">return</span> 3;
<a name="l02024"></a>02024             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l02025"></a>02025               <span class="keywordflow">return</span> 1;
<a name="l02026"></a>02026             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l02027"></a>02027               <span class="keywordflow">return</span> 2;
<a name="l02028"></a>02028             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l02029"></a>02029               <span class="keywordflow">return</span> 1;
<a name="l02030"></a>02030             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l02031"></a>02031             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l02032"></a>02032               <span class="keywordflow">return</span> 2;
<a name="l02033"></a>02033             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l02034"></a>02034               <span class="keywordflow">return</span> 1;
<a name="l02035"></a>02035             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l02036"></a>02036               <span class="keywordflow">return</span> 2;
<a name="l02037"></a>02037             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l02038"></a>02038               <span class="keywordflow">return</span> 1;
<a name="l02039"></a>02039             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l02040"></a>02040             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l02041"></a>02041               <span class="keywordflow">return</span> 2;
<a name="l02042"></a>02042             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l02043"></a>02043             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l02044"></a>02044               <span class="keywordflow">return</span> 1;
<a name="l02045"></a>02045             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l02046"></a>02046               <span class="keywordflow">return</span> 2;
<a name="l02047"></a>02047             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l02048"></a>02048               <span class="keywordflow">return</span> 1;
<a name="l02049"></a>02049             <span class="keywordflow">default</span>:
<a name="l02050"></a>02050               <span class="keywordflow">return</span> unknown;
<a name="l02051"></a>02051           }
<a name="l02052"></a>02052         <span class="keywordflow">break</span>;
<a name="l02053"></a>02053       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l02054"></a>02054         <span class="keywordflow">switch</span> (el_t)
<a name="l02055"></a>02055           {
<a name="l02056"></a>02056             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l02057"></a>02057             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l02058"></a>02058             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l02059"></a>02059             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l02060"></a>02060             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l02061"></a>02061             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l02062"></a>02062             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l02063"></a>02063             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l02064"></a>02064             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l02065"></a>02065             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l02066"></a>02066             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l02067"></a>02067             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l02068"></a>02068             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l02069"></a>02069             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l02070"></a>02070             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l02071"></a>02071             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l02072"></a>02072             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l02073"></a>02073               <span class="keywordflow">return</span> unlimited;
<a name="l02074"></a>02074             <span class="keywordflow">default</span>:
<a name="l02075"></a>02075               <span class="keywordflow">return</span> unknown;
<a name="l02076"></a>02076           }
<a name="l02077"></a>02077         <span class="keywordflow">break</span>;
<a name="l02078"></a>02078 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l02079"></a>02079 <span class="preprocessor"></span>      <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l02080"></a>02080         <span class="keywordflow">switch</span> (el_t)
<a name="l02081"></a>02081           {
<a name="l02082"></a>02082             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l02083"></a>02083             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l02084"></a>02084             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l02085"></a>02085               <span class="keywordflow">return</span> unlimited;
<a name="l02086"></a>02086             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l02087"></a>02087               <span class="keywordflow">return</span> 0;
<a name="l02088"></a>02088             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l02089"></a>02089               <span class="keywordflow">return</span> 6;
<a name="l02090"></a>02090             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l02091"></a>02091               <span class="keywordflow">return</span> 0;
<a name="l02092"></a>02092             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l02093"></a>02093             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l02094"></a>02094               <span class="keywordflow">return</span> unlimited;
<a name="l02095"></a>02095             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l02096"></a>02096               <span class="keywordflow">return</span> 1;
<a name="l02097"></a>02097             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l02098"></a>02098               <span class="keywordflow">return</span> 2;
<a name="l02099"></a>02099             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l02100"></a>02100               <span class="keywordflow">return</span> 0;
<a name="l02101"></a>02101             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l02102"></a>02102               <span class="keywordflow">return</span> 2;
<a name="l02103"></a>02103             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l02104"></a>02104               <span class="keywordflow">return</span> 4;
<a name="l02105"></a>02105             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l02106"></a>02106             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l02107"></a>02107             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l02108"></a>02108             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l02109"></a>02109               <span class="keywordflow">return</span> 0;
<a name="l02110"></a>02110             <span class="keywordflow">default</span>:
<a name="l02111"></a>02111               <span class="keywordflow">return</span> unknown;
<a name="l02112"></a>02112           }
<a name="l02113"></a>02113         <span class="keywordflow">break</span>;
<a name="l02114"></a>02114       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l02115"></a>02115         <span class="keywordflow">switch</span> (el_t)
<a name="l02116"></a>02116           {
<a name="l02117"></a>02117             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l02118"></a>02118             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l02119"></a>02119             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l02120"></a>02120               <span class="keywordflow">return</span> 7;
<a name="l02121"></a>02121             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l02122"></a>02122               <span class="keywordflow">return</span> 0;
<a name="l02123"></a>02123             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l02124"></a>02124               <span class="keywordflow">return</span> 7;
<a name="l02125"></a>02125             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l02126"></a>02126               <span class="keywordflow">return</span> 0;
<a name="l02127"></a>02127             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l02128"></a>02128             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l02129"></a>02129               <span class="keywordflow">return</span> 7;
<a name="l02130"></a>02130             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l02131"></a>02131             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l02132"></a>02132             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l02133"></a>02133             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l02134"></a>02134             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l02135"></a>02135             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l02136"></a>02136             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l02137"></a>02137             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l02138"></a>02138             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l02139"></a>02139               <span class="keywordflow">return</span> 0;
<a name="l02140"></a>02140             <span class="keywordflow">default</span>:
<a name="l02141"></a>02141               <span class="keywordflow">return</span> unknown;
<a name="l02142"></a>02142           }
<a name="l02143"></a>02143         <span class="keywordflow">break</span>;
<a name="l02144"></a>02144 <span class="preprocessor">#endif</span>
<a name="l02145"></a>02145 <span class="preprocessor"></span>      <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l02146"></a>02146         <span class="keywordflow">switch</span> (el_t)
<a name="l02147"></a>02147           {
<a name="l02148"></a>02148             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l02149"></a>02149             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l02150"></a>02150             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l02151"></a>02151             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l02152"></a>02152             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l02153"></a>02153             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l02154"></a>02154             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l02155"></a>02155             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l02156"></a>02156             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l02157"></a>02157             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l02158"></a>02158             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l02159"></a>02159             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l02160"></a>02160             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l02161"></a>02161             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l02162"></a>02162             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l02163"></a>02163             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l02164"></a>02164             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l02165"></a>02165               <span class="keywordflow">return</span> unlimited;
<a name="l02166"></a>02166             <span class="keywordflow">default</span>:
<a name="l02167"></a>02167               <span class="keywordflow">return</span> unknown;
<a name="l02168"></a>02168           }
<a name="l02169"></a>02169         <span class="keywordflow">break</span>;
<a name="l02170"></a>02170       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l02171"></a>02171         <span class="keywordflow">switch</span> (el_t)
<a name="l02172"></a>02172           {
<a name="l02173"></a>02173             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l02174"></a>02174             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l02175"></a>02175               <span class="keywordflow">return</span> 3;
<a name="l02176"></a>02176             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l02177"></a>02177             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l02178"></a>02178               <span class="keywordflow">return</span> 0;
<a name="l02179"></a>02179             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l02180"></a>02180               <span class="keywordflow">return</span> 3;
<a name="l02181"></a>02181             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l02182"></a>02182             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l02183"></a>02183             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l02184"></a>02184             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l02185"></a>02185             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l02186"></a>02186             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l02187"></a>02187             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l02188"></a>02188             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l02189"></a>02189             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l02190"></a>02190             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l02191"></a>02191             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l02192"></a>02192             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l02193"></a>02193               <span class="keywordflow">return</span> 0;
<a name="l02194"></a>02194             <span class="keywordflow">default</span>:
<a name="l02195"></a>02195               <span class="keywordflow">return</span> unknown;
<a name="l02196"></a>02196           }
<a name="l02197"></a>02197         <span class="keywordflow">break</span>;
<a name="l02198"></a>02198       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l02199"></a>02199         <span class="keywordflow">switch</span> (el_t)
<a name="l02200"></a>02200           {
<a name="l02201"></a>02201             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l02202"></a>02202             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l02203"></a>02203               <span class="keywordflow">return</span> unlimited;
<a name="l02204"></a>02204             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l02205"></a>02205             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l02206"></a>02206             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l02207"></a>02207               <span class="keywordflow">return</span> 0;
<a name="l02208"></a>02208             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l02209"></a>02209               <span class="keywordflow">return</span> 3;
<a name="l02210"></a>02210             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l02211"></a>02211             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l02212"></a>02212               <span class="keywordflow">return</span> unlimited;
<a name="l02213"></a>02213             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l02214"></a>02214             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l02215"></a>02215               <span class="keywordflow">return</span> 0;
<a name="l02216"></a>02216             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l02217"></a>02217               <span class="keywordflow">return</span> 3;
<a name="l02218"></a>02218             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l02219"></a>02219             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l02220"></a>02220               <span class="keywordflow">return</span> unlimited;
<a name="l02221"></a>02221             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l02222"></a>02222             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l02223"></a>02223             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l02224"></a>02224             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l02225"></a>02225               <span class="keywordflow">return</span> 0;
<a name="l02226"></a>02226             <span class="keywordflow">default</span>:
<a name="l02227"></a>02227               <span class="keywordflow">return</span> unknown;
<a name="l02228"></a>02228           }
<a name="l02229"></a>02229         <span class="keywordflow">break</span>;
<a name="l02230"></a>02230       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l02231"></a>02231         <span class="keywordflow">switch</span> (el_t)
<a name="l02232"></a>02232           {
<a name="l02233"></a>02233             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l02234"></a>02234             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l02235"></a>02235             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l02236"></a>02236               <span class="keywordflow">return</span> unlimited;
<a name="l02237"></a>02237             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l02238"></a>02238               <span class="keywordflow">return</span> 1;
<a name="l02239"></a>02239             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l02240"></a>02240               <span class="keywordflow">return</span> unlimited;
<a name="l02241"></a>02241             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l02242"></a>02242               <span class="keywordflow">return</span> 1;
<a name="l02243"></a>02243             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l02244"></a>02244             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l02245"></a>02245               <span class="keywordflow">return</span> unlimited;
<a name="l02246"></a>02246             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l02247"></a>02247             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l02248"></a>02248               <span class="keywordflow">return</span> 0;
<a name="l02249"></a>02249             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l02250"></a>02250             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l02251"></a>02251               <span class="keywordflow">return</span> 1;
<a name="l02252"></a>02252             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l02253"></a>02253               <span class="keywordflow">return</span> unlimited;
<a name="l02254"></a>02254             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l02255"></a>02255             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l02256"></a>02256             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l02257"></a>02257             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l02258"></a>02258               <span class="keywordflow">return</span> 0;
<a name="l02259"></a>02259             <span class="keywordflow">default</span>:
<a name="l02260"></a>02260               <span class="keywordflow">return</span> unknown;
<a name="l02261"></a>02261           }
<a name="l02262"></a>02262         <span class="keywordflow">break</span>;
<a name="l02263"></a>02263       <span class="keywordflow">default</span>:
<a name="l02264"></a>02264         <span class="keywordflow">return</span> 0;
<a name="l02265"></a>02265         <span class="keywordflow">break</span>;
<a name="l02266"></a>02266     }
<a name="l02267"></a>02267 }
<a name="l02268"></a>02268 
<a name="l02269"></a>02269   
<a name="l02270"></a>02270 
<a name="l02271"></a><a class="code" href="classFEInterface.php#a3d821150f7d5a6315292b5c2117ef417">02271</a> <span class="keywordtype">bool</span> <a class="code" href="classFEInterface.php#a3d821150f7d5a6315292b5c2117ef417">FEInterface::extra_hanging_dofs</a>(<span class="keyword">const</span> <a class="code" href="classFEType.php">FEType</a>&amp; fe_t)
<a name="l02272"></a>02272 {
<a name="l02273"></a>02273   <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classFEType.php#a22c439dc134e1ba4695d39368fc55e99">family</a>)
<a name="l02274"></a>02274     {
<a name="l02275"></a>02275       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l02276"></a>02276       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>:
<a name="l02277"></a>02277 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l02278"></a>02278 <span class="preprocessor"></span>      <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a55dc18be37e759512e76ab9e3354dd1b">BERNSTEIN</a>:
<a name="l02279"></a>02279       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>:
<a name="l02280"></a>02280 <span class="preprocessor">#endif</span>
<a name="l02281"></a>02281 <span class="preprocessor"></span>      <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>:
<a name="l02282"></a>02282         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l02283"></a>02283       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>:
<a name="l02284"></a>02284       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>:
<a name="l02285"></a>02285       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>:
<a name="l02286"></a>02286       <span class="keywordflow">default</span>:
<a name="l02287"></a>02287         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l02288"></a>02288     }
<a name="l02289"></a>02289 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
