<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_a444518d96d2df902338d2a7eb3a040c.php">base</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>getpot.h</h1>  </div>
</div>
<div class="contents">
<a href="getpot_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: getpot.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 <span class="comment">//</span>
<a name="l00003"></a>00003 <span class="comment">// (with patches from Michael Anderson for more general variable types)</span>
<a name="l00004"></a>00004 
<a name="l00005"></a>00005 <span class="comment">//  -*- c++ -*- </span>
<a name="l00006"></a>00006 <span class="comment">//  GetPot Version 1.0                                        Sept/13/2002</span>
<a name="l00007"></a>00007 <span class="comment">//  </span>
<a name="l00008"></a>00008 <span class="comment">//  WEBSITE: http://getpot.sourceforge.net</span>
<a name="l00009"></a>00009 <span class="comment">//  </span>
<a name="l00010"></a>00010 <span class="comment">//  This library is  free software; you can redistribute  it and/or modify</span>
<a name="l00011"></a>00011 <span class="comment">//  it  under  the terms  of  the GNU  Lesser  General  Public License  as</span>
<a name="l00012"></a>00012 <span class="comment">//  published by the  Free Software Foundation; either version  2.1 of the</span>
<a name="l00013"></a>00013 <span class="comment">//  License, or (at your option) any later version.</span>
<a name="l00014"></a>00014 <span class="comment">//  </span>
<a name="l00015"></a>00015 <span class="comment">//  This library  is distributed in the  hope that it will  be useful, but</span>
<a name="l00016"></a>00016 <span class="comment">//  WITHOUT   ANY  WARRANTY;   without  even   the  implied   warranty  of</span>
<a name="l00017"></a>00017 <span class="comment">//  MERCHANTABILITY  or FITNESS  FOR A  PARTICULAR PURPOSE.   See  the GNU</span>
<a name="l00018"></a>00018 <span class="comment">//  Lesser General Public License for more details.</span>
<a name="l00019"></a>00019 <span class="comment">//  </span>
<a name="l00020"></a>00020 <span class="comment">//  You  should have  received a  copy of  the GNU  Lesser  General Public</span>
<a name="l00021"></a>00021 <span class="comment">//  License along  with this library; if  not, write to  the Free Software</span>
<a name="l00022"></a>00022 <span class="comment">//  Foundation, Inc.,  59 Temple Place,  Suite 330, Boston,  MA 02111-1307</span>
<a name="l00023"></a>00023 <span class="comment">//  USA</span>
<a name="l00024"></a>00024 <span class="comment">//  </span>
<a name="l00025"></a>00025 <span class="comment">//  (C) 2001-2002 Frank R. Schaefer  </span>
<a name="l00026"></a>00026 <span class="comment">//==========================================================================</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef __GETPOT_H__</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define __GETPOT_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#if defined(WIN32) || defined(SOLARIS_RAW) || defined(__SUNPRO_CC) || (__GNUC__ == 2) || defined(__HP_aCC) || defined (__CYGWIN__)</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#  define strtok_r(a, b, c) std::strtok(a, b)</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#endif // WINDOWS or SOLARIS or gcc 2.* or HP aCC or CYGWIN</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#define GETPOT_ALLOW_VARGS</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;cctype&gt;</span> 
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;cstdio&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#ifdef GETPOT_ALLOW_VARGS</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;cstdarg&gt;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#endif</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="preprocessor">#include &lt;math.h&gt;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00050"></a>00050 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00051"></a>00051 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="preprocessor">#define victorate(TYPE, VARIABLE, ITERATOR) \</span>
<a name="l00055"></a>00055 <span class="preprocessor">for(std::vector&lt;TYPE&gt;::const_iterator (ITERATOR) = (VARIABLE).begin(); \</span>
<a name="l00056"></a>00056 <span class="preprocessor">    (ITERATOR) != (VARIABLE).end(); ++(ITERATOR))</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classGetPot.php">00059</a> <span class="keyword">class </span><a class="code" href="classGetPot.php">GetPot</a> {
<a name="l00060"></a>00060   <span class="comment">//--------</span>
<a name="l00061"></a>00061   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classGetPot.php#a7e5a50b5320deb27205a6bd939a656d1">__basic_initialization</a>();
<a name="l00062"></a>00062   <span class="keyword">public</span>:
<a name="l00063"></a>00063   <span class="comment">// (*) constructors, destructor, assignment operator -----------------------</span>
<a name="l00064"></a>00064   <span class="keyword">inline</span> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot</a>();
<a name="l00065"></a>00065   <span class="keyword">inline</span> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot</a>(<span class="keyword">const</span> <a class="code" href="classGetPot.php">GetPot</a>&amp;);
<a name="l00066"></a>00066   <span class="keyword">inline</span> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot</a>(<span class="keywordtype">int</span> argc_, <span class="keywordtype">char</span> ** argv_);
<a name="l00067"></a>00067   <span class="keyword">inline</span> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* FileName);
<a name="l00068"></a>00068   <span class="keyword">inline</span> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot</a>(<span class="keyword">const</span> std::string &amp;FileName);
<a name="l00069"></a>00069   <span class="keyword">inline</span> <a class="code" href="classGetPot.php#a42a3a4f6bc0035c64ee5fa13859310db">~GetPot</a>();
<a name="l00070"></a>00070   <span class="keyword">inline</span> <a class="code" href="classGetPot.php">GetPot</a>&amp; <a class="code" href="classGetPot.php#a92c9fa06ffb4b578cdbb6e9200d27249">operator=</a>(<span class="keyword">const</span> <a class="code" href="classGetPot.php">GetPot</a>&amp;);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">// (*) parse methods for command line &amp; input files ------------------------</span>
<a name="l00073"></a>00073   <span class="keyword">inline</span> <span class="keywordtype">void</span>         <a class="code" href="classGetPot.php#a9c6f64040ac5979e017ea4b7a44d49c6">parse_command_line</a> (<span class="keywordtype">int</span> argc_, <span class="keywordtype">char</span> ** argv_);
<a name="l00074"></a>00074   <span class="keyword">inline</span> <span class="keywordtype">void</span>         <a class="code" href="classGetPot.php#aa585a3a5169ec7d5e745ff48aa4b1d29">parse_input_file</a>   (<span class="keyword">const</span> std::string&amp; FileName);
<a name="l00075"></a>00075   <span class="keyword">inline</span> <span class="keywordtype">void</span>         <a class="code" href="classGetPot.php#aa585a3a5169ec7d5e745ff48aa4b1d29">parse_input_file</a>   (<span class="keyword">const</span> <span class="keywordtype">char</span>* FileName);
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <span class="comment">// (*) direct access to command line arguments -----------------------------</span>
<a name="l00078"></a>00078   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*  <a class="code" href="classGetPot.php#a2b57efabc69cfeaccc4a357313349816">operator[]</a>(<span class="keywordtype">unsigned</span> Idx) <span class="keyword">const</span>;
<a name="l00079"></a>00079   <span class="keyword">inline</span> <span class="keywordtype">int</span>          <span class="keyword">get</span>(<span class="keywordtype">unsigned</span> Idx, <span class="keywordtype">int</span>         Default) <span class="keyword">const</span>;
<a name="l00080"></a>00080   <span class="keyword">inline</span> <span class="keywordtype">double</span>       <span class="keyword">get</span>(<span class="keywordtype">unsigned</span> Idx, <span class="keywordtype">double</span>      Default) <span class="keyword">const</span>;
<a name="l00081"></a>00081   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*  <span class="keyword">get</span>(<span class="keywordtype">unsigned</span> Idx, <span class="keyword">const</span> <span class="keywordtype">char</span>* Default) <span class="keyword">const</span>;
<a name="l00082"></a>00082   <span class="keyword">inline</span> <span class="keywordtype">unsigned</span>     <a class="code" href="classGetPot.php#a2d932ac1adaa8c96cd7d6a9379bee729">size</a>() <span class="keyword">const</span>; 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">// (*) flags ---------------------------------------------------------------</span>
<a name="l00085"></a>00085   <span class="keyword">inline</span> <span class="keywordtype">bool</span>         <a class="code" href="classGetPot.php#ae0ca20c8e8ddd2908d8d47e0a2d0569b">options_contain</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* FlagList) <span class="keyword">const</span>;
<a name="l00086"></a>00086   <span class="keyword">inline</span> <span class="keywordtype">bool</span>         <a class="code" href="classGetPot.php#a30b6999f373de76e53eb702667b0b09f">argument_contains</a>(<span class="keywordtype">unsigned</span> Idx, <span class="keyword">const</span> <span class="keywordtype">char</span>* FlagList) <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="comment">// (*) variables -----------------------------------------------------------</span>
<a name="l00089"></a>00089   <span class="comment">//     -- check for a variable</span>
<a name="l00090"></a>00090   <span class="keyword">inline</span> <span class="keywordtype">bool</span>         <a class="code" href="classGetPot.php#adc3475ba87c72e6ea8b84de02d2ef58f">have_variable</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName) <span class="keyword">const</span>;
<a name="l00091"></a>00091   <span class="comment">//     -- scalar values</span>
<a name="l00092"></a>00092   <span class="keyword">inline</span> <span class="keywordtype">bool</span>         <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">bool</span>        Default) <span class="keyword">const</span>;
<a name="l00093"></a>00093   <span class="keyword">inline</span> <span class="keywordtype">int</span>          <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">int</span>         Default) <span class="keyword">const</span>;
<a name="l00094"></a>00094   <span class="keyword">inline</span> <span class="keywordtype">double</span>       <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">double</span>      Default) <span class="keyword">const</span>;
<a name="l00095"></a>00095   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span>  <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">long</span> <span class="keywordtype">double</span> Default) <span class="keyword">const</span>;
<a name="l00096"></a>00096   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*  <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keyword">const</span> <span class="keywordtype">char</span>* Default) <span class="keyword">const</span>;
<a name="l00097"></a>00097   <span class="keyword">inline</span> std::string  <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keyword">const</span> std::string&amp; Default) <span class="keyword">const</span>;
<a name="l00098"></a>00098   <span class="comment">//     -- vectors</span>
<a name="l00099"></a>00099   <span class="keyword">inline</span> <span class="keywordtype">int</span>          <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">int</span>         Default, <span class="keywordtype">unsigned</span> Idx) <span class="keyword">const</span>;
<a name="l00100"></a>00100   <span class="keyword">inline</span> <span class="keywordtype">double</span>       <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">double</span>      Default, <span class="keywordtype">unsigned</span> Idx) <span class="keyword">const</span>;
<a name="l00101"></a>00101   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*  <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keyword">const</span> <span class="keywordtype">char</span>* Default, <span class="keywordtype">unsigned</span> Idx) <span class="keyword">const</span>;
<a name="l00102"></a>00102   <span class="keyword">inline</span> <span class="keywordtype">unsigned</span>     <a class="code" href="classGetPot.php#ac58129dc7b1cccfa45a7175f33c8d6c3">vector_variable_size</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName) <span class="keyword">const</span>;
<a name="l00103"></a>00103   <span class="keyword">inline</span> std::vector&lt;std::string&gt; <a class="code" href="classGetPot.php#a7dff9aa415fc2f74e5b7c6a38db0fa30">get_variable_names</a>() <span class="keyword">const</span>;
<a name="l00104"></a>00104   <span class="keyword">inline</span> std::vector&lt;std::string&gt; <a class="code" href="classGetPot.php#a3b76628a2f0ae4394386663a6985c598">get_section_names</a>() <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="comment">// (*) cursor oriented functions -------------------------------------------</span>
<a name="l00108"></a><a class="code" href="classGetPot.php#a19e24ca540e9e72ea3a8a8780d950a22">00108</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span>         <a class="code" href="classGetPot.php#a19e24ca540e9e72ea3a8a8780d950a22">set_prefix</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Prefix) { <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> = std::string(Prefix); }
<a name="l00109"></a><a class="code" href="classGetPot.php#aa7f00aca576d29d198e8e1bfef34fd50">00109</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span>         <a class="code" href="classGetPot.php#aa7f00aca576d29d198e8e1bfef34fd50">set_prefix</a>(<span class="keyword">const</span> std::string &amp; Prefix) { <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> = Prefix; }
<a name="l00110"></a><a class="code" href="classGetPot.php#a5d6af0d1618f40cb9d0acaba79931014">00110</a>   <span class="keyword">inline</span> <span class="keywordtype">bool</span>         <a class="code" href="classGetPot.php#a5d6af0d1618f40cb9d0acaba79931014">search_failed</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a>; }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="comment">//     -- enable/disable search for an option in loop</span>
<a name="l00113"></a><a class="code" href="classGetPot.php#a84b0e0199ae3df63c01ea125a16be83f">00113</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span>         <a class="code" href="classGetPot.php#a84b0e0199ae3df63c01ea125a16be83f">disable_loop</a>() { <a class="code" href="classGetPot.php#ae6e6ca5fb70e92b0e7e4f6717ec6a15a">search_loop_f</a> = <span class="keyword">false</span>; }
<a name="l00114"></a><a class="code" href="classGetPot.php#a99f8e9cc6ff54d0abf4ef090cd39d8a7">00114</a>   <span class="keyword">inline</span> <span class="keywordtype">void</span>         <a class="code" href="classGetPot.php#a99f8e9cc6ff54d0abf4ef090cd39d8a7">enable_loop</a>()  { <a class="code" href="classGetPot.php#ae6e6ca5fb70e92b0e7e4f6717ec6a15a">search_loop_f</a> = <span class="keyword">true</span>; }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="comment">//     -- reset cursor to position &#39;1&#39;</span>
<a name="l00117"></a>00117   <span class="keyword">inline</span> <span class="keywordtype">void</span>         <a class="code" href="classGetPot.php#ad55107a9bd39804599844194218e8e3a">reset_cursor</a>();
<a name="l00118"></a>00118   <span class="keyword">inline</span> <span class="keywordtype">void</span>         <a class="code" href="classGetPot.php#af8d29a623cd9a37d9f133c66b712efc5">init_multiple_occurrence</a>();
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">//     -- search for a certain option and set cursor to position</span>
<a name="l00121"></a>00121   <span class="keyword">inline</span> <span class="keywordtype">bool</span>         <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* option);
<a name="l00122"></a>00122   <span class="keyword">inline</span> <span class="keywordtype">bool</span>         <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(<span class="keyword">const</span> std::string &amp;option);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="preprocessor">#ifdef GETPOT_ALLOW_VARGS</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>  <span class="comment">// TODO:    BAD USING VARGS</span>
<a name="l00127"></a>00127     <span class="keyword">inline</span> <span class="keywordtype">bool</span>         <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(<span class="keywordtype">unsigned</span> No, <span class="keyword">const</span> <span class="keywordtype">char</span>* P, ...);
<a name="l00128"></a>00128 <span class="preprocessor">#endif</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00130"></a>00130   <span class="comment">//     -- get argument at cursor++</span>
<a name="l00131"></a>00131   <span class="keyword">inline</span> <span class="keywordtype">int</span>          <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(<span class="keywordtype">int</span>           Default);
<a name="l00132"></a>00132   <span class="keyword">inline</span> <span class="keywordtype">double</span>       <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(<span class="keywordtype">double</span> Default);
<a name="l00133"></a>00133   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*  <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>*   Default);
<a name="l00134"></a>00134   <span class="keyword">inline</span> std::string  <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(<span class="keyword">const</span> std::string   &amp;Default);
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   <span class="comment">//     -- search for option and get argument at cursor++</span>
<a name="l00137"></a>00137   <span class="keyword">inline</span> <span class="keywordtype">int</span>          <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">follow</a>(<span class="keywordtype">int</span>           Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option);
<a name="l00138"></a>00138   <span class="keyword">inline</span> <span class="keywordtype">double</span>       <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">follow</a>(<span class="keywordtype">double</span> Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option);
<a name="l00139"></a>00139   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*  <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">follow</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>*   Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">//     -- search for one of the given options and get argument that follows it</span>
<a name="l00142"></a>00142 <span class="preprocessor">#ifdef GETPOT_ALLOW_VARGS</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>  <span class="comment">// TODO:    BAD USING VARGS</span>
<a name="l00144"></a>00144   <span class="keyword">inline</span> <span class="keywordtype">int</span>          <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">follow</a>(<span class="keywordtype">int</span>           Default, <span class="keywordtype">unsigned</span> No, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option, ...);
<a name="l00145"></a>00145   <span class="keyword">inline</span> <span class="keywordtype">double</span>       <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">follow</a>(<span class="keywordtype">double</span> Default, <span class="keywordtype">unsigned</span> No, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option, ...);
<a name="l00146"></a>00146   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*  <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">follow</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>*   Default, <span class="keywordtype">unsigned</span> No, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option, ...);
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>
<a name="l00149"></a>00149   <span class="comment">//     -- directly followed arguments </span>
<a name="l00150"></a>00150   <span class="keyword">inline</span> <span class="keywordtype">int</span>          <a class="code" href="classGetPot.php#a2eec5ed54d86646402e5e16485601fea">direct_follow</a>(<span class="keywordtype">int</span>           Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option);
<a name="l00151"></a>00151   <span class="keyword">inline</span> <span class="keywordtype">double</span>       <a class="code" href="classGetPot.php#a2eec5ed54d86646402e5e16485601fea">direct_follow</a>(<span class="keywordtype">double</span> Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option);
<a name="l00152"></a>00152   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*  <a class="code" href="classGetPot.php#a2eec5ed54d86646402e5e16485601fea">direct_follow</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>*   Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option);
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// (*) nominus arguments ---------------------------------------------------</span>
<a name="l00155"></a>00155   <span class="keyword">inline</span> <span class="keywordtype">void</span>                      <a class="code" href="classGetPot.php#a3a2ef52f5233b7c7fc0044a1b2e92ff7">reset_nominus_cursor</a>();
<a name="l00156"></a>00156   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#a71533816009fe25d4b1306aaa5f4e041">nominus_vector</a>() <span class="keyword">const</span>;
<a name="l00157"></a><a class="code" href="classGetPot.php#ab696e5463b8a7e1e5cbab563e406db60">00157</a>   <span class="keyword">inline</span> <span class="keywordtype">unsigned</span>                  <a class="code" href="classGetPot.php#ab696e5463b8a7e1e5cbab563e406db60">nominus_size</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">idx_nominus</a>.size(); }
<a name="l00158"></a>00158   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*               <a class="code" href="classGetPot.php#af2e290d253b1c20d9dffb995a5af4d4b">next_nominus</a>();
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">// (*) unidentified flying objects -----------------------------------------</span>
<a name="l00161"></a>00161   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#a1d5444f8f57c23d1568de392aaaf2016">unidentified_arguments</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns) <span class="keyword">const</span>;
<a name="l00162"></a>00162   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#ade9b7d19d72cab14d3af460906c56667">unidentified_options</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns) <span class="keyword">const</span>;
<a name="l00163"></a>00163   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#a376abbc67b3560db36f7393817cad391">unidentified_variables</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns) <span class="keyword">const</span>;
<a name="l00164"></a>00164   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#a3d56e136650aa9efb5a72ad4cbe400fb">unidentified_sections</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns) <span class="keyword">const</span>;
<a name="l00165"></a>00165   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#ab15068c3bafe041868c9796e73ba3646">unidentified_nominuses</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns) <span class="keyword">const</span>;
<a name="l00166"></a>00166   
<a name="l00167"></a>00167   <span class="keyword">inline</span> std::string  <a class="code" href="classGetPot.php#a3b4c3f3128a38c2a24c977f9c5371c1a">unidentified_flags</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Known, 
<a name="l00168"></a>00168                                          <span class="keywordtype">int</span> ArgumentNumber <span class="comment">/* =-1 */</span>) <span class="keyword">const</span>;
<a name="l00169"></a>00169 <span class="preprocessor">#ifdef GETPOT_ALLOW_VARGS</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>  <span class="comment">// TODO:    BAD USING VARGS</span>
<a name="l00171"></a>00171   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#a1d5444f8f57c23d1568de392aaaf2016">unidentified_arguments</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, <span class="keyword">const</span> <span class="keywordtype">char</span>* Known, ...) <span class="keyword">const</span>;
<a name="l00172"></a>00172   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#ade9b7d19d72cab14d3af460906c56667">unidentified_options</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, <span class="keyword">const</span> <span class="keywordtype">char</span>* Known, ...) <span class="keyword">const</span>;
<a name="l00173"></a>00173   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#a376abbc67b3560db36f7393817cad391">unidentified_variables</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, <span class="keyword">const</span> <span class="keywordtype">char</span>* Known, ...) <span class="keyword">const</span>;
<a name="l00174"></a>00174   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#a3d56e136650aa9efb5a72ad4cbe400fb">unidentified_sections</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, <span class="keyword">const</span> <span class="keywordtype">char</span>* Known, ...) <span class="keyword">const</span>;
<a name="l00175"></a>00175   <span class="keyword">inline</span> std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#ab15068c3bafe041868c9796e73ba3646">unidentified_nominuses</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, <span class="keyword">const</span> <span class="keywordtype">char</span>* Known, ...) <span class="keyword">const</span>;
<a name="l00176"></a>00176 <span class="preprocessor">#endif</span>
<a name="l00177"></a>00177 <span class="preprocessor"></span>
<a name="l00178"></a>00178   <span class="comment">// (*) output --------------------------------------------------------------</span>
<a name="l00179"></a>00179   <span class="keyword">inline</span> <span class="keywordtype">int</span> <a class="code" href="classGetPot.php#a50eb9af9aec818bf434da399bb3644d1">print</a>() <span class="keyword">const</span>;
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   <span class="keyword">private</span>:
<a name="l00182"></a>00182   <span class="comment">// (*) Type Declaration ----------------------------------------------------</span>
<a name="l00183"></a><a class="code" href="structGetPot_1_1variable.php">00183</a>   <span class="keyword">struct </span><a class="code" href="structGetPot_1_1variable.php">variable</a> {
<a name="l00184"></a>00184     <span class="comment">//-----------</span>
<a name="l00185"></a>00185     <span class="comment">// Variable to be specified on the command line or in input files.</span>
<a name="l00186"></a>00186     <span class="comment">// (i.e. of the form var=&#39;12 312 341&#39;)</span>
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="comment">// -- constructors, destructors, assignment operator</span>
<a name="l00189"></a>00189     <a class="code" href="structGetPot_1_1variable.php#a53dc34d72895adde8df26c8edec0ddbd">variable</a>();
<a name="l00190"></a>00190     <a class="code" href="structGetPot_1_1variable.php#a53dc34d72895adde8df26c8edec0ddbd">variable</a>(<span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>&amp;);
<a name="l00191"></a>00191     <a class="code" href="structGetPot_1_1variable.php#a53dc34d72895adde8df26c8edec0ddbd">variable</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Name, <span class="keyword">const</span> <span class="keywordtype">char</span>* Value);
<a name="l00192"></a>00192     <a class="code" href="structGetPot_1_1variable.php#ad3b121a0b18dc153e734a1d68b8ff882">~variable</a>();
<a name="l00193"></a>00193     <a class="code" href="structGetPot_1_1variable.php">variable</a>&amp; <a class="code" href="structGetPot_1_1variable.php#ae5d596e76d1cf7f780becbce8e283a1d">operator=</a>(<span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>&amp; Other);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195     <span class="keywordtype">void</span>      <a class="code" href="structGetPot_1_1variable.php#ac6436ee90263756d3446b088cad447f7">take</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Value);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197     <span class="comment">// -- get a specific element in the string vector</span>
<a name="l00198"></a>00198     <span class="comment">//    (return 0 if not present)</span>
<a name="l00199"></a>00199     <span class="keyword">const</span> std::string*  <a class="code" href="structGetPot_1_1variable.php#afbec5f1b56e2c6d4929cae8de7bc0f89">get_element</a>(<span class="keywordtype">unsigned</span> Idx) <span class="keyword">const</span>;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201     <span class="comment">// -- data memebers</span>
<a name="l00202"></a><a class="code" href="structGetPot_1_1variable.php#aafb48af9c71fbcd816917ee7ec25bed0">00202</a>     std::string         <a class="code" href="structGetPot_1_1variable.php#aafb48af9c71fbcd816917ee7ec25bed0">name</a>;      <span class="comment">// identifier of variable</span>
<a name="l00203"></a><a class="code" href="structGetPot_1_1variable.php#a8900906a1cbdf47618278b468ef6283d">00203</a>     std::vector&lt;std::string&gt; <a class="code" href="structGetPot_1_1variable.php#a8900906a1cbdf47618278b468ef6283d">value</a>;     <span class="comment">// value of variable stored in vector</span>
<a name="l00204"></a><a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">00204</a>     std::string         <a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>;  <span class="comment">// value of variable as given on command line</span>
<a name="l00205"></a>00205   };
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="comment">// (*) member variables --------------------------------------------------------------</span>
<a name="l00208"></a><a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">00208</a>   std::string          <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>;          <span class="comment">// prefix automatically added in queries</span>
<a name="l00209"></a><a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">00209</a>   std::string          <a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">section</a>;         <span class="comment">// (for dollar bracket parsing)</span>
<a name="l00210"></a><a class="code" href="classGetPot.php#a8b8f2d90bc5546a69172c19c23ddfe10">00210</a>   std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#a8b8f2d90bc5546a69172c19c23ddfe10">section_list</a>;    <span class="comment">// list of all parsed sections</span>
<a name="l00211"></a>00211   <span class="comment">//     -- argurment vector </span>
<a name="l00212"></a><a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">00212</a>   std::vector&lt;std::string&gt;  <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>;            <span class="comment">// vector of command line arguments stored as strings</span>
<a name="l00213"></a><a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">00213</a>   <span class="keywordtype">unsigned</span>        <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>;          <span class="comment">// cursor for argv</span>
<a name="l00214"></a><a class="code" href="classGetPot.php#ae6e6ca5fb70e92b0e7e4f6717ec6a15a">00214</a>   <span class="keywordtype">bool</span>            <a class="code" href="classGetPot.php#ae6e6ca5fb70e92b0e7e4f6717ec6a15a">search_loop_f</a>;   <span class="comment">// shall search start at beginning after</span>
<a name="l00215"></a>00215   <span class="comment">//                               // reaching end of arg array ?</span>
<a name="l00216"></a><a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">00216</a>   <span class="keywordtype">bool</span>            <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a>; <span class="comment">// flag indicating a failed search() operation</span>
<a name="l00217"></a>00217   <span class="comment">//                               // (e.g. next() functions react with &#39;missed&#39;)</span>
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="comment">//     --  nominus vector </span>
<a name="l00220"></a><a class="code" href="classGetPot.php#a1a9c5bf4bc324f13459a9ca99fdc72eb">00220</a>   <span class="keywordtype">int</span>              <a class="code" href="classGetPot.php#a1a9c5bf4bc324f13459a9ca99fdc72eb">nominus_cursor</a>; <span class="comment">// cursor for nominus_pointers</span>
<a name="l00221"></a><a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">00221</a>   std::vector&lt;unsigned&gt; <a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">idx_nominus</a>;     <span class="comment">// indecies of &#39;no minus&#39; arguments</span>
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="comment">//    -- intern variables </span>
<a name="l00224"></a>00224   <span class="comment">//       (arguments of the form &quot;variable=value&quot;)</span>
<a name="l00225"></a><a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">00225</a>   std::vector&lt;variable&gt; <a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">variables</a>; 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="comment">// (*) helper functions ----------------------------------------------------</span>
<a name="l00228"></a>00228   <span class="comment">//     -- produce three basic data vectors:</span>
<a name="l00229"></a>00229   <span class="comment">//          - argument vector</span>
<a name="l00230"></a>00230   <span class="comment">//          - nominus vector</span>
<a name="l00231"></a>00231   <span class="comment">//          - variable dictionary</span>
<a name="l00232"></a>00232   <span class="keyword">inline</span> <span class="keywordtype">void</span>          <a class="code" href="classGetPot.php#a0ebeb7787334269d1a08094d356a7c11">__parse_argument_vector</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; ARGV);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   <span class="comment">//     -- helpers for argument list processing</span>
<a name="l00235"></a>00235   <span class="comment">//        * search for a variable in &#39;variables&#39; array</span>
<a name="l00236"></a>00236   <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>*  <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>*) <span class="keyword">const</span>;
<a name="l00237"></a>00237   <span class="comment">//        * support finding directly followed arguments</span>
<a name="l00238"></a>00238   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*   <a class="code" href="classGetPot.php#a7bf8707b91c842d22acb956fc03e0454">__match_starting_string</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* StartString);
<a name="l00239"></a>00239   <span class="comment">//        * support search for flags in a specific argument</span>
<a name="l00240"></a>00240   <span class="keyword">inline</span> <span class="keywordtype">bool</span>          <a class="code" href="classGetPot.php#abfa713c1ea40427eb6983c9c11a14938">__check_flags</a>(<span class="keyword">const</span> std::string&amp; Str, <span class="keyword">const</span> <span class="keywordtype">char</span>* FlagList) <span class="keyword">const</span>;
<a name="l00241"></a>00241   <span class="comment">//        * type conversion if possible     </span>
<a name="l00242"></a>00242   <span class="keyword">inline</span> <span class="keywordtype">int</span>      <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keywordtype">int</span> Default) <span class="keyword">const</span>;
<a name="l00243"></a>00243   <span class="keyword">inline</span> <span class="keywordtype">double</span>   <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keywordtype">double</span> Default) <span class="keyword">const</span>;
<a name="l00244"></a>00244   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span>   <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keywordtype">long</span> <span class="keywordtype">double</span> Default) <span class="keyword">const</span>;
<a name="l00245"></a>00245   <span class="keyword">inline</span> <span class="keywordtype">bool</span>     <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keywordtype">bool</span> Default) <span class="keyword">const</span>;
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <span class="comment">//        * prefix extraction</span>
<a name="l00248"></a>00248   <span class="keyword">const</span> std::string    <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keyword">const</span> std::string&amp; Start) <span class="keyword">const</span>;
<a name="l00249"></a>00249   <span class="comment">//        * search for a specific string</span>
<a name="l00250"></a>00250   <span class="keyword">inline</span> <span class="keywordtype">bool</span>          <a class="code" href="classGetPot.php#acbcfcc3a4ac55ecedb94eaefe7685821">__search_string_vector</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Vec, 
<a name="l00251"></a>00251       <span class="keyword">const</span> std::string&amp; Str) <span class="keyword">const</span>;    
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">//     -- helpers to parse input files</span>
<a name="l00254"></a>00254   <span class="comment">//        create an argument vector based on data found in an input file, i.e.:</span>
<a name="l00255"></a>00255   <span class="comment">//           1) delete &#39;#&#39;-comments </span>
<a name="l00256"></a>00256   <span class="comment">//           2) contract assignment expressions, such as</span>
<a name="l00257"></a>00257   <span class="comment">//                   my-variable   =    &#39;007 J. B.&#39;</span>
<a name="l00258"></a>00258   <span class="comment">//             into </span>
<a name="l00259"></a>00259   <span class="comment">//                   my-variable=&#39;007 J. B.&#39;</span>
<a name="l00260"></a>00260   <span class="comment">//           3) interprete sections like &#39;[../my-section]&#39; etc.</span>
<a name="l00261"></a>00261   <span class="keyword">inline</span> <span class="keywordtype">void</span>               <a class="code" href="classGetPot.php#afff655a258a9f01f170ec5d4feb2725b">__skip_whitespace</a>(std::istream&amp; istr);
<a name="l00262"></a>00262   <span class="keyword">inline</span> <span class="keyword">const</span> std::string  <a class="code" href="classGetPot.php#a86e7d8745b18c09055779af4f69c111f">__get_next_token</a>(std::istream&amp; istr);
<a name="l00263"></a>00263   <span class="keyword">inline</span> <span class="keyword">const</span> std::string  <a class="code" href="classGetPot.php#a44c7971c61d6ffc9c7ec370241a9ec6b">__get_string</a>(std::istream&amp; istr);
<a name="l00264"></a>00264   <span class="keyword">inline</span> <span class="keyword">const</span> std::string  <a class="code" href="classGetPot.php#af401c41285f5ad1e6081261d72c97460">__get_until_closing_bracket</a>(std::istream&amp; istr);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <span class="keyword">inline</span> std::vector&lt;std::string&gt; <a class="code" href="classGetPot.php#ae3659b1e9f2754c731b7db0c3ce49a14">__read_in_stream</a>(std::istream&amp; istr);
<a name="l00267"></a>00267   <span class="keyword">inline</span> std::vector&lt;std::string&gt; <a class="code" href="classGetPot.php#a8abffde658d436696e75dec87e9b8b1b">__read_in_file</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* FileName);
<a name="l00268"></a>00268   <span class="keyword">inline</span> std::string              <a class="code" href="classGetPot.php#a48326bcb7728ce42bed9867ae9f7ae58">__process_section_label</a>(<span class="keyword">const</span> std::string&amp; Section, 
<a name="l00269"></a>00269       std::vector&lt;std::string&gt;&amp; section_stack);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">//      -- dollar bracket expressions</span>
<a name="l00272"></a>00272   std::string                   <a class="code" href="classGetPot.php#aa1db4b6a0116a113c709ab2921b50fba">__DBE_expand_string</a>(<span class="keyword">const</span> std::string&amp; str);
<a name="l00273"></a>00273   std::string                   <a class="code" href="classGetPot.php#a5d561f41337478dfd74cb1603ff57a6c">__DBE_expand</a>(<span class="keyword">const</span> std::string&amp; str);
<a name="l00274"></a>00274   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>*  <a class="code" href="classGetPot.php#aac4f507f1b7aeb37d2e1b46dbcc17461">__DBE_get_variable</a>(<span class="keyword">const</span> std::string&amp; str);
<a name="l00275"></a>00275   std::vector&lt;std::string&gt;           <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(<span class="keyword">const</span> std::string&amp; str, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> ExpectedNumber);
<a name="l00276"></a>00276 
<a name="l00277"></a><a class="code" href="classGetPot.php#a366697457a53916e1f4512b2a2b531b5">00277</a>   std::string  <a class="code" href="classGetPot.php#a366697457a53916e1f4512b2a2b531b5">__double2string</a>(<span class="keywordtype">double</span> Value)<span class="keyword"> const </span>{ 
<a name="l00278"></a>00278     <span class="keywordtype">char</span>* tmp = <span class="keyword">new</span> <span class="keywordtype">char</span>[128];
<a name="l00279"></a>00279     std::sprintf(tmp, <span class="stringliteral">&quot;%e&quot;</span>, Value);
<a name="l00280"></a>00280     std::string result(tmp);
<a name="l00281"></a>00281     <span class="keyword">delete</span> [] tmp;
<a name="l00282"></a>00282     <span class="keywordflow">return</span> result;
<a name="l00283"></a>00283   }
<a name="l00284"></a><a class="code" href="classGetPot.php#a97c11f31da01463d52aa007a9f0ce1bc">00284</a>   std::string  <a class="code" href="classGetPot.php#a97c11f31da01463d52aa007a9f0ce1bc">__int2string</a>(<span class="keyword">const</span> <span class="keywordtype">int</span>&amp; Value)<span class="keyword"> const </span>{ 
<a name="l00285"></a>00285     <span class="keywordtype">char</span>* tmp = <span class="keyword">new</span> <span class="keywordtype">char</span>[128];
<a name="l00286"></a>00286     std::sprintf(tmp, <span class="stringliteral">&quot;%i&quot;</span>, Value);
<a name="l00287"></a>00287     std::string result(tmp);
<a name="l00288"></a>00288     <span class="keyword">delete</span> [] tmp;
<a name="l00289"></a>00289     <span class="keywordflow">return</span> result;
<a name="l00290"></a>00290   }
<a name="l00291"></a>00291 };
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00295"></a>00295 <span class="comment">// (*) constructors, destructor, assignment operator</span>
<a name="l00296"></a>00296 <span class="comment">//.............................................................................</span>
<a name="l00297"></a>00297 <span class="comment">//</span>
<a name="l00298"></a>00298 <span class="keyword">inline</span> <span class="keywordtype">void</span>
<a name="l00299"></a><a class="code" href="classGetPot.php#a7e5a50b5320deb27205a6bd939a656d1">00299</a> <a class="code" href="classGetPot.php#a7e5a50b5320deb27205a6bd939a656d1">GetPot::__basic_initialization</a>()
<a name="l00300"></a>00300 {
<a name="l00301"></a>00301   <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = 0;              <a class="code" href="classGetPot.php#a1a9c5bf4bc324f13459a9ca99fdc72eb">nominus_cursor</a> = -1;
<a name="l00302"></a>00302   <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> = <span class="keyword">true</span>;  <a class="code" href="classGetPot.php#ae6e6ca5fb70e92b0e7e4f6717ec6a15a">search_loop_f</a> = <span class="keyword">true</span>;
<a name="l00303"></a>00303   <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> = <span class="stringliteral">&quot;&quot;</span>;             <a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">section</a> = <span class="stringliteral">&quot;&quot;</span>;      
<a name="l00304"></a>00304 }
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 <span class="keyword">inline</span> 
<a name="l00309"></a><a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">00309</a> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot::GetPot</a>()
<a name="l00310"></a>00310 {
<a name="l00311"></a>00311   <a class="code" href="classGetPot.php#a7e5a50b5320deb27205a6bd939a656d1">__basic_initialization</a>();
<a name="l00312"></a>00312 }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 <span class="keyword">inline</span> 
<a name="l00317"></a><a class="code" href="classGetPot.php#acc161a652dee31847a26aaa2e1859d05">00317</a> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot::GetPot</a>(<span class="keywordtype">int</span> argc_, <span class="keywordtype">char</span> ** argv_)
<a name="l00318"></a>00318 {
<a name="l00319"></a>00319   <a class="code" href="classGetPot.php#a9c6f64040ac5979e017ea4b7a44d49c6">parse_command_line</a> (argc_, argv_);
<a name="l00320"></a>00320 }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 <span class="keyword">inline</span> 
<a name="l00325"></a><a class="code" href="classGetPot.php#a47dbdc575b90afd7f9daf59153c49c48">00325</a> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot::GetPot</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* FileName)
<a name="l00326"></a>00326 {
<a name="l00327"></a>00327   <a class="code" href="classGetPot.php#aa585a3a5169ec7d5e745ff48aa4b1d29">parse_input_file</a> (FileName);
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="keyword">inline</span> 
<a name="l00333"></a><a class="code" href="classGetPot.php#a70b397d21d32d4be4e9d346aec9f6c67">00333</a> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot::GetPot</a>(<span class="keyword">const</span> std::string &amp;FileName)
<a name="l00334"></a>00334 {
<a name="l00335"></a>00335   <a class="code" href="classGetPot.php#aa585a3a5169ec7d5e745ff48aa4b1d29">parse_input_file</a> (FileName);
<a name="l00336"></a>00336 }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 <span class="keyword">inline</span> 
<a name="l00341"></a><a class="code" href="classGetPot.php#ac36175020c34fa0b29dcadda76f6926e">00341</a> <a class="code" href="classGetPot.php#a33f99faaa93ea2cc332a72ab1b4f3798">GetPot::GetPot</a>(<span class="keyword">const</span> <a class="code" href="classGetPot.php">GetPot</a>&amp; Other)
<a name="l00342"></a>00342 {
<a name="l00343"></a>00343   <a class="code" href="classGetPot.php#a92c9fa06ffb4b578cdbb6e9200d27249">GetPot::operator=</a>(Other);
<a name="l00344"></a>00344 }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 <span class="keyword">inline</span> 
<a name="l00349"></a><a class="code" href="classGetPot.php#a42a3a4f6bc0035c64ee5fa13859310db">00349</a> <a class="code" href="classGetPot.php#a42a3a4f6bc0035c64ee5fa13859310db">GetPot::~GetPot</a>()
<a name="l00350"></a>00350 {
<a name="l00351"></a>00351 }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 <span class="keyword">inline</span>
<a name="l00356"></a><a class="code" href="classGetPot.php#a9c6f64040ac5979e017ea4b7a44d49c6">00356</a> <span class="keywordtype">void</span> <a class="code" href="classGetPot.php#a9c6f64040ac5979e017ea4b7a44d49c6">GetPot::parse_command_line</a> (<span class="keywordtype">int</span> argc_, <span class="keywordtype">char</span> ** argv_)
<a name="l00357"></a>00357 {
<a name="l00358"></a>00358   <a class="code" href="classGetPot.php#a7e5a50b5320deb27205a6bd939a656d1">__basic_initialization</a>();
<a name="l00359"></a>00359 
<a name="l00360"></a>00360   <span class="comment">// -- make an internal copy of the argument list:</span>
<a name="l00361"></a>00361   std::vector&lt;std::string&gt; __argv;
<a name="l00362"></a>00362   __argv.reserve (argc_);
<a name="l00363"></a>00363   
<a name="l00364"></a>00364   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i=0; i&lt;argc_; i++) {
<a name="l00365"></a>00365     std::string tmp(argv_[i]);
<a name="l00366"></a>00366     __argv.push_back(tmp);
<a name="l00367"></a>00367   }
<a name="l00368"></a>00368   <a class="code" href="classGetPot.php#a0ebeb7787334269d1a08094d356a7c11">__parse_argument_vector</a>(__argv); 
<a name="l00369"></a>00369 }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 <span class="keyword">inline</span>
<a name="l00374"></a><a class="code" href="classGetPot.php#aa585a3a5169ec7d5e745ff48aa4b1d29">00374</a> <span class="keywordtype">void</span> <a class="code" href="classGetPot.php#aa585a3a5169ec7d5e745ff48aa4b1d29">GetPot::parse_input_file</a> (<span class="keyword">const</span> std::string&amp; FileName)
<a name="l00375"></a>00375 {
<a name="l00376"></a>00376   <a class="code" href="classGetPot.php#a7e5a50b5320deb27205a6bd939a656d1">__basic_initialization</a>();
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   std::vector&lt;std::string&gt; __argv;
<a name="l00379"></a>00379   __argv.push_back(FileName); 
<a name="l00380"></a>00380   std::vector&lt;std::string&gt; args = <a class="code" href="classGetPot.php#a8abffde658d436696e75dec87e9b8b1b">__read_in_file</a>(FileName.c_str());
<a name="l00381"></a>00381   __argv.insert(__argv.begin()+1, args.begin(), args.end());
<a name="l00382"></a>00382   <a class="code" href="classGetPot.php#a0ebeb7787334269d1a08094d356a7c11">__parse_argument_vector</a>(__argv); 
<a name="l00383"></a>00383 }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 <span class="keyword">inline</span>
<a name="l00388"></a><a class="code" href="classGetPot.php#a0e336f4490f6e920e2ecb6ee23fe0c9d">00388</a> <span class="keywordtype">void</span> <a class="code" href="classGetPot.php#aa585a3a5169ec7d5e745ff48aa4b1d29">GetPot::parse_input_file</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* FileName)
<a name="l00389"></a>00389 {
<a name="l00390"></a>00390   <a class="code" href="classGetPot.php#a7e5a50b5320deb27205a6bd939a656d1">__basic_initialization</a>();
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   std::vector&lt;std::string&gt; __argv;
<a name="l00393"></a>00393   __argv.push_back(FileName); 
<a name="l00394"></a>00394   std::vector&lt;std::string&gt; args = <a class="code" href="classGetPot.php#a8abffde658d436696e75dec87e9b8b1b">__read_in_file</a>(FileName);
<a name="l00395"></a>00395   __argv.insert(__argv.begin()+1, args.begin(), args.end());
<a name="l00396"></a>00396   <a class="code" href="classGetPot.php#a0ebeb7787334269d1a08094d356a7c11">__parse_argument_vector</a>(__argv); 
<a name="l00397"></a>00397 }
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 <span class="keyword">inline</span> <a class="code" href="classGetPot.php">GetPot</a>&amp;
<a name="l00402"></a><a class="code" href="classGetPot.php#a92c9fa06ffb4b578cdbb6e9200d27249">00402</a> <a class="code" href="classGetPot.php#a92c9fa06ffb4b578cdbb6e9200d27249">GetPot::operator=</a>(<span class="keyword">const</span> <a class="code" href="classGetPot.php">GetPot</a>&amp; Other)
<a name="l00403"></a>00403 {
<a name="l00404"></a>00404   <span class="keywordflow">if</span> (&amp;Other != <span class="keyword">this</span>) {
<a name="l00405"></a>00405     <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>            = Other.<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>;
<a name="l00406"></a>00406     <a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">variables</a>       = Other.<a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">variables</a>;
<a name="l00407"></a>00407     <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>          = Other.<a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>;
<a name="l00408"></a>00408     <a class="code" href="classGetPot.php#a1a9c5bf4bc324f13459a9ca99fdc72eb">nominus_cursor</a>  = Other.<a class="code" href="classGetPot.php#a1a9c5bf4bc324f13459a9ca99fdc72eb">nominus_cursor</a>;
<a name="l00409"></a>00409     <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> = Other.<a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a>;
<a name="l00410"></a>00410     <a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">idx_nominus</a>     = Other.<a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">idx_nominus</a>;
<a name="l00411"></a>00411     <a class="code" href="classGetPot.php#ae6e6ca5fb70e92b0e7e4f6717ec6a15a">search_loop_f</a>   = Other.<a class="code" href="classGetPot.php#ae6e6ca5fb70e92b0e7e4f6717ec6a15a">search_loop_f</a>;
<a name="l00412"></a>00412   }
<a name="l00413"></a>00413   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00414"></a>00414 }
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 <span class="keyword">inline</span> <span class="keywordtype">void</span>
<a name="l00419"></a><a class="code" href="classGetPot.php#a0ebeb7787334269d1a08094d356a7c11">00419</a> <a class="code" href="classGetPot.php#a0ebeb7787334269d1a08094d356a7c11">GetPot::__parse_argument_vector</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; ARGV)
<a name="l00420"></a>00420 {
<a name="l00421"></a>00421   <span class="comment">// build internal databases:</span>
<a name="l00422"></a>00422   <span class="comment">//   1) array with no-minus arguments (usually used as filenames)</span>
<a name="l00423"></a>00423   <span class="comment">//   2) variable assignments:</span>
<a name="l00424"></a>00424   <span class="comment">//             &#39;variable name&#39; &#39;=&#39; number | string</span>
<a name="l00425"></a>00425   <a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">section</a> = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00426"></a>00426   std::vector&lt;std::string&gt;  section_stack;
<a name="l00427"></a>00427   <span class="keywordtype">unsigned</span> i=0;
<a name="l00428"></a>00428   std::vector&lt;std::string&gt;::const_iterator it     = ARGV.begin();
<a name="l00429"></a>00429   std::vector&lt;std::string&gt;::const_iterator it_end = ARGV.end();
<a name="l00430"></a>00430   <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.push_back(*it);
<a name="l00431"></a>00431   
<a name="l00432"></a>00432   <span class="keywordflow">for</span>(++it; it != it_end; ++it, i++) {
<a name="l00433"></a>00433     std::string arg = *it;
<a name="l00434"></a>00434     <span class="keywordflow">if</span>( arg.length() == 0 ) <span class="keywordflow">continue</span>;
<a name="l00435"></a>00435 
<a name="l00436"></a>00436     <span class="comment">// -- [section] labels</span>
<a name="l00437"></a>00437     <span class="keywordflow">if</span>( (arg.length() &gt; 1) &amp;&amp;
<a name="l00438"></a>00438         (arg[0] == <span class="charliteral">&#39;[&#39;</span> )   &amp;&amp;
<a name="l00439"></a>00439         (arg[arg.length()-1] == <span class="charliteral">&#39;]&#39;</span>) ) {
<a name="l00440"></a>00440       <span class="keyword">const</span> std::string Name = <a class="code" href="classGetPot.php#aa1db4b6a0116a113c709ab2921b50fba">__DBE_expand_string</a>(arg.substr(1, arg.length()-2));
<a name="l00441"></a>00441       <a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">section</a> = <a class="code" href="classGetPot.php#a48326bcb7728ce42bed9867ae9f7ae58">__process_section_label</a>(Name, section_stack);
<a name="l00442"></a>00442       <span class="comment">// new section --&gt; append to list of sections</span>
<a name="l00443"></a>00443       <span class="keywordflow">if</span>( std::find(<a class="code" href="classGetPot.php#a8b8f2d90bc5546a69172c19c23ddfe10">section_list</a>.begin(), <a class="code" href="classGetPot.php#a8b8f2d90bc5546a69172c19c23ddfe10">section_list</a>.end(), <a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">section</a>) == <a class="code" href="classGetPot.php#a8b8f2d90bc5546a69172c19c23ddfe10">section_list</a>.end() )
<a name="l00444"></a>00444         <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">section</a>.length() != 0 ) <a class="code" href="classGetPot.php#a8b8f2d90bc5546a69172c19c23ddfe10">section_list</a>.push_back(<a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">section</a>);
<a name="l00445"></a>00445       <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.push_back(arg);
<a name="l00446"></a>00446     }
<a name="l00447"></a>00447     <span class="keywordflow">else</span> {
<a name="l00448"></a>00448       arg = <a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">section</a> + <a class="code" href="classGetPot.php#aa1db4b6a0116a113c709ab2921b50fba">__DBE_expand_string</a>(arg);
<a name="l00449"></a>00449       <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.push_back(arg);
<a name="l00450"></a>00450     }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452     <span class="comment">// -- separate array for nominus arguments</span>
<a name="l00453"></a>00453     <span class="keywordflow">if</span>( arg[0] != <span class="charliteral">&#39;-&#39;</span> ) <a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">idx_nominus</a>.push_back(<span class="keywordtype">unsigned</span>(i));
<a name="l00454"></a>00454 
<a name="l00455"></a>00455     <span class="comment">// -- variables: does arg contain a &#39;=&#39; operator ?</span>
<a name="l00456"></a>00456     <span class="keywordflow">for</span>(<span class="keyword">const</span> <span class="keywordtype">char</span>* p = arg.c_str(); *p ; p++) {
<a name="l00457"></a>00457       <span class="keywordflow">if</span>( *p == <span class="charliteral">&#39;=&#39;</span> ) {
<a name="l00458"></a>00458         <span class="comment">// set terminating &#39;zero&#39; to treat first part as single string</span>
<a name="l00459"></a>00459         <span class="comment">// =&gt; arg (from start to &#39;p&#39;) = Name of variable</span>
<a name="l00460"></a>00460         <span class="comment">//    p+1     (until terminating zero) = value of variable</span>
<a name="l00461"></a>00461         <span class="keywordtype">char</span>* o = (<span class="keywordtype">char</span>*)p++;
<a name="l00462"></a>00462         *o = <span class="charliteral">&#39;\0&#39;</span>;
<a name="l00463"></a>00463         <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>* Var = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(arg.c_str());
<a name="l00464"></a>00464         
<a name="l00465"></a>00465         <span class="keywordflow">if</span>( Var == 0 )
<a name="l00466"></a>00466           <a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">variables</a>.push_back(<a class="code" href="structGetPot_1_1variable.php">variable</a>(arg.c_str(), p)); 
<a name="l00467"></a>00467         <span class="keywordflow">else</span>
<a name="l00468"></a>00468           ((<a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>*)Var)-&gt;take(p);
<a name="l00469"></a>00469         
<a name="l00470"></a>00470         *o = <span class="charliteral">&#39;=&#39;</span>;
<a name="l00471"></a>00471         <span class="keywordflow">break</span>;
<a name="l00472"></a>00472       }
<a name="l00473"></a>00473     }
<a name="l00474"></a>00474   }
<a name="l00475"></a>00475 }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 <span class="keyword">inline</span> std::vector&lt;std::string&gt;
<a name="l00480"></a><a class="code" href="classGetPot.php#a8abffde658d436696e75dec87e9b8b1b">00480</a> <a class="code" href="classGetPot.php#a8abffde658d436696e75dec87e9b8b1b">GetPot::__read_in_file</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* FileName)
<a name="l00481"></a>00481 {
<a name="l00482"></a>00482   std::ifstream  i(FileName);
<a name="l00483"></a>00483   <span class="keywordflow">if</span>( ! i ) <span class="keywordflow">return</span> std::vector&lt;std::string&gt;();
<a name="l00484"></a>00484   <span class="comment">// argv[0] == the filename of the file that was read in</span>
<a name="l00485"></a>00485   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ae3659b1e9f2754c731b7db0c3ce49a14">__read_in_stream</a>(i);
<a name="l00486"></a>00486 }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 <span class="keyword">inline</span> std::vector&lt;std::string&gt;
<a name="l00491"></a><a class="code" href="classGetPot.php#ae3659b1e9f2754c731b7db0c3ce49a14">00491</a> <a class="code" href="classGetPot.php#ae3659b1e9f2754c731b7db0c3ce49a14">GetPot::__read_in_stream</a>(std::istream&amp; istr)
<a name="l00492"></a>00492 {
<a name="l00493"></a>00493   std::vector&lt;std::string&gt;  brute_tokens;
<a name="l00494"></a>00494   <span class="keywordflow">while</span>(istr) {
<a name="l00495"></a>00495     <a class="code" href="classGetPot.php#afff655a258a9f01f170ec5d4feb2725b">__skip_whitespace</a>(istr);
<a name="l00496"></a>00496     <span class="keyword">const</span> std::string Token = <a class="code" href="classGetPot.php#a86e7d8745b18c09055779af4f69c111f">__get_next_token</a>(istr);
<a name="l00497"></a>00497     <span class="keywordflow">if</span>( Token.empty() ||
<a name="l00498"></a>00498         (Token[0] == <span class="keyword">static_cast&lt;</span>std::string::value_type<span class="keyword">&gt;</span>(EOF)) ) <span class="keywordflow">break</span>;
<a name="l00499"></a>00499     brute_tokens.push_back(Token);
<a name="l00500"></a>00500   }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   <span class="comment">// -- reduce expressions of token1&#39;=&#39;token2 to a single </span>
<a name="l00503"></a>00503   <span class="comment">//    string &#39;token1=token2&#39;</span>
<a name="l00504"></a>00504   <span class="comment">// -- copy everything into &#39;argv&#39;</span>
<a name="l00505"></a>00505   <span class="comment">// -- arguments preceded by something like &#39;[&#39; name &#39;]&#39; (section)</span>
<a name="l00506"></a>00506   <span class="comment">//    produce a second copy of each argument with a prefix &#39;[name]argument&#39;</span>
<a name="l00507"></a>00507   <span class="keywordtype">unsigned</span> i1 = 0;
<a name="l00508"></a>00508   <span class="keywordtype">unsigned</span> i2 = 1;
<a name="l00509"></a>00509   <span class="keywordtype">unsigned</span> i3 = 2;
<a name="l00510"></a>00510 
<a name="l00511"></a>00511   std::vector&lt;std::string&gt;  arglist;
<a name="l00512"></a>00512   <span class="keywordflow">while</span>( i1 &lt; brute_tokens.size() ) {
<a name="l00513"></a>00513     <span class="keyword">const</span> std::string&amp; SRef = brute_tokens[i1];
<a name="l00514"></a>00514     <span class="comment">// 1) concatinate &#39;abcdef&#39; &#39;=&#39; &#39;efgasdef&#39; to &#39;abcdef=efgasdef&#39;</span>
<a name="l00515"></a>00515     <span class="comment">// note: java.lang.String: substring(a,b) = from a to b-1</span>
<a name="l00516"></a>00516     <span class="comment">//        C++ string:      substr(a,b)    = from a to a + b</span>
<a name="l00517"></a>00517     <span class="keywordflow">if</span>( i2 &lt; brute_tokens.size() &amp;&amp; brute_tokens[i2] == <span class="stringliteral">&quot;=&quot;</span> ) {
<a name="l00518"></a>00518       <span class="keywordflow">if</span>( i3 &gt;= brute_tokens.size() )
<a name="l00519"></a>00519         arglist.push_back(brute_tokens[i1] + brute_tokens[i2]);
<a name="l00520"></a>00520       <span class="keywordflow">else</span>
<a name="l00521"></a>00521         arglist.push_back(brute_tokens[i1] + brute_tokens[i2] + brute_tokens[i3]);
<a name="l00522"></a>00522       i1 = i3+1; i2 = i3+2; i3 = i3+3;
<a name="l00523"></a>00523       <span class="keywordflow">continue</span>;
<a name="l00524"></a>00524     }
<a name="l00525"></a>00525     <span class="keywordflow">else</span> {
<a name="l00526"></a>00526       arglist.push_back(SRef);
<a name="l00527"></a>00527       i1=i2; i2=i3; i3++;
<a name="l00528"></a>00528     }
<a name="l00529"></a>00529   }
<a name="l00530"></a>00530   <span class="keywordflow">return</span> arglist;
<a name="l00531"></a>00531 }
<a name="l00532"></a>00532 
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 <span class="keyword">inline</span> <span class="keywordtype">void</span>
<a name="l00536"></a><a class="code" href="classGetPot.php#afff655a258a9f01f170ec5d4feb2725b">00536</a> <a class="code" href="classGetPot.php#afff655a258a9f01f170ec5d4feb2725b">GetPot::__skip_whitespace</a>(std::istream&amp; istr)
<a name="l00537"></a>00537   <span class="comment">// find next non-whitespace while deleting comments</span>
<a name="l00538"></a>00538 { 
<a name="l00539"></a>00539   <span class="keywordtype">int</span> tmp = istr.get();
<a name="l00540"></a>00540   <span class="keywordflow">do</span> {
<a name="l00541"></a>00541     <span class="keywordflow">while</span>( isspace(tmp) ) {
<a name="l00542"></a>00542       tmp = istr.get();
<a name="l00543"></a>00543       <span class="keywordflow">if</span>( ! istr ) <span class="keywordflow">return</span>;
<a name="l00544"></a>00544     }
<a name="l00545"></a>00545     <span class="comment">// found a non whitespace </span>
<a name="l00546"></a>00546     <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;#&#39;</span> ) {
<a name="l00547"></a>00547       <span class="comment">// comment =&gt; skip until end of line</span>
<a name="l00548"></a>00548       <span class="keywordflow">while</span>( tmp != <span class="charliteral">&#39;\n&#39;</span> ) {
<a name="l00549"></a>00549         <span class="keywordflow">if</span>( ! istr ) { istr.unget(); <span class="keywordflow">return</span>; }
<a name="l00550"></a>00550         tmp = istr.get();
<a name="l00551"></a>00551       }
<a name="l00552"></a>00552       <span class="keywordflow">continue</span>; 
<a name="l00553"></a>00553     }
<a name="l00554"></a>00554     <span class="keywordflow">else</span> {
<a name="l00555"></a>00555       istr.unget();
<a name="l00556"></a>00556       <span class="keywordflow">return</span>;
<a name="l00557"></a>00557     }
<a name="l00558"></a>00558   } <span class="keywordflow">while</span>( istr );
<a name="l00559"></a>00559 }
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 <span class="keyword">inline</span> <span class="keyword">const</span> std::string
<a name="l00564"></a><a class="code" href="classGetPot.php#a86e7d8745b18c09055779af4f69c111f">00564</a> <a class="code" href="classGetPot.php#a86e7d8745b18c09055779af4f69c111f">GetPot::__get_next_token</a>(std::istream&amp; istr)
<a name="l00565"></a>00565   <span class="comment">// get next concatinates string token. consider quotes that embrace</span>
<a name="l00566"></a>00566   <span class="comment">// whitespaces</span>
<a name="l00567"></a>00567 {
<a name="l00568"></a>00568   std::string token;
<a name="l00569"></a>00569   <span class="keywordtype">int</span>    tmp = 0; 
<a name="l00570"></a>00570   <span class="keywordtype">int</span>    last_letter = 0;
<a name="l00571"></a>00571   <span class="keywordflow">while</span>(1+1 == 2) {
<a name="l00572"></a>00572     last_letter = tmp; tmp = istr.get();
<a name="l00573"></a>00573     <span class="keywordflow">if</span>( tmp == EOF 
<a name="l00574"></a>00574         || ((tmp == <span class="charliteral">&#39; &#39;</span> || tmp == <span class="charliteral">&#39;\t&#39;</span> || tmp == <span class="charliteral">&#39;\n&#39;</span>) &amp;&amp; last_letter != <span class="charliteral">&#39;\\&#39;</span>) ) {
<a name="l00575"></a>00575       <span class="keywordflow">return</span> token;
<a name="l00576"></a>00576     }
<a name="l00577"></a>00577     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;\&#39;&#39;</span> &amp;&amp; last_letter != <span class="charliteral">&#39;\\&#39;</span> ) {
<a name="l00578"></a>00578       <span class="comment">// QUOTES: un-backslashed quotes =&gt; it&#39;s a string</span>
<a name="l00579"></a>00579       token += <a class="code" href="classGetPot.php#a44c7971c61d6ffc9c7ec370241a9ec6b">__get_string</a>(istr);
<a name="l00580"></a>00580       <span class="keywordflow">continue</span>;
<a name="l00581"></a>00581     }
<a name="l00582"></a>00582     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;{&#39;</span> &amp;&amp; last_letter == <span class="charliteral">&#39;$&#39;</span>) {
<a name="l00583"></a>00583       token += <span class="charliteral">&#39;{&#39;</span> + <a class="code" href="classGetPot.php#af401c41285f5ad1e6081261d72c97460">__get_until_closing_bracket</a>(istr);
<a name="l00584"></a>00584       <span class="keywordflow">continue</span>;
<a name="l00585"></a>00585     }
<a name="l00586"></a>00586     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;$&#39;</span> &amp;&amp; last_letter == <span class="charliteral">&#39;\\&#39;</span>) {
<a name="l00587"></a>00587       token += tmp; tmp = 0;  <span class="comment">//  so that last_letter will become = 0, not &#39;$&#39;;</span>
<a name="l00588"></a>00588       <span class="keywordflow">continue</span>;
<a name="l00589"></a>00589     }
<a name="l00590"></a>00590     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;\\&#39;</span> &amp;&amp; last_letter != <span class="charliteral">&#39;\\&#39;</span>) 
<a name="l00591"></a>00591       <span class="keywordflow">continue</span>;              <span class="comment">// don&#39;t append un-backslashed backslashes</span>
<a name="l00592"></a>00592     token += tmp;
<a name="l00593"></a>00593   }
<a name="l00594"></a>00594 
<a name="l00595"></a>00595   <span class="keywordflow">return</span> token;
<a name="l00596"></a>00596 }
<a name="l00597"></a>00597 
<a name="l00598"></a>00598 
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 <span class="keyword">inline</span> <span class="keyword">const</span> std::string
<a name="l00601"></a><a class="code" href="classGetPot.php#a44c7971c61d6ffc9c7ec370241a9ec6b">00601</a> <a class="code" href="classGetPot.php#a44c7971c61d6ffc9c7ec370241a9ec6b">GetPot::__get_string</a>(std::istream&amp; istr)
<a name="l00602"></a>00602   <span class="comment">// parse input until next matching &#39;</span>
<a name="l00603"></a>00603 {
<a name="l00604"></a>00604   std::string str;
<a name="l00605"></a>00605   <span class="keywordtype">int</span>    tmp = 0;
<a name="l00606"></a>00606   <span class="keywordtype">int</span>    last_letter = 0;
<a name="l00607"></a>00607   <span class="keywordflow">while</span>(1 + 1 == 2) {
<a name="l00608"></a>00608     last_letter = tmp; tmp = istr.get();
<a name="l00609"></a>00609     <span class="keywordflow">if</span>( tmp == EOF)  <span class="keywordflow">return</span> str;
<a name="l00610"></a>00610     <span class="comment">// un-backslashed quotes =&gt; it&#39;s the end of the string</span>
<a name="l00611"></a>00611     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;\&#39;&#39;</span> &amp;&amp; last_letter != <span class="charliteral">&#39;\\&#39;</span>)  <span class="keywordflow">return</span> str;
<a name="l00612"></a>00612     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;\\&#39;</span> &amp;&amp; last_letter != <span class="charliteral">&#39;\\&#39;</span>)  <span class="keywordflow">continue</span>; <span class="comment">// don&#39;t append </span>
<a name="l00613"></a>00613 
<a name="l00614"></a>00614     str += tmp;
<a name="l00615"></a>00615   }
<a name="l00616"></a>00616 
<a name="l00617"></a>00617   <span class="keywordflow">return</span> str;
<a name="l00618"></a>00618 }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 <span class="keyword">inline</span> <span class="keyword">const</span> std::string
<a name="l00623"></a><a class="code" href="classGetPot.php#af401c41285f5ad1e6081261d72c97460">00623</a> <a class="code" href="classGetPot.php#af401c41285f5ad1e6081261d72c97460">GetPot::__get_until_closing_bracket</a>(std::istream&amp; istr)
<a name="l00624"></a>00624   <span class="comment">// parse input until next matching }</span>
<a name="l00625"></a>00625 {
<a name="l00626"></a>00626   std::string str = <span class="stringliteral">&quot;&quot;</span>; 
<a name="l00627"></a>00627   <span class="keywordtype">int</span>    tmp = 0;
<a name="l00628"></a>00628   <span class="keywordtype">int</span>    last_letter = 0;
<a name="l00629"></a>00629   <span class="keywordtype">int</span>    brackets = 1;
<a name="l00630"></a>00630   <span class="keywordflow">while</span>(1 + 1 == 2) {
<a name="l00631"></a>00631     last_letter = tmp; tmp = istr.get();
<a name="l00632"></a>00632     <span class="keywordflow">if</span>( tmp == EOF) <span class="keywordflow">return</span> str;
<a name="l00633"></a>00633     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;{&#39;</span> &amp;&amp; last_letter == <span class="charliteral">&#39;$&#39;</span>) brackets += 1;
<a name="l00634"></a>00634     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;}&#39;</span>) {
<a name="l00635"></a>00635       brackets -= 1;
<a name="l00636"></a>00636       <span class="comment">// un-backslashed brackets =&gt; it&#39;s the end of the string</span>
<a name="l00637"></a>00637       <span class="keywordflow">if</span>( brackets == 0) <span class="keywordflow">return</span> str + <span class="charliteral">&#39;}&#39;</span>;
<a name="l00638"></a>00638       <span class="keywordflow">else</span> <span class="keywordflow">if</span>( tmp == <span class="charliteral">&#39;\\&#39;</span> &amp;&amp; last_letter != <span class="charliteral">&#39;\\&#39;</span>) 
<a name="l00639"></a>00639         <span class="keywordflow">continue</span>;  <span class="comment">// do not append an unbackslashed backslash</span>
<a name="l00640"></a>00640     }
<a name="l00641"></a>00641     str += tmp;
<a name="l00642"></a>00642   }
<a name="l00643"></a>00643 
<a name="l00644"></a>00644   <span class="keywordflow">return</span> str;
<a name="l00645"></a>00645 }
<a name="l00646"></a>00646 
<a name="l00647"></a>00647 
<a name="l00648"></a>00648 
<a name="l00649"></a>00649 <span class="keyword">inline</span> std::string
<a name="l00650"></a><a class="code" href="classGetPot.php#a48326bcb7728ce42bed9867ae9f7ae58">00650</a> <a class="code" href="classGetPot.php#a48326bcb7728ce42bed9867ae9f7ae58">GetPot::__process_section_label</a>(<span class="keyword">const</span> std::string&amp; Section, 
<a name="l00651"></a>00651     std::vector&lt;std::string&gt;&amp; section_stack)
<a name="l00652"></a>00652 {
<a name="l00653"></a>00653   std::string sname = Section;
<a name="l00654"></a>00654   <span class="comment">//  1) subsection of actual section (&#39;./&#39; prefix)</span>
<a name="l00655"></a>00655   <span class="keywordflow">if</span>( sname.length() &gt;= 2 &amp;&amp; sname.substr(0, 2) == <span class="stringliteral">&quot;./&quot;</span> ) {
<a name="l00656"></a>00656     sname = sname.substr(2);
<a name="l00657"></a>00657   }
<a name="l00658"></a>00658   <span class="comment">//  2) subsection of parent section (&#39;../&#39; prefix)</span>
<a name="l00659"></a>00659   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( sname.length() &gt;= 3 &amp;&amp; sname.substr(0, 3) == <span class="stringliteral">&quot;../&quot;</span> ) {
<a name="l00660"></a>00660     <span class="keywordflow">do</span> {
<a name="l00661"></a>00661       <span class="keywordflow">if</span>( section_stack.end() != section_stack.begin() ) 
<a name="l00662"></a>00662         section_stack.pop_back();
<a name="l00663"></a>00663       sname = sname.substr(3);
<a name="l00664"></a>00664     } <span class="keywordflow">while</span>( sname.substr(0, 3) == <span class="stringliteral">&quot;../&quot;</span> );
<a name="l00665"></a>00665   }
<a name="l00666"></a>00666   <span class="comment">// 3) subsection of the root-section</span>
<a name="l00667"></a>00667   <span class="keywordflow">else</span> {
<a name="l00668"></a>00668     section_stack.erase(section_stack.begin(), section_stack.end());
<a name="l00669"></a>00669     <span class="comment">// [] =&gt; back to root section</span>
<a name="l00670"></a>00670   }
<a name="l00671"></a>00671 
<a name="l00672"></a>00672   <span class="keywordflow">if</span>( sname != <span class="stringliteral">&quot;&quot;</span> ) {
<a name="l00673"></a>00673     <span class="comment">// parse section name for &#39;slashes&#39;</span>
<a name="l00674"></a>00674     <span class="keywordtype">unsigned</span> i=0;
<a name="l00675"></a>00675     <span class="keywordflow">while</span>( i &lt; sname.length() ) {
<a name="l00676"></a>00676       <span class="keywordflow">if</span>( sname[i] == <span class="charliteral">&#39;/&#39;</span> ) {
<a name="l00677"></a>00677         section_stack.push_back(sname.substr(0,i));
<a name="l00678"></a>00678         <span class="keywordflow">if</span>( i+1 &lt; sname.length()-1 )
<a name="l00679"></a>00679           sname = sname.substr(i+1);
<a name="l00680"></a>00680         i = 0;
<a name="l00681"></a>00681       }
<a name="l00682"></a>00682       <span class="keywordflow">else</span> 
<a name="l00683"></a>00683         i++;
<a name="l00684"></a>00684     }      
<a name="l00685"></a>00685     section_stack.push_back(sname);
<a name="l00686"></a>00686   } 
<a name="l00687"></a>00687   std::string section_name = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00688"></a>00688   <span class="keywordflow">if</span>( section_stack.size() != 0 )
<a name="l00689"></a>00689     victorate(std::string, section_stack, it) {
<a name="l00690"></a>00690       section_name += *it + <span class="stringliteral">&quot;/&quot;</span>;
<a name="l00691"></a>00691     }
<a name="l00692"></a>00692   <span class="keywordflow">return</span> section_name;
<a name="l00693"></a>00693 }
<a name="l00694"></a>00694 
<a name="l00695"></a>00695 
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 <span class="comment">// convert string to DOUBLE, if not possible return Default</span>
<a name="l00698"></a>00698 <span class="keyword">inline</span> <span class="keywordtype">double</span>   
<a name="l00699"></a><a class="code" href="classGetPot.php#a669bdebcbb0330dcc7e0b636c00facab">00699</a> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">GetPot::__convert_to_type</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keywordtype">double</span> Default)<span class="keyword"> const</span>
<a name="l00700"></a>00700 <span class="keyword"></span>{
<a name="l00701"></a>00701   <span class="keywordtype">double</span> tmp;
<a name="l00702"></a>00702   <span class="keywordflow">if</span>( std::sscanf(String.c_str(),<span class="stringliteral">&quot;%lf&quot;</span>, &amp;tmp) != 1 ) <span class="keywordflow">return</span> Default;
<a name="l00703"></a>00703   <span class="keywordflow">return</span> tmp;
<a name="l00704"></a>00704 }
<a name="l00705"></a>00705 
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 <span class="comment">// convert string to LONG DOUBLE, if not possible return Default</span>
<a name="l00709"></a>00709 <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span>   
<a name="l00710"></a><a class="code" href="classGetPot.php#adf14fe0f18400c988230397577ec77db">00710</a> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">GetPot::__convert_to_type</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keywordtype">long</span> <span class="keywordtype">double</span> Default)<span class="keyword"> const</span>
<a name="l00711"></a>00711 <span class="keyword"></span>{
<a name="l00712"></a>00712   <span class="keywordtype">long</span> <span class="keywordtype">double</span> tmp;
<a name="l00713"></a>00713   <span class="keywordflow">if</span>( std::sscanf(String.c_str(),<span class="stringliteral">&quot;%Lf&quot;</span>, &amp;tmp) != 1 ) <span class="keywordflow">return</span> Default;
<a name="l00714"></a>00714   <span class="keywordflow">return</span> tmp;
<a name="l00715"></a>00715 }
<a name="l00716"></a>00716 
<a name="l00717"></a>00717 
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 <span class="comment">// convert string to INT, if not possible return Default</span>
<a name="l00720"></a>00720 <span class="keyword">inline</span> <span class="keywordtype">int</span>   
<a name="l00721"></a><a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">00721</a> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">GetPot::__convert_to_type</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keywordtype">int</span> Default)<span class="keyword"> const</span>
<a name="l00722"></a>00722 <span class="keyword"></span>{
<a name="l00723"></a>00723   <span class="keywordtype">int</span> tmp;
<a name="l00724"></a>00724   <span class="keywordflow">if</span>( std::sscanf(String.c_str(),<span class="stringliteral">&quot;%i&quot;</span>, &amp;tmp) != 1 ) <span class="keywordflow">return</span> Default;
<a name="l00725"></a>00725   <span class="keywordflow">return</span> tmp;    
<a name="l00726"></a>00726 }
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 
<a name="l00729"></a>00729 
<a name="l00730"></a>00730 <span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l00731"></a><a class="code" href="classGetPot.php#a55d6c0c69c75f9fcaead2a00b231f394">00731</a> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">GetPot::__convert_to_type</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keywordtype">bool</span> Default)<span class="keyword"> const</span>
<a name="l00732"></a>00732 <span class="keyword"></span>{
<a name="l00733"></a>00733   std::string newstring(String);
<a name="l00734"></a>00734   <span class="comment">//std::transform(newstring.begin(), newstring.end(), newstring.begin(), std::toupper);</span>
<a name="l00735"></a>00735   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;newstring.length(); ++i)
<a name="l00736"></a>00736   {
<a name="l00737"></a>00737     newstring[i]=toupper(newstring[i]);
<a name="l00738"></a>00738   }
<a name="l00739"></a>00739   
<a name="l00740"></a>00740   <span class="keywordflow">if</span> (newstring.find(<span class="stringliteral">&quot;TRUE&quot;</span>)!=std::string::npos)  <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00741"></a>00741   <span class="keywordflow">if</span> (newstring.find(<span class="stringliteral">&quot;FALSE&quot;</span>)!=std::string::npos) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00742"></a>00742   <span class="keywordflow">return</span> Default;
<a name="l00743"></a>00743 }
<a name="l00744"></a>00744 
<a name="l00745"></a>00745 
<a name="l00746"></a>00746 
<a name="l00748"></a>00748 <span class="comment">// (*) cursor oriented functions</span>
<a name="l00749"></a>00749 <span class="comment">//.............................................................................</span>
<a name="l00750"></a>00750 <span class="keyword">inline</span> <span class="keyword">const</span> std::string  
<a name="l00751"></a><a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">00751</a> <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">GetPot::__get_remaining_string</a>(<span class="keyword">const</span> std::string&amp; String, <span class="keyword">const</span> std::string&amp; Start) <span class="keyword">const</span>
<a name="l00752"></a>00752 <span class="comment">// Checks if &#39;String&#39; begins with &#39;Start&#39; and returns the remaining String.</span>
<a name="l00753"></a>00753 <span class="comment">// Returns None if String does not begin with Start.</span>
<a name="l00754"></a>00754 {
<a name="l00755"></a>00755   <span class="keywordflow">if</span>( Start == <span class="stringliteral">&quot;&quot;</span> ) <span class="keywordflow">return</span> String;
<a name="l00756"></a>00756   <span class="comment">// note: java.lang.String: substring(a,b) = from a to b-1</span>
<a name="l00757"></a>00757   <span class="comment">//        C++ string:      substr(a,b)    = from a to a + b</span>
<a name="l00758"></a>00758   <span class="keywordflow">if</span>( String.find(Start) == 0 ) <span class="keywordflow">return</span> String.substr(Start.length());
<a name="l00759"></a>00759   <span class="keywordflow">else</span>                          <span class="keywordflow">return</span> <span class="stringliteral">&quot;&quot;</span>;
<a name="l00760"></a>00760 }
<a name="l00761"></a>00761 
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 <span class="comment">//     -- search for a certain argument and set cursor to position</span>
<a name="l00765"></a>00765 <span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l00766"></a><a class="code" href="classGetPot.php#ae47304b9f1be50519b09aff22f93a6af">00766</a> <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">GetPot::search</a>(<span class="keyword">const</span> std::string &amp;Option)
<a name="l00767"></a>00767 { 
<a name="l00768"></a>00768   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(Option.c_str());
<a name="l00769"></a>00769 }
<a name="l00770"></a>00770 
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 
<a name="l00773"></a>00773 <span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l00774"></a><a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">00774</a> <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">GetPot::search</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Option)
<a name="l00775"></a>00775 { 
<a name="l00776"></a>00776   <span class="keywordtype">unsigned</span>      OldCursor = <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>;
<a name="l00777"></a>00777   <span class="keyword">const</span> std::string  SearchTerm = <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> + Option;
<a name="l00778"></a>00778 
<a name="l00779"></a>00779   <span class="keywordflow">if</span>( OldCursor &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) OldCursor = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() - 1;
<a name="l00780"></a>00780   <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> = <span class="keyword">true</span>;
<a name="l00781"></a>00781 
<a name="l00782"></a>00782   <span class="comment">// (*) first loop from cursor position until end</span>
<a name="l00783"></a>00783   <span class="keywordtype">unsigned</span>  c = <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>;
<a name="l00784"></a>00784   <span class="keywordflow">for</span>(; c &lt; <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size(); c++) {
<a name="l00785"></a>00785     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[c] == SearchTerm ) 
<a name="l00786"></a>00786     { <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = c; <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> = <span class="keyword">false</span>; <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00787"></a>00787   }
<a name="l00788"></a>00788   <span class="keywordflow">if</span>( ! <a class="code" href="classGetPot.php#ae6e6ca5fb70e92b0e7e4f6717ec6a15a">search_loop_f</a> ) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00789"></a>00789 
<a name="l00790"></a>00790   <span class="comment">// (*) second loop from 0 to old cursor position</span>
<a name="l00791"></a>00791   <span class="keywordflow">for</span>(c = 0; c &lt; OldCursor; c++) {
<a name="l00792"></a>00792     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[c] == SearchTerm ) 
<a name="l00793"></a>00793     { <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = c; <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> = <span class="keyword">false</span>; <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00794"></a>00794   }
<a name="l00795"></a>00795   <span class="comment">// in case nothing is found the cursor stays where it was</span>
<a name="l00796"></a>00796   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00797"></a>00797 }
<a name="l00798"></a>00798 
<a name="l00799"></a>00799 
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 <span class="preprocessor">#ifdef GETPOT_ALLOW_VARGS</span>
<a name="l00802"></a>00802 <span class="preprocessor"></span><span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l00803"></a><a class="code" href="classGetPot.php#aba4993d981a043ea377eed1588f6da98">00803</a> <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">GetPot::search</a>(<span class="keywordtype">unsigned</span> No, <span class="keyword">const</span> <span class="keywordtype">char</span>* P, ...)
<a name="l00804"></a>00804 {
<a name="l00805"></a>00805     <span class="keywordflow">if</span>( No == 0 ) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00806"></a>00806 
<a name="l00807"></a>00807     <span class="comment">// search for the first argument</span>
<a name="l00808"></a>00808     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(P) == <span class="keyword">true</span> ) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00809"></a>00809     
<a name="l00810"></a>00810     <span class="comment">// start interpreting variable argument list</span>
<a name="l00811"></a>00811     std::va_list ap;
<a name="l00812"></a>00812     va_start(ap, P);
<a name="l00813"></a>00813     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;No; i++) {
<a name="l00814"></a>00814         <span class="keywordtype">char</span>* Opt = va_arg(ap, <span class="keywordtype">char</span> *);
<a name="l00815"></a>00815         <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(Opt) == <span class="keyword">true</span> ) 
<a name="l00816"></a>00816         { va_end(ap); <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00817"></a>00817     }
<a name="l00818"></a>00818     va_end(ap);
<a name="l00819"></a>00819     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00820"></a>00820 }
<a name="l00821"></a>00821 <span class="preprocessor">#endif //GETPOT_ALLOW_VARGS</span>
<a name="l00822"></a>00822 <span class="preprocessor"></span>
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 
<a name="l00825"></a>00825 <span class="keyword">inline</span> <span class="keywordtype">void</span>  
<a name="l00826"></a><a class="code" href="classGetPot.php#ad55107a9bd39804599844194218e8e3a">00826</a> <a class="code" href="classGetPot.php#ad55107a9bd39804599844194218e8e3a">GetPot::reset_cursor</a>()
<a name="l00827"></a>00827 { <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> = <span class="keyword">false</span>; <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = 0; }
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 
<a name="l00830"></a>00830 
<a name="l00831"></a>00831 <span class="keyword">inline</span> <span class="keywordtype">void</span>         
<a name="l00832"></a><a class="code" href="classGetPot.php#af8d29a623cd9a37d9f133c66b712efc5">00832</a> <a class="code" href="classGetPot.php#af8d29a623cd9a37d9f133c66b712efc5">GetPot::init_multiple_occurrence</a>()
<a name="l00833"></a>00833 { <a class="code" href="classGetPot.php#a84b0e0199ae3df63c01ea125a16be83f">disable_loop</a>(); <a class="code" href="classGetPot.php#ad55107a9bd39804599844194218e8e3a">reset_cursor</a>(); }
<a name="l00834"></a>00834 
<a name="l00835"></a>00835 
<a name="l00836"></a>00836 
<a name="l00838"></a>00838 <span class="comment">// (*) direct access to command line arguments</span>
<a name="l00839"></a>00839 <span class="comment">//.............................................................................</span>
<a name="l00840"></a>00840 <span class="comment">//</span>
<a name="l00841"></a>00841 <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*   
<a name="l00842"></a><a class="code" href="classGetPot.php#a2b57efabc69cfeaccc4a357313349816">00842</a> <a class="code" href="classGetPot.php#a2b57efabc69cfeaccc4a357313349816">GetPot::operator[]</a>(<span class="keywordtype">unsigned</span> <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>)<span class="keyword"> const</span>
<a name="l00843"></a>00843 <span class="keyword"></span>{ <span class="keywordflow">return</span> idx&lt;<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ? <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>].c_str() : 0; }
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 <span class="keyword">inline</span> <span class="keywordtype">int</span>   
<a name="l00848"></a><a class="code" href="classGetPot.php#a1c017e282a0074f949ea4b6aa7bae6b6">00848</a> <a class="code" href="classGetPot.php#a1c017e282a0074f949ea4b6aa7bae6b6">GetPot::get</a>(<span class="keywordtype">unsigned</span> Idx, <span class="keywordtype">int</span> Default)<span class="keyword"> const</span>
<a name="l00849"></a>00849 <span class="keyword"></span>{ 
<a name="l00850"></a>00850   <span class="keywordflow">if</span>( Idx &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) <span class="keywordflow">return</span> Default;
<a name="l00851"></a>00851   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[Idx], Default);
<a name="l00852"></a>00852 }
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 
<a name="l00856"></a>00856 <span class="keyword">inline</span> <span class="keywordtype">double</span>   
<a name="l00857"></a><a class="code" href="classGetPot.php#a37c2eb089f32fb46016d69e8234c1967">00857</a> <a class="code" href="classGetPot.php#a1c017e282a0074f949ea4b6aa7bae6b6">GetPot::get</a>(<span class="keywordtype">unsigned</span> Idx, <span class="keywordtype">double</span> Default)<span class="keyword"> const</span>
<a name="l00858"></a>00858 <span class="keyword"></span>{ 
<a name="l00859"></a>00859   <span class="keywordflow">if</span>( Idx &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) <span class="keywordflow">return</span> Default;
<a name="l00860"></a>00860   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[Idx], Default);
<a name="l00861"></a>00861 }
<a name="l00862"></a>00862 
<a name="l00863"></a>00863 
<a name="l00864"></a>00864 
<a name="l00865"></a>00865 <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*   
<a name="l00866"></a><a class="code" href="classGetPot.php#a7ddada9e24062d8844e759c86c9d1c84">00866</a> <a class="code" href="classGetPot.php#a1c017e282a0074f949ea4b6aa7bae6b6">GetPot::get</a>(<span class="keywordtype">unsigned</span> Idx, <span class="keyword">const</span> <span class="keywordtype">char</span>* Default)<span class="keyword"> const</span>
<a name="l00867"></a>00867 <span class="keyword"></span>{ 
<a name="l00868"></a>00868   <span class="keywordflow">if</span>( Idx &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) <span class="keywordflow">return</span> Default;
<a name="l00869"></a>00869   <span class="keywordflow">else</span>                     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[Idx].c_str();
<a name="l00870"></a>00870 }
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> 
<a name="l00875"></a><a class="code" href="classGetPot.php#a2d932ac1adaa8c96cd7d6a9379bee729">00875</a> <a class="code" href="classGetPot.php#a2d932ac1adaa8c96cd7d6a9379bee729">GetPot::size</a>()<span class="keyword"> const</span>
<a name="l00876"></a>00876 <span class="keyword"></span>{ <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size(); }
<a name="l00877"></a>00877 <span class="comment">//     -- next() function group</span>
<a name="l00878"></a>00878   <span class="keyword">inline</span> <span class="keywordtype">int</span>  
<a name="l00879"></a><a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">00879</a> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">GetPot::next</a>(<span class="keywordtype">int</span> Default)    
<a name="l00880"></a>00880 { 
<a name="l00881"></a>00881   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> ) <span class="keywordflow">return</span> Default;
<a name="l00882"></a>00882   <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>++; 
<a name="l00883"></a>00883   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) 
<a name="l00884"></a>00884   { <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size(); <span class="keywordflow">return</span> Default; }
<a name="l00885"></a>00885 
<a name="l00886"></a>00886   <span class="keyword">const</span> std::string Remain = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[<a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>], <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l00887"></a>00887 
<a name="l00888"></a>00888   <span class="keywordflow">return</span> Remain != <span class="stringliteral">&quot;&quot;</span> ? <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(Remain, Default) : Default;
<a name="l00889"></a>00889 }
<a name="l00890"></a>00890 
<a name="l00891"></a>00891 
<a name="l00892"></a>00892 
<a name="l00893"></a>00893 <span class="keyword">inline</span> <span class="keywordtype">double</span> 
<a name="l00894"></a><a class="code" href="classGetPot.php#a77b55fa77a0eb1842ff2be622cd25cf5">00894</a> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">GetPot::next</a>(<span class="keywordtype">double</span> Default) 
<a name="l00895"></a>00895 { 
<a name="l00896"></a>00896   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> ) <span class="keywordflow">return</span> Default;
<a name="l00897"></a>00897   <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>++;
<a name="l00898"></a>00898 
<a name="l00899"></a>00899   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) 
<a name="l00900"></a>00900   { <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size(); <span class="keywordflow">return</span> Default; }
<a name="l00901"></a>00901 
<a name="l00902"></a>00902   std::string Remain = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[<a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>], <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l00903"></a>00903 
<a name="l00904"></a>00904   <span class="keywordflow">return</span> Remain != <span class="stringliteral">&quot;&quot;</span> ? <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(Remain, Default) : Default;
<a name="l00905"></a>00905 }
<a name="l00906"></a>00906 
<a name="l00907"></a>00907 
<a name="l00908"></a>00908 
<a name="l00909"></a>00909 <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*   
<a name="l00910"></a><a class="code" href="classGetPot.php#a306a8b9702652529c3141b79216db264">00910</a> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">GetPot::next</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Default) 
<a name="l00911"></a>00911 { 
<a name="l00912"></a>00912   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> ) <span class="keywordflow">return</span> Default;
<a name="l00913"></a>00913   <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>++; 
<a name="l00914"></a>00914 
<a name="l00915"></a>00915   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() )
<a name="l00916"></a>00916   { <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size(); <span class="keywordflow">return</span> Default; }
<a name="l00917"></a>00917 
<a name="l00918"></a>00918   <span class="keyword">const</span> std::string Remain = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[<a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>], <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l00919"></a>00919 
<a name="l00920"></a>00920   <span class="keywordflow">return</span> Remain != <span class="stringliteral">&quot;&quot;</span> ? Remain.c_str() : Default;
<a name="l00921"></a>00921 }
<a name="l00922"></a>00922 
<a name="l00923"></a>00923 
<a name="l00924"></a>00924 
<a name="l00925"></a>00925 <span class="keyword">inline</span> std::string
<a name="l00926"></a><a class="code" href="classGetPot.php#aab07ce268797917b207a6309bc36f4a6">00926</a> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">GetPot::next</a>(<span class="keyword">const</span> std::string &amp;Default) 
<a name="l00927"></a>00927 { 
<a name="l00928"></a>00928   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> ) <span class="keywordflow">return</span> Default;
<a name="l00929"></a>00929   <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>++; 
<a name="l00930"></a>00930 
<a name="l00931"></a>00931   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() )
<a name="l00932"></a>00932   { <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size(); <span class="keywordflow">return</span> Default; }
<a name="l00933"></a>00933 
<a name="l00934"></a>00934   <span class="keyword">const</span> std::string Remain = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[<a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>], <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l00935"></a>00935 
<a name="l00936"></a>00936   <span class="keywordflow">return</span> Remain != <span class="stringliteral">&quot;&quot;</span> ? Remain : Default;
<a name="l00937"></a>00937 }
<a name="l00938"></a>00938 
<a name="l00939"></a>00939 
<a name="l00940"></a>00940 
<a name="l00941"></a>00941 <span class="comment">//     -- follow() function group </span>
<a name="l00942"></a>00942 <span class="comment">//        distinct option to be searched for</span>
<a name="l00943"></a>00943 <span class="keyword">inline</span> <span class="keywordtype">int</span> 
<a name="l00944"></a><a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">00944</a> <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">GetPot::follow</a>(<span class="keywordtype">int</span> Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option) 
<a name="l00945"></a>00945 { 
<a name="l00946"></a>00946   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(Option) == <span class="keyword">false</span> ) <span class="keywordflow">return</span> Default;
<a name="l00947"></a>00947   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(Default);
<a name="l00948"></a>00948 }
<a name="l00949"></a>00949 
<a name="l00950"></a>00950 
<a name="l00951"></a>00951 
<a name="l00952"></a>00952 <span class="keyword">inline</span> <span class="keywordtype">double</span>  
<a name="l00953"></a><a class="code" href="classGetPot.php#a1fbef86c9b70753ba353b162ec7e09a9">00953</a> <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">GetPot::follow</a>(<span class="keywordtype">double</span> Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option)
<a name="l00954"></a>00954 { 
<a name="l00955"></a>00955   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(Option) == <span class="keyword">false</span> ) <span class="keywordflow">return</span> Default;
<a name="l00956"></a>00956   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(Default);
<a name="l00957"></a>00957 }
<a name="l00958"></a>00958 
<a name="l00959"></a>00959 
<a name="l00960"></a>00960 
<a name="l00961"></a>00961 <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* 
<a name="l00962"></a><a class="code" href="classGetPot.php#aee69126624a03c72f4cebd87c5f36655">00962</a> <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">GetPot::follow</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option)
<a name="l00963"></a>00963 { 
<a name="l00964"></a>00964   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(Option) == <span class="keyword">false</span> ) <span class="keywordflow">return</span> Default;
<a name="l00965"></a>00965   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(Default);
<a name="l00966"></a>00966 }
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 
<a name="l00969"></a>00969 
<a name="l00970"></a>00970 <span class="preprocessor">#ifdef GETPOT_ALLOW_VARGS</span>
<a name="l00971"></a>00971 <span class="preprocessor"></span>  <span class="comment">//     -- second follow() function group </span>
<a name="l00972"></a>00972   <span class="comment">//        multiple option to be searched for</span>
<a name="l00973"></a>00973   <span class="keyword">inline</span> <span class="keywordtype">int</span> 
<a name="l00974"></a><a class="code" href="classGetPot.php#a55bfc61743e387853e6939e7fa70b5ee">00974</a>   <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">GetPot::follow</a>(<span class="keywordtype">int</span> Default, <span class="keywordtype">unsigned</span> No, <span class="keyword">const</span> <span class="keywordtype">char</span>* P, ...) 
<a name="l00975"></a>00975   { 
<a name="l00976"></a>00976     <span class="keywordflow">if</span>( No == 0 ) <span class="keywordflow">return</span> Default;
<a name="l00977"></a>00977     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(P) == <span class="keyword">true</span> ) <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(Default);
<a name="l00978"></a>00978   
<a name="l00979"></a>00979     std::va_list ap;
<a name="l00980"></a>00980     va_start(ap, P);
<a name="l00981"></a>00981     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;No; i++) {
<a name="l00982"></a>00982       <span class="keywordtype">char</span>* Opt = va_arg(ap, <span class="keywordtype">char</span> *);
<a name="l00983"></a>00983       <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(Opt) == <span class="keyword">true</span> ) { 
<a name="l00984"></a>00984         va_end(ap); 
<a name="l00985"></a>00985         <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(Default); 
<a name="l00986"></a>00986       }
<a name="l00987"></a>00987     }
<a name="l00988"></a>00988     va_end(ap); 
<a name="l00989"></a>00989     <span class="keywordflow">return</span> Default;
<a name="l00990"></a>00990   }
<a name="l00991"></a>00991 
<a name="l00992"></a>00992 
<a name="l00993"></a>00993 
<a name="l00994"></a>00994   <span class="keyword">inline</span> <span class="keywordtype">double</span>  
<a name="l00995"></a><a class="code" href="classGetPot.php#a853c1059736074cb693ef34ba4adaca6">00995</a>   <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">GetPot::follow</a>(<span class="keywordtype">double</span> Default, <span class="keywordtype">unsigned</span> No, <span class="keyword">const</span> <span class="keywordtype">char</span>* P, ...)
<a name="l00996"></a>00996   {
<a name="l00997"></a>00997     <span class="keywordflow">if</span>( No == 0 ) <span class="keywordflow">return</span> Default;
<a name="l00998"></a>00998     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(P) == <span class="keyword">true</span> ) <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(Default);
<a name="l00999"></a>00999   
<a name="l01000"></a>01000     std::va_list ap;
<a name="l01001"></a>01001     va_start(ap, P);
<a name="l01002"></a>01002     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;No; i++) {
<a name="l01003"></a>01003       <span class="keywordtype">char</span>* Opt = va_arg(ap, <span class="keywordtype">char</span> *);
<a name="l01004"></a>01004       <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(Opt) == <span class="keyword">true</span> ) { 
<a name="l01005"></a>01005         va_end(ap); 
<a name="l01006"></a>01006         <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(Default); 
<a name="l01007"></a>01007       }
<a name="l01008"></a>01008     }
<a name="l01009"></a>01009     va_end(ap); 
<a name="l01010"></a>01010     <span class="keywordflow">return</span> Default;
<a name="l01011"></a>01011   }
<a name="l01012"></a>01012 
<a name="l01013"></a>01013 
<a name="l01014"></a>01014 
<a name="l01015"></a>01015   <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* 
<a name="l01016"></a><a class="code" href="classGetPot.php#afaf293eedf5eb0565858be69c1bd1f00">01016</a>   <a class="code" href="classGetPot.php#aaa1c2b835b2599c5c087d2d4f82e368b">GetPot::follow</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Default, <span class="keywordtype">unsigned</span> No, <span class="keyword">const</span> <span class="keywordtype">char</span>* P, ...)
<a name="l01017"></a>01017   {
<a name="l01018"></a>01018     <span class="keywordflow">if</span>( No == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01019"></a>01019     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(P) == <span class="keyword">true</span> ) <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(Default);
<a name="l01020"></a>01020   
<a name="l01021"></a>01021     std::va_list ap;
<a name="l01022"></a>01022     va_start(ap, P);
<a name="l01023"></a>01023     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;No; i++) {
<a name="l01024"></a>01024       <span class="keywordtype">char</span>* Opt = va_arg(ap, <span class="keywordtype">char</span> *);
<a name="l01025"></a>01025       <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a183e68216495d2afe4fb1d3a6363718d">search</a>(Opt) == <span class="keyword">true</span> ) { 
<a name="l01026"></a>01026         va_end(ap); 
<a name="l01027"></a>01027         <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab198c8915bf041f409d021d947a63c8d">next</a>(Default); 
<a name="l01028"></a>01028       }
<a name="l01029"></a>01029     }
<a name="l01030"></a>01030     va_end(ap); 
<a name="l01031"></a>01031     <span class="keywordflow">return</span> Default;
<a name="l01032"></a>01032   }
<a name="l01033"></a>01033 
<a name="l01034"></a>01034 <span class="preprocessor">#endif // GETPOT_ALLOW_VARGS</span>
<a name="l01035"></a>01035 <span class="preprocessor"></span>
<a name="l01036"></a>01036 
<a name="l01037"></a>01037 
<a name="l01039"></a>01039 <span class="comment">// (*) directly connected options</span>
<a name="l01040"></a>01040 <span class="comment">//.............................................................................</span>
<a name="l01041"></a>01041 <span class="comment">//</span>
<a name="l01042"></a>01042 <span class="keyword">inline</span> <span class="keywordtype">int</span>
<a name="l01043"></a><a class="code" href="classGetPot.php#a2eec5ed54d86646402e5e16485601fea">01043</a> <a class="code" href="classGetPot.php#a2eec5ed54d86646402e5e16485601fea">GetPot::direct_follow</a>(<span class="keywordtype">int</span> Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option) 
<a name="l01044"></a>01044 {
<a name="l01045"></a>01045   <span class="keyword">const</span> <span class="keywordtype">char</span>* FollowStr = <a class="code" href="classGetPot.php#a7bf8707b91c842d22acb956fc03e0454">__match_starting_string</a>(Option);
<a name="l01046"></a>01046   <span class="keywordflow">if</span>( FollowStr == 0 )                    <span class="keywordflow">return</span> Default;
<a name="l01047"></a>01047   <span class="keywordflow">if</span>( ++<a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size();
<a name="l01048"></a>01048   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(FollowStr, Default);
<a name="l01049"></a>01049 }
<a name="l01050"></a>01050 
<a name="l01051"></a>01051 
<a name="l01052"></a>01052 
<a name="l01053"></a>01053 <span class="keyword">inline</span> <span class="keywordtype">double</span> 
<a name="l01054"></a><a class="code" href="classGetPot.php#a7fec55c8f0671e952b7f02fc799d8d4c">01054</a> <a class="code" href="classGetPot.php#a2eec5ed54d86646402e5e16485601fea">GetPot::direct_follow</a>(<span class="keywordtype">double</span> Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option) 
<a name="l01055"></a>01055 {
<a name="l01056"></a>01056   <span class="keyword">const</span> <span class="keywordtype">char</span>* FollowStr = <a class="code" href="classGetPot.php#a7bf8707b91c842d22acb956fc03e0454">__match_starting_string</a>(Option);
<a name="l01057"></a>01057   <span class="keywordflow">if</span>( FollowStr == 0 )                   <span class="keywordflow">return</span> Default;
<a name="l01058"></a>01058   <span class="keywordflow">if</span>( ++<a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size();
<a name="l01059"></a>01059   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(FollowStr, Default);
<a name="l01060"></a>01060 }
<a name="l01061"></a>01061 
<a name="l01062"></a>01062 
<a name="l01063"></a>01063 
<a name="l01064"></a>01064 <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* 
<a name="l01065"></a><a class="code" href="classGetPot.php#a3e164afa7159d9e041aa5387f8712cd3">01065</a> <a class="code" href="classGetPot.php#a2eec5ed54d86646402e5e16485601fea">GetPot::direct_follow</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Default, <span class="keyword">const</span> <span class="keywordtype">char</span>* Option)
<a name="l01066"></a>01066 {
<a name="l01067"></a>01067   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> ) <span class="keywordflow">return</span> Default;
<a name="l01068"></a>01068   <span class="keyword">const</span> <span class="keywordtype">char</span>* FollowStr = <a class="code" href="classGetPot.php#a7bf8707b91c842d22acb956fc03e0454">__match_starting_string</a>(Option);
<a name="l01069"></a>01069   <span class="keywordflow">if</span>( FollowStr == 0 )          <span class="keywordflow">return</span> Default;
<a name="l01070"></a>01070   <span class="keywordflow">if</span>( ++<a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size();
<a name="l01071"></a>01071   <span class="keywordflow">return</span> FollowStr;
<a name="l01072"></a>01072 }
<a name="l01073"></a>01073 
<a name="l01074"></a>01074 
<a name="l01075"></a>01075 
<a name="l01076"></a>01076 <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*
<a name="l01077"></a><a class="code" href="classGetPot.php#a7bf8707b91c842d22acb956fc03e0454">01077</a> <a class="code" href="classGetPot.php#a7bf8707b91c842d22acb956fc03e0454">GetPot::__match_starting_string</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* StartString) 
<a name="l01078"></a>01078   <span class="comment">// pointer  to the place where the string after </span>
<a name="l01079"></a>01079   <span class="comment">//          the match inside the found argument starts.</span>
<a name="l01080"></a>01080   <span class="comment">// 0        no argument matches the starting string.</span>
<a name="l01081"></a>01081 {
<a name="l01082"></a>01082   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> N = std::strlen(StartString);
<a name="l01083"></a>01083   <span class="keywordtype">unsigned</span> OldCursor = <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>;
<a name="l01084"></a>01084   <span class="keywordflow">if</span>( OldCursor &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) OldCursor = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() - 1;
<a name="l01085"></a>01085   <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> = <span class="keyword">true</span>;
<a name="l01086"></a>01086 
<a name="l01087"></a>01087   <span class="comment">// (*) first loop from cursor position until end</span>
<a name="l01088"></a>01088   <span class="keywordtype">unsigned</span> c = <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a>;
<a name="l01089"></a>01089   <span class="keywordflow">for</span>(; c &lt; <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size(); c++) {
<a name="l01090"></a>01090     <span class="keywordflow">if</span>( std::strncmp(StartString, <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[c].c_str(), N) == 0)
<a name="l01091"></a>01091     { <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = c; <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> = <span class="keyword">false</span>; <span class="keywordflow">return</span> &amp;(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[c].c_str()[N]); }
<a name="l01092"></a>01092   }
<a name="l01093"></a>01093 
<a name="l01094"></a>01094   <span class="keywordflow">if</span>( ! <a class="code" href="classGetPot.php#ae6e6ca5fb70e92b0e7e4f6717ec6a15a">search_loop_f</a> ) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01095"></a>01095 
<a name="l01096"></a>01096   <span class="comment">// (*) second loop from 0 to old cursor position</span>
<a name="l01097"></a>01097   <span class="keywordflow">for</span>(c = 1; c &lt; OldCursor; c++) {
<a name="l01098"></a>01098     <span class="keywordflow">if</span>( std::strncmp(StartString, <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[c].c_str(), N) == 0)
<a name="l01099"></a>01099     { <a class="code" href="classGetPot.php#a6ac9cf03ccc22e114721474382b52220">cursor</a> = c; <a class="code" href="classGetPot.php#a53936c82a020f75d4718c112fce90e7e">search_failed_f</a> = <span class="keyword">false</span>; <span class="keywordflow">return</span> &amp;(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[c].c_str()[N]); }
<a name="l01100"></a>01100   }
<a name="l01101"></a>01101   <span class="keywordflow">return</span> 0;
<a name="l01102"></a>01102 }
<a name="l01103"></a>01103 
<a name="l01104"></a>01104 
<a name="l01105"></a>01105 
<a name="l01107"></a>01107 <span class="comment">// (*) search for flags</span>
<a name="l01108"></a>01108 <span class="comment">//.............................................................................</span>
<a name="l01109"></a>01109 <span class="comment">//</span>
<a name="l01110"></a>01110 <span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l01111"></a><a class="code" href="classGetPot.php#ae0ca20c8e8ddd2908d8d47e0a2d0569b">01111</a> <a class="code" href="classGetPot.php#ae0ca20c8e8ddd2908d8d47e0a2d0569b">GetPot::options_contain</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* FlagList)<span class="keyword"> const</span>
<a name="l01112"></a>01112 <span class="keyword"></span>{
<a name="l01113"></a>01113   <span class="comment">// go through all arguments that start with a &#39;-&#39; (but not &#39;--&#39;)</span>
<a name="l01114"></a>01114   std::string str;
<a name="l01115"></a>01115   <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::const_iterator it = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.begin();
<a name="l01116"></a>01116       it != <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.end();
<a name="l01117"></a>01117       it++) {
<a name="l01118"></a>01118     str = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(*it, <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l01119"></a>01119 
<a name="l01120"></a>01120     <span class="keywordflow">if</span>( str.length() &gt;= 2 &amp;&amp; str[0] == <span class="charliteral">&#39;-&#39;</span> &amp;&amp; str[1] != <span class="charliteral">&#39;-&#39;</span> )
<a name="l01121"></a>01121       <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#abfa713c1ea40427eb6983c9c11a14938">__check_flags</a>(str, FlagList) ) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01122"></a>01122   }
<a name="l01123"></a>01123   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01124"></a>01124 }
<a name="l01125"></a>01125 
<a name="l01126"></a>01126 
<a name="l01127"></a>01127 
<a name="l01128"></a>01128 <span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l01129"></a><a class="code" href="classGetPot.php#a30b6999f373de76e53eb702667b0b09f">01129</a> <a class="code" href="classGetPot.php#a30b6999f373de76e53eb702667b0b09f">GetPot::argument_contains</a>(<span class="keywordtype">unsigned</span> Idx, <span class="keyword">const</span> <span class="keywordtype">char</span>* FlagList)<span class="keyword"> const</span>
<a name="l01130"></a>01130 <span class="keyword"></span>{
<a name="l01131"></a>01131   <span class="keywordflow">if</span>( Idx &gt;= <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() ) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01132"></a>01132 
<a name="l01133"></a>01133   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> == <span class="stringliteral">&quot;&quot;</span> )
<a name="l01134"></a>01134     <span class="comment">// search argument for any flag in flag list</span>
<a name="l01135"></a>01135     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#abfa713c1ea40427eb6983c9c11a14938">__check_flags</a>(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[Idx], FlagList);
<a name="l01136"></a>01136 
<a name="l01137"></a>01137   <span class="comment">// if a prefix is set, then the argument index is the index</span>
<a name="l01138"></a>01138   <span class="comment">//   inside the &#39;namespace&#39;</span>
<a name="l01139"></a>01139   <span class="comment">// =&gt; only check list of arguments that start with prefix</span>
<a name="l01140"></a>01140   <span class="keywordtype">unsigned</span> no_matches = 0;
<a name="l01141"></a>01141   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=0; i&lt;<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size(); i++) {
<a name="l01142"></a>01142     <span class="keyword">const</span> std::string Remain = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[i], <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l01143"></a>01143     <span class="keywordflow">if</span>( Remain != <span class="stringliteral">&quot;&quot;</span>) {
<a name="l01144"></a>01144       no_matches += 1;
<a name="l01145"></a>01145       <span class="keywordflow">if</span>( no_matches == Idx)
<a name="l01146"></a>01146         <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#abfa713c1ea40427eb6983c9c11a14938">__check_flags</a>(Remain, FlagList);
<a name="l01147"></a>01147     }
<a name="l01148"></a>01148   }
<a name="l01149"></a>01149   <span class="comment">// no argument in this namespace</span>
<a name="l01150"></a>01150   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01151"></a>01151 }
<a name="l01152"></a>01152 
<a name="l01153"></a>01153 
<a name="l01154"></a>01154 
<a name="l01155"></a>01155 <span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l01156"></a><a class="code" href="classGetPot.php#abfa713c1ea40427eb6983c9c11a14938">01156</a> <a class="code" href="classGetPot.php#abfa713c1ea40427eb6983c9c11a14938">GetPot::__check_flags</a>(<span class="keyword">const</span> std::string&amp; Str, <span class="keyword">const</span> <span class="keywordtype">char</span>* FlagList)<span class="keyword"> const</span>
<a name="l01157"></a>01157 <span class="keyword"></span>{
<a name="l01158"></a>01158   <span class="keywordflow">for</span>(<span class="keyword">const</span> <span class="keywordtype">char</span>* p=FlagList; *p != <span class="charliteral">&#39;\0&#39;</span> ; p++)
<a name="l01159"></a>01159     <span class="keywordflow">if</span>( Str.find(*p) != std::string::npos ) <span class="keywordflow">return</span> <span class="keyword">true</span>; <span class="comment">// found something</span>
<a name="l01160"></a>01160   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01161"></a>01161 }
<a name="l01162"></a>01162 
<a name="l01163"></a>01163 
<a name="l01164"></a>01164 
<a name="l01166"></a>01166 <span class="comment">// (*) nominus arguments</span>
<a name="l01167"></a>01167 <span class="keyword">inline</span> std::vector&lt;std::string&gt;  
<a name="l01168"></a><a class="code" href="classGetPot.php#a71533816009fe25d4b1306aaa5f4e041">01168</a> <a class="code" href="classGetPot.php#a71533816009fe25d4b1306aaa5f4e041">GetPot::nominus_vector</a>() const
<a name="l01169"></a>01169 <span class="comment">// return vector of nominus arguments</span>
<a name="l01170"></a>01170 {
<a name="l01171"></a>01171   std::vector&lt;std::string&gt; nv;
<a name="l01172"></a>01172   <span class="keywordflow">for</span>(std::vector&lt;unsigned&gt;::const_iterator it = <a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">idx_nominus</a>.begin();
<a name="l01173"></a>01173       it != <a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">idx_nominus</a>.end();
<a name="l01174"></a>01174       it++) {
<a name="l01175"></a>01175     nv.push_back(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[*it]);
<a name="l01176"></a>01176   }
<a name="l01177"></a>01177   <span class="keywordflow">return</span> nv;
<a name="l01178"></a>01178 }
<a name="l01179"></a>01179 
<a name="l01180"></a>01180 
<a name="l01181"></a>01181 
<a name="l01182"></a>01182 <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* 
<a name="l01183"></a><a class="code" href="classGetPot.php#af2e290d253b1c20d9dffb995a5af4d4b">01183</a> <a class="code" href="classGetPot.php#af2e290d253b1c20d9dffb995a5af4d4b">GetPot::next_nominus</a>()
<a name="l01184"></a>01184 {
<a name="l01185"></a>01185   <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a1a9c5bf4bc324f13459a9ca99fdc72eb">nominus_cursor</a> &lt; <span class="keywordtype">int</span>(<a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">idx_nominus</a>.size()) - 1 )
<a name="l01186"></a>01186     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[<a class="code" href="classGetPot.php#ae0665595a49e0fc24a14199345d0176e">idx_nominus</a>[++<a class="code" href="classGetPot.php#a1a9c5bf4bc324f13459a9ca99fdc72eb">nominus_cursor</a>]].c_str();
<a name="l01187"></a>01187   <span class="keywordflow">return</span> 0;
<a name="l01188"></a>01188 }
<a name="l01189"></a>01189 
<a name="l01190"></a>01190 
<a name="l01191"></a>01191 
<a name="l01192"></a>01192 <span class="keyword">inline</span> <span class="keywordtype">void</span> 
<a name="l01193"></a><a class="code" href="classGetPot.php#a3a2ef52f5233b7c7fc0044a1b2e92ff7">01193</a> <a class="code" href="classGetPot.php#a3a2ef52f5233b7c7fc0044a1b2e92ff7">GetPot::reset_nominus_cursor</a>()
<a name="l01194"></a>01194 { <a class="code" href="classGetPot.php#a1a9c5bf4bc324f13459a9ca99fdc72eb">nominus_cursor</a> = -1; }
<a name="l01195"></a>01195 
<a name="l01196"></a>01196 
<a name="l01197"></a>01197 
<a name="l01199"></a>01199 <span class="comment">// (*) variables</span>
<a name="l01200"></a>01200 <span class="comment">//.............................................................................</span>
<a name="l01201"></a>01201 <span class="comment">//</span>
<a name="l01202"></a>01202 <span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l01203"></a><a class="code" href="classGetPot.php#adc3475ba87c72e6ea8b84de02d2ef58f">01203</a> <a class="code" href="classGetPot.php#adc3475ba87c72e6ea8b84de02d2ef58f">GetPot::have_variable</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName)<span class="keyword"> const</span>
<a name="l01204"></a>01204 <span class="keyword"></span>{
<a name="l01205"></a>01205   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>* sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01206"></a>01206   <span class="keywordflow">if</span> (sv == 0) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01207"></a>01207   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01208"></a>01208 }
<a name="l01209"></a>01209 
<a name="l01210"></a>01210 <span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l01211"></a><a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">01211</a> <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">GetPot::operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">bool</span> Default)<span class="keyword"> const</span>
<a name="l01212"></a>01212 <span class="keyword"></span>{
<a name="l01213"></a>01213   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>* sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01214"></a>01214   <span class="keywordflow">if</span> ( sv == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01215"></a>01215   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(sv-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>, Default);
<a name="l01216"></a>01216 }
<a name="l01217"></a>01217 
<a name="l01218"></a>01218 
<a name="l01219"></a>01219 
<a name="l01220"></a>01220 <span class="keyword">inline</span> <span class="keywordtype">int</span> 
<a name="l01221"></a><a class="code" href="classGetPot.php#a97a8b10f961e4401ef6f6db3b4642c78">01221</a> <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">GetPot::operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">int</span> Default)<span class="keyword"> const</span>
<a name="l01222"></a>01222 <span class="keyword"></span>{
<a name="l01223"></a>01223   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>*  sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01224"></a>01224   <span class="keywordflow">if</span>( sv == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01225"></a>01225   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(sv-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>, Default);
<a name="l01226"></a>01226 }
<a name="l01227"></a>01227 
<a name="l01228"></a>01228 
<a name="l01229"></a>01229 
<a name="l01230"></a>01230 <span class="keyword">inline</span> <span class="keywordtype">double</span>
<a name="l01231"></a><a class="code" href="classGetPot.php#a7c5f97119da8c79795efa0dbb0a431cf">01231</a> <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">GetPot::operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">double</span> Default)<span class="keyword"> const</span>
<a name="l01232"></a>01232 <span class="keyword"></span>{
<a name="l01233"></a>01233   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>*  sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01234"></a>01234   <span class="keywordflow">if</span>( sv == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01235"></a>01235   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(sv-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>, Default);
<a name="l01236"></a>01236 }
<a name="l01237"></a>01237 
<a name="l01238"></a>01238 
<a name="l01239"></a>01239 
<a name="l01240"></a>01240 <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span>
<a name="l01241"></a><a class="code" href="classGetPot.php#a7e3523afbc4b733e34a9fb5821750267">01241</a> <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">GetPot::operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">long</span> <span class="keywordtype">double</span> Default)<span class="keyword"> const</span>
<a name="l01242"></a>01242 <span class="keyword"></span>{
<a name="l01243"></a>01243   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>*  sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01244"></a>01244   <span class="keywordflow">if</span>( sv == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01245"></a>01245   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(sv-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>, Default);
<a name="l01246"></a>01246 }
<a name="l01247"></a>01247 
<a name="l01248"></a>01248 
<a name="l01249"></a>01249 
<a name="l01250"></a>01250 <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*
<a name="l01251"></a><a class="code" href="classGetPot.php#a77909ae51564b9a2909cd81f8639ea7a">01251</a> <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">GetPot::operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keyword">const</span> <span class="keywordtype">char</span>* Default)<span class="keyword"> const</span>
<a name="l01252"></a>01252 <span class="keyword"></span>{
<a name="l01253"></a>01253   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>*  sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01254"></a>01254   <span class="keywordflow">if</span>( sv == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01255"></a>01255   <span class="keywordflow">return</span> sv-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>.c_str();
<a name="l01256"></a>01256 }
<a name="l01257"></a>01257 
<a name="l01258"></a>01258 
<a name="l01259"></a>01259 
<a name="l01260"></a>01260 <span class="keyword">inline</span> std::string
<a name="l01261"></a><a class="code" href="classGetPot.php#a766a36009500c16202291439d95bdfcb">01261</a> <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">GetPot::operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keyword">const</span> std::string&amp; Default)<span class="keyword"> const</span>
<a name="l01262"></a>01262 <span class="keyword"></span>{
<a name="l01263"></a>01263   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>*  sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01264"></a>01264   <span class="keywordflow">if</span>( sv == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01265"></a>01265   <span class="keywordflow">return</span> sv-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>;
<a name="l01266"></a>01266 }
<a name="l01267"></a>01267 
<a name="l01268"></a>01268 
<a name="l01269"></a>01269 
<a name="l01270"></a>01270 <span class="keyword">inline</span> <span class="keywordtype">int</span> 
<a name="l01271"></a><a class="code" href="classGetPot.php#a403ee188f1ba0447569cd982cb9dcc44">01271</a> <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">GetPot::operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">int</span> Default, <span class="keywordtype">unsigned</span> Idx)<span class="keyword"> const</span>
<a name="l01272"></a>01272 <span class="keyword"></span>{
<a name="l01273"></a>01273   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>* sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01274"></a>01274   <span class="keywordflow">if</span>( sv == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01275"></a>01275   <span class="keyword">const</span> std::string*  element = sv-&gt;<a class="code" href="structGetPot_1_1variable.php#afbec5f1b56e2c6d4929cae8de7bc0f89">get_element</a>(Idx);
<a name="l01276"></a>01276   <span class="keywordflow">if</span>( element == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01277"></a>01277   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*element, Default);
<a name="l01278"></a>01278 }
<a name="l01279"></a>01279 
<a name="l01280"></a>01280 
<a name="l01281"></a>01281 
<a name="l01282"></a>01282 <span class="keyword">inline</span> <span class="keywordtype">double</span>
<a name="l01283"></a><a class="code" href="classGetPot.php#a5208ce52dbf038c6fff7c04b84cedac9">01283</a> <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">GetPot::operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keywordtype">double</span> Default, <span class="keywordtype">unsigned</span> Idx)<span class="keyword"> const</span>
<a name="l01284"></a>01284 <span class="keyword"></span>{
<a name="l01285"></a>01285   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>* sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01286"></a>01286   <span class="keywordflow">if</span>( sv == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01287"></a>01287   <span class="keyword">const</span> std::string*  element = sv-&gt;<a class="code" href="structGetPot_1_1variable.php#afbec5f1b56e2c6d4929cae8de7bc0f89">get_element</a>(Idx);
<a name="l01288"></a>01288   <span class="keywordflow">if</span>( element == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01289"></a>01289   <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*element, Default);
<a name="l01290"></a>01290 }
<a name="l01291"></a>01291 
<a name="l01292"></a>01292 
<a name="l01293"></a>01293 
<a name="l01294"></a>01294 <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">char</span>*
<a name="l01295"></a><a class="code" href="classGetPot.php#a07734aa343750fc051104c8e10a33493">01295</a> <a class="code" href="classGetPot.php#ae8ef969f90efc0b45d53265c45b4ae4d">GetPot::operator()</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName, <span class="keyword">const</span> <span class="keywordtype">char</span>* Default, <span class="keywordtype">unsigned</span> Idx)<span class="keyword"> const</span>
<a name="l01296"></a>01296 <span class="keyword"></span>{
<a name="l01297"></a>01297   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>*  sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01298"></a>01298   <span class="keywordflow">if</span>( sv == 0 ) <span class="keywordflow">return</span> Default;
<a name="l01299"></a>01299   <span class="keyword">const</span> std::string* element = sv-&gt;<a class="code" href="structGetPot_1_1variable.php#afbec5f1b56e2c6d4929cae8de7bc0f89">get_element</a>(Idx);     
<a name="l01300"></a>01300   <span class="keywordflow">if</span>( element == 0 )  <span class="keywordflow">return</span> Default;
<a name="l01301"></a>01301   <span class="keywordflow">return</span> element-&gt;c_str();
<a name="l01302"></a>01302 }
<a name="l01303"></a>01303 
<a name="l01304"></a>01304 
<a name="l01305"></a>01305 
<a name="l01306"></a>01306 <span class="keyword">inline</span> <span class="keywordtype">unsigned</span>
<a name="l01307"></a><a class="code" href="classGetPot.php#ac58129dc7b1cccfa45a7175f33c8d6c3">01307</a> <a class="code" href="classGetPot.php#ac58129dc7b1cccfa45a7175f33c8d6c3">GetPot::vector_variable_size</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* VarName)<span class="keyword"> const</span>
<a name="l01308"></a>01308 <span class="keyword"></span>{
<a name="l01309"></a>01309   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>*  sv = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName);
<a name="l01310"></a>01310   <span class="keywordflow">if</span>( sv == 0 ) <span class="keywordflow">return</span> 0;
<a name="l01311"></a>01311   <span class="keywordflow">return</span> sv-&gt;<a class="code" href="structGetPot_1_1variable.php#a8900906a1cbdf47618278b468ef6283d">value</a>.size();
<a name="l01312"></a>01312 }
<a name="l01313"></a>01313 
<a name="l01314"></a>01314 
<a name="l01315"></a>01315 
<a name="l01316"></a>01316 <span class="keyword">inline</span> std::vector&lt;std::string&gt;
<a name="l01317"></a><a class="code" href="classGetPot.php#a7dff9aa415fc2f74e5b7c6a38db0fa30">01317</a> <a class="code" href="classGetPot.php#a7dff9aa415fc2f74e5b7c6a38db0fa30">GetPot::get_variable_names</a>()<span class="keyword"> const</span>
<a name="l01318"></a>01318 <span class="keyword"></span>{
<a name="l01319"></a>01319   std::vector&lt;std::string&gt;  result;
<a name="l01320"></a>01320   <span class="keywordflow">for</span>(std::vector&lt;GetPot::variable&gt;::const_iterator it = <a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">variables</a>.begin();
<a name="l01321"></a>01321       it != <a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">variables</a>.end(); it++) {
<a name="l01322"></a>01322     <span class="keyword">const</span> std::string Tmp = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>((*it).name, <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l01323"></a>01323     <span class="keywordflow">if</span>( Tmp != <span class="stringliteral">&quot;&quot;</span> ) result.push_back(Tmp);
<a name="l01324"></a>01324   }
<a name="l01325"></a>01325   <span class="keywordflow">return</span> result;
<a name="l01326"></a>01326 }
<a name="l01327"></a>01327 
<a name="l01328"></a>01328 
<a name="l01329"></a>01329 
<a name="l01330"></a>01330 <span class="keyword">inline</span> std::vector&lt;std::string&gt;
<a name="l01331"></a><a class="code" href="classGetPot.php#a3b76628a2f0ae4394386663a6985c598">01331</a> <a class="code" href="classGetPot.php#a3b76628a2f0ae4394386663a6985c598">GetPot::get_section_names</a>()<span class="keyword"> const</span>
<a name="l01332"></a>01332 <span class="keyword"></span>{ <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a8b8f2d90bc5546a69172c19c23ddfe10">section_list</a>; }
<a name="l01333"></a>01333 
<a name="l01334"></a>01334 <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>*
<a name="l01335"></a><a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">01335</a> <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">GetPot::__find_variable</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Name)<span class="keyword"> const</span>
<a name="l01336"></a>01336 <span class="keyword"></span>{
<a name="l01337"></a>01337   std::string <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a> = <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> + Name;
<a name="l01338"></a>01338   <span class="keywordflow">for</span>(std::vector&lt;variable&gt;::const_iterator it = <a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">variables</a>.begin();
<a name="l01339"></a>01339       it != <a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">variables</a>.end();
<a name="l01340"></a>01340       it++)
<a name="l01341"></a>01341     <span class="keywordflow">if</span>( (*it).name == name ) <span class="keywordflow">return</span> &amp;(*it);
<a name="l01342"></a>01342   <span class="keywordflow">return</span> 0;
<a name="l01343"></a>01343 }
<a name="l01344"></a>01344 
<a name="l01345"></a>01345 
<a name="l01346"></a>01346 
<a name="l01348"></a>01348 <span class="comment">// (*) ouput (basically for debugging reasons</span>
<a name="l01349"></a>01349 <span class="comment">//.............................................................................</span>
<a name="l01350"></a>01350 <span class="comment">//</span>
<a name="l01351"></a>01351 <span class="keyword">inline</span> <span class="keywordtype">int</span> 
<a name="l01352"></a><a class="code" href="classGetPot.php#a50eb9af9aec818bf434da399bb3644d1">01352</a> <a class="code" href="classGetPot.php#a50eb9af9aec818bf434da399bb3644d1">GetPot::print</a>()<span class="keyword"> const</span>
<a name="l01353"></a>01353 <span class="keyword"></span>{
<a name="l01354"></a>01354   std::cout &lt;&lt; <span class="stringliteral">&quot;argc = &quot;</span> &lt;&lt; <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size() &lt;&lt; std::endl;
<a name="l01355"></a>01355   <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::const_iterator it = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.begin(); it != <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.end(); it++)
<a name="l01356"></a>01356     std::cout &lt;&lt; *it &lt;&lt; std::endl;
<a name="l01357"></a>01357   std::cout &lt;&lt; std::endl;
<a name="l01358"></a>01358   <span class="keywordflow">return</span> 1;
<a name="l01359"></a>01359 }
<a name="l01360"></a>01360 
<a name="l01361"></a>01361 
<a name="l01362"></a>01362 
<a name="l01363"></a>01363 <span class="comment">// (*) dollar bracket expressions (DBEs) ------------------------------------</span>
<a name="l01364"></a>01364 <span class="comment">//</span>
<a name="l01365"></a>01365 <span class="comment">//     1) Entry Function: __DBE_expand_string()</span>
<a name="l01366"></a>01366 <span class="comment">//        Takes a string such as</span>
<a name="l01367"></a>01367 <span class="comment">//</span>
<a name="l01368"></a>01368 <span class="comment">//          &quot;${+ ${x} ${y}}   Subject-${&amp; ${section} ${subsection}}:   ${title}&quot;</span>
<a name="l01369"></a>01369 <span class="comment">//</span>
<a name="l01370"></a>01370 <span class="comment">//        calls __DBE_expand() for each of the expressions</span>
<a name="l01371"></a>01371 <span class="comment">//</span>
<a name="l01372"></a>01372 <span class="comment">//           ${+ ${x} ${y}}</span>
<a name="l01373"></a>01373 <span class="comment">//           ${&amp; ${section} ${subsection}}</span>
<a name="l01374"></a>01374 <span class="comment">//           ${Title}</span>
<a name="l01375"></a>01375 <span class="comment">//</span>
<a name="l01376"></a>01376 <span class="comment">//        and returns the string</span>
<a name="l01377"></a>01377 <span class="comment">//</span>
<a name="l01378"></a>01378 <span class="comment">//          &quot;4711 Subject-1.01:   Mit den Clowns kamen die Schwaene&quot;</span>
<a name="l01379"></a>01379 <span class="comment">//</span>
<a name="l01380"></a>01380 <span class="comment">//        assuming that</span>
<a name="l01381"></a>01381 <span class="comment">//            x          = &quot;4699&quot;</span>
<a name="l01382"></a>01382 <span class="comment">//            y          = &quot;12&quot;</span>
<a name="l01383"></a>01383 <span class="comment">//            section    = &quot;1.&quot;</span>
<a name="l01384"></a>01384 <span class="comment">//            subsection = &quot;01&quot;</span>
<a name="l01385"></a>01385 <span class="comment">//            title      = &quot;Mit den Clowns kamen die Schwaene&quot;</span>
<a name="l01386"></a>01386 <span class="comment">//</span>
<a name="l01387"></a>01387 <span class="comment">//      2) __DBE_expand():</span>
<a name="l01388"></a>01388 <span class="comment">//</span>
<a name="l01389"></a>01389 <span class="comment">//           checks for the command, i.e. the &#39;sign&#39; that follows &#39;${&#39;</span>
<a name="l01390"></a>01390 <span class="comment">//           divides the argument list into sub-expressions using</span>
<a name="l01391"></a>01391 <span class="comment">//           __DBE_get_expr_list()</span>
<a name="l01392"></a>01392 <span class="comment">//</span>
<a name="l01393"></a>01393 <span class="comment">//           ${+ ${x} ${y}}                 -&gt; &quot;${x}&quot;  &quot;${y}&quot;</span>
<a name="l01394"></a>01394 <span class="comment">//           ${&amp; ${section} ${subsection}}  -&gt; &quot;${section}&quot; &quot;${subsection}&quot;</span>
<a name="l01395"></a>01395 <span class="comment">//           ${Title}                       -&gt; Nothing, variable expansion</span>
<a name="l01396"></a>01396 <span class="comment">//</span>
<a name="l01397"></a>01397 <span class="comment">//      3) __DBE_expression_list():</span>
<a name="l01398"></a>01398 <span class="comment">//</span>
<a name="l01399"></a>01399 <span class="comment">//           builds a vector of unbracketed whitespace separated strings, i.e.</span>
<a name="l01400"></a>01400 <span class="comment">//</span>
<a name="l01401"></a>01401 <span class="comment">//           &quot;  ${Number}.a ${: Das Marmorbild} AB-${&amp; Author= ${Eichendorf}-1870}&quot;</span>
<a name="l01402"></a>01402 <span class="comment">//</span>
<a name="l01403"></a>01403 <span class="comment">//           is split into a vector</span>
<a name="l01404"></a>01404 <span class="comment">//</span>
<a name="l01405"></a>01405 <span class="comment">//              [0] ${Number}.a</span>
<a name="l01406"></a>01406 <span class="comment">//              [1] ${: Das Marmorbild}</span>
<a name="l01407"></a>01407 <span class="comment">//              [2] AB-${&amp; Author= ${Eichendorf}}-1870</span>
<a name="l01408"></a>01408 <span class="comment">//</span>
<a name="l01409"></a>01409 <span class="comment">//           Each sub-expression is expanded using expand(). </span>
<a name="l01410"></a>01410 <span class="comment">//---------------------------------------------------------------------------    </span>
<a name="l01411"></a>01411 <span class="keyword">inline</span> std::string 
<a name="l01412"></a><a class="code" href="classGetPot.php#aa1db4b6a0116a113c709ab2921b50fba">01412</a> <a class="code" href="classGetPot.php#aa1db4b6a0116a113c709ab2921b50fba">GetPot::__DBE_expand_string</a>(<span class="keyword">const</span> std::string&amp; str) 
<a name="l01413"></a>01413 {
<a name="l01414"></a>01414   <span class="comment">// Parses for closing operators &#39;${ }&#39; and expands them letting</span>
<a name="l01415"></a>01415   <span class="comment">// white spaces and other letters as they are.</span>
<a name="l01416"></a>01416   std::string   new_string = <span class="stringliteral">&quot;&quot;</span>;
<a name="l01417"></a>01417   <span class="keywordtype">unsigned</span> open_brackets = 0;
<a name="l01418"></a>01418   <span class="keywordtype">unsigned</span> first = 0;
<a name="l01419"></a>01419   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i = 0;  i&lt;str.size(); i++) {
<a name="l01420"></a>01420     <span class="keywordflow">if</span>( i &lt; str.size() - 2 &amp;&amp; str.substr(i, 2) == <span class="stringliteral">&quot;${&quot;</span> ) {
<a name="l01421"></a>01421       <span class="keywordflow">if</span>( open_brackets == 0 ) first = i+2;
<a name="l01422"></a>01422       open_brackets++;
<a name="l01423"></a>01423     }
<a name="l01424"></a>01424     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( str[i] == <span class="charliteral">&#39;}&#39;</span> &amp;&amp; open_brackets &gt; 0) {
<a name="l01425"></a>01425       open_brackets -= 1;
<a name="l01426"></a>01426       <span class="keywordflow">if</span>( open_brackets == 0 ) {
<a name="l01427"></a>01427         <span class="keyword">const</span> std::string Replacement = <a class="code" href="classGetPot.php#a5d561f41337478dfd74cb1603ff57a6c">__DBE_expand</a>(str.substr(first, i - first));
<a name="l01428"></a>01428         new_string += Replacement;
<a name="l01429"></a>01429       }
<a name="l01430"></a>01430     }
<a name="l01431"></a>01431     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( open_brackets == 0 )
<a name="l01432"></a>01432       new_string += str[i];
<a name="l01433"></a>01433   }
<a name="l01434"></a>01434   <span class="keywordflow">return</span> new_string;
<a name="l01435"></a>01435 }
<a name="l01436"></a>01436 
<a name="l01437"></a>01437 
<a name="l01438"></a>01438 
<a name="l01439"></a>01439 <span class="keyword">inline</span> std::vector&lt;std::string&gt;
<a name="l01440"></a><a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">01440</a> <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">GetPot::__DBE_get_expr_list</a>(<span class="keyword">const</span> std::string&amp; str_, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> ExpectedNumber)
<a name="l01441"></a>01441   <span class="comment">// ensures that the resulting vector has the expected number</span>
<a name="l01442"></a>01442   <span class="comment">// of arguments, but they may contain an error message</span>
<a name="l01443"></a>01443 {
<a name="l01444"></a>01444   std::string str = str_;
<a name="l01445"></a>01445   <span class="comment">// Separates expressions by non-bracketed whitespaces, expands them</span>
<a name="l01446"></a>01446   <span class="comment">// and puts them into a list.</span>
<a name="l01447"></a>01447 
<a name="l01448"></a>01448   <span class="keywordtype">unsigned</span> i=0;
<a name="l01449"></a>01449   <span class="comment">// (1) eat initial whitespaces</span>
<a name="l01450"></a>01450   <span class="keywordflow">for</span>(; i &lt; str.size(); i++)
<a name="l01451"></a>01451     <span class="keywordflow">if</span>( ! isspace(str[i]) ) <span class="keywordflow">break</span>;
<a name="l01452"></a>01452 
<a name="l01453"></a>01453   std::vector&lt;std::string&gt;   expr_list;
<a name="l01454"></a>01454   <span class="keywordtype">unsigned</span>         open_brackets = 0;
<a name="l01455"></a>01455   std::vector&lt;unsigned&gt; start_idx;
<a name="l01456"></a>01456   <span class="keywordtype">unsigned</span>         start_new_string = i;
<a name="l01457"></a>01457   <span class="keywordtype">unsigned</span>         l = str.size();
<a name="l01458"></a>01458 
<a name="l01459"></a>01459   <span class="comment">// (2) search for ${ } expressions ...</span>
<a name="l01460"></a>01460   <span class="keywordflow">while</span>( i &lt; l ) {
<a name="l01461"></a>01461     <span class="keyword">const</span> <span class="keywordtype">char</span> letter = str[i];
<a name="l01462"></a>01462     <span class="comment">// whitespace -&gt; end of expression</span>
<a name="l01463"></a>01463     <span class="keywordflow">if</span>( isspace(letter) &amp;&amp; open_brackets == 0) {
<a name="l01464"></a>01464       expr_list.push_back(str.substr(start_new_string, i - start_new_string));
<a name="l01465"></a>01465       <span class="keywordtype">bool</span> no_breakout_f = <span class="keyword">true</span>;
<a name="l01466"></a>01466       <span class="keywordflow">for</span>(i++; i &lt; l ; i++) {
<a name="l01467"></a>01467         <span class="keywordflow">if</span>( ! isspace(str[i]) ) 
<a name="l01468"></a>01468         { no_breakout_f = <span class="keyword">false</span>; start_new_string = i; <span class="keywordflow">break</span>; }
<a name="l01469"></a>01469       }
<a name="l01470"></a>01470       <span class="keywordflow">if</span>( no_breakout_f ) {
<a name="l01471"></a>01471         <span class="comment">// end of expression list</span>
<a name="l01472"></a>01472         <span class="keywordflow">if</span>( expr_list.size() &lt; ExpectedNumber ) {
<a name="l01473"></a>01473           <span class="keyword">const</span> std::string   pre_tmp(<span class="stringliteral">&quot;&lt;&lt; ${ }: missing arguments&gt;&gt;&quot;</span>);
<a name="l01474"></a>01474           std::vector&lt;std::string&gt; tmp(ExpectedNumber - expr_list.size(), pre_tmp); 
<a name="l01475"></a>01475           expr_list.insert(expr_list.end(), tmp.begin(), tmp.end());
<a name="l01476"></a>01476         }
<a name="l01477"></a>01477         <span class="keywordflow">return</span> expr_list;
<a name="l01478"></a>01478       }
<a name="l01479"></a>01479     }
<a name="l01480"></a>01480 
<a name="l01481"></a>01481     <span class="comment">// dollar-bracket expression</span>
<a name="l01482"></a>01482     <span class="keywordflow">if</span>( str.length() &gt;= i+2 &amp;&amp; str.substr(i, 2) == <span class="stringliteral">&quot;${&quot;</span> ) {
<a name="l01483"></a>01483       open_brackets++;
<a name="l01484"></a>01484       start_idx.push_back(i+2);
<a name="l01485"></a>01485     }
<a name="l01486"></a>01486     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( letter == <span class="charliteral">&#39;}&#39;</span> &amp;&amp; open_brackets &gt; 0) {
<a name="l01487"></a>01487       <span class="keywordtype">unsigned</span> start = start_idx[start_idx.size()-1];
<a name="l01488"></a>01488       start_idx.pop_back();
<a name="l01489"></a>01489       <span class="keyword">const</span> std::string Replacement = <a class="code" href="classGetPot.php#a5d561f41337478dfd74cb1603ff57a6c">__DBE_expand</a>(str.substr(start, i-start));
<a name="l01490"></a>01490       <span class="keywordflow">if</span>( start  &lt; 3)
<a name="l01491"></a>01491         str = Replacement + str.substr(i+1);
<a name="l01492"></a>01492       <span class="keywordflow">else</span>
<a name="l01493"></a>01493         str = str.substr(0, start-2) + Replacement + str.substr(i+1);
<a name="l01494"></a>01494       l = str.size();              
<a name="l01495"></a>01495       i = start + Replacement.size() - 3;
<a name="l01496"></a>01496       open_brackets--;
<a name="l01497"></a>01497     }
<a name="l01498"></a>01498     i++;
<a name="l01499"></a>01499   }
<a name="l01500"></a>01500 
<a name="l01501"></a>01501   <span class="comment">// end of expression list</span>
<a name="l01502"></a>01502   expr_list.push_back(str.substr(start_new_string, i-start_new_string));
<a name="l01503"></a>01503 
<a name="l01504"></a>01504   <span class="keywordflow">if</span>( expr_list.size() &lt; ExpectedNumber ) {
<a name="l01505"></a>01505     <span class="keyword">const</span> std::string   pre_tmp(<span class="stringliteral">&quot;&lt;&lt; ${ }: missing arguments&gt;&gt;&quot;</span>);
<a name="l01506"></a>01506     std::vector&lt;std::string&gt; tmp(ExpectedNumber - expr_list.size(), pre_tmp); 
<a name="l01507"></a>01507     expr_list.insert(expr_list.end(), tmp.begin(), tmp.end());
<a name="l01508"></a>01508   }
<a name="l01509"></a>01509 
<a name="l01510"></a>01510   <span class="keywordflow">return</span> expr_list;
<a name="l01511"></a>01511 }
<a name="l01512"></a>01512 
<a name="l01513"></a>01513 
<a name="l01514"></a>01514 
<a name="l01515"></a>01515 <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>*
<a name="l01516"></a><a class="code" href="classGetPot.php#aac4f507f1b7aeb37d2e1b46dbcc17461">01516</a> <a class="code" href="classGetPot.php#aac4f507f1b7aeb37d2e1b46dbcc17461">GetPot::__DBE_get_variable</a>(<span class="keyword">const</span> std::string&amp; VarName)
<a name="l01517"></a>01517 {
<a name="l01518"></a>01518   <span class="keyword">static</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a> ev;
<a name="l01519"></a>01519   std::string secure_Prefix = <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>;
<a name="l01520"></a>01520 
<a name="l01521"></a>01521   <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> = <a class="code" href="classGetPot.php#a26b296f58b478c481d4a6a9edf559d1c">section</a>;
<a name="l01522"></a>01522   <span class="comment">// (1) first search in currently active section</span>
<a name="l01523"></a>01523   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>* var = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName.c_str());
<a name="l01524"></a>01524   <span class="keywordflow">if</span>( var != 0 ) { <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> = secure_Prefix; <span class="keywordflow">return</span> var; }
<a name="l01525"></a>01525 
<a name="l01526"></a>01526   <span class="comment">// (2) search in root name space</span>
<a name="l01527"></a>01527   <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> = <span class="stringliteral">&quot;&quot;</span>;
<a name="l01528"></a>01528   var = <a class="code" href="classGetPot.php#a75a97835d9fcb69c767efdb7b2c0a668">__find_variable</a>(VarName.c_str());
<a name="l01529"></a>01529   <span class="keywordflow">if</span>( var != 0 ) { <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> = secure_Prefix; <span class="keywordflow">return</span> var; }
<a name="l01530"></a>01530 
<a name="l01531"></a>01531   <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a> = secure_Prefix;
<a name="l01532"></a>01532 
<a name="l01533"></a>01533   <span class="comment">// error occured =&gt; variable name == &quot;&quot;</span>
<a name="l01534"></a>01534   <span class="keywordtype">char</span>* tmp = <span class="keyword">new</span> <span class="keywordtype">char</span>[VarName.length() + 25];
<a name="l01535"></a>01535   std::sprintf(tmp, <span class="stringliteral">&quot;&lt;&lt;${ } variable &#39;%s&#39; undefined&gt;&gt;&quot;</span>, VarName.c_str());
<a name="l01536"></a>01536   ev.<a class="code" href="structGetPot_1_1variable.php#aafb48af9c71fbcd816917ee7ec25bed0">name</a> = <span class="stringliteral">&quot;&quot;</span>;
<a name="l01537"></a>01537   ev.<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a> = std::string(tmp);
<a name="l01538"></a>01538   <span class="keyword">delete</span> [] tmp;
<a name="l01539"></a>01539   <span class="keywordflow">return</span> &amp;ev;
<a name="l01540"></a>01540 }
<a name="l01541"></a>01541 
<a name="l01542"></a>01542   <span class="keyword">inline</span> std::string 
<a name="l01543"></a><a class="code" href="classGetPot.php#a5d561f41337478dfd74cb1603ff57a6c">01543</a> <a class="code" href="classGetPot.php#a5d561f41337478dfd74cb1603ff57a6c">GetPot::__DBE_expand</a>(<span class="keyword">const</span> std::string&amp; expr)
<a name="l01544"></a>01544 {
<a name="l01545"></a>01545   <span class="comment">// ${: } pure text</span>
<a name="l01546"></a>01546   <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;:&#39;</span> )
<a name="l01547"></a>01547     <span class="keywordflow">return</span> expr.substr(1);
<a name="l01548"></a>01548 
<a name="l01549"></a>01549   <span class="comment">// ${&amp; expr expr ... } text concatination</span>
<a name="l01550"></a>01550   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;&amp;&#39;</span> ) {
<a name="l01551"></a>01551     <span class="keyword">const</span> std::vector&lt;std::string&gt; A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(1), 1);
<a name="l01552"></a>01552 
<a name="l01553"></a>01553     std::vector&lt;std::string&gt;::const_iterator it = A.begin();
<a name="l01554"></a>01554     std::string result = *it++;
<a name="l01555"></a>01555     <span class="keywordflow">for</span>(; it != A.end(); it++) result += *it;
<a name="l01556"></a>01556 
<a name="l01557"></a>01557     <span class="keywordflow">return</span> result;
<a name="l01558"></a>01558   }
<a name="l01559"></a>01559 
<a name="l01560"></a>01560   <span class="comment">// ${&lt;-&gt; expr expr expr} text replacement</span>
<a name="l01561"></a>01561   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr.length() &gt;= 3 &amp;&amp; expr.substr(0, 3) == <span class="stringliteral">&quot;&lt;-&gt;&quot;</span> ) {
<a name="l01562"></a>01562     std::vector&lt;std::string&gt; A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(3), 3);
<a name="l01563"></a>01563     std::string::size_type tmp = 0;
<a name="l01564"></a>01564     <span class="keyword">const</span> std::string::size_type L = A[1].length();
<a name="l01565"></a>01565     <span class="keywordflow">while</span>( (tmp = A[0].find(A[1])) != std::string::npos ) {
<a name="l01566"></a>01566       A[0].replace(tmp, L, A[2]);
<a name="l01567"></a>01567     }
<a name="l01568"></a>01568     <span class="keywordflow">return</span> A[0];
<a name="l01569"></a>01569   }
<a name="l01570"></a>01570   <span class="comment">// ${+ ...}, ${- ...}, ${* ...}, ${/ ...} expressions</span>
<a name="l01571"></a>01571   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;+&#39;</span> ) {
<a name="l01572"></a>01572     std::vector&lt;std::string&gt; A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(1), 2);
<a name="l01573"></a>01573     std::vector&lt;std::string&gt;::const_iterator it = A.begin();
<a name="l01574"></a>01574     <span class="keywordtype">double</span> result = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it++, 0.0);
<a name="l01575"></a>01575     <span class="keywordflow">for</span>(; it != A.end(); it++)
<a name="l01576"></a>01576       result += <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it, 0.0);
<a name="l01577"></a>01577 
<a name="l01578"></a>01578     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a366697457a53916e1f4512b2a2b531b5">__double2string</a>(result);
<a name="l01579"></a>01579   }
<a name="l01580"></a>01580   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;-&#39;</span> ) {
<a name="l01581"></a>01581     std::vector&lt;std::string&gt; A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(1), 2);
<a name="l01582"></a>01582     std::vector&lt;std::string&gt;::const_iterator it = A.begin();
<a name="l01583"></a>01583     <span class="keywordtype">double</span> result = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it++, 0.0);
<a name="l01584"></a>01584     <span class="keywordflow">for</span>(; it != A.end(); it++)
<a name="l01585"></a>01585       result -= <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it, 0.0);
<a name="l01586"></a>01586 
<a name="l01587"></a>01587     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a366697457a53916e1f4512b2a2b531b5">__double2string</a>(result);
<a name="l01588"></a>01588   }
<a name="l01589"></a>01589   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;*&#39;</span> ) {
<a name="l01590"></a>01590     std::vector&lt;std::string&gt; A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(1), 2);
<a name="l01591"></a>01591     std::vector&lt;std::string&gt;::const_iterator it = A.begin();
<a name="l01592"></a>01592     <span class="keywordtype">double</span> result = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it++, 0.0);
<a name="l01593"></a>01593     <span class="keywordflow">for</span>(; it != A.end(); it++)
<a name="l01594"></a>01594       result *= <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it, 0.0);
<a name="l01595"></a>01595 
<a name="l01596"></a>01596     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a366697457a53916e1f4512b2a2b531b5">__double2string</a>(result);
<a name="l01597"></a>01597   }
<a name="l01598"></a>01598   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;/&#39;</span> ) {
<a name="l01599"></a>01599     std::vector&lt;std::string&gt; A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(1), 2);
<a name="l01600"></a>01600     std::vector&lt;std::string&gt;::const_iterator it = A.begin();
<a name="l01601"></a>01601     <span class="keywordtype">double</span> result = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it++, 0.0);
<a name="l01602"></a>01602     <span class="keywordflow">if</span>( result == 0 ) <span class="keywordflow">return</span> <span class="stringliteral">&quot;0.0&quot;</span>;
<a name="l01603"></a>01603     <span class="keywordflow">for</span>(; it != A.end(); it++) {
<a name="l01604"></a>01604       <span class="keyword">const</span> <span class="keywordtype">double</span> Q = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it, 0.0);
<a name="l01605"></a>01605       <span class="keywordflow">if</span>( Q == 0.0 ) <span class="keywordflow">return</span> <span class="stringliteral">&quot;0.0&quot;</span>;          
<a name="l01606"></a>01606       result /= Q;
<a name="l01607"></a>01607     }
<a name="l01608"></a>01608     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a366697457a53916e1f4512b2a2b531b5">__double2string</a>(result);
<a name="l01609"></a>01609   }
<a name="l01610"></a>01610 
<a name="l01611"></a>01611   <span class="comment">// ${^ ... } power expressions</span>
<a name="l01612"></a>01612   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;^&#39;</span> ) {
<a name="l01613"></a>01613     std::vector&lt;std::string&gt; A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(1), 2);
<a name="l01614"></a>01614     std::vector&lt;std::string&gt;::const_iterator it = A.begin();
<a name="l01615"></a>01615     <span class="keywordtype">double</span> result = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it++, 0.0);
<a name="l01616"></a>01616     <span class="keywordflow">for</span>(; it != A.end(); it++)
<a name="l01617"></a>01617       result = <a class="code" href="namespaceUtility.php#aa31a2ff44b735ae86eea0446796a3b42">pow</a>(result, <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*it, 0.0));
<a name="l01618"></a>01618     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a366697457a53916e1f4512b2a2b531b5">__double2string</a>(result);
<a name="l01619"></a>01619   }
<a name="l01620"></a>01620 
<a name="l01621"></a>01621   <span class="comment">// ${==  } ${&lt;=  } ${&gt;= } comparisons (return the number of the first &#39;match&#39;</span>
<a name="l01622"></a>01622   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr.length() &gt;= 2 &amp;&amp; 
<a name="l01623"></a>01623       ( expr.substr(0,2) == <span class="stringliteral">&quot;==&quot;</span> || expr.substr(0,2) == <span class="stringliteral">&quot;&gt;=&quot;</span> || 
<a name="l01624"></a>01624         expr.substr(0,2) == <span class="stringliteral">&quot;&lt;=&quot;</span> || expr[0] == <span class="charliteral">&#39;&gt;&#39;</span>           || expr[0] == <span class="charliteral">&#39;&lt;&#39;</span>)) {
<a name="l01625"></a>01625     <span class="comment">// differentiate between two and one sign operators</span>
<a name="l01626"></a>01626     <span class="keywordtype">unsigned</span> op = 0;
<a name="l01627"></a>01627     <span class="keyword">enum</span> { EQ, GEQ, LEQ, GT, LT };
<a name="l01628"></a>01628     <span class="keywordflow">if</span>      ( expr.substr(0, 2) == <span class="stringliteral">&quot;==&quot;</span> ) op = EQ;
<a name="l01629"></a>01629     <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( expr.substr(0, 2) == <span class="stringliteral">&quot;&gt;=&quot;</span> ) op = GEQ;
<a name="l01630"></a>01630     <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( expr.substr(0, 2) == <span class="stringliteral">&quot;&lt;=&quot;</span> ) op = LEQ;
<a name="l01631"></a>01631     <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( expr[0] == <span class="charliteral">&#39;&gt;&#39;</span> )            op = GT;
<a name="l01632"></a>01632     <span class="keywordflow">else</span>    <span class="comment">/*                     &quot;&lt;&quot; */</span> op = LT;
<a name="l01633"></a>01633 
<a name="l01634"></a>01634     std::vector&lt;std::string&gt; a;
<a name="l01635"></a>01635     <span class="keywordflow">if</span> ( op == GT || op == LT ) a = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(1), 2);
<a name="l01636"></a>01636     <span class="keywordflow">else</span>                        a = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(2), 2);
<a name="l01637"></a>01637 
<a name="l01638"></a>01638     std::string   x_orig = a[0];          
<a name="l01639"></a>01639     <span class="keywordtype">double</span>   x = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(x_orig, 1e37);
<a name="l01640"></a>01640     <span class="keywordtype">unsigned</span> i = 1;
<a name="l01641"></a>01641 
<a name="l01642"></a>01642     std::vector&lt;std::string&gt;::const_iterator y_orig = a.begin();
<a name="l01643"></a>01643     <span class="keywordflow">for</span>(y_orig++; y_orig != a.end(); y_orig++) { 
<a name="l01644"></a>01644       <span class="keywordtype">double</span> y = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(*y_orig, 1e37);
<a name="l01645"></a>01645 
<a name="l01646"></a>01646       <span class="comment">// set the strings as reference if one wasn&#39;t a number</span>
<a name="l01647"></a>01647       <span class="keywordflow">if</span> ( x == 1e37 || y == 1e37 ) {
<a name="l01648"></a>01648         <span class="comment">// it&#39;s a string comparison</span>
<a name="l01649"></a>01649         <span class="keywordflow">if</span>( (op == EQ  &amp;&amp; x_orig == *y_orig) || (op == GEQ &amp;&amp; x_orig &gt;= *y_orig) ||
<a name="l01650"></a>01650             (op == LEQ &amp;&amp; x_orig &lt;= *y_orig) || (op == GT  &amp;&amp; x_orig &gt;  *y_orig) ||
<a name="l01651"></a>01651             (op == LT  &amp;&amp; x_orig &lt;  *y_orig) )
<a name="l01652"></a>01652           <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a97c11f31da01463d52aa007a9f0ce1bc">__int2string</a>(i);
<a name="l01653"></a>01653       }
<a name="l01654"></a>01654       <span class="keywordflow">else</span> {
<a name="l01655"></a>01655         <span class="comment">// it&#39;s a number comparison</span>
<a name="l01656"></a>01656         <span class="keywordflow">if</span>( (op == EQ  &amp;&amp; x == y) || (op == GEQ &amp;&amp; x &gt;= y) ||
<a name="l01657"></a>01657             (op == LEQ &amp;&amp; x &lt;= y) || (op == GT  &amp;&amp; x &gt;  y) || 
<a name="l01658"></a>01658             (op == LT  &amp;&amp; x &lt;  y) )
<a name="l01659"></a>01659           <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a97c11f31da01463d52aa007a9f0ce1bc">__int2string</a>(i);
<a name="l01660"></a>01660       }
<a name="l01661"></a>01661       i++;
<a name="l01662"></a>01662     }
<a name="l01663"></a>01663 
<a name="l01664"></a>01664     <span class="comment">// nothing fulfills the condition =&gt; return 0</span>
<a name="l01665"></a>01665     <span class="keywordflow">return</span> <span class="stringliteral">&quot;0&quot;</span>;
<a name="l01666"></a>01666   }
<a name="l01667"></a>01667   <span class="comment">// ${?? expr expr} select </span>
<a name="l01668"></a>01668   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr.length() &gt;= 2 &amp;&amp; expr.substr(0, 2) == <span class="stringliteral">&quot;??&quot;</span> ) {
<a name="l01669"></a>01669     std::vector&lt;std::string&gt; a = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(2), 2);
<a name="l01670"></a>01670     <span class="keywordtype">double</span> x = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(a[0], 1e37);
<a name="l01671"></a>01671     <span class="comment">// last element is always the default argument</span>
<a name="l01672"></a>01672     <span class="keywordflow">if</span>( x == 1e37 || x &lt; 0 || x &gt;= a.size() - 1 ) <span class="keywordflow">return</span> a[a.size()-1];
<a name="l01673"></a>01673 
<a name="l01674"></a>01674     <span class="comment">// round x to closest integer</span>
<a name="l01675"></a>01675     <span class="keywordflow">return</span> a[int(x+0.5)];
<a name="l01676"></a>01676   }
<a name="l01677"></a>01677   <span class="comment">// ${? expr expr expr} if then else conditions</span>
<a name="l01678"></a>01678   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;?&#39;</span> ) {
<a name="l01679"></a>01679     std::vector&lt;std::string&gt; a = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(1), 2);
<a name="l01680"></a>01680     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(a[0], 0.0) == 1.0 ) <span class="keywordflow">return</span> a[1];
<a name="l01681"></a>01681     <span class="keywordflow">else</span> <span class="keywordflow">if</span>( a.size() &gt; 2 )     <span class="keywordflow">return</span> a[2];
<a name="l01682"></a>01682   }
<a name="l01683"></a>01683   <span class="comment">// ${! expr} maxro expansion </span>
<a name="l01684"></a>01684   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;!&#39;</span> ) {
<a name="l01685"></a>01685     <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>* Var = <a class="code" href="classGetPot.php#aac4f507f1b7aeb37d2e1b46dbcc17461">__DBE_get_variable</a>(expr.substr(1));
<a name="l01686"></a>01686     <span class="comment">// error</span>
<a name="l01687"></a>01687     <span class="keywordflow">if</span>( Var-&gt;<a class="code" href="structGetPot_1_1variable.php#aafb48af9c71fbcd816917ee7ec25bed0">name</a> == <span class="stringliteral">&quot;&quot;</span> ) <span class="keywordflow">return</span> std::string(Var-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>);
<a name="l01688"></a>01688 
<a name="l01689"></a>01689     <span class="keyword">const</span> std::vector&lt;std::string&gt; A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(Var-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>, 2);
<a name="l01690"></a>01690     <span class="keywordflow">return</span> A[0];
<a name="l01691"></a>01691   }
<a name="l01692"></a>01692   <span class="comment">// ${@: } - string subscription</span>
<a name="l01693"></a>01693   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr.length() &gt;= 2 &amp;&amp; expr.substr(0,2) == <span class="stringliteral">&quot;@:&quot;</span> ) {
<a name="l01694"></a>01694     <span class="keyword">const</span> std::vector&lt;std::string&gt; A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(2), 2);
<a name="l01695"></a>01695     <span class="keywordtype">double</span> x = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(A[1], 1e37);
<a name="l01696"></a>01696 
<a name="l01697"></a>01697     <span class="comment">// last element is always the default argument</span>
<a name="l01698"></a>01698     <span class="keywordflow">if</span>( x == 1e37 || x &lt; 0 || x &gt;= A[0].<a class="code" href="classGetPot.php#a2d932ac1adaa8c96cd7d6a9379bee729">size</a>() - 1)
<a name="l01699"></a>01699       <span class="keywordflow">return</span> <span class="stringliteral">&quot;&lt;&lt;1st index out of range&gt;&gt;&quot;</span>;
<a name="l01700"></a>01700 
<a name="l01701"></a>01701     <span class="keywordflow">if</span>( A.size() &gt; 2 ) {
<a name="l01702"></a>01702       <span class="keywordtype">double</span> y = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(A[2], 1e37);
<a name="l01703"></a>01703       <span class="keywordflow">if</span> ( y != 1e37 &amp;&amp; y &gt; 0 &amp;&amp; y &lt;= A[0].<a class="code" href="classGetPot.php#a2d932ac1adaa8c96cd7d6a9379bee729">size</a>() - 1 &amp;&amp; y &gt; x )
<a name="l01704"></a>01704         <span class="keywordflow">return</span> A[0].substr(<span class="keywordtype">int</span>(x+0.5), <span class="keywordtype">int</span>(y+1.5) - <span class="keywordtype">int</span>(x+0.5));
<a name="l01705"></a>01705       <span class="keywordflow">else</span> <span class="keywordflow">if</span>( y == -1 )
<a name="l01706"></a>01706         <span class="keywordflow">return</span> A[0].substr(<span class="keywordtype">int</span>(x+0.5));
<a name="l01707"></a>01707       <span class="keywordflow">return</span> <span class="stringliteral">&quot;&lt;&lt;2nd index out of range&gt;&gt;&quot;</span>;
<a name="l01708"></a>01708     }
<a name="l01709"></a>01709     <span class="keywordflow">else</span> {
<a name="l01710"></a>01710       <span class="keywordtype">char</span>* tmp = <span class="keyword">new</span> <span class="keywordtype">char</span>[2];
<a name="l01711"></a>01711       tmp[0] = A[0][int(x+0.5)]; tmp[1] = <span class="charliteral">&#39;\0&#39;</span>;
<a name="l01712"></a>01712       std::string result(tmp);
<a name="l01713"></a>01713       <span class="keyword">delete</span> [] tmp;
<a name="l01714"></a>01714       <span class="keywordflow">return</span> result;
<a name="l01715"></a>01715     }
<a name="l01716"></a>01716   }
<a name="l01717"></a>01717   <span class="comment">// ${@ } - vector subscription</span>
<a name="l01718"></a>01718   <span class="keywordflow">else</span> <span class="keywordflow">if</span>( expr[0] == <span class="charliteral">&#39;@&#39;</span> ) {
<a name="l01719"></a>01719     std::vector&lt;std::string&gt;          A   = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr.substr(1), 2);
<a name="l01720"></a>01720     <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>* Var = <a class="code" href="classGetPot.php#aac4f507f1b7aeb37d2e1b46dbcc17461">__DBE_get_variable</a>(A[0]);
<a name="l01721"></a>01721     <span class="comment">// error</span>
<a name="l01722"></a>01722     <span class="keywordflow">if</span>( Var-&gt;name == <span class="stringliteral">&quot;&quot;</span> ) {    
<a name="l01723"></a>01723       <span class="comment">// make a copy of the string if an error occured</span>
<a name="l01724"></a>01724       <span class="comment">// (since the error variable is a static variable inside get_variable())</span>
<a name="l01725"></a>01725       <span class="keywordflow">return</span> std::string(Var-&gt;original);
<a name="l01726"></a>01726     }
<a name="l01727"></a>01727 
<a name="l01728"></a>01728     <span class="keywordtype">double</span> x = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(A[1], 1e37);
<a name="l01729"></a>01729 
<a name="l01730"></a>01730     <span class="comment">// last element is always the default argument</span>
<a name="l01731"></a>01731     <span class="keywordflow">if</span> (x == 1e37 || x &lt; 0 || x &gt;= Var-&gt;value.size() )
<a name="l01732"></a>01732       <span class="keywordflow">return</span> <span class="stringliteral">&quot;&lt;&lt;1st index out of range&gt;&gt;&quot;</span>;
<a name="l01733"></a>01733 
<a name="l01734"></a>01734     <span class="keywordflow">if</span> ( A.size() &gt; 2) {
<a name="l01735"></a>01735       <span class="keywordtype">double</span> y = <a class="code" href="classGetPot.php#a4f24a1e7a8430e9bbb2dbe9727c78df8">__convert_to_type</a>(A[2], 1e37);
<a name="l01736"></a>01736       <span class="keywordtype">int</span>    begin = int(x+0.5);
<a name="l01737"></a>01737       <span class="keywordtype">int</span>    end = 0;
<a name="l01738"></a>01738       <span class="keywordflow">if</span> ( y != 1e37 &amp;&amp; y &gt; 0 &amp;&amp; y &lt;= Var-&gt;value.size() &amp;&amp; y &gt; x)
<a name="l01739"></a>01739         end = <span class="keywordtype">int</span>(y+1.5);
<a name="l01740"></a>01740       <span class="keywordflow">else</span> <span class="keywordflow">if</span>( y == -1 )
<a name="l01741"></a>01741         end = Var-&gt;value.size();
<a name="l01742"></a>01742       <span class="keywordflow">else</span>
<a name="l01743"></a>01743         <span class="keywordflow">return</span> <span class="stringliteral">&quot;&lt;&lt;2nd index out of range&gt;&gt;&quot;</span>;                
<a name="l01744"></a>01744 
<a name="l01745"></a>01745       std::string result = *(Var-&gt;get_element(begin));
<a name="l01746"></a>01746       <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = begin+1; i &lt; end; i++) 
<a name="l01747"></a>01747         result += std::string(<span class="stringliteral">&quot; &quot;</span>) + *(Var-&gt;get_element(i));
<a name="l01748"></a>01748       <span class="keywordflow">return</span> result;
<a name="l01749"></a>01749     }
<a name="l01750"></a>01750     <span class="keywordflow">else</span>
<a name="l01751"></a>01751       <span class="keywordflow">return</span> *(Var-&gt;get_element(<span class="keywordtype">int</span>(x+0.5)));
<a name="l01752"></a>01752   }
<a name="l01753"></a>01753 
<a name="l01754"></a>01754   <span class="keyword">const</span> std::vector&lt;std::string&gt;    A = <a class="code" href="classGetPot.php#ab2bd9b93c66cf669b2cba26495187a78">__DBE_get_expr_list</a>(expr, 1);
<a name="l01755"></a>01755   <span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>* B = <a class="code" href="classGetPot.php#aac4f507f1b7aeb37d2e1b46dbcc17461">__DBE_get_variable</a>(A[0]);
<a name="l01756"></a>01756 
<a name="l01757"></a>01757   <span class="comment">// make a copy of the string if an error occured</span>
<a name="l01758"></a>01758   <span class="comment">// (since the error variable is a static variable inside get_variable())</span>
<a name="l01759"></a>01759   <span class="keywordflow">if</span>( B-&gt;<a class="code" href="structGetPot_1_1variable.php#aafb48af9c71fbcd816917ee7ec25bed0">name</a> == <span class="stringliteral">&quot;&quot;</span> )
<a name="l01760"></a>01760     <span class="keywordflow">return</span> std::string(B-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>);
<a name="l01761"></a>01761   
<a name="l01762"></a>01762   <span class="comment">//else</span>
<a name="l01763"></a>01763 
<a name="l01764"></a>01764   <span class="keywordflow">return</span> B-&gt;<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>;
<a name="l01765"></a>01765 }
<a name="l01766"></a>01766 
<a name="l01767"></a>01767 
<a name="l01768"></a>01768 
<a name="l01770"></a>01770 <span class="comment">// (*) unidentified flying objects</span>
<a name="l01771"></a>01771 <span class="comment">//.............................................................................</span>
<a name="l01772"></a>01772 <span class="comment">//</span>
<a name="l01773"></a>01773 <span class="keyword">inline</span> <span class="keywordtype">bool</span>
<a name="l01774"></a><a class="code" href="classGetPot.php#acbcfcc3a4ac55ecedb94eaefe7685821">01774</a> <a class="code" href="classGetPot.php#acbcfcc3a4ac55ecedb94eaefe7685821">GetPot::__search_string_vector</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; VecStr, <span class="keyword">const</span> std::string&amp; Str)<span class="keyword"> const</span>
<a name="l01775"></a>01775 <span class="keyword"></span>{
<a name="l01776"></a>01776   victorate(std::string, VecStr, itk) {
<a name="l01777"></a>01777     <span class="keywordflow">if</span>( *itk == Str ) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01778"></a>01778   }
<a name="l01779"></a>01779   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01780"></a>01780 }
<a name="l01781"></a>01781 
<a name="l01782"></a>01782 <span class="preprocessor">#ifdef GETPOT_ALLOW_VARGS</span>
<a name="l01783"></a>01783 <span class="preprocessor"></span>  <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l01784"></a><a class="code" href="classGetPot.php#a7e90d56c93dd460b84142b0b48373797">01784</a>   <a class="code" href="classGetPot.php#a1d5444f8f57c23d1568de392aaaf2016">GetPot::unidentified_arguments</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, 
<a name="l01785"></a>01785       <span class="keyword">const</span> <span class="keywordtype">char</span>* KnownArgument1, ...)<span class="keyword"> const</span>
<a name="l01786"></a>01786 <span class="keyword">  </span>{
<a name="l01787"></a>01787     std::vector&lt;std::string&gt; known_arguments;
<a name="l01788"></a>01788   
<a name="l01789"></a>01789     <span class="comment">// (1) create a vector of known arguments</span>
<a name="l01790"></a>01790     <span class="keywordflow">if</span>( Number == 0 ) <span class="keywordflow">return</span> std::vector&lt;std::string&gt;();
<a name="l01791"></a>01791   
<a name="l01792"></a>01792     std::va_list ap;
<a name="l01793"></a>01793     va_start(ap, KnownArgument1);
<a name="l01794"></a>01794     known_arguments.push_back(std::string(KnownArgument1));
<a name="l01795"></a>01795     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>; i++)
<a name="l01796"></a>01796       known_arguments.push_back(std::string(va_arg(ap, <span class="keywordtype">char</span> *)));
<a name="l01797"></a>01797     va_end(ap);
<a name="l01798"></a>01798   
<a name="l01799"></a>01799     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a1d5444f8f57c23d1568de392aaaf2016">unidentified_arguments</a>(known_arguments);
<a name="l01800"></a>01800   }
<a name="l01801"></a>01801   
<a name="l01802"></a>01802   
<a name="l01803"></a>01803   <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l01804"></a><a class="code" href="classGetPot.php#a19b0ecb606c45065ef210b706d5c79a0">01804</a>   <a class="code" href="classGetPot.php#ade9b7d19d72cab14d3af460906c56667">GetPot::unidentified_options</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, 
<a name="l01805"></a>01805       <span class="keyword">const</span> <span class="keywordtype">char</span>* KnownOption1, ...)<span class="keyword"> const</span>
<a name="l01806"></a>01806 <span class="keyword">  </span>{
<a name="l01807"></a>01807     std::vector&lt;std::string&gt; known_options;
<a name="l01808"></a>01808   
<a name="l01809"></a>01809     <span class="comment">// (1) create a vector of known arguments</span>
<a name="l01810"></a>01810     <span class="keywordflow">if</span>( Number == 0 ) <span class="keywordflow">return</span> std::vector&lt;std::string&gt;();
<a name="l01811"></a>01811   
<a name="l01812"></a>01812     std::va_list ap;
<a name="l01813"></a>01813     va_start(ap, KnownOption1);
<a name="l01814"></a>01814     known_options.push_back(std::string(KnownOption1));
<a name="l01815"></a>01815     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>; i++)
<a name="l01816"></a>01816       known_options.push_back(std::string(va_arg(ap, <span class="keywordtype">char</span> *)));
<a name="l01817"></a>01817     va_end(ap);
<a name="l01818"></a>01818   
<a name="l01819"></a>01819     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ade9b7d19d72cab14d3af460906c56667">unidentified_options</a>(known_options);
<a name="l01820"></a>01820   }
<a name="l01821"></a>01821   
<a name="l01822"></a>01822   <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l01823"></a><a class="code" href="classGetPot.php#a2a03156c9984fee5b2d6e353ddfb6698">01823</a>   <a class="code" href="classGetPot.php#a376abbc67b3560db36f7393817cad391">GetPot::unidentified_variables</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, 
<a name="l01824"></a>01824     <span class="keyword">const</span> <span class="keywordtype">char</span>* KnownVariable1, ...)<span class="keyword"> const</span>
<a name="l01825"></a>01825 <span class="keyword">  </span>{
<a name="l01826"></a>01826     std::vector&lt;std::string&gt; known_variables;
<a name="l01827"></a>01827   
<a name="l01828"></a>01828     <span class="comment">// create vector of known arguments</span>
<a name="l01829"></a>01829     <span class="keywordflow">if</span>( Number == 0 ) <span class="keywordflow">return</span> std::vector&lt;std::string&gt;();
<a name="l01830"></a>01830   
<a name="l01831"></a>01831     std::va_list ap;
<a name="l01832"></a>01832     va_start(ap, KnownVariable1);
<a name="l01833"></a>01833     known_variables.push_back(std::string(KnownVariable1));
<a name="l01834"></a>01834     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>; i++)
<a name="l01835"></a>01835       known_variables.push_back(std::string(va_arg(ap, <span class="keywordtype">char</span> *)));
<a name="l01836"></a>01836     va_end(ap);
<a name="l01837"></a>01837   
<a name="l01838"></a>01838     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a376abbc67b3560db36f7393817cad391">unidentified_variables</a>(known_variables);
<a name="l01839"></a>01839   }
<a name="l01840"></a>01840   
<a name="l01841"></a>01841   <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l01842"></a><a class="code" href="classGetPot.php#abe65b825ade23fac5b3282f8bf553703">01842</a>   <a class="code" href="classGetPot.php#a3d56e136650aa9efb5a72ad4cbe400fb">GetPot::unidentified_sections</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, 
<a name="l01843"></a>01843       <span class="keyword">const</span> <span class="keywordtype">char</span>* KnownSection1, ...)<span class="keyword"> const</span>
<a name="l01844"></a>01844 <span class="keyword">  </span>{
<a name="l01845"></a>01845     std::vector&lt;std::string&gt; known_sections;
<a name="l01846"></a>01846   
<a name="l01847"></a>01847     <span class="comment">// (1) create a vector of known arguments</span>
<a name="l01848"></a>01848     <span class="keywordflow">if</span>( Number == 0 ) <span class="keywordflow">return</span> std::vector&lt;std::string&gt;();
<a name="l01849"></a>01849   
<a name="l01850"></a>01850     std::va_list ap;
<a name="l01851"></a>01851     va_start(ap, KnownSection1);
<a name="l01852"></a>01852     known_sections.push_back(std::string(KnownSection1));
<a name="l01853"></a>01853     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>; i++) {
<a name="l01854"></a>01854       std::string tmp = std::string(va_arg(ap, <span class="keywordtype">char</span> *));
<a name="l01855"></a>01855       <span class="keywordflow">if</span>( tmp.length() == 0 ) <span class="keywordflow">continue</span>;
<a name="l01856"></a>01856       <span class="keywordflow">if</span>( tmp[tmp.length()-1] != <span class="charliteral">&#39;/&#39;</span> ) tmp += <span class="charliteral">&#39;/&#39;</span>;
<a name="l01857"></a>01857       known_sections.push_back(tmp);
<a name="l01858"></a>01858     }
<a name="l01859"></a>01859     va_end(ap);
<a name="l01860"></a>01860   
<a name="l01861"></a>01861     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#a3d56e136650aa9efb5a72ad4cbe400fb">unidentified_sections</a>(known_sections);
<a name="l01862"></a>01862   }
<a name="l01863"></a>01863   
<a name="l01864"></a>01864   <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l01865"></a><a class="code" href="classGetPot.php#a4e6ad3f5d4b82ad8a9fde567714c9ab9">01865</a>   <a class="code" href="classGetPot.php#ab15068c3bafe041868c9796e73ba3646">GetPot::unidentified_nominuses</a>(<span class="keywordtype">unsigned</span> <a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>, <span class="keyword">const</span> <span class="keywordtype">char</span>* Known, ...)<span class="keyword"> const</span>
<a name="l01866"></a>01866 <span class="keyword">  </span>{
<a name="l01867"></a>01867     std::vector&lt;std::string&gt; known_nominuses;
<a name="l01868"></a>01868   
<a name="l01869"></a>01869     <span class="comment">// create vector of known arguments</span>
<a name="l01870"></a>01870     <span class="keywordflow">if</span>( Number == 0 ) <span class="keywordflow">return</span> std::vector&lt;std::string&gt;();
<a name="l01871"></a>01871   
<a name="l01872"></a>01872     std::va_list ap;
<a name="l01873"></a>01873     va_start(ap, Known);
<a name="l01874"></a>01874     known_nominuses.push_back(std::string(Known));
<a name="l01875"></a>01875     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;<a class="code" href="libmesh__common_8h.php#a93f2a4f0c19c6c284b678b9590b8119b">Number</a>; i++) {
<a name="l01876"></a>01876       std::string tmp = std::string(va_arg(ap, <span class="keywordtype">char</span> *));
<a name="l01877"></a>01877       <span class="keywordflow">if</span>( tmp.length() == 0 ) <span class="keywordflow">continue</span>;
<a name="l01878"></a>01878       known_nominuses.push_back(tmp);
<a name="l01879"></a>01879     }
<a name="l01880"></a>01880     va_end(ap);
<a name="l01881"></a>01881   
<a name="l01882"></a>01882     <span class="keywordflow">return</span> <a class="code" href="classGetPot.php#ab15068c3bafe041868c9796e73ba3646">unidentified_nominuses</a>(known_nominuses);
<a name="l01883"></a>01883   }
<a name="l01884"></a>01884   
<a name="l01885"></a>01885 <span class="preprocessor">#endif //GETPOT_ALLOW_VARGS</span>
<a name="l01886"></a>01886 <span class="preprocessor"></span>
<a name="l01887"></a>01887 
<a name="l01888"></a>01888 
<a name="l01889"></a>01889 <span class="keyword">inline</span> std::string
<a name="l01890"></a><a class="code" href="classGetPot.php#a3b4c3f3128a38c2a24c977f9c5371c1a">01890</a> <a class="code" href="classGetPot.php#a3b4c3f3128a38c2a24c977f9c5371c1a">GetPot::unidentified_flags</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* KnownFlagList, <span class="keywordtype">int</span> ArgumentNumber=-1) const
<a name="l01891"></a>01891 <span class="comment">// Two modes:</span>
<a name="l01892"></a>01892 <span class="comment">//  ArgumentNumber &gt;= 0 check specific argument </span>
<a name="l01893"></a>01893 <span class="comment">//  ArgumentNumber == -1 check all options starting with one &#39;-&#39; </span>
<a name="l01894"></a>01894 <span class="comment">//                       for flags</span>
<a name="l01895"></a>01895 {
<a name="l01896"></a>01896   std::string         ufos;
<a name="l01897"></a>01897   std::vector&lt;std::string&gt; known_arguments;
<a name="l01898"></a>01898   std::string         KFL(KnownFlagList);
<a name="l01899"></a>01899 
<a name="l01900"></a>01900   <span class="comment">// (2) iteration over &#39;-&#39; arguments (options)</span>
<a name="l01901"></a>01901   <span class="keywordflow">if</span>( ArgumentNumber == -1 ) {
<a name="l01902"></a>01902     std::vector&lt;std::string&gt;::const_iterator it = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.begin();
<a name="l01903"></a>01903     it++; <span class="comment">// forget about argv[0] (application or filename)</span>
<a name="l01904"></a>01904     <span class="keywordflow">for</span>(; it != <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.end(); it++) {
<a name="l01905"></a>01905       <span class="comment">// -- argument belongs to prefixed section ?</span>
<a name="l01906"></a>01906       <span class="keyword">const</span> std::string arg = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(*it, <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l01907"></a>01907       <span class="keywordflow">if</span>( arg == <span class="stringliteral">&quot;&quot;</span> ) <span class="keywordflow">continue</span>;
<a name="l01908"></a>01908 
<a name="l01909"></a>01909       <span class="comment">// -- does arguments start with &#39;-&#39; (but not &#39;--&#39;)</span>
<a name="l01910"></a>01910       <span class="keywordflow">if</span>     ( arg.length() &lt; 2 ) <span class="keywordflow">continue</span>;
<a name="l01911"></a>01911       <span class="keywordflow">else</span> <span class="keywordflow">if</span>( arg[0] != <span class="charliteral">&#39;-&#39;</span> )    <span class="keywordflow">continue</span>;
<a name="l01912"></a>01912       <span class="keywordflow">else</span> <span class="keywordflow">if</span>( arg[1] == <span class="charliteral">&#39;-&#39;</span> )    <span class="keywordflow">continue</span>;
<a name="l01913"></a>01913 
<a name="l01914"></a>01914       <span class="comment">// -- check out if flags inside option are contained in KnownFlagList</span>
<a name="l01915"></a>01915       <span class="keyword">const</span> <span class="keywordtype">char</span>* p=arg.c_str();
<a name="l01916"></a>01916       p++; <span class="comment">// skip starting minus</span>
<a name="l01917"></a>01917       <span class="keywordflow">for</span>(; *p != <span class="charliteral">&#39;\0&#39;</span> ; p++)
<a name="l01918"></a>01918         <span class="keywordflow">if</span>( KFL.find(*p) == std::string::npos ) ufos += *p;
<a name="l01919"></a>01919     }
<a name="l01920"></a>01920   }
<a name="l01921"></a>01921   <span class="comment">// (1) check specific argument</span>
<a name="l01922"></a>01922   <span class="keywordflow">else</span> {
<a name="l01923"></a>01923     <span class="comment">// -- only check arguments that start with prefix</span>
<a name="l01924"></a>01924     <span class="keywordtype">int</span> no_matches = 0;
<a name="l01925"></a>01925     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=1; i&lt;<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.size(); i++) {
<a name="l01926"></a>01926       <span class="keyword">const</span> std::string Remain = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(<a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>[i], <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l01927"></a>01927       <span class="keywordflow">if</span>( Remain != <span class="stringliteral">&quot;&quot;</span>) {
<a name="l01928"></a>01928         no_matches++;
<a name="l01929"></a>01929         <span class="keywordflow">if</span>( no_matches == ArgumentNumber) {
<a name="l01930"></a>01930           <span class="comment">// -- the right argument number inside the section is found</span>
<a name="l01931"></a>01931           <span class="comment">// =&gt; check it for flags</span>
<a name="l01932"></a>01932           <span class="keyword">const</span> <span class="keywordtype">char</span>* p = Remain.c_str();
<a name="l01933"></a>01933           p++; <span class="comment">// skip starting minus</span>
<a name="l01934"></a>01934           <span class="keywordflow">for</span>(; *p != <span class="charliteral">&#39;\0&#39;</span> ; p++)
<a name="l01935"></a>01935             <span class="keywordflow">if</span>( KFL.find(*p) == std::string::npos ) ufos += *p;
<a name="l01936"></a>01936           <span class="keywordflow">return</span> ufos;
<a name="l01937"></a>01937         }
<a name="l01938"></a>01938       }
<a name="l01939"></a>01939     }
<a name="l01940"></a>01940   }
<a name="l01941"></a>01941   <span class="keywordflow">return</span> ufos;
<a name="l01942"></a>01942 }
<a name="l01943"></a>01943 
<a name="l01944"></a>01944 
<a name="l01945"></a>01945 
<a name="l01946"></a>01946 <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l01947"></a><a class="code" href="classGetPot.php#a1d5444f8f57c23d1568de392aaaf2016">01947</a> <a class="code" href="classGetPot.php#a1d5444f8f57c23d1568de392aaaf2016">GetPot::unidentified_arguments</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns)<span class="keyword"> const</span>
<a name="l01948"></a>01948 <span class="keyword"></span>{
<a name="l01949"></a>01949   std::vector&lt;std::string&gt; ufos;
<a name="l01950"></a>01950   std::vector&lt;std::string&gt;::const_iterator it = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.begin();
<a name="l01951"></a>01951   it++; <span class="comment">// forget about argv[0] (application or filename)</span>
<a name="l01952"></a>01952   <span class="keywordflow">for</span>(; it != <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.end(); it++) {
<a name="l01953"></a>01953     <span class="comment">// -- argument belongs to prefixed section ?</span>
<a name="l01954"></a>01954     <span class="keyword">const</span> std::string arg = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(*it, <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l01955"></a>01955     <span class="keywordflow">if</span>( arg == <span class="stringliteral">&quot;&quot;</span> ) <span class="keywordflow">continue</span>;
<a name="l01956"></a>01956 
<a name="l01957"></a>01957     <span class="comment">// -- check if in list</span>
<a name="l01958"></a>01958     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#acbcfcc3a4ac55ecedb94eaefe7685821">__search_string_vector</a>(Knowns, arg) == <span class="keyword">false</span>)
<a name="l01959"></a>01959       ufos.push_back(*it);
<a name="l01960"></a>01960   }
<a name="l01961"></a>01961   <span class="keywordflow">return</span> ufos;
<a name="l01962"></a>01962 }
<a name="l01963"></a>01963 
<a name="l01964"></a>01964 
<a name="l01965"></a>01965 
<a name="l01966"></a>01966 <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l01967"></a><a class="code" href="classGetPot.php#ade9b7d19d72cab14d3af460906c56667">01967</a> <a class="code" href="classGetPot.php#ade9b7d19d72cab14d3af460906c56667">GetPot::unidentified_options</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns)<span class="keyword"> const</span>
<a name="l01968"></a>01968 <span class="keyword"></span>{
<a name="l01969"></a>01969   std::vector&lt;std::string&gt; ufos;
<a name="l01970"></a>01970   std::vector&lt;std::string&gt;::const_iterator it = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.begin();
<a name="l01971"></a>01971   it++; <span class="comment">// forget about argv[0] (application or filename)</span>
<a name="l01972"></a>01972   <span class="keywordflow">for</span>(; it != <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.end(); it++) {
<a name="l01973"></a>01973     <span class="comment">// -- argument belongs to prefixed section ?</span>
<a name="l01974"></a>01974     <span class="keyword">const</span> std::string arg = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(*it, <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l01975"></a>01975     <span class="keywordflow">if</span>( arg == <span class="stringliteral">&quot;&quot;</span> ) <span class="keywordflow">continue</span>;
<a name="l01976"></a>01976 
<a name="l01977"></a>01977     <span class="comment">// is argument really an option (starting with &#39;-&#39;) ?</span>
<a name="l01978"></a>01978     <span class="keywordflow">if</span>( arg.length() &lt; 1 || arg[0] != <span class="charliteral">&#39;-&#39;</span> ) <span class="keywordflow">continue</span>;
<a name="l01979"></a>01979 
<a name="l01980"></a>01980     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#acbcfcc3a4ac55ecedb94eaefe7685821">__search_string_vector</a>(Knowns, arg) == <span class="keyword">false</span>)
<a name="l01981"></a>01981       ufos.push_back(*it);
<a name="l01982"></a>01982   }
<a name="l01983"></a>01983 
<a name="l01984"></a>01984   <span class="keywordflow">return</span> ufos;
<a name="l01985"></a>01985 }
<a name="l01986"></a>01986 
<a name="l01987"></a>01987 
<a name="l01988"></a>01988 
<a name="l01989"></a>01989 <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l01990"></a><a class="code" href="classGetPot.php#a376abbc67b3560db36f7393817cad391">01990</a> <a class="code" href="classGetPot.php#a376abbc67b3560db36f7393817cad391">GetPot::unidentified_variables</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns)<span class="keyword"> const</span>
<a name="l01991"></a>01991 <span class="keyword"></span>{
<a name="l01992"></a>01992   std::vector&lt;std::string&gt; ufos;
<a name="l01993"></a>01993 
<a name="l01994"></a>01994   victorate(<a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>, <a class="code" href="classGetPot.php#a375d4be36c548e2c476df0672e1b19b6">variables</a>, it) {
<a name="l01995"></a>01995     <span class="comment">// -- check if variable has specific prefix</span>
<a name="l01996"></a>01996     <span class="keyword">const</span> std::string var_name = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>((*it).name, <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l01997"></a>01997     <span class="keywordflow">if</span>( var_name == <span class="stringliteral">&quot;&quot;</span> ) <span class="keywordflow">continue</span>;
<a name="l01998"></a>01998 
<a name="l01999"></a>01999     <span class="comment">// -- check if variable is known</span>
<a name="l02000"></a>02000     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#acbcfcc3a4ac55ecedb94eaefe7685821">__search_string_vector</a>(Knowns, var_name) == <span class="keyword">false</span>)
<a name="l02001"></a>02001       ufos.push_back((*it).name);
<a name="l02002"></a>02002   }
<a name="l02003"></a>02003   <span class="keywordflow">return</span> ufos;    
<a name="l02004"></a>02004 }
<a name="l02005"></a>02005 
<a name="l02006"></a>02006 
<a name="l02007"></a>02007 
<a name="l02008"></a>02008 <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l02009"></a><a class="code" href="classGetPot.php#a3d56e136650aa9efb5a72ad4cbe400fb">02009</a> <a class="code" href="classGetPot.php#a3d56e136650aa9efb5a72ad4cbe400fb">GetPot::unidentified_sections</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns)<span class="keyword"> const</span>
<a name="l02010"></a>02010 <span class="keyword"></span>{
<a name="l02011"></a>02011   std::vector&lt;std::string&gt; ufos;
<a name="l02012"></a>02012 
<a name="l02013"></a>02013   victorate(std::string, <a class="code" href="classGetPot.php#a8b8f2d90bc5546a69172c19c23ddfe10">section_list</a>, it) {
<a name="l02014"></a>02014     <span class="comment">// -- check if section conform to prefix</span>
<a name="l02015"></a>02015     <span class="keyword">const</span> std::string sec_name = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(*it, <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l02016"></a>02016     <span class="keywordflow">if</span>( sec_name == <span class="stringliteral">&quot;&quot;</span> ) <span class="keywordflow">continue</span>;
<a name="l02017"></a>02017 
<a name="l02018"></a>02018     <span class="comment">// -- check if section is known</span>
<a name="l02019"></a>02019     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#acbcfcc3a4ac55ecedb94eaefe7685821">__search_string_vector</a>(Knowns, sec_name) == <span class="keyword">false</span> )
<a name="l02020"></a>02020       ufos.push_back(*it);
<a name="l02021"></a>02021   }
<a name="l02022"></a>02022 
<a name="l02023"></a>02023   <span class="keywordflow">return</span> ufos;    
<a name="l02024"></a>02024 }
<a name="l02025"></a>02025 
<a name="l02026"></a>02026 
<a name="l02027"></a>02027 
<a name="l02028"></a>02028 <span class="keyword">inline</span> std::vector&lt;std::string&gt; 
<a name="l02029"></a><a class="code" href="classGetPot.php#ab15068c3bafe041868c9796e73ba3646">02029</a> <a class="code" href="classGetPot.php#ab15068c3bafe041868c9796e73ba3646">GetPot::unidentified_nominuses</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; Knowns)<span class="keyword"> const</span>
<a name="l02030"></a>02030 <span class="keyword"></span>{
<a name="l02031"></a>02031   std::vector&lt;std::string&gt; ufos;
<a name="l02032"></a>02032 
<a name="l02033"></a>02033   <span class="comment">// (2) iterate over all arguments </span>
<a name="l02034"></a>02034   std::vector&lt;std::string&gt;::const_iterator it = <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.begin();
<a name="l02035"></a>02035   it++; <span class="comment">// forget about argv[0] (application or filename)</span>
<a name="l02036"></a>02036   <span class="keywordflow">for</span>(; it != <a class="code" href="classGetPot.php#aa91ea7124745726698dbf2bfa7a677e2">argv</a>.end(); it++) {
<a name="l02037"></a>02037     <span class="comment">// -- check if nominus part of prefix</span>
<a name="l02038"></a>02038     <span class="keyword">const</span> std::string arg = <a class="code" href="classGetPot.php#ae2e71e91b6577b2b05226871bc74de1f">__get_remaining_string</a>(*it, <a class="code" href="classGetPot.php#ae9851493b49f8b86acf60dd41a593067">prefix</a>);
<a name="l02039"></a>02039     <span class="keywordflow">if</span>( arg == <span class="stringliteral">&quot;&quot;</span> ) <span class="keywordflow">continue</span>;
<a name="l02040"></a>02040 
<a name="l02041"></a>02041     <span class="keywordflow">if</span>( arg.length() &lt; 1 )                                  <span class="keywordflow">continue</span>;
<a name="l02042"></a>02042     <span class="comment">// option ? --&gt; not a nomius </span>
<a name="l02043"></a>02043     <span class="keywordflow">if</span>( arg[0] == <span class="charliteral">&#39;-&#39;</span> )                                     <span class="keywordflow">continue</span>;
<a name="l02044"></a>02044     <span class="comment">// section ? --&gt; not a real nominus</span>
<a name="l02045"></a>02045     <span class="keywordflow">if</span>( arg[0] == <span class="charliteral">&#39;[&#39;</span> &amp;&amp; arg[arg.length()-1] == <span class="charliteral">&#39;]&#39;</span> ) <span class="keywordflow">continue</span>;
<a name="l02046"></a>02046     <span class="comment">// variable definition ? --&gt; not a real nominus</span>
<a name="l02047"></a>02047     <span class="keywordtype">bool</span> continue_f = <span class="keyword">false</span>;
<a name="l02048"></a>02048     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> i=0; i&lt;arg.length() ; i++)
<a name="l02049"></a>02049       <span class="keywordflow">if</span>( arg[i] == <span class="charliteral">&#39;=&#39;</span> ) { continue_f = <span class="keyword">true</span>; <span class="keywordflow">break</span>; }
<a name="l02050"></a>02050     <span class="keywordflow">if</span>( continue_f )                                           <span class="keywordflow">continue</span>;
<a name="l02051"></a>02051 
<a name="l02052"></a>02052     <span class="comment">// real nominuses are compared with the given list</span>
<a name="l02053"></a>02053     <span class="keywordflow">if</span>( <a class="code" href="classGetPot.php#acbcfcc3a4ac55ecedb94eaefe7685821">__search_string_vector</a>(Knowns, arg) == false )
<a name="l02054"></a>02054       ufos.push_back(*it);
<a name="l02055"></a>02055   }    
<a name="l02056"></a>02056   <span class="keywordflow">return</span> ufos;
<a name="l02057"></a>02057 }
<a name="l02058"></a>02058 
<a name="l02059"></a>02059 
<a name="l02060"></a>02060 
<a name="l02062"></a>02062 <span class="comment">// (*) variable class</span>
<a name="l02063"></a>02063 <span class="comment">//.............................................................................</span>
<a name="l02064"></a>02064 <span class="comment">//</span>
<a name="l02065"></a>02065 <span class="keyword">inline</span>
<a name="l02066"></a><a class="code" href="structGetPot_1_1variable.php#a53dc34d72895adde8df26c8edec0ddbd">02066</a> <a class="code" href="structGetPot_1_1variable.php#a53dc34d72895adde8df26c8edec0ddbd">GetPot::variable::variable</a>()
<a name="l02067"></a>02067 {}
<a name="l02068"></a>02068 
<a name="l02069"></a>02069 
<a name="l02070"></a>02070 
<a name="l02071"></a>02071 <span class="keyword">inline</span>
<a name="l02072"></a><a class="code" href="structGetPot_1_1variable.php#a755ec9f3bf18b621cf76e2758ed479ad">02072</a> <a class="code" href="structGetPot_1_1variable.php#a53dc34d72895adde8df26c8edec0ddbd">GetPot::variable::variable</a>(<span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">variable</a>&amp; Other)
<a name="l02073"></a>02073 { 
<a name="l02074"></a>02074 <span class="preprocessor">#ifdef WIN32</span>
<a name="l02075"></a>02075 <span class="preprocessor"></span>  <a class="code" href="classGetPot.php#a92c9fa06ffb4b578cdbb6e9200d27249">operator=</a>(Other); 
<a name="l02076"></a>02076 <span class="preprocessor">#else</span>
<a name="l02077"></a>02077 <span class="preprocessor"></span>  <a class="code" href="classGetPot.php#a92c9fa06ffb4b578cdbb6e9200d27249">GetPot::variable::operator=</a>(Other); 
<a name="l02078"></a>02078 <span class="preprocessor">#endif</span>
<a name="l02079"></a>02079 <span class="preprocessor"></span>}
<a name="l02080"></a>02080 
<a name="l02081"></a>02081 
<a name="l02082"></a>02082 
<a name="l02083"></a>02083 <span class="keyword">inline</span>
<a name="l02084"></a><a class="code" href="structGetPot_1_1variable.php#a4ab3b3393c5963e8018a6cdcc3069680">02084</a> <a class="code" href="structGetPot_1_1variable.php#a53dc34d72895adde8df26c8edec0ddbd">GetPot::variable::variable</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Name, <span class="keyword">const</span> <span class="keywordtype">char</span>* Value)
<a name="l02085"></a>02085 : <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>(Name) 
<a name="l02086"></a>02086 { 
<a name="l02087"></a>02087   <span class="comment">// make a copy of the &#39;Value&#39;</span>
<a name="l02088"></a>02088   <a class="code" href="structGetPot_1_1variable.php#ac6436ee90263756d3446b088cad447f7">take</a>(Value);
<a name="l02089"></a>02089 }
<a name="l02090"></a>02090 
<a name="l02091"></a>02091 
<a name="l02092"></a>02092 
<a name="l02093"></a>02093 <span class="keyword">inline</span> <span class="keyword">const</span> std::string*
<a name="l02094"></a><a class="code" href="structGetPot_1_1variable.php#afbec5f1b56e2c6d4929cae8de7bc0f89">02094</a> <a class="code" href="structGetPot_1_1variable.php#afbec5f1b56e2c6d4929cae8de7bc0f89">GetPot::variable::get_element</a>(<span class="keywordtype">unsigned</span> Idx)<span class="keyword"> const</span>
<a name="l02095"></a>02095 <span class="keyword"></span>{ <span class="keywordflow">if</span>( Idx &gt;= value.size() ) <span class="keywordflow">return</span> 0; <span class="keywordflow">else</span> <span class="keywordflow">return</span> &amp;(value[Idx]); }
<a name="l02096"></a>02096 
<a name="l02097"></a>02097 
<a name="l02098"></a>02098 
<a name="l02099"></a>02099 <span class="keyword">inline</span> <span class="keywordtype">void</span>
<a name="l02100"></a><a class="code" href="structGetPot_1_1variable.php#ac6436ee90263756d3446b088cad447f7">02100</a> <a class="code" href="structGetPot_1_1variable.php#ac6436ee90263756d3446b088cad447f7">GetPot::variable::take</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* Value)
<a name="l02101"></a>02101 { 
<a name="l02102"></a>02102   original = std::string(Value);
<a name="l02103"></a>02103 
<a name="l02104"></a>02104   <span class="comment">// separate string by white space delimiters using &#39;strtok&#39;</span>
<a name="l02105"></a>02105   <span class="comment">// thread safe usage of strtok (no static members)</span>
<a name="l02106"></a>02106   <span class="keywordtype">char</span>* spt = 0; 
<a name="l02107"></a>02107   <span class="comment">// make a copy of the &#39;Value&#39;</span>
<a name="l02108"></a>02108   <span class="keywordtype">char</span>* copy = <span class="keyword">new</span> <span class="keywordtype">char</span>[std::strlen(Value)+1];
<a name="l02109"></a>02109   std::strcpy(copy, Value);
<a name="l02110"></a>02110   <span class="keywordtype">char</span>* follow_token = strtok_r(copy, <span class="stringliteral">&quot; \t\n&quot;</span>, &amp;spt);
<a name="l02111"></a>02111   <span class="keywordflow">if</span>( value.size() != 0 ) value.erase(value.begin(), value.end());
<a name="l02112"></a>02112   <span class="keywordflow">while</span>(follow_token != 0) {
<a name="l02113"></a>02113     value.push_back(std::string(follow_token));
<a name="l02114"></a>02114     follow_token = strtok_r(NULL, <span class="stringliteral">&quot; \t\n&quot;</span>, &amp;spt);
<a name="l02115"></a>02115   }
<a name="l02116"></a>02116 
<a name="l02117"></a>02117   <span class="keyword">delete</span> [] copy;
<a name="l02118"></a>02118 }
<a name="l02119"></a>02119 
<a name="l02120"></a>02120 
<a name="l02121"></a>02121 
<a name="l02122"></a>02122 <span class="keyword">inline</span>
<a name="l02123"></a><a class="code" href="structGetPot_1_1variable.php#ad3b121a0b18dc153e734a1d68b8ff882">02123</a> <a class="code" href="structGetPot_1_1variable.php#ad3b121a0b18dc153e734a1d68b8ff882">GetPot::variable::~variable</a>()
<a name="l02124"></a>02124 {}
<a name="l02125"></a>02125 
<a name="l02126"></a>02126 
<a name="l02127"></a>02127 
<a name="l02128"></a>02128 <span class="keyword">inline</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>&amp; 
<a name="l02129"></a><a class="code" href="structGetPot_1_1variable.php#ae5d596e76d1cf7f780becbce8e283a1d">02129</a> <a class="code" href="classGetPot.php#a92c9fa06ffb4b578cdbb6e9200d27249">GetPot::variable::operator=</a>(<span class="keyword">const</span> <a class="code" href="structGetPot_1_1variable.php">GetPot::variable</a>&amp; Other)
<a name="l02130"></a>02130 {
<a name="l02131"></a>02131   <span class="keywordflow">if</span>( &amp;Other != <span class="keyword">this</span>) {
<a name="l02132"></a>02132     <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>     = Other.<a class="code" href="structGetPot_1_1variable.php#aafb48af9c71fbcd816917ee7ec25bed0">name</a>;
<a name="l02133"></a>02133     value    = Other.<a class="code" href="structGetPot_1_1variable.php#a8900906a1cbdf47618278b468ef6283d">value</a>;
<a name="l02134"></a>02134     original = Other.<a class="code" href="structGetPot_1_1variable.php#a5f3dff13ab481abc484dd1208bbd7a47">original</a>;
<a name="l02135"></a>02135   }
<a name="l02136"></a>02136   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l02137"></a>02137 }
<a name="l02138"></a>02138 
<a name="l02139"></a>02139 
<a name="l02140"></a>02140 <span class="comment">//using namespace __GetPot_namespace__;</span>
<a name="l02141"></a>02141 
<a name="l02142"></a>02142 <span class="preprocessor">#undef victorate</span>
<a name="l02143"></a>02143 <span class="preprocessor"></span><span class="preprocessor">#undef reduce</span>
<a name="l02144"></a>02144 <span class="preprocessor"></span><span class="preprocessor">#endif // __GETPOT_H__</span>
<a name="l02145"></a>02145 <span class="preprocessor"></span>
<a name="l02146"></a>02146 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
