<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_communication.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__communication_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_communication.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;location_maps.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;mesh_communication.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;parallel_mesh.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;parallel_ghost_sync.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;utility.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;remote_elem.h&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">//-----------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// anonymous namespace for implementation details</span>
<a name="l00044"></a>00044 <span class="keyword">namespace </span>{
<a name="l00045"></a>00045 
<a name="l00052"></a>00052   <span class="keyword">struct </span>CompareElemIdsByLevel
<a name="l00053"></a>00053   {
<a name="l00054"></a>00054     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *a,
<a name="l00055"></a>00055                     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *b)<span class="keyword"> const</span>
<a name="l00056"></a>00056 <span class="keyword">    </span>{
<a name="l00057"></a>00057       libmesh_assert (a);
<a name="l00058"></a>00058       libmesh_assert (b);
<a name="l00059"></a>00059       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00060"></a>00060         al = a-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>(), bl = b-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>(),
<a name="l00061"></a>00061         aid = a-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>(),   bid = b-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00062"></a>00062 
<a name="l00063"></a>00063       <span class="keywordflow">return</span> (al == bl) ? aid &lt; bid : al &lt; bl;
<a name="l00064"></a>00064     }
<a name="l00065"></a>00065   };
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00071"></a>00071     FaceNeighborMask[] = { 1,    <span class="comment">// face 0 neighbor</span>
<a name="l00072"></a>00072                            2,    <span class="comment">// face 1 neighbor</span>
<a name="l00073"></a>00073                            4,    <span class="comment">// face 2 neighbor</span>
<a name="l00074"></a>00074                            8,    <span class="comment">// face 3 neighbor</span>
<a name="l00075"></a>00075                            16,   <span class="comment">// face 4 neighbor</span>
<a name="l00076"></a>00076                            32 }; <span class="comment">// face 5 neighbor</span>
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00082"></a>00082 <span class="comment">// MeshCommunication class members</span>
<a name="l00083"></a><a class="code" href="classMeshCommunication.php#a086c678faf2b37cc2033be2342ef3c74">00083</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a086c678faf2b37cc2033be2342ef3c74">MeshCommunication::clear</a> ()
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085   <span class="comment">//  _neighboring_processors.clear();</span>
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="comment">// #ifdef LIBMESH_HAVE_MPI</span>
<a name="l00090"></a>00090 <span class="comment">// void MeshCommunication::find_neighboring_processors (const MeshBase&amp; mesh)</span>
<a name="l00091"></a>00091 <span class="comment">// {</span>
<a name="l00092"></a>00092 <span class="comment">//   // Don&#39;t need to do anything if there is</span>
<a name="l00093"></a>00093 <span class="comment">//   // only one processor.</span>
<a name="l00094"></a>00094 <span class="comment">//   if (libMesh::n_processors() == 1)</span>
<a name="l00095"></a>00095 <span class="comment">//     return;</span>
<a name="l00096"></a>00096   
<a name="l00097"></a>00097 <span class="comment">//   _neighboring_processors.clear();</span>
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="comment">//   // Get the bounding sphere for the local processor</span>
<a name="l00100"></a>00100 <span class="comment">//   Sphere bounding_sphere =</span>
<a name="l00101"></a>00101 <span class="comment">//     MeshTools::processor_bounding_sphere (mesh, libMesh::processor_id());</span>
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="comment">//   // Just to be sure, increase its radius by 10%.  Sure would suck to</span>
<a name="l00104"></a>00104 <span class="comment">//   // miss a neighboring processor!</span>
<a name="l00105"></a>00105 <span class="comment">//   bounding_sphere.radius() *= 1.1;</span>
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="comment">//   // Collect the bounding spheres from all processors, test for intersection</span>
<a name="l00108"></a>00108 <span class="comment">//   {</span>
<a name="l00109"></a>00109 <span class="comment">//     std::vector&lt;float&gt;</span>
<a name="l00110"></a>00110 <span class="comment">//       send (4,                         0),</span>
<a name="l00111"></a>00111 <span class="comment">//       recv (4*libMesh::n_processors(), 0);</span>
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="comment">//     send[0] = bounding_sphere.center()(0);</span>
<a name="l00114"></a>00114 <span class="comment">//     send[1] = bounding_sphere.center()(1);</span>
<a name="l00115"></a>00115 <span class="comment">//     send[2] = bounding_sphere.center()(2);</span>
<a name="l00116"></a>00116 <span class="comment">//     send[3] = bounding_sphere.radius();</span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="comment">//     MPI_Allgather (&amp;send[0], send.size(), MPI_FLOAT,</span>
<a name="l00119"></a>00119 <span class="comment">//                 &amp;recv[0], send.size(), MPI_FLOAT,</span>
<a name="l00120"></a>00120 <span class="comment">//                 libMesh::COMM_WORLD);</span>
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="comment">//     for (unsigned int proc=0; proc&lt;libMesh::n_processors(); proc++)</span>
<a name="l00124"></a>00124 <span class="comment">//       {</span>
<a name="l00125"></a>00125 <span class="comment">//      const Point center (recv[4*proc+0],</span>
<a name="l00126"></a>00126 <span class="comment">//                          recv[4*proc+1],</span>
<a name="l00127"></a>00127 <span class="comment">//                          recv[4*proc+2]);</span>
<a name="l00128"></a>00128         
<a name="l00129"></a>00129 <span class="comment">//      const Real radius = recv[4*proc+3];</span>
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="comment">//      const Sphere proc_sphere (center, radius);</span>
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="comment">//      if (bounding_sphere.intersects(proc_sphere))</span>
<a name="l00134"></a>00134 <span class="comment">//        _neighboring_processors.push_back(proc);</span>
<a name="l00135"></a>00135 <span class="comment">//       }</span>
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="comment">//     // Print out the _neighboring_processors list</span>
<a name="l00138"></a>00138 <span class="comment">//     std::cout &lt;&lt; &quot;Processor &quot; &lt;&lt; libMesh::processor_id()</span>
<a name="l00139"></a>00139 <span class="comment">//            &lt;&lt; &quot; intersects:&quot; &lt;&lt; std::endl;</span>
<a name="l00140"></a>00140 <span class="comment">//     for (unsigned int p=0; p&lt;_neighboring_processors.size(); p++)</span>
<a name="l00141"></a>00141 <span class="comment">//       std::cout &lt;&lt; &quot; &quot; &lt;&lt; _neighboring_processors[p] &lt;&lt; std::endl;</span>
<a name="l00142"></a>00142 <span class="comment">//   }</span>
<a name="l00143"></a>00143 <span class="comment">// }</span>
<a name="l00144"></a>00144 <span class="comment">// #else</span>
<a name="l00145"></a>00145 <span class="comment">// void MeshCommunication::find_neighboring_processors (const MeshBase&amp;)</span>
<a name="l00146"></a>00146 <span class="comment">// {</span>
<a name="l00147"></a>00147 <span class="comment">// }</span>
<a name="l00148"></a>00148 <span class="comment">// #endif</span>
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI // avoid spurious gcc warnings</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l00154"></a><a class="code" href="classMeshCommunication.php#a81c4ded86040b982ff4c811823c7c187">00154</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a81c4ded86040b982ff4c811823c7c187">MeshCommunication::redistribute</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;)<span class="keyword"> const</span>
<a name="l00155"></a>00155 <span class="keyword"></span>{
<a name="l00156"></a>00156   <span class="comment">// no MPI == one processor, no redistribution</span>
<a name="l00157"></a>00157   <span class="keywordflow">return</span>;
<a name="l00158"></a>00158 }
<a name="l00159"></a>00159 <span class="preprocessor">#else</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l00161"></a>00161 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a81c4ded86040b982ff4c811823c7c187">MeshCommunication::redistribute</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;mesh)<span class="keyword"> const</span>
<a name="l00162"></a>00162 <span class="keyword"></span>{
<a name="l00163"></a>00163   <span class="comment">// This method will be called after a new partitioning has been </span>
<a name="l00164"></a>00164   <span class="comment">// assigned to the elements.  This partitioning was defined in</span>
<a name="l00165"></a>00165   <span class="comment">// terms of the active elements, and &quot;trickled down&quot; to the</span>
<a name="l00166"></a>00166   <span class="comment">// parents and nodes as to be consistent.</span>
<a name="l00167"></a>00167   <span class="comment">//</span>
<a name="l00168"></a>00168   <span class="comment">// The point is that the entire concept of local elements is</span>
<a name="l00169"></a>00169   <span class="comment">// kinda shaky in this method.  Elements which were previously</span>
<a name="l00170"></a>00170   <span class="comment">// local may now be assigned to other processors, so we need to</span>
<a name="l00171"></a>00171   <span class="comment">// send those off.  Similarly, we need to accept elements from</span>
<a name="l00172"></a>00172   <span class="comment">// other processors.  </span>
<a name="l00173"></a>00173   <span class="comment">// </span>
<a name="l00174"></a>00174   <span class="comment">// The approach is as follows:</span>
<a name="l00175"></a>00175   <span class="comment">// (1) send all elements we have stored to their proper homes</span>
<a name="l00176"></a>00176   <span class="comment">// (2) receive elements from all processors, watching for duplicates</span>
<a name="l00177"></a>00177   <span class="comment">// (3) deleting all nonlocal elements elements</span>
<a name="l00178"></a>00178   <span class="comment">// (4) obtaining required ghost elements from neighboring processors</span>
<a name="l00179"></a>00179   parallel_only();
<a name="l00180"></a>00180   libmesh_assert (!mesh.<a class="code" href="classParallelMesh.php#ac72c8fd7a3d1df94503f7028601c14df">is_serial</a>());
<a name="l00181"></a>00181   libmesh_assert (<a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">MeshTools::n_elem</a>(mesh.<a class="code" href="classParallelMesh.php#a36cda99fc5687ca38b5b0cf2e113fcff">unpartitioned_elements_begin</a>(),
<a name="l00182"></a>00182                                     mesh.<a class="code" href="classParallelMesh.php#a147d2a4bda46d2dbeabd972f908525bb">unpartitioned_elements_end</a>()) == 0);
<a name="l00183"></a>00183   
<a name="l00184"></a>00184   START_LOG(<span class="stringliteral">&quot;redistribute()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// register a derived datatype to use in shipping nodes  </span>
<a name="l00187"></a>00187   Parallel::DataType packed_node_datatype = <a class="code" href="structNode_1_1PackedNode.php#aa8d2df259c60b02a82fa80fa60326acf">Node::PackedNode::create_mpi_datatype</a>();
<a name="l00188"></a>00188   packed_node_datatype.commit();
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">// Figure out how many nodes and elements we have which are assigned to each</span>
<a name="l00191"></a>00191   <span class="comment">// processor.  send_n_nodes_and_elem_per_proc contains the number of nodes/elements</span>
<a name="l00192"></a>00192   <span class="comment">// we will be sending to each processor, recv_n_nodes_and_elem_per_proc contains</span>
<a name="l00193"></a>00193   <span class="comment">// the number of nodes/elements we will be receiving from each processor.</span>
<a name="l00194"></a>00194   <span class="comment">// Format:</span>
<a name="l00195"></a>00195   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+0] = number of nodes to send to pid</span>
<a name="l00196"></a>00196   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+1] = number of elements to send to pid</span>
<a name="l00197"></a>00197   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+2] = connectivity buffer size</span>
<a name="l00198"></a>00198   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+3] = node bc buffer size</span>
<a name="l00199"></a>00199   <span class="comment">//  send_n_nodes_and_elem_per_proc[5*pid+4] = element bc buffer size</span>
<a name="l00200"></a>00200   std::vector&lt;unsigned int&gt; send_n_nodes_and_elem_per_proc(5*<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00201"></a>00201   
<a name="l00202"></a>00202   std::vector&lt;std::vector&lt;Node::PackedNode&gt; &gt;
<a name="l00203"></a>00203     nodes_sent(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   std::vector&lt;std::vector&lt;int&gt; &gt; 
<a name="l00206"></a>00206     elements_sent(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00207"></a>00207     node_bcs_sent(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00208"></a>00208     element_bcs_sent(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00209"></a>00209     
<a name="l00210"></a>00210   std::vector&lt;Parallel::request&gt;
<a name="l00211"></a>00211     node_send_requests, element_send_requests,
<a name="l00212"></a>00212     node_bc_requests,   element_bc_requests;
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00215"></a>00215     <span class="keywordflow">if</span> (pid != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) <span class="comment">// don&#39;t send to ourselves!!</span>
<a name="l00216"></a>00216       {
<a name="l00217"></a>00217         <span class="comment">// Build up a list of nodes and elements to send to processor pid.</span>
<a name="l00218"></a>00218         <span class="comment">// We will certainly send all the active elements assigned to this processor,</span>
<a name="l00219"></a>00219         <span class="comment">// but we will also ship off the other elements in the same family tree</span>
<a name="l00220"></a>00220         <span class="comment">// as the active ones for data structure consistency.  We also</span>
<a name="l00221"></a>00221         <span class="comment">// ship any nodes connected to these elements.  Note some of these nodes</span>
<a name="l00222"></a>00222         <span class="comment">// and elements may be replicated from other processors, but that is OK.</span>
<a name="l00223"></a>00223         std::set&lt;const Elem*, CompareElemIdsByLevel&gt; elements_to_send;
<a name="l00224"></a>00224         std::set&lt;const Node*&gt; connected_nodes;
<a name="l00225"></a>00225         {
<a name="l00226"></a>00226           std::vector&lt;const Elem*&gt; family_tree;
<a name="l00227"></a>00227 
<a name="l00228"></a>00228           <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = mesh.<a class="code" href="classParallelMesh.php#afaa6356f7fc192f9146c38194f4747ba">active_pid_elements_begin</a>(pid);
<a name="l00229"></a>00229           <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = mesh.<a class="code" href="classParallelMesh.php#ac83631fe55f1b418f31db3c4cab3e6c3">active_pid_elements_end</a>(pid);
<a name="l00230"></a>00230           
<a name="l00231"></a>00231           <span class="keywordflow">for</span> (; elem_it!=elem_end; ++elem_it)
<a name="l00232"></a>00232             {
<a name="l00233"></a>00233               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *top_parent = (*elem_it)-&gt;<a class="code" href="classElem.php#a6bc01ad4901efb64eb4f584ed5e1bd0b">top_parent</a>();
<a name="l00234"></a>00234 
<a name="l00235"></a>00235               <span class="comment">// avoid a lot of duplication -- if we already have top_parent</span>
<a name="l00236"></a>00236               <span class="comment">// in the set its entire family tree is already in the set.</span>
<a name="l00237"></a>00237               <span class="keywordflow">if</span> (!elements_to_send.count(top_parent))
<a name="l00238"></a>00238                 {
<a name="l00239"></a>00239 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span>                  top_parent-&gt;<a class="code" href="classElem.php#abafd34cacabfdf831cc86e781c211fa1">family_tree</a>(family_tree);
<a name="l00241"></a>00241 <span class="preprocessor">#else</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>                  family_tree.clear();
<a name="l00243"></a>00243                   family_tree.push_back(top_parent);
<a name="l00244"></a>00244 <span class="preprocessor">#endif</span>
<a name="l00245"></a>00245 <span class="preprocessor"></span>                  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;family_tree.size(); e++)
<a name="l00246"></a>00246                     {
<a name="l00247"></a>00247                       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = family_tree[e];
<a name="l00248"></a>00248                       elements_to_send.insert (elem);
<a name="l00249"></a>00249                       
<a name="l00250"></a>00250                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00251"></a>00251                         connected_nodes.insert (elem-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n));               
<a name="l00252"></a>00252                     }
<a name="l00253"></a>00253                 }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255               <span class="comment">// then do the same for the face neighbors</span>
<a name="l00256"></a>00256               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;(*elem_it)-&gt;n_sides(); s++)
<a name="l00257"></a>00257                 <span class="keywordflow">if</span> ((*elem_it)-&gt;neighbor(s) != NULL)
<a name="l00258"></a>00258                   <span class="keywordflow">if</span> (!(*elem_it)-&gt;neighbor(s)-&gt;is_remote())
<a name="l00259"></a>00259                     {
<a name="l00260"></a>00260                       top_parent = (*elem_it)-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s)-&gt;<a class="code" href="classElem.php#a6bc01ad4901efb64eb4f584ed5e1bd0b">top_parent</a>();
<a name="l00261"></a>00261                       
<a name="l00262"></a>00262                       <span class="keywordflow">if</span> (!elements_to_send.count(top_parent))
<a name="l00263"></a>00263                         {
<a name="l00264"></a>00264 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span>                          top_parent-&gt;<a class="code" href="classElem.php#abafd34cacabfdf831cc86e781c211fa1">family_tree</a>(family_tree);
<a name="l00266"></a>00266 <span class="preprocessor">#else</span>
<a name="l00267"></a>00267 <span class="preprocessor"></span>                          family_tree.clear();
<a name="l00268"></a>00268                           family_tree.push_back(top_parent);
<a name="l00269"></a>00269 <span class="preprocessor">#endif                    </span>
<a name="l00270"></a>00270 <span class="preprocessor"></span>                          <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;family_tree.size(); e++)
<a name="l00271"></a>00271                             {
<a name="l00272"></a>00272                               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = family_tree[e];
<a name="l00273"></a>00273                               elements_to_send.insert (elem);
<a name="l00274"></a>00274                               
<a name="l00275"></a>00275                               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00276"></a>00276                                 connected_nodes.insert (elem-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n));               
<a name="l00277"></a>00277                             }
<a name="l00278"></a>00278                         }
<a name="l00279"></a>00279                     }
<a name="l00280"></a>00280             }
<a name="l00281"></a>00281         }
<a name="l00282"></a>00282         <span class="comment">// The elements_to_send set now contains all the elements stored on the local</span>
<a name="l00283"></a>00283         <span class="comment">// processor but owned by processor pid.  Additionally, the face neighbors</span>
<a name="l00284"></a>00284         <span class="comment">// for these elements are also transferred.  Finally, the entire refinement</span>
<a name="l00285"></a>00285         <span class="comment">// tree is also included.  This is a very simplistic way of ensuring data</span>
<a name="l00286"></a>00286         <span class="comment">// structure consistency at the cost of larger communication buffers.  It is</span>
<a name="l00287"></a>00287         <span class="comment">// worth profiling this on several parallel architectures to assess its impact.</span>
<a name="l00288"></a>00288         
<a name="l00289"></a>00289         
<a name="l00290"></a>00290         <span class="keywordflow">if</span> (!connected_nodes.empty())
<a name="l00291"></a>00291           {
<a name="l00292"></a>00292             <span class="comment">// the number of nodes we will ship to pid</span>
<a name="l00293"></a>00293             send_n_nodes_and_elem_per_proc[5*pid+0] = connected_nodes.size();
<a name="l00294"></a>00294             
<a name="l00295"></a>00295             nodes_sent[pid].reserve(connected_nodes.size());
<a name="l00296"></a>00296             
<a name="l00297"></a>00297             <span class="keywordflow">for</span> (std::set&lt;const Node*&gt;::const_iterator node_it = connected_nodes.begin();
<a name="l00298"></a>00298                  node_it != connected_nodes.end(); ++node_it)
<a name="l00299"></a>00299               {
<a name="l00300"></a>00300                 nodes_sent[pid].push_back(<a class="code" href="structNode_1_1PackedNode.php">Node::PackedNode</a>(**node_it));
<a name="l00301"></a>00301 
<a name="l00302"></a>00302                 <span class="comment">// add the node if it has BCs</span>
<a name="l00303"></a>00303                 std::vector&lt;short int&gt; bcs = mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;boundary_ids(*node_it);
<a name="l00304"></a>00304                 
<a name="l00305"></a>00305                 <span class="keywordflow">if</span> (!bcs.empty())
<a name="l00306"></a>00306                   {
<a name="l00307"></a>00307                     node_bcs_sent[pid].push_back((*node_it)-&gt;id());
<a name="l00308"></a>00308                     node_bcs_sent[pid].push_back(bcs.size());
<a name="l00309"></a>00309                     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc_it=0; bc_it &lt; bcs.size(); bc_it++)
<a name="l00310"></a>00310                       node_bcs_sent[pid].push_back(bcs[bc_it]);
<a name="l00311"></a>00311                   }
<a name="l00312"></a>00312               }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314             <span class="comment">// the size of the node bc buffer we will ship to pid</span>
<a name="l00315"></a>00315             send_n_nodes_and_elem_per_proc[5*pid+3] = node_bcs_sent[pid].size();            
<a name="l00316"></a>00316             
<a name="l00317"></a>00317             <span class="comment">// send the nodes off to the destination processor</span>
<a name="l00318"></a>00318             node_send_requests.push_back(Parallel::request());
<a name="l00319"></a>00319           
<a name="l00320"></a>00320             Parallel::send (pid,
<a name="l00321"></a>00321                             nodes_sent[pid],
<a name="l00322"></a>00322                             packed_node_datatype,
<a name="l00323"></a>00323                             node_send_requests.back(),
<a name="l00324"></a>00324                             <span class="comment">/* tag = */</span> 0);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326             <span class="keywordflow">if</span> (!node_bcs_sent[pid].empty())
<a name="l00327"></a>00327               {
<a name="l00328"></a>00328                 node_bc_requests.push_back(Parallel::request());
<a name="l00329"></a>00329 
<a name="l00330"></a>00330                 Parallel::send (pid,
<a name="l00331"></a>00331                                 node_bcs_sent[pid],
<a name="l00332"></a>00332                                 node_bc_requests.back(),
<a name="l00333"></a>00333                                 <span class="comment">/* tag = */</span> 2);
<a name="l00334"></a>00334               }
<a name="l00335"></a>00335           }
<a name="l00336"></a>00336         
<a name="l00337"></a>00337         <span class="keywordflow">if</span> (!elements_to_send.empty())
<a name="l00338"></a>00338           {
<a name="l00339"></a>00339             <span class="comment">// the number of elements we will send to this processor</span>
<a name="l00340"></a>00340             send_n_nodes_and_elem_per_proc[5*pid+1] = elements_to_send.size();
<a name="l00341"></a>00341 
<a name="l00342"></a>00342             <span class="keywordflow">for</span> (std::set&lt;const Elem*, CompareElemIdsByLevel&gt;::const_iterator 
<a name="l00343"></a>00343                    elem_it = elements_to_send.begin(); elem_it != elements_to_send.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>(); ++elem_it)
<a name="l00344"></a>00344               {
<a name="l00345"></a>00345                 Elem::PackedElem::pack (elements_sent[pid], *elem_it);
<a name="l00346"></a>00346 
<a name="l00347"></a>00347                 <span class="comment">// if this is a level-0 element look for boundary conditions</span>
<a name="l00348"></a>00348                 <span class="keywordflow">if</span> ((*elem_it)-&gt;level() == 0)
<a name="l00349"></a>00349                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;(*elem_it)-&gt;n_sides(); s++)
<a name="l00350"></a>00350                     <span class="keywordflow">if</span> ((*elem_it)-&gt;neighbor(s) == NULL)
<a name="l00351"></a>00351                       <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;boundary_id (*elem_it, s) !=
<a name="l00352"></a>00352                           mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;invalid_id)
<a name="l00353"></a>00353                         {
<a name="l00354"></a>00354                           element_bcs_sent[pid].push_back ((*elem_it)-&gt;id());
<a name="l00355"></a>00355                           element_bcs_sent[pid].push_back (s);
<a name="l00356"></a>00356                           element_bcs_sent[pid].push_back (mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;boundary_id (*elem_it, s));
<a name="l00357"></a>00357                         }
<a name="l00358"></a>00358               }
<a name="l00359"></a>00359             
<a name="l00360"></a>00360             <span class="comment">// the packed connectivity size to send to this processor</span>
<a name="l00361"></a>00361             send_n_nodes_and_elem_per_proc[5*pid+2] = elements_sent[pid].size();
<a name="l00362"></a>00362 
<a name="l00363"></a>00363             <span class="comment">// send the elements off to the destination processor</span>
<a name="l00364"></a>00364             element_send_requests.push_back(Parallel::request());
<a name="l00365"></a>00365           
<a name="l00366"></a>00366             Parallel::send (pid,
<a name="l00367"></a>00367                             elements_sent[pid],
<a name="l00368"></a>00368                             element_send_requests.back(),
<a name="l00369"></a>00369                             <span class="comment">/* tag = */</span> 1);
<a name="l00370"></a>00370 
<a name="l00371"></a>00371             <span class="comment">// the size of the element bc buffer we will ship to pid</span>
<a name="l00372"></a>00372             send_n_nodes_and_elem_per_proc[5*pid+4] = element_bcs_sent[pid].size();
<a name="l00373"></a>00373 
<a name="l00374"></a>00374             <span class="keywordflow">if</span> (!element_bcs_sent[pid].empty())
<a name="l00375"></a>00375               {
<a name="l00376"></a>00376                 element_bc_requests.push_back(Parallel::request());
<a name="l00377"></a>00377 
<a name="l00378"></a>00378                 Parallel::send (pid,
<a name="l00379"></a>00379                                 element_bcs_sent[pid],
<a name="l00380"></a>00380                                 element_bc_requests.back(),
<a name="l00381"></a>00381                                 <span class="comment">/* tag = */</span> 3);
<a name="l00382"></a>00382               }
<a name="l00383"></a>00383           }
<a name="l00384"></a>00384       }
<a name="l00385"></a>00385   
<a name="l00386"></a>00386   std::vector&lt;unsigned int&gt; recv_n_nodes_and_elem_per_proc(send_n_nodes_and_elem_per_proc);
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   Parallel::alltoall (recv_n_nodes_and_elem_per_proc);
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <span class="comment">// In general we will only need to communicate with a subset of the other processors.</span>
<a name="l00391"></a>00391   <span class="comment">// I can&#39;t immediately think of a case where we will send elements but not nodes, but</span>
<a name="l00392"></a>00392   <span class="comment">// these are only bools and we have the information anyway...</span>
<a name="l00393"></a>00393   std::vector&lt;bool&gt;
<a name="l00394"></a>00394     send_node_pair(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),<span class="keyword">false</span>), send_elem_pair(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),<span class="keyword">false</span>),
<a name="l00395"></a>00395     recv_node_pair(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),<span class="keyword">false</span>), recv_elem_pair(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),<span class="keyword">false</span>);
<a name="l00396"></a>00396   
<a name="l00397"></a>00397   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00398"></a>00398     n_send_node_pairs=0,     n_send_elem_pairs=0,
<a name="l00399"></a>00399     n_send_node_bc_pairs=0,  n_send_elem_bc_pairs=0, 
<a name="l00400"></a>00400     n_recv_node_pairs=0,     n_recv_elem_pairs=0,
<a name="l00401"></a>00401     n_recv_node_bc_pairs=0,  n_recv_elem_bc_pairs=0, 
<a name="l00402"></a>00402     max_n_nodes_received=0,  max_conn_size_received=0,
<a name="l00403"></a>00403     max_node_bcs_received=0, max_elem_bcs_received=0;
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00406"></a>00406     {
<a name="l00407"></a>00407       <span class="keywordflow">if</span> (send_n_nodes_and_elem_per_proc[5*pid+0]) <span class="comment">// we have nodes to send</span>
<a name="l00408"></a>00408         {
<a name="l00409"></a>00409           send_node_pair[pid] = <span class="keyword">true</span>;
<a name="l00410"></a>00410           n_send_node_pairs++;
<a name="l00411"></a>00411 
<a name="l00412"></a>00412           <span class="keywordflow">if</span> (send_n_nodes_and_elem_per_proc[5*pid+3]) <span class="comment">// and node bcs</span>
<a name="l00413"></a>00413             n_send_node_bc_pairs++;
<a name="l00414"></a>00414         }
<a name="l00415"></a>00415       
<a name="l00416"></a>00416       <span class="keywordflow">if</span> (send_n_nodes_and_elem_per_proc[5*pid+1]) <span class="comment">// we have elements to send</span>
<a name="l00417"></a>00417         {
<a name="l00418"></a>00418           send_elem_pair[pid] = <span class="keyword">true</span>;
<a name="l00419"></a>00419           n_send_elem_pairs++;
<a name="l00420"></a>00420 
<a name="l00421"></a>00421           <span class="keywordflow">if</span> (send_n_nodes_and_elem_per_proc[5*pid+4]) <span class="comment">// and element bcs</span>
<a name="l00422"></a>00422             n_send_elem_bc_pairs++;
<a name="l00423"></a>00423         }
<a name="l00424"></a>00424 
<a name="l00425"></a>00425       <span class="keywordflow">if</span> (recv_n_nodes_and_elem_per_proc[5*pid+0]) <span class="comment">// we have nodes to receive</span>
<a name="l00426"></a>00426         {
<a name="l00427"></a>00427           recv_node_pair[pid] = <span class="keyword">true</span>;
<a name="l00428"></a>00428           n_recv_node_pairs++;
<a name="l00429"></a>00429           max_n_nodes_received = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_n_nodes_received,
<a name="l00430"></a>00430                                           recv_n_nodes_and_elem_per_proc[5*pid+0]);
<a name="l00431"></a>00431 
<a name="l00432"></a>00432           <span class="keywordflow">if</span> (recv_n_nodes_and_elem_per_proc[5*pid+3]) <span class="comment">// and node bcs</span>
<a name="l00433"></a>00433             {
<a name="l00434"></a>00434               n_recv_node_bc_pairs++;
<a name="l00435"></a>00435               max_node_bcs_received = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_node_bcs_received,
<a name="l00436"></a>00436                                                recv_n_nodes_and_elem_per_proc[5*pid+3]);
<a name="l00437"></a>00437             }           
<a name="l00438"></a>00438         }
<a name="l00439"></a>00439       
<a name="l00440"></a>00440       <span class="keywordflow">if</span> (recv_n_nodes_and_elem_per_proc[5*pid+1]) <span class="comment">// we have elements to receive</span>
<a name="l00441"></a>00441         {
<a name="l00442"></a>00442           recv_elem_pair[pid] = <span class="keyword">true</span>;
<a name="l00443"></a>00443           n_recv_elem_pairs++;
<a name="l00444"></a>00444           max_conn_size_received = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_conn_size_received,
<a name="l00445"></a>00445                                             recv_n_nodes_and_elem_per_proc[5*pid+2]);
<a name="l00446"></a>00446 
<a name="l00447"></a>00447           <span class="keywordflow">if</span> (recv_n_nodes_and_elem_per_proc[5*pid+4]) <span class="comment">// and element bcs</span>
<a name="l00448"></a>00448             {
<a name="l00449"></a>00449               n_recv_elem_bc_pairs++;
<a name="l00450"></a>00450               max_elem_bcs_received = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_elem_bcs_received,
<a name="l00451"></a>00451                                                recv_n_nodes_and_elem_per_proc[5*pid+4]);
<a name="l00452"></a>00452             }
<a name="l00453"></a>00453         }
<a name="l00454"></a>00454     }
<a name="l00455"></a>00455   libmesh_assert (n_send_node_pairs    == node_send_requests.size());
<a name="l00456"></a>00456   libmesh_assert (n_send_elem_pairs    == element_send_requests.size());
<a name="l00457"></a>00457   libmesh_assert (n_send_node_bc_pairs == node_bc_requests.size());
<a name="l00458"></a>00458   libmesh_assert (n_send_elem_bc_pairs == element_bc_requests.size());
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   <span class="comment">// Receive nodes.  Size this array for the largest message.</span>
<a name="l00461"></a>00461   {
<a name="l00462"></a>00462     std::vector&lt;Node::PackedNode&gt; received_nodes; 
<a name="l00463"></a>00463     received_nodes.reserve(max_n_nodes_received);
<a name="l00464"></a>00464 
<a name="l00465"></a>00465     <span class="comment">// We now know how many processors will be sending us nodes.</span>
<a name="l00466"></a>00466     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_comm_step=0; node_comm_step&lt;n_recv_node_pairs; node_comm_step++)
<a name="l00467"></a>00467       {
<a name="l00468"></a>00468         <span class="comment">// but we don&#39;t necessarily want to impose an ordering, so</span>
<a name="l00469"></a>00469         <span class="comment">// just grab whatever message is available next.  note that</span>
<a name="l00470"></a>00470         <span class="comment">// the blocking receive should resize the vector to fit the</span>
<a name="l00471"></a>00471         <span class="comment">// incoming message</span>
<a name="l00472"></a>00472         Parallel::Status status =
<a name="l00473"></a>00473           Parallel::receive (Parallel::any_source,
<a name="l00474"></a>00474                              received_nodes,
<a name="l00475"></a>00475                              packed_node_datatype,
<a name="l00476"></a>00476                              <span class="comment">/* tag = */</span> 0);
<a name="l00477"></a>00477         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_pid = status.source();
<a name="l00478"></a>00478         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_nodes_received =
<a name="l00479"></a>00479           recv_n_nodes_and_elem_per_proc[5*source_pid+0];
<a name="l00480"></a>00480         libmesh_assert (n_nodes_received == received_nodes.size());
<a name="l00481"></a>00481         libmesh_assert (status.size() == n_nodes_received);
<a name="l00482"></a>00482         libmesh_assert (recv_node_pair[source_pid]);
<a name="l00483"></a>00483         
<a name="l00484"></a>00484         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_nodes_received; n++)
<a name="l00485"></a>00485           {
<a name="l00486"></a>00486             <a class="code" href="classNode.php">Node</a> *node = received_nodes[n].build_node().release();
<a name="l00487"></a>00487             mesh.<a class="code" href="classParallelMesh.php#ae5a2ef7ac888ae42fe08bb9716664795">insert_node</a>(node); <span class="comment">// insert_node works even if the</span>
<a name="l00488"></a>00488           }                         <span class="comment">// node already exists in the mesh,</span>
<a name="l00489"></a>00489       }                             <span class="comment">// in which case it overwrites (x,y,z)</span>
<a name="l00490"></a>00490   }
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   <span class="comment">// Receive BCs for those nodes.</span>
<a name="l00493"></a>00493   {
<a name="l00494"></a>00494     std::vector&lt;int&gt; received_node_bcs(max_node_bcs_received);
<a name="l00495"></a>00495 
<a name="l00496"></a>00496     <span class="comment">// again, receive all the messages in whatever order they come.</span>
<a name="l00497"></a>00497     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_comm_step=0; node_comm_step&lt;n_recv_node_bc_pairs; node_comm_step++)
<a name="l00498"></a>00498       {
<a name="l00499"></a>00499         Parallel::Status status =
<a name="l00500"></a>00500           Parallel::receive (Parallel::any_source,
<a name="l00501"></a>00501                              received_node_bcs,
<a name="l00502"></a>00502                              <span class="comment">/* tag = */</span> 2);
<a name="l00503"></a>00503 
<a name="l00504"></a>00504         libmesh_assert (status.size() == recv_n_nodes_and_elem_per_proc[5*status.source()+3]);
<a name="l00505"></a>00505 
<a name="l00506"></a>00506         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffer_size = status.size();
<a name="l00507"></a>00507         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00508"></a>00508 
<a name="l00509"></a>00509         <span class="keywordflow">while</span> (cnt &lt; buffer_size)
<a name="l00510"></a>00510           {
<a name="l00511"></a>00511             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = received_node_bcs[cnt++];
<a name="l00512"></a>00512             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_bcs = received_node_bcs[cnt++];
<a name="l00513"></a>00513 
<a name="l00514"></a>00514             libmesh_assert (mesh.<a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a>(node_id));
<a name="l00515"></a>00515             
<a name="l00516"></a>00516             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc_it=0; bc_it &lt; num_bcs; bc_it++)
<a name="l00517"></a>00517               mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_node (mesh.<a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a>(node_id), received_node_bcs[cnt++]);
<a name="l00518"></a>00518           }     
<a name="l00519"></a>00519       }
<a name="l00520"></a>00520   }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 
<a name="l00523"></a>00523   
<a name="l00524"></a>00524   <span class="comment">// Receive elements.  Size this array for the largest message.</span>
<a name="l00525"></a>00525   {
<a name="l00526"></a>00526     std::vector&lt;int&gt; received_elements(max_conn_size_received);
<a name="l00527"></a>00527 
<a name="l00528"></a>00528     <span class="comment">// Similarly we know how many processors are sending us elements, </span>
<a name="l00529"></a>00529     <span class="comment">// but we don&#39;t really care in what order we receive them.</span>
<a name="l00530"></a>00530     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_comm_step=0; elem_comm_step&lt;n_recv_elem_pairs; elem_comm_step++)
<a name="l00531"></a>00531       {
<a name="l00532"></a>00532         Parallel::Status status =
<a name="l00533"></a>00533           Parallel::receive (Parallel::any_source,
<a name="l00534"></a>00534                              received_elements,
<a name="l00535"></a>00535                              <span class="comment">/* tag = */</span> 1);
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00538"></a>00538 <span class="preprocessor"></span>        <span class="comment">// Avoid declaring these variables unless asserts are enabled.</span>
<a name="l00539"></a>00539         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_pid = status.source();
<a name="l00540"></a>00540         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_received = 
<a name="l00541"></a>00541           recv_n_nodes_and_elem_per_proc[5*source_pid+1];
<a name="l00542"></a>00542 <span class="preprocessor">#endif</span>
<a name="l00543"></a>00543 <span class="preprocessor"></span>        libmesh_assert (recv_elem_pair[source_pid]);
<a name="l00544"></a>00544         libmesh_assert (recv_n_nodes_and_elem_per_proc[5*source_pid+2] 
<a name="l00545"></a>00545                 &lt;= received_elements.size());
<a name="l00546"></a>00546         libmesh_assert (recv_n_nodes_and_elem_per_proc[5*source_pid+2] 
<a name="l00547"></a>00547                 == status.size());
<a name="l00548"></a>00548 
<a name="l00549"></a>00549         <span class="comment">// iterate through the input buffer and add the elements</span>
<a name="l00550"></a>00550         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> xfer_buffer_size = status.size();
<a name="l00551"></a>00551         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00552"></a>00552         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_elem=0;
<a name="l00553"></a>00553         <span class="keywordflow">while</span> (cnt &lt; xfer_buffer_size)
<a name="l00554"></a>00554           {
<a name="l00555"></a>00555             <span class="comment">// Unpack the element </span>
<a name="l00556"></a>00556             Elem::PackedElem packed_elem (received_elements.begin()+cnt);
<a name="l00557"></a>00557             
<a name="l00558"></a>00558             <span class="comment">// The ParallelMesh::elem(i) member will return NULL if the element</span>
<a name="l00559"></a>00559             <span class="comment">// is not in the mesh.  We rely on that here, so it better not change!</span>
<a name="l00560"></a>00560             <a class="code" href="classElem.php">Elem</a> *elem = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(packed_elem.id());
<a name="l00561"></a>00561             
<a name="l00562"></a>00562             <span class="comment">// if we already have this element, make sure its properties match</span>
<a name="l00563"></a>00563             <span class="comment">// but then go on</span>
<a name="l00564"></a>00564             <span class="keywordflow">if</span> (elem)
<a name="l00565"></a>00565               {
<a name="l00566"></a>00566                 libmesh_assert (elem-&gt;level()             == packed_elem.level());
<a name="l00567"></a>00567                 libmesh_assert (elem-&gt;id()                == packed_elem.id());
<a name="l00568"></a>00568                 libmesh_assert (elem-&gt;processor_id()      == packed_elem.processor_id());
<a name="l00569"></a>00569                 libmesh_assert (elem-&gt;subdomain_id()      == packed_elem.subdomain_id());
<a name="l00570"></a>00570                 libmesh_assert (elem-&gt;type()              == packed_elem.type());
<a name="l00571"></a>00571 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00572"></a>00572 <span class="preprocessor"></span>                libmesh_assert (elem-&gt;p_level()           == packed_elem.p_level());
<a name="l00573"></a>00573                 libmesh_assert (elem-&gt;refinement_flag()   == packed_elem.refinement_flag());
<a name="l00574"></a>00574                 libmesh_assert (elem-&gt;p_refinement_flag() == packed_elem.p_refinement_flag());
<a name="l00575"></a>00575                 
<a name="l00576"></a>00576                 <span class="keywordflow">if</span> (elem-&gt;level() &gt; 0)
<a name="l00577"></a>00577                   {
<a name="l00578"></a>00578                     libmesh_assert (elem-&gt;parent()-&gt;id() == <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(packed_elem.parent_id()));
<a name="l00579"></a>00579                     libmesh_assert (elem-&gt;parent()-&gt;child(packed_elem.which_child_am_i()) == elem);
<a name="l00580"></a>00580                   }           
<a name="l00581"></a>00581 <span class="preprocessor">#endif</span>
<a name="l00582"></a>00582 <span class="preprocessor"></span>                libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l00583"></a>00583               }
<a name="l00584"></a>00584             <span class="keywordflow">else</span>
<a name="l00585"></a>00585               {
<a name="l00586"></a>00586                 <span class="comment">// We need to add the element.</span>
<a name="l00587"></a>00587 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00588"></a>00588 <span class="preprocessor"></span>                <span class="comment">// maybe find the parent</span>
<a name="l00589"></a>00589                 <span class="keywordflow">if</span> (packed_elem.level() &gt; 0)
<a name="l00590"></a>00590                   {
<a name="l00591"></a>00591                     <a class="code" href="classElem.php">Elem</a> *parent = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(packed_elem.parent_id());
<a name="l00592"></a>00592                     
<a name="l00593"></a>00593                     <span class="comment">// Note that we were very careful to construct the send connectivity</span>
<a name="l00594"></a>00594                     <span class="comment">// so that parents are encountered before children.  So if we get here</span>
<a name="l00595"></a>00595                     <span class="comment">// and can&#39;t find the parent that is a fatal error.</span>
<a name="l00596"></a>00596                     <span class="keywordflow">if</span> (parent == NULL)
<a name="l00597"></a>00597                       {
<a name="l00598"></a>00598                         std::cerr &lt;&lt; <span class="stringliteral">&quot;Parent element with ID &quot;</span> &lt;&lt; packed_elem.parent_id()
<a name="l00599"></a>00599                                   &lt;&lt; <span class="stringliteral">&quot; not found.&quot;</span> &lt;&lt; std::endl; 
<a name="l00600"></a>00600                         libmesh_error();
<a name="l00601"></a>00601                       }
<a name="l00602"></a>00602                     
<a name="l00603"></a>00603                     elem = packed_elem.unpack (mesh, parent);
<a name="l00604"></a>00604                   }
<a name="l00605"></a>00605                 <span class="keywordflow">else</span>
<a name="l00606"></a>00606                   {
<a name="l00607"></a>00607                     libmesh_assert (packed_elem.parent_id() == -1);
<a name="l00608"></a>00608 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00609"></a>00609 <span class="preprocessor"></span>                    elem = packed_elem.unpack (mesh);
<a name="l00610"></a>00610 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00611"></a>00611 <span class="preprocessor"></span>                  }
<a name="l00612"></a>00612 <span class="preprocessor">#endif          </span>
<a name="l00613"></a>00613 <span class="preprocessor"></span>                <span class="comment">// Good to go.  Add to the mesh.</span>
<a name="l00614"></a>00614                 libmesh_assert (elem);
<a name="l00615"></a>00615                 libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l00616"></a>00616                 mesh.<a class="code" href="classParallelMesh.php#aadf11922b8147ddc3680d9a7da5d4447">insert_elem</a>(elem);
<a name="l00617"></a>00617               }
<a name="l00618"></a>00618             
<a name="l00619"></a>00619             <span class="comment">// properly position cnt for the next element </span>
<a name="l00620"></a>00620             cnt += Elem::PackedElem::header_size + packed_elem.<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l00621"></a>00621             current_elem++;
<a name="l00622"></a>00622           }
<a name="l00623"></a>00623         libmesh_assert (current_elem == n_elem_received);
<a name="l00624"></a>00624       }
<a name="l00625"></a>00625   }
<a name="l00626"></a>00626 
<a name="l00627"></a>00627   <span class="comment">// Receive boundary conditions for those elements</span>
<a name="l00628"></a>00628   {
<a name="l00629"></a>00629     std::vector&lt;int&gt; received_element_bcs(max_elem_bcs_received);
<a name="l00630"></a>00630     
<a name="l00631"></a>00631     <span class="comment">// again, receive all the messages in whatever order they come.</span>
<a name="l00632"></a>00632     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_comm_step=0; elem_comm_step&lt;n_recv_elem_bc_pairs; elem_comm_step++)
<a name="l00633"></a>00633       {
<a name="l00634"></a>00634         Parallel::Status status =
<a name="l00635"></a>00635           Parallel::receive (Parallel::any_source,
<a name="l00636"></a>00636                              received_element_bcs,
<a name="l00637"></a>00637                              <span class="comment">/* tag = */</span> 3);
<a name="l00638"></a>00638 
<a name="l00639"></a>00639         libmesh_assert (status.size() == recv_n_nodes_and_elem_per_proc[5*status.source()+4]);
<a name="l00640"></a>00640 
<a name="l00641"></a>00641         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffer_size = status.size();
<a name="l00642"></a>00642         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l00643"></a>00643 
<a name="l00644"></a>00644         <span class="keywordflow">while</span> (cnt &lt; buffer_size)
<a name="l00645"></a>00645           {
<a name="l00646"></a>00646             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_id = received_element_bcs[cnt++];
<a name="l00647"></a>00647             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side    = received_element_bcs[cnt++];
<a name="l00648"></a>00648             <span class="keyword">const</span> <span class="keywordtype">int</span> bc_id            = received_element_bcs[cnt++];
<a name="l00649"></a>00649 
<a name="l00650"></a>00650             libmesh_assert (mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(elem_id));
<a name="l00651"></a>00651             mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_side (mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(elem_id), side, bc_id);
<a name="l00652"></a>00652           }
<a name="l00653"></a>00653       }    
<a name="l00654"></a>00654   }
<a name="l00655"></a>00655 
<a name="l00656"></a>00656   <span class="comment">// Wait for all sends to complete</span>
<a name="l00657"></a>00657   Parallel::wait (node_send_requests);
<a name="l00658"></a>00658   Parallel::wait (node_bc_requests);
<a name="l00659"></a>00659   Parallel::wait (element_send_requests);
<a name="l00660"></a>00660   Parallel::wait (element_bc_requests);
<a name="l00661"></a>00661   
<a name="l00662"></a>00662   <span class="comment">// unregister MPI datatypes</span>
<a name="l00663"></a>00663   packed_node_datatype.free();
<a name="l00664"></a>00664   
<a name="l00665"></a>00665   STOP_LOG(<span class="stringliteral">&quot;redistribute()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);  
<a name="l00666"></a>00666 }
<a name="l00667"></a>00667 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l00668"></a>00668 <span class="preprocessor"></span>
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI // avoid spurious gcc warnings</span>
<a name="l00672"></a>00672 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l00673"></a><a class="code" href="classMeshCommunication.php#ae4d56ded77652b52bec621f5093091ce">00673</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ae4d56ded77652b52bec621f5093091ce">MeshCommunication::gather_neighboring_elements</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;)<span class="keyword"> const</span>
<a name="l00674"></a>00674 <span class="keyword"></span>{
<a name="l00675"></a>00675   <span class="comment">// no MPI == one processor, no need for this method...</span>
<a name="l00676"></a>00676   <span class="keywordflow">return</span>;
<a name="l00677"></a>00677 }
<a name="l00678"></a>00678 <span class="preprocessor">#else</span>
<a name="l00679"></a>00679 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l00680"></a>00680 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ae4d56ded77652b52bec621f5093091ce">MeshCommunication::gather_neighboring_elements</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a> &amp;mesh)<span class="keyword"> const</span>
<a name="l00681"></a>00681 <span class="keyword"></span>{
<a name="l00682"></a>00682   <span class="comment">// Don&#39;t need to do anything if there is</span>
<a name="l00683"></a>00683   <span class="comment">// only one processor.</span>
<a name="l00684"></a>00684   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00685"></a>00685     <span class="keywordflow">return</span>;  
<a name="l00686"></a>00686 
<a name="l00687"></a>00687   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00688"></a>00688   parallel_only();
<a name="l00689"></a>00689   
<a name="l00690"></a>00690   START_LOG(<span class="stringliteral">&quot;gather_neighboring_elements()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l00691"></a>00691 
<a name="l00692"></a>00692   <span class="comment">//------------------------------------------------------------------</span>
<a name="l00693"></a>00693   <span class="comment">// The purpose of this function is to provide neighbor data structure</span>
<a name="l00694"></a>00694   <span class="comment">// consistency for a parallel, distributed mesh.  In libMesh we require</span>
<a name="l00695"></a>00695   <span class="comment">// that each local element have access to a full set of valid face</span>
<a name="l00696"></a>00696   <span class="comment">// neighbors.  In some cases this requires us to store &quot;ghost elements&quot; -</span>
<a name="l00697"></a>00697   <span class="comment">// elements that belong to other processors but we store to provide</span>
<a name="l00698"></a>00698   <span class="comment">// data structure consistency.  Also, it is assumed that any element</span>
<a name="l00699"></a>00699   <span class="comment">// with a NULL neighbor resides on a physical domain boundary.  So,</span>
<a name="l00700"></a>00700   <span class="comment">// even our &quot;ghost elements&quot; must have non-NULL neighbors.  To handle</span>
<a name="l00701"></a>00701   <span class="comment">// this the concept of &quot;RemoteElem&quot; is used - a special construct which</span>
<a name="l00702"></a>00702   <span class="comment">// is used to denote that an element has a face neighbor, but we do</span>
<a name="l00703"></a>00703   <span class="comment">// not actually store detailed information about that neighbor.  This</span>
<a name="l00704"></a>00704   <span class="comment">// is required to prevent data structure explosion.</span>
<a name="l00705"></a>00705   <span class="comment">//</span>
<a name="l00706"></a>00706   <span class="comment">// So when this method is called we should have only local elements.</span>
<a name="l00707"></a>00707   <span class="comment">// These local elements will then find neighbors among the local</span>
<a name="l00708"></a>00708   <span class="comment">// element set.  After this is completed, any element with a NULL</span>
<a name="l00709"></a>00709   <span class="comment">// neighbor has either (i) a face on the physical boundary of the mesh,</span>
<a name="l00710"></a>00710   <span class="comment">// or (ii) a neighboring element which lives on a remote processor.</span>
<a name="l00711"></a>00711   <span class="comment">// To handle case (ii), we communicate the global node indices connected</span>
<a name="l00712"></a>00712   <span class="comment">// to all such faces to our neighboring processors.  They then send us</span>
<a name="l00713"></a>00713   <span class="comment">// all their elements with a NULL neighbor that are connected to any</span>
<a name="l00714"></a>00714   <span class="comment">// of the nodes in our list.</span>
<a name="l00715"></a>00715   <span class="comment">//------------------------------------------------------------------</span>
<a name="l00716"></a>00716 
<a name="l00717"></a>00717   <span class="comment">// Let&#39;s begin with finding consistent neighbor data information</span>
<a name="l00718"></a>00718   <span class="comment">// for all the elements we currently have.  We&#39;ll use a clean</span>
<a name="l00719"></a>00719   <span class="comment">// slate here - clear any existing information, including RemoteElem&#39;s.</span>
<a name="l00720"></a>00720   mesh.<a class="code" href="classUnstructuredMesh.php#a98c765606a6c53e090c2595b739201ff">find_neighbors</a> (<span class="comment">/* reset_remote_elements = */</span> <span class="keyword">true</span>,
<a name="l00721"></a>00721                        <span class="comment">/* reset_current_list    = */</span> <span class="keyword">true</span>);    
<a name="l00722"></a>00722   
<a name="l00723"></a>00723   <span class="comment">// register a derived datatype to use in shipping nodes  </span>
<a name="l00724"></a>00724   Parallel::DataType packed_node_datatype = <a class="code" href="structNode_1_1PackedNode.php#aa8d2df259c60b02a82fa80fa60326acf">Node::PackedNode::create_mpi_datatype</a>();
<a name="l00725"></a>00725   packed_node_datatype.commit();
<a name="l00726"></a>00726 
<a name="l00727"></a>00727   <span class="comment">// Now any element with a NULL neighbor either</span>
<a name="l00728"></a>00728   <span class="comment">// (i) lives on the physical domain boundary, or</span>
<a name="l00729"></a>00729   <span class="comment">// (ii) lives on an inter-processor boundary.</span>
<a name="l00730"></a>00730   <span class="comment">// We will now gather all the elements from adjacent processors</span>
<a name="l00731"></a>00731   <span class="comment">// which are of the same state, which should address all the type (ii)</span>
<a name="l00732"></a>00732   <span class="comment">// elements.</span>
<a name="l00733"></a>00733   
<a name="l00734"></a>00734   <span class="comment">// A list of all the processors which *may* contain neighboring elements.</span>
<a name="l00735"></a>00735   <span class="comment">// (for development simplicity, just make this the identity map)</span>
<a name="l00736"></a>00736   std::vector&lt;unsigned int&gt; adjacent_processors;
<a name="l00737"></a>00737   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00738"></a>00738     <span class="keywordflow">if</span> (pid != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00739"></a>00739       adjacent_processors.push_back (pid);
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 
<a name="l00742"></a>00742   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_adjacent_processors = adjacent_processors.size();
<a name="l00743"></a>00743 
<a name="l00744"></a>00744   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00745"></a>00745   <span class="comment">// Let&#39;s build a list of all nodes which live on NULL-neighbor sides.</span>
<a name="l00746"></a>00746   <span class="comment">// For simplicity, we will use a set to build the list, then transfer</span>
<a name="l00747"></a>00747   <span class="comment">// it to a vector for communication.</span>
<a name="l00748"></a>00748   std::vector&lt;unsigned int&gt; my_interface_node_list;
<a name="l00749"></a>00749   std::vector&lt;const Elem*&gt;  my_interface_elements;
<a name="l00750"></a>00750   {
<a name="l00751"></a>00751     std::set&lt;unsigned int&gt; my_interface_node_set;
<a name="l00752"></a>00752 
<a name="l00753"></a>00753     <span class="comment">// since parent nodes are a subset of children nodes, this should be sufficient</span>
<a name="l00754"></a>00754     <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it     = mesh.<a class="code" href="classParallelMesh.php#a6256f0b7f343da9232eb280a94f95999">active_local_elements_begin</a>();
<a name="l00755"></a>00755     <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it_end = mesh.<a class="code" href="classParallelMesh.php#a7505f8ccf94a640390308892417a5f49">active_local_elements_end</a>();
<a name="l00756"></a>00756 
<a name="l00757"></a>00757     <span class="keywordflow">for</span> (; it != it_end; ++it)
<a name="l00758"></a>00758       {
<a name="l00759"></a>00759         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> * <span class="keyword">const</span> elem = *it;
<a name="l00760"></a>00760         libmesh_assert (elem != NULL);
<a name="l00761"></a>00761 
<a name="l00762"></a>00762         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#ad8c7675fc46286f2824582d9c4cb8177">on_boundary</a>()) <span class="comment">// denotes *any* side has a NULL neighbor</span>
<a name="l00763"></a>00763           {
<a name="l00764"></a>00764             my_interface_elements.push_back(elem); <span class="comment">// add the element, but only once, even</span>
<a name="l00765"></a>00765                                                    <span class="comment">// if there are multiple NULL neighbors</span>
<a name="l00766"></a>00766             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l00767"></a>00767               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL)
<a name="l00768"></a>00768                 {
<a name="l00769"></a>00769                   <a class="code" href="classAutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Elem&gt;</a> side(elem-&gt;<a class="code" href="classElem.php#a554c146bcfb5537636bd77a157f21b85">build_side</a>(s));
<a name="l00770"></a>00770                   
<a name="l00771"></a>00771                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;side-&gt;n_vertices(); n++)
<a name="l00772"></a>00772                     my_interface_node_set.insert (side-&gt;node(n));   
<a name="l00773"></a>00773                 }
<a name="l00774"></a>00774           }
<a name="l00775"></a>00775       }
<a name="l00776"></a>00776 
<a name="l00777"></a>00777     my_interface_node_list.reserve (my_interface_node_set.size());
<a name="l00778"></a>00778     my_interface_node_list.insert  (my_interface_node_list.end(),
<a name="l00779"></a>00779                                     my_interface_node_set.begin(),
<a name="l00780"></a>00780                                     my_interface_node_set.end());
<a name="l00781"></a>00781   }
<a name="l00782"></a>00782   
<a name="l00783"></a>00783   <span class="keywordflow">if</span> (<span class="keyword">true</span>)
<a name="l00784"></a>00784     std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00785"></a>00785               &lt;&lt; <span class="stringliteral">&quot;mesh.n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>
<a name="l00786"></a>00786               &lt;&lt; <span class="stringliteral">&quot;my_interface_node_list.size()=&quot;</span> &lt;&lt; my_interface_node_list.size()
<a name="l00787"></a>00787               &lt;&lt; std::endl;
<a name="l00788"></a>00788   
<a name="l00789"></a>00789   <span class="comment">// we will now send my_interface_node_list to all of the adjacent processors.</span>
<a name="l00790"></a>00790   <span class="comment">// note that for the time being we will copy the list to a unique buffer for </span>
<a name="l00791"></a>00791   <span class="comment">// each processor so that we can use a nonblocking send and not access the</span>
<a name="l00792"></a>00792   <span class="comment">// buffer again until the send completes.  it is my understanding that the</span>
<a name="l00793"></a>00793   <span class="comment">// MPI 2.1 standard seeks to remove this restriction as unnecessary, so in</span>
<a name="l00794"></a>00794   <span class="comment">// the future we should change this to send the same buffer to each of the</span>
<a name="l00795"></a>00795   <span class="comment">// adjacent processors. - BSK 11/17/2008</span>
<a name="l00796"></a>00796   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; 
<a name="l00797"></a>00797     my_interface_node_xfer_buffers (n_adjacent_processors, my_interface_node_list);
<a name="l00798"></a>00798   std::vector&lt;Parallel::request&gt; my_interface_node_list_requests (n_adjacent_processors);
<a name="l00799"></a>00799   std::map&lt;unsigned int, unsigned int&gt; n_comm_steps;
<a name="l00800"></a>00800 
<a name="l00801"></a>00801   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;n_adjacent_processors; comm_step++)
<a name="l00802"></a>00802     {
<a name="l00803"></a>00803       n_comm_steps[adjacent_processors[comm_step]]=1;
<a name="l00804"></a>00804       Parallel::send (adjacent_processors[comm_step],
<a name="l00805"></a>00805                       my_interface_node_xfer_buffers[comm_step],
<a name="l00806"></a>00806                       my_interface_node_list_requests[comm_step],
<a name="l00807"></a>00807                       <span class="comment">/* tag = */</span> 314159);
<a name="l00808"></a>00808     }
<a name="l00809"></a>00809 
<a name="l00810"></a>00810   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00811"></a>00811   <span class="comment">// processor pairings are symmetric - I expect to receive an interface node</span>
<a name="l00812"></a>00812   <span class="comment">// list from each processor in adjacent_processors as well!</span>
<a name="l00813"></a>00813   <span class="comment">// now we will catch an incoming node list for each of our adjacent processors.</span>
<a name="l00814"></a>00814   <span class="comment">//</span>
<a name="l00815"></a>00815   <span class="comment">// we are done with the adjacent_processors list - note that it is in general</span>
<a name="l00816"></a>00816   <span class="comment">// a superset of the processors we truly share elements with.  so let&#39;s</span>
<a name="l00817"></a>00817   <span class="comment">// clear the superset list, and we will fill it with the true list.</span>
<a name="l00818"></a>00818   adjacent_processors.clear();
<a name="l00819"></a>00819   
<a name="l00820"></a>00820   std::vector&lt;unsigned int&gt; common_interface_node_list;
<a name="l00821"></a>00821 
<a name="l00822"></a>00822   <span class="comment">// send buffers.  we will fill these with data from the elements we own </span>
<a name="l00823"></a>00823   <span class="comment">// which share nodes with an adjacent processor.  we will slightly abuse </span>
<a name="l00824"></a>00824   <span class="comment">// the node_bcs_sent and element_bcs_sent buffers - we&#39;ll fill them and then tack</span>
<a name="l00825"></a>00825   <span class="comment">// them on to the end of the elements_sent buffer to reduce the message count.</span>
<a name="l00826"></a>00826   std::vector&lt;std::vector&lt;Node::PackedNode&gt; &gt; nodes_sent(n_adjacent_processors);
<a name="l00827"></a>00827   std::vector&lt;std::vector&lt;int&gt; &gt; elements_sent(n_adjacent_processors);
<a name="l00828"></a>00828   std::vector&lt;int&gt; node_bcs_sent, &amp;element_bcs_sent(node_bcs_sent);
<a name="l00829"></a>00829   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; element_neighbors_sent(n_adjacent_processors);
<a name="l00830"></a>00830     
<a name="l00831"></a>00831   std::vector&lt;Parallel::Request&gt; 
<a name="l00832"></a>00832     node_send_requests(n_adjacent_processors), 
<a name="l00833"></a>00833     element_send_requests(n_adjacent_processors),
<a name="l00834"></a>00834     element_neighbor_send_requests(n_adjacent_processors);
<a name="l00835"></a>00835 
<a name="l00836"></a>00836   <span class="comment">// receive buffers</span>
<a name="l00837"></a>00837   std::vector&lt;Node::PackedNode&gt; nodes_received;
<a name="l00838"></a>00838   std::vector&lt;int&gt; elements_received;
<a name="l00839"></a>00839   std::vector&lt;unsigned int&gt; element_neighbors_received;
<a name="l00840"></a>00840 
<a name="l00841"></a>00841   <span class="comment">// we expect two classess of messages - </span>
<a name="l00842"></a>00842   <span class="comment">// (1) incoming interface node lists, to which we will reply with our elements </span>
<a name="l00843"></a>00843   <span class="comment">//     touching nodes in the list, and</span>
<a name="l00844"></a>00844   <span class="comment">// (2) replies from the requests we sent off previously.  </span>
<a name="l00845"></a>00845   <span class="comment">//  (2.a) - nodes</span>
<a name="l00846"></a>00846   <span class="comment">//  (2.b) - element connectivity &amp; bc info</span>
<a name="l00847"></a>00847   <span class="comment">// so we expect 3 communications from each adjacent processor.</span>
<a name="l00848"></a>00848   <span class="comment">// by structuring the communication in this way we hopefully impose no </span>
<a name="l00849"></a>00849   <span class="comment">// order on the handling of the arriving messages.  in particular, we</span>
<a name="l00850"></a>00850   <span class="comment">// should be able to handle the case where we receive a request and</span>
<a name="l00851"></a>00851   <span class="comment">// all replies from processor A before even receiving a request from</span>
<a name="l00852"></a>00852   <span class="comment">// processor B.</span>
<a name="l00853"></a>00853   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00854"></a>00854     n_node_replies_sent=0, n_node_replies_received=0, 
<a name="l00855"></a>00855     n_elem_replies_sent=0, n_elem_replies_received=0;
<a name="l00856"></a>00856 
<a name="l00857"></a>00857   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;3*n_adjacent_processors; comm_step++)
<a name="l00858"></a>00858     {
<a name="l00859"></a>00859       <span class="comment">//------------------------------------------------------------------</span>
<a name="l00860"></a>00860       <span class="comment">// catch tag = ~100,000pi</span>
<a name="l00861"></a>00861       Parallel::Status
<a name="l00862"></a>00862         status(Parallel::probe (Parallel::any_source,
<a name="l00863"></a>00863                                 <span class="comment">/* tag = */</span> 314159));      
<a name="l00864"></a>00864       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00865"></a>00865         source_pid_idx = status.source(),
<a name="l00866"></a>00866         dest_pid_idx   = source_pid_idx;
<a name="l00867"></a>00867 
<a name="l00868"></a>00868       <span class="comment">//------------------------------------------------------------------</span>
<a name="l00869"></a>00869       <span class="comment">// first time - incoming request</span>
<a name="l00870"></a>00870       <span class="keywordflow">if</span> (n_comm_steps[source_pid_idx] == 1)
<a name="l00871"></a>00871         {
<a name="l00872"></a>00872           n_comm_steps[source_pid_idx]++;
<a name="l00873"></a>00873           
<a name="l00874"></a>00874           Parallel::receive (source_pid_idx,
<a name="l00875"></a>00875                              common_interface_node_list,
<a name="l00876"></a>00876                              <span class="comment">/* tag = */</span> 314159);
<a name="l00877"></a>00877           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>    
<a name="l00878"></a>00878             their_interface_node_list_size = common_interface_node_list.size();
<a name="l00879"></a>00879           
<a name="l00880"></a>00880           <span class="comment">// we now have the interface node list from processor source_pid_idx.</span>
<a name="l00881"></a>00881           <span class="comment">// now we can find all of our elements which touch any of these nodes</span>
<a name="l00882"></a>00882           <span class="comment">// and send copies back to this processor.  however, we can make our</span>
<a name="l00883"></a>00883           <span class="comment">// search more efficient by first excluding all the nodes in</span>
<a name="l00884"></a>00884           <span class="comment">// their list which are not also contained in</span>
<a name="l00885"></a>00885           <span class="comment">// my_interface_node_list.  we can do this in place as a set</span>
<a name="l00886"></a>00886           <span class="comment">// intersection.</span>
<a name="l00887"></a>00887           common_interface_node_list.erase
<a name="l00888"></a>00888             (std::set_intersection (my_interface_node_list.begin(),
<a name="l00889"></a>00889                                     my_interface_node_list.end(),
<a name="l00890"></a>00890                                     common_interface_node_list.begin(),
<a name="l00891"></a>00891                                     common_interface_node_list.end(),
<a name="l00892"></a>00892                                     common_interface_node_list.begin()),
<a name="l00893"></a>00893              common_interface_node_list.end());
<a name="l00894"></a>00894           
<a name="l00895"></a>00895           <span class="keywordflow">if</span> (<span class="keyword">true</span>)
<a name="l00896"></a>00896             std::cout &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00897"></a>00897                       &lt;&lt; <span class="stringliteral">&quot;my_interface_node_list.size()=&quot;</span>       &lt;&lt; my_interface_node_list.size()
<a name="l00898"></a>00898                       &lt;&lt; <span class="stringliteral">&quot;, [&quot;</span> &lt;&lt; source_pid_idx &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00899"></a>00899                       &lt;&lt; <span class="stringliteral">&quot;their_interface_node_list.size()=&quot;</span>    &lt;&lt; their_interface_node_list_size
<a name="l00900"></a>00900                       &lt;&lt; <span class="stringliteral">&quot;, common_interface_node_list.size()=&quot;</span> &lt;&lt; common_interface_node_list.size()
<a name="l00901"></a>00901                       &lt;&lt; std::endl;
<a name="l00902"></a>00902           
<a name="l00903"></a>00903           <span class="comment">// Check for quick return?</span>
<a name="l00904"></a>00904           <span class="keywordflow">if</span> (common_interface_node_list.empty())
<a name="l00905"></a>00905             {
<a name="l00906"></a>00906               <span class="comment">// let&#39;s try to be smart here - if we have no nodes in common,</span>
<a name="l00907"></a>00907               <span class="comment">// we cannot share elements.  so post the messages expected</span>
<a name="l00908"></a>00908               <span class="comment">// from us here and go on about our business.  </span>
<a name="l00909"></a>00909               <span class="comment">// note that even though these are nonblocking sends</span>
<a name="l00910"></a>00910               <span class="comment">// they should complete essentially instantly, because</span>
<a name="l00911"></a>00911               <span class="comment">// in all cases the send buffers are empty</span>
<a name="l00912"></a>00912               Parallel::send (dest_pid_idx,
<a name="l00913"></a>00913                               nodes_sent[n_node_replies_sent],
<a name="l00914"></a>00914                               packed_node_datatype,
<a name="l00915"></a>00915                               node_send_requests[n_node_replies_sent],
<a name="l00916"></a>00916                               <span class="comment">/* tag = */</span> 314159);
<a name="l00917"></a>00917               n_node_replies_sent++;
<a name="l00918"></a>00918 
<a name="l00919"></a>00919               Parallel::send (dest_pid_idx,
<a name="l00920"></a>00920                               elements_sent[n_elem_replies_sent],
<a name="l00921"></a>00921                               element_send_requests[n_elem_replies_sent],
<a name="l00922"></a>00922                               <span class="comment">/* tag = */</span> 314159);
<a name="l00923"></a>00923 
<a name="l00924"></a>00924               Parallel::send (dest_pid_idx,
<a name="l00925"></a>00925                               element_neighbors_sent[n_elem_replies_sent],
<a name="l00926"></a>00926                               element_neighbor_send_requests[n_elem_replies_sent],
<a name="l00927"></a>00927                               <span class="comment">/* tag = */</span> 314159*2);
<a name="l00928"></a>00928               n_elem_replies_sent++;
<a name="l00929"></a>00929 
<a name="l00930"></a>00930               <span class="keywordflow">continue</span>;
<a name="l00931"></a>00931             }
<a name="l00932"></a>00932           <span class="comment">// otherwise, this really *is* an adjacent processor.</span>
<a name="l00933"></a>00933           adjacent_processors.push_back(source_pid_idx);
<a name="l00934"></a>00934 
<a name="l00935"></a>00935           <span class="comment">// Now we need to see which of our elements touch the nodes in the list.</span>
<a name="l00936"></a>00936           <span class="comment">// We built a reduced element list above, and we know the pointers are</span>
<a name="l00937"></a>00937           <span class="comment">// not NULL.</span>
<a name="l00938"></a>00938           <span class="comment">// We will certainly send all the active elements which intersect source_pid_idx,</span>
<a name="l00939"></a>00939           <span class="comment">// but we will also ship off the other elements in the same family tree</span>
<a name="l00940"></a>00940           <span class="comment">// as the active ones for data structure consistency.  We also</span>
<a name="l00941"></a>00941           <span class="comment">// ship any nodes connected to these elements.  Note some of these nodes</span>
<a name="l00942"></a>00942           <span class="comment">// and elements may be replicated from other processors, but that is OK.</span>
<a name="l00943"></a>00943           std::set&lt;const Elem*, CompareElemIdsByLevel&gt; elements_to_send;
<a name="l00944"></a>00944           std::set&lt;const Node*&gt; connected_nodes;
<a name="l00945"></a>00945           std::vector&lt;const Elem*&gt; family_tree;
<a name="l00946"></a>00946           
<a name="l00947"></a>00947           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0, n_shared_nodes=0; e&lt;my_interface_elements.size(); e++, n_shared_nodes=0)
<a name="l00948"></a>00948             {
<a name="l00949"></a>00949               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> * elem = my_interface_elements[e];
<a name="l00950"></a>00950               
<a name="l00951"></a>00951               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a6bbe1895127c069722e36ee4e2a8a6e1">n_vertices</a>(); n++)
<a name="l00952"></a>00952                 <span class="keywordflow">if</span> (std::binary_search (common_interface_node_list.begin(),
<a name="l00953"></a>00953                                         common_interface_node_list.end(),
<a name="l00954"></a>00954                                         elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)))
<a name="l00955"></a>00955                   { 
<a name="l00956"></a>00956                     n_shared_nodes++;
<a name="l00957"></a>00957                     
<a name="l00958"></a>00958                     <span class="comment">// TBD - how many nodes do we need to share </span>
<a name="l00959"></a>00959                     <span class="comment">// before we care?  certainly 2, but 1?  not </span>
<a name="l00960"></a>00960                     <span class="comment">// sure, so let&#39;s play it safe...</span>
<a name="l00961"></a>00961                     <span class="keywordflow">if</span> (n_shared_nodes &gt; 0) <span class="keywordflow">break</span>;
<a name="l00962"></a>00962                   }
<a name="l00963"></a>00963               
<a name="l00964"></a>00964               <span class="keywordflow">if</span> (n_shared_nodes) <span class="comment">// share at least one node?</span>
<a name="l00965"></a>00965                 {
<a name="l00966"></a>00966                   elem = elem-&gt;<a class="code" href="classElem.php#a6bc01ad4901efb64eb4f584ed5e1bd0b">top_parent</a>();
<a name="l00967"></a>00967                   
<a name="l00968"></a>00968                   <span class="comment">// avoid a lot of duplicated effort -- if we already have elem</span>
<a name="l00969"></a>00969                   <span class="comment">// in the set its entire family tree is already in the set.</span>
<a name="l00970"></a>00970                   <span class="keywordflow">if</span> (!elements_to_send.count(elem))
<a name="l00971"></a>00971                     {
<a name="l00972"></a>00972 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00973"></a>00973 <span class="preprocessor"></span>                      elem-&gt;<a class="code" href="classElem.php#abafd34cacabfdf831cc86e781c211fa1">family_tree</a>(family_tree);
<a name="l00974"></a>00974 <span class="preprocessor">#else</span>
<a name="l00975"></a>00975 <span class="preprocessor"></span>                      family_tree.clear();
<a name="l00976"></a>00976                       family_tree.push_back(elem);
<a name="l00977"></a>00977 <span class="preprocessor">#endif</span>
<a name="l00978"></a>00978 <span class="preprocessor"></span>                      <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> leaf=0; leaf&lt;family_tree.size(); leaf++)
<a name="l00979"></a>00979                         {
<a name="l00980"></a>00980                           elem = family_tree[leaf];
<a name="l00981"></a>00981                           elements_to_send.insert (elem);
<a name="l00982"></a>00982                           
<a name="l00983"></a>00983                           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); n++)
<a name="l00984"></a>00984                             connected_nodes.insert (elem-&gt;<a class="code" href="classElem.php#a68359ea98eafc947ea5af014bdea03fb">get_node</a>(n));           
<a name="l00985"></a>00985                         }                   
<a name="l00986"></a>00986                     }
<a name="l00987"></a>00987                 }
<a name="l00988"></a>00988             }
<a name="l00989"></a>00989           
<a name="l00990"></a>00990           <span class="comment">// The elements_to_send and connected_nodes sets now contain all</span>
<a name="l00991"></a>00991           <span class="comment">// the elements and nodes we need to send to this processor.</span>
<a name="l00992"></a>00992           <span class="comment">// All that remains is to pack up the objects (along with</span>
<a name="l00993"></a>00993           <span class="comment">// any boundary conditions) and send the messages off.</span>
<a name="l00994"></a>00994           {
<a name="l00995"></a>00995             <span class="keywordflow">if</span> (elements_to_send.empty()) libmesh_assert (connected_nodes.empty());
<a name="l00996"></a>00996             <span class="keywordflow">if</span> (connected_nodes.empty())  libmesh_assert (elements_to_send.empty());
<a name="l00997"></a>00997             
<a name="l00998"></a>00998             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_nodes_sent = connected_nodes.size();
<a name="l00999"></a>00999             nodes_sent[n_node_replies_sent].reserve (n_nodes_sent);
<a name="l01000"></a>01000             node_bcs_sent.clear();
<a name="l01001"></a>01001         
<a name="l01002"></a>01002             <span class="keywordflow">for</span> (std::set&lt;const Node*&gt;::const_iterator node_it = connected_nodes.begin();
<a name="l01003"></a>01003                  node_it != connected_nodes.end(); ++node_it)
<a name="l01004"></a>01004               {
<a name="l01005"></a>01005                 nodes_sent[n_node_replies_sent].push_back (<a class="code" href="structNode_1_1PackedNode.php">Node::PackedNode</a>(**node_it));
<a name="l01006"></a>01006                 
<a name="l01007"></a>01007                 <span class="comment">// add the node if it has BCs</span>
<a name="l01008"></a>01008                 std::vector&lt;short int&gt; bcs = mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;boundary_ids(*node_it);
<a name="l01009"></a>01009                 
<a name="l01010"></a>01010                 <span class="keywordflow">if</span> (!bcs.empty())
<a name="l01011"></a>01011                   {
<a name="l01012"></a>01012                     node_bcs_sent.push_back((*node_it)-&gt;id());
<a name="l01013"></a>01013                     node_bcs_sent.push_back(bcs.size());
<a name="l01014"></a>01014                     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc_it=0; bc_it &lt; bcs.size(); bc_it++)
<a name="l01015"></a>01015                       node_bcs_sent.push_back(bcs[bc_it]);
<a name="l01016"></a>01016                   }
<a name="l01017"></a>01017               }
<a name="l01018"></a>01018             connected_nodes.clear();
<a name="l01019"></a>01019         
<a name="l01020"></a>01020             <span class="comment">// send the nodes off to the destination processor</span>
<a name="l01021"></a>01021             Parallel::send (dest_pid_idx,
<a name="l01022"></a>01022                             nodes_sent[n_node_replies_sent],
<a name="l01023"></a>01023                             packed_node_datatype,
<a name="l01024"></a>01024                             node_send_requests[n_node_replies_sent],
<a name="l01025"></a>01025                             <span class="comment">/* tag = */</span> 314159);
<a name="l01026"></a>01026             n_node_replies_sent++;
<a name="l01027"></a>01027         
<a name="l01028"></a>01028             <span class="comment">// let&#39;s pack the node bc data in the front of the element</span>
<a name="l01029"></a>01029             <span class="comment">// connectivity buffer</span>
<a name="l01030"></a>01030             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01031"></a>01031               n_node_bcs_sent = node_bcs_sent.size();
<a name="l01032"></a>01032             
<a name="l01033"></a>01033             elements_sent[n_elem_replies_sent].clear();
<a name="l01034"></a>01034             elements_sent[n_elem_replies_sent].insert (elements_sent[n_elem_replies_sent].end(),
<a name="l01035"></a>01035                                                        node_bcs_sent.begin(),
<a name="l01036"></a>01036                                                        node_bcs_sent.end());
<a name="l01037"></a>01037         
<a name="l01038"></a>01038             <span class="comment">// this is really just a reference to node_bcs_sent,</span>
<a name="l01039"></a>01039             <span class="comment">// so be careful not to clear it before packing the</span>
<a name="l01040"></a>01040             <span class="comment">// node_bcs_sent into the elements_sent buffer!!</span>
<a name="l01041"></a>01041             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elements_sent = elements_to_send.size();
<a name="l01042"></a>01042             element_neighbors_sent[n_elem_replies_sent].reserve(2*n_elements_sent+1);
<a name="l01043"></a>01043             element_bcs_sent.clear(); 
<a name="l01044"></a>01044             
<a name="l01045"></a>01045             <span class="keywordflow">for</span> (std::set&lt;const Elem*, CompareElemIdsByLevel&gt;::const_iterator 
<a name="l01046"></a>01046                    elem_it = elements_to_send.begin(); elem_it != elements_to_send.<a class="code" href="classvariant__filter__iterator.php#a79bde51f62b20c1c11836ee498eff219">end</a>(); ++elem_it)
<a name="l01047"></a>01047               {
<a name="l01048"></a>01048                 Elem::PackedElem::pack (elements_sent[n_elem_replies_sent], *elem_it);
<a name="l01049"></a>01049                 
<a name="l01050"></a>01050                 <span class="comment">// let&#39;s put the element index in the element_neighbors_sent</span>
<a name="l01051"></a>01051                 <span class="comment">// buffer - we will later overwrite it with a bitmask of the</span>
<a name="l01052"></a>01052                 <span class="comment">// element neighbor information to send out.  this will be used </span>
<a name="l01053"></a>01053                 <span class="comment">// to create RemoteElems where appropriate.</span>
<a name="l01054"></a>01054                 element_neighbors_sent[n_elem_replies_sent].push_back((*elem_it)-&gt;id());
<a name="l01055"></a>01055                 element_neighbors_sent[n_elem_replies_sent].push_back(0);
<a name="l01056"></a>01056                 
<a name="l01057"></a>01057                 <span class="comment">// if this is a level-0 element look for boundary conditions</span>
<a name="l01058"></a>01058                 <span class="keywordflow">if</span> ((*elem_it)-&gt;level() == 0)
<a name="l01059"></a>01059                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;(*elem_it)-&gt;n_sides(); s++)
<a name="l01060"></a>01060                     <span class="keywordflow">if</span> ((*elem_it)-&gt;neighbor(s) == NULL)
<a name="l01061"></a>01061                       <span class="keywordflow">if</span> (mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;boundary_id (*elem_it, s) !=
<a name="l01062"></a>01062                           mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;invalid_id)
<a name="l01063"></a>01063                         {
<a name="l01064"></a>01064                           element_bcs_sent.push_back ((*elem_it)-&gt;id());
<a name="l01065"></a>01065                           element_bcs_sent.push_back (s);
<a name="l01066"></a>01066                           element_bcs_sent.push_back (mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;boundary_id (*elem_it, s));
<a name="l01067"></a>01067                         }
<a name="l01068"></a>01068               }
<a name="l01069"></a>01069             element_neighbors_sent[n_elem_replies_sent].push_back (dest_pid_idx);
<a name="l01070"></a>01070             elements_to_send.clear();
<a name="l01071"></a>01071             
<a name="l01072"></a>01072             <span class="comment">// let&#39;s pack the node bc data in the front of the element</span>
<a name="l01073"></a>01073             <span class="comment">// connectivity buffer</span>
<a name="l01074"></a>01074             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01075"></a>01075               n_elem_bcs_sent = element_bcs_sent.size() / 3;
<a name="l01076"></a>01076             
<a name="l01077"></a>01077             elements_sent[n_elem_replies_sent].insert (elements_sent[n_elem_replies_sent].end(),
<a name="l01078"></a>01078                                                        element_bcs_sent.begin(),
<a name="l01079"></a>01079                                                        element_bcs_sent.end());
<a name="l01080"></a>01080             
<a name="l01081"></a>01081             <span class="comment">// only append to the message if it is not empty</span>
<a name="l01082"></a>01082             <span class="keywordflow">if</span> (!elements_sent[n_elem_replies_sent].empty())
<a name="l01083"></a>01083               {
<a name="l01084"></a>01084                 <span class="comment">// let&#39;s tack three ints on to</span>
<a name="l01085"></a>01085                 <span class="comment">// the end of the elements_sent</span>
<a name="l01086"></a>01086                 <span class="comment">// buffer for use on the receiving end</span>
<a name="l01087"></a>01087                 elements_sent[n_elem_replies_sent].push_back (n_elements_sent);
<a name="l01088"></a>01088                 elements_sent[n_elem_replies_sent].push_back (n_elem_bcs_sent);
<a name="l01089"></a>01089                 elements_sent[n_elem_replies_sent].push_back (n_node_bcs_sent);
<a name="l01090"></a>01090               }
<a name="l01091"></a>01091             
<a name="l01092"></a>01092             <span class="comment">// send the elements off to the destination processor</span>
<a name="l01093"></a>01093             Parallel::send (dest_pid_idx,
<a name="l01094"></a>01094                             elements_sent[n_elem_replies_sent],
<a name="l01095"></a>01095                             element_send_requests[n_elem_replies_sent],
<a name="l01096"></a>01096                             <span class="comment">/* tag = */</span> 314159);
<a name="l01097"></a>01097             n_elem_replies_sent++;
<a name="l01098"></a>01098           }
<a name="l01099"></a>01099         }
<a name="l01100"></a>01100 
<a name="l01101"></a>01101 
<a name="l01102"></a>01102 
<a name="l01103"></a>01103       <span class="comment">//------------------------------------------------------------------</span>
<a name="l01104"></a>01104       <span class="comment">// second time - reply of nodes</span>
<a name="l01105"></a>01105       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (n_comm_steps[source_pid_idx] == 2)
<a name="l01106"></a>01106         {
<a name="l01107"></a>01107           n_comm_steps[source_pid_idx]++;
<a name="l01108"></a>01108         
<a name="l01109"></a>01109           Parallel::receive (source_pid_idx,
<a name="l01110"></a>01110                              nodes_received,
<a name="l01111"></a>01111                              packed_node_datatype,
<a name="l01112"></a>01112                              <span class="comment">/* tag = */</span> 314159);
<a name="l01113"></a>01113           n_node_replies_received++;
<a name="l01114"></a>01114           
<a name="l01115"></a>01115           <span class="comment">// add the nodes we just received</span>
<a name="l01116"></a>01116           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nodes_received.size(); n++)
<a name="l01117"></a>01117             mesh.<a class="code" href="classParallelMesh.php#ae5a2ef7ac888ae42fe08bb9716664795">insert_node</a> (nodes_received[n].build_node().release());
<a name="l01118"></a>01118         }
<a name="l01119"></a>01119 
<a name="l01120"></a>01120 
<a name="l01121"></a>01121 
<a name="l01122"></a>01122       <span class="comment">//------------------------------------------------------------------</span>
<a name="l01123"></a>01123       <span class="comment">// third time - elements &amp; bcs</span>
<a name="l01124"></a>01124       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (n_comm_steps[source_pid_idx] == 3)
<a name="l01125"></a>01125         { 
<a name="l01126"></a>01126           n_comm_steps[source_pid_idx]++;
<a name="l01127"></a>01127 
<a name="l01128"></a>01128           Parallel::receive (source_pid_idx,
<a name="l01129"></a>01129                              elements_received,
<a name="l01130"></a>01130                              <span class="comment">/* tag = */</span> 314159);         
<a name="l01131"></a>01131           n_elem_replies_received++;
<a name="l01132"></a>01132           
<a name="l01133"></a>01133           <span class="keywordflow">if</span> (elements_received.empty())
<a name="l01134"></a>01134             <span class="keywordflow">continue</span>;
<a name="l01135"></a>01135           
<a name="l01136"></a>01136           libmesh_assert (elements_received.size() &gt; 3);
<a name="l01137"></a>01137           
<a name="l01139"></a>01139           <span class="comment">// remember: elements_sent = </span>
<a name="l01140"></a>01140           <span class="comment">//          { [node bd data] [element conntectivity] [element bc data] # # # }</span>
<a name="l01142"></a>01142 <span class="comment"></span>          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_node_bcs_received = elements_received.back(); elements_received.pop_back();
<a name="l01143"></a>01143           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_bcs_received = elements_received.back(); elements_received.pop_back();
<a name="l01144"></a>01144           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elements_received = elements_received.back(); elements_received.pop_back();
<a name="l01145"></a>01145           
<a name="l01146"></a>01146           <span class="comment">// counter into the bc/element connectivty buffer</span>
<a name="l01147"></a>01147           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01148"></a>01148           
<a name="l01149"></a>01149           <span class="comment">// add any node bcs</span>
<a name="l01150"></a>01150           <span class="keywordflow">while</span> (cnt &lt; n_node_bcs_received)
<a name="l01151"></a>01151             {
<a name="l01152"></a>01152               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = elements_received[cnt++];
<a name="l01153"></a>01153               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_bcs = elements_received[cnt++];
<a name="l01154"></a>01154 
<a name="l01155"></a>01155               libmesh_assert (mesh.<a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a>(node_id));
<a name="l01156"></a>01156             
<a name="l01157"></a>01157               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc_it=0; bc_it &lt; num_bcs; bc_it++)
<a name="l01158"></a>01158                 mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_node (mesh.<a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a>(node_id), elements_received[cnt++]);
<a name="l01159"></a>01159             }
<a name="l01160"></a>01160       
<a name="l01161"></a>01161           <span class="comment">// add the elements we just received</span>
<a name="l01162"></a>01162           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;n_elements_received; e++)
<a name="l01163"></a>01163             {
<a name="l01164"></a>01164               <span class="comment">// Unpack the element </span>
<a name="l01165"></a>01165               Elem::PackedElem packed_elem (elements_received.begin()+cnt);
<a name="l01166"></a>01166           
<a name="l01167"></a>01167               <span class="comment">// The ParallelMesh::elem(i) member will return NULL if the element</span>
<a name="l01168"></a>01168               <span class="comment">// is not in the mesh.  We rely on that here, so it better not change!</span>
<a name="l01169"></a>01169               <a class="code" href="classElem.php">Elem</a> *elem = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(packed_elem.id());
<a name="l01170"></a>01170           
<a name="l01171"></a>01171               <span class="comment">// if we already have this element, make sure its properties match</span>
<a name="l01172"></a>01172               <span class="comment">// but then go on</span>
<a name="l01173"></a>01173               <span class="keywordflow">if</span> (elem)
<a name="l01174"></a>01174                 {
<a name="l01175"></a>01175                   libmesh_assert (elem-&gt;level()             == packed_elem.level());
<a name="l01176"></a>01176                   libmesh_assert (elem-&gt;id()                == packed_elem.id());
<a name="l01177"></a>01177                   libmesh_assert (elem-&gt;processor_id()      == packed_elem.processor_id());
<a name="l01178"></a>01178                   libmesh_assert (elem-&gt;subdomain_id()      == packed_elem.subdomain_id());
<a name="l01179"></a>01179                   libmesh_assert (elem-&gt;type()              == packed_elem.type());
<a name="l01180"></a>01180 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01181"></a>01181 <span class="preprocessor"></span>                  libmesh_assert (elem-&gt;p_level()           == packed_elem.p_level());
<a name="l01182"></a>01182                   libmesh_assert (elem-&gt;refinement_flag()   == packed_elem.refinement_flag());
<a name="l01183"></a>01183                   libmesh_assert (elem-&gt;p_refinement_flag() == packed_elem.p_refinement_flag());
<a name="l01184"></a>01184                   
<a name="l01185"></a>01185                   <span class="keywordflow">if</span> (elem-&gt;level() &gt; 0)
<a name="l01186"></a>01186                     {
<a name="l01187"></a>01187                       libmesh_assert (elem-&gt;parent()-&gt;id() == <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(packed_elem.parent_id()));
<a name="l01188"></a>01188                       libmesh_assert (elem-&gt;parent()-&gt;child(packed_elem.which_child_am_i()) == elem);
<a name="l01189"></a>01189                     }         
<a name="l01190"></a>01190 <span class="preprocessor">#endif</span>
<a name="l01191"></a>01191 <span class="preprocessor"></span>                  libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l01192"></a>01192                 }
<a name="l01193"></a>01193               <span class="keywordflow">else</span>
<a name="l01194"></a>01194                 {
<a name="l01195"></a>01195                   <span class="comment">// We need to add the element.</span>
<a name="l01196"></a>01196 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01197"></a>01197 <span class="preprocessor"></span>                  <span class="comment">// maybe find the parent</span>
<a name="l01198"></a>01198                   <span class="keywordflow">if</span> (packed_elem.level() &gt; 0)
<a name="l01199"></a>01199                     {
<a name="l01200"></a>01200                       <a class="code" href="classElem.php">Elem</a> *parent = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(packed_elem.parent_id());
<a name="l01201"></a>01201                       
<a name="l01202"></a>01202                       <span class="comment">// Note that we were very careful to construct the send connectivity</span>
<a name="l01203"></a>01203                       <span class="comment">// so that parents are encountered before children.  So if we get here</span>
<a name="l01204"></a>01204                       <span class="comment">// and can&#39;t find the parent that is a fatal error.</span>
<a name="l01205"></a>01205                       <span class="keywordflow">if</span> (parent == NULL)
<a name="l01206"></a>01206                         {
<a name="l01207"></a>01207                           std::cerr &lt;&lt; <span class="stringliteral">&quot;Parent element with ID &quot;</span> &lt;&lt; packed_elem.parent_id()
<a name="l01208"></a>01208                                     &lt;&lt; <span class="stringliteral">&quot; not found.&quot;</span> &lt;&lt; std::endl; 
<a name="l01209"></a>01209                           libmesh_error();
<a name="l01210"></a>01210                         }
<a name="l01211"></a>01211                       
<a name="l01212"></a>01212                       elem = packed_elem.unpack (mesh, parent);
<a name="l01213"></a>01213                     }
<a name="l01214"></a>01214                   <span class="keywordflow">else</span>
<a name="l01215"></a>01215                     {
<a name="l01216"></a>01216                       libmesh_assert (packed_elem.parent_id() == -1);
<a name="l01217"></a>01217                       elem = packed_elem.unpack (mesh);
<a name="l01218"></a>01218                     }
<a name="l01219"></a>01219 <span class="preprocessor">#else // !defined(LIBMESH_ENABLE_AMR)</span>
<a name="l01220"></a>01220 <span class="preprocessor"></span>                  elem = packed_elem.unpack (mesh);
<a name="l01221"></a>01221 <span class="preprocessor">#endif          </span>
<a name="l01222"></a>01222 <span class="preprocessor"></span>                  <span class="comment">// Good to go.  Add to the mesh.</span>
<a name="l01223"></a>01223                   libmesh_assert (elem);
<a name="l01224"></a>01224                   libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l01225"></a>01225                   mesh.<a class="code" href="classParallelMesh.php#aadf11922b8147ddc3680d9a7da5d4447">insert_elem</a>(elem);
<a name="l01226"></a>01226                 }
<a name="l01227"></a>01227           
<a name="l01228"></a>01228               <span class="comment">// properly position cnt for the next element </span>
<a name="l01229"></a>01229               cnt += Elem::PackedElem::header_size + packed_elem.<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();           
<a name="l01230"></a>01230             } <span class="comment">// done adding elements</span>
<a name="l01231"></a>01231       
<a name="l01232"></a>01232           <span class="comment">// add any element bcs</span>
<a name="l01233"></a>01233           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_bcs=0;
<a name="l01234"></a>01234           <span class="keywordflow">while</span> (cnt &lt; elements_received.size())
<a name="l01235"></a>01235             {
<a name="l01236"></a>01236               n_elem_bcs++;
<a name="l01237"></a>01237               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_id = elements_received[cnt++];
<a name="l01238"></a>01238               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side    = elements_received[cnt++];
<a name="l01239"></a>01239               <span class="keyword">const</span> <span class="keywordtype">int</span> bc_id            = elements_received[cnt++];
<a name="l01240"></a>01240               
<a name="l01241"></a>01241               libmesh_assert (mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(elem_id));
<a name="l01242"></a>01242               mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;add_side (mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(elem_id), side, bc_id);
<a name="l01243"></a>01243             }
<a name="l01244"></a>01244           libmesh_assert (n_elem_bcs_received == n_elem_bcs);
<a name="l01245"></a>01245         }
<a name="l01246"></a>01246 
<a name="l01247"></a>01247       <span class="comment">// Huh?</span>
<a name="l01248"></a>01248       <span class="keywordflow">else</span>
<a name="l01249"></a>01249         {
<a name="l01250"></a>01250           std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR:  unexpected number of replies: &quot;</span>
<a name="l01251"></a>01251                     &lt;&lt; n_comm_steps[source_pid_idx]
<a name="l01252"></a>01252                     &lt;&lt; std::endl;
<a name="l01253"></a>01253         }
<a name="l01254"></a>01254     } <span class="comment">// done catching &amp; processing replies associated with tag ~ 100,000pi</span>
<a name="l01255"></a>01255   
<a name="l01256"></a>01256   <span class="comment">// Update neighbor information with the new elements,</span>
<a name="l01257"></a>01257   <span class="comment">// but don&#39;t throw away old information.</span>
<a name="l01258"></a>01258   mesh.<a class="code" href="classUnstructuredMesh.php#a98c765606a6c53e090c2595b739201ff">find_neighbors</a> (<span class="comment">/* reset_remote_elements = */</span> <span class="keyword">true</span>,
<a name="l01259"></a>01259                        <span class="comment">/* reset_current_list    = */</span> <span class="keyword">false</span>);    
<a name="l01260"></a>01260   
<a name="l01261"></a>01261   <span class="comment">// OK, now at least all local elements should have a full set</span>
<a name="l01262"></a>01262   <span class="comment">// of neighbor information.  we still need to resolve remote</span>
<a name="l01263"></a>01263   <span class="comment">// element neighbor information though. to do this, we need</span>
<a name="l01264"></a>01264   <span class="comment">// to get the neighbor information from the processors that</span>
<a name="l01265"></a>01265   <span class="comment">// sent elements to us.</span>
<a name="l01266"></a>01266   <span class="comment">// </span>
<a name="l01267"></a>01267   <span class="comment">// first, send element face information to requisite processors</span>
<a name="l01268"></a>01268   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;n_adjacent_processors; comm_step++)
<a name="l01269"></a>01269     <span class="keywordflow">if</span> (!element_neighbors_sent[comm_step].empty()) <span class="comment">// if it is empty we already sent it!</span>
<a name="l01270"></a>01270       {
<a name="l01271"></a>01271         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_pid_idx = 
<a name="l01272"></a>01272           element_neighbors_sent[comm_step].back();
<a name="l01273"></a>01273         element_neighbors_sent[comm_step].pop_back();
<a name="l01274"></a>01274         
<a name="l01275"></a>01275         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pos=0; pos&lt;element_neighbors_sent[comm_step].size(); pos+=2)
<a name="l01276"></a>01276           {
<a name="l01277"></a>01277             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_global_idx = element_neighbors_sent[comm_step][pos+0];
<a name="l01278"></a>01278             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(elem_global_idx);
<a name="l01279"></a>01279             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> face_neighbor_bitmask = 0;
<a name="l01280"></a>01280             
<a name="l01281"></a>01281             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l01282"></a>01282               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) != NULL)
<a name="l01283"></a>01283                 face_neighbor_bitmask |= FaceNeighborMask[s];
<a name="l01284"></a>01284             
<a name="l01285"></a>01285             element_neighbors_sent[comm_step][pos+1] = face_neighbor_bitmask;
<a name="l01286"></a>01286           }
<a name="l01287"></a>01287       
<a name="l01288"></a>01288         Parallel::send (dest_pid_idx,
<a name="l01289"></a>01289                         element_neighbors_sent[comm_step],
<a name="l01290"></a>01290                         element_neighbor_send_requests[comm_step],
<a name="l01291"></a>01291                         <span class="comment">/* tag = */</span> 314159*2);
<a name="l01292"></a>01292       } <span class="comment">// done sending neighbor information</span>
<a name="l01293"></a>01293 
<a name="l01294"></a>01294   <span class="comment">// second, receive and process all face neighbor information</span>
<a name="l01295"></a>01295   <span class="comment">// from the processors which sent us elements</span>
<a name="l01296"></a>01296   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;n_elem_replies_received; comm_step++)
<a name="l01297"></a>01297     {
<a name="l01298"></a>01298       Parallel::receive (Parallel::any_source,
<a name="l01299"></a>01299                          element_neighbors_received,
<a name="l01300"></a>01300                          <span class="comment">/* tag = */</span> 314159*2);
<a name="l01301"></a>01301 
<a name="l01302"></a>01302       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pos=0; pos&lt;element_neighbors_received.size(); pos+=2)
<a name="l01303"></a>01303         {
<a name="l01304"></a>01304           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l01305"></a>01305             elem_global_idx       = element_neighbors_received[pos+0],
<a name="l01306"></a>01306             face_neighbor_bitmask = element_neighbors_received[pos+1];
<a name="l01307"></a>01307 
<a name="l01308"></a>01308           <a class="code" href="classElem.php">Elem</a> *elem = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(elem_global_idx);
<a name="l01309"></a>01309 
<a name="l01310"></a>01310           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); s++)
<a name="l01311"></a>01311             <span class="keywordflow">if</span> ((face_neighbor_bitmask &amp; FaceNeighborMask[s]) <span class="comment">// if there is a face neighbor...</span>
<a name="l01312"></a>01312                 &amp;&amp; (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(s) == NULL))               <span class="comment">// ...and we do not have it</span>
<a name="l01313"></a>01313               elem-&gt;<a class="code" href="classElem.php#a88d676b002db35d70e0915d10c606f7f">set_neighbor</a>(s,const_cast&lt;RemoteElem*&gt;(<a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)); <span class="comment">// then it is a remote element</span>
<a name="l01314"></a>01314         }      
<a name="l01315"></a>01315     } <span class="comment">// done catching &amp; processing neighbor information</span>
<a name="l01316"></a>01316 
<a name="l01317"></a>01317   <span class="comment">// allow any pending requests to complete</span>
<a name="l01318"></a>01318   Parallel::wait (my_interface_node_list_requests);
<a name="l01319"></a>01319   Parallel::wait (node_send_requests);
<a name="l01320"></a>01320   Parallel::wait (element_send_requests);
<a name="l01321"></a>01321   Parallel::wait (element_neighbor_send_requests);  
<a name="l01322"></a>01322 
<a name="l01323"></a>01323   <span class="comment">// unregister MPI datatypes</span>
<a name="l01324"></a>01324   packed_node_datatype.free();
<a name="l01325"></a>01325   
<a name="l01326"></a>01326   STOP_LOG(<span class="stringliteral">&quot;gather_neighboring_elements()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);  
<a name="l01327"></a>01327 }
<a name="l01328"></a>01328 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l01329"></a>01329 <span class="preprocessor"></span>
<a name="l01330"></a>01330 
<a name="l01331"></a>01331 
<a name="l01332"></a>01332 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01333"></a><a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">01333</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">MeshCommunication::broadcast</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l01334"></a>01334 <span class="keyword"></span>{
<a name="l01335"></a>01335   <span class="comment">// Don&#39;t need to do anything if there is</span>
<a name="l01336"></a>01336   <span class="comment">// only one processor.</span>
<a name="l01337"></a>01337   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01338"></a>01338     <span class="keywordflow">return</span>;
<a name="l01339"></a>01339   
<a name="l01340"></a>01340   this-&gt;<a class="code" href="classMeshCommunication.php#ad78fc27e8a89028e43d364173b62f974">broadcast_mesh</a> (mesh);
<a name="l01341"></a>01341   this-&gt;<a class="code" href="classMeshCommunication.php#a4a9d78ca5e1cf68f295abe5b60c744ee">broadcast_bcs</a>  (mesh, *(mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>));
<a name="l01342"></a>01342 }
<a name="l01343"></a>01343 
<a name="l01344"></a>01344 
<a name="l01345"></a>01345 
<a name="l01346"></a>01346 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l01347"></a>01347 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l01348"></a><a class="code" href="classMeshCommunication.php#ad78fc27e8a89028e43d364173b62f974">01348</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ad78fc27e8a89028e43d364173b62f974">MeshCommunication::broadcast_mesh</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp;) const <span class="comment">// avoid spurious gcc warnings</span>
<a name="l01349"></a>01349 {
<a name="l01350"></a>01350   <span class="comment">// no MPI, no need for this method...</span>
<a name="l01351"></a>01351   <span class="keywordflow">return</span>;
<a name="l01352"></a>01352 }
<a name="l01353"></a>01353 <span class="preprocessor">#else </span>
<a name="l01354"></a>01354 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l01355"></a>01355 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ad78fc27e8a89028e43d364173b62f974">MeshCommunication::broadcast_mesh</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l01356"></a>01356 <span class="keyword"></span>{
<a name="l01357"></a>01357   <span class="comment">// Don&#39;t need to do anything if there is</span>
<a name="l01358"></a>01358   <span class="comment">// only one processor.</span>
<a name="l01359"></a>01359   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01360"></a>01360     <span class="keywordflow">return</span>;  
<a name="l01361"></a>01361 
<a name="l01362"></a>01362   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01363"></a>01363   parallel_only();
<a name="l01364"></a>01364 
<a name="l01365"></a>01365   START_LOG(<span class="stringliteral">&quot;broadcast_mesh()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01366"></a>01366 
<a name="l01367"></a>01367   <span class="comment">// Explicitly clear the mesh on all but processor 0.</span>
<a name="l01368"></a>01368   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01369"></a>01369     mesh.<a class="code" href="classMeshBase.php#aefd56c4c29285d5e845f8869112b2b67">clear</a>();
<a name="l01370"></a>01370   
<a name="l01371"></a>01371   <span class="comment">// Get important sizes</span>
<a name="l01372"></a>01372   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>      = mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>();
<a name="l01373"></a>01373   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>       = mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>();
<a name="l01374"></a>01374   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a>     = <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">MeshTools::n_levels</a>(mesh);
<a name="l01375"></a>01375   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#a12088fda1f68ba58f5868a24a4ed884a">total_weight</a> = <a class="code" href="namespaceMeshTools.php#a12088fda1f68ba58f5868a24a4ed884a">MeshTools::total_weight</a>(mesh);
<a name="l01376"></a>01376 
<a name="l01377"></a>01377   <span class="comment">// Broadcast the sizes</span>
<a name="l01378"></a>01378   {
<a name="l01379"></a>01379     std::vector&lt;unsigned int&gt; buf (3);
<a name="l01380"></a>01380     
<a name="l01381"></a>01381     buf[0] = <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>;
<a name="l01382"></a>01382     buf[1] = <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>;
<a name="l01383"></a>01383     buf[2] = <a class="code" href="namespaceMeshTools.php#a12088fda1f68ba58f5868a24a4ed884a">total_weight</a>;
<a name="l01384"></a>01384     
<a name="l01385"></a>01385     <span class="comment">// Broadcast</span>
<a name="l01386"></a>01386     <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (buf);
<a name="l01387"></a>01387 
<a name="l01388"></a>01388     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01389"></a>01389       {
<a name="l01390"></a>01390         n_nodes      = buf[0];
<a name="l01391"></a>01391         n_elem       = buf[1];
<a name="l01392"></a>01392         total_weight = buf[2];
<a name="l01393"></a>01393       } 
<a name="l01394"></a>01394   }  
<a name="l01395"></a>01395 
<a name="l01396"></a>01396   <span class="comment">// First build up the pts vector which contains</span>
<a name="l01397"></a>01397   <span class="comment">// the spatial locations of all the nodes      </span>
<a name="l01398"></a>01398   {
<a name="l01399"></a>01399     std::vector&lt;Real&gt; pts;
<a name="l01400"></a>01400         
<a name="l01401"></a>01401     <span class="comment">// If we are processor 0, we must populate this vector and</span>
<a name="l01402"></a>01402     <span class="comment">// broadcast it to the other processors.</span>
<a name="l01403"></a>01403     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01404"></a>01404       {
<a name="l01405"></a>01405         pts.reserve (3*n_nodes);
<a name="l01406"></a>01406 
<a name="l01407"></a>01407         <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       it     = mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>();
<a name="l01408"></a>01408         <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it_end = mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>();
<a name="l01409"></a>01409 
<a name="l01410"></a>01410         <span class="keywordflow">for</span> (; it != it_end; ++it)
<a name="l01411"></a>01411           {
<a name="l01412"></a>01412             libmesh_assert (*it != NULL);
<a name="l01413"></a>01413             libmesh_assert (!(*it)-&gt;valid_processor_id());
<a name="l01414"></a>01414             libmesh_assert ((*it)-&gt;id()*3 == pts.size());
<a name="l01415"></a>01415             
<a name="l01416"></a>01416             <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p = **it;
<a name="l01417"></a>01417             
<a name="l01418"></a>01418             pts.push_back ( p(0) ); <span class="comment">// x</span>
<a name="l01419"></a>01419             pts.push_back ( p(1) ); <span class="comment">// y</span>
<a name="l01420"></a>01420             pts.push_back ( p(2) ); <span class="comment">// z          </span>
<a name="l01421"></a>01421           }
<a name="l01422"></a>01422       }
<a name="l01423"></a>01423     <span class="keywordflow">else</span>
<a name="l01424"></a>01424       pts.resize (3*n_nodes);
<a name="l01425"></a>01425 
<a name="l01426"></a>01426     <span class="comment">// Sanity check for all processors</span>
<a name="l01427"></a>01427     libmesh_assert (pts.size() == (3*<a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>));
<a name="l01428"></a>01428     
<a name="l01429"></a>01429     <span class="comment">// Broadcast the pts vector</span>
<a name="l01430"></a>01430     <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (pts);
<a name="l01431"></a>01431 
<a name="l01432"></a>01432     <span class="comment">// Add the nodes we just received if we are not</span>
<a name="l01433"></a>01433     <span class="comment">// processor 0.</span>
<a name="l01434"></a>01434     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01435"></a>01435       {
<a name="l01436"></a>01436         libmesh_assert (mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() == 0);
<a name="l01437"></a>01437         
<a name="l01438"></a>01438         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;pts.size(); i += 3)
<a name="l01439"></a>01439           mesh.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> (<a class="code" href="classPoint.php">Point</a>(pts[i+0],
<a name="l01440"></a>01440                                 pts[i+1],
<a name="l01441"></a>01441                                 pts[i+2]),
<a name="l01442"></a>01442                           i/3);
<a name="l01443"></a>01443       }
<a name="l01444"></a>01444     
<a name="l01445"></a>01445     libmesh_assert (mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>() == <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>);
<a name="l01446"></a>01446   } <span class="comment">// Done distributing the nodes</span>
<a name="l01447"></a>01447 
<a name="l01448"></a>01448   
<a name="l01449"></a>01449   <span class="comment">// Now build up the elements vector which</span>
<a name="l01450"></a>01450   <span class="comment">// contains the element types and connectivity</span>
<a name="l01451"></a>01451   {
<a name="l01452"></a>01452     <span class="comment">// The conn array contains the information needed to construct each element.</span>
<a name="l01453"></a>01453     <span class="comment">// Pack all this information into one communication to avoid two latency hits</span>
<a name="l01454"></a>01454     <span class="comment">// For each element it is of the form</span>
<a name="l01455"></a>01455     <span class="comment">// [ level p_level r_flag p_flag etype subdomain_id </span>
<a name="l01456"></a>01456     <span class="comment">//   self_ID parent_ID which_child node_0 node_1 ... node_n]</span>
<a name="l01457"></a>01457     <span class="comment">// We cannot use unsigned int because parent_ID can be negative</span>
<a name="l01458"></a>01458     std::vector&lt;int&gt; conn;
<a name="l01459"></a>01459 
<a name="l01460"></a>01460     <span class="comment">// If we are processor 0, we must populate this vector and</span>
<a name="l01461"></a>01461     <span class="comment">// broadcast it to the other processors.</span>
<a name="l01462"></a>01462     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01463"></a>01463       {
<a name="l01464"></a>01464         conn.reserve (Elem::PackedElem::header_size*n_elem + total_weight);
<a name="l01465"></a>01465         
<a name="l01466"></a>01466         <span class="comment">// We start from level 0. This is a bit simpler than in xdr_io.C</span>
<a name="l01467"></a>01467         <span class="comment">// because we do not have to worry about economizing by group elements</span>
<a name="l01468"></a>01468         <span class="comment">// of the same type. Element type is simply specified as an</span>
<a name="l01469"></a>01469         <span class="comment">// entry in the connectivity vector, &quot;conn&quot;.</span>
<a name="l01470"></a>01470         <span class="comment">// By filling conn in order of levels, parents should exist before children</span>
<a name="l01471"></a>01471         <span class="comment">// are built when we reconstruct the elements on the other processors.</span>
<a name="l01472"></a>01472         
<a name="l01473"></a>01473         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0; level&lt;=<a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">n_levels</a>; ++level)
<a name="l01474"></a>01474           {
<a name="l01475"></a>01475             <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> it = mesh.<a class="code" href="classMeshBase.php#a534079bde46c7d86cb976db76c697804">level_elements_begin</a>(level);
<a name="l01476"></a>01476             <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> it_end = mesh.<a class="code" href="classMeshBase.php#a724dcfe5c7d4ad16f3ee09e22d6f1372">level_elements_end</a>(level);
<a name="l01477"></a>01477             
<a name="l01478"></a>01478             <span class="keywordflow">for</span> (; it != it_end; ++it)
<a name="l01479"></a>01479               {
<a name="l01480"></a>01480                 libmesh_assert (*it);
<a name="l01481"></a>01481                 libmesh_assert (!(*it)-&gt;valid_processor_id());
<a name="l01482"></a>01482                 <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l01483"></a>01483                 Elem::PackedElem::pack (conn, elem);
<a name="l01484"></a>01484               }
<a name="l01485"></a>01485           }
<a name="l01486"></a>01486       }
<a name="l01487"></a>01487     <span class="keywordflow">else</span>
<a name="l01488"></a>01488       conn.resize (Elem::PackedElem::header_size*n_elem + total_weight);
<a name="l01489"></a>01489     
<a name="l01490"></a>01490     <span class="comment">// Sanity check for all processors</span>
<a name="l01491"></a>01491     libmesh_assert (conn.size() == (Elem::PackedElem::header_size*n_elem + <a class="code" href="namespaceMeshTools.php#a12088fda1f68ba58f5868a24a4ed884a">total_weight</a>));
<a name="l01492"></a>01492     
<a name="l01493"></a>01493     <span class="comment">// Broadcast the element connectivity</span>
<a name="l01494"></a>01494     <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (conn);
<a name="l01495"></a>01495 
<a name="l01496"></a>01496     <span class="comment">// Build the elements we just received if we are not</span>
<a name="l01497"></a>01497     <span class="comment">// processor 0.</span>
<a name="l01498"></a>01498     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01499"></a>01499       {
<a name="l01500"></a>01500         libmesh_assert (mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>() == 0);
<a name="l01501"></a>01501         
<a name="l01502"></a>01502         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = 0;
<a name="l01503"></a>01503 
<a name="l01504"></a>01504         <span class="comment">// This map keeps track of elements we&#39;ve previously added to the mesh </span>
<a name="l01505"></a>01505         <span class="comment">// to avoid O(n) lookup times for parent pointers.</span>
<a name="l01506"></a>01506         std::map&lt;unsigned int, Elem*&gt; parents;
<a name="l01507"></a>01507 
<a name="l01508"></a>01508         <span class="keywordflow">while</span> (cnt &lt; conn.size())
<a name="l01509"></a>01509           {
<a name="l01510"></a>01510             <span class="comment">// Unpack the element</span>
<a name="l01511"></a>01511             Elem::PackedElem packed_elem (conn.begin()+cnt);
<a name="l01512"></a>01512 
<a name="l01513"></a>01513             <span class="comment">// Declare the element that we will add</span>
<a name="l01514"></a>01514             <a class="code" href="classElem.php">Elem</a>* elem = NULL;
<a name="l01515"></a>01515 
<a name="l01516"></a>01516 <span class="comment">//          // Unpack the element header</span>
<a name="l01517"></a>01517 <span class="comment">// #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01518"></a>01518 <span class="comment">//          const int level             = conn[cnt++];</span>
<a name="l01519"></a>01519 <span class="comment">//          const int p_level           = conn[cnt++];</span>
<a name="l01520"></a>01520 <span class="comment">//          const Elem::RefinementState refinement_flag =</span>
<a name="l01521"></a>01521 <span class="comment">//               static_cast&lt;Elem::RefinementState&gt;(conn[cnt++]);</span>
<a name="l01522"></a>01522 <span class="comment">//          const Elem::RefinementState p_refinement_flag =</span>
<a name="l01523"></a>01523 <span class="comment">//               static_cast&lt;Elem::RefinementState&gt;(conn[cnt++]);</span>
<a name="l01524"></a>01524 <span class="comment">// #endif</span>
<a name="l01525"></a>01525 <span class="comment">//             const ElemType elem_type    = static_cast&lt;ElemType&gt;(conn[cnt++]);</span>
<a name="l01526"></a>01526 <span class="comment">//          const unsigned int elem_PID = conn[cnt++];</span>
<a name="l01527"></a>01527 <span class="comment">//          const int subdomain_ID      = conn[cnt++];</span>
<a name="l01528"></a>01528 <span class="comment">//             const int self_ID           = conn[cnt++];</span>
<a name="l01529"></a>01529 <span class="comment">// #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01530"></a>01530 <span class="comment">//             const int parent_ID         = conn[cnt++];</span>
<a name="l01531"></a>01531 <span class="comment">//             const int which_child       = conn[cnt++];</span>
<a name="l01532"></a>01532 
<a name="l01533"></a>01533 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01534"></a>01534 <span class="preprocessor"></span>
<a name="l01535"></a>01535             <span class="keywordflow">if</span> (packed_elem.parent_id() != -1) <span class="comment">// Do a log(n) search for the parent</span>
<a name="l01536"></a>01536               {
<a name="l01537"></a>01537                 <a class="code" href="classElem.php">Elem</a>* my_parent = 
<a name="l01538"></a>01538                   parents.count(packed_elem.parent_id()) ? parents[packed_elem.parent_id()] : NULL;
<a name="l01539"></a>01539                 
<a name="l01540"></a>01540                 <span class="comment">// If the parent was not previously added, we cannot continue.</span>
<a name="l01541"></a>01541                 <span class="keywordflow">if</span> (my_parent == NULL)
<a name="l01542"></a>01542                   {
<a name="l01543"></a>01543                     std::cerr &lt;&lt; <span class="stringliteral">&quot;Parent element with ID &quot;</span> &lt;&lt; packed_elem.parent_id()
<a name="l01544"></a>01544                               &lt;&lt; <span class="stringliteral">&quot; not found.&quot;</span> &lt;&lt; std::endl; 
<a name="l01545"></a>01545                     libmesh_error();
<a name="l01546"></a>01546                   }
<a name="l01547"></a>01547                 
<a name="l01548"></a>01548                 libmesh_assert (my_parent-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);                
<a name="l01549"></a>01549                 
<a name="l01550"></a>01550                 elem = packed_elem.unpack (mesh, my_parent);
<a name="l01551"></a>01551               }
<a name="l01552"></a>01552             
<a name="l01553"></a>01553             <span class="keywordflow">else</span> <span class="comment">// level 0 element has no parent</span>
<a name="l01554"></a>01554               {
<a name="l01555"></a>01555                 libmesh_assert (packed_elem.level() == 0);
<a name="l01556"></a>01556 <span class="preprocessor">#endif          </span>
<a name="l01557"></a>01557 <span class="preprocessor"></span>                elem = packed_elem.unpack (mesh);
<a name="l01558"></a>01558 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01559"></a>01559 <span class="preprocessor"></span>              }
<a name="l01560"></a>01560 <span class="preprocessor">#endif      </span>
<a name="l01561"></a>01561 <span class="preprocessor"></span>            <span class="comment">// Add elem to the map of parents, since it may have</span>
<a name="l01562"></a>01562             <span class="comment">// children to be added later</span>
<a name="l01563"></a>01563             parents.insert(std::make_pair(elem-&gt;id(),elem));
<a name="l01564"></a>01564 
<a name="l01565"></a>01565             cnt += Elem::PackedElem::header_size + packed_elem.n_nodes();
<a name="l01566"></a>01566           } <span class="comment">// end while cnt &lt; conn.size</span>
<a name="l01567"></a>01567 
<a name="l01568"></a>01568         <span class="comment">// Iterate in ascending elem ID order</span>
<a name="l01569"></a>01569         <span class="keywordflow">for</span> (std::map&lt;unsigned int, Elem *&gt;::iterator i =
<a name="l01570"></a>01570              parents.begin();
<a name="l01571"></a>01571              i != parents.end(); ++i)
<a name="l01572"></a>01572           {
<a name="l01573"></a>01573             <a class="code" href="classElem.php">Elem</a> *elem = i-&gt;second;
<a name="l01574"></a>01574             <span class="keywordflow">if</span> (elem)
<a name="l01575"></a>01575               mesh.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a>(elem);
<a name="l01576"></a>01576             <span class="keywordflow">else</span>
<a name="l01577"></a>01577               <span class="comment">// We can probably handle this, but we don&#39;t expect it</span>
<a name="l01578"></a>01578               libmesh_error();
<a name="l01579"></a>01579           }
<a name="l01580"></a>01580 
<a name="l01581"></a>01581       } <span class="comment">// end if iam != cpu 0</span>
<a name="l01582"></a>01582     
<a name="l01583"></a>01583     
<a name="l01584"></a>01584     libmesh_assert (mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>() == <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>);
<a name="l01585"></a>01585   } <span class="comment">// Done distributing the elements</span>
<a name="l01586"></a>01586 
<a name="l01587"></a>01587 
<a name="l01588"></a>01588   STOP_LOG(<span class="stringliteral">&quot;broadcast_mesh()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01589"></a>01589 }
<a name="l01590"></a>01590 <span class="preprocessor">#endif</span>
<a name="l01591"></a>01591 <span class="preprocessor"></span>
<a name="l01592"></a>01592 
<a name="l01593"></a>01593 
<a name="l01594"></a>01594 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l01595"></a>01595 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l01596"></a><a class="code" href="classMeshCommunication.php#a4a9d78ca5e1cf68f295abe5b60c744ee">01596</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a4a9d78ca5e1cf68f295abe5b60c744ee">MeshCommunication::broadcast_bcs</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp;,
<a name="l01597"></a>01597                                        <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>&amp;) const <span class="comment">// avoid spurious gcc warnings</span>
<a name="l01598"></a>01598 {
<a name="l01599"></a>01599 }
<a name="l01600"></a>01600 <span class="preprocessor">#else</span>
<a name="l01601"></a>01601 <span class="preprocessor"></span><span class="comment">// ------------------------------------------------------------</span>
<a name="l01602"></a>01602 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a4a9d78ca5e1cf68f295abe5b60c744ee">MeshCommunication::broadcast_bcs</a> (<span class="keyword">const</span> <a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l01603"></a>01603                                        <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>&amp; boundary_info)<span class="keyword"> const</span>
<a name="l01604"></a>01604 <span class="keyword"></span>{
<a name="l01605"></a>01605   <span class="comment">// Don&#39;t need to do anything if there is</span>
<a name="l01606"></a>01606   <span class="comment">// only one processor.</span>
<a name="l01607"></a>01607   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01608"></a>01608     <span class="keywordflow">return</span>;
<a name="l01609"></a>01609   
<a name="l01610"></a>01610   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01611"></a>01611   parallel_only();
<a name="l01612"></a>01612 
<a name="l01613"></a>01613   START_LOG(<span class="stringliteral">&quot;broadcast_bcs()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01614"></a>01614 
<a name="l01615"></a>01615   <span class="comment">// Explicitly clear the boundary conditions on all</span>
<a name="l01616"></a>01616   <span class="comment">// but processor 0.</span>
<a name="l01617"></a>01617   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01618"></a>01618     boundary_info.<a class="code" href="classBoundaryInfo.php#a0565fdb81d365b6bf7dd1c99aad1da86">clear</a>();
<a name="l01619"></a>01619 
<a name="l01620"></a>01620   <span class="comment">// Build up the list of elements with boundary conditions</span>
<a name="l01621"></a>01621   {
<a name="l01622"></a>01622     std::vector&lt;unsigned int&gt;       el_id;
<a name="l01623"></a>01623     std::vector&lt;unsigned short int&gt; side_id;
<a name="l01624"></a>01624     std::vector&lt;short int&gt;          bc_id;
<a name="l01625"></a>01625 
<a name="l01626"></a>01626     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01627"></a>01627       boundary_info.<a class="code" href="classBoundaryInfo.php#af5e88d4226dd6141a31c63a32fa647e0">build_side_list</a> (el_id, side_id, bc_id);
<a name="l01628"></a>01628 
<a name="l01629"></a>01629     libmesh_assert (el_id.size() == side_id.size());
<a name="l01630"></a>01630     libmesh_assert (el_id.size() == bc_id.size());
<a name="l01631"></a>01631     
<a name="l01632"></a>01632     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = el_id.size();
<a name="l01633"></a>01633 
<a name="l01634"></a>01634     <span class="comment">// Broadcast the number of bcs to expect from processor 0.</span>
<a name="l01635"></a>01635     <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (n_bcs);
<a name="l01636"></a>01636 
<a name="l01637"></a>01637     <span class="comment">// Only continue if we have element BCs</span>
<a name="l01638"></a>01638     <span class="keywordflow">if</span> (n_bcs &gt; 0)
<a name="l01639"></a>01639       {
<a name="l01640"></a>01640         <span class="comment">// Allocate space. On CPU 0, these vectors should already have size n_bcs.</span>
<a name="l01641"></a>01641         el_id.resize   (n_bcs);
<a name="l01642"></a>01642         side_id.resize (n_bcs);
<a name="l01643"></a>01643         bc_id.resize   (n_bcs);
<a name="l01644"></a>01644         
<a name="l01645"></a>01645         <span class="comment">// Broadcast the element identities</span>
<a name="l01646"></a>01646         <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (el_id);
<a name="l01647"></a>01647 
<a name="l01648"></a>01648         <span class="comment">// Broadcast the side ids for those elements</span>
<a name="l01649"></a>01649         <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (side_id);
<a name="l01650"></a>01650 
<a name="l01651"></a>01651         <span class="comment">// Broadcast the bc ids for each side</span>
<a name="l01652"></a>01652         <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (bc_id);
<a name="l01653"></a>01653 
<a name="l01654"></a>01654         <span class="comment">// Build the boundary_info structure if we aren&#39;t processor 0</span>
<a name="l01655"></a>01655         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01656"></a>01656           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;n_bcs; e++)
<a name="l01657"></a>01657             {
<a name="l01658"></a>01658               libmesh_assert (el_id[e] &lt; mesh.<a class="code" href="classMeshBase.php#aaf9a7117f3bb01392950ac079e5b5c8a">n_elem</a>());
<a name="l01659"></a>01659               
<a name="l01660"></a>01660               <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = mesh.<a class="code" href="classMeshBase.php#a574a1283614a386b1a8b69a8fe517214">elem</a>(el_id[e]);
<a name="l01661"></a>01661 
<a name="l01662"></a>01662               libmesh_assert (elem != NULL);
<a name="l01663"></a>01663 
<a name="l01664"></a>01664               <span class="comment">// sanity: be sure that the element returned by mesh.elem() really has id()==el_id[e]</span>
<a name="l01665"></a>01665               libmesh_assert(elem-&gt;id() == el_id[e]);
<a name="l01666"></a>01666 
<a name="l01667"></a>01667               libmesh_assert (side_id[e] &lt; elem-&gt;n_sides());
<a name="l01668"></a>01668             
<a name="l01669"></a>01669               boundary_info.<a class="code" href="classBoundaryInfo.php#a98ca8858756f9d549cbf8b3bb324f363">add_side</a> (elem, side_id[e], bc_id[e]);
<a name="l01670"></a>01670             }
<a name="l01671"></a>01671       }
<a name="l01672"></a>01672   }
<a name="l01673"></a>01673 
<a name="l01674"></a>01674 
<a name="l01675"></a>01675 
<a name="l01676"></a>01676   <span class="comment">// Build up the list of nodes with boundary conditions</span>
<a name="l01677"></a>01677   {
<a name="l01678"></a>01678     std::vector&lt;unsigned int&gt; node_id;
<a name="l01679"></a>01679     std::vector&lt;short int&gt;    bc_id;
<a name="l01680"></a>01680 
<a name="l01681"></a>01681     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l01682"></a>01682       boundary_info.<a class="code" href="classBoundaryInfo.php#a6b5c5e582386fd889c7fba624cd45c57">build_node_list</a> (node_id, bc_id);
<a name="l01683"></a>01683 
<a name="l01684"></a>01684     libmesh_assert (node_id.size() == bc_id.size());
<a name="l01685"></a>01685     
<a name="l01686"></a>01686     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = node_id.size();
<a name="l01687"></a>01687 
<a name="l01688"></a>01688     <span class="comment">// Broadcast the number of bcs to expect from processor 0.</span>
<a name="l01689"></a>01689     <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (n_bcs);
<a name="l01690"></a>01690 
<a name="l01691"></a>01691     <span class="comment">// Only continue if we have nodal BCs</span>
<a name="l01692"></a>01692     <span class="keywordflow">if</span> (n_bcs &gt; 0)
<a name="l01693"></a>01693       {      
<a name="l01694"></a>01694         <span class="comment">// Allocate space, again on CPU 0 this should be a no-op.</span>
<a name="l01695"></a>01695         node_id.resize (n_bcs);
<a name="l01696"></a>01696         bc_id.resize   (n_bcs);
<a name="l01697"></a>01697         
<a name="l01698"></a>01698         <span class="comment">// Broadcast the node ids</span>
<a name="l01699"></a>01699         <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (node_id);
<a name="l01700"></a>01700         
<a name="l01701"></a>01701         <span class="comment">// Broadcast the bc ids for each side</span>
<a name="l01702"></a>01702         <a class="code" href="classMeshCommunication.php#af47e26c3e42077ed8389a4faf1b52570">Parallel::broadcast</a> (bc_id);
<a name="l01703"></a>01703 
<a name="l01704"></a>01704         <span class="comment">// Build the boundary_info structure if we aren&#39;t processor 0</span>
<a name="l01705"></a>01705         <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() != 0)
<a name="l01706"></a>01706           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_bcs; n++)
<a name="l01707"></a>01707             {
<a name="l01708"></a>01708               libmesh_assert (node_id[n] &lt; mesh.<a class="code" href="classMeshBase.php#a8a927e499ea08fe30b7a867fa14314d6">n_nodes</a>());
<a name="l01709"></a>01709               
<a name="l01710"></a>01710               <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a> (node_id[n]);
<a name="l01711"></a>01711 
<a name="l01712"></a>01712               libmesh_assert (node != NULL);
<a name="l01713"></a>01713               
<a name="l01714"></a>01714               <span class="comment">// sanity: be sure that the node returned by mesh.node_ptr() really has id()==node_id[n]</span>
<a name="l01715"></a>01715               libmesh_assert(node-&gt;id() == node_id[n]);
<a name="l01716"></a>01716             
<a name="l01717"></a>01717               boundary_info.<a class="code" href="classBoundaryInfo.php#ad1b6927a343e6a084e384fcf7b8e9e8a">add_node</a> (node, bc_id[n]);
<a name="l01718"></a>01718             }
<a name="l01719"></a>01719       }
<a name="l01720"></a>01720   }
<a name="l01721"></a>01721 
<a name="l01722"></a>01722   STOP_LOG(<span class="stringliteral">&quot;broadcast_bcs()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01723"></a>01723 }
<a name="l01724"></a>01724 <span class="preprocessor">#endif  </span>
<a name="l01725"></a>01725 <span class="preprocessor"></span>
<a name="l01726"></a>01726 
<a name="l01727"></a>01727 
<a name="l01728"></a>01728 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01729"></a><a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">01729</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">MeshCommunication::allgather</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l01730"></a>01730 <span class="keyword"></span>{
<a name="l01731"></a>01731   START_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01732"></a>01732 
<a name="l01733"></a>01733   <span class="comment">// The mesh should know it&#39;s about to be serialized</span>
<a name="l01734"></a>01734   libmesh_assert (mesh.<a class="code" href="classParallelMesh.php#ac72c8fd7a3d1df94503f7028601c14df">is_serial</a>());
<a name="l01735"></a>01735 
<a name="l01736"></a>01736   this-&gt;<a class="code" href="classMeshCommunication.php#acd6f8a7ba179432312ff14e57ba7132c">allgather_mesh</a> (mesh);
<a name="l01737"></a>01737   this-&gt;<a class="code" href="classMeshCommunication.php#a1c1d7509c36d90cf7cf042b979e71d24">allgather_bcs</a>  (mesh, *(mesh.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>));
<a name="l01738"></a>01738 
<a name="l01739"></a>01739   <span class="comment">// Inform new elements of their neighbors,</span>
<a name="l01740"></a>01740   <span class="comment">// while resetting all remote_elem links</span>
<a name="l01741"></a>01741   mesh.<a class="code" href="classUnstructuredMesh.php#a98c765606a6c53e090c2595b739201ff">find_neighbors</a>(<span class="keyword">true</span>);
<a name="l01742"></a>01742 
<a name="l01743"></a>01743   STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01744"></a>01744 }
<a name="l01745"></a>01745 
<a name="l01746"></a>01746 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l01747"></a>01747 <span class="preprocessor"></span>  
<a name="l01748"></a>01748 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01749"></a><a class="code" href="classMeshCommunication.php#acd6f8a7ba179432312ff14e57ba7132c">01749</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#acd6f8a7ba179432312ff14e57ba7132c">MeshCommunication::allgather_mesh</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a>&amp;)<span class="keyword"> const</span>
<a name="l01750"></a>01750 <span class="keyword"></span>{
<a name="l01751"></a>01751   <span class="comment">// NO MPI == one processor, no need for this method</span>
<a name="l01752"></a>01752   <span class="keywordflow">return</span>;
<a name="l01753"></a>01753 }
<a name="l01754"></a>01754   
<a name="l01755"></a>01755 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01756"></a><a class="code" href="classMeshCommunication.php#a1c1d7509c36d90cf7cf042b979e71d24">01756</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a1c1d7509c36d90cf7cf042b979e71d24">MeshCommunication::allgather_bcs</a> (<span class="keyword">const</span> <a class="code" href="classParallelMesh.php">ParallelMesh</a>&amp;,
<a name="l01757"></a>01757                                        <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>&amp;)<span class="keyword"> const</span>
<a name="l01758"></a>01758 <span class="keyword"></span>{
<a name="l01759"></a>01759   <span class="comment">// NO MPI == one processor, no need for this method</span>
<a name="l01760"></a>01760   <span class="keywordflow">return</span>;
<a name="l01761"></a>01761 }
<a name="l01762"></a>01762 
<a name="l01763"></a>01763 <span class="preprocessor">#else</span>
<a name="l01764"></a>01764 <span class="preprocessor"></span>
<a name="l01765"></a>01765 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01766"></a>01766 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#acd6f8a7ba179432312ff14e57ba7132c">MeshCommunication::allgather_mesh</a> (<a class="code" href="classParallelMesh.php">ParallelMesh</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l01767"></a>01767 <span class="keyword"></span>{
<a name="l01768"></a>01768   <span class="comment">// Check for quick return</span>
<a name="l01769"></a>01769   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01770"></a>01770     <span class="keywordflow">return</span>;
<a name="l01771"></a>01771 
<a name="l01772"></a>01772   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01773"></a>01773   parallel_only();
<a name="l01774"></a>01774 
<a name="l01775"></a>01775   START_LOG (<span class="stringliteral">&quot;allgather_mesh()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l01776"></a>01776   
<a name="l01777"></a>01777   <span class="comment">// Gather the number of nodes and elements on each processor.</span>
<a name="l01778"></a>01778   std::vector&lt;unsigned int&gt;
<a name="l01779"></a>01779     <a class="code" href="namespaceMeshTools.php#acc8ae40253981cb744c63be2e0e0fdde">n_nodes</a>(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()), <a class="code" href="namespaceMeshTools.php#a337ed123c95f0ba57b665456c413db4b">n_elem</a>(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01780"></a>01780   
<a name="l01781"></a>01781   {
<a name="l01782"></a>01782     std::vector&lt;unsigned int&gt; n_objects(2);
<a name="l01783"></a>01783     n_objects[0] = mesh.<a class="code" href="classMeshBase.php#a56053e95ae70a2f5c67725d5f4e6ea04">n_local_nodes</a>();
<a name="l01784"></a>01784     n_objects[1] = mesh.<a class="code" href="classMeshBase.php#ab2d0abdfdf6c884bace77cf94af08874">n_local_elem</a>();
<a name="l01785"></a>01785 
<a name="l01786"></a>01786     <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a>(n_objects, <span class="comment">/* identical_buffer_sizes = */</span> <span class="keyword">true</span>);
<a name="l01787"></a>01787     
<a name="l01788"></a>01788     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0, <a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>=0; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01789"></a>01789       {
<a name="l01790"></a>01790         n_nodes[p] = n_objects[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++];
<a name="l01791"></a>01791         n_elem[p]  = n_objects[<a class="code" href="namespaceMeshTools_1_1Generation_1_1Private.php#aedbefed1d284b69338d1b1594c77f34c">idx</a>++];  
<a name="l01792"></a>01792       }
<a name="l01793"></a>01793 
<a name="l01794"></a>01794     libmesh_assert (mesh.<a class="code" href="classMeshBase.php#a56053e95ae70a2f5c67725d5f4e6ea04">n_local_nodes</a>() == n_nodes[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l01795"></a>01795     libmesh_assert (mesh.<a class="code" href="classMeshBase.php#ab2d0abdfdf6c884bace77cf94af08874">n_local_elem</a>()  ==  n_elem[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l01796"></a>01796   }
<a name="l01797"></a>01797 
<a name="l01798"></a>01798   std::vector&lt;unsigned int&gt;
<a name="l01799"></a>01799     node_offsets(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0),
<a name="l01800"></a>01800     elem_offsets(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l01801"></a>01801   
<a name="l01802"></a>01802   <span class="comment">// Compute the global sizes to cross-check the results of the</span>
<a name="l01803"></a>01803   <span class="comment">// operations that follow.</span>
<a name="l01804"></a>01804   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01805"></a>01805     global_n_nodes = n_nodes[0], 
<a name="l01806"></a>01806     global_n_elem  = n_elem[0];
<a name="l01807"></a>01807 
<a name="l01808"></a>01808   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01809"></a>01809     {
<a name="l01810"></a>01810       node_offsets[p] = node_offsets[p-1] + n_nodes[p-1];
<a name="l01811"></a>01811       elem_offsets[p] = elem_offsets[p-1] +  n_elem[p-1];
<a name="l01812"></a>01812 
<a name="l01813"></a>01813       global_n_nodes += n_nodes[p];
<a name="l01814"></a>01814       global_n_elem  += n_elem[p];
<a name="l01815"></a>01815     }
<a name="l01816"></a>01816 
<a name="l01817"></a>01817   
<a name="l01818"></a>01818   
<a name="l01819"></a>01819   <span class="comment">//-------------------------------------------------</span>
<a name="l01820"></a>01820   <span class="comment">// Gather the nodal coordinates from each processor.</span>
<a name="l01821"></a>01821   {
<a name="l01822"></a>01822     std::vector&lt;Real&gt; xyz; xyz.reserve(3*n_nodes[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l01823"></a>01823     
<a name="l01824"></a>01824     ParallelMesh::node_iterator       it  = mesh.<a class="code" href="classParallelMesh.php#a6d946e045e452f81014f878a6c0e3dc0">local_nodes_begin</a>();
<a name="l01825"></a>01825     <span class="keyword">const</span> ParallelMesh::node_iterator end = mesh.<a class="code" href="classParallelMesh.php#aea43c4aa5e1717506724d63551de946c">local_nodes_end</a>();
<a name="l01826"></a>01826 
<a name="l01827"></a>01827     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01828"></a>01828       {
<a name="l01829"></a>01829         libmesh_assert (*it != NULL);
<a name="l01830"></a>01830             
<a name="l01831"></a>01831         <span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a> &amp;p = **it;
<a name="l01832"></a>01832 
<a name="l01833"></a>01833         xyz.push_back(p(0));
<a name="l01834"></a>01834         xyz.push_back(p(1));
<a name="l01835"></a>01835         xyz.push_back(p(2));
<a name="l01836"></a>01836       }
<a name="l01837"></a>01837 
<a name="l01838"></a>01838     libmesh_assert (xyz.size() == 3*n_nodes[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l01839"></a>01839 
<a name="l01840"></a>01840     <span class="comment">// Get values from other processors</span>
<a name="l01841"></a>01841     <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (xyz);
<a name="l01842"></a>01842 
<a name="l01843"></a>01843     <span class="comment">// And add them to our mesh.</span>
<a name="l01844"></a>01844     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01845"></a>01845       <span class="keywordflow">if</span> (p == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) <span class="keywordflow">continue</span>; <span class="comment">// We&#39;ve already got our</span>
<a name="l01846"></a>01846                                                   <span class="comment">// own local nodes!</span>
<a name="l01847"></a>01847       <span class="keywordflow">else</span>
<a name="l01848"></a>01848         {
<a name="l01849"></a>01849           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01850"></a>01850             first_global_idx = node_offsets[p],
<a name="l01851"></a>01851             last_global_idx  = first_global_idx + n_nodes[p];
<a name="l01852"></a>01852 
<a name="l01853"></a>01853           <span class="comment">// Extract the coordinates for each node belonging to processor p</span>
<a name="l01854"></a>01854           <span class="comment">// and add it to our mesh.</span>
<a name="l01855"></a>01855           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_idx = first_global_idx; global_idx&lt;last_global_idx; global_idx++)
<a name="l01856"></a>01856             {
<a name="l01857"></a>01857               libmesh_assert ((3*global_idx + 2) &lt; xyz.size());
<a name="l01858"></a>01858               
<a name="l01859"></a>01859               <a class="code" href="classNode.php">Node</a> *node = <a class="code" href="classNode.php#aa6175b07d8a78dc554bb0f9f4727b02e">Node::build</a>(xyz[3*global_idx + 0],
<a name="l01860"></a>01860                                        xyz[3*global_idx + 1],
<a name="l01861"></a>01861                                        xyz[3*global_idx + 2],
<a name="l01862"></a>01862                                        global_idx).release();
<a name="l01863"></a>01863               
<a name="l01864"></a>01864               libmesh_assert (node != NULL);
<a name="l01865"></a>01865               libmesh_assert (node-&gt;id() == global_idx);
<a name="l01866"></a>01866               
<a name="l01867"></a>01867               node-&gt;processor_id() = p;
<a name="l01868"></a>01868 
<a name="l01869"></a>01869               mesh.<a class="code" href="classParallelMesh.php#ae5a2ef7ac888ae42fe08bb9716664795">insert_node</a>(node);
<a name="l01870"></a>01870             }
<a name="l01871"></a>01871         }
<a name="l01872"></a>01872     
<a name="l01873"></a>01873     <span class="comment">// Check the result</span>
<a name="l01874"></a>01874     libmesh_assert (global_n_nodes == mesh.<a class="code" href="classParallelMesh.php#a0b5505cdbb6799aed76cafb62a7e0135">n_nodes</a>());
<a name="l01875"></a>01875   }
<a name="l01876"></a>01876   
<a name="l01877"></a>01877   <span class="comment">//----------------------------------------------------</span>
<a name="l01878"></a>01878   <span class="comment">// Gather the element connectivity from each processor.</span>
<a name="l01879"></a>01879   {
<a name="l01880"></a>01880     <span class="comment">// Get the sum of elem-&gt;n_nodes() for all local elements.  This</span>
<a name="l01881"></a>01881     <span class="comment">// will allow for efficient preallocation.</span>
<a name="l01882"></a>01882     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01883"></a>01883       local_weight   = <a class="code" href="namespaceMeshTools.php#a7c3064eb37925fb5bdda7660e872cf69">MeshTools::weight</a>(mesh),
<a name="l01884"></a>01884       local_n_levels = <a class="code" href="namespaceMeshTools.php#a2d3e473958b98cab21275e75b75ed19b">MeshTools::n_local_levels</a>(mesh);
<a name="l01885"></a>01885 
<a name="l01886"></a>01886     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_n_levels = local_n_levels;
<a name="l01887"></a>01887     <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a> (global_n_levels);
<a name="l01888"></a>01888     
<a name="l01889"></a>01889     <span class="comment">// The conn array contains the information needed to construct each element.</span>
<a name="l01890"></a>01890     std::vector&lt;int&gt; conn; conn.reserve 
<a name="l01891"></a>01891       (Elem::PackedElem::header_size*n_elem[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] + local_weight);
<a name="l01892"></a>01892                                                 
<a name="l01893"></a>01893     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0; level&lt;=local_n_levels; level++)
<a name="l01894"></a>01894       {
<a name="l01895"></a>01895         ParallelMesh::element_iterator        it  = mesh.<a class="code" href="classParallelMesh.php#abcc01be1661a0e82a4e4d5dfb1a79ef4">local_level_elements_begin</a>(level);
<a name="l01896"></a>01896         <span class="keyword">const</span> ParallelMesh::element_iterator  end = mesh.<a class="code" href="classParallelMesh.php#a0b6fc28939ea321936ea2edabb65f1c1">local_level_elements_end</a>(level);
<a name="l01897"></a>01897 
<a name="l01898"></a>01898         <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01899"></a>01899           {
<a name="l01900"></a>01900             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l01901"></a>01901 
<a name="l01902"></a>01902             libmesh_assert (elem != NULL);
<a name="l01903"></a>01903             libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == level);
<a name="l01904"></a>01904             
<a name="l01905"></a>01905             <span class="comment">// We&#39;re not handling unpartitioned elements!</span>
<a name="l01906"></a>01906             libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() != <a class="code" href="classDofObject.php#ad9521de38fb2ed1bfca2d4fe98b21422">DofObject::invalid_processor_id</a>);
<a name="l01907"></a>01907 
<a name="l01908"></a>01908             <span class="comment">// Only local elements!</span>
<a name="l01909"></a>01909             libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l01910"></a>01910 
<a name="l01911"></a>01911             Elem::PackedElem::pack (conn, elem);            
<a name="l01912"></a>01912           }
<a name="l01913"></a>01913       } <span class="comment">// ...that was easy.</span>
<a name="l01914"></a>01914 
<a name="l01915"></a>01915     libmesh_assert (conn.size() == 
<a name="l01916"></a>01916       Elem::PackedElem::header_size*n_elem[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] + local_weight);
<a name="l01917"></a>01917 
<a name="l01918"></a>01918     <span class="comment">// Get the size of the connectivity array on each processor</span>
<a name="l01919"></a>01919     std::vector&lt;unsigned int&gt;
<a name="l01920"></a>01920       conn_size   (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0),
<a name="l01921"></a>01921       conn_offset (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l01922"></a>01922     
<a name="l01923"></a>01923     <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (static_cast&lt;unsigned int&gt;(conn.size()), conn_size);
<a name="l01924"></a>01924 
<a name="l01925"></a>01925     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01926"></a>01926       conn_offset[p] = conn_offset[p-1] + conn_size[p-1];    
<a name="l01927"></a>01927     
<a name="l01928"></a>01928     <span class="comment">// Get the element connectivity from all the other processors</span>
<a name="l01929"></a>01929     <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (conn);
<a name="l01930"></a>01930 
<a name="l01931"></a>01931 
<a name="l01932"></a>01932         
<a name="l01933"></a>01933     <span class="comment">// ...and add them to our mesh.</span>
<a name="l01934"></a>01934     <span class="comment">// This is a little tricky.  We need to insure that parents are added before children. </span>
<a name="l01935"></a>01935     <span class="comment">// So we need to add elements level-wise to handle, for example, the case where a child on</span>
<a name="l01936"></a>01936     <span class="comment">// processor [0] has a parent on processor [1].  But we also need to add the elements </span>
<a name="l01937"></a>01937     <span class="comment">// processor-wise so that we can set the processor_id() properly.  </span>
<a name="l01938"></a>01938     <span class="comment">// So, loop on levels/processors</span>
<a name="l01939"></a>01939     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level=0; level&lt;=global_n_levels; level++)
<a name="l01940"></a>01940       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l01941"></a>01941         <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) <span class="comment">// We&#39;ve already got our</span>
<a name="l01942"></a>01942           {                               <span class="comment">// own local elements!</span>
<a name="l01943"></a>01943             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = conn_offset[p]; <span class="comment">// counter into the conn[] array.</span>
<a name="l01944"></a>01944             
<a name="l01945"></a>01945 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01946"></a>01946 <span class="preprocessor"></span>            <span class="comment">// The first and last global indices are only used for error-checking.</span>
<a name="l01947"></a>01947             <span class="comment">// Avoid declaring them unless asserts are enabled.</span>
<a name="l01948"></a>01948             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l01949"></a>01949               first_global_idx = elem_offsets[p],
<a name="l01950"></a>01950               last_global_idx  = first_global_idx + n_elem[p];
<a name="l01951"></a>01951 <span class="preprocessor">#endif</span>
<a name="l01952"></a>01952 <span class="preprocessor"></span>            
<a name="l01953"></a>01953             <span class="comment">// Process each element for processor p.</span>
<a name="l01954"></a>01954             <span class="comment">// Note this must work in the case when conn_size[p] == 0.</span>
<a name="l01955"></a>01955             <span class="keywordflow">while</span> (cnt &lt; (conn_offset[p] + conn_size[p]))
<a name="l01956"></a>01956               {
<a name="l01957"></a>01957                 <span class="comment">// Unpack the element</span>
<a name="l01958"></a>01958                 Elem::PackedElem packed_elem (conn.begin()+cnt);
<a name="l01959"></a>01959 
<a name="l01960"></a>01960                 <span class="comment">// We require contiguous numbering on each processor</span>
<a name="l01961"></a>01961                 <span class="comment">// for elements.</span>
<a name="l01962"></a>01962                 libmesh_assert (packed_elem.id() &gt;= first_global_idx);
<a name="l01963"></a>01963                 libmesh_assert (packed_elem.id()  &lt; last_global_idx);
<a name="l01964"></a>01964 
<a name="l01965"></a>01965 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01966"></a>01966 <span class="preprocessor"></span>                libmesh_assert ((packed_elem.level() == 0) || (packed_elem.parent_id() != -1));
<a name="l01967"></a>01967   
<a name="l01968"></a>01968                 <span class="comment">// Ignore elements not matching the current level.</span>
<a name="l01969"></a>01969                 <span class="keywordflow">if</span> (packed_elem.level() &gt; level) <span class="comment">// skip all entries in the conn array for this element.</span>
<a name="l01970"></a>01970                   cnt += Elem::PackedElem::header_size + packed_elem.n_nodes();
<a name="l01971"></a>01971 
<a name="l01972"></a>01972                 <span class="keywordflow">else</span>
<a name="l01973"></a>01973 <span class="preprocessor">#endif</span>
<a name="l01974"></a>01974 <span class="preprocessor"></span>                <span class="keywordflow">if</span> (packed_elem.level() &lt; level ||     <span class="comment">// we should already have</span>
<a name="l01975"></a>01975                     (packed_elem.level() == level &amp;&amp;   <span class="comment">// lower level and some</span>
<a name="l01976"></a>01976                      mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(packed_elem.id())))     <span class="comment">// ghost elements</span>
<a name="l01977"></a>01977                   {
<a name="l01978"></a>01978                     <span class="comment">// No need to construct a dummy element of this type</span>
<a name="l01979"></a>01979 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01980"></a>01980 <span class="preprocessor"></span>                    <span class="comment">// The elem information need not be extracted unless asserts are enabled.</span>
<a name="l01981"></a>01981                     <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(packed_elem.id());
<a name="l01982"></a>01982 <span class="preprocessor">#endif</span>
<a name="l01983"></a>01983 <span class="preprocessor"></span>                    libmesh_assert (elem);
<a name="l01984"></a>01984 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01985"></a>01985 <span class="preprocessor"></span>                    libmesh_assert (!elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>() ||
<a name="l01986"></a>01986                                     elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() ==
<a name="l01987"></a>01987                                     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(packed_elem.parent_id()));
<a name="l01988"></a>01988                     libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>()           == packed_elem.p_level());
<a name="l01989"></a>01989                     libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>()   == packed_elem.refinement_flag());
<a name="l01990"></a>01990                     libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == packed_elem.p_refinement_flag());
<a name="l01991"></a>01991 <span class="preprocessor">#endif</span>
<a name="l01992"></a>01992 <span class="preprocessor"></span>                    libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a9700699e6d71d5b50ab11b72bfdb2f02">type</a>()              == packed_elem.type());
<a name="l01993"></a>01993                     libmesh_assert (elem-&gt;<a class="code" href="classElem.php#acc4746605aad9169ad38cfd0b9b97123">subdomain_id</a>()      == packed_elem.subdomain_id());
<a name="l01994"></a>01994                     libmesh_assert (elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()                == packed_elem.id());
<a name="l01995"></a>01995                     libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>()           == packed_elem.n_nodes());
<a name="l01996"></a>01996 
<a name="l01997"></a>01997                     cnt += Elem::PackedElem::header_size + packed_elem.n_nodes();
<a name="l01998"></a>01998                   }
<a name="l01999"></a>01999                 <span class="comment">// Those are the easy cases...</span>
<a name="l02000"></a>02000                 <span class="comment">// now elem_level == level and we don&#39;t have it</span>
<a name="l02001"></a>02001                 <span class="keywordflow">else</span>
<a name="l02002"></a>02002                   {
<a name="l02003"></a>02003                     <span class="comment">// Declare the element we will add</span>
<a name="l02004"></a>02004                     <a class="code" href="classElem.php">Elem</a>* elem = NULL;
<a name="l02005"></a>02005 
<a name="l02006"></a>02006 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02007"></a>02007 <span class="preprocessor"></span>                    <span class="comment">// Maybe find its parent</span>
<a name="l02008"></a>02008                     <span class="keywordflow">if</span> (level &gt; 0)
<a name="l02009"></a>02009                       {
<a name="l02010"></a>02010                         <a class="code" href="classElem.php">Elem</a>* my_parent = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(packed_elem.parent_id());
<a name="l02011"></a>02011 
<a name="l02012"></a>02012                         <span class="comment">// If the parent was not previously added, we</span>
<a name="l02013"></a>02013                         <span class="comment">// cannot continue.</span>
<a name="l02014"></a>02014                         <span class="keywordflow">if</span> (my_parent == NULL)
<a name="l02015"></a>02015                           {
<a name="l02016"></a>02016                             std::cerr &lt;&lt; <span class="stringliteral">&quot;Parent element with ID &quot;</span> &lt;&lt; packed_elem.parent_id()
<a name="l02017"></a>02017                                       &lt;&lt; <span class="stringliteral">&quot; not found.&quot;</span> &lt;&lt; std::endl; 
<a name="l02018"></a>02018                             libmesh_error();
<a name="l02019"></a>02019                           }
<a name="l02020"></a>02020                         
<a name="l02021"></a>02021                         elem = packed_elem.unpack (mesh, my_parent);
<a name="l02022"></a>02022                       }
<a name="l02023"></a>02023                     <span class="keywordflow">else</span>
<a name="l02024"></a>02024                       {
<a name="l02025"></a>02025                         libmesh_assert (packed_elem.parent_id() == -1);
<a name="l02026"></a>02026 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l02027"></a>02027 <span class="preprocessor"></span>                        elem = packed_elem.unpack (mesh);
<a name="l02028"></a>02028 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02029"></a>02029 <span class="preprocessor"></span>                      }
<a name="l02030"></a>02030 <span class="preprocessor">#endif</span>
<a name="l02031"></a>02031 <span class="preprocessor"></span>
<a name="l02032"></a>02032                     <span class="comment">// Good to go.  Add to the mesh.</span>
<a name="l02033"></a>02033                     libmesh_assert (elem);
<a name="l02034"></a>02034                     mesh.<a class="code" href="classParallelMesh.php#aadf11922b8147ddc3680d9a7da5d4447">insert_elem</a>(elem);
<a name="l02035"></a>02035 
<a name="l02036"></a>02036                     libmesh_assert (elem-&gt;n_nodes() == packed_elem.n_nodes());
<a name="l02037"></a>02037 
<a name="l02038"></a>02038                     cnt += Elem::PackedElem::header_size + packed_elem.<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>();
<a name="l02039"></a>02039                     
<a name="l02040"></a>02040                   } <span class="comment">// end elem_level == level</span>
<a name="l02041"></a>02041               }
<a name="l02042"></a>02042             
<a name="l02043"></a>02043           }   
<a name="l02044"></a>02044 
<a name="l02045"></a>02045     <span class="comment">// Check the result</span>
<a name="l02046"></a>02046     libmesh_assert (global_n_elem == mesh.<a class="code" href="classParallelMesh.php#aaefea67041752d4e801f25d2a41c3552">n_elem</a>());
<a name="l02047"></a>02047   }
<a name="l02048"></a>02048 
<a name="l02049"></a>02049   <span class="comment">// All done!</span>
<a name="l02050"></a>02050   STOP_LOG (<span class="stringliteral">&quot;allgather_mesh()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02051"></a>02051 }
<a name="l02052"></a>02052 
<a name="l02053"></a>02053 
<a name="l02054"></a>02054 
<a name="l02055"></a>02055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02056"></a>02056 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a1c1d7509c36d90cf7cf042b979e71d24">MeshCommunication::allgather_bcs</a> (<span class="keyword">const</span> <a class="code" href="classParallelMesh.php">ParallelMesh</a>&amp; mesh,
<a name="l02057"></a>02057                                        <a class="code" href="classBoundaryInfo.php">BoundaryInfo</a>&amp; boundary_info)<span class="keyword"> const</span>
<a name="l02058"></a>02058 <span class="keyword"></span>{
<a name="l02059"></a>02059   <span class="comment">// Check for quick return</span>
<a name="l02060"></a>02060   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l02061"></a>02061     <span class="keywordflow">return</span>;
<a name="l02062"></a>02062 
<a name="l02063"></a>02063   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02064"></a>02064   parallel_only();
<a name="l02065"></a>02065 
<a name="l02066"></a>02066   START_LOG (<span class="stringliteral">&quot;allgather_bcs()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02067"></a>02067 
<a name="l02068"></a>02068   std::vector&lt;int&gt;
<a name="l02069"></a>02069     xfer_elem_bcs,
<a name="l02070"></a>02070     xfer_node_bcs;
<a name="l02071"></a>02071   
<a name="l02072"></a>02072   
<a name="l02073"></a>02073   <span class="comment">// Get the element boundary conditions</span>
<a name="l02074"></a>02074   {    
<a name="l02075"></a>02075     std::vector&lt;unsigned int&gt;       el_id;
<a name="l02076"></a>02076     std::vector&lt;unsigned short int&gt; side_id;
<a name="l02077"></a>02077     std::vector&lt;short int&gt;          bc_id;
<a name="l02078"></a>02078     
<a name="l02079"></a>02079     boundary_info.<a class="code" href="classBoundaryInfo.php#af5e88d4226dd6141a31c63a32fa647e0">build_side_list</a> (el_id, side_id, bc_id);
<a name="l02080"></a>02080 
<a name="l02081"></a>02081     libmesh_assert (el_id.size() == side_id.size());
<a name="l02082"></a>02082     libmesh_assert (el_id.size() == bc_id.size());
<a name="l02083"></a>02083     
<a name="l02084"></a>02084     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = el_id.size();
<a name="l02085"></a>02085 
<a name="l02086"></a>02086     <span class="comment">// reserve an upper bound for the number of BCs</span>
<a name="l02087"></a>02087     xfer_elem_bcs.reserve(3*n_bcs);
<a name="l02088"></a>02088 
<a name="l02089"></a>02089     <span class="comment">// populate the xfer_elem_bcs list with *local* elements only.</span>
<a name="l02090"></a>02090     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc=0; bc&lt;n_bcs; bc++)
<a name="l02091"></a>02091       {
<a name="l02092"></a>02092         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(el_id[bc]);
<a name="l02093"></a>02093         
<a name="l02094"></a>02094         <span class="comment">// sanity: be sure that the element returned by mesh.elem() really has id()==el_id[e]</span>
<a name="l02095"></a>02095         libmesh_assert(elem != NULL);
<a name="l02096"></a>02096         libmesh_assert(elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == el_id[bc]);
<a name="l02097"></a>02097         libmesh_assert(elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == 0);
<a name="l02098"></a>02098         libmesh_assert(side_id[bc] &lt; elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>());
<a name="l02099"></a>02099 
<a name="l02100"></a>02100         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l02101"></a>02101           {
<a name="l02102"></a>02102             xfer_elem_bcs.push_back(el_id[bc]);
<a name="l02103"></a>02103             xfer_elem_bcs.push_back(side_id[bc]);
<a name="l02104"></a>02104             xfer_elem_bcs.push_back(bc_id[bc]);
<a name="l02105"></a>02105           }
<a name="l02106"></a>02106       }
<a name="l02107"></a>02107   
<a name="l02108"></a>02108   } <span class="comment">// done with element boundary conditions</span>
<a name="l02109"></a>02109 
<a name="l02110"></a>02110 
<a name="l02111"></a>02111   <span class="comment">// Get the nodal boundary conditions</span>
<a name="l02112"></a>02112   {
<a name="l02113"></a>02113     std::vector&lt;unsigned int&gt; node_id;
<a name="l02114"></a>02114     std::vector&lt;short int&gt;    bc_id;
<a name="l02115"></a>02115     
<a name="l02116"></a>02116     boundary_info.<a class="code" href="classBoundaryInfo.php#a6b5c5e582386fd889c7fba624cd45c57">build_node_list</a> (node_id, bc_id);
<a name="l02117"></a>02117 
<a name="l02118"></a>02118     libmesh_assert (node_id.size() == bc_id.size());
<a name="l02119"></a>02119 
<a name="l02120"></a>02120     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = node_id.size();
<a name="l02121"></a>02121 
<a name="l02122"></a>02122     <span class="comment">// reserve an upper bound for the number of BCs</span>
<a name="l02123"></a>02123     xfer_node_bcs.reserve(2*n_bcs);
<a name="l02124"></a>02124 
<a name="l02125"></a>02125     <span class="comment">// populate the xfer_node_bcs witl *local* nodes only</span>
<a name="l02126"></a>02126     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc=0; bc&lt;n_bcs; bc++)
<a name="l02127"></a>02127       {
<a name="l02128"></a>02128         <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = mesh.<a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a>(node_id[bc]);
<a name="l02129"></a>02129         
<a name="l02130"></a>02130         libmesh_assert(node != NULL);
<a name="l02131"></a>02131         libmesh_assert(node-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>() == node_id[bc]);
<a name="l02132"></a>02132 
<a name="l02133"></a>02133         <span class="keywordflow">if</span> (node-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l02134"></a>02134           {
<a name="l02135"></a>02135             xfer_node_bcs.push_back(node_id[bc]);
<a name="l02136"></a>02136             xfer_node_bcs.push_back(bc_id[bc]);
<a name="l02137"></a>02137           }
<a name="l02138"></a>02138       }
<a name="l02139"></a>02139   } <span class="comment">// done with nodal boundary conditions</span>
<a name="l02140"></a>02140 
<a name="l02141"></a>02141 
<a name="l02142"></a>02142   <span class="comment">// The xfer arrays now contain all the information for our</span>
<a name="l02143"></a>02143   <span class="comment">// local bcs, and we are about to get all the information for</span>
<a name="l02144"></a>02144   <span class="comment">// remote bcs.  Go ahead and clear the current boundary_info</span>
<a name="l02145"></a>02145   <span class="comment">// information and rebuild it after we get the remote data.</span>
<a name="l02146"></a>02146   boundary_info.<a class="code" href="classBoundaryInfo.php#a0565fdb81d365b6bf7dd1c99aad1da86">clear</a>();
<a name="l02147"></a>02147   
<a name="l02148"></a>02148   <span class="comment">// Get the boundary condition information from adacent processors</span>
<a name="l02149"></a>02149   <span class="comment">// Insert the elements</span>
<a name="l02150"></a>02150   {
<a name="l02151"></a>02151     <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (xfer_elem_bcs);
<a name="l02152"></a>02152 
<a name="l02153"></a>02153     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = xfer_elem_bcs.size()/3;
<a name="l02154"></a>02154 
<a name="l02155"></a>02155     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc=0, cnt=0; bc&lt;n_bcs; bc++)
<a name="l02156"></a>02156       {
<a name="l02157"></a>02157         <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* elem = mesh.<a class="code" href="classParallelMesh.php#ae5df0d138114adafeae3bc6b3270cff8">elem</a>(xfer_elem_bcs[cnt++]);
<a name="l02158"></a>02158         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> side_id = xfer_elem_bcs[cnt++];
<a name="l02159"></a>02159         <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> bc_id = xfer_elem_bcs[cnt++];
<a name="l02160"></a>02160 
<a name="l02161"></a>02161         boundary_info.<a class="code" href="classBoundaryInfo.php#a98ca8858756f9d549cbf8b3bb324f363">add_side</a> (elem, side_id, bc_id);  
<a name="l02162"></a>02162       }
<a name="l02163"></a>02163 
<a name="l02164"></a>02164     <span class="comment">// no need for this any more</span>
<a name="l02165"></a>02165     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (xfer_elem_bcs);
<a name="l02166"></a>02166   }
<a name="l02167"></a>02167 
<a name="l02168"></a>02168   
<a name="l02169"></a>02169   <span class="comment">// Insert the nodes</span>
<a name="l02170"></a>02170   {
<a name="l02171"></a>02171     <a class="code" href="classMeshCommunication.php#a21c1490e797f0bce2a29880c078eb8f5">Parallel::allgather</a> (xfer_node_bcs);
<a name="l02172"></a>02172 
<a name="l02173"></a>02173     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bcs = xfer_node_bcs.size()/2;
<a name="l02174"></a>02174 
<a name="l02175"></a>02175     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bc=0, cnt=0; bc&lt;n_bcs; bc++)
<a name="l02176"></a>02176       {
<a name="l02177"></a>02177         <span class="keyword">const</span> <a class="code" href="classNode.php">Node</a>* node = mesh.<a class="code" href="classParallelMesh.php#a39d1343ddfc925e1012d021d9a11e42f">node_ptr</a> (xfer_node_bcs[cnt++]);
<a name="l02178"></a>02178         <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> bc_id = xfer_node_bcs[cnt++];
<a name="l02179"></a>02179 
<a name="l02180"></a>02180         boundary_info.<a class="code" href="classBoundaryInfo.php#ad1b6927a343e6a084e384fcf7b8e9e8a">add_node</a> (node, bc_id);
<a name="l02181"></a>02181       }
<a name="l02182"></a>02182  
<a name="l02183"></a>02183     <span class="comment">// no need for this any more</span>
<a name="l02184"></a>02184     <a class="code" href="namespaceUtility.php#a87eab2b9d265355c6c62b945c15bdf9f">Utility::deallocate</a> (xfer_node_bcs);
<a name="l02185"></a>02185   }
<a name="l02186"></a>02186 
<a name="l02187"></a>02187  
<a name="l02188"></a>02188 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02189"></a>02189 <span class="preprocessor"></span>  
<a name="l02190"></a>02190   <span class="comment">// Make sure all processors agree on the number of boundary ids.</span>
<a name="l02191"></a>02191   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bc_ids = boundary_info.<a class="code" href="classBoundaryInfo.php#ae4a9fe24ebb554775311ceda65a21708">n_boundary_ids</a>();
<a name="l02192"></a>02192   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_n_bc_ids = n_bc_ids;
<a name="l02193"></a>02193   
<a name="l02194"></a>02194   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a> (global_n_bc_ids);
<a name="l02195"></a>02195   libmesh_assert (n_bc_ids == global_n_bc_ids);
<a name="l02196"></a>02196   
<a name="l02197"></a>02197 <span class="preprocessor">#endif</span>
<a name="l02198"></a>02198 <span class="preprocessor"></span>  
<a name="l02199"></a>02199 
<a name="l02200"></a>02200   STOP_LOG  (<span class="stringliteral">&quot;allgather_bcs()&quot;</span>,<span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02201"></a>02201 }
<a name="l02202"></a>02202 
<a name="l02203"></a>02203 
<a name="l02204"></a>02204 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l02205"></a>02205 <span class="preprocessor"></span>
<a name="l02206"></a>02206 
<a name="l02207"></a>02207 
<a name="l02208"></a>02208 <span class="comment">// Functor for make_elems_parallel_consistent and</span>
<a name="l02209"></a>02209 <span class="comment">// make_node_ids_parallel_consistent</span>
<a name="l02210"></a>02210 <span class="keyword">namespace </span>{
<a name="l02211"></a>02211 
<a name="l02212"></a>02212 <span class="keyword">struct </span>SyncIds
<a name="l02213"></a>02213 {
<a name="l02214"></a>02214 <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> datum;
<a name="l02215"></a>02215 <span class="keyword">typedef</span> void (<a class="code" href="classMeshBase.php">MeshBase</a>::*renumber_obj)(<span class="keywordtype">unsigned</span> int, <span class="keywordtype">unsigned</span> int);
<a name="l02216"></a>02216 
<a name="l02217"></a>02217 SyncIds(<a class="code" href="classMeshBase.php">MeshBase</a> &amp;_mesh, renumber_obj _renumberer) :
<a name="l02218"></a>02218   mesh(_mesh),
<a name="l02219"></a>02219   renumber(_renumberer) {}
<a name="l02220"></a>02220 
<a name="l02221"></a>02221 <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh;
<a name="l02222"></a>02222 renumber_obj renumber;
<a name="l02223"></a>02223 <span class="comment">// renumber_obj &amp;renumber;</span>
<a name="l02224"></a>02224 
<a name="l02225"></a>02225 <span class="comment">// Find the id of each requested DofObject -</span>
<a name="l02226"></a>02226 <span class="comment">// sync_dofobject_data_by_xyz already did the work for us</span>
<a name="l02227"></a>02227 <span class="keywordtype">void</span> gather_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l02228"></a>02228                   std::vector&lt;datum&gt;&amp; ids_out)
<a name="l02229"></a>02229 {
<a name="l02230"></a>02230   ids_out = ids;
<a name="l02231"></a>02231 }
<a name="l02232"></a>02232 
<a name="l02233"></a>02233 <span class="keywordtype">void</span> act_on_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; old_ids,
<a name="l02234"></a>02234                   std::vector&lt;datum&gt;&amp; new_ids)
<a name="l02235"></a>02235 {
<a name="l02236"></a>02236   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != old_ids.size(); ++i)
<a name="l02237"></a>02237     <span class="keywordflow">if</span> (old_ids[i] != new_ids[i])
<a name="l02238"></a>02238       (mesh.*renumber)(old_ids[i], new_ids[i]);
<a name="l02239"></a>02239 }
<a name="l02240"></a>02240 };
<a name="l02241"></a>02241 }
<a name="l02242"></a>02242 
<a name="l02243"></a>02243 
<a name="l02244"></a>02244 
<a name="l02245"></a>02245 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02246"></a>02246 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#abce9300c55a7f17ace07ec52ea575c96">MeshCommunication::make_node_ids_parallel_consistent</a>
<a name="l02247"></a><a class="code" href="classMeshCommunication.php#abce9300c55a7f17ace07ec52ea575c96">02247</a>   (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l02248"></a>02248    <a class="code" href="classLocationMap.php">LocationMap&lt;Node&gt;</a> &amp;loc_map)
<a name="l02249"></a>02249 {
<a name="l02250"></a>02250   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02251"></a>02251   parallel_only();
<a name="l02252"></a>02252 
<a name="l02253"></a>02253   START_LOG (<span class="stringliteral">&quot;make_node_ids_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02254"></a>02254 
<a name="l02255"></a>02255   SyncIds syncids(mesh, &amp;<a class="code" href="classMeshBase.php#a608fdcb50de42af663437ae88d7a4056">MeshBase::renumber_node</a>);
<a name="l02256"></a>02256   <a class="code" href="namespaceParallel.php#a67ce8f53bd6f7bda0eb3cb0fb3964251">Parallel::sync_dofobject_data_by_xyz</a>
<a name="l02257"></a>02257     (mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>(), mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>(),
<a name="l02258"></a>02258      loc_map, syncids);
<a name="l02259"></a>02259 
<a name="l02260"></a>02260   STOP_LOG (<span class="stringliteral">&quot;make_node_ids_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02261"></a>02261 }
<a name="l02262"></a>02262 
<a name="l02263"></a>02263 
<a name="l02264"></a>02264 
<a name="l02265"></a>02265 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02266"></a><a class="code" href="classMeshCommunication.php#a7b765d81a42d5e663f884ed709dd4040">02266</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a7b765d81a42d5e663f884ed709dd4040">MeshCommunication::make_elems_parallel_consistent</a>(<a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh)
<a name="l02267"></a>02267 {
<a name="l02268"></a>02268   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02269"></a>02269   parallel_only();
<a name="l02270"></a>02270 
<a name="l02271"></a>02271   START_LOG (<span class="stringliteral">&quot;make_elems_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02272"></a>02272 
<a name="l02273"></a>02273   SyncIds syncids(mesh, &amp;<a class="code" href="classMeshBase.php#ac0e399ab1929b022cae1e8d1a1b7abbd">MeshBase::renumber_elem</a>);
<a name="l02274"></a>02274   <a class="code" href="namespaceParallel.php#a6ccf8177a39475406f26a72369dfc56d">Parallel::sync_element_data_by_parent_id</a>
<a name="l02275"></a>02275     (mesh, mesh.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>(),
<a name="l02276"></a>02276      mesh.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(), syncids);
<a name="l02277"></a>02277 
<a name="l02278"></a>02278   STOP_LOG (<span class="stringliteral">&quot;make_elems_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02279"></a>02279 }
<a name="l02280"></a>02280 
<a name="l02281"></a>02281 
<a name="l02282"></a>02282 
<a name="l02283"></a>02283 <span class="comment">// Functors for make_node_proc_ids_parallel_consistent</span>
<a name="l02284"></a>02284 <span class="keyword">namespace </span>{
<a name="l02285"></a>02285 
<a name="l02286"></a>02286 <span class="keyword">struct </span>SyncProcIds
<a name="l02287"></a>02287 {
<a name="l02288"></a>02288 <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> datum;
<a name="l02289"></a>02289 
<a name="l02290"></a>02290 SyncProcIds(<a class="code" href="classMeshBase.php">MeshBase</a> &amp;_mesh) : mesh(_mesh) {}
<a name="l02291"></a>02291 
<a name="l02292"></a>02292 <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh;
<a name="l02293"></a>02293 
<a name="l02294"></a>02294 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02295"></a>02295 <span class="keywordtype">void</span> gather_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l02296"></a>02296                   std::vector&lt;datum&gt;&amp; data)
<a name="l02297"></a>02297 {
<a name="l02298"></a>02298   <span class="comment">// Find the processor id of each requested node</span>
<a name="l02299"></a>02299   data.resize(ids.size());
<a name="l02300"></a>02300 
<a name="l02301"></a>02301   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != ids.size(); ++i)
<a name="l02302"></a>02302     {
<a name="l02303"></a>02303       <span class="comment">// Look for this point in the mesh</span>
<a name="l02304"></a>02304       <a class="code" href="classNode.php">Node</a> *node = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(ids[i]);
<a name="l02305"></a>02305 
<a name="l02306"></a>02306       <span class="comment">// We&#39;d better find every node we&#39;re asked for</span>
<a name="l02307"></a>02307       libmesh_assert (node);
<a name="l02308"></a>02308 
<a name="l02309"></a>02309       <span class="comment">// Return the node&#39;s correct processor id,</span>
<a name="l02310"></a>02310       data[i] = node-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>();
<a name="l02311"></a>02311     }
<a name="l02312"></a>02312 }
<a name="l02313"></a>02313 
<a name="l02314"></a>02314 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02315"></a>02315 <span class="keywordtype">void</span> act_on_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l02316"></a>02316                   std::vector&lt;datum&gt; proc_ids)
<a name="l02317"></a>02317 {
<a name="l02318"></a>02318   <span class="comment">// Set the ghost node processor ids we&#39;ve now been informed of</span>
<a name="l02319"></a>02319   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != ids.size(); ++i)
<a name="l02320"></a>02320     {
<a name="l02321"></a>02321       <a class="code" href="classNode.php">Node</a> *node = mesh.<a class="code" href="classMeshBase.php#a1f4e7c33b1f6fa7742e703b625e95c54">node_ptr</a>(ids[i]);
<a name="l02322"></a>02322       node-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() = proc_ids[i];
<a name="l02323"></a>02323     }
<a name="l02324"></a>02324 }
<a name="l02325"></a>02325 };
<a name="l02326"></a>02326 }
<a name="l02327"></a>02327 
<a name="l02328"></a>02328 
<a name="l02329"></a>02329 
<a name="l02330"></a>02330 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02331"></a>02331 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#a663092448c5bc3a969eadbd6a002ce43">MeshCommunication::make_node_proc_ids_parallel_consistent</a>
<a name="l02332"></a><a class="code" href="classMeshCommunication.php#a663092448c5bc3a969eadbd6a002ce43">02332</a>   (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; mesh,
<a name="l02333"></a>02333    <a class="code" href="classLocationMap.php">LocationMap&lt;Node&gt;</a>&amp; loc_map)
<a name="l02334"></a>02334 {
<a name="l02335"></a>02335   START_LOG (<span class="stringliteral">&quot;make_node_proc_ids_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02336"></a>02336 
<a name="l02337"></a>02337   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02338"></a>02338   parallel_only();
<a name="l02339"></a>02339 
<a name="l02340"></a>02340   <span class="comment">// When this function is called, each section of a parallelized mesh</span>
<a name="l02341"></a>02341   <span class="comment">// should be in the following state:</span>
<a name="l02342"></a>02342   <span class="comment">//</span>
<a name="l02343"></a>02343   <span class="comment">// All nodes should have the exact same physical location on every</span>
<a name="l02344"></a>02344   <span class="comment">// processor where they exist.</span>
<a name="l02345"></a>02345   <span class="comment">//</span>
<a name="l02346"></a>02346   <span class="comment">// Local nodes should have unique authoritative ids,</span>
<a name="l02347"></a>02347   <span class="comment">// and processor ids consistent with all processors which own</span>
<a name="l02348"></a>02348   <span class="comment">// an element touching them.</span>
<a name="l02349"></a>02349   <span class="comment">//</span>
<a name="l02350"></a>02350   <span class="comment">// Ghost nodes touching local elements should have processor ids</span>
<a name="l02351"></a>02351   <span class="comment">// consistent with all processors which own an element touching</span>
<a name="l02352"></a>02352   <span class="comment">// them.</span>
<a name="l02353"></a>02353   
<a name="l02354"></a>02354   SyncProcIds sync(mesh);
<a name="l02355"></a>02355   <a class="code" href="namespaceParallel.php#a67ce8f53bd6f7bda0eb3cb0fb3964251">Parallel::sync_dofobject_data_by_xyz</a>
<a name="l02356"></a>02356     (mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>(), mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>(), loc_map, sync);
<a name="l02357"></a>02357 
<a name="l02358"></a>02358   STOP_LOG (<span class="stringliteral">&quot;make_node_proc_ids_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02359"></a>02359 }
<a name="l02360"></a>02360 
<a name="l02361"></a>02361 
<a name="l02362"></a>02362 
<a name="l02363"></a>02363 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02364"></a>02364 <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#ad2ae60d0388971e32c1060bf5304186e">MeshCommunication::make_nodes_parallel_consistent</a>
<a name="l02365"></a><a class="code" href="classMeshCommunication.php#ad2ae60d0388971e32c1060bf5304186e">02365</a>   (<a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh,
<a name="l02366"></a>02366    <a class="code" href="classLocationMap.php">LocationMap&lt;Node&gt;</a> &amp;loc_map)
<a name="l02367"></a>02367 {
<a name="l02368"></a>02368   <span class="comment">// This function must be run on all processors at once</span>
<a name="l02369"></a>02369   parallel_only();
<a name="l02370"></a>02370 
<a name="l02371"></a>02371   <span class="comment">// Create the loc_map if it hasn&#39;t been done already</span>
<a name="l02372"></a>02372   <span class="keywordtype">bool</span> need_map_update = (mesh.<a class="code" href="classMeshBase.php#a2683097ac8a923892fa43a1a911a273d">nodes_begin</a>() != mesh.<a class="code" href="classMeshBase.php#ab9b58c2b060ea4d47b50e1dad15415b0">nodes_end</a>() &amp;&amp; 
<a name="l02373"></a>02373                           loc_map.<a class="code" href="classLocationMap.php#a4517c7633d5d724f8666fefc8220b408">empty</a>());
<a name="l02374"></a>02374   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(need_map_update);
<a name="l02375"></a>02375 
<a name="l02376"></a>02376   <span class="keywordflow">if</span> (need_map_update)
<a name="l02377"></a>02377     loc_map.<a class="code" href="classLocationMap.php#a11ceffd5adae2b79e2cc0f8ab0b1f73f">init</a>(mesh);
<a name="l02378"></a>02378 
<a name="l02379"></a>02379   <span class="comment">// When this function is called, each section of a parallelized mesh</span>
<a name="l02380"></a>02380   <span class="comment">// should be in the following state:</span>
<a name="l02381"></a>02381   <span class="comment">//</span>
<a name="l02382"></a>02382   <span class="comment">// All nodes should have the exact same physical location on every</span>
<a name="l02383"></a>02383   <span class="comment">// processor where they exist.</span>
<a name="l02384"></a>02384   <span class="comment">//</span>
<a name="l02385"></a>02385   <span class="comment">// Local nodes should have unique authoritative ids,</span>
<a name="l02386"></a>02386   <span class="comment">// and processor ids consistent with all processors which own</span>
<a name="l02387"></a>02387   <span class="comment">// an element touching them.</span>
<a name="l02388"></a>02388   <span class="comment">//</span>
<a name="l02389"></a>02389   <span class="comment">// Ghost nodes touching local elements should have processor ids</span>
<a name="l02390"></a>02390   <span class="comment">// consistent with all processors which own an element touching</span>
<a name="l02391"></a>02391   <span class="comment">// them.</span>
<a name="l02392"></a>02392   <span class="comment">//</span>
<a name="l02393"></a>02393   <span class="comment">// Ghost nodes should have ids which are either already correct</span>
<a name="l02394"></a>02394   <span class="comment">// or which are in the &quot;unpartitioned&quot; id space.</span>
<a name="l02395"></a>02395 
<a name="l02396"></a>02396   <span class="comment">// First, let&#39;s sync up processor ids.  Some of these processor ids</span>
<a name="l02397"></a>02397   <span class="comment">// may be &quot;wrong&quot; from coarsening, but they&#39;re right in the sense</span>
<a name="l02398"></a>02398   <span class="comment">// that they&#39;ll tell us who has the authoritative dofobject ids for</span>
<a name="l02399"></a>02399   <span class="comment">// each node.</span>
<a name="l02400"></a>02400   this-&gt;make_node_proc_ids_parallel_consistent(mesh, loc_map);
<a name="l02401"></a>02401 
<a name="l02402"></a>02402   <span class="comment">// Second, sync up dofobject ids.</span>
<a name="l02403"></a>02403   this-&gt;make_node_ids_parallel_consistent(mesh, loc_map);
<a name="l02404"></a>02404 
<a name="l02405"></a>02405   <span class="comment">// Finally, correct the processor ids to make DofMap happy</span>
<a name="l02406"></a>02406   <a class="code" href="namespaceMeshTools.php#a0ce5caf2cff3d386fe0906e09c052c91">MeshTools::correct_node_proc_ids</a>(mesh, loc_map);
<a name="l02407"></a>02407 }
<a name="l02408"></a>02408 
<a name="l02409"></a>02409 
<a name="l02410"></a>02410 
<a name="l02411"></a>02411 <span class="comment">// ------------------------------------------------------------</span>
<a name="l02412"></a><a class="code" href="classMeshCommunication.php#aeb16d7915a3e73e7d12f3e928aa22431">02412</a> <span class="keywordtype">void</span> <a class="code" href="classMeshCommunication.php#aeb16d7915a3e73e7d12f3e928aa22431">MeshCommunication::delete_remote_elements</a>(<a class="code" href="classParallelMesh.php">ParallelMesh</a>&amp; mesh)<span class="keyword"> const</span>
<a name="l02413"></a>02413 <span class="keyword"></span>{
<a name="l02414"></a>02414   <span class="comment">// The mesh should know it&#39;s about to be parallelized</span>
<a name="l02415"></a>02415   libmesh_assert (!mesh.<a class="code" href="classParallelMesh.php#ac72c8fd7a3d1df94503f7028601c14df">is_serial</a>());
<a name="l02416"></a>02416 
<a name="l02417"></a>02417   START_LOG(<span class="stringliteral">&quot;delete_remote_elements()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02418"></a>02418 
<a name="l02419"></a>02419   <span class="comment">// FIXME - should these be &quot;unsorted_set&quot;s?  O(N) is O(N)...</span>
<a name="l02420"></a>02420   std::vector&lt;bool&gt; local_nodes(mesh.<a class="code" href="classParallelMesh.php#ac30d8f34e21ae07a6d9be2a5850c058c">max_node_id</a>(), <span class="keyword">false</span>);
<a name="l02421"></a>02421   std::vector&lt;bool&gt; semilocal_elems(mesh.<a class="code" href="classParallelMesh.php#a01b6a417b62c640cff4a50ffe13645a5">max_elem_id</a>(), <span class="keyword">false</span>);
<a name="l02422"></a>02422 
<a name="l02423"></a>02423   <span class="comment">// We don&#39;t want to delete any element that shares a node</span>
<a name="l02424"></a>02424   <span class="comment">// with or is an ancestor of a local element.</span>
<a name="l02425"></a>02425   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> l_elem_it = mesh.<a class="code" href="classParallelMesh.php#adffe63cef73e8fd317f08aa1722d8e71">local_elements_begin</a>(),
<a name="l02426"></a>02426                                    l_end     = mesh.<a class="code" href="classParallelMesh.php#a70c12ce1edd2d0c5af2367da3d0da5e3">local_elements_end</a>();
<a name="l02427"></a>02427   <span class="keywordflow">for</span> (; l_elem_it != l_end; ++l_elem_it)
<a name="l02428"></a>02428     {
<a name="l02429"></a>02429       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = *l_elem_it;
<a name="l02430"></a>02430       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l02431"></a>02431         local_nodes[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)] = <span class="keyword">true</span>;
<a name="l02432"></a>02432       <span class="keywordflow">while</span> (elem)
<a name="l02433"></a>02433         {
<a name="l02434"></a>02434           semilocal_elems[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = <span class="keyword">true</span>;
<a name="l02435"></a>02435           elem = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l02436"></a>02436         }
<a name="l02437"></a>02437     }
<a name="l02438"></a>02438 
<a name="l02439"></a>02439   <span class="comment">// We don&#39;t want to delete any element that shares a node</span>
<a name="l02440"></a>02440   <span class="comment">// with or is an ancestor of an unpartitioned element either.</span>
<a name="l02441"></a>02441   <a class="code" href="structMeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l02442"></a>02442     u_elem_it = mesh.<a class="code" href="classParallelMesh.php#a36cda99fc5687ca38b5b0cf2e113fcff">unpartitioned_elements_begin</a>(),
<a name="l02443"></a>02443     u_end     = mesh.<a class="code" href="classParallelMesh.php#a147d2a4bda46d2dbeabd972f908525bb">unpartitioned_elements_end</a>();
<a name="l02444"></a>02444   
<a name="l02445"></a>02445   <span class="keywordflow">for</span> (; u_elem_it != u_end; ++u_elem_it)
<a name="l02446"></a>02446     {
<a name="l02447"></a>02447       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = *u_elem_it;
<a name="l02448"></a>02448       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l02449"></a>02449         local_nodes[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)] = <span class="keyword">true</span>;
<a name="l02450"></a>02450       <span class="keywordflow">while</span> (elem)
<a name="l02451"></a>02451         {
<a name="l02452"></a>02452           semilocal_elems[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = <span class="keyword">true</span>;
<a name="l02453"></a>02453           elem = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l02454"></a>02454         }
<a name="l02455"></a>02455     }
<a name="l02456"></a>02456 
<a name="l02457"></a>02457   <span class="comment">// Flag all the elements that share nodes with</span>
<a name="l02458"></a>02458   <span class="comment">// local and unpartitioned elements, along with their ancestors</span>
<a name="l02459"></a>02459   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> nl_elem_it = mesh.<a class="code" href="classParallelMesh.php#ad0e42cc14d2d5f0cd26d2bb2a6b1b888">not_local_elements_begin</a>(),
<a name="l02460"></a>02460                              nl_end     = mesh.<a class="code" href="classParallelMesh.php#aa84e174e2190219edc0e15c12db6bf8d">not_local_elements_end</a>();
<a name="l02461"></a>02461   <span class="keywordflow">for</span> (; nl_elem_it != nl_end; ++nl_elem_it)
<a name="l02462"></a>02462     {
<a name="l02463"></a>02463       <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a> *elem = *nl_elem_it;
<a name="l02464"></a>02464       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a60c2584ed47a2b6ddca06bc7b3d12acf">n_nodes</a>(); ++n)
<a name="l02465"></a>02465         <span class="keywordflow">if</span> (local_nodes[elem-&gt;<a class="code" href="classElem.php#a2924d09a5bddbd9cce87838bdec6c6c1">node</a>(n)])
<a name="l02466"></a>02466           {
<a name="l02467"></a>02467             <span class="keywordflow">while</span> (elem)
<a name="l02468"></a>02468               {
<a name="l02469"></a>02469                 semilocal_elems[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = <span class="keyword">true</span>;
<a name="l02470"></a>02470                 elem = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l02471"></a>02471               }
<a name="l02472"></a>02472             <span class="keywordflow">break</span>;
<a name="l02473"></a>02473           }
<a name="l02474"></a>02474     }
<a name="l02475"></a>02475 
<a name="l02476"></a>02476   <span class="comment">// Delete all the elements we have no reason to save,</span>
<a name="l02477"></a>02477   <span class="comment">// starting with the most refined so that the mesh</span>
<a name="l02478"></a>02478   <span class="comment">// is valid at all intermediate steps</span>
<a name="l02479"></a>02479   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_levels = <a class="code" href="namespaceMeshTools.php#a467cd3c96ff9a03c0918d4df6ef16301">MeshTools::n_levels</a>(mesh);
<a name="l02480"></a>02480 
<a name="l02481"></a>02481   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> l = n_levels - 1; l &gt;= 0; --l)
<a name="l02482"></a>02482     {
<a name="l02483"></a>02483       <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> lev_elem_it = mesh.<a class="code" href="classParallelMesh.php#ad61c7ac197af37ec6eee1fafc72c625a">level_elements_begin</a>(l),
<a name="l02484"></a>02484                                  lev_end     = mesh.<a class="code" href="classParallelMesh.php#a41457c8b4b80171696f8fc4ff4f444b9">level_elements_end</a>(l);
<a name="l02485"></a>02485       <span class="keywordflow">for</span> (; lev_elem_it != lev_end; ++lev_elem_it)
<a name="l02486"></a>02486         {
<a name="l02487"></a>02487           <a class="code" href="classElem.php">Elem</a> *elem = *lev_elem_it;
<a name="l02488"></a>02488           libmesh_assert (elem);
<a name="l02489"></a>02489           <span class="keywordflow">if</span> (!semilocal_elems[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()])
<a name="l02490"></a>02490             {
<a name="l02491"></a>02491               <span class="comment">// Make sure we don&#39;t leave any invalid pointers</span>
<a name="l02492"></a>02492               elem-&gt;<a class="code" href="classElem.php#aa4989bf7c952831c59b6204075f7b8ab">make_links_to_me_remote</a>();
<a name="l02493"></a>02493 
<a name="l02494"></a>02494               <span class="comment">// delete_elem doesn&#39;t currently invalidate element</span>
<a name="l02495"></a>02495               <span class="comment">// iterators... that had better not change</span>
<a name="l02496"></a>02496               mesh.<a class="code" href="classParallelMesh.php#a7f67f79d1533bcace8c133804ab977b2">delete_elem</a>(elem);
<a name="l02497"></a>02497             }
<a name="l02498"></a>02498         }
<a name="l02499"></a>02499     }
<a name="l02500"></a>02500 
<a name="l02501"></a>02501   STOP_LOG(<span class="stringliteral">&quot;delete_remote_elements()&quot;</span>, <span class="stringliteral">&quot;MeshCommunication&quot;</span>);
<a name="l02502"></a>02502 
<a name="l02503"></a>02503   <span class="comment">// Now make sure the containers actually shrink - strip</span>
<a name="l02504"></a>02504   <span class="comment">// any newly-created NULL voids out of the element array</span>
<a name="l02505"></a>02505   mesh.<a class="code" href="classParallelMesh.php#afdb75157107defbfd06ceb5fe11fde7e">renumber_nodes_and_elements</a>();
<a name="l02506"></a>02506 }
<a name="l02507"></a>02507 
<a name="l02508"></a>02508 
<a name="l02509"></a>02509 
<a name="l02510"></a>02510 
<a name="l02511"></a>02511 <span class="comment">// // Pack all this information into one communication to avoid two latency hits</span>
<a name="l02512"></a>02512 <span class="comment">// // For each element it is of the form</span>
<a name="l02513"></a>02513 <span class="comment">// // [ level p_level r_flag p_flag etype subdomain_id </span>
<a name="l02514"></a>02514 <span class="comment">// //   self_ID parent_ID which_child node_0 node_1 ... node_n]</span>
<a name="l02515"></a>02515 <span class="comment">// // We cannot use unsigned int because parent_ID can be negative</span>
<a name="l02516"></a>02516 <span class="comment">// void MeshCommunication::pack_element (std::vector&lt;int&gt; &amp;conn, const Elem* elem) const</span>
<a name="l02517"></a>02517 <span class="comment">// {</span>
<a name="l02518"></a>02518 <span class="comment">//   libmesh_assert (elem != NULL);</span>
<a name="l02519"></a>02519 
<a name="l02520"></a>02520 <span class="comment">// #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02521"></a>02521 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;level()));</span>
<a name="l02522"></a>02522 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;p_level()));</span>
<a name="l02523"></a>02523 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;refinement_flag()));</span>
<a name="l02524"></a>02524 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;p_refinement_flag()));</span>
<a name="l02525"></a>02525 <span class="comment">// #endif</span>
<a name="l02526"></a>02526 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;type()));</span>
<a name="l02527"></a>02527 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;processor_id()));</span>
<a name="l02528"></a>02528 <span class="comment">//   conn.push_back (static_cast&lt;int&gt;(elem-&gt;subdomain_id()));</span>
<a name="l02529"></a>02529 <span class="comment">//   conn.push_back (elem-&gt;id());</span>
<a name="l02530"></a>02530                 
<a name="l02531"></a>02531 <span class="comment">// #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l02532"></a>02532 <span class="comment">//   // use parent_ID of -1 to indicate a level 0 element</span>
<a name="l02533"></a>02533 <span class="comment">//   if (elem-&gt;level() == 0)</span>
<a name="l02534"></a>02534 <span class="comment">//     {</span>
<a name="l02535"></a>02535 <span class="comment">//       conn.push_back(-1);</span>
<a name="l02536"></a>02536 <span class="comment">//       conn.push_back(-1);</span>
<a name="l02537"></a>02537 <span class="comment">//     }</span>
<a name="l02538"></a>02538 <span class="comment">//   else</span>
<a name="l02539"></a>02539 <span class="comment">//     {</span>
<a name="l02540"></a>02540 <span class="comment">//       conn.push_back(elem-&gt;parent()-&gt;id());</span>
<a name="l02541"></a>02541 <span class="comment">//       conn.push_back(elem-&gt;parent()-&gt;which_child_am_i(elem));</span>
<a name="l02542"></a>02542 <span class="comment">//     }</span>
<a name="l02543"></a>02543 <span class="comment">// #endif</span>
<a name="l02544"></a>02544   
<a name="l02545"></a>02545 <span class="comment">//   for (unsigned int n=0; n&lt;elem-&gt;n_nodes(); n++)</span>
<a name="l02546"></a>02546 <span class="comment">//     conn.push_back (elem-&gt;node(n));          </span>
<a name="l02547"></a>02547 <span class="comment">// }</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
