<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d80d010101221a980255dcd0a797f3cf.php">mesh</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>mesh_refinement.C</h1>  </div>
</div>
<div class="contents">
<a href="mesh__refinement_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_refinement.C 3502 2009-10-20 18:06:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for isnan(), when it&#39;s defined</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_config.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// only compile these functions if the user requests AMR support</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;boundary_info.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;elem.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;error_vector.h&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;mesh_base.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;mesh_communication.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;mesh_refinement.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;parallel_ghost_sync.h&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;remote_elem.h&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="comment">// Some extra validation for ParallelMesh</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;mesh_tools.h&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;parallel_mesh.h&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#endif // DEBUG</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// Mesh refinement methods</span>
<a name="l00051"></a><a class="code" href="classMeshRefinement.php#a7d394c81f2d11d13f5a9f674f1dca24c">00051</a> <a class="code" href="classMeshRefinement.php#a7d394c81f2d11d13f5a9f674f1dca24c">MeshRefinement::MeshRefinement</a> (<a class="code" href="classMeshBase.php">MeshBase</a>&amp; m) :
<a name="l00052"></a>00052   _mesh(m),
<a name="l00053"></a>00053   _use_member_parameters(false),
<a name="l00054"></a>00054   _coarsen_by_parents(false),
<a name="l00055"></a>00055   _refine_fraction(0.3),
<a name="l00056"></a>00056   _coarsen_fraction(0.0),
<a name="l00057"></a>00057   _max_h_level(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00058"></a>00058   _coarsen_threshold(10),
<a name="l00059"></a>00059   _nelem_target(0),
<a name="l00060"></a>00060   _absolute_global_tolerance(0.0),
<a name="l00061"></a>00061   _face_level_mismatch_limit(1),
<a name="l00062"></a>00062   _edge_level_mismatch_limit(0),
<a name="l00063"></a>00063   _node_level_mismatch_limit(0)
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classMeshRefinement.php#a21700694e32153fdac783406d91309d2">00069</a> <a class="code" href="classMeshRefinement.php#a21700694e32153fdac783406d91309d2">MeshRefinement::~MeshRefinement</a> ()
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071   this-&gt;<a class="code" href="classMeshRefinement.php#aaefd0f57b9d612831bbaf75cfcc1962c">clear</a>();  
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classMeshRefinement.php#aaefd0f57b9d612831bbaf75cfcc1962c">00076</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#aaefd0f57b9d612831bbaf75cfcc1962c">MeshRefinement::clear</a> ()
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   <a class="code" href="classMeshRefinement.php#a830cefaa2e0f102fc921dc5cae2b5733">_new_nodes_map</a>.<a class="code" href="classLocationMap.php#aca32ff9cab95a48aaf3d5e4250e51cb4">clear</a>();
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classMeshRefinement.php#a1ba6d819dde6739791062d14a25e49aa">00083</a> <a class="code" href="classNode.php">Node</a>* <a class="code" href="classMeshRefinement.php#a1ba6d819dde6739791062d14a25e49aa">MeshRefinement::add_point</a> (<span class="keyword">const</span> <a class="code" href="classPoint.php">Point</a>&amp; p,
<a name="l00084"></a>00084                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>,
<a name="l00085"></a>00085                                  <span class="keyword">const</span> <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a> tol)
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087   START_LOG(<span class="stringliteral">&quot;add_point()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// Return the node if it already exists</span>
<a name="l00090"></a>00090   <a class="code" href="classNode.php">Node</a> *node = <a class="code" href="classMeshRefinement.php#a830cefaa2e0f102fc921dc5cae2b5733">_new_nodes_map</a>.<a class="code" href="classLocationMap.php#a5af3c498d43b5eec4c40e1fd8aff23cb">find</a>(p, tol);
<a name="l00091"></a>00091   <span class="keywordflow">if</span> (node)
<a name="l00092"></a>00092     {
<a name="l00093"></a>00093       STOP_LOG(<span class="stringliteral">&quot;add_point()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00094"></a>00094       <span class="keywordflow">return</span> node;
<a name="l00095"></a>00095     }
<a name="l00096"></a>00096       
<a name="l00097"></a>00097   <span class="comment">// Add the node, with a default id and the requested</span>
<a name="l00098"></a>00098   <span class="comment">// processor_id</span>
<a name="l00099"></a>00099   node = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a01b66468d3e9d8b5db82c6f3d9131f5e">add_point</a> (p, <a class="code" href="classDofObject.php#a35a5c88688334a8a3b8f0ff45105fb36">DofObject::invalid_id</a>, processor_id);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   libmesh_assert (node != NULL);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">// Add the node to the map.</span>
<a name="l00104"></a>00104   <a class="code" href="classMeshRefinement.php#a830cefaa2e0f102fc921dc5cae2b5733">_new_nodes_map</a>.<a class="code" href="classLocationMap.php#aa31e9800e314e1437fdcc82088df5f3f">insert</a>(*node);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">// Return the address of the new node</span>
<a name="l00107"></a>00107   STOP_LOG(<span class="stringliteral">&quot;add_point()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00108"></a>00108   <span class="keywordflow">return</span> node;
<a name="l00109"></a>00109 }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classMeshRefinement.php#a2227d3f4c2e3cde51213d2845c0ce508">00113</a> <a class="code" href="classElem.php">Elem</a>* <a class="code" href="classMeshRefinement.php#a2227d3f4c2e3cde51213d2845c0ce508">MeshRefinement::add_elem</a> (<a class="code" href="classElem.php">Elem</a>* elem)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115   libmesh_assert (elem != NULL);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   
<a name="l00118"></a>00118 <span class="comment">//   // If the unused_elements has any iterators from</span>
<a name="l00119"></a>00119 <span class="comment">//   // old elements, take the first one</span>
<a name="l00120"></a>00120 <span class="comment">//   if (!_unused_elements.empty())</span>
<a name="l00121"></a>00121 <span class="comment">//     {</span>
<a name="l00122"></a>00122 <span class="comment">//       std::vector&lt;Elem*&gt;::iterator it = _unused_elements.front();</span>
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="comment">//       *it = elem;</span>
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="comment">//       _unused_elements.pop_front();</span>
<a name="l00127"></a>00127 <span class="comment">//     }</span>
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="comment">//   // Otherwise, use the conventional add method</span>
<a name="l00130"></a>00130 <span class="comment">//   else</span>
<a name="l00131"></a>00131 <span class="comment">//     {</span>
<a name="l00132"></a>00132 <span class="comment">//       _mesh.add_elem (elem);</span>
<a name="l00133"></a>00133 <span class="comment">//     }</span>
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">// The _unused_elements optimization has been turned off.</span>
<a name="l00136"></a>00136   <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a0f6974cf3e413cfe9caa1fcb4ce8153e">add_elem</a> (elem);
<a name="l00137"></a>00137   
<a name="l00138"></a>00138   <span class="keywordflow">return</span> elem;
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a0ccabd41707c7e688b674b3bc4f3d070">MeshRefinement::create_parent_error_vector</a>
<a name="l00144"></a><a class="code" href="classMeshRefinement.php#a0ccabd41707c7e688b674b3bc4f3d070">00144</a>   (<span class="keyword">const</span> <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00145"></a>00145    <a class="code" href="classErrorVector.php">ErrorVector</a>&amp; error_per_parent,
<a name="l00146"></a>00146    <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; parent_error_min,
<a name="l00147"></a>00147    <a class="code" href="libmesh__common_8h.php#ab685845059e8a2c92743427d9a698c70">Real</a>&amp; parent_error_max)
<a name="l00148"></a>00148 {
<a name="l00149"></a>00149   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00150"></a>00150   parallel_only();
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">// Make sure the input error vector is valid</span>
<a name="l00153"></a>00153 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != error_per_cell.size(); ++i)
<a name="l00155"></a>00155     {
<a name="l00156"></a>00156       libmesh_assert(error_per_cell[i] &gt;= 0);
<a name="l00157"></a>00157   <span class="comment">// isnan() isn&#39;t standard C++ yet</span>
<a name="l00158"></a>00158 <span class="preprocessor">  #ifdef isnan</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>      libmesh_assert(!isnan(error_per_cell[i]));
<a name="l00160"></a>00160 <span class="preprocessor">  #endif</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>    }
<a name="l00162"></a>00162 <span class="preprocessor">#endif // #ifdef DEBUG</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>
<a name="l00164"></a>00164   <span class="comment">// error values on uncoarsenable elements will be left at -1</span>
<a name="l00165"></a>00165   error_per_parent.clear();
<a name="l00166"></a>00166   error_per_parent.resize(error_per_cell.size(), 0.0);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   {
<a name="l00169"></a>00169   <span class="comment">// Find which elements are uncoarsenable</span>
<a name="l00170"></a>00170   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = _mesh.active_local_elements_begin();
<a name="l00171"></a>00171   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = _mesh.active_local_elements_end();
<a name="l00172"></a>00172   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00173"></a>00173     {
<a name="l00174"></a>00174       <a class="code" href="classElem.php">Elem</a>* elem   = *elem_it;
<a name="l00175"></a>00175       <a class="code" href="classElem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177       <span class="comment">// Active elements are uncoarsenable</span>
<a name="l00178"></a>00178       error_per_parent[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] = -1.0;
<a name="l00179"></a>00179 
<a name="l00180"></a>00180       <span class="comment">// Grandparents and up are uncoarsenable</span>
<a name="l00181"></a>00181       <span class="keywordflow">while</span> (parent)
<a name="l00182"></a>00182         {
<a name="l00183"></a>00183           parent = parent-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00184"></a>00184           <span class="keywordflow">if</span> (parent)
<a name="l00185"></a>00185             {
<a name="l00186"></a>00186               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parentid  = parent-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00187"></a>00187               libmesh_assert (parentid &lt; error_per_parent.size());
<a name="l00188"></a>00188               error_per_parent[parentid] = -1.0;
<a name="l00189"></a>00189             }
<a name="l00190"></a>00190         }
<a name="l00191"></a>00191     }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="comment">// Sync between processors.</span>
<a name="l00194"></a>00194   <span class="comment">// Use a reference to std::vector to avoid confusing</span>
<a name="l00195"></a>00195   <span class="comment">// Parallel::min</span>
<a name="l00196"></a>00196   std::vector&lt;ErrorVectorReal&gt; &amp;epp = error_per_parent;
<a name="l00197"></a>00197   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(epp);
<a name="l00198"></a>00198   }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="comment">// The parent&#39;s error is defined as the square root of the</span>
<a name="l00201"></a>00201   <span class="comment">// sum of the children&#39;s errors squared, so errors that are</span>
<a name="l00202"></a>00202   <span class="comment">// Hilbert norms remain Hilbert norms.</span>
<a name="l00203"></a>00203   <span class="comment">//</span>
<a name="l00204"></a>00204   <span class="comment">// Because the children may be on different processors, we</span>
<a name="l00205"></a>00205   <span class="comment">// calculate local contributions to the parents&#39; errors squared</span>
<a name="l00206"></a>00206   <span class="comment">// first, then sum across processors and take the square roots</span>
<a name="l00207"></a>00207   <span class="comment">// second.</span>
<a name="l00208"></a>00208   {
<a name="l00209"></a>00209   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = _mesh.active_local_elements_begin();
<a name="l00210"></a>00210   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = _mesh.active_local_elements_end();
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00213"></a>00213     {
<a name="l00214"></a>00214       <a class="code" href="classElem.php">Elem</a>* elem   = *elem_it;
<a name="l00215"></a>00215       <a class="code" href="classElem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>();
<a name="l00216"></a>00216 
<a name="l00217"></a>00217       <span class="comment">// Calculate each contribution to parent cells</span>
<a name="l00218"></a>00218       <span class="keywordflow">if</span> (parent)
<a name="l00219"></a>00219         {
<a name="l00220"></a>00220           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parentid  = parent-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>();
<a name="l00221"></a>00221           libmesh_assert (parentid &lt; error_per_parent.size());
<a name="l00222"></a>00222 
<a name="l00223"></a>00223           <span class="comment">// If the parent has grandchildren we won&#39;t be able to</span>
<a name="l00224"></a>00224           <span class="comment">// coarsen it, so forget it.  Otherwise, add this child&#39;s</span>
<a name="l00225"></a>00225           <span class="comment">// contribution to the sum of the squared child errors</span>
<a name="l00226"></a>00226           <span class="keywordflow">if</span> (error_per_parent[parentid] != -1.0)
<a name="l00227"></a>00227             error_per_parent[parentid] += (error_per_cell[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()] *
<a name="l00228"></a>00228                                            error_per_cell[elem-&gt;<a class="code" href="classDofObject.php#ad3f6da3b644c6670591f768df4971291">id</a>()]);
<a name="l00229"></a>00229         }
<a name="l00230"></a>00230     }
<a name="l00231"></a>00231   }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <span class="comment">// Sum the vector across all processors</span>
<a name="l00234"></a>00234   Parallel::sum(<span class="keyword">static_cast&lt;</span>std::vector&lt;ErrorVectorReal&gt;&amp;<span class="keyword">&gt;</span>(error_per_parent));
<a name="l00235"></a>00235 
<a name="l00236"></a>00236   <span class="comment">// Calculate the min and max as we loop</span>
<a name="l00237"></a>00237   parent_error_min = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;double&gt;::max</a>();
<a name="l00238"></a>00238   parent_error_max = 0.;
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != error_per_parent.size(); ++i)
<a name="l00241"></a>00241     {
<a name="l00242"></a>00242       <span class="comment">// If this element isn&#39;t a coarsenable parent with error, we</span>
<a name="l00243"></a>00243       <span class="comment">// have nothing to do.  Just flag it as -1 and move on</span>
<a name="l00244"></a>00244       <span class="comment">// Note that Parallel::sum might have left uncoarsenable</span>
<a name="l00245"></a>00245       <span class="comment">// elements with error_per_parent=-n_proc, so reset it to</span>
<a name="l00246"></a>00246       <span class="comment">// error_per_parent=-1</span>
<a name="l00247"></a>00247       <span class="keywordflow">if</span> (error_per_parent[i] &lt; 0.)
<a name="l00248"></a>00248         {
<a name="l00249"></a>00249           error_per_parent[i] = -1.;
<a name="l00250"></a>00250           <span class="keywordflow">continue</span>;
<a name="l00251"></a>00251         }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253       <span class="comment">// The error estimator might have already given us an</span>
<a name="l00254"></a>00254       <span class="comment">// estimate on the coarsenable parent elements; if so then</span>
<a name="l00255"></a>00255       <span class="comment">// we want to retain that estimate</span>
<a name="l00256"></a>00256       <span class="keywordflow">if</span> (error_per_cell[i])
<a name="l00257"></a>00257         {
<a name="l00258"></a>00258           error_per_parent[i] = error_per_cell[i];
<a name="l00259"></a>00259           <span class="keywordflow">continue</span>;
<a name="l00260"></a>00260         }
<a name="l00261"></a>00261       <span class="comment">// if not, then e_parent = sqrt(sum(e_child^2))</span>
<a name="l00262"></a>00262       <span class="keywordflow">else</span>
<a name="l00263"></a>00263         error_per_parent[i] = std::sqrt(error_per_parent[i]);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265       parent_error_min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (parent_error_min,
<a name="l00266"></a>00266                                    error_per_parent[i]);
<a name="l00267"></a>00267       parent_error_max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (parent_error_max,
<a name="l00268"></a>00268                                    error_per_parent[i]);
<a name="l00269"></a>00269     }
<a name="l00270"></a>00270 }
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a><a class="code" href="classMeshRefinement.php#a09537b2ea4265d398d94c1f1e547a2fe">00274</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a09537b2ea4265d398d94c1f1e547a2fe">MeshRefinement::update_nodes_map</a> ()
<a name="l00275"></a>00275 {
<a name="l00276"></a>00276   this-&gt;<a class="code" href="classMeshRefinement.php#a830cefaa2e0f102fc921dc5cae2b5733">_new_nodes_map</a>.<a class="code" href="classLocationMap.php#a11ceffd5adae2b79e2cc0f8ab0b1f73f">init</a>(<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>);
<a name="l00277"></a>00277 } 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a><a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">00281</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">MeshRefinement::test_level_one</a> (<span class="keywordtype">bool</span> libmesh_assert_pass)
<a name="l00282"></a>00282 {
<a name="l00283"></a>00283   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00284"></a>00284   parallel_only();
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00287"></a>00287   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   <span class="keywordtype">bool</span> failure = <span class="keyword">false</span>;
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <span class="keywordflow">for</span> ( ; elem_it != elem_end &amp;&amp; !failure; ++elem_it)
<a name="l00292"></a>00292     {
<a name="l00293"></a>00293       <span class="comment">// Pointer to the element</span>
<a name="l00294"></a>00294       <a class="code" href="classElem.php">Elem</a> *elem = *elem_it;
<a name="l00295"></a>00295 
<a name="l00296"></a>00296       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); n++)
<a name="l00297"></a>00297         {
<a name="l00298"></a>00298           <a class="code" href="classElem.php">Elem</a> *neighbor = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300           <span class="keywordflow">if</span> (!neighbor || !neighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>() ||
<a name="l00301"></a>00301               neighbor == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l00302"></a>00302             <span class="keywordflow">continue</span>;
<a name="l00303"></a>00303 
<a name="l00304"></a>00304           <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() + 1 &lt; elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>()) ||
<a name="l00305"></a>00305               (neighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() + 1 &lt; elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>()) ||
<a name="l00306"></a>00306               (neighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() &gt; elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() + 1))
<a name="l00307"></a>00307             {
<a name="l00308"></a>00308               failure = <span class="keyword">true</span>;
<a name="l00309"></a>00309               <span class="keywordflow">break</span>;
<a name="l00310"></a>00310             }
<a name="l00311"></a>00311         }
<a name="l00312"></a>00312     }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="comment">// If any processor failed, we failed globally</span>
<a name="l00315"></a>00315   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(failure);
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <span class="keywordflow">if</span> (failure)
<a name="l00318"></a>00318     {
<a name="l00319"></a>00319       <span class="comment">// We didn&#39;t pass the level one test, so libmesh_assert that </span>
<a name="l00320"></a>00320       <span class="comment">// we&#39;re allowed not to</span>
<a name="l00321"></a>00321       libmesh_assert(!libmesh_assert_pass);
<a name="l00322"></a>00322       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00323"></a>00323     }
<a name="l00324"></a>00324   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a><a class="code" href="classMeshRefinement.php#aa1fdda385ef81a73833abeac506d48bc">00329</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#aa1fdda385ef81a73833abeac506d48bc">MeshRefinement::test_unflagged</a> (<span class="keywordtype">bool</span> libmesh_assert_pass)
<a name="l00330"></a>00330 {
<a name="l00331"></a>00331   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00332"></a>00332   parallel_only();
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="keywordtype">bool</span> found_flag = <span class="keyword">false</span>;
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// Search for local flags</span>
<a name="l00337"></a>00337   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a9fb46d4dcfe226ea6414ae6bfdb62fad">active_local_elements_begin</a>();
<a name="l00338"></a>00338   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a779dcea0bf1c07c57adc11fb8e482a61">active_local_elements_end</a>();
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00341"></a>00341     {
<a name="l00342"></a>00342       <span class="comment">// Pointer to the element</span>
<a name="l00343"></a>00343       <a class="code" href="classElem.php">Elem</a> *elem = *elem_it;
<a name="l00344"></a>00344 
<a name="l00345"></a>00345       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a> ||
<a name="l00346"></a>00346           elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a> ||
<a name="l00347"></a>00347           elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a> ||
<a name="l00348"></a>00348           elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l00349"></a>00349         {
<a name="l00350"></a>00350           found_flag = <span class="keyword">true</span>;
<a name="l00351"></a>00351           <span class="keywordflow">break</span>;
<a name="l00352"></a>00352         }
<a name="l00353"></a>00353     }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355   <span class="comment">// If we found a flag on any processor, it counts</span>
<a name="l00356"></a>00356   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(found_flag);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358   <span class="keywordflow">if</span> (found_flag)
<a name="l00359"></a>00359     {
<a name="l00360"></a>00360       <span class="comment">// We didn&#39;t pass the &quot;elements are unflagged&quot; test,</span>
<a name="l00361"></a>00361       <span class="comment">// so libmesh_assert that we&#39;re allowed not to</span>
<a name="l00362"></a>00362       libmesh_assert(!libmesh_assert_pass);
<a name="l00363"></a>00363       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00366"></a>00366 }
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a><a class="code" href="classMeshRefinement.php#a0c992129fc3ed9b157eb98f2b75db7d9">00370</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a0c992129fc3ed9b157eb98f2b75db7d9">MeshRefinement::refine_and_coarsen_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l00371"></a>00371 {
<a name="l00372"></a>00372   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00373"></a>00373   parallel_only();
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l00378"></a>00378   <span class="comment">// deprecated</span>
<a name="l00379"></a>00379   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l00380"></a>00380     {
<a name="l00381"></a>00381       libmesh_deprecated();
<a name="l00382"></a>00382     }
<a name="l00383"></a>00383   <span class="keywordflow">else</span>
<a name="l00384"></a>00384     _maintain_level_one = <a class="code" href="classMeshRefinement.php#a6f1ce9fd520404fd1076968ef4c95dad">_face_level_mismatch_limit</a>;
<a name="l00385"></a>00385 
<a name="l00386"></a>00386   <span class="comment">// We can&#39;t yet turn a non-level-one mesh into a level-one mesh</span>
<a name="l00387"></a>00387   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00388"></a>00388     libmesh_assert(<a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <span class="comment">// Possibly clean up the refinement flags from</span>
<a name="l00391"></a>00391   <span class="comment">// a previous step</span>
<a name="l00392"></a>00392   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00393"></a>00393   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00396"></a>00396     {
<a name="l00397"></a>00397       <span class="comment">// Pointer to the element</span>
<a name="l00398"></a>00398       <a class="code" href="classElem.php">Elem</a> *elem = *elem_it;
<a name="l00399"></a>00399 
<a name="l00400"></a>00400       <span class="comment">// Set refinement flag to INACTIVE if the</span>
<a name="l00401"></a>00401       <span class="comment">// element isn&#39;t active</span>
<a name="l00402"></a>00402       <span class="keywordflow">if</span> ( !elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00403"></a>00403         {
<a name="l00404"></a>00404           elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00405"></a>00405           elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00406"></a>00406         }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408       <span class="comment">// This might be left over from the last step</span>
<a name="l00409"></a>00409       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>)
<a name="l00410"></a>00410         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00411"></a>00411     }
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="comment">// Parallel consistency has to come first, or coarsening</span>
<a name="l00414"></a>00414   <span class="comment">// along processor boundaries might occasionally be falsely</span>
<a name="l00415"></a>00415   <span class="comment">// prevented</span>
<a name="l00416"></a>00416   <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00417"></a>00417     this-&gt;<a class="code" href="classMeshRefinement.php#a964d0b5fff0a75536267bc6ad8df166b">make_flags_parallel_consistent</a>();
<a name="l00418"></a>00418 
<a name="l00419"></a>00419   <span class="comment">// Repeat until flag changes match on every processor</span>
<a name="l00420"></a>00420   <span class="keywordflow">do</span>
<a name="l00421"></a>00421     {
<a name="l00422"></a>00422       <span class="comment">// Repeat until coarsening &amp; refinement flags jive</span>
<a name="l00423"></a>00423       <span class="keywordtype">bool</span> satisfied = <span class="keyword">false</span>;
<a name="l00424"></a>00424       <span class="keywordflow">do</span>
<a name="l00425"></a>00425         {
<a name="l00426"></a>00426           <span class="keyword">const</span> <span class="keywordtype">bool</span> coarsening_satisfied =
<a name="l00427"></a>00427             this-&gt;<a class="code" href="classMeshRefinement.php#a960de39287ae7d4821527767af11ea09">make_coarsening_compatible</a>(maintain_level_one);
<a name="l00428"></a>00428 
<a name="l00429"></a>00429           <span class="keyword">const</span> <span class="keywordtype">bool</span> refinement_satisfied =
<a name="l00430"></a>00430             this-&gt;<a class="code" href="classMeshRefinement.php#a95d2a98b52ef5a7360e4cba48b182c05">make_refinement_compatible</a>(maintain_level_one);
<a name="l00431"></a>00431 
<a name="l00432"></a>00432           <span class="keywordtype">bool</span> smoothing_satisfied = 
<a name="l00433"></a>00433             !this-&gt;<a class="code" href="classMeshRefinement.php#a0c58ffb7438dae0abb7a01b00a806400">eliminate_unrefined_patches</a>();
<a name="l00434"></a>00434 
<a name="l00435"></a>00435           <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#af529cf6d70ea8e067d667f07269862a7">_edge_level_mismatch_limit</a>)
<a name="l00436"></a>00436             smoothing_satisfied = smoothing_satisfied &amp;&amp; 
<a name="l00437"></a>00437               !this-&gt;<a class="code" href="classMeshRefinement.php#ab10822f9e5af57f3816bdb766d315fd3">limit_level_mismatch_at_edge</a> (<a class="code" href="classMeshRefinement.php#af529cf6d70ea8e067d667f07269862a7">_edge_level_mismatch_limit</a>);
<a name="l00438"></a>00438 
<a name="l00439"></a>00439           <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a46b608a8db8dbb59f693a137e19ea458">_node_level_mismatch_limit</a>)
<a name="l00440"></a>00440             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00441"></a>00441               !this-&gt;<a class="code" href="classMeshRefinement.php#a679686967e6929094bb35a045836c409">limit_level_mismatch_at_node</a> (<a class="code" href="classMeshRefinement.php#a46b608a8db8dbb59f693a137e19ea458">_node_level_mismatch_limit</a>);
<a name="l00442"></a>00442 
<a name="l00443"></a>00443           satisfied = (coarsening_satisfied &amp;&amp;
<a name="l00444"></a>00444                        refinement_satisfied &amp;&amp;
<a name="l00445"></a>00445                        smoothing_satisfied);
<a name="l00446"></a>00446 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00447"></a>00447 <span class="preprocessor"></span>          <span class="keywordtype">bool</span> max_satisfied = satisfied,
<a name="l00448"></a>00448                min_satisfied = satisfied;
<a name="l00449"></a>00449           <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_satisfied);
<a name="l00450"></a>00450           <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_satisfied);
<a name="l00451"></a>00451           libmesh_assert (satisfied == max_satisfied);
<a name="l00452"></a>00452           libmesh_assert (satisfied == min_satisfied);
<a name="l00453"></a>00453 <span class="preprocessor">#endif</span>
<a name="l00454"></a>00454 <span class="preprocessor"></span>        }
<a name="l00455"></a>00455       <span class="keywordflow">while</span> (!satisfied);
<a name="l00456"></a>00456     }
<a name="l00457"></a>00457   <span class="keywordflow">while</span> (!<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>() &amp;&amp; !this-&gt;<a class="code" href="classMeshRefinement.php#a964d0b5fff0a75536267bc6ad8df166b">make_flags_parallel_consistent</a>());
<a name="l00458"></a>00458 
<a name="l00459"></a>00459   <span class="comment">// First coarsen the flagged elements.</span>
<a name="l00460"></a>00460   <span class="keyword">const</span> <span class="keywordtype">bool</span> coarsening_changed_mesh =
<a name="l00461"></a>00461     this-&gt;<a class="code" href="classMeshRefinement.php#ae33151743e5987e4d216eac6a1142376">_coarsen_elements</a> ();
<a name="l00462"></a>00462 
<a name="l00463"></a>00463   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00464"></a>00464     libmesh_assert(<a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00465"></a>00465   libmesh_assert(this-&gt;<a class="code" href="classMeshRefinement.php#a960de39287ae7d4821527767af11ea09">make_coarsening_compatible</a>(maintain_level_one));
<a name="l00466"></a>00466   libmesh_assert(this-&gt;<a class="code" href="classMeshRefinement.php#a95d2a98b52ef5a7360e4cba48b182c05">make_refinement_compatible</a>(maintain_level_one));
<a name="l00467"></a>00467 <span class="comment">// FIXME: This won&#39;t pass unless we add a redundant find_neighbors()</span>
<a name="l00468"></a>00468 <span class="comment">// call or replace find_neighbors() with on-the-fly neighbor updating</span>
<a name="l00469"></a>00469 <span class="comment">// libmesh_assert(!this-&gt;eliminate_unrefined_patches());</span>
<a name="l00470"></a>00470 
<a name="l00471"></a>00471   <span class="comment">// We can&#39;t contract the mesh ourselves anymore - a System might</span>
<a name="l00472"></a>00472   <span class="comment">// need to restrict old coefficient vectors first</span>
<a name="l00473"></a>00473   <span class="comment">// _mesh.contract();</span>
<a name="l00474"></a>00474 
<a name="l00475"></a>00475   <span class="comment">// Now refine the flagged elements.  This will</span>
<a name="l00476"></a>00476   <span class="comment">// take up some space, maybe more than what was freed.</span>
<a name="l00477"></a>00477   <span class="keyword">const</span> <span class="keywordtype">bool</span> refining_changed_mesh =
<a name="l00478"></a>00478     this-&gt;<a class="code" href="classMeshRefinement.php#a2edc635e999cae1d61575a7dd54ca782">_refine_elements</a>();
<a name="l00479"></a>00479 
<a name="l00480"></a>00480   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00481"></a>00481     libmesh_assert(<a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00482"></a>00482   libmesh_assert(<a class="code" href="classMeshRefinement.php#aa1fdda385ef81a73833abeac506d48bc">test_unflagged</a>(<span class="keyword">true</span>));
<a name="l00483"></a>00483   libmesh_assert(this-&gt;<a class="code" href="classMeshRefinement.php#a960de39287ae7d4821527767af11ea09">make_coarsening_compatible</a>(maintain_level_one));
<a name="l00484"></a>00484   libmesh_assert(this-&gt;<a class="code" href="classMeshRefinement.php#a95d2a98b52ef5a7360e4cba48b182c05">make_refinement_compatible</a>(maintain_level_one));
<a name="l00485"></a>00485 <span class="comment">// FIXME: This won&#39;t pass unless we add a redundant find_neighbors()</span>
<a name="l00486"></a>00486 <span class="comment">// call or replace find_neighbors() with on-the-fly neighbor updating</span>
<a name="l00487"></a>00487 <span class="comment">// libmesh_assert(!this-&gt;eliminate_unrefined_patches());</span>
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   <span class="comment">// Finally, the new mesh needs to be prepared for use</span>
<a name="l00490"></a>00490   <span class="keywordflow">if</span> (coarsening_changed_mesh || refining_changed_mesh)
<a name="l00491"></a>00491     {
<a name="l00492"></a>00492 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00493"></a>00493 <span class="preprocessor"></span>      <a class="code" href="classParallelMesh.php">ParallelMesh</a> *pmesh = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classParallelMesh.php">ParallelMesh</a> *<span class="keyword">&gt;</span>(&amp;<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>);
<a name="l00494"></a>00494       <span class="keywordflow">if</span> (pmesh)
<a name="l00495"></a>00495         pmesh-&gt;<a class="code" href="classParallelMesh.php#aa17a6d0f8e2d57519d42f7be307d6ee3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00496"></a>00496 <span class="preprocessor">#endif</span>
<a name="l00497"></a>00497 <span class="preprocessor"></span>      <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a> ();
<a name="l00498"></a>00498       
<a name="l00499"></a>00499       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00500"></a>00500     }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   <span class="comment">// Otherwise there was no change in the mesh,</span>
<a name="l00503"></a>00503   <span class="comment">// let the user know.  Also, there is no need</span>
<a name="l00504"></a>00504   <span class="comment">// to prepare the mesh for use since it did not change.</span>
<a name="l00505"></a>00505   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00506"></a>00506     
<a name="l00507"></a>00507 }
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 
<a name="l00515"></a><a class="code" href="classMeshRefinement.php#a34f81cc5a33c88fffe936b191e48cb24">00515</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a34f81cc5a33c88fffe936b191e48cb24">MeshRefinement::coarsen_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l00516"></a>00516 {
<a name="l00517"></a>00517   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00518"></a>00518   parallel_only();
<a name="l00519"></a>00519 
<a name="l00520"></a>00520   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l00523"></a>00523   <span class="comment">// deprecated</span>
<a name="l00524"></a>00524   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l00525"></a>00525     {
<a name="l00526"></a>00526       libmesh_deprecated();
<a name="l00527"></a>00527     }
<a name="l00528"></a>00528   <span class="keywordflow">else</span>
<a name="l00529"></a>00529     _maintain_level_one = <a class="code" href="classMeshRefinement.php#a6f1ce9fd520404fd1076968ef4c95dad">_face_level_mismatch_limit</a>;
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   <span class="comment">// We can&#39;t yet turn a non-level-one mesh into a level-one mesh</span>
<a name="l00532"></a>00532   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00533"></a>00533     libmesh_assert(<a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <span class="comment">// Possibly clean up the refinement flags from</span>
<a name="l00536"></a>00536   <span class="comment">// a previous step</span>
<a name="l00537"></a>00537   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00538"></a>00538   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00539"></a>00539 
<a name="l00540"></a>00540   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00541"></a>00541     {
<a name="l00542"></a>00542       <span class="comment">// Pointer to the element</span>
<a name="l00543"></a>00543       <a class="code" href="classElem.php">Elem</a>* elem = *elem_it;
<a name="l00544"></a>00544 
<a name="l00545"></a>00545       <span class="comment">// Set refinement flag to INACTIVE if the</span>
<a name="l00546"></a>00546       <span class="comment">// element isn&#39;t active</span>
<a name="l00547"></a>00547       <span class="keywordflow">if</span> ( !elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00548"></a>00548         {
<a name="l00549"></a>00549           elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00550"></a>00550           elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00551"></a>00551         }
<a name="l00552"></a>00552 
<a name="l00553"></a>00553       <span class="comment">// This might be left over from the last step</span>
<a name="l00554"></a>00554       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>)
<a name="l00555"></a>00555         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00556"></a>00556     }
<a name="l00557"></a>00557 
<a name="l00558"></a>00558   <span class="comment">// Parallel consistency has to come first, or coarsening</span>
<a name="l00559"></a>00559   <span class="comment">// along processor boundaries might occasionally be falsely</span>
<a name="l00560"></a>00560   <span class="comment">// prevented</span>
<a name="l00561"></a>00561   <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00562"></a>00562     this-&gt;<a class="code" href="classMeshRefinement.php#a964d0b5fff0a75536267bc6ad8df166b">make_flags_parallel_consistent</a>();
<a name="l00563"></a>00563 
<a name="l00564"></a>00564   <span class="comment">// Repeat until flag changes match on every processor</span>
<a name="l00565"></a>00565   <span class="keywordflow">do</span>
<a name="l00566"></a>00566     {
<a name="l00567"></a>00567       <span class="comment">// Repeat until the flags form a conforming mesh.</span>
<a name="l00568"></a>00568       <span class="keywordtype">bool</span> satisfied = <span class="keyword">false</span>;
<a name="l00569"></a>00569       <span class="keywordflow">do</span>
<a name="l00570"></a>00570         {
<a name="l00571"></a>00571           <span class="keyword">const</span> <span class="keywordtype">bool</span> coarsening_satisfied =
<a name="l00572"></a>00572             this-&gt;<a class="code" href="classMeshRefinement.php#a960de39287ae7d4821527767af11ea09">make_coarsening_compatible</a>(maintain_level_one);
<a name="l00573"></a>00573 
<a name="l00574"></a>00574           <span class="keywordtype">bool</span> smoothing_satisfied = 
<a name="l00575"></a>00575             !this-&gt;<a class="code" href="classMeshRefinement.php#a0c58ffb7438dae0abb7a01b00a806400">eliminate_unrefined_patches</a>();<span class="comment">// &amp;&amp;</span>
<a name="l00576"></a>00576 
<a name="l00577"></a>00577           <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#af529cf6d70ea8e067d667f07269862a7">_edge_level_mismatch_limit</a>)
<a name="l00578"></a>00578             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00579"></a>00579               !this-&gt;<a class="code" href="classMeshRefinement.php#ab10822f9e5af57f3816bdb766d315fd3">limit_level_mismatch_at_edge</a> (<a class="code" href="classMeshRefinement.php#af529cf6d70ea8e067d667f07269862a7">_edge_level_mismatch_limit</a>);
<a name="l00580"></a>00580 
<a name="l00581"></a>00581           <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a46b608a8db8dbb59f693a137e19ea458">_node_level_mismatch_limit</a>)
<a name="l00582"></a>00582             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00583"></a>00583               !this-&gt;<a class="code" href="classMeshRefinement.php#a679686967e6929094bb35a045836c409">limit_level_mismatch_at_node</a> (<a class="code" href="classMeshRefinement.php#a46b608a8db8dbb59f693a137e19ea458">_node_level_mismatch_limit</a>);
<a name="l00584"></a>00584 
<a name="l00585"></a>00585           satisfied = (coarsening_satisfied &amp;&amp;
<a name="l00586"></a>00586                        smoothing_satisfied);
<a name="l00587"></a>00587 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00588"></a>00588 <span class="preprocessor"></span>          <span class="keywordtype">bool</span> max_satisfied = satisfied,
<a name="l00589"></a>00589                min_satisfied = satisfied;
<a name="l00590"></a>00590           <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_satisfied);
<a name="l00591"></a>00591           <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_satisfied);
<a name="l00592"></a>00592           libmesh_assert (satisfied == max_satisfied);
<a name="l00593"></a>00593           libmesh_assert (satisfied == min_satisfied);
<a name="l00594"></a>00594 <span class="preprocessor">#endif</span>
<a name="l00595"></a>00595 <span class="preprocessor"></span>        }
<a name="l00596"></a>00596       <span class="keywordflow">while</span> (!satisfied);
<a name="l00597"></a>00597     }
<a name="l00598"></a>00598   <span class="keywordflow">while</span> (!<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>() &amp;&amp; !this-&gt;<a class="code" href="classMeshRefinement.php#a964d0b5fff0a75536267bc6ad8df166b">make_flags_parallel_consistent</a>());
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   <span class="comment">// Coarsen the flagged elements.</span>
<a name="l00601"></a>00601   <span class="keyword">const</span> <span class="keywordtype">bool</span> mesh_changed = 
<a name="l00602"></a>00602     this-&gt;<a class="code" href="classMeshRefinement.php#ae33151743e5987e4d216eac6a1142376">_coarsen_elements</a> ();
<a name="l00603"></a>00603 
<a name="l00604"></a>00604   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00605"></a>00605     libmesh_assert(<a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00606"></a>00606   libmesh_assert(this-&gt;<a class="code" href="classMeshRefinement.php#a960de39287ae7d4821527767af11ea09">make_coarsening_compatible</a>(maintain_level_one));
<a name="l00607"></a>00607 <span class="comment">// FIXME: This won&#39;t pass unless we add a redundant find_neighbors()</span>
<a name="l00608"></a>00608 <span class="comment">// call or replace find_neighbors() with on-the-fly neighbor updating</span>
<a name="l00609"></a>00609 <span class="comment">// libmesh_assert(!this-&gt;eliminate_unrefined_patches());</span>
<a name="l00610"></a>00610     
<a name="l00611"></a>00611   <span class="comment">// We can&#39;t contract the mesh ourselves anymore - a System might</span>
<a name="l00612"></a>00612   <span class="comment">// need to restrict old coefficient vectors first</span>
<a name="l00613"></a>00613   <span class="comment">// _mesh.contract();</span>
<a name="l00614"></a>00614 
<a name="l00615"></a>00615   <span class="comment">// Finally, the new mesh may need to be prepared for use</span>
<a name="l00616"></a>00616   <span class="keywordflow">if</span> (mesh_changed)
<a name="l00617"></a>00617     <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a> ();
<a name="l00618"></a>00618 
<a name="l00619"></a>00619   <span class="keywordflow">return</span> mesh_changed;
<a name="l00620"></a>00620 }
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 
<a name="l00627"></a>00627 
<a name="l00628"></a><a class="code" href="classMeshRefinement.php#ae8312ffdcfe06d7e83c4fde95480c299">00628</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#ae8312ffdcfe06d7e83c4fde95480c299">MeshRefinement::refine_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l00629"></a>00629 {
<a name="l00630"></a>00630   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00631"></a>00631   parallel_only();
<a name="l00632"></a>00632 
<a name="l00633"></a>00633   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l00634"></a>00634 
<a name="l00635"></a>00635   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l00636"></a>00636   <span class="comment">// deprecated</span>
<a name="l00637"></a>00637   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l00638"></a>00638     {
<a name="l00639"></a>00639       libmesh_deprecated();
<a name="l00640"></a>00640     }
<a name="l00641"></a>00641   <span class="keywordflow">else</span>
<a name="l00642"></a>00642     _maintain_level_one = <a class="code" href="classMeshRefinement.php#a6f1ce9fd520404fd1076968ef4c95dad">_face_level_mismatch_limit</a>;
<a name="l00643"></a>00643 
<a name="l00644"></a>00644   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00645"></a>00645     libmesh_assert(<a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00646"></a>00646 
<a name="l00647"></a>00647   <span class="comment">// Possibly clean up the refinement flags from</span>
<a name="l00648"></a>00648   <span class="comment">// a previous step</span>
<a name="l00649"></a>00649   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l00650"></a>00650   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00653"></a>00653     {
<a name="l00654"></a>00654       <span class="comment">// Pointer to the element</span>
<a name="l00655"></a>00655       <a class="code" href="classElem.php">Elem</a> *elem = *elem_it;
<a name="l00656"></a>00656 
<a name="l00657"></a>00657       <span class="comment">// Set refinement flag to INACTIVE if the</span>
<a name="l00658"></a>00658       <span class="comment">// element isn&#39;t active</span>
<a name="l00659"></a>00659       <span class="keywordflow">if</span> ( !elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l00660"></a>00660         {
<a name="l00661"></a>00661           elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00662"></a>00662           elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l00663"></a>00663         }
<a name="l00664"></a>00664 
<a name="l00665"></a>00665       <span class="comment">// This might be left over from the last step</span>
<a name="l00666"></a>00666       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>)
<a name="l00667"></a>00667         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00668"></a>00668     }
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671   
<a name="l00672"></a>00672   <span class="comment">// Parallel consistency has to come first, or coarsening</span>
<a name="l00673"></a>00673   <span class="comment">// along processor boundaries might occasionally be falsely</span>
<a name="l00674"></a>00674   <span class="comment">// prevented</span>
<a name="l00675"></a>00675   <span class="keywordflow">if</span> (!<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l00676"></a>00676     this-&gt;<a class="code" href="classMeshRefinement.php#a964d0b5fff0a75536267bc6ad8df166b">make_flags_parallel_consistent</a>();
<a name="l00677"></a>00677 
<a name="l00678"></a>00678   <span class="comment">// Repeat until flag changes match on every processor</span>
<a name="l00679"></a>00679   <span class="keywordflow">do</span>
<a name="l00680"></a>00680     {
<a name="l00681"></a>00681       <span class="comment">// Repeat until coarsening &amp; refinement flags jive</span>
<a name="l00682"></a>00682       <span class="keywordtype">bool</span> satisfied = <span class="keyword">false</span>;
<a name="l00683"></a>00683       <span class="keywordflow">do</span>
<a name="l00684"></a>00684         {
<a name="l00685"></a>00685           <span class="keyword">const</span> <span class="keywordtype">bool</span> refinement_satisfied =
<a name="l00686"></a>00686             this-&gt;<a class="code" href="classMeshRefinement.php#a95d2a98b52ef5a7360e4cba48b182c05">make_refinement_compatible</a>(maintain_level_one);
<a name="l00687"></a>00687 
<a name="l00688"></a>00688           <span class="keywordtype">bool</span> smoothing_satisfied = 
<a name="l00689"></a>00689             !this-&gt;<a class="code" href="classMeshRefinement.php#a0c58ffb7438dae0abb7a01b00a806400">eliminate_unrefined_patches</a>();<span class="comment">// &amp;&amp;</span>
<a name="l00690"></a>00690 
<a name="l00691"></a>00691           <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#af529cf6d70ea8e067d667f07269862a7">_edge_level_mismatch_limit</a>)
<a name="l00692"></a>00692             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00693"></a>00693               !this-&gt;<a class="code" href="classMeshRefinement.php#ab10822f9e5af57f3816bdb766d315fd3">limit_level_mismatch_at_edge</a> (<a class="code" href="classMeshRefinement.php#af529cf6d70ea8e067d667f07269862a7">_edge_level_mismatch_limit</a>);
<a name="l00694"></a>00694 
<a name="l00695"></a>00695           <span class="keywordflow">if</span> (<a class="code" href="classMeshRefinement.php#a46b608a8db8dbb59f693a137e19ea458">_node_level_mismatch_limit</a>)
<a name="l00696"></a>00696             smoothing_satisfied = smoothing_satisfied &amp;&amp;
<a name="l00697"></a>00697               !this-&gt;<a class="code" href="classMeshRefinement.php#a679686967e6929094bb35a045836c409">limit_level_mismatch_at_node</a> (<a class="code" href="classMeshRefinement.php#a46b608a8db8dbb59f693a137e19ea458">_node_level_mismatch_limit</a>);
<a name="l00698"></a>00698 
<a name="l00699"></a>00699           satisfied = (refinement_satisfied &amp;&amp;
<a name="l00700"></a>00700                        smoothing_satisfied);
<a name="l00701"></a>00701 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00702"></a>00702 <span class="preprocessor"></span>          <span class="keywordtype">bool</span> max_satisfied = satisfied,
<a name="l00703"></a>00703                min_satisfied = satisfied;
<a name="l00704"></a>00704           <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_satisfied);
<a name="l00705"></a>00705           <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_satisfied);
<a name="l00706"></a>00706           libmesh_assert (satisfied == max_satisfied);
<a name="l00707"></a>00707           libmesh_assert (satisfied == min_satisfied);
<a name="l00708"></a>00708 <span class="preprocessor">#endif</span>
<a name="l00709"></a>00709 <span class="preprocessor"></span>        }
<a name="l00710"></a>00710       <span class="keywordflow">while</span> (!satisfied);
<a name="l00711"></a>00711     }
<a name="l00712"></a>00712   <span class="keywordflow">while</span> (!<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>() &amp;&amp; !this-&gt;<a class="code" href="classMeshRefinement.php#a964d0b5fff0a75536267bc6ad8df166b">make_flags_parallel_consistent</a>());
<a name="l00713"></a>00713   
<a name="l00714"></a>00714   <span class="comment">// Now refine the flagged elements.  This will</span>
<a name="l00715"></a>00715   <span class="comment">// take up some space, maybe more than what was freed.</span>
<a name="l00716"></a>00716   <span class="keyword">const</span> <span class="keywordtype">bool</span> mesh_changed = 
<a name="l00717"></a>00717     this-&gt;<a class="code" href="classMeshRefinement.php#a2edc635e999cae1d61575a7dd54ca782">_refine_elements</a>();
<a name="l00718"></a>00718 
<a name="l00719"></a>00719   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00720"></a>00720     libmesh_assert(<a class="code" href="classMeshRefinement.php#ac11ceeab37e4935d02192813c539358d">test_level_one</a>(<span class="keyword">true</span>));
<a name="l00721"></a>00721   libmesh_assert(this-&gt;<a class="code" href="classMeshRefinement.php#a95d2a98b52ef5a7360e4cba48b182c05">make_refinement_compatible</a>(maintain_level_one));
<a name="l00722"></a>00722 <span class="comment">// FIXME: This won&#39;t pass unless we add a redundant find_neighbors()</span>
<a name="l00723"></a>00723 <span class="comment">// call or replace find_neighbors() with on-the-fly neighbor updating</span>
<a name="l00724"></a>00724 <span class="comment">// libmesh_assert(!this-&gt;eliminate_unrefined_patches());</span>
<a name="l00725"></a>00725     
<a name="l00726"></a>00726   <span class="comment">// Finally, the new mesh needs to be prepared for use</span>
<a name="l00727"></a>00727   <span class="keywordflow">if</span> (mesh_changed)
<a name="l00728"></a>00728     <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a> ();
<a name="l00729"></a>00729 
<a name="l00730"></a>00730   <span class="keywordflow">return</span> mesh_changed;
<a name="l00731"></a>00731 }
<a name="l00732"></a>00732 
<a name="l00733"></a>00733 
<a name="l00734"></a>00734 <span class="comment">// Functor for make_flags_parallel_consistent</span>
<a name="l00735"></a>00735 <span class="keyword">namespace </span>{
<a name="l00736"></a>00736 
<a name="l00737"></a>00737 <span class="keyword">struct </span>SyncRefinementFlags
<a name="l00738"></a>00738 {
<a name="l00739"></a>00739 <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> datum;
<a name="l00740"></a>00740 <span class="keyword">typedef</span> <a class="code" href="classElem.php#a946039859488cca879512de516fef829">Elem::RefinementState</a> (<a class="code" href="classElem.php">Elem</a>::*get_a_flag)() <span class="keyword">const</span>;
<a name="l00741"></a>00741 <span class="keyword">typedef</span> void (<a class="code" href="classElem.php">Elem</a>::*set_a_flag)(<span class="keyword">const</span> <a class="code" href="classElem.php#a946039859488cca879512de516fef829">Elem::RefinementState</a>);
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 SyncRefinementFlags(<a class="code" href="classMeshBase.php">MeshBase</a> &amp;_mesh,
<a name="l00744"></a>00744                     get_a_flag _getter,
<a name="l00745"></a>00745                     set_a_flag _setter) :
<a name="l00746"></a>00746   mesh(_mesh), parallel_consistent(true),
<a name="l00747"></a>00747   get_flag(_getter), set_flag(_setter) {}
<a name="l00748"></a>00748 
<a name="l00749"></a>00749 <a class="code" href="classMeshBase.php">MeshBase</a> &amp;mesh;
<a name="l00750"></a>00750 <span class="keywordtype">bool</span> parallel_consistent;
<a name="l00751"></a>00751 get_a_flag get_flag;
<a name="l00752"></a>00752 set_a_flag set_flag;
<a name="l00753"></a>00753 <span class="comment">// References to pointers to member functions segfault?</span>
<a name="l00754"></a>00754 <span class="comment">// get_a_flag&amp; get_flag;</span>
<a name="l00755"></a>00755 <span class="comment">// set_a_flag&amp; set_flag;</span>
<a name="l00756"></a>00756 
<a name="l00757"></a>00757 <span class="comment">// Find the refinement flag on each requested element</span>
<a name="l00758"></a>00758 <span class="keywordtype">void</span> gather_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l00759"></a>00759                   std::vector&lt;datum&gt;&amp; flags)
<a name="l00760"></a>00760 {
<a name="l00761"></a>00761   flags.resize(ids.size());
<a name="l00762"></a>00762 
<a name="l00763"></a>00763   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != ids.size(); ++i)
<a name="l00764"></a>00764     {
<a name="l00765"></a>00765       <span class="comment">// Look for this element in the mesh</span>
<a name="l00766"></a>00766       <a class="code" href="classElem.php">Elem</a> *elem = mesh.elem(ids[i]);
<a name="l00767"></a>00767 
<a name="l00768"></a>00768       <span class="comment">// We&#39;d better find every element we&#39;re asked for</span>
<a name="l00769"></a>00769       libmesh_assert (elem);
<a name="l00770"></a>00770 
<a name="l00771"></a>00771       <span class="comment">// Return the element&#39;s refinement flag</span>
<a name="l00772"></a>00772       flags[i] = (elem-&gt;*get_flag)();
<a name="l00773"></a>00773     }
<a name="l00774"></a>00774 }
<a name="l00775"></a>00775 
<a name="l00776"></a>00776 <span class="keywordtype">void</span> act_on_data (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ids,
<a name="l00777"></a>00777                   std::vector&lt;datum&gt;&amp; flags)
<a name="l00778"></a>00778 {
<a name="l00779"></a>00779   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != ids.size(); ++i)
<a name="l00780"></a>00780     {
<a name="l00781"></a>00781       <a class="code" href="classElem.php">Elem</a> *elem = mesh.elem(ids[i]);
<a name="l00782"></a>00782 
<a name="l00783"></a>00783       libmesh_assert(elem);
<a name="l00784"></a>00784 
<a name="l00785"></a>00785       datum old_flag = (elem-&gt;*get_flag)();
<a name="l00786"></a>00786       datum &amp;new_flag = flags[i];
<a name="l00787"></a>00787 
<a name="l00788"></a>00788       <span class="keywordflow">if</span> (old_flag != new_flag)
<a name="l00789"></a>00789         {
<a name="l00790"></a>00790           <span class="comment">// It&#39;s possible for foreign flags to be (temporarily) more</span>
<a name="l00791"></a>00791           <span class="comment">// conservative than our own, such as when a refinement in</span>
<a name="l00792"></a>00792           <span class="comment">// one of the foreign processor&#39;s elements is mandated by a</span>
<a name="l00793"></a>00793           <span class="comment">// refinement in one of our neighboring elements it can see</span>
<a name="l00794"></a>00794           <span class="comment">// which was mandated by a refinement in one of our</span>
<a name="l00795"></a>00795           <span class="comment">// neighboring elements it can&#39;t see</span>
<a name="l00796"></a>00796           <span class="comment">// libmesh_assert (!(new_flag != Elem::REFINE &amp;&amp; </span>
<a name="l00797"></a>00797           <span class="comment">//                   old_flag == Elem::REFINE));</span>
<a name="l00798"></a>00798           <span class="comment">//</span>
<a name="l00799"></a>00799           (elem-&gt;*set_flag)
<a name="l00800"></a>00800             (static_cast&lt;Elem::RefinementState&gt;(new_flag));
<a name="l00801"></a>00801           parallel_consistent = <span class="keyword">false</span>;
<a name="l00802"></a>00802         }
<a name="l00803"></a>00803     }
<a name="l00804"></a>00804 }
<a name="l00805"></a>00805 };
<a name="l00806"></a>00806 }
<a name="l00807"></a>00807 
<a name="l00808"></a>00808 
<a name="l00809"></a>00809 
<a name="l00810"></a><a class="code" href="classMeshRefinement.php#a964d0b5fff0a75536267bc6ad8df166b">00810</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a964d0b5fff0a75536267bc6ad8df166b">MeshRefinement::make_flags_parallel_consistent</a>()
<a name="l00811"></a>00811 {
<a name="l00812"></a>00812   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00813"></a>00813   parallel_only();
<a name="l00814"></a>00814 
<a name="l00815"></a>00815   START_LOG (<span class="stringliteral">&quot;make_flags_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00816"></a>00816 
<a name="l00817"></a>00817   SyncRefinementFlags hsync(<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>, &amp;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">Elem::refinement_flag</a>,
<a name="l00818"></a>00818                             &amp;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">Elem::set_refinement_flag</a>);
<a name="l00819"></a>00819   <a class="code" href="namespaceParallel.php#ab9f27623ac0ba8ee92c34c881386afe5">Parallel::sync_dofobject_data_by_id</a>
<a name="l00820"></a>00820     (<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>(), <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(), hsync);
<a name="l00821"></a>00821 
<a name="l00822"></a>00822   SyncRefinementFlags psync(<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>, &amp;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">Elem::p_refinement_flag</a>,
<a name="l00823"></a>00823                             &amp;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">Elem::set_p_refinement_flag</a>);
<a name="l00824"></a>00824   <a class="code" href="namespaceParallel.php#ab9f27623ac0ba8ee92c34c881386afe5">Parallel::sync_dofobject_data_by_id</a>
<a name="l00825"></a>00825     (<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>(), <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(), psync);
<a name="l00826"></a>00826 
<a name="l00827"></a>00827   <span class="comment">// If we weren&#39;t consistent in both h and p on every processor then</span>
<a name="l00828"></a>00828   <span class="comment">// we weren&#39;t globally consistent</span>
<a name="l00829"></a>00829   <span class="keywordtype">bool</span> parallel_consistent = hsync.parallel_consistent &amp;&amp;
<a name="l00830"></a>00830                              psync.parallel_consistent;
<a name="l00831"></a>00831   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(parallel_consistent);
<a name="l00832"></a>00832 
<a name="l00833"></a>00833   STOP_LOG (<span class="stringliteral">&quot;make_flags_parallel_consistent()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00834"></a>00834 
<a name="l00835"></a>00835   <span class="keywordflow">return</span> parallel_consistent;
<a name="l00836"></a>00836 }
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 
<a name="l00839"></a>00839 
<a name="l00840"></a><a class="code" href="classMeshRefinement.php#a960de39287ae7d4821527767af11ea09">00840</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a960de39287ae7d4821527767af11ea09">MeshRefinement::make_coarsening_compatible</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l00841"></a>00841 {
<a name="l00842"></a>00842   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00843"></a>00843   parallel_only();
<a name="l00844"></a>00844 
<a name="l00845"></a>00845   START_LOG (<span class="stringliteral">&quot;make_coarsening_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00846"></a>00846   
<a name="l00847"></a>00847   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l00848"></a>00848 
<a name="l00849"></a>00849   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l00850"></a>00850   <span class="comment">// deprecated</span>
<a name="l00851"></a>00851   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l00852"></a>00852     {
<a name="l00853"></a>00853       libmesh_deprecated();
<a name="l00854"></a>00854     }
<a name="l00855"></a>00855   <span class="keywordflow">else</span>
<a name="l00856"></a>00856     _maintain_level_one = <a class="code" href="classMeshRefinement.php#a6f1ce9fd520404fd1076968ef4c95dad">_face_level_mismatch_limit</a>;
<a name="l00857"></a>00857 
<a name="l00858"></a>00858   
<a name="l00859"></a>00859   <span class="comment">// Unless we encounter a specific situation level-one</span>
<a name="l00860"></a>00860   <span class="comment">// will be satisfied after executing this loop just once   </span>
<a name="l00861"></a>00861   <span class="keywordtype">bool</span> level_one_satisfied = <span class="keyword">true</span>;
<a name="l00862"></a>00862 
<a name="l00863"></a>00863   
<a name="l00864"></a>00864   <span class="comment">// Unless we encounter a specific situation we will be compatible</span>
<a name="l00865"></a>00865   <span class="comment">// with any selected refinement flags</span>
<a name="l00866"></a>00866   <span class="keywordtype">bool</span> compatible_with_refinement = <span class="keyword">true</span>;
<a name="l00867"></a>00867 
<a name="l00868"></a>00868   
<a name="l00869"></a>00869   <span class="comment">// find the maximum h and p levels in the mesh   </span>
<a name="l00870"></a>00870   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceMeshTools.php#aa7528fd4ca1533ce837c7aedc6a9a108">max_level</a> = 0;
<a name="l00871"></a>00871   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_p_level = 0;
<a name="l00872"></a>00872     
<a name="l00873"></a>00873   
<a name="l00874"></a>00874   <span class="comment">// First we look at all the active level-0 elements.  Since it doesn&#39;t make</span>
<a name="l00875"></a>00875   <span class="comment">// sense to coarsen them we must un-set their coarsen flags if</span>
<a name="l00876"></a>00876   <span class="comment">// they are set.   </span>
<a name="l00877"></a>00877   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00878"></a>00878   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00879"></a>00879 
<a name="l00880"></a>00880   <span class="keywordflow">for</span> (; el != end_el; ++el)
<a name="l00881"></a>00881     {      
<a name="l00882"></a>00882       <a class="code" href="classElem.php">Elem</a> *elem = *el;
<a name="l00883"></a>00883       max_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_level, elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>());
<a name="l00884"></a>00884       max_p_level =
<a name="l00885"></a>00885         <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_p_level,
<a name="l00886"></a>00886                  static_cast&lt;unsigned int&gt;(elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>()));
<a name="l00887"></a>00887       
<a name="l00888"></a>00888       <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == 0) &amp;&amp;
<a name="l00889"></a>00889           (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>))
<a name="l00890"></a>00890         elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00891"></a>00891 
<a name="l00892"></a>00892       <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() == 0) &amp;&amp;
<a name="l00893"></a>00893           (elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>))
<a name="l00894"></a>00894         elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00895"></a>00895     }
<a name="l00896"></a>00896   
<a name="l00897"></a>00897   <span class="comment">// if there are no refined elements on this processor then</span>
<a name="l00898"></a>00898   <span class="comment">// there is no work for us to do   </span>
<a name="l00899"></a>00899   <span class="keywordflow">if</span> (max_level == 0 &amp;&amp; max_p_level == 0)
<a name="l00900"></a>00900     {
<a name="l00901"></a>00901       STOP_LOG (<span class="stringliteral">&quot;make_coarsening_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l00902"></a>00902 
<a name="l00903"></a>00903       <span class="comment">// But we still have to check with other processors</span>
<a name="l00904"></a>00904       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(compatible_with_refinement);
<a name="l00905"></a>00905 
<a name="l00906"></a>00906       <span class="keywordflow">return</span> compatible_with_refinement;
<a name="l00907"></a>00907     }
<a name="l00908"></a>00908 
<a name="l00909"></a>00909   
<a name="l00910"></a>00910   
<a name="l00911"></a>00911   <span class="comment">// Loop over all the active elements.  If an element is marked</span>
<a name="l00912"></a>00912   <span class="comment">// for coarsening we better check its neighbors.  If ANY of these neighbors</span>
<a name="l00913"></a>00913   <span class="comment">// are marked for refinement AND are at the same level then there is a</span>
<a name="l00914"></a>00914   <span class="comment">// conflict.  By convention refinement wins, so we un-mark the element for</span>
<a name="l00915"></a>00915   <span class="comment">// coarsening.  Level-one would be violated in this case so we need to re-run</span>
<a name="l00916"></a>00916   <span class="comment">// the loop.   </span>
<a name="l00917"></a>00917   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l00918"></a>00918     {
<a name="l00919"></a>00919       
<a name="l00920"></a>00920     repeat:
<a name="l00921"></a>00921       level_one_satisfied = <span class="keyword">true</span>;
<a name="l00922"></a>00922   
<a name="l00923"></a>00923       <span class="keywordflow">do</span>
<a name="l00924"></a>00924         {
<a name="l00925"></a>00925           level_one_satisfied = <span class="keyword">true</span>;
<a name="l00926"></a>00926 
<a name="l00927"></a>00927           <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l00928"></a>00928           <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l00929"></a>00929 
<a name="l00930"></a>00930           <span class="keywordflow">for</span> (; el != end_el; ++el)
<a name="l00931"></a>00931             {
<a name="l00932"></a>00932               <a class="code" href="classElem.php">Elem</a>* elem = *el;
<a name="l00933"></a>00933               <span class="keywordtype">bool</span> my_flag_changed = <span class="keyword">false</span>;
<a name="l00934"></a>00934               
<a name="l00935"></a>00935               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>) <span class="comment">// If the element is active and </span>
<a name="l00936"></a>00936                 <span class="comment">// the coarsen flag is set</span>
<a name="l00937"></a>00937                 {
<a name="l00938"></a>00938                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_level = elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>();
<a name="l00939"></a>00939                   
<a name="l00940"></a>00940                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); n++)
<a name="l00941"></a>00941                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) != NULL &amp;&amp;      <span class="comment">// I have a</span>
<a name="l00942"></a>00942                         elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>) <span class="comment">// neighbor here</span>
<a name="l00943"></a>00943                       {
<a name="l00944"></a>00944                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n)-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>()) <span class="comment">// and it is active</span>
<a name="l00945"></a>00945                           {
<a name="l00946"></a>00946                             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n);
<a name="l00947"></a>00947                           
<a name="l00948"></a>00948                             <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == my_level) &amp;&amp;
<a name="l00949"></a>00949                                 (neighbor-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)) <span class="comment">// the neighbor is at my level</span>
<a name="l00950"></a>00950                                                                                <span class="comment">// and wants to be refined</span>
<a name="l00951"></a>00951                               {
<a name="l00952"></a>00952                                 elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00953"></a>00953                                 my_flag_changed = <span class="keyword">true</span>;
<a name="l00954"></a>00954                                 <span class="keywordflow">break</span>;
<a name="l00955"></a>00955                               }
<a name="l00956"></a>00956                           }
<a name="l00957"></a>00957                         <span class="keywordflow">else</span> <span class="comment">// I have a neighbor and it is not active. That means it has children.</span>
<a name="l00958"></a>00958                           {  <span class="comment">// While it _may_ be possible to coarsen us if all the children of</span>
<a name="l00959"></a>00959                              <span class="comment">// that element want to be coarsened, it is impossible to know at this</span>
<a name="l00960"></a>00960                              <span class="comment">// stage.  Forget about it for the moment...  This can be handled in</span>
<a name="l00961"></a>00961                              <span class="comment">// two steps.</span>
<a name="l00962"></a>00962                             elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00963"></a>00963                             my_flag_changed = <span class="keyword">true</span>;
<a name="l00964"></a>00964                             <span class="keywordflow">break</span>;
<a name="l00965"></a>00965                           }
<a name="l00966"></a>00966                       }
<a name="l00967"></a>00967                 }
<a name="l00968"></a>00968               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>) <span class="comment">// If</span>
<a name="l00969"></a>00969                 <span class="comment">// the element is active and the order reduction flag is set</span>
<a name="l00970"></a>00970                 {
<a name="l00971"></a>00971                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_p_level = elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l00972"></a>00972 
<a name="l00973"></a>00973                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); n++)
<a name="l00974"></a>00974                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) != NULL &amp;&amp;      <span class="comment">// I have a</span>
<a name="l00975"></a>00975                         elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n) != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>) <span class="comment">// neighbor here</span>
<a name="l00976"></a>00976                       {
<a name="l00977"></a>00977                         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n)-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>()) <span class="comment">// and it is active</span>
<a name="l00978"></a>00978                           {
<a name="l00979"></a>00979                             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n);
<a name="l00980"></a>00980 
<a name="l00981"></a>00981                             <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() &gt; my_p_level &amp;&amp;
<a name="l00982"></a>00982                                  neighbor-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l00983"></a>00983                                 || (neighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() == my_p_level &amp;&amp;
<a name="l00984"></a>00984                                  neighbor-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>))
<a name="l00985"></a>00985                               {
<a name="l00986"></a>00986                                 elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l00987"></a>00987                                 my_flag_changed = <span class="keyword">true</span>;
<a name="l00988"></a>00988                                 <span class="keywordflow">break</span>;
<a name="l00989"></a>00989                               }
<a name="l00990"></a>00990                           }
<a name="l00991"></a>00991                         <span class="keywordflow">else</span> <span class="comment">// I have a neighbor and it is not active.</span>
<a name="l00992"></a>00992                           {  <span class="comment">// We need to find which of its children</span>
<a name="l00993"></a>00993                              <span class="comment">// have me as a neighbor, and maintain</span>
<a name="l00994"></a>00994                              <span class="comment">// level one p compatibility with them.</span>
<a name="l00995"></a>00995                              <span class="comment">// Because we currently have level one h</span>
<a name="l00996"></a>00996                              <span class="comment">// compatibility, we don&#39;t need to check</span>
<a name="l00997"></a>00997                              <span class="comment">// grandchildren</span>
<a name="l00998"></a>00998                             <span class="keyword">const</span> <a class="code" href="classElem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n);
<a name="l00999"></a>00999 
<a name="l01000"></a>01000                              libmesh_assert(neighbor-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>());
<a name="l01001"></a>01001                              <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c!=neighbor-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01002"></a>01002                                {
<a name="l01003"></a>01003                                  <a class="code" href="classElem.php">Elem</a> *subneighbor = neighbor-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01004"></a>01004                                  <span class="keywordflow">if</span> (subneighbor != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a> &amp;&amp;
<a name="l01005"></a>01005                                      subneighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>() &amp;&amp;
<a name="l01006"></a>01006                                      subneighbor-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(elem))
<a name="l01007"></a>01007                                    <span class="keywordflow">if</span> ((subneighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() &gt; my_p_level &amp;&amp;
<a name="l01008"></a>01008                                        subneighbor-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l01009"></a>01009                                        || (subneighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() == my_p_level &amp;&amp;
<a name="l01010"></a>01010                                        subneighbor-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>))
<a name="l01011"></a>01011                                      {
<a name="l01012"></a>01012                                        elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l01013"></a>01013                                        my_flag_changed = <span class="keyword">true</span>;
<a name="l01014"></a>01014                                        <span class="keywordflow">break</span>;
<a name="l01015"></a>01015                                      }
<a name="l01016"></a>01016                                }
<a name="l01017"></a>01017                              <span class="keywordflow">if</span> (my_flag_changed)
<a name="l01018"></a>01018                                <span class="keywordflow">break</span>;
<a name="l01019"></a>01019                           }
<a name="l01020"></a>01020                       }
<a name="l01021"></a>01021                 }
<a name="l01022"></a>01022                   
<a name="l01023"></a>01023               <span class="comment">// If the current element&#39;s flag changed, we hadn&#39;t</span>
<a name="l01024"></a>01024               <span class="comment">// satisfied the level one rule.</span>
<a name="l01025"></a>01025               <span class="keywordflow">if</span> (my_flag_changed)
<a name="l01026"></a>01026                 level_one_satisfied = <span class="keyword">false</span>;
<a name="l01027"></a>01027               
<a name="l01028"></a>01028               <span class="comment">// Additionally, if it has non-local neighbors, and</span>
<a name="l01029"></a>01029               <span class="comment">// we&#39;re not in serial, then we&#39;ll eventually have to</span>
<a name="l01030"></a>01030               <span class="comment">// return compatible_with_refinement = false, because</span>
<a name="l01031"></a>01031               <span class="comment">// our change has to propagate to neighboring</span>
<a name="l01032"></a>01032               <span class="comment">// processors.</span>
<a name="l01033"></a>01033               <span class="keywordflow">if</span> (my_flag_changed &amp;&amp; !<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l01034"></a>01034               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classElem.php#a8082733f3ea7b0ef5090b7ee81edf73d">n_neighbors</a>(); ++n)
<a name="l01035"></a>01035                 {
<a name="l01036"></a>01036                   <a class="code" href="classElem.php">Elem</a> *neigh = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(n);
<a name="l01037"></a>01037                   <span class="keywordflow">if</span> (!neigh)
<a name="l01038"></a>01038                     <span class="keywordflow">continue</span>;
<a name="l01039"></a>01039                   <span class="keywordflow">if</span> (neigh == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a> ||
<a name="l01040"></a>01040                       neigh-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() !=
<a name="l01041"></a>01041                       <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01042"></a>01042                     {
<a name="l01043"></a>01043                       compatible_with_refinement = <span class="keyword">false</span>;
<a name="l01044"></a>01044                       <span class="keywordflow">break</span>;
<a name="l01045"></a>01045                     }
<a name="l01046"></a>01046                   <span class="comment">// FIXME - for non-level one meshes we should</span>
<a name="l01047"></a>01047                   <span class="comment">// test all descendants</span>
<a name="l01048"></a>01048                   <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>())
<a name="l01049"></a>01049                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != neigh-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); ++c)
<a name="l01050"></a>01050                       <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c) == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a> ||
<a name="l01051"></a>01051                           neigh-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c)-&gt;<a class="code" href="classDofObject.php#a60370db4dd8ae6f440e5a887415167f8">processor_id</a>() !=
<a name="l01052"></a>01052                           <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01053"></a>01053                         {
<a name="l01054"></a>01054                           compatible_with_refinement = <span class="keyword">false</span>;
<a name="l01055"></a>01055                           <span class="keywordflow">break</span>;
<a name="l01056"></a>01056                         }
<a name="l01057"></a>01057                 }
<a name="l01058"></a>01058             }      
<a name="l01059"></a>01059         }
<a name="l01060"></a>01060       <span class="keywordflow">while</span> (!level_one_satisfied);
<a name="l01061"></a>01061       
<a name="l01062"></a>01062     } <span class="comment">// end if (_maintain_level_one)</span>
<a name="l01063"></a>01063   
<a name="l01064"></a>01064   
<a name="l01065"></a>01065   <span class="comment">// Next we look at all of the ancestor cells.</span>
<a name="l01066"></a>01066   <span class="comment">// If there is a parent cell with all of its children</span>
<a name="l01067"></a>01067   <span class="comment">// wanting to be unrefined then the element is a candidate</span>
<a name="l01068"></a>01068   <span class="comment">// for unrefinement.  If all the children don&#39;t</span>
<a name="l01069"></a>01069   <span class="comment">// all want to be unrefined then ALL of them need to have their</span>
<a name="l01070"></a>01070   <span class="comment">// unrefinement flags cleared.    </span>
<a name="l01071"></a>01071   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> level=(max_level); level &gt;= 0; level--)
<a name="l01072"></a>01072     {
<a name="l01073"></a>01073       <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a534079bde46c7d86cb976db76c697804">level_elements_begin</a>(level);
<a name="l01074"></a>01074       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a724dcfe5c7d4ad16f3ee09e22d6f1372">level_elements_end</a>(level); 
<a name="l01075"></a>01075       <span class="keywordflow">for</span> (; el != end_el; ++el)
<a name="l01076"></a>01076         {
<a name="l01077"></a>01077           <a class="code" href="classElem.php">Elem</a> *elem = *el;
<a name="l01078"></a>01078           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">ancestor</a>())
<a name="l01079"></a>01079             {
<a name="l01080"></a>01080           
<a name="l01081"></a>01081               <span class="comment">// right now the element hasn&#39;t been disqualified</span>
<a name="l01082"></a>01082               <span class="comment">// as a candidate for unrefinement           </span>
<a name="l01083"></a>01083               <span class="keywordtype">bool</span> is_a_candidate = <span class="keyword">true</span>;
<a name="l01084"></a>01084               <span class="keywordtype">bool</span> found_remote_child = <span class="keyword">false</span>;
<a name="l01085"></a>01085               
<a name="l01086"></a>01086               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;elem-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01087"></a>01087                 {
<a name="l01088"></a>01088                   <a class="code" href="classElem.php">Elem</a> *child = elem-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01089"></a>01089                   <span class="keywordflow">if</span> (child == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l01090"></a>01090                     found_remote_child = <span class="keyword">true</span>;
<a name="l01091"></a>01091                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((child-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>) ||
<a name="l01092"></a>01092                            !child-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>() )
<a name="l01093"></a>01093                     is_a_candidate = <span class="keyword">false</span>;
<a name="l01094"></a>01094                 }
<a name="l01095"></a>01095               
<a name="l01096"></a>01096               <span class="keywordflow">if</span> (!is_a_candidate &amp;&amp; !found_remote_child)
<a name="l01097"></a>01097                 {
<a name="l01098"></a>01098                   elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l01099"></a>01099                   
<a name="l01100"></a>01100                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;elem-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01101"></a>01101                     {
<a name="l01102"></a>01102                       <a class="code" href="classElem.php">Elem</a> *child = elem-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01103"></a>01103                       <span class="keywordflow">if</span> (child == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l01104"></a>01104                         <span class="keywordflow">continue</span>;
<a name="l01105"></a>01105                       <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l01106"></a>01106                         {
<a name="l01107"></a>01107                           level_one_satisfied = <span class="keyword">false</span>;
<a name="l01108"></a>01108                           child-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l01109"></a>01109                         }
<a name="l01110"></a>01110                     }
<a name="l01111"></a>01111                 }
<a name="l01112"></a>01112             }
<a name="l01113"></a>01113          }
<a name="l01114"></a>01114      }
<a name="l01115"></a>01115      
<a name="l01116"></a>01116   <span class="keywordflow">if</span> (!level_one_satisfied &amp;&amp; _maintain_level_one) <span class="keywordflow">goto</span> repeat;
<a name="l01117"></a>01117   
<a name="l01118"></a>01118   
<a name="l01119"></a>01119   <span class="comment">// If all the children of a parent are set to be coarsened</span>
<a name="l01120"></a>01120   <span class="comment">// then flag the parent so that they can kill thier kids...   </span>
<a name="l01121"></a>01121   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       all_el     = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l01122"></a>01122   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> all_el_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>(); 
<a name="l01123"></a>01123   <span class="keywordflow">for</span> (; all_el != all_el_end; ++all_el)
<a name="l01124"></a>01124     {
<a name="l01125"></a>01125       <a class="code" href="classElem.php">Elem</a> *elem = *all_el;
<a name="l01126"></a>01126         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a3ad156b66b45310da85b653c791bd790">ancestor</a>())
<a name="l01127"></a>01127           {
<a name="l01128"></a>01128         
<a name="l01129"></a>01129             <span class="comment">// Presume all the children are local and flagged for</span>
<a name="l01130"></a>01130             <span class="comment">// coarsening and then look for a contradiction      </span>
<a name="l01131"></a>01131             <span class="keywordtype">bool</span> all_children_flagged_for_coarsening = <span class="keyword">true</span>;
<a name="l01132"></a>01132             <span class="keywordtype">bool</span> found_remote_child = <span class="keyword">false</span>;
<a name="l01133"></a>01133         
<a name="l01134"></a>01134             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;elem-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01135"></a>01135               {
<a name="l01136"></a>01136                 <a class="code" href="classElem.php">Elem</a> *child = elem-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01137"></a>01137                 <span class="keywordflow">if</span> (child == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l01138"></a>01138                   found_remote_child = <span class="keyword">true</span>;
<a name="l01139"></a>01139                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l01140"></a>01140                   all_children_flagged_for_coarsening = <span class="keyword">false</span>;
<a name="l01141"></a>01141               }
<a name="l01142"></a>01142         
<a name="l01143"></a>01143             <span class="keywordflow">if</span> (!found_remote_child &amp;&amp;
<a name="l01144"></a>01144                 all_children_flagged_for_coarsening)
<a name="l01145"></a>01145               elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a1d4c57ce97a2dff1f6dd0e2b8855f80e">Elem::COARSEN_INACTIVE</a>);
<a name="l01146"></a>01146             <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!found_remote_child)
<a name="l01147"></a>01147               elem-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l01148"></a>01148           }
<a name="l01149"></a>01149     }
<a name="l01150"></a>01150         
<a name="l01151"></a>01151   STOP_LOG (<span class="stringliteral">&quot;make_coarsening_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01152"></a>01152 
<a name="l01153"></a>01153   <span class="comment">// If one processor finds an incompatibility, we&#39;re globally</span>
<a name="l01154"></a>01154   <span class="comment">// incompatible</span>
<a name="l01155"></a>01155   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(compatible_with_refinement);
<a name="l01156"></a>01156   
<a name="l01157"></a>01157   <span class="keywordflow">return</span> compatible_with_refinement;
<a name="l01158"></a>01158 }
<a name="l01159"></a>01159 
<a name="l01160"></a>01160 
<a name="l01161"></a>01161 
<a name="l01162"></a>01162 
<a name="l01163"></a>01163 
<a name="l01164"></a>01164 
<a name="l01165"></a>01165 
<a name="l01166"></a>01166 
<a name="l01167"></a><a class="code" href="classMeshRefinement.php#a95d2a98b52ef5a7360e4cba48b182c05">01167</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a95d2a98b52ef5a7360e4cba48b182c05">MeshRefinement::make_refinement_compatible</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one)
<a name="l01168"></a>01168 {
<a name="l01169"></a>01169   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01170"></a>01170   parallel_only();
<a name="l01171"></a>01171 
<a name="l01172"></a>01172   START_LOG (<span class="stringliteral">&quot;make_refinement_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01173"></a>01173   
<a name="l01174"></a>01174   <span class="keywordtype">bool</span> _maintain_level_one = maintain_level_one;
<a name="l01175"></a>01175 
<a name="l01176"></a>01176   <span class="comment">// If the user used non-default parameters, let&#39;s warn that they&#39;re</span>
<a name="l01177"></a>01177   <span class="comment">// deprecated</span>
<a name="l01178"></a>01178   <span class="keywordflow">if</span> (!maintain_level_one)
<a name="l01179"></a>01179     {
<a name="l01180"></a>01180       libmesh_deprecated();
<a name="l01181"></a>01181     }
<a name="l01182"></a>01182   <span class="keywordflow">else</span>
<a name="l01183"></a>01183     _maintain_level_one = <a class="code" href="classMeshRefinement.php#a6f1ce9fd520404fd1076968ef4c95dad">_face_level_mismatch_limit</a>;
<a name="l01184"></a>01184 
<a name="l01185"></a>01185   <span class="comment">// Unless we encounter a specific situation level-one</span>
<a name="l01186"></a>01186   <span class="comment">// will be satisfied after executing this loop just once</span>
<a name="l01187"></a>01187   <span class="keywordtype">bool</span> level_one_satisfied = <span class="keyword">true</span>;
<a name="l01188"></a>01188 
<a name="l01189"></a>01189   <span class="comment">// Unless we encounter a specific situation we will be compatible</span>
<a name="l01190"></a>01190   <span class="comment">// with any selected coarsening flags</span>
<a name="l01191"></a>01191   <span class="keywordtype">bool</span> compatible_with_coarsening = <span class="keyword">true</span>;
<a name="l01192"></a>01192 
<a name="l01193"></a>01193   <span class="comment">// This loop enforces the level-1 rule.  We should only</span>
<a name="l01194"></a>01194   <span class="comment">// execute it if the user indeed wants level-1 satisfied!   </span>
<a name="l01195"></a>01195   <span class="keywordflow">if</span> (_maintain_level_one)
<a name="l01196"></a>01196     {  
<a name="l01197"></a>01197       <span class="keywordflow">do</span>
<a name="l01198"></a>01198         {
<a name="l01199"></a>01199           level_one_satisfied = <span class="keyword">true</span>;
<a name="l01200"></a>01200           
<a name="l01201"></a>01201           <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el     = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l01202"></a>01202           <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l01203"></a>01203 
<a name="l01204"></a>01204           <span class="keywordflow">for</span> (; el != end_el; ++el)
<a name="l01205"></a>01205             {
<a name="l01206"></a>01206             <a class="code" href="classElem.php">Elem</a> *elem = *el;
<a name="l01207"></a>01207             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)  <span class="comment">// If the element is active and the</span>
<a name="l01208"></a>01208                                                           <span class="comment">// h refinement flag is set    </span>
<a name="l01209"></a>01209               {
<a name="l01210"></a>01210                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_level = elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>();
<a name="l01211"></a>01211             
<a name="l01212"></a>01212                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side=0; side != elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); side++)
<a name="l01213"></a>01213                   {
<a name="l01214"></a>01214                     <a class="code" href="classElem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(side);
<a name="l01215"></a>01215                     <span class="keywordflow">if</span> (neighbor != NULL        &amp;&amp; <span class="comment">// I have a</span>
<a name="l01216"></a>01216                         neighbor != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a> &amp;&amp; <span class="comment">// neighbor here</span>
<a name="l01217"></a>01217                         neighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>()) <span class="comment">// and it is active</span>
<a name="l01218"></a>01218                       {
<a name="l01219"></a>01219                         
<a name="l01220"></a>01220                         
<a name="l01221"></a>01221                         <span class="comment">// Case 1:  The neighbor is at the same level I am.</span>
<a name="l01222"></a>01222                         <span class="comment">//        1a: The neighbor will be refined       -&gt; NO PROBLEM</span>
<a name="l01223"></a>01223                         <span class="comment">//        1b: The neighbor won&#39;t be refined      -&gt; NO PROBLEM</span>
<a name="l01224"></a>01224                         <span class="comment">//        1c: The neighbor wants to be coarsened -&gt; PROBLEM                      </span>
<a name="l01225"></a>01225                         <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() == my_level)
<a name="l01226"></a>01226                           {
<a name="l01227"></a>01227                             <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l01228"></a>01228                               {
<a name="l01229"></a>01229                                 neighbor-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l01230"></a>01230                                 <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>())
<a name="l01231"></a>01231                                   neighbor-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l01232"></a>01232                                 compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01233"></a>01233                                 level_one_satisfied = <span class="keyword">false</span>;
<a name="l01234"></a>01234                               }
<a name="l01235"></a>01235                           }
<a name="l01236"></a>01236                         
<a name="l01237"></a>01237                         
<a name="l01238"></a>01238                         <span class="comment">// Case 2: The neighbor is one level lower than I am.</span>
<a name="l01239"></a>01239                         <span class="comment">//         The neighbor thus MUST be refined to satisfy</span>
<a name="l01240"></a>01240                         <span class="comment">//         the level-one rule, regardless of whether it</span>
<a name="l01241"></a>01241                         <span class="comment">//         was originally flagged for refinement. If it</span>
<a name="l01242"></a>01242                         <span class="comment">//         wasn&#39;t flagged already we need to repeat</span>
<a name="l01243"></a>01243                         <span class="comment">//         this process.                         </span>
<a name="l01244"></a>01244                         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>()+1) == my_level)
<a name="l01245"></a>01245                           {
<a name="l01246"></a>01246                             <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)
<a name="l01247"></a>01247                               {
<a name="l01248"></a>01248                                 neighbor-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l01249"></a>01249                                 <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>())
<a name="l01250"></a>01250                                   neighbor-&gt;<a class="code" href="classElem.php#a39350a0c1e7cf0c73242e80f714de15b">parent</a>()-&gt;<a class="code" href="classElem.php#a8280fc64e8b8a7ce4189f964ff6ce6e3">set_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829aa5b67adf7b456724c4a0a07034a0adbf">Elem::INACTIVE</a>);
<a name="l01251"></a>01251                                 compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01252"></a>01252                                 level_one_satisfied = <span class="keyword">false</span>; 
<a name="l01253"></a>01253                               }
<a name="l01254"></a>01254                           }
<a name="l01255"></a>01255 <span class="preprocessor">#ifdef DEBUG            </span>
<a name="l01256"></a>01256 <span class="preprocessor"></span>                        
<a name="l01257"></a>01257                         <span class="comment">// Sanity check. We should never get into a</span>
<a name="l01258"></a>01258                         <span class="comment">// case when our neighbot is more than one</span>
<a name="l01259"></a>01259                         <span class="comment">// level away.                   </span>
<a name="l01260"></a>01260                         <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((neighbor-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>()+1) &lt; my_level)
<a name="l01261"></a>01261                           {
<a name="l01262"></a>01262                             libmesh_error();
<a name="l01263"></a>01263                           }
<a name="l01264"></a>01264                         
<a name="l01265"></a>01265                         
<a name="l01266"></a>01266                         <span class="comment">// Note that the only other possibility is that the</span>
<a name="l01267"></a>01267                         <span class="comment">// neighbor is already refined, in which case it isn&#39;t</span>
<a name="l01268"></a>01268                         <span class="comment">// active and we should never get here.                  </span>
<a name="l01269"></a>01269                         <span class="keywordflow">else</span>
<a name="l01270"></a>01270                           {
<a name="l01271"></a>01271                             libmesh_error();
<a name="l01272"></a>01272                           }
<a name="l01273"></a>01273 <span class="preprocessor">#endif          </span>
<a name="l01274"></a>01274 <span class="preprocessor"></span>                      } 
<a name="l01275"></a>01275                   }
<a name="l01276"></a>01276               }
<a name="l01277"></a>01277             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)  <span class="comment">// If the element is active and the</span>
<a name="l01278"></a>01278                                                             <span class="comment">// p refinement flag is set    </span>
<a name="l01279"></a>01279               {
<a name="l01280"></a>01280                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_p_level = elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>();
<a name="l01281"></a>01281 
<a name="l01282"></a>01282                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> side=0; side != elem-&gt;<a class="code" href="classElem.php#a1cdf1ceddfde6e841d7f1bc0d912a423">n_sides</a>(); side++)
<a name="l01283"></a>01283                   {
<a name="l01284"></a>01284                     <a class="code" href="classElem.php">Elem</a> *neighbor = elem-&gt;<a class="code" href="classElem.php#aa2ee230e92ba3e8f2fc1dfe4536b3e9b">neighbor</a>(side);
<a name="l01285"></a>01285                     <span class="keywordflow">if</span> (neighbor != NULL &amp;&amp;      <span class="comment">// I have a</span>
<a name="l01286"></a>01286                         neighbor != <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>) <span class="comment">// neighbor here</span>
<a name="l01287"></a>01287                       {
<a name="l01288"></a>01288                         <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>()) <span class="comment">// and it is active</span>
<a name="l01289"></a>01289                           {
<a name="l01290"></a>01290                             <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() &lt; my_p_level &amp;&amp;
<a name="l01291"></a>01291                                 neighbor-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)
<a name="l01292"></a>01292                               {
<a name="l01293"></a>01293                                 neighbor-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l01294"></a>01294                                 level_one_satisfied = <span class="keyword">false</span>;
<a name="l01295"></a>01295                                 compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01296"></a>01296                               }
<a name="l01297"></a>01297                             <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() == my_p_level &amp;&amp;
<a name="l01298"></a>01298                                 neighbor-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l01299"></a>01299                               {
<a name="l01300"></a>01300                                 neighbor-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l01301"></a>01301                                 level_one_satisfied = <span class="keyword">false</span>;
<a name="l01302"></a>01302                                 compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01303"></a>01303                               }
<a name="l01304"></a>01304                           } 
<a name="l01305"></a>01305                         <span class="keywordflow">else</span> <span class="comment">// I have an inactive neighbor</span>
<a name="l01306"></a>01306                           {
<a name="l01307"></a>01307                             libmesh_assert(neighbor-&gt;<a class="code" href="classElem.php#a2ff2cfd3b4b05b8f091ba91eb068f81c">has_children</a>());
<a name="l01308"></a>01308                             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c!=neighbor-&gt;<a class="code" href="classElem.php#a72c7aa3b55c011b6e130f0b61111ed9b">n_children</a>(); c++)
<a name="l01309"></a>01309                               {
<a name="l01310"></a>01310                                 <a class="code" href="classElem.php">Elem</a> *subneighbor = neighbor-&gt;<a class="code" href="classElem.php#afecb64affd11092da030f9ee4973a764">child</a>(c);
<a name="l01311"></a>01311                                 <span class="keywordflow">if</span> (subneighbor == <a class="code" href="remote__elem_8C.php#acfab407b388e3281b090fe98dc744db8">remote_elem</a>)
<a name="l01312"></a>01312                                   <span class="keywordflow">continue</span>;
<a name="l01313"></a>01313                                 <span class="keywordflow">if</span> (subneighbor-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>() &amp;&amp;
<a name="l01314"></a>01314                                     subneighbor-&gt;<a class="code" href="classElem.php#a7213196f7c76938ee380d331c4abd1ea">has_neighbor</a>(elem))
<a name="l01315"></a>01315                                   {
<a name="l01316"></a>01316                                     <span class="keywordflow">if</span> (subneighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() &lt; my_p_level &amp;&amp;
<a name="l01317"></a>01317                                         subneighbor-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() != <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)
<a name="l01318"></a>01318                                       {
<a name="l01319"></a>01319                                         <span class="comment">// We should already be level one</span>
<a name="l01320"></a>01320                                         <span class="comment">// compatible</span>
<a name="l01321"></a>01321                                         libmesh_assert(subneighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() + 2u &gt; 
<a name="l01322"></a>01322                                                        my_p_level);
<a name="l01323"></a>01323                                         subneighbor-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l01324"></a>01324                                         level_one_satisfied = <span class="keyword">false</span>;
<a name="l01325"></a>01325                                         compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01326"></a>01326                                       }
<a name="l01327"></a>01327                                     <span class="keywordflow">if</span> (subneighbor-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() == my_p_level &amp;&amp;
<a name="l01328"></a>01328                                         subneighbor-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l01329"></a>01329                                       {
<a name="l01330"></a>01330                                         subneighbor-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l01331"></a>01331                                         level_one_satisfied = <span class="keyword">false</span>;
<a name="l01332"></a>01332                                         compatible_with_coarsening = <span class="keyword">false</span>;
<a name="l01333"></a>01333                                       }
<a name="l01334"></a>01334                                   }
<a name="l01335"></a>01335                               }
<a name="l01336"></a>01336                           } 
<a name="l01337"></a>01337                       }
<a name="l01338"></a>01338                   }
<a name="l01339"></a>01339               }
<a name="l01340"></a>01340             }
<a name="l01341"></a>01341         }
<a name="l01342"></a>01342       
<a name="l01343"></a>01343       <span class="keywordflow">while</span> (!level_one_satisfied);
<a name="l01344"></a>01344     } <span class="comment">// end if (_maintain_level_one)</span>
<a name="l01345"></a>01345 
<a name="l01346"></a>01346   <span class="comment">// If we&#39;re not compatible on one processor, we&#39;re globally not</span>
<a name="l01347"></a>01347   <span class="comment">// compatible</span>
<a name="l01348"></a>01348   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(compatible_with_coarsening);
<a name="l01349"></a>01349   
<a name="l01350"></a>01350   STOP_LOG (<span class="stringliteral">&quot;make_refinement_compatible()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01351"></a>01351 
<a name="l01352"></a>01352   <span class="keywordflow">return</span> compatible_with_coarsening;
<a name="l01353"></a>01353 }
<a name="l01354"></a>01354 
<a name="l01355"></a>01355 
<a name="l01356"></a>01356 
<a name="l01357"></a>01357 
<a name="l01358"></a><a class="code" href="classMeshRefinement.php#ae33151743e5987e4d216eac6a1142376">01358</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#ae33151743e5987e4d216eac6a1142376">MeshRefinement::_coarsen_elements</a> ()
<a name="l01359"></a>01359 {
<a name="l01360"></a>01360   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01361"></a>01361   parallel_only();
<a name="l01362"></a>01362 
<a name="l01363"></a>01363   START_LOG (<span class="stringliteral">&quot;_coarsen_elements()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01364"></a>01364 
<a name="l01365"></a>01365   <span class="comment">// Flag indicating if this call actually changes the mesh</span>
<a name="l01366"></a>01366   <span class="keywordtype">bool</span> mesh_changed = <span class="keyword">false</span>;
<a name="l01367"></a>01367   
<a name="l01368"></a>01368   <span class="comment">// Clear the unused_elements data structure.</span>
<a name="l01369"></a>01369   <span class="comment">// The elements have been packed since it was built,</span>
<a name="l01370"></a>01370   <span class="comment">// so there are _no_ unused elements.  We cannot trust</span>
<a name="l01371"></a>01371   <span class="comment">// any iterators currently in this data structure.</span>
<a name="l01372"></a>01372   <span class="comment">// _unused_elements.clear();</span>
<a name="l01373"></a>01373 
<a name="l01374"></a>01374   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l01375"></a>01375   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l01376"></a>01376 
<a name="l01377"></a>01377   <span class="comment">// Loop over the elements.   </span>
<a name="l01378"></a>01378   <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l01379"></a>01379     {
<a name="l01380"></a>01380       <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l01381"></a>01381 
<a name="l01382"></a>01382       <span class="comment">// Not necessary when using elem_iterator</span>
<a name="l01383"></a>01383       <span class="comment">// libmesh_assert (elem != NULL);</span>
<a name="l01384"></a>01384       
<a name="l01385"></a>01385       <span class="comment">// active elements flagged for coarsening will</span>
<a name="l01386"></a>01386       <span class="comment">// no longer be deleted until MeshRefinement::contract()</span>
<a name="l01387"></a>01387       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l01388"></a>01388         {
<a name="l01389"></a>01389           <span class="comment">// Huh?  no level-0 element should be active</span>
<a name="l01390"></a>01390           <span class="comment">// and flagged for coarsening.</span>
<a name="l01391"></a>01391           libmesh_assert (elem-&gt;<a class="code" href="classElem.php#a6f560ac1183602b02cb8523c64bed87c">level</a>() != 0);
<a name="l01392"></a>01392           
<a name="l01393"></a>01393           <span class="comment">// Remove this element from any neighbor</span>
<a name="l01394"></a>01394           <span class="comment">// lists that point to it.</span>
<a name="l01395"></a>01395           elem-&gt;<a class="code" href="classElem.php#a0c6afe5c0a0f5b304bb3846098c30a85">nullify_neighbors</a>();
<a name="l01396"></a>01396 
<a name="l01397"></a>01397           <span class="comment">// Remove any boundary information associated</span>
<a name="l01398"></a>01398           <span class="comment">// with this element</span>
<a name="l01399"></a>01399           <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a1052f4f96581302db00730160e1a978b">boundary_info</a>-&gt;remove (elem);
<a name="l01400"></a>01400               
<a name="l01401"></a>01401           <span class="comment">// Add this iterator to the _unused_elements</span>
<a name="l01402"></a>01402           <span class="comment">// data structure so we might fill it.</span>
<a name="l01403"></a>01403           <span class="comment">// The _unused_elements optimization is currently off.</span>
<a name="l01404"></a>01404           <span class="comment">// _unused_elements.push_back (it);</span>
<a name="l01405"></a>01405 
<a name="l01406"></a>01406           <span class="comment">// Don&#39;t delete the element until</span>
<a name="l01407"></a>01407           <span class="comment">// MeshRefinement::contract()</span>
<a name="l01408"></a>01408           <span class="comment">// _mesh.delete_elem(elem);</span>
<a name="l01409"></a>01409 
<a name="l01410"></a>01410           <span class="comment">// the mesh has certainly changed</span>
<a name="l01411"></a>01411           mesh_changed = <span class="keyword">true</span>;
<a name="l01412"></a>01412         }
<a name="l01413"></a>01413       
<a name="l01414"></a>01414       <span class="comment">// inactive elements flagged for coarsening</span>
<a name="l01415"></a>01415       <span class="comment">// will become active</span>
<a name="l01416"></a>01416       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a1d4c57ce97a2dff1f6dd0e2b8855f80e">Elem::COARSEN_INACTIVE</a>)
<a name="l01417"></a>01417         {
<a name="l01418"></a>01418           elem-&gt;<a class="code" href="classElem.php#a404022768f8be8b29a31c2f021d4304d">coarsen</a>();
<a name="l01419"></a>01419           libmesh_assert (elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>());
<a name="l01420"></a>01420 
<a name="l01421"></a>01421           <span class="comment">// the mesh has certainly changed</span>
<a name="l01422"></a>01422           mesh_changed = <span class="keyword">true</span>;
<a name="l01423"></a>01423         }
<a name="l01424"></a>01424       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>)
<a name="l01425"></a>01425         {
<a name="l01426"></a>01426           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() &gt; 0)
<a name="l01427"></a>01427             {
<a name="l01428"></a>01428               elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829ad2c57c7a107071f8229a64a5af22202f">Elem::JUST_COARSENED</a>);
<a name="l01429"></a>01429               elem-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>() - 1);
<a name="l01430"></a>01430               mesh_changed = <span class="keyword">true</span>;
<a name="l01431"></a>01431             }
<a name="l01432"></a>01432           <span class="keywordflow">else</span>
<a name="l01433"></a>01433             {
<a name="l01434"></a>01434               elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a3bc34bb09879a3388ad735a75317b3c3">Elem::DO_NOTHING</a>);
<a name="l01435"></a>01435             }
<a name="l01436"></a>01436         }
<a name="l01437"></a>01437     }  
<a name="l01438"></a>01438 
<a name="l01439"></a>01439   <span class="comment">// If the mesh changed on any processor, it changed globally</span>
<a name="l01440"></a>01440   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(mesh_changed);
<a name="l01441"></a>01441   <span class="comment">// And we may need to update ParallelMesh values reflecting the changes</span>
<a name="l01442"></a>01442   <span class="keywordflow">if</span> (mesh_changed)
<a name="l01443"></a>01443     <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#aed43d56cc6447129ded7ef46e4c8bb3e">update_parallel_id_counts</a>();
<a name="l01444"></a>01444 
<a name="l01445"></a>01445   <span class="comment">// Node processor ids may need to change if an element of that id</span>
<a name="l01446"></a>01446   <span class="comment">// was coarsened away</span>
<a name="l01447"></a>01447   <span class="keywordflow">if</span> (mesh_changed &amp;&amp; !<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l01448"></a>01448     {
<a name="l01449"></a>01449       <span class="comment">// Update the _new_nodes_map so that processors can</span>
<a name="l01450"></a>01450       <span class="comment">// find requested nodes</span>
<a name="l01451"></a>01451       this-&gt;<a class="code" href="classMeshRefinement.php#a09537b2ea4265d398d94c1f1e547a2fe">update_nodes_map</a> ();
<a name="l01452"></a>01452 
<a name="l01453"></a>01453       <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#ad2ae60d0388971e32c1060bf5304186e">make_nodes_parallel_consistent</a>
<a name="l01454"></a>01454         (<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>, <a class="code" href="classMeshRefinement.php#a830cefaa2e0f102fc921dc5cae2b5733">_new_nodes_map</a>);
<a name="l01455"></a>01455 
<a name="l01456"></a>01456       <span class="comment">// Clear the _new_nodes_map</span>
<a name="l01457"></a>01457       this-&gt;<a class="code" href="classMeshRefinement.php#aaefd0f57b9d612831bbaf75cfcc1962c">clear</a>();
<a name="l01458"></a>01458   
<a name="l01459"></a>01459 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01460"></a>01460 <span class="preprocessor"></span>      <a class="code" href="namespaceMeshTools.php#a8459293294733e3d034d2fec20501759">MeshTools::libmesh_assert_valid_node_procids</a>(<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>);
<a name="l01461"></a>01461 <span class="preprocessor">#endif</span>
<a name="l01462"></a>01462 <span class="preprocessor"></span>    }
<a name="l01463"></a>01463 
<a name="l01464"></a>01464   STOP_LOG (<span class="stringliteral">&quot;_coarsen_elements()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01465"></a>01465 
<a name="l01466"></a>01466   <span class="keywordflow">return</span> mesh_changed;
<a name="l01467"></a>01467 }
<a name="l01468"></a>01468 
<a name="l01469"></a>01469 
<a name="l01470"></a>01470 
<a name="l01471"></a><a class="code" href="classMeshRefinement.php#a2edc635e999cae1d61575a7dd54ca782">01471</a> <span class="keywordtype">bool</span> <a class="code" href="classMeshRefinement.php#a2edc635e999cae1d61575a7dd54ca782">MeshRefinement::_refine_elements</a> ()
<a name="l01472"></a>01472 {
<a name="l01473"></a>01473   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01474"></a>01474   parallel_only();
<a name="l01475"></a>01475 
<a name="l01476"></a>01476   <span class="comment">// Update the _new_nodes_map so that elements can</span>
<a name="l01477"></a>01477   <span class="comment">// find nodes to connect to.</span>
<a name="l01478"></a>01478   this-&gt;<a class="code" href="classMeshRefinement.php#a09537b2ea4265d398d94c1f1e547a2fe">update_nodes_map</a> ();
<a name="l01479"></a>01479 
<a name="l01480"></a>01480   START_LOG (<span class="stringliteral">&quot;_refine_elements()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01481"></a>01481 
<a name="l01482"></a>01482   <span class="comment">// Iterate over the elements, counting the elements</span>
<a name="l01483"></a>01483   <span class="comment">// flagged for h refinement.</span>
<a name="l01484"></a>01484   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elems_flagged = 0;
<a name="l01485"></a>01485 
<a name="l01486"></a>01486   <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>();
<a name="l01487"></a>01487   <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c251ab5d4977d0f4c49f1a03c678cfb">elements_end</a>();
<a name="l01488"></a>01488 
<a name="l01489"></a>01489   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01490"></a>01490     {
<a name="l01491"></a>01491       <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l01492"></a>01492       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)
<a name="l01493"></a>01493         n_elems_flagged++;
<a name="l01494"></a>01494     }
<a name="l01495"></a>01495 
<a name="l01496"></a>01496   <span class="comment">// Construct a local vector of Elem* which have been</span>
<a name="l01497"></a>01497   <span class="comment">// previously marked for refinement.  We reserve enough</span>
<a name="l01498"></a>01498   <span class="comment">// space to allow for every element to be refined.</span>
<a name="l01499"></a>01499   std::vector&lt;Elem*&gt; local_copy_of_elements;
<a name="l01500"></a>01500   local_copy_of_elements.reserve(n_elems_flagged);
<a name="l01501"></a>01501 
<a name="l01502"></a>01502   <span class="comment">// Iterate over the elements, looking for elements</span>
<a name="l01503"></a>01503   <span class="comment">// flagged for refinement.</span>
<a name="l01504"></a>01504   <span class="keywordflow">for</span> (it = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afc498f8b812e8256531089b5ee849be3">elements_begin</a>(); it != end; ++it)
<a name="l01505"></a>01505     {
<a name="l01506"></a>01506       <a class="code" href="classElem.php">Elem</a>* elem = *it;
<a name="l01507"></a>01507       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a563d04d228653b467b919b2346d64ad4">refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>)
<a name="l01508"></a>01508         local_copy_of_elements.push_back(elem);
<a name="l01509"></a>01509       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classElem.php#a227edef356569bc6cf2ccca4472043bf">p_refinement_flag</a>() == <a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a> &amp;&amp;
<a name="l01510"></a>01510           elem-&gt;<a class="code" href="classElem.php#acb3eb8d0303b33bcbb2eab79393bbfc4">active</a>())
<a name="l01511"></a>01511         {
<a name="l01512"></a>01512           elem-&gt;<a class="code" href="classElem.php#ae5dda58cdd729c5ee19c0a44bc1dd7bf">set_p_level</a>(elem-&gt;<a class="code" href="classElem.php#a66a1e9e5328241a70c7c5cca3a78247d">p_level</a>()+1);
<a name="l01513"></a>01513           elem-&gt;<a class="code" href="classElem.php#a40b62e384088baa756c3481b6631d7c4">set_p_refinement_flag</a>(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>);
<a name="l01514"></a>01514         }
<a name="l01515"></a>01515     }
<a name="l01516"></a>01516 
<a name="l01517"></a>01517   <span class="comment">// Now iterate over the local copies and refine each one.</span>
<a name="l01518"></a>01518   <span class="comment">// This may resize the mesh&#39;s internal container and invalidate</span>
<a name="l01519"></a>01519   <span class="comment">// any existing iterators.</span>
<a name="l01520"></a>01520   
<a name="l01521"></a>01521   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e = 0; e != local_copy_of_elements.size(); ++e)
<a name="l01522"></a>01522     local_copy_of_elements[e]-&gt;refine(*<span class="keyword">this</span>);
<a name="l01523"></a>01523 
<a name="l01524"></a>01524   <span class="comment">// The mesh changed if there were elements h refined</span>
<a name="l01525"></a>01525   <span class="keywordtype">bool</span> mesh_changed = !local_copy_of_elements.empty();
<a name="l01526"></a>01526 
<a name="l01527"></a>01527   <span class="comment">// If the mesh changed on any processor, it changed globally</span>
<a name="l01528"></a>01528   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(mesh_changed);
<a name="l01529"></a>01529 
<a name="l01530"></a>01530   <span class="comment">// And we may need to update ParallelMesh values reflecting the changes</span>
<a name="l01531"></a>01531   <span class="keywordflow">if</span> (mesh_changed)
<a name="l01532"></a>01532     <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#aed43d56cc6447129ded7ef46e4c8bb3e">update_parallel_id_counts</a>();
<a name="l01533"></a>01533 
<a name="l01534"></a>01534   <span class="keywordflow">if</span> (mesh_changed &amp;&amp; !<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a660bb92c9fb94527d1cabfb1fdd6d056">is_serial</a>())
<a name="l01535"></a>01535     {
<a name="l01536"></a>01536       <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#a7b765d81a42d5e663f884ed709dd4040">make_elems_parallel_consistent</a> (<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>);
<a name="l01537"></a>01537       <a class="code" href="classMeshCommunication.php">MeshCommunication</a>().<a class="code" href="classMeshCommunication.php#ad2ae60d0388971e32c1060bf5304186e">make_nodes_parallel_consistent</a>
<a name="l01538"></a>01538         (<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>, <a class="code" href="classMeshRefinement.php#a830cefaa2e0f102fc921dc5cae2b5733">_new_nodes_map</a>);
<a name="l01539"></a>01539 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01540"></a>01540 <span class="preprocessor"></span>      <a class="code" href="classParallelMesh.php">ParallelMesh</a> *pmesh = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="classParallelMesh.php">ParallelMesh</a> *<span class="keyword">&gt;</span>(&amp;<a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>);
<a name="l01541"></a>01541       <span class="keywordflow">if</span> (pmesh)
<a name="l01542"></a>01542         pmesh-&gt;<a class="code" href="classParallelMesh.php#aa17a6d0f8e2d57519d42f7be307d6ee3">libmesh_assert_valid_parallel_ids</a>();
<a name="l01543"></a>01543 <span class="preprocessor">#endif</span>
<a name="l01544"></a>01544 <span class="preprocessor"></span>    }
<a name="l01545"></a>01545   
<a name="l01546"></a>01546   <span class="comment">// Clear the _new_nodes_map and _unused_elements data structures.</span>
<a name="l01547"></a>01547   this-&gt;<a class="code" href="classMeshRefinement.php#aaefd0f57b9d612831bbaf75cfcc1962c">clear</a>();
<a name="l01548"></a>01548   
<a name="l01549"></a>01549   STOP_LOG (<span class="stringliteral">&quot;_refine_elements()&quot;</span>, <span class="stringliteral">&quot;MeshRefinement&quot;</span>);
<a name="l01550"></a>01550 
<a name="l01551"></a>01551   <span class="keywordflow">return</span> mesh_changed;
<a name="l01552"></a>01552 }
<a name="l01553"></a>01553 
<a name="l01554"></a>01554 
<a name="l01555"></a>01555 
<a name="l01556"></a><a class="code" href="classMeshRefinement.php#a9a37541cb84e7ca981c7c4c6a3bc8f0b">01556</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a9a37541cb84e7ca981c7c4c6a3bc8f0b">MeshRefinement::uniformly_p_refine</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01557"></a>01557 {
<a name="l01558"></a>01558   <span class="comment">// Refine n times</span>
<a name="l01559"></a>01559   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rstep=0; rstep&lt;n; rstep++)
<a name="l01560"></a>01560     {
<a name="l01561"></a>01561       <span class="comment">// P refine all the active elements</span>
<a name="l01562"></a>01562       <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l01563"></a>01563       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l01564"></a>01564 
<a name="l01565"></a>01565       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01566"></a>01566         {
<a name="l01567"></a>01567           (*elem_it)-&gt;set_p_level((*elem_it)-&gt;p_level()+1);
<a name="l01568"></a>01568           (*elem_it)-&gt;set_p_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a28fd8e260b7464210efa6f4f24d54310">Elem::JUST_REFINED</a>);
<a name="l01569"></a>01569         }
<a name="l01570"></a>01570     }
<a name="l01571"></a>01571 }
<a name="l01572"></a>01572 
<a name="l01573"></a>01573 
<a name="l01574"></a>01574 
<a name="l01575"></a><a class="code" href="classMeshRefinement.php#a03c0e4cc5b36b95c8044950c50b6745e">01575</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a03c0e4cc5b36b95c8044950c50b6745e">MeshRefinement::uniformly_p_coarsen</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01576"></a>01576 {
<a name="l01577"></a>01577   <span class="comment">// Coarsen p times</span>
<a name="l01578"></a>01578   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rstep=0; rstep&lt;n; rstep++)
<a name="l01579"></a>01579     {
<a name="l01580"></a>01580       <span class="comment">// P coarsen all the active elements</span>
<a name="l01581"></a>01581       <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l01582"></a>01582       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l01583"></a>01583 
<a name="l01584"></a>01584       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01585"></a>01585         {
<a name="l01586"></a>01586           <span class="keywordflow">if</span> ((*elem_it)-&gt;p_level() &gt; 0)
<a name="l01587"></a>01587             {
<a name="l01588"></a>01588               (*elem_it)-&gt;set_p_level((*elem_it)-&gt;p_level()-1);
<a name="l01589"></a>01589               (*elem_it)-&gt;set_p_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829ad2c57c7a107071f8229a64a5af22202f">Elem::JUST_COARSENED</a>);
<a name="l01590"></a>01590             }
<a name="l01591"></a>01591         }
<a name="l01592"></a>01592     }
<a name="l01593"></a>01593 }
<a name="l01594"></a>01594 
<a name="l01595"></a>01595 
<a name="l01596"></a>01596 
<a name="l01597"></a><a class="code" href="classMeshRefinement.php#a9fdd024cd000c1ac0bf52f9c777098c6">01597</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#a9fdd024cd000c1ac0bf52f9c777098c6">MeshRefinement::uniformly_refine</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01598"></a>01598 {
<a name="l01599"></a>01599   <span class="comment">// Refine n times</span>
<a name="l01600"></a>01600   <span class="comment">// FIXME - this won&#39;t work if n&gt;1 and the mesh </span>
<a name="l01601"></a>01601   <span class="comment">// has already been attached to an equation system</span>
<a name="l01602"></a>01602   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rstep=0; rstep&lt;n; rstep++)
<a name="l01603"></a>01603     {
<a name="l01604"></a>01604       <span class="comment">// Clean up the refinement flags</span>
<a name="l01605"></a>01605       this-&gt;<a class="code" href="classMeshRefinement.php#a78e121fabb0ee86091a7c39190440ca1">clean_refinement_flags</a>();
<a name="l01606"></a>01606       
<a name="l01607"></a>01607       <span class="comment">// Flag all the active elements for refinement.       </span>
<a name="l01608"></a>01608       <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l01609"></a>01609       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l01610"></a>01610 
<a name="l01611"></a>01611       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01612"></a>01612         (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a791ec26e8f44f2f323a9a13eeb957314">Elem::REFINE</a>);
<a name="l01613"></a>01613 
<a name="l01614"></a>01614       <span class="comment">// Refine all the elements we just flagged.</span>
<a name="l01615"></a>01615       this-&gt;<a class="code" href="classMeshRefinement.php#a2edc635e999cae1d61575a7dd54ca782">_refine_elements</a>();
<a name="l01616"></a>01616     }
<a name="l01617"></a>01617   
<a name="l01618"></a>01618   <span class="comment">// Finally, the new mesh needs to be prepared for use</span>
<a name="l01619"></a>01619   <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a> ();
<a name="l01620"></a>01620 }
<a name="l01621"></a>01621 
<a name="l01622"></a>01622 
<a name="l01623"></a>01623 
<a name="l01624"></a><a class="code" href="classMeshRefinement.php#ab1c27c47f0c680e97e3ef33c09312278">01624</a> <span class="keywordtype">void</span> <a class="code" href="classMeshRefinement.php#ab1c27c47f0c680e97e3ef33c09312278">MeshRefinement::uniformly_coarsen</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l01625"></a>01625 {
<a name="l01626"></a>01626   <span class="comment">// Coarsen n times</span>
<a name="l01627"></a>01627   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rstep=0; rstep&lt;n; rstep++)
<a name="l01628"></a>01628     {
<a name="l01629"></a>01629       <span class="comment">// Clean up the refinement flags</span>
<a name="l01630"></a>01630       this-&gt;<a class="code" href="classMeshRefinement.php#a78e121fabb0ee86091a7c39190440ca1">clean_refinement_flags</a>();
<a name="l01631"></a>01631       
<a name="l01632"></a>01632       <span class="comment">// Flag all the active elements for coarsening</span>
<a name="l01633"></a>01633       <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#afa816e5e9ad7e9140a9b2131e06c777b">active_elements_begin</a>();
<a name="l01634"></a>01634       <span class="keyword">const</span> <a class="code" href="structMeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a8ba916f71ea6df87fe1d9adc2e92be1e">active_elements_end</a>(); 
<a name="l01635"></a>01635 
<a name="l01636"></a>01636       <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01637"></a>01637         {
<a name="l01638"></a>01638           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a38f6891e50b8a289565b655135e1b0c5">Elem::COARSEN</a>);
<a name="l01639"></a>01639           <span class="keywordflow">if</span> ((*elem_it)-&gt;parent()) 
<a name="l01640"></a>01640             (*elem_it)-&gt;parent()-&gt;set_refinement_flag(<a class="code" href="classElem.php#a946039859488cca879512de516fef829a1d4c57ce97a2dff1f6dd0e2b8855f80e">Elem::COARSEN_INACTIVE</a>);
<a name="l01641"></a>01641         }
<a name="l01642"></a>01642 
<a name="l01643"></a>01643       <span class="comment">// Coarsen all the elements we just flagged.</span>
<a name="l01644"></a>01644       this-&gt;<a class="code" href="classMeshRefinement.php#ae33151743e5987e4d216eac6a1142376">_coarsen_elements</a>();
<a name="l01645"></a>01645     }
<a name="l01646"></a>01646     
<a name="l01647"></a>01647   
<a name="l01648"></a>01648   <span class="comment">// Finally, the new mesh needs to be prepared for use</span>
<a name="l01649"></a>01649   <a class="code" href="classMeshRefinement.php#a27a229e0c166dee9ac24b22916b6933a">_mesh</a>.<a class="code" href="classMeshBase.php#a7c79bc3b9a75a580ed1ef91195eb77e5">prepare_for_use</a> ();
<a name="l01650"></a>01650 }
<a name="l01651"></a>01651 
<a name="l01652"></a>01652 
<a name="l01653"></a>01653 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
