<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_9bc6555b272caa61bcb135ef1733087c.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_68b326994b1686b0c255607250545e3c.php">parallel</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>parallel.h</h1>  </div>
</div>
<div class="contents">
<a href="parallel_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel.h 3478 2009-09-29 03:00:33Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __parallel_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// System includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;libmesh_common.h&quot;</span> <span class="comment">// for Real</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Macro to identify and debug functions which should only be called in</span>
<a name="l00034"></a>00034 <span class="comment">// parallel on every processor at once</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#undef parallel_only</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">  #define parallel_only() do { libmesh_assert(Parallel::verify(std::string(__FILE__))); libmesh_assert(Parallel::verify(__LINE__)); } while (0)</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">  #define parallel_only()</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00050"></a>00050 <span class="keyword">namespace </span>Parallel
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment"></span>  <span class="keyword">class </span>DataType;
<a name="l00057"></a>00057   <span class="keyword">class </span>Request;
<a name="l00058"></a>00058   <span class="keyword">class </span>Status;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00065"></a>00065 <span class="comment"></span>  <span class="keyword">typedef</span> MPI_Datatype data_type;
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <span class="keyword">typedef</span> MPI_Request request;
<a name="l00071"></a>00071 
<a name="l00075"></a>00075   <span class="keyword">typedef</span> MPI_Status status;
<a name="l00076"></a>00076  
<a name="l00081"></a>00081   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00082"></a>00082   <span class="keyword">inline</span> data_type datatype();
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keyword">const</span> <span class="keywordtype">int</span> any_tag=MPI_ANY_TAG;
<a name="l00088"></a>00088 
<a name="l00092"></a>00092   <span class="keyword">const</span> <span class="keywordtype">int</span> any_source=MPI_ANY_SOURCE;
<a name="l00093"></a>00093   
<a name="l00094"></a>00094 <span class="preprocessor">#else</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span>
<a name="l00096"></a>00096   <span class="comment">// These shouldn&#39;t actually be needed, but must be </span>
<a name="l00097"></a>00097   <span class="comment">// unique types for function overloading to work </span>
<a name="l00098"></a>00098   <span class="comment">// properly.</span>
<a name="l00099"></a>00099   <span class="keyword">struct </span>data_type { <span class="comment">/* unsigned int t; */</span> };
<a name="l00100"></a>00100   <span class="keyword">struct </span>request   { <span class="comment">/* unsigned int r; */</span> };
<a name="l00101"></a>00101   <span class="keyword">struct </span>status    { <span class="comment">/* unsigned int s; */</span> };
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00104"></a>00104   <span class="keyword">inline</span> data_type datatype() { <span class="keywordflow">return</span> data_type(); }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keyword">const</span> <span class="keywordtype">int</span> any_tag=-1;
<a name="l00107"></a>00107   <span class="keyword">const</span> <span class="keywordtype">int</span> any_source=0;
<a name="l00108"></a>00108 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span>
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00116"></a>00116 <span class="comment"></span>  <span class="keyword">class </span>DataType
<a name="l00117"></a>00117   {
<a name="l00118"></a>00118   <span class="keyword">public</span>:
<a name="l00119"></a>00119     DataType () {}
<a name="l00120"></a>00120 
<a name="l00121"></a>00121     DataType (<span class="keyword">const</span> DataType &amp;other) :
<a name="l00122"></a>00122       _datatype(other._datatype)
<a name="l00123"></a>00123     {}
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     DataType (<span class="keyword">const</span> data_type &amp;type) :
<a name="l00126"></a>00126       _datatype(type)
<a name="l00127"></a>00127     {}
<a name="l00128"></a>00128 
<a name="l00129"></a>00129     DataType &amp; operator = (<span class="keyword">const</span> DataType &amp;other) 
<a name="l00130"></a>00130     { _datatype = other._datatype; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132     DataType &amp; operator = (<span class="keyword">const</span> data_type &amp;type)
<a name="l00133"></a>00133     { _datatype = type; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     operator const data_type &amp; ()<span class="keyword"> const</span>
<a name="l00136"></a>00136 <span class="keyword">    </span>{ <span class="keywordflow">return</span> _datatype; }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     operator data_type &amp; ()
<a name="l00139"></a>00139     { <span class="keywordflow">return</span> _datatype; }
<a name="l00140"></a>00140     
<a name="l00141"></a>00141 <span class="comment">//     operator data_type const * () const</span>
<a name="l00142"></a>00142 <span class="comment">//     { return &amp;_datatype; }</span>
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="comment">//     operator data_type * ()</span>
<a name="l00145"></a>00145 <span class="comment">//     { return &amp;_datatype; }</span>
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     <span class="keywordtype">void</span> commit ()
<a name="l00148"></a>00148     {
<a name="l00149"></a>00149 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>      MPI_Type_commit (&amp;_datatype);
<a name="l00151"></a>00151 <span class="preprocessor">#endif</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>    }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154     <span class="keywordtype">void</span> free ()
<a name="l00155"></a>00155     {
<a name="l00156"></a>00156 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span>      MPI_Type_free (&amp;_datatype);
<a name="l00158"></a>00158 <span class="preprocessor">#endif</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>    }
<a name="l00160"></a>00160     
<a name="l00161"></a>00161   <span class="keyword">private</span>:
<a name="l00162"></a>00162 
<a name="l00163"></a>00163     data_type _datatype;    
<a name="l00164"></a>00164   };
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00173"></a>00173 <span class="comment"></span>  <span class="keyword">class </span>Status
<a name="l00174"></a>00174   {
<a name="l00175"></a>00175   <span class="keyword">public</span>:
<a name="l00176"></a>00176     Status () {}
<a name="l00177"></a>00177     
<a name="l00178"></a>00178     Status (<span class="keyword">const</span> data_type &amp;type) :
<a name="l00179"></a>00179     _datatype(type)           
<a name="l00180"></a>00180     {}
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     Status (<span class="keyword">const</span> status &amp;status) :
<a name="l00183"></a>00183       _status(status)
<a name="l00184"></a>00184     {}
<a name="l00185"></a>00185 
<a name="l00186"></a>00186     Status (<span class="keyword">const</span> status    &amp;status,
<a name="l00187"></a>00187             <span class="keyword">const</span> data_type &amp;type) :
<a name="l00188"></a>00188       _status(status),
<a name="l00189"></a>00189       _datatype(type)           
<a name="l00190"></a>00190     {}
<a name="l00191"></a>00191 
<a name="l00192"></a>00192     Status (<span class="keyword">const</span> Status &amp;status) :
<a name="l00193"></a>00193       _status(status._status),
<a name="l00194"></a>00194       _datatype(status._datatype)
<a name="l00195"></a>00195     {}
<a name="l00196"></a>00196 
<a name="l00197"></a>00197     Status (<span class="keyword">const</span> Status    &amp;status,
<a name="l00198"></a>00198             <span class="keyword">const</span> data_type &amp;type) :
<a name="l00199"></a>00199       _status(status._status),
<a name="l00200"></a>00200       _datatype(type)
<a name="l00201"></a>00201     {}
<a name="l00202"></a>00202     
<a name="l00203"></a>00203     operator status * () 
<a name="l00204"></a>00204     { <span class="keywordflow">return</span> &amp;_status; }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206     operator status const * ()<span class="keyword"> const</span>
<a name="l00207"></a>00207 <span class="keyword">    </span>{ <span class="keywordflow">return</span> &amp;_status; }
<a name="l00208"></a>00208     
<a name="l00209"></a>00209 <span class="comment">//     operator status &amp; ()</span>
<a name="l00210"></a>00210 <span class="comment">//     { return _status; }</span>
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 <span class="comment">//     operator const status &amp; () const</span>
<a name="l00213"></a>00213 <span class="comment">//     { return _status; }</span>
<a name="l00214"></a>00214 
<a name="l00215"></a>00215     <span class="keywordtype">int</span> source ()<span class="keyword"> const</span>
<a name="l00216"></a>00216 <span class="keyword">    </span>{
<a name="l00217"></a>00217 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI </span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>      <span class="keywordflow">return</span> _status.MPI_SOURCE; 
<a name="l00219"></a>00219 <span class="preprocessor">#else</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span>      <span class="keywordflow">return</span> 0;
<a name="l00221"></a>00221 <span class="preprocessor">#endif</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span>    }    
<a name="l00223"></a>00223 
<a name="l00224"></a>00224     <span class="keywordtype">int</span> tag ()<span class="keyword"> const</span>
<a name="l00225"></a>00225 <span class="keyword">    </span>{
<a name="l00226"></a>00226 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI </span>
<a name="l00227"></a>00227 <span class="preprocessor"></span>      <span class="keywordflow">return</span> _status.MPI_TAG; 
<a name="l00228"></a>00228 <span class="preprocessor">#else</span>
<a name="l00229"></a>00229 <span class="preprocessor"></span>      libmesh_error();
<a name="l00230"></a>00230       <span class="keywordflow">return</span> 0;
<a name="l00231"></a>00231 <span class="preprocessor">#endif</span>
<a name="l00232"></a>00232 <span class="preprocessor"></span>    }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234     data_type&amp; datatype () 
<a name="l00235"></a>00235     { <span class="keywordflow">return</span> _datatype; }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237     <span class="keyword">const</span> data_type&amp; datatype ()<span class="keyword"> const</span>
<a name="l00238"></a>00238 <span class="keyword">    </span>{ <span class="keywordflow">return</span> _datatype; }
<a name="l00239"></a>00239   
<a name="l00240"></a>00240 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size (<span class="keyword">const</span> data_type &amp;type)<span class="keyword"> const</span>
<a name="l00242"></a>00242 <span class="keyword">    </span>{
<a name="l00243"></a>00243       <span class="keywordtype">int</span> msg_size;
<a name="l00244"></a>00244       MPI_Get_count (const_cast&lt;MPI_Status*&gt;(&amp;_status), type, &amp;msg_size);
<a name="l00245"></a>00245       libmesh_assert (msg_size &gt;= 0);
<a name="l00246"></a>00246       <span class="keywordflow">return</span> msg_size;
<a name="l00247"></a>00247     }
<a name="l00248"></a>00248 <span class="preprocessor">#else</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size (<span class="keyword">const</span> data_type &amp;)<span class="keyword"> const</span>
<a name="l00250"></a>00250 <span class="keyword">    </span>{
<a name="l00251"></a>00251       libmesh_error();
<a name="l00252"></a>00252       <span class="keywordflow">return</span> 0;
<a name="l00253"></a>00253     }
<a name="l00254"></a>00254 <span class="preprocessor">#endif</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span>
<a name="l00256"></a>00256     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size ()<span class="keyword"> const</span>
<a name="l00257"></a>00257 <span class="keyword">    </span>{ <span class="keywordflow">return</span> this-&gt;size (this-&gt;datatype()); }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259   <span class="keyword">private</span>:
<a name="l00260"></a>00260 
<a name="l00261"></a>00261     status    _status;
<a name="l00262"></a>00262     data_type _datatype;
<a name="l00263"></a>00263   };
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00271"></a>00271 <span class="comment"></span>  <span class="keyword">class </span>Request
<a name="l00272"></a>00272   {
<a name="l00273"></a>00273   <span class="keyword">public</span>:
<a name="l00274"></a>00274     Request () 
<a name="l00275"></a>00275     {
<a name="l00276"></a>00276 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00277"></a>00277 <span class="preprocessor"></span>      _request = MPI_REQUEST_NULL;
<a name="l00278"></a>00278 <span class="preprocessor">#endif</span>
<a name="l00279"></a>00279 <span class="preprocessor"></span>    }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281     Request (<span class="keyword">const</span> request &amp;r) :
<a name="l00282"></a>00282       _request(r)
<a name="l00283"></a>00283     {}
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     Request &amp; operator = (<span class="keyword">const</span> Request &amp;other) 
<a name="l00286"></a>00286     { _request = other._request; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288     Request &amp; operator = (<span class="keyword">const</span> request &amp;r)
<a name="l00289"></a>00289     { _request = r; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291     ~Request ()
<a name="l00292"></a>00292     {
<a name="l00293"></a>00293 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00294"></a>00294 <span class="preprocessor"></span>      <span class="comment">// explicitly free this request if not </span>
<a name="l00295"></a>00295       <span class="comment">// done so already, otherwise this would</span>
<a name="l00296"></a>00296       <span class="comment">// be a memory leak!</span>
<a name="l00297"></a>00297       <span class="keywordflow">if</span> (_request != MPI_REQUEST_NULL)
<a name="l00298"></a>00298         MPI_Request_free (&amp;_request);
<a name="l00299"></a>00299 <span class="preprocessor">#endif</span>
<a name="l00300"></a>00300 <span class="preprocessor"></span>    }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302     operator const request &amp; ()<span class="keyword"> const</span>
<a name="l00303"></a>00303 <span class="keyword">    </span>{ <span class="keywordflow">return</span> _request; }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305     operator request &amp; () 
<a name="l00306"></a>00306     { <span class="keywordflow">return</span> _request; }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308     status wait ()
<a name="l00309"></a>00309     {
<a name="l00310"></a>00310       status status;
<a name="l00311"></a>00311 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00312"></a>00312 <span class="preprocessor"></span>      MPI_Wait (&amp;_request, &amp;status);
<a name="l00313"></a>00313 <span class="preprocessor">#endif</span>
<a name="l00314"></a>00314 <span class="preprocessor"></span>      <span class="keywordflow">return</span> status;
<a name="l00315"></a>00315     }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317     <span class="keywordtype">bool</span> test ()
<a name="l00318"></a>00318     {
<a name="l00319"></a>00319 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span>      <span class="keywordtype">int</span> val=0;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322       MPI_Test (&amp;_request,
<a name="l00323"></a>00323                 &amp;val,
<a name="l00324"></a>00324                 MPI_STATUS_IGNORE);
<a name="l00325"></a>00325       <span class="keywordflow">if</span> (val)
<a name="l00326"></a>00326         {
<a name="l00327"></a>00327           libmesh_assert (_request == MPI_REQUEST_NULL);
<a name="l00328"></a>00328           libmesh_assert (val == 1);
<a name="l00329"></a>00329         }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331       <span class="keywordflow">return</span> val;
<a name="l00332"></a>00332 <span class="preprocessor">#else</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>      <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00334"></a>00334 <span class="preprocessor">#endif</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>    }
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00338"></a>00338 <span class="preprocessor"></span>    <span class="keywordtype">bool</span> test (status &amp;status)
<a name="l00339"></a>00339     {
<a name="l00340"></a>00340       <span class="keywordtype">int</span> val=0;
<a name="l00341"></a>00341 
<a name="l00342"></a>00342       MPI_Test (&amp;_request,
<a name="l00343"></a>00343                 &amp;val,
<a name="l00344"></a>00344                 &amp;status);
<a name="l00345"></a>00345 
<a name="l00346"></a>00346       <span class="keywordflow">return</span> val;
<a name="l00347"></a>00347 <span class="preprocessor">#else</span>
<a name="l00348"></a>00348 <span class="preprocessor"></span>    <span class="keywordtype">bool</span> test (status &amp;)
<a name="l00349"></a>00349     {
<a name="l00350"></a>00350       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00351"></a>00351 <span class="preprocessor">#endif</span>
<a name="l00352"></a>00352 <span class="preprocessor"></span>    }
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355   <span class="keyword">private</span>:
<a name="l00356"></a>00356 
<a name="l00357"></a>00357     request _request;    
<a name="l00358"></a>00358   };
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361   
<a name="l00362"></a>00362   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00366"></a>00366 <span class="comment"></span>  <span class="keyword">inline</span> <span class="keywordtype">void</span> barrier ()
<a name="l00367"></a>00367   {
<a name="l00368"></a>00368 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00369"></a>00369 <span class="preprocessor"></span>    MPI_Barrier (<a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l00370"></a>00370 <span class="preprocessor">#endif</span>
<a name="l00371"></a>00371 <span class="preprocessor"></span>  }    
<a name="l00372"></a>00372   
<a name="l00373"></a>00373   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00377"></a>00377 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00378"></a>00378   <span class="keyword">inline</span> <span class="keywordtype">bool</span> verify(<span class="keyword">const</span> T &amp;r);
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00385"></a>00385 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00386"></a>00386   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(T &amp;r);
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00393"></a>00393 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00394"></a>00394   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(std::vector&lt;T&gt; &amp;r);
<a name="l00395"></a>00395 
<a name="l00396"></a>00396   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00401"></a>00401 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00402"></a>00402   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(T &amp;r);
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00409"></a>00409 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00410"></a>00410   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(std::vector&lt;T&gt; &amp;r);
<a name="l00411"></a>00411 
<a name="l00412"></a>00412   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00417"></a>00417 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00418"></a>00418   <span class="keyword">inline</span> <span class="keywordtype">void</span> sum(T &amp;r);
<a name="l00419"></a>00419 
<a name="l00420"></a>00420   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00425"></a>00425 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00426"></a>00426   <span class="keyword">inline</span> <span class="keywordtype">void</span> sum(std::vector&lt;T&gt; &amp;r);
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00433"></a>00433 <span class="comment"></span>  <span class="keyword">inline</span> status probe (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00434"></a>00434                        <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag);
<a name="l00435"></a>00435 
<a name="l00436"></a>00436   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00440"></a>00440 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00441"></a>00441   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00442"></a>00442                     std::vector&lt;T&gt; &amp;buf,
<a name="l00443"></a>00443                     <span class="keyword">const</span> DataType &amp;type,
<a name="l00444"></a>00444                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0);
<a name="l00445"></a>00445 
<a name="l00446"></a>00446   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00450"></a>00450 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00451"></a>00451   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00452"></a>00452                     std::vector&lt;T&gt; &amp;buf,
<a name="l00453"></a>00453                     <span class="keyword">const</span> DataType &amp;type,
<a name="l00454"></a>00454                     request &amp;req,
<a name="l00455"></a>00455                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0);
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00462"></a>00462 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00463"></a>00463   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00464"></a>00464                     std::vector&lt;T&gt; &amp;buf,
<a name="l00465"></a>00465                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0)
<a name="l00466"></a>00466   {
<a name="l00467"></a>00467     send (dest_processor_id,
<a name="l00468"></a>00468           buf,
<a name="l00469"></a>00469           datatype&lt;T&gt;(),
<a name="l00470"></a>00470           tag);
<a name="l00471"></a>00471   }
<a name="l00472"></a>00472 
<a name="l00473"></a>00473   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00474"></a>00474   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00475"></a>00475   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00476"></a>00476                     std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00477"></a>00477                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0)
<a name="l00478"></a>00478   {
<a name="l00479"></a>00479     send (dest_processor_id,
<a name="l00480"></a>00480           buf,
<a name="l00481"></a>00481           datatype&lt;T&gt;(),
<a name="l00482"></a>00482           tag);
<a name="l00483"></a>00483   }
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00491"></a>00491 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00492"></a>00492   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00493"></a>00493                     std::vector&lt;T&gt; &amp;buf,
<a name="l00494"></a>00494                     request &amp;req,
<a name="l00495"></a>00495                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0)
<a name="l00496"></a>00496   {
<a name="l00497"></a>00497     send (dest_processor_id,
<a name="l00498"></a>00498           buf,
<a name="l00499"></a>00499           datatype&lt;T&gt;(),
<a name="l00500"></a>00500           req,
<a name="l00501"></a>00501           tag);
<a name="l00502"></a>00502   }
<a name="l00503"></a>00503 
<a name="l00504"></a>00504   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00505"></a>00505   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00506"></a>00506   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00507"></a>00507                     std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00508"></a>00508                     request &amp;req,
<a name="l00509"></a>00509                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0)
<a name="l00510"></a>00510   {
<a name="l00511"></a>00511     send (dest_processor_id,
<a name="l00512"></a>00512           buf,
<a name="l00513"></a>00513           datatype&lt;T&gt;(),
<a name="l00514"></a>00514           req,
<a name="l00515"></a>00515           tag);
<a name="l00516"></a>00516   }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00523"></a>00523 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00524"></a>00524   <span class="keyword">inline</span> <span class="keywordtype">void</span> nonblocking_send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00525"></a>00525                                 std::vector&lt;T&gt; &amp;buf,
<a name="l00526"></a>00526                                 <span class="keyword">const</span> DataType &amp;type,
<a name="l00527"></a>00527                                 request &amp;r,
<a name="l00528"></a>00528                                 <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0)
<a name="l00529"></a>00529   {
<a name="l00530"></a>00530     send (dest_processor_id,
<a name="l00531"></a>00531           buf,
<a name="l00532"></a>00532           type,
<a name="l00533"></a>00533           r,
<a name="l00534"></a>00534           tag);
<a name="l00535"></a>00535   }
<a name="l00536"></a>00536 
<a name="l00537"></a>00537   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00541"></a>00541 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00542"></a>00542   <span class="keyword">inline</span> <span class="keywordtype">void</span> nonblocking_send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00543"></a>00543                                 std::vector&lt;T&gt; &amp;buf,
<a name="l00544"></a>00544                                 request &amp;r,
<a name="l00545"></a>00545                                 <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0)
<a name="l00546"></a>00546   {
<a name="l00547"></a>00547     send (dest_processor_id,
<a name="l00548"></a>00548           buf,
<a name="l00549"></a>00549           datatype&lt;T&gt;(),
<a name="l00550"></a>00550           r,
<a name="l00551"></a>00551           tag);
<a name="l00552"></a>00552   }
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00555"></a>00555   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00556"></a>00556   <span class="keyword">inline</span> <span class="keywordtype">void</span> nonblocking_send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00557"></a>00557                                 std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00558"></a>00558                                 request &amp;r,
<a name="l00559"></a>00559                                 <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0)
<a name="l00560"></a>00560   {
<a name="l00561"></a>00561     send (dest_processor_id,
<a name="l00562"></a>00562           buf,
<a name="l00563"></a>00563           datatype&lt;T&gt;(),
<a name="l00564"></a>00564           r,
<a name="l00565"></a>00565           tag);
<a name="l00566"></a>00566   }
<a name="l00567"></a>00567 
<a name="l00568"></a>00568   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00572"></a>00572 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00573"></a>00573   <span class="keyword">inline</span> Status receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00574"></a>00574                          std::vector&lt;T&gt; &amp;buf,
<a name="l00575"></a>00575                          <span class="keyword">const</span> DataType &amp;type,
<a name="l00576"></a>00576                          <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag);
<a name="l00577"></a>00577 
<a name="l00578"></a>00578   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00582"></a>00582 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00583"></a>00583   <span class="keyword">inline</span> <span class="keywordtype">void</span> receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00584"></a>00584                        std::vector&lt;T&gt; &amp;buf,
<a name="l00585"></a>00585                        <span class="keyword">const</span> DataType &amp;type,
<a name="l00586"></a>00586                        request &amp;req,
<a name="l00587"></a>00587                        <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag);
<a name="l00588"></a>00588 
<a name="l00589"></a>00589   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00594"></a>00594 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00595"></a>00595   <span class="keyword">inline</span> Status receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00596"></a>00596                          std::vector&lt;T&gt; &amp;buf,
<a name="l00597"></a>00597                          <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag)
<a name="l00598"></a>00598   {
<a name="l00599"></a>00599     <span class="keywordflow">return</span> receive (src_processor_id,
<a name="l00600"></a>00600                     buf,
<a name="l00601"></a>00601                     datatype&lt;T&gt;(),
<a name="l00602"></a>00602                     tag);
<a name="l00603"></a>00603   }
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00606"></a>00606   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00607"></a>00607   <span class="keyword">inline</span> Status receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00608"></a>00608                          std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00609"></a>00609                          <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag)
<a name="l00610"></a>00610   {
<a name="l00611"></a>00611     <span class="keywordflow">return</span> receive (src_processor_id,
<a name="l00612"></a>00612                     buf,
<a name="l00613"></a>00613                     datatype&lt;T&gt;(),
<a name="l00614"></a>00614                     tag);
<a name="l00615"></a>00615   }
<a name="l00616"></a>00616 
<a name="l00617"></a>00617   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00622"></a>00622 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00623"></a>00623   <span class="keyword">inline</span> <span class="keywordtype">void</span> receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00624"></a>00624                        std::vector&lt;T&gt; &amp;buf,
<a name="l00625"></a>00625                        request &amp;req,
<a name="l00626"></a>00626                        <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag)
<a name="l00627"></a>00627   {
<a name="l00628"></a>00628     receive (src_processor_id,
<a name="l00629"></a>00629              buf,
<a name="l00630"></a>00630              datatype&lt;T&gt;(),
<a name="l00631"></a>00631              req,
<a name="l00632"></a>00632              tag);
<a name="l00633"></a>00633   }
<a name="l00634"></a>00634 
<a name="l00635"></a>00635   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00636"></a>00636   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00637"></a>00637   <span class="keyword">inline</span> <span class="keywordtype">void</span> receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00638"></a>00638                        std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00639"></a>00639                        request &amp;req,
<a name="l00640"></a>00640                        <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag)
<a name="l00641"></a>00641   {
<a name="l00642"></a>00642     receive (src_processor_id,
<a name="l00643"></a>00643              buf,
<a name="l00644"></a>00644              datatype&lt;T&gt;(),
<a name="l00645"></a>00645              req,
<a name="l00646"></a>00646              tag);
<a name="l00647"></a>00647   }
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00653"></a>00653 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00654"></a>00654   <span class="keyword">inline</span> <span class="keywordtype">void</span> nonblocking_receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00655"></a>00655                                    std::vector&lt;T&gt; &amp;buf,
<a name="l00656"></a>00656                                    <span class="keyword">const</span> DataType &amp;type,
<a name="l00657"></a>00657                                    request &amp;r,
<a name="l00658"></a>00658                                    <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag)
<a name="l00659"></a>00659   {
<a name="l00660"></a>00660     receive (src_processor_id,
<a name="l00661"></a>00661              buf,
<a name="l00662"></a>00662              type,
<a name="l00663"></a>00663              r,
<a name="l00664"></a>00664              tag);
<a name="l00665"></a>00665   }
<a name="l00666"></a>00666 
<a name="l00667"></a>00667   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00671"></a>00671 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00672"></a>00672   <span class="keyword">inline</span> <span class="keywordtype">void</span> nonblocking_receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00673"></a>00673                                    std::vector&lt;T&gt; &amp;buf,
<a name="l00674"></a>00674                                    request &amp;r,
<a name="l00675"></a>00675                                    <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag)
<a name="l00676"></a>00676   {
<a name="l00677"></a>00677     receive (src_processor_id,
<a name="l00678"></a>00678              buf,
<a name="l00679"></a>00679              datatype&lt;T&gt;(),
<a name="l00680"></a>00680              r,
<a name="l00681"></a>00681              tag);
<a name="l00682"></a>00682   }
<a name="l00683"></a>00683 
<a name="l00684"></a>00684   <span class="comment">// Function overloading for std::complex&lt;&gt;</span>
<a name="l00685"></a>00685   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00686"></a>00686   <span class="keyword">inline</span> <span class="keywordtype">void</span> nonblocking_receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l00687"></a>00687                                    std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l00688"></a>00688                                    request &amp;r,
<a name="l00689"></a>00689                                    <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag)
<a name="l00690"></a>00690   {
<a name="l00691"></a>00691     receive (src_processor_id,
<a name="l00692"></a>00692              buf,
<a name="l00693"></a>00693              datatype&lt;T&gt;(),
<a name="l00694"></a>00694              r,
<a name="l00695"></a>00695              tag);
<a name="l00696"></a>00696   }
<a name="l00697"></a>00697 
<a name="l00698"></a>00698   
<a name="l00699"></a>00699   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00703"></a>00703 <span class="comment"></span>  <span class="keyword">inline</span> status wait (request &amp;r);
<a name="l00704"></a>00704   
<a name="l00705"></a>00705   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00709"></a>00709 <span class="comment"></span>  <span class="keyword">inline</span> <span class="keywordtype">void</span> wait (std::vector&lt;request&gt; &amp;r);
<a name="l00710"></a>00710   
<a name="l00711"></a>00711   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00715"></a>00715 <span class="comment"></span>  <span class="keyword">inline</span> <span class="keywordtype">void</span> wait (std::vector&lt;Request&gt; &amp;r)
<a name="l00716"></a>00716   { <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;r.size(); i++) r[i].wait(); }
<a name="l00717"></a>00717   
<a name="l00718"></a>00718   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00723"></a>00723 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00724"></a>00724   <span class="keyword">inline</span> <span class="keywordtype">void</span> send_receive(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00725"></a>00725                            T &amp;send,
<a name="l00726"></a>00726                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l00727"></a>00727                            T &amp;recv);
<a name="l00728"></a>00728 
<a name="l00729"></a>00729   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00735"></a>00735 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00736"></a>00736   <span class="keyword">inline</span> <span class="keywordtype">void</span> send_receive(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l00737"></a>00737                            T &amp;send,
<a name="l00738"></a>00738                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l00739"></a>00739                            T &amp;recv,
<a name="l00740"></a>00740                            <span class="keyword">const</span> DataType &amp;type);
<a name="l00741"></a>00741 
<a name="l00742"></a>00742   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00747"></a>00747 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00748"></a>00748   <span class="keyword">inline</span> <span class="keywordtype">void</span> gather(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l00749"></a>00749                      T send,
<a name="l00750"></a>00750                      std::vector&lt;T&gt; &amp;recv);
<a name="l00751"></a>00751 
<a name="l00752"></a>00752   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00757"></a>00757 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00758"></a>00758   <span class="keyword">inline</span> <span class="keywordtype">void</span> gather(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l00759"></a>00759                      std::vector&lt;T&gt; &amp;r);
<a name="l00760"></a>00760 
<a name="l00761"></a>00761   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00766"></a>00766 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00767"></a>00767   <span class="keyword">inline</span> <span class="keywordtype">void</span> allgather(T send,
<a name="l00768"></a>00768                         std::vector&lt;T&gt; &amp;recv);
<a name="l00769"></a>00769 
<a name="l00770"></a>00770 
<a name="l00771"></a>00771   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00779"></a>00779 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00780"></a>00780   <span class="keyword">inline</span> <span class="keywordtype">void</span> allgather(std::vector&lt;T&gt; &amp;r,
<a name="l00781"></a>00781                         <span class="keyword">const</span> <span class="keywordtype">bool</span> identical_buffer_sizes = <span class="keyword">false</span>);
<a name="l00782"></a>00782 
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 
<a name="l00785"></a>00785   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00791"></a>00791 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00792"></a>00792   <span class="keyword">inline</span> <span class="keywordtype">void</span> alltoall(std::vector&lt;T&gt; &amp;r);
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 
<a name="l00796"></a>00796   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00802"></a>00802 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00803"></a>00803   <span class="keyword">inline</span> <span class="keywordtype">void</span> broadcast(T &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0);
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 
<a name="l00806"></a>00806 
<a name="l00807"></a>00807   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00814"></a>00814 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00815"></a>00815   <span class="keyword">inline</span> <span class="keywordtype">void</span> broadcast(std::vector&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0);
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 
<a name="l00818"></a>00818 
<a name="l00819"></a>00819   <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00820"></a>00820   <span class="comment">// Parallel members</span>
<a name="l00821"></a>00821 
<a name="l00822"></a>00822   <span class="comment">// Internal helper function to create vector&lt;something_useable&gt; from</span>
<a name="l00823"></a>00823   <span class="comment">// vector&lt;bool&gt; for compatibility with MPI bitwise operations</span>
<a name="l00824"></a>00824   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00825"></a>00825   <span class="keyword">inline</span> <span class="keywordtype">void</span> pack_vector_bool(<span class="keyword">const</span> std::vector&lt;bool&gt; &amp;in,
<a name="l00826"></a>00826                                std::vector&lt;T&gt; &amp;out)
<a name="l00827"></a>00827   {
<a name="l00828"></a>00828     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_bits = 8*<span class="keyword">sizeof</span>(T);
<a name="l00829"></a>00829     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> in_size = in.size();
<a name="l00830"></a>00830     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> out_size = in_size/data_bits + (in_size%data_bits?1:0);
<a name="l00831"></a>00831     out.clear();
<a name="l00832"></a>00832     out.resize(out_size);
<a name="l00833"></a>00833     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != in_size; ++i)
<a name="l00834"></a>00834       {
<a name="l00835"></a>00835         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = i/data_bits;
<a name="l00836"></a>00836         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset = i%data_bits;
<a name="l00837"></a>00837         out[index] += (in[i]?1:0) &lt;&lt; offset;
<a name="l00838"></a>00838       }
<a name="l00839"></a>00839   }
<a name="l00840"></a>00840 
<a name="l00841"></a>00841   <span class="comment">// Internal helper function to create vector&lt;something_useable&gt; from</span>
<a name="l00842"></a>00842   <span class="comment">// vector&lt;bool&gt; for compatibility with MPI byte operations</span>
<a name="l00843"></a>00843   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00844"></a>00844   <span class="keyword">inline</span> <span class="keywordtype">void</span> unpack_vector_bool(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;in,
<a name="l00845"></a>00845                                  std::vector&lt;bool&gt; &amp;out)
<a name="l00846"></a>00846   {
<a name="l00847"></a>00847     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_bits = 8*<span class="keyword">sizeof</span>(T);
<a name="l00848"></a>00848     <span class="comment">// We need the output vector to already be properly sized</span>
<a name="l00849"></a>00849     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> out_size = out.size();
<a name="l00850"></a>00850     libmesh_assert(out_size/data_bits + (out_size%data_bits?1:0) == in.size());
<a name="l00851"></a>00851 
<a name="l00852"></a>00852     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != out_size; ++i)
<a name="l00853"></a>00853       {
<a name="l00854"></a>00854         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = i/data_bits;
<a name="l00855"></a>00855         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset = i%data_bits;
<a name="l00856"></a>00856         out[i] = in[index] &lt;&lt; (data_bits-1-offset) &gt;&gt; (data_bits-1);
<a name="l00857"></a>00857       }
<a name="l00858"></a>00858   }
<a name="l00859"></a>00859 
<a name="l00860"></a>00860 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00861"></a>00861 <span class="preprocessor"></span> <span class="keyword">template</span>&lt;&gt;
<a name="l00862"></a>00862  <span class="keyword">inline</span> data_type datatype&lt;char&gt;() { <span class="keywordflow">return</span> MPI_CHAR; }
<a name="l00863"></a>00863 
<a name="l00864"></a>00864  <span class="keyword">template</span>&lt;&gt;
<a name="l00865"></a>00865  <span class="keyword">inline</span> data_type datatype&lt;unsigned char&gt;() { <span class="keywordflow">return</span> MPI_UNSIGNED_CHAR; }
<a name="l00866"></a>00866 
<a name="l00867"></a>00867   <span class="keyword">template</span>&lt;&gt;
<a name="l00868"></a>00868   <span class="keyword">inline</span> data_type datatype&lt;short int&gt;() { <span class="keywordflow">return</span> MPI_SHORT; }
<a name="l00869"></a>00869 
<a name="l00870"></a>00870   <span class="keyword">template</span>&lt;&gt;
<a name="l00871"></a>00871   <span class="keyword">inline</span> data_type datatype&lt;unsigned short int&gt;() { <span class="keywordflow">return</span> MPI_UNSIGNED_SHORT; }
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   <span class="keyword">template</span>&lt;&gt;
<a name="l00874"></a>00874   <span class="keyword">inline</span> data_type datatype&lt;int&gt;() { <span class="keywordflow">return</span> MPI_INT; }
<a name="l00875"></a>00875 
<a name="l00876"></a>00876   <span class="keyword">template</span>&lt;&gt;
<a name="l00877"></a>00877   <span class="keyword">inline</span> data_type datatype&lt;unsigned int&gt;() { <span class="keywordflow">return</span> MPI_UNSIGNED; }
<a name="l00878"></a>00878 
<a name="l00879"></a>00879   <span class="keyword">template</span>&lt;&gt;
<a name="l00880"></a>00880   <span class="keyword">inline</span> data_type datatype&lt;long&gt;() { <span class="keywordflow">return</span> MPI_LONG; }
<a name="l00881"></a>00881 
<a name="l00882"></a>00882   <span class="keyword">template</span>&lt;&gt;
<a name="l00883"></a>00883   <span class="keyword">inline</span> data_type datatype&lt;unsigned long&gt;() { <span class="keywordflow">return</span> MPI_UNSIGNED_LONG; }
<a name="l00884"></a>00884 
<a name="l00885"></a>00885   <span class="keyword">template</span>&lt;&gt;
<a name="l00886"></a>00886   <span class="keyword">inline</span> data_type datatype&lt;float&gt;() { <span class="keywordflow">return</span> MPI_FLOAT; }
<a name="l00887"></a>00887 
<a name="l00888"></a>00888   <span class="keyword">template</span>&lt;&gt;
<a name="l00889"></a>00889   <span class="keyword">inline</span> data_type datatype&lt;double&gt;() { <span class="keywordflow">return</span> MPI_DOUBLE; }
<a name="l00890"></a>00890 
<a name="l00891"></a>00891   <span class="keyword">template</span>&lt;&gt;
<a name="l00892"></a>00892   <span class="keyword">inline</span> data_type datatype&lt;long double&gt;() { <span class="keywordflow">return</span> MPI_LONG_DOUBLE; }
<a name="l00893"></a>00893 
<a name="l00894"></a>00894   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00895"></a>00895   <span class="keyword">inline</span> <span class="keywordtype">bool</span> verify(<span class="keyword">const</span> T &amp;r)
<a name="l00896"></a>00896   {
<a name="l00897"></a>00897     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00898"></a>00898       {
<a name="l00899"></a>00899         T tempmin = r, tempmax = r;
<a name="l00900"></a>00900         <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(tempmin);
<a name="l00901"></a>00901         <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(tempmax);
<a name="l00902"></a>00902         <span class="keywordtype">bool</span> verified = (r == tempmin) &amp;&amp;
<a name="l00903"></a>00903                         (r == tempmax);
<a name="l00904"></a>00904         <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(verified);
<a name="l00905"></a>00905         <span class="keywordflow">return</span> verified;
<a name="l00906"></a>00906       }
<a name="l00907"></a>00907     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00908"></a>00908   }
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 
<a name="l00911"></a>00911   <span class="keyword">template</span> &lt;&gt;
<a name="l00912"></a>00912   <span class="keyword">inline</span> <span class="keywordtype">bool</span> verify(<span class="keyword">const</span> std::string &amp; r)
<a name="l00913"></a>00913   {
<a name="l00914"></a>00914     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00915"></a>00915       {
<a name="l00916"></a>00916         <span class="comment">// Cannot use &lt;char&gt; since MPI_MIN is not</span>
<a name="l00917"></a>00917         <span class="comment">// strictly defined for chars!</span>
<a name="l00918"></a>00918         std::vector&lt;short int&gt; temp; temp.reserve(r.size());
<a name="l00919"></a>00919         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != r.size(); ++i)
<a name="l00920"></a>00920           temp.push_back(r[i]);
<a name="l00921"></a>00921         <span class="keywordflow">return</span> Parallel::verify(temp);
<a name="l00922"></a>00922       }
<a name="l00923"></a>00923     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00924"></a>00924   }
<a name="l00925"></a>00925 
<a name="l00926"></a>00926 
<a name="l00927"></a>00927   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00928"></a>00928   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(T &amp;r)
<a name="l00929"></a>00929   {
<a name="l00930"></a>00930     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00931"></a>00931       {
<a name="l00932"></a>00932         START_LOG(<span class="stringliteral">&quot;min()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l00933"></a>00933     
<a name="l00934"></a>00934         T temp = r;
<a name="l00935"></a>00935         MPI_Allreduce (&amp;temp,
<a name="l00936"></a>00936                        &amp;r,
<a name="l00937"></a>00937                        1,
<a name="l00938"></a>00938                        datatype&lt;T&gt;(),
<a name="l00939"></a>00939                        MPI_MIN,
<a name="l00940"></a>00940                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l00941"></a>00941 
<a name="l00942"></a>00942         STOP_LOG(<span class="stringliteral">&quot;min()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l00943"></a>00943       }
<a name="l00944"></a>00944   }
<a name="l00945"></a>00945 
<a name="l00946"></a>00946 
<a name="l00947"></a>00947   <span class="keyword">template</span> &lt;&gt;
<a name="l00948"></a>00948   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">bool</span> &amp;r)
<a name="l00949"></a>00949   {
<a name="l00950"></a>00950     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00951"></a>00951       {
<a name="l00952"></a>00952         START_LOG(<span class="stringliteral">&quot;min()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l00953"></a>00953     
<a name="l00954"></a>00954         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tempsend = r;
<a name="l00955"></a>00955         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp;
<a name="l00956"></a>00956         MPI_Allreduce (&amp;tempsend,
<a name="l00957"></a>00957                        &amp;temp,
<a name="l00958"></a>00958                        1,
<a name="l00959"></a>00959                        datatype&lt;unsigned int&gt;(),
<a name="l00960"></a>00960                        MPI_MIN,
<a name="l00961"></a>00961                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l00962"></a>00962         r = temp;
<a name="l00963"></a>00963 
<a name="l00964"></a>00964         STOP_LOG(<span class="stringliteral">&quot;min()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l00965"></a>00965       }
<a name="l00966"></a>00966   }
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 
<a name="l00969"></a>00969   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00970"></a>00970   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(std::vector&lt;T&gt; &amp;r)
<a name="l00971"></a>00971   {
<a name="l00972"></a>00972     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l00973"></a>00973       {
<a name="l00974"></a>00974         START_LOG(<span class="stringliteral">&quot;min()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l00975"></a>00975     
<a name="l00976"></a>00976         std::vector&lt;T&gt; temp(r);
<a name="l00977"></a>00977         MPI_Allreduce (&amp;temp[0],
<a name="l00978"></a>00978                        &amp;r[0],
<a name="l00979"></a>00979                        r.size(),
<a name="l00980"></a>00980                        datatype&lt;T&gt;(),
<a name="l00981"></a>00981                        MPI_MIN,
<a name="l00982"></a>00982                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l00983"></a>00983 
<a name="l00984"></a>00984         STOP_LOG(<span class="stringliteral">&quot;min()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l00985"></a>00985       }
<a name="l00986"></a>00986   }
<a name="l00987"></a>00987 
<a name="l00988"></a>00988 
<a name="l00989"></a>00989   <span class="keyword">template</span> &lt;&gt;
<a name="l00990"></a>00990   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(std::vector&lt;bool&gt; &amp;r)
<a name="l00991"></a>00991   {
<a name="l00992"></a>00992     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l00993"></a>00993       {
<a name="l00994"></a>00994         START_LOG(<span class="stringliteral">&quot;min()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l00995"></a>00995     
<a name="l00996"></a>00996         std::vector&lt;unsigned int&gt; ruint;
<a name="l00997"></a>00997         pack_vector_bool(r, ruint);
<a name="l00998"></a>00998         std::vector&lt;unsigned int&gt; temp(ruint.size());
<a name="l00999"></a>00999         MPI_Allreduce (&amp;ruint[0],
<a name="l01000"></a>01000                        &amp;temp[0],
<a name="l01001"></a>01001                        ruint.size(),
<a name="l01002"></a>01002                        datatype&lt;unsigned int&gt;(),
<a name="l01003"></a>01003                        MPI_BAND,
<a name="l01004"></a>01004                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01005"></a>01005         unpack_vector_bool(temp, r);
<a name="l01006"></a>01006 
<a name="l01007"></a>01007         STOP_LOG(<span class="stringliteral">&quot;min()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01008"></a>01008       }
<a name="l01009"></a>01009   }
<a name="l01010"></a>01010 
<a name="l01011"></a>01011 
<a name="l01012"></a>01012   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01013"></a>01013   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(T &amp;r)
<a name="l01014"></a>01014   {
<a name="l01015"></a>01015     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01016"></a>01016       {
<a name="l01017"></a>01017         START_LOG(<span class="stringliteral">&quot;max()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01018"></a>01018     
<a name="l01019"></a>01019         T temp;
<a name="l01020"></a>01020         MPI_Allreduce (&amp;r,
<a name="l01021"></a>01021                        &amp;temp,
<a name="l01022"></a>01022                        1,
<a name="l01023"></a>01023                        datatype&lt;T&gt;(),
<a name="l01024"></a>01024                        MPI_MAX,
<a name="l01025"></a>01025                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01026"></a>01026         r = temp;
<a name="l01027"></a>01027 
<a name="l01028"></a>01028         STOP_LOG(<span class="stringliteral">&quot;max()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01029"></a>01029       }
<a name="l01030"></a>01030   }
<a name="l01031"></a>01031 
<a name="l01032"></a>01032 
<a name="l01033"></a>01033   <span class="keyword">template</span> &lt;&gt;
<a name="l01034"></a>01034   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">bool</span> &amp;r)
<a name="l01035"></a>01035   {
<a name="l01036"></a>01036     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01037"></a>01037       {
<a name="l01038"></a>01038         START_LOG(<span class="stringliteral">&quot;max()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01039"></a>01039     
<a name="l01040"></a>01040         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tempsend = r;
<a name="l01041"></a>01041         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp;
<a name="l01042"></a>01042         MPI_Allreduce (&amp;tempsend,
<a name="l01043"></a>01043                        &amp;temp,
<a name="l01044"></a>01044                        1,
<a name="l01045"></a>01045                        datatype&lt;unsigned int&gt;(),
<a name="l01046"></a>01046                        MPI_MAX,
<a name="l01047"></a>01047                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01048"></a>01048         r = temp;
<a name="l01049"></a>01049 
<a name="l01050"></a>01050         STOP_LOG(<span class="stringliteral">&quot;max()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01051"></a>01051       }
<a name="l01052"></a>01052   }
<a name="l01053"></a>01053 
<a name="l01054"></a>01054 
<a name="l01055"></a>01055   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01056"></a>01056   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(std::vector&lt;T&gt; &amp;r)
<a name="l01057"></a>01057   {
<a name="l01058"></a>01058     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01059"></a>01059       {
<a name="l01060"></a>01060         START_LOG(<span class="stringliteral">&quot;max()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01061"></a>01061     
<a name="l01062"></a>01062         std::vector&lt;T&gt; temp(r);
<a name="l01063"></a>01063         MPI_Allreduce (&amp;temp[0],
<a name="l01064"></a>01064                        &amp;r[0],
<a name="l01065"></a>01065                        r.size(),
<a name="l01066"></a>01066                        datatype&lt;T&gt;(),
<a name="l01067"></a>01067                        MPI_MAX,
<a name="l01068"></a>01068                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01069"></a>01069 
<a name="l01070"></a>01070         STOP_LOG(<span class="stringliteral">&quot;max()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01071"></a>01071       }
<a name="l01072"></a>01072   }
<a name="l01073"></a>01073 
<a name="l01074"></a>01074 
<a name="l01075"></a>01075   <span class="keyword">template</span> &lt;&gt;
<a name="l01076"></a>01076   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(std::vector&lt;bool&gt; &amp;r)
<a name="l01077"></a>01077   {
<a name="l01078"></a>01078     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01079"></a>01079       {
<a name="l01080"></a>01080         START_LOG(<span class="stringliteral">&quot;max()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01081"></a>01081     
<a name="l01082"></a>01082         std::vector&lt;unsigned int&gt; ruint;
<a name="l01083"></a>01083         pack_vector_bool(r, ruint);
<a name="l01084"></a>01084         std::vector&lt;unsigned int&gt; temp(ruint.size());
<a name="l01085"></a>01085         MPI_Allreduce (&amp;ruint[0],
<a name="l01086"></a>01086                        &amp;temp[0],
<a name="l01087"></a>01087                        ruint.size(),
<a name="l01088"></a>01088                        datatype&lt;unsigned int&gt;(),
<a name="l01089"></a>01089                        MPI_BOR,
<a name="l01090"></a>01090                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01091"></a>01091         unpack_vector_bool(temp, r);
<a name="l01092"></a>01092 
<a name="l01093"></a>01093         STOP_LOG(<span class="stringliteral">&quot;max()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01094"></a>01094       }
<a name="l01095"></a>01095   }
<a name="l01096"></a>01096 
<a name="l01097"></a>01097 
<a name="l01098"></a>01098   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01099"></a>01099   <span class="keyword">inline</span> <span class="keywordtype">void</span> sum(T &amp;r)
<a name="l01100"></a>01100   {
<a name="l01101"></a>01101     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01102"></a>01102       {
<a name="l01103"></a>01103         START_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01104"></a>01104     
<a name="l01105"></a>01105         T temp = r;
<a name="l01106"></a>01106         MPI_Allreduce (&amp;temp,
<a name="l01107"></a>01107                        &amp;r,
<a name="l01108"></a>01108                        1,
<a name="l01109"></a>01109                        datatype&lt;T&gt;(),
<a name="l01110"></a>01110                        MPI_SUM,
<a name="l01111"></a>01111                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01112"></a>01112 
<a name="l01113"></a>01113         STOP_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01114"></a>01114       }
<a name="l01115"></a>01115   }
<a name="l01116"></a>01116 
<a name="l01117"></a>01117 
<a name="l01118"></a>01118   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01119"></a>01119   <span class="keyword">inline</span> <span class="keywordtype">void</span> sum(std::vector&lt;T&gt; &amp;r)
<a name="l01120"></a>01120   {
<a name="l01121"></a>01121     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01122"></a>01122       {
<a name="l01123"></a>01123         START_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01124"></a>01124     
<a name="l01125"></a>01125         std::vector&lt;T&gt; temp(r);
<a name="l01126"></a>01126         MPI_Allreduce (&amp;temp[0],
<a name="l01127"></a>01127                        &amp;r[0],
<a name="l01128"></a>01128                        r.size(),
<a name="l01129"></a>01129                        datatype&lt;T&gt;(),
<a name="l01130"></a>01130                        MPI_SUM,
<a name="l01131"></a>01131                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01132"></a>01132 
<a name="l01133"></a>01133         STOP_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01134"></a>01134       }
<a name="l01135"></a>01135   }
<a name="l01136"></a>01136 
<a name="l01137"></a>01137 
<a name="l01138"></a>01138 
<a name="l01139"></a>01139   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01140"></a>01140   <span class="keyword">inline</span> <span class="keywordtype">void</span> sum(std::complex&lt;T&gt; &amp;r)
<a name="l01141"></a>01141   {
<a name="l01142"></a>01142     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01143"></a>01143       {
<a name="l01144"></a>01144         START_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01145"></a>01145     
<a name="l01146"></a>01146         std::complex&lt;T&gt; temp(r);
<a name="l01147"></a>01147         MPI_Allreduce (&amp;temp,
<a name="l01148"></a>01148                        &amp;r,
<a name="l01149"></a>01149                        2,
<a name="l01150"></a>01150                        datatype&lt;T&gt;(),
<a name="l01151"></a>01151                        MPI_SUM,
<a name="l01152"></a>01152                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01153"></a>01153 
<a name="l01154"></a>01154         STOP_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01155"></a>01155       }
<a name="l01156"></a>01156   }
<a name="l01157"></a>01157 
<a name="l01158"></a>01158 
<a name="l01159"></a>01159   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01160"></a>01160   <span class="keyword">inline</span> <span class="keywordtype">void</span> sum(std::vector&lt;std::complex&lt;T&gt; &gt; &amp;r)
<a name="l01161"></a>01161   {
<a name="l01162"></a>01162     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1 &amp;&amp; !r.empty())
<a name="l01163"></a>01163       {
<a name="l01164"></a>01164         START_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01165"></a>01165     
<a name="l01166"></a>01166         std::vector&lt;std::complex&lt;T&gt; &gt; temp(r);
<a name="l01167"></a>01167         MPI_Allreduce (&amp;temp[0],
<a name="l01168"></a>01168                        &amp;r[0],
<a name="l01169"></a>01169                        r.size() * 2,
<a name="l01170"></a>01170                        datatype&lt;T&gt;(),
<a name="l01171"></a>01171                        MPI_SUM,
<a name="l01172"></a>01172                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01173"></a>01173 
<a name="l01174"></a>01174         STOP_LOG(<span class="stringliteral">&quot;sum()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01175"></a>01175       }
<a name="l01176"></a>01176   }
<a name="l01177"></a>01177 
<a name="l01178"></a>01178 
<a name="l01179"></a>01179 
<a name="l01180"></a>01180   <span class="keyword">inline</span> status probe (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01181"></a>01181                        <span class="keyword">const</span> <span class="keywordtype">int</span> tag)
<a name="l01182"></a>01182   {
<a name="l01183"></a>01183     START_LOG(<span class="stringliteral">&quot;probe()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01184"></a>01184 
<a name="l01185"></a>01185     status status;
<a name="l01186"></a>01186 
<a name="l01187"></a>01187     MPI_Probe (src_processor_id, 
<a name="l01188"></a>01188                tag, 
<a name="l01189"></a>01189                <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>, 
<a name="l01190"></a>01190                &amp;status);
<a name="l01191"></a>01191 
<a name="l01192"></a>01192     STOP_LOG(<span class="stringliteral">&quot;probe()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01193"></a>01193 
<a name="l01194"></a>01194     <span class="keywordflow">return</span> status;
<a name="l01195"></a>01195   }  
<a name="l01196"></a>01196 
<a name="l01197"></a>01197 
<a name="l01198"></a>01198 
<a name="l01199"></a>01199   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01200"></a>01200   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01201"></a>01201                     std::vector&lt;T&gt; &amp;buf,
<a name="l01202"></a>01202                     <span class="keyword">const</span> DataType &amp;type,
<a name="l01203"></a>01203                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag)
<a name="l01204"></a>01204   {    
<a name="l01205"></a>01205     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01206"></a>01206 
<a name="l01207"></a>01207 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01208"></a>01208 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l01209"></a>01209     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l01210"></a>01210 <span class="preprocessor">#endif</span>
<a name="l01211"></a>01211 <span class="preprocessor"></span>      MPI_Send (buf.empty() ? NULL : &amp;buf[0],
<a name="l01212"></a>01212                 buf.size(),
<a name="l01213"></a>01213                 type,
<a name="l01214"></a>01214                 dest_processor_id,
<a name="l01215"></a>01215                 tag,
<a name="l01216"></a>01216                 <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01217"></a>01217 
<a name="l01218"></a>01218     libmesh_assert (ierr == MPI_SUCCESS);    
<a name="l01219"></a>01219     
<a name="l01220"></a>01220     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01221"></a>01221   }
<a name="l01222"></a>01222 
<a name="l01223"></a>01223 
<a name="l01224"></a>01224 
<a name="l01225"></a>01225   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l01226"></a>01226   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l01227"></a>01227   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01228"></a>01228   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01229"></a>01229                     std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01230"></a>01230                     <span class="keyword">const</span> DataType &amp;type,
<a name="l01231"></a>01231                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0)
<a name="l01232"></a>01232   {    
<a name="l01233"></a>01233     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01234"></a>01234 
<a name="l01235"></a>01235 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01236"></a>01236 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l01237"></a>01237     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l01238"></a>01238 <span class="preprocessor">#endif</span>
<a name="l01239"></a>01239 <span class="preprocessor"></span>      MPI_Send (buf.empty() ? NULL : &amp;buf[0],
<a name="l01240"></a>01240                 buf.size() * 2,
<a name="l01241"></a>01241                 type,
<a name="l01242"></a>01242                 dest_processor_id,
<a name="l01243"></a>01243                 tag,
<a name="l01244"></a>01244                 <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01245"></a>01245 
<a name="l01246"></a>01246     libmesh_assert (ierr == MPI_SUCCESS);    
<a name="l01247"></a>01247     
<a name="l01248"></a>01248     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01249"></a>01249   }
<a name="l01250"></a>01250 
<a name="l01251"></a>01251 
<a name="l01252"></a>01252 
<a name="l01253"></a>01253   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01254"></a>01254   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01255"></a>01255                     std::vector&lt;T&gt; &amp;buf,
<a name="l01256"></a>01256                     <span class="keyword">const</span> DataType &amp;type,
<a name="l01257"></a>01257                     request &amp;req,
<a name="l01258"></a>01258                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag)
<a name="l01259"></a>01259   {    
<a name="l01260"></a>01260     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01261"></a>01261 
<a name="l01262"></a>01262 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01263"></a>01263 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l01264"></a>01264     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l01265"></a>01265 <span class="preprocessor">#endif</span>
<a name="l01266"></a>01266 <span class="preprocessor"></span>      MPI_Isend (buf.empty() ? NULL : &amp;buf[0],
<a name="l01267"></a>01267                  buf.size(),
<a name="l01268"></a>01268                  type,
<a name="l01269"></a>01269                  dest_processor_id,
<a name="l01270"></a>01270                  tag,
<a name="l01271"></a>01271                  <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01272"></a>01272                  &amp;req);    
<a name="l01273"></a>01273     libmesh_assert (ierr == MPI_SUCCESS);    
<a name="l01274"></a>01274 
<a name="l01275"></a>01275     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01276"></a>01276   }
<a name="l01277"></a>01277 
<a name="l01278"></a>01278 
<a name="l01279"></a>01279   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l01280"></a>01280   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l01281"></a>01281   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01282"></a>01282   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01283"></a>01283                     std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01284"></a>01284                     <span class="keyword">const</span> DataType &amp;type,
<a name="l01285"></a>01285                     request &amp;req,
<a name="l01286"></a>01286                     <span class="keyword">const</span> <span class="keywordtype">int</span> tag=0)
<a name="l01287"></a>01287   {
<a name="l01288"></a>01288     START_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01289"></a>01289 
<a name="l01290"></a>01290 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01291"></a>01291 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l01292"></a>01292     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =      
<a name="l01293"></a>01293 <span class="preprocessor">#endif</span>
<a name="l01294"></a>01294 <span class="preprocessor"></span>      MPI_ISend (buf.empty() ? NULL : &amp;buf[0],
<a name="l01295"></a>01295                  buf.size() * 2,
<a name="l01296"></a>01296                  type,
<a name="l01297"></a>01297                  dest_processor_id,
<a name="l01298"></a>01298                  tag,
<a name="l01299"></a>01299                  <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01300"></a>01300                  &amp;req);    
<a name="l01301"></a>01301     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l01302"></a>01302 
<a name="l01303"></a>01303     STOP_LOG(<span class="stringliteral">&quot;send()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01304"></a>01304   }
<a name="l01305"></a>01305 
<a name="l01306"></a>01306 
<a name="l01307"></a>01307 
<a name="l01308"></a>01308   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01309"></a>01309   <span class="keyword">inline</span> Status receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01310"></a>01310                          std::vector&lt;T&gt; &amp;buf,
<a name="l01311"></a>01311                          <span class="keyword">const</span> DataType &amp;type,
<a name="l01312"></a>01312                          <span class="keyword">const</span> <span class="keywordtype">int</span> tag)
<a name="l01313"></a>01313   {
<a name="l01314"></a>01314     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01315"></a>01315 
<a name="l01316"></a>01316     <span class="comment">// Get the status of the message, explicitly provide the</span>
<a name="l01317"></a>01317     <span class="comment">// datatype so we can later query the size</span>
<a name="l01318"></a>01318     Status status(Parallel::probe(src_processor_id, tag), type);
<a name="l01319"></a>01319 
<a name="l01320"></a>01320     buf.resize(status.size());
<a name="l01321"></a>01321     
<a name="l01322"></a>01322 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01323"></a>01323 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l01324"></a>01324     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l01325"></a>01325 <span class="preprocessor">#endif</span>
<a name="l01326"></a>01326 <span class="preprocessor"></span>      MPI_Recv (buf.empty() ? NULL : &amp;buf[0],
<a name="l01327"></a>01327                 buf.size(),
<a name="l01328"></a>01328                 type,
<a name="l01329"></a>01329                 src_processor_id,
<a name="l01330"></a>01330                 tag,
<a name="l01331"></a>01331                 <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01332"></a>01332                 status);
<a name="l01333"></a>01333     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l01334"></a>01334 
<a name="l01335"></a>01335     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01336"></a>01336 
<a name="l01337"></a>01337     <span class="keywordflow">return</span> status;
<a name="l01338"></a>01338   }
<a name="l01339"></a>01339 
<a name="l01340"></a>01340 
<a name="l01341"></a>01341 
<a name="l01342"></a>01342   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l01343"></a>01343   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l01344"></a>01344   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01345"></a>01345   <span class="keyword">inline</span> Status receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01346"></a>01346                          std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01347"></a>01347                          <span class="keyword">const</span> DataType &amp;type,
<a name="l01348"></a>01348                          <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag)
<a name="l01349"></a>01349   {
<a name="l01350"></a>01350     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01351"></a>01351 
<a name="l01352"></a>01352     <span class="comment">// Get the status of the message, explicitly provide the</span>
<a name="l01353"></a>01353     <span class="comment">// datatype so we can later query the size</span>
<a name="l01354"></a>01354     Status status(Parallel::probe(src_processor_id, tag), datatype&lt;T&gt;());
<a name="l01355"></a>01355 
<a name="l01356"></a>01356     libmesh_assert(!(status.size()%2));
<a name="l01357"></a>01357     buf.resize(status.size()/2);
<a name="l01358"></a>01358     
<a name="l01359"></a>01359 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01360"></a>01360 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l01361"></a>01361     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =      
<a name="l01362"></a>01362 <span class="preprocessor">#endif</span>
<a name="l01363"></a>01363 <span class="preprocessor"></span>      MPI_Recv (buf.empty() ? NULL : &amp;buf[0],
<a name="l01364"></a>01364                 buf.size() * 2,
<a name="l01365"></a>01365                 type,
<a name="l01366"></a>01366                 src_processor_id,
<a name="l01367"></a>01367                 tag,
<a name="l01368"></a>01368                 <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01369"></a>01369                 status);
<a name="l01370"></a>01370     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l01371"></a>01371     
<a name="l01372"></a>01372     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01373"></a>01373 
<a name="l01374"></a>01374     <span class="keywordflow">return</span> status;
<a name="l01375"></a>01375   }
<a name="l01376"></a>01376 
<a name="l01377"></a>01377 
<a name="l01378"></a>01378 
<a name="l01379"></a>01379   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01380"></a>01380   <span class="keyword">inline</span> <span class="keywordtype">void</span> receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01381"></a>01381                        std::vector&lt;T&gt; &amp;buf,
<a name="l01382"></a>01382                        <span class="keyword">const</span> DataType &amp;type,
<a name="l01383"></a>01383                        request &amp;req,
<a name="l01384"></a>01384                        <span class="keyword">const</span> <span class="keywordtype">int</span> tag)
<a name="l01385"></a>01385   {
<a name="l01386"></a>01386     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01387"></a>01387 
<a name="l01388"></a>01388 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01389"></a>01389 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l01390"></a>01390     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l01391"></a>01391 <span class="preprocessor">#endif</span>
<a name="l01392"></a>01392 <span class="preprocessor"></span>      MPI_Irecv (buf.empty() ? NULL : &amp;buf[0],
<a name="l01393"></a>01393                  buf.size(),
<a name="l01394"></a>01394                  type,
<a name="l01395"></a>01395                  src_processor_id,
<a name="l01396"></a>01396                  tag,
<a name="l01397"></a>01397                  <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01398"></a>01398                  &amp;req);    
<a name="l01399"></a>01399     libmesh_assert (ierr == MPI_SUCCESS);    
<a name="l01400"></a>01400 
<a name="l01401"></a>01401     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01402"></a>01402   }
<a name="l01403"></a>01403 
<a name="l01404"></a>01404 
<a name="l01405"></a>01405 
<a name="l01406"></a>01406   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l01407"></a>01407   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l01408"></a>01408   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01409"></a>01409   <span class="keyword">inline</span> <span class="keywordtype">void</span> receive (<span class="keyword">const</span> <span class="keywordtype">int</span> src_processor_id,
<a name="l01410"></a>01410                        std::vector&lt;std::complex&lt;T&gt; &gt; &amp;buf,
<a name="l01411"></a>01411                        <span class="keyword">const</span> DataType &amp;type,
<a name="l01412"></a>01412                        request &amp;req,
<a name="l01413"></a>01413                        <span class="keyword">const</span> <span class="keywordtype">int</span> tag=any_tag)
<a name="l01414"></a>01414   {
<a name="l01415"></a>01415     START_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01416"></a>01416 
<a name="l01417"></a>01417     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =      
<a name="l01418"></a>01418       MPI_Irecv (buf.empty() ? NULL : &amp;buf[0],
<a name="l01419"></a>01419                 buf.size() * 2,
<a name="l01420"></a>01420                 type,
<a name="l01421"></a>01421                 src_processor_id,
<a name="l01422"></a>01422                 tag,
<a name="l01423"></a>01423                 <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01424"></a>01424                 &amp;req);
<a name="l01425"></a>01425 
<a name="l01426"></a>01426     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l01427"></a>01427     
<a name="l01428"></a>01428     STOP_LOG(<span class="stringliteral">&quot;receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01429"></a>01429 
<a name="l01430"></a>01430     <span class="keywordflow">return</span>;
<a name="l01431"></a>01431   }
<a name="l01432"></a>01432 
<a name="l01433"></a>01433   
<a name="l01434"></a>01434 
<a name="l01435"></a>01435   <span class="keyword">inline</span> status wait (request &amp;r)
<a name="l01436"></a>01436   {
<a name="l01437"></a>01437     START_LOG(<span class="stringliteral">&quot;wait()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01438"></a>01438 
<a name="l01439"></a>01439     status status;
<a name="l01440"></a>01440 
<a name="l01441"></a>01441     MPI_Wait (&amp;r, &amp;status);
<a name="l01442"></a>01442 
<a name="l01443"></a>01443     STOP_LOG(<span class="stringliteral">&quot;wait()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01444"></a>01444 
<a name="l01445"></a>01445     <span class="keywordflow">return</span> status;
<a name="l01446"></a>01446   }
<a name="l01447"></a>01447 
<a name="l01448"></a>01448   
<a name="l01449"></a>01449 
<a name="l01450"></a>01450   <span class="keyword">inline</span> <span class="keywordtype">void</span> wait (std::vector&lt;request&gt; &amp;r)
<a name="l01451"></a>01451   {
<a name="l01452"></a>01452     START_LOG(<span class="stringliteral">&quot;wait()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01453"></a>01453     
<a name="l01454"></a>01454     MPI_Waitall (r.size(), r.empty() ? NULL : &amp;r[0], MPI_STATUSES_IGNORE);
<a name="l01455"></a>01455 
<a name="l01456"></a>01456     STOP_LOG(<span class="stringliteral">&quot;wait()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01457"></a>01457   }
<a name="l01458"></a>01458 
<a name="l01459"></a>01459 
<a name="l01460"></a>01460 
<a name="l01461"></a>01461   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01462"></a>01462   <span class="keyword">inline</span> <span class="keywordtype">void</span> send_receive(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01463"></a>01463                            std::vector&lt;T&gt; &amp;send,
<a name="l01464"></a>01464                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l01465"></a>01465                            std::vector&lt;T&gt; &amp;recv,
<a name="l01466"></a>01466                            <span class="keyword">const</span> DataType &amp;type)
<a name="l01467"></a>01467   {
<a name="l01468"></a>01468     START_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01469"></a>01469 
<a name="l01470"></a>01470     <span class="keywordflow">if</span> (dest_processor_id   == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l01471"></a>01471         source_processor_id == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01472"></a>01472       {
<a name="l01473"></a>01473         recv = send;
<a name="l01474"></a>01474         STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01475"></a>01475         <span class="keywordflow">return</span>;
<a name="l01476"></a>01476       }
<a name="l01477"></a>01477 
<a name="l01478"></a>01478     Parallel::request request;
<a name="l01479"></a>01479     
<a name="l01480"></a>01480     Parallel::nonblocking_send (dest_processor_id,
<a name="l01481"></a>01481                                 send,
<a name="l01482"></a>01482                                 type,
<a name="l01483"></a>01483                                 request,
<a name="l01484"></a>01484                                 <span class="comment">/* tag = */</span> 321);
<a name="l01485"></a>01485     
<a name="l01486"></a>01486     Parallel::receive (source_processor_id,
<a name="l01487"></a>01487                        recv,
<a name="l01488"></a>01488                        type,
<a name="l01489"></a>01489                        <span class="comment">/* tag = */</span> 321);
<a name="l01490"></a>01490     
<a name="l01491"></a>01491     Parallel::wait (request);
<a name="l01492"></a>01492     
<a name="l01493"></a>01493     STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01494"></a>01494   }
<a name="l01495"></a>01495   
<a name="l01496"></a>01496 
<a name="l01497"></a>01497   
<a name="l01498"></a>01498   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01499"></a>01499   <span class="keyword">inline</span> <span class="keywordtype">void</span> send_receive(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01500"></a>01500                            T &amp;send,
<a name="l01501"></a>01501                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l01502"></a>01502                            T &amp;recv)
<a name="l01503"></a>01503   {
<a name="l01504"></a>01504     START_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01505"></a>01505 
<a name="l01506"></a>01506     <span class="keywordflow">if</span> (dest_processor_id   == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l01507"></a>01507         source_processor_id == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01508"></a>01508       {
<a name="l01509"></a>01509         recv = send;
<a name="l01510"></a>01510         STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01511"></a>01511         <span class="keywordflow">return</span>;
<a name="l01512"></a>01512       }
<a name="l01513"></a>01513 
<a name="l01514"></a>01514     MPI_Sendrecv(&amp;send, 1, datatype&lt;T&gt;(),
<a name="l01515"></a>01515                  dest_processor_id, 0,
<a name="l01516"></a>01516                  &amp;recv, 1, datatype&lt;T&gt;(),
<a name="l01517"></a>01517                  source_processor_id, 0,
<a name="l01518"></a>01518                  <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01519"></a>01519                  MPI_STATUS_IGNORE);
<a name="l01520"></a>01520 
<a name="l01521"></a>01521     STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01522"></a>01522   }
<a name="l01523"></a>01523 
<a name="l01524"></a>01524 
<a name="l01525"></a>01525 
<a name="l01526"></a>01526   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01527"></a>01527   <span class="keyword">inline</span> <span class="keywordtype">void</span> send_receive(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01528"></a>01528                            std::complex&lt;T&gt; &amp;send,
<a name="l01529"></a>01529                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l01530"></a>01530                            std::complex&lt;T&gt; &amp;recv)
<a name="l01531"></a>01531   {
<a name="l01532"></a>01532     START_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01533"></a>01533 
<a name="l01534"></a>01534     <span class="keywordflow">if</span> (dest_processor_id   == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l01535"></a>01535         source_processor_id == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01536"></a>01536       {
<a name="l01537"></a>01537         recv = send;
<a name="l01538"></a>01538         STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01539"></a>01539         <span class="keywordflow">return</span>;
<a name="l01540"></a>01540       }
<a name="l01541"></a>01541 
<a name="l01542"></a>01542     MPI_Sendrecv(&amp;send, 2, datatype&lt;T&gt;(),
<a name="l01543"></a>01543                  dest_processor_id, 0,
<a name="l01544"></a>01544                  &amp;recv, 2, datatype&lt;T&gt;(),
<a name="l01545"></a>01545                  source_processor_id, 0,
<a name="l01546"></a>01546                  <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01547"></a>01547                  MPI_STATUS_IGNORE);
<a name="l01548"></a>01548 
<a name="l01549"></a>01549     STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01550"></a>01550   }
<a name="l01551"></a>01551 
<a name="l01552"></a>01552 
<a name="l01553"></a>01553 
<a name="l01554"></a>01554   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01555"></a>01555   <span class="keyword">inline</span> <span class="keywordtype">void</span> send_receive(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01556"></a>01556                            std::vector&lt;T&gt; &amp;send,
<a name="l01557"></a>01557                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l01558"></a>01558                            std::vector&lt;T&gt; &amp;recv)
<a name="l01559"></a>01559   {
<a name="l01560"></a>01560     <span class="comment">// Call the user-defined type version with automatic </span>
<a name="l01561"></a>01561     <span class="comment">// type conversion based on template argument:    </span>
<a name="l01562"></a>01562     send_receive (dest_processor_id,
<a name="l01563"></a>01563                   send,
<a name="l01564"></a>01564                   source_processor_id,
<a name="l01565"></a>01565                   recv,
<a name="l01566"></a>01566                   datatype&lt;T&gt;());
<a name="l01567"></a>01567   }
<a name="l01568"></a>01568 
<a name="l01569"></a>01569 
<a name="l01570"></a>01570 
<a name="l01571"></a>01571   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01572"></a>01572   <span class="keyword">inline</span> <span class="keywordtype">void</span> send_receive(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dest_processor_id,
<a name="l01573"></a>01573                            std::vector&lt;std::vector&lt;T&gt; &gt; &amp;send,
<a name="l01574"></a>01574                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> source_processor_id,
<a name="l01575"></a>01575                            std::vector&lt;std::vector&lt;T&gt; &gt; &amp;recv)
<a name="l01576"></a>01576   {
<a name="l01577"></a>01577     START_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01578"></a>01578 
<a name="l01579"></a>01579     <span class="keywordflow">if</span> (dest_processor_id   == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l01580"></a>01580         source_processor_id == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01581"></a>01581       {
<a name="l01582"></a>01582         recv = send;
<a name="l01583"></a>01583         STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01584"></a>01584         <span class="keywordflow">return</span>;
<a name="l01585"></a>01585       }
<a name="l01586"></a>01586     
<a name="l01587"></a>01587     <span class="comment">// temporary buffers - these will be sized in bytes</span>
<a name="l01588"></a>01588     <span class="comment">// and manipulated with MPI_Pack and friends</span>
<a name="l01589"></a>01589     std::vector&lt;char&gt; sendbuf, recvbuf;
<a name="l01590"></a>01590 
<a name="l01591"></a>01591     <span class="comment">// figure out how many bytes we need to pack all the data</span>
<a name="l01592"></a>01592     <span class="keywordtype">int</span> packedsize=0, sendsize=0;
<a name="l01593"></a>01593 
<a name="l01594"></a>01594     <span class="comment">// The outer buffer size</span>
<a name="l01595"></a>01595     MPI_Pack_size (1,           
<a name="l01596"></a>01596                    datatype&lt;unsigned int&gt;(),
<a name="l01597"></a>01597                    <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01598"></a>01598                    &amp;packedsize);
<a name="l01599"></a>01599     sendsize += packedsize;
<a name="l01600"></a>01600 
<a name="l01601"></a>01601     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;send.size(); i++)
<a name="l01602"></a>01602       {
<a name="l01603"></a>01603         <span class="comment">// The size of the ith inner buffer</span>
<a name="l01604"></a>01604         MPI_Pack_size (1,           
<a name="l01605"></a>01605                        datatype&lt;unsigned int&gt;(),
<a name="l01606"></a>01606                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01607"></a>01607                        &amp;packedsize);
<a name="l01608"></a>01608         sendsize += packedsize;
<a name="l01609"></a>01609 
<a name="l01610"></a>01610         <span class="comment">// The data for each inner buffer</span>
<a name="l01611"></a>01611         MPI_Pack_size (send[i].size(),
<a name="l01612"></a>01612                        datatype&lt;T&gt;(),
<a name="l01613"></a>01613                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>,
<a name="l01614"></a>01614                        &amp;packedsize);
<a name="l01615"></a>01615         sendsize += packedsize;
<a name="l01616"></a>01616       }
<a name="l01617"></a>01617     
<a name="l01618"></a>01618     libmesh_assert (sendsize <span class="comment">/* should at least be 1! */</span>);
<a name="l01619"></a>01619     sendbuf.resize (sendsize);
<a name="l01620"></a>01620 
<a name="l01621"></a>01621     <span class="comment">// Pack the send buffer</span>
<a name="l01622"></a>01622     <span class="keywordtype">int</span> pos=0;
<a name="l01623"></a>01623 
<a name="l01624"></a>01624     <span class="comment">// ... the size of the outer buffer</span>
<a name="l01625"></a>01625     sendsize = send.size();
<a name="l01626"></a>01626     MPI_Pack (&amp;sendsize, 1, datatype&lt;unsigned int&gt;(),
<a name="l01627"></a>01627               &amp;sendbuf[0], sendbuf.size(), &amp;pos,
<a name="l01628"></a>01628               <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01629"></a>01629     
<a name="l01630"></a>01630     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;send.size(); i++)
<a name="l01631"></a>01631       {
<a name="l01632"></a>01632         <span class="comment">// ... the size of the ith inner buffer</span>
<a name="l01633"></a>01633         sendsize = send[i].size();
<a name="l01634"></a>01634         MPI_Pack (&amp;sendsize, 1, datatype&lt;unsigned int&gt;(),
<a name="l01635"></a>01635                   &amp;sendbuf[0], sendbuf.size(), &amp;pos,
<a name="l01636"></a>01636                   <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01637"></a>01637         
<a name="l01638"></a>01638         <span class="comment">// ... the contents of the ith inner buffer</span>
<a name="l01639"></a>01639         <span class="keywordflow">if</span> (!send[i].empty())
<a name="l01640"></a>01640           MPI_Pack (&amp;send[i][0], send[i].size(), datatype&lt;T&gt;(),
<a name="l01641"></a>01641                     &amp;sendbuf[0], sendbuf.size(), &amp;pos,
<a name="l01642"></a>01642                     <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01643"></a>01643       }
<a name="l01644"></a>01644 
<a name="l01645"></a>01645     libmesh_assert (static_cast&lt;unsigned int&gt;(pos) == sendbuf.size());
<a name="l01646"></a>01646 
<a name="l01647"></a>01647     Parallel::request request;
<a name="l01648"></a>01648 
<a name="l01649"></a>01649     Parallel::nonblocking_send (dest_processor_id,
<a name="l01650"></a>01650                                 sendbuf,
<a name="l01651"></a>01651                                 MPI_PACKED,
<a name="l01652"></a>01652                                 request,
<a name="l01653"></a>01653                                 <span class="comment">/* tag = */</span> 123);
<a name="l01654"></a>01654 
<a name="l01655"></a>01655     Parallel::receive (source_processor_id,
<a name="l01656"></a>01656                        recvbuf,
<a name="l01657"></a>01657                        MPI_PACKED,
<a name="l01658"></a>01658                        <span class="comment">/* tag = */</span> 123);
<a name="l01659"></a>01659 
<a name="l01660"></a>01660     <span class="comment">// Unpack the received buffer</span>
<a name="l01661"></a>01661     libmesh_assert (!recvbuf.empty());
<a name="l01662"></a>01662     pos=0;
<a name="l01663"></a>01663     MPI_Unpack (&amp;recvbuf[0], recvbuf.size(), &amp;pos,
<a name="l01664"></a>01664                 &amp;sendsize, 1, datatype&lt;unsigned int&gt;(),
<a name="l01665"></a>01665                 <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01666"></a>01666     
<a name="l01667"></a>01667     <span class="comment">// ... size the outer buffer</span>
<a name="l01668"></a>01668     recv.resize (sendsize);
<a name="l01669"></a>01669 
<a name="l01670"></a>01670     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;recv.size(); i++)
<a name="l01671"></a>01671       {
<a name="l01672"></a>01672         MPI_Unpack (&amp;recvbuf[0], recvbuf.size(), &amp;pos,
<a name="l01673"></a>01673                     &amp;sendsize, 1, datatype&lt;unsigned int&gt;(),
<a name="l01674"></a>01674                     <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01675"></a>01675     
<a name="l01676"></a>01676         <span class="comment">// ... size the inner buffer</span>
<a name="l01677"></a>01677         recv[i].resize (sendsize);
<a name="l01678"></a>01678 
<a name="l01679"></a>01679         <span class="comment">// ... unpack the inner buffer if it is not empty</span>
<a name="l01680"></a>01680         <span class="keywordflow">if</span> (!recv[i].empty())
<a name="l01681"></a>01681           MPI_Unpack (&amp;recvbuf[0], recvbuf.size(), &amp;pos,
<a name="l01682"></a>01682                       &amp;recv[i][0], recv[i].size(), datatype&lt;T&gt;(),
<a name="l01683"></a>01683                       <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01684"></a>01684       }
<a name="l01685"></a>01685 
<a name="l01686"></a>01686     Parallel::wait (request);
<a name="l01687"></a>01687 
<a name="l01688"></a>01688     STOP_LOG(<span class="stringliteral">&quot;send_receive()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01689"></a>01689   }
<a name="l01690"></a>01690 
<a name="l01691"></a>01691 
<a name="l01692"></a>01692   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01693"></a>01693   <span class="keyword">inline</span> <span class="keywordtype">void</span> gather(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l01694"></a>01694                      T send,
<a name="l01695"></a>01695                      std::vector&lt;T&gt; &amp;recv)
<a name="l01696"></a>01696   {
<a name="l01697"></a>01697     libmesh_assert(root_id &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01698"></a>01698 
<a name="l01699"></a>01699     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == root_id)
<a name="l01700"></a>01700       recv.resize(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01701"></a>01701     
<a name="l01702"></a>01702     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01703"></a>01703       {
<a name="l01704"></a>01704         START_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01705"></a>01705 
<a name="l01706"></a>01706         MPI_Gather(&amp;send,
<a name="l01707"></a>01707                    1,
<a name="l01708"></a>01708                    datatype&lt;T&gt;(),
<a name="l01709"></a>01709                    recv.empty() ? NULL : &amp;recv[0],
<a name="l01710"></a>01710                    1,
<a name="l01711"></a>01711                    datatype&lt;T&gt;(),
<a name="l01712"></a>01712                    root_id,
<a name="l01713"></a>01713                    <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01714"></a>01714 
<a name="l01715"></a>01715         STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01716"></a>01716       }
<a name="l01717"></a>01717     <span class="keywordflow">else</span>
<a name="l01718"></a>01718       recv[0] = send;
<a name="l01719"></a>01719   }
<a name="l01720"></a>01720 
<a name="l01721"></a>01721 
<a name="l01722"></a>01722 
<a name="l01723"></a>01723   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01724"></a>01724   <span class="keyword">inline</span> <span class="keywordtype">void</span> gather(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l01725"></a>01725                      std::complex&lt;T&gt; send,
<a name="l01726"></a>01726                      std::vector&lt;std::complex&lt;T&gt; &gt; &amp;recv)
<a name="l01727"></a>01727   {
<a name="l01728"></a>01728     libmesh_assert(root_id &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01729"></a>01729 
<a name="l01730"></a>01730     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == root_id)
<a name="l01731"></a>01731       recv.resize(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01732"></a>01732     
<a name="l01733"></a>01733     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01734"></a>01734       {
<a name="l01735"></a>01735         START_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01736"></a>01736 
<a name="l01737"></a>01737         MPI_Gather(&amp;send,
<a name="l01738"></a>01738                    2,
<a name="l01739"></a>01739                    datatype&lt;T&gt;(),
<a name="l01740"></a>01740                    recv.empty() ? NULL : &amp;recv[0],
<a name="l01741"></a>01741                    2,
<a name="l01742"></a>01742                    datatype&lt;T&gt;(),
<a name="l01743"></a>01743                    root_id,
<a name="l01744"></a>01744                    <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01745"></a>01745 
<a name="l01746"></a>01746         STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01747"></a>01747       }
<a name="l01748"></a>01748     <span class="keywordflow">else</span>
<a name="l01749"></a>01749       recv[0] = send;
<a name="l01750"></a>01750   }
<a name="l01751"></a>01751 
<a name="l01752"></a>01752 
<a name="l01753"></a>01753 
<a name="l01776"></a>01776   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01777"></a>01777   <span class="keyword">inline</span> <span class="keywordtype">void</span> gather(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l01778"></a>01778                      std::vector&lt;T&gt; &amp;r)
<a name="l01779"></a>01779   {
<a name="l01780"></a>01780     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01781"></a>01781       {
<a name="l01782"></a>01782         libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()==root_id);
<a name="l01783"></a>01783         <span class="keywordflow">return</span>;
<a name="l01784"></a>01784       }
<a name="l01785"></a>01785     
<a name="l01786"></a>01786     std::vector&lt;int&gt;
<a name="l01787"></a>01787       sendlengths  (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0),
<a name="l01788"></a>01788       displacements(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l01789"></a>01789 
<a name="l01790"></a>01790     <span class="keyword">const</span> <span class="keywordtype">int</span> mysize = r.size();
<a name="l01791"></a>01791     Parallel::allgather(mysize, sendlengths);
<a name="l01792"></a>01792     
<a name="l01793"></a>01793     START_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01794"></a>01794 
<a name="l01795"></a>01795     <span class="comment">// Find the total size of the final array and</span>
<a name="l01796"></a>01796     <span class="comment">// set up the displacement offsets for each processor.</span>
<a name="l01797"></a>01797     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> globalsize = 0; 
<a name="l01798"></a>01798     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++i)
<a name="l01799"></a>01799       {
<a name="l01800"></a>01800         displacements[i] = globalsize;
<a name="l01801"></a>01801         globalsize += sendlengths[i];
<a name="l01802"></a>01802       }
<a name="l01803"></a>01803 
<a name="l01804"></a>01804     <span class="comment">// Check for quick return</span>
<a name="l01805"></a>01805     <span class="keywordflow">if</span> (globalsize == 0)
<a name="l01806"></a>01806       {
<a name="l01807"></a>01807         STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01808"></a>01808         <span class="keywordflow">return</span>;
<a name="l01809"></a>01809       }
<a name="l01810"></a>01810 
<a name="l01811"></a>01811     <span class="comment">// copy the input buffer</span>
<a name="l01812"></a>01812     std::vector&lt;T&gt; r_src(r);
<a name="l01813"></a>01813 
<a name="l01814"></a>01814     <span class="comment">// now resize it to hold the global data</span>
<a name="l01815"></a>01815     <span class="comment">// on the receiving processor</span>
<a name="l01816"></a>01816     <span class="keywordflow">if</span> (root_id == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01817"></a>01817       r.resize(globalsize);
<a name="l01818"></a>01818 
<a name="l01819"></a>01819     <span class="comment">// and get the data from the remote processors</span>
<a name="l01820"></a>01820 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01821"></a>01821 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l01822"></a>01822     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l01823"></a>01823 <span class="preprocessor">#endif</span>
<a name="l01824"></a>01824 <span class="preprocessor"></span>      MPI_Gatherv (r_src.empty() ? NULL : &amp;r_src[0], mysize, datatype&lt;T&gt;(),
<a name="l01825"></a>01825                    r.empty() ? NULL :  &amp;r[0], &amp;sendlengths[0],
<a name="l01826"></a>01826                    &amp;displacements[0], datatype&lt;T&gt;(),
<a name="l01827"></a>01827                    root_id,
<a name="l01828"></a>01828                    <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01829"></a>01829 
<a name="l01830"></a>01830     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l01831"></a>01831 
<a name="l01832"></a>01832     STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01833"></a>01833   }
<a name="l01834"></a>01834 
<a name="l01835"></a>01835 
<a name="l01836"></a>01836   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01837"></a>01837   <span class="keyword">inline</span> <span class="keywordtype">void</span> gather(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l01838"></a>01838                      std::vector&lt;std::complex&lt;T&gt; &gt; &amp;r)
<a name="l01839"></a>01839   {
<a name="l01840"></a>01840     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01841"></a>01841       {
<a name="l01842"></a>01842         libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()==root_id);
<a name="l01843"></a>01843         <span class="keywordflow">return</span>;
<a name="l01844"></a>01844       }
<a name="l01845"></a>01845     
<a name="l01846"></a>01846     std::vector&lt;int&gt;
<a name="l01847"></a>01847       sendlengths  (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0),
<a name="l01848"></a>01848       displacements(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l01849"></a>01849 
<a name="l01850"></a>01850     <span class="keyword">const</span> <span class="keywordtype">int</span> mysize = r.size() * 2;
<a name="l01851"></a>01851     Parallel::allgather(mysize, sendlengths);
<a name="l01852"></a>01852     
<a name="l01853"></a>01853     START_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01854"></a>01854 
<a name="l01855"></a>01855     <span class="comment">// Find the total size of the final array and</span>
<a name="l01856"></a>01856     <span class="comment">// set up the displacement offsets for each processor.</span>
<a name="l01857"></a>01857     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> globalsize = 0; 
<a name="l01858"></a>01858     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++i)
<a name="l01859"></a>01859       {
<a name="l01860"></a>01860         displacements[i] = globalsize;
<a name="l01861"></a>01861         globalsize += sendlengths[i];
<a name="l01862"></a>01862       }
<a name="l01863"></a>01863 
<a name="l01864"></a>01864     <span class="comment">// Check for quick return</span>
<a name="l01865"></a>01865     <span class="keywordflow">if</span> (globalsize == 0)
<a name="l01866"></a>01866       {
<a name="l01867"></a>01867         STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01868"></a>01868         <span class="keywordflow">return</span>;
<a name="l01869"></a>01869       }
<a name="l01870"></a>01870 
<a name="l01871"></a>01871     <span class="comment">// Make temporary buffers for the input/output data</span>
<a name="l01872"></a>01872     std::vector&lt;std::complex&lt;T&gt; &gt; r_src(r);
<a name="l01873"></a>01873 
<a name="l01874"></a>01874     <span class="comment">// now resize r to hold the global data</span>
<a name="l01875"></a>01875     <span class="comment">// on the receiving processor</span>
<a name="l01876"></a>01876     <span class="keywordflow">if</span> (root_id == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l01877"></a>01877       r.resize(globalsize/2);
<a name="l01878"></a>01878 
<a name="l01879"></a>01879     <span class="comment">// and get the data from the remote processors</span>
<a name="l01880"></a>01880     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l01881"></a>01881       MPI_Gatherv (r_src.empty() ? NULL : &amp;r_src[0], mysize, datatype&lt;T&gt;(),
<a name="l01882"></a>01882                    r.empty() ? NULL : &amp;r[0], &amp;sendlengths[0],
<a name="l01883"></a>01883                    &amp;displacements[0], datatype&lt;T&gt;(),
<a name="l01884"></a>01884                    root_id, <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01885"></a>01885     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l01886"></a>01886 
<a name="l01887"></a>01887     STOP_LOG(<span class="stringliteral">&quot;gather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01888"></a>01888   }
<a name="l01889"></a>01889 
<a name="l01890"></a>01890 
<a name="l01891"></a>01891   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01892"></a>01892   <span class="keyword">inline</span> <span class="keywordtype">void</span> allgather(T send,
<a name="l01893"></a>01893                         std::vector&lt;T&gt; &amp;recv)
<a name="l01894"></a>01894   {
<a name="l01895"></a>01895     START_LOG (<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01896"></a>01896     
<a name="l01897"></a>01897     recv.resize(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01898"></a>01898     
<a name="l01899"></a>01899     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01900"></a>01900       {
<a name="l01901"></a>01901         MPI_Allgather (&amp;send,
<a name="l01902"></a>01902                        1,
<a name="l01903"></a>01903                        datatype&lt;T&gt;(),
<a name="l01904"></a>01904                        &amp;recv[0],
<a name="l01905"></a>01905                        1, 
<a name="l01906"></a>01906                        datatype&lt;T&gt;(),
<a name="l01907"></a>01907                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01908"></a>01908       }
<a name="l01909"></a>01909     <span class="keywordflow">else</span>
<a name="l01910"></a>01910       recv[0] = send;
<a name="l01911"></a>01911 
<a name="l01912"></a>01912     STOP_LOG (<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01913"></a>01913   }
<a name="l01914"></a>01914 
<a name="l01915"></a>01915 
<a name="l01916"></a>01916 
<a name="l01917"></a>01917   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01918"></a>01918   <span class="keyword">inline</span> <span class="keywordtype">void</span> allgather(std::complex&lt;T&gt; send,
<a name="l01919"></a>01919                         std::vector&lt;std::complex&lt;T&gt; &gt; &amp;recv)
<a name="l01920"></a>01920   {
<a name="l01921"></a>01921     START_LOG (<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01922"></a>01922 
<a name="l01923"></a>01923     recv.resize(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01924"></a>01924 
<a name="l01925"></a>01925     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l01926"></a>01926       {
<a name="l01927"></a>01927         MPI_Allgather (&amp;send,
<a name="l01928"></a>01928                        2,
<a name="l01929"></a>01929                        datatype&lt;T&gt;(),
<a name="l01930"></a>01930                        &amp;recv[0],
<a name="l01931"></a>01931                        2, 
<a name="l01932"></a>01932                        datatype&lt;T&gt;(),
<a name="l01933"></a>01933                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01934"></a>01934       }
<a name="l01935"></a>01935     <span class="keywordflow">else</span>
<a name="l01936"></a>01936       recv[0] = send;
<a name="l01937"></a>01937 
<a name="l01938"></a>01938     STOP_LOG (<span class="stringliteral">&quot;allgather()&quot;</span>,<span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01939"></a>01939   }
<a name="l01940"></a>01940   
<a name="l01941"></a>01941 
<a name="l01942"></a>01942 
<a name="l01965"></a>01965   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01966"></a>01966   <span class="keyword">inline</span> <span class="keywordtype">void</span> allgather(std::vector&lt;T&gt; &amp;r,
<a name="l01967"></a>01967                         <span class="keyword">const</span> <span class="keywordtype">bool</span> identical_buffer_sizes)
<a name="l01968"></a>01968   {
<a name="l01969"></a>01969     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01970"></a>01970       <span class="keywordflow">return</span>;
<a name="l01971"></a>01971 
<a name="l01972"></a>01972     START_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01973"></a>01973 
<a name="l01974"></a>01974     <span class="keywordflow">if</span> (identical_buffer_sizes)
<a name="l01975"></a>01975       {
<a name="l01976"></a>01976         std::vector&lt;T&gt; r_src(r.size()*<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01977"></a>01977         r_src.swap(r);
<a name="l01978"></a>01978         MPI_Allgather (r_src.empty() ? NULL : &amp;r_src[0],
<a name="l01979"></a>01979                        r_src.size(),
<a name="l01980"></a>01980                        datatype&lt;T&gt;(),
<a name="l01981"></a>01981                        r.empty() ? NULL : &amp;r[0],
<a name="l01982"></a>01982                        r_src.size(), 
<a name="l01983"></a>01983                        datatype&lt;T&gt;(),
<a name="l01984"></a>01984                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l01985"></a>01985         STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l01986"></a>01986         <span class="keywordflow">return</span>;
<a name="l01987"></a>01987       }
<a name="l01988"></a>01988 
<a name="l01989"></a>01989     std::vector&lt;int&gt;
<a name="l01990"></a>01990       sendlengths  (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0),
<a name="l01991"></a>01991       displacements(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l01992"></a>01992 
<a name="l01993"></a>01993     <span class="keyword">const</span> <span class="keywordtype">int</span> mysize = r.size();
<a name="l01994"></a>01994     Parallel::allgather(mysize, sendlengths);
<a name="l01995"></a>01995 
<a name="l01996"></a>01996     <span class="comment">// Find the total size of the final array and</span>
<a name="l01997"></a>01997     <span class="comment">// set up the displacement offsets for each processor.</span>
<a name="l01998"></a>01998     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> globalsize = 0; 
<a name="l01999"></a>01999     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++i)
<a name="l02000"></a>02000       {
<a name="l02001"></a>02001         displacements[i] = globalsize;
<a name="l02002"></a>02002         globalsize += sendlengths[i];
<a name="l02003"></a>02003       }
<a name="l02004"></a>02004 
<a name="l02005"></a>02005     <span class="comment">// Check for quick return</span>
<a name="l02006"></a>02006     <span class="keywordflow">if</span> (globalsize == 0)
<a name="l02007"></a>02007       {
<a name="l02008"></a>02008         STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02009"></a>02009         <span class="keywordflow">return</span>;
<a name="l02010"></a>02010       }
<a name="l02011"></a>02011 
<a name="l02012"></a>02012     <span class="comment">// copy the input buffer</span>
<a name="l02013"></a>02013     std::vector&lt;T&gt; r_src(globalsize);
<a name="l02014"></a>02014     r_src.swap(r);
<a name="l02015"></a>02015 
<a name="l02016"></a>02016     <span class="comment">// and get the data from the remote processors.</span>
<a name="l02017"></a>02017     <span class="comment">// Pass NULL if our vector is empty.</span>
<a name="l02018"></a>02018 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02019"></a>02019 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02020"></a>02020     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02021"></a>02021 <span class="preprocessor">#endif</span>
<a name="l02022"></a>02022 <span class="preprocessor"></span>      MPI_Allgatherv (r_src.empty() ? NULL : &amp;r_src[0], mysize, datatype&lt;T&gt;(),
<a name="l02023"></a>02023                       r.empty()     ? NULL : &amp;r[0],     &amp;sendlengths[0],
<a name="l02024"></a>02024                       &amp;displacements[0], datatype&lt;T&gt;(), <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l02025"></a>02025 
<a name="l02026"></a>02026     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02027"></a>02027 
<a name="l02028"></a>02028     STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02029"></a>02029   }
<a name="l02030"></a>02030 
<a name="l02031"></a>02031 
<a name="l02032"></a>02032   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02033"></a>02033   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l02034"></a>02034   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02035"></a>02035   <span class="keyword">inline</span> <span class="keywordtype">void</span> allgather(std::vector&lt;std::complex&lt;T&gt; &gt; &amp;r,
<a name="l02036"></a>02036                         <span class="keyword">const</span> <span class="keywordtype">bool</span> identical_buffer_sizes = <span class="keyword">false</span>)
<a name="l02037"></a>02037   {
<a name="l02038"></a>02038     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l02039"></a>02039       <span class="keywordflow">return</span>;
<a name="l02040"></a>02040 
<a name="l02041"></a>02041     START_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02042"></a>02042 
<a name="l02043"></a>02043     <span class="keywordflow">if</span> (identical_buffer_sizes)
<a name="l02044"></a>02044       {
<a name="l02045"></a>02045         std::vector&lt;std::complex&lt;T&gt; &gt; r_src(r.size()*<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l02046"></a>02046         r_src.swap(r);
<a name="l02047"></a>02047         MPI_Allgather (r_src.empty() ? NULL : &amp;r_src[0],
<a name="l02048"></a>02048                        2*r_src.size(),
<a name="l02049"></a>02049                        datatype&lt;T&gt;(),
<a name="l02050"></a>02050                        r.empty() ? NULL : &amp;r[0],
<a name="l02051"></a>02051                        2*r_src.size(), 
<a name="l02052"></a>02052                        datatype&lt;T&gt;(),
<a name="l02053"></a>02053                        <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l02054"></a>02054         STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02055"></a>02055         <span class="keywordflow">return</span>;
<a name="l02056"></a>02056       }
<a name="l02057"></a>02057 
<a name="l02058"></a>02058     std::vector&lt;int&gt;
<a name="l02059"></a>02059       sendlengths  (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0),
<a name="l02060"></a>02060       displacements(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l02061"></a>02061 
<a name="l02062"></a>02062     <span class="keyword">const</span> <span class="keywordtype">int</span> mysize = r.size() * 2;
<a name="l02063"></a>02063     Parallel::allgather(mysize, sendlengths);
<a name="l02064"></a>02064 
<a name="l02065"></a>02065     <span class="comment">// Find the total size of the final array and</span>
<a name="l02066"></a>02066     <span class="comment">// set up the displacement offsets for each processor.</span>
<a name="l02067"></a>02067     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> globalsize = 0; 
<a name="l02068"></a>02068     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++i)
<a name="l02069"></a>02069       {
<a name="l02070"></a>02070         displacements[i] = globalsize;
<a name="l02071"></a>02071         globalsize += sendlengths[i];
<a name="l02072"></a>02072       }
<a name="l02073"></a>02073 
<a name="l02074"></a>02074     <span class="comment">// Check for quick return</span>
<a name="l02075"></a>02075     <span class="keywordflow">if</span> (globalsize == 0)
<a name="l02076"></a>02076       {
<a name="l02077"></a>02077         STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02078"></a>02078         <span class="keywordflow">return</span>;
<a name="l02079"></a>02079       }
<a name="l02080"></a>02080 
<a name="l02081"></a>02081     <span class="comment">// copy the input buffer</span>
<a name="l02082"></a>02082     std::vector&lt;std::complex&lt;T&gt; &gt; r_src(globalsize);
<a name="l02083"></a>02083     r_src.swap(r);
<a name="l02084"></a>02084 
<a name="l02085"></a>02085     <span class="comment">// and get the data from the remote processors.</span>
<a name="l02086"></a>02086     <span class="comment">// Pass NULL if our vector is empty.</span>
<a name="l02087"></a>02087     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02088"></a>02088       MPI_Allgatherv (r_src.empty() ? NULL : &amp;r_src[0], mysize, datatype&lt;T&gt;(),
<a name="l02089"></a>02089                       r.empty()     ? NULL : &amp;r[0],     &amp;sendlengths[0],
<a name="l02090"></a>02090                       &amp;displacements[0], datatype&lt;T&gt;(),
<a name="l02091"></a>02091                       <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l02092"></a>02092     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02093"></a>02093 
<a name="l02094"></a>02094     STOP_LOG(<span class="stringliteral">&quot;allgather()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02095"></a>02095   }
<a name="l02096"></a>02096   
<a name="l02097"></a>02097 
<a name="l02098"></a>02098 
<a name="l02105"></a>02105   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02106"></a>02106   <span class="keyword">inline</span> <span class="keywordtype">void</span> alltoall(std::vector&lt;T&gt; &amp;buf)
<a name="l02107"></a>02107   {
<a name="l02108"></a>02108     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l02109"></a>02109       <span class="keywordflow">return</span>;
<a name="l02110"></a>02110 
<a name="l02111"></a>02111     START_LOG(<span class="stringliteral">&quot;alltoall()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02112"></a>02112 
<a name="l02113"></a>02113     <span class="comment">// the per-processor size.  this is the same for all</span>
<a name="l02114"></a>02114     <span class="comment">// processors using MPI_Alltoall, could be variable</span>
<a name="l02115"></a>02115     <span class="comment">// using MPI_Alltoallv</span>
<a name="l02116"></a>02116     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size_per_proc = 
<a name="l02117"></a>02117       buf.size()/<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l02118"></a>02118 
<a name="l02119"></a>02119     libmesh_assert (buf.size()%<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 0);
<a name="l02120"></a>02120 
<a name="l02121"></a>02121     std::vector&lt;T&gt; tmp(buf);
<a name="l02122"></a>02122     
<a name="l02123"></a>02123 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02124"></a>02124 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02125"></a>02125     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02126"></a>02126 <span class="preprocessor">#endif</span>
<a name="l02127"></a>02127 <span class="preprocessor"></span>      MPI_Alltoall (tmp.empty() ? NULL : &amp;tmp[0],
<a name="l02128"></a>02128                     size_per_proc,
<a name="l02129"></a>02129                     datatype&lt;T&gt;(),
<a name="l02130"></a>02130                     buf.empty() ? NULL : &amp;buf[0],
<a name="l02131"></a>02131                     size_per_proc,
<a name="l02132"></a>02132                     datatype&lt;T&gt;(),
<a name="l02133"></a>02133                     <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l02134"></a>02134     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02135"></a>02135     
<a name="l02136"></a>02136     STOP_LOG(<span class="stringliteral">&quot;alltoall()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02137"></a>02137   }
<a name="l02138"></a>02138 
<a name="l02139"></a>02139 
<a name="l02140"></a>02140 
<a name="l02141"></a>02141   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02142"></a>02142   <span class="keyword">inline</span> <span class="keywordtype">void</span> broadcast (T &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id)
<a name="l02143"></a>02143   {
<a name="l02144"></a>02144     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l02145"></a>02145       {
<a name="l02146"></a>02146         libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == root_id);
<a name="l02147"></a>02147         <span class="keywordflow">return</span>;
<a name="l02148"></a>02148       }
<a name="l02149"></a>02149     
<a name="l02150"></a>02150     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02151"></a>02151 
<a name="l02152"></a>02152     <span class="comment">// Spread data to remote processors.</span>
<a name="l02153"></a>02153 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02154"></a>02154 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02155"></a>02155     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02156"></a>02156 <span class="preprocessor">#endif</span>
<a name="l02157"></a>02157 <span class="preprocessor"></span>      MPI_Bcast (&amp;data, 1, datatype&lt;T&gt;(), root_id, <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l02158"></a>02158 
<a name="l02159"></a>02159     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02160"></a>02160 
<a name="l02161"></a>02161     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02162"></a>02162   }
<a name="l02163"></a>02163 
<a name="l02164"></a>02164 
<a name="l02165"></a>02165   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02166"></a>02166   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l02167"></a>02167   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02168"></a>02168   <span class="keyword">inline</span> <span class="keywordtype">void</span> broadcast (std::complex&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0)
<a name="l02169"></a>02169   {
<a name="l02170"></a>02170     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l02171"></a>02171       {
<a name="l02172"></a>02172         libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == root_id);
<a name="l02173"></a>02173         <span class="keywordflow">return</span>;
<a name="l02174"></a>02174       }
<a name="l02175"></a>02175     
<a name="l02176"></a>02176     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02177"></a>02177 
<a name="l02178"></a>02178     <span class="comment">// Spread data to remote processors.</span>
<a name="l02179"></a>02179     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02180"></a>02180       MPI_Bcast (&amp;data, 2, datatype&lt;T&gt;(), root_id, <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l02181"></a>02181     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02182"></a>02182 
<a name="l02183"></a>02183     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02184"></a>02184   }
<a name="l02185"></a>02185 
<a name="l02186"></a>02186 
<a name="l02187"></a>02187 
<a name="l02188"></a>02188   <span class="keyword">template</span> &lt;&gt;
<a name="l02189"></a>02189   <span class="keyword">inline</span> <span class="keywordtype">void</span> broadcast (std::string &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id)
<a name="l02190"></a>02190   {
<a name="l02191"></a>02191     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l02192"></a>02192       {
<a name="l02193"></a>02193         libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == root_id);
<a name="l02194"></a>02194         <span class="keywordflow">return</span>;
<a name="l02195"></a>02195       }
<a name="l02196"></a>02196 
<a name="l02197"></a>02197     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02198"></a>02198 
<a name="l02199"></a>02199     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> data_size = data.size();
<a name="l02200"></a>02200     Parallel::broadcast(data_size, root_id);
<a name="l02201"></a>02201     
<a name="l02202"></a>02202     std::vector&lt;char&gt; data_c(data_size);
<a name="l02203"></a>02203     std::string orig(data);
<a name="l02204"></a>02204 
<a name="l02205"></a>02205     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == root_id)
<a name="l02206"></a>02206       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;data.size(); i++)
<a name="l02207"></a>02207         data_c[i] = data[i];
<a name="l02208"></a>02208 
<a name="l02209"></a>02209     Parallel::broadcast (data_c,root_id);
<a name="l02210"></a>02210     
<a name="l02211"></a>02211     data.clear(); data.reserve(data_c.size());
<a name="l02212"></a>02212     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;data_c.size(); i++)
<a name="l02213"></a>02213       data.push_back(data_c[i]);
<a name="l02214"></a>02214     
<a name="l02215"></a>02215     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == root_id)
<a name="l02216"></a>02216       libmesh_assert(data == orig);
<a name="l02217"></a>02217 
<a name="l02218"></a>02218     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02219"></a>02219   }
<a name="l02220"></a>02220 
<a name="l02221"></a>02221 
<a name="l02222"></a>02222 
<a name="l02223"></a>02223   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02224"></a>02224   <span class="keyword">inline</span> <span class="keywordtype">void</span> broadcast (std::vector&lt;T&gt; &amp;data, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id)
<a name="l02225"></a>02225   {
<a name="l02226"></a>02226     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l02227"></a>02227       {
<a name="l02228"></a>02228         libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == root_id);
<a name="l02229"></a>02229         <span class="keywordflow">return</span>;
<a name="l02230"></a>02230       }
<a name="l02231"></a>02231 
<a name="l02232"></a>02232     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02233"></a>02233 
<a name="l02234"></a>02234     <span class="comment">// and get the data from the remote processors.</span>
<a name="l02235"></a>02235     <span class="comment">// Pass NULL if our vector is empty.</span>
<a name="l02236"></a>02236 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l02237"></a>02237 <span class="preprocessor"></span>    <span class="comment">// Only catch the return value when asserts are active.</span>
<a name="l02238"></a>02238     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02239"></a>02239 <span class="preprocessor">#endif</span>
<a name="l02240"></a>02240 <span class="preprocessor"></span>      MPI_Bcast (data.empty() ? NULL : &amp;data[0], data.size(), datatype&lt;T&gt;(),
<a name="l02241"></a>02241                  root_id, <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l02242"></a>02242 
<a name="l02243"></a>02243     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02244"></a>02244 
<a name="l02245"></a>02245     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02246"></a>02246   }
<a name="l02247"></a>02247 
<a name="l02248"></a>02248 
<a name="l02249"></a>02249   <span class="comment">// This is both a declaration and definition for a new overloaded</span>
<a name="l02250"></a>02250   <span class="comment">// function template, so we have to re-specify the default argument</span>
<a name="l02251"></a>02251   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02252"></a>02252   <span class="keyword">inline</span> <span class="keywordtype">void</span> broadcast (std::vector&lt;std::complex&lt;T&gt; &gt; &amp;data,
<a name="l02253"></a>02253                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id=0)
<a name="l02254"></a>02254   {
<a name="l02255"></a>02255     <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l02256"></a>02256       {
<a name="l02257"></a>02257         libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == root_id);
<a name="l02258"></a>02258         <span class="keywordflow">return</span>;
<a name="l02259"></a>02259       }
<a name="l02260"></a>02260 
<a name="l02261"></a>02261     START_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02262"></a>02262 
<a name="l02263"></a>02263     <span class="comment">// and get the data from the remote processors.</span>
<a name="l02264"></a>02264     <span class="comment">// Pass NULL if our vector is empty.</span>
<a name="l02265"></a>02265     <span class="keyword">const</span> <span class="keywordtype">int</span> ierr =
<a name="l02266"></a>02266       MPI_Bcast (data.empty() ? NULL : &amp;data[0], data.size() * 2, datatype&lt;T&gt;(),
<a name="l02267"></a>02267                  root_id, <a class="code" href="namespacelibMesh.php#a30eab924fe569ab4dc3c2187c625c4ba">libMesh::COMM_WORLD</a>);
<a name="l02268"></a>02268     libmesh_assert (ierr == MPI_SUCCESS);
<a name="l02269"></a>02269 
<a name="l02270"></a>02270     STOP_LOG(<span class="stringliteral">&quot;broadcast()&quot;</span>, <span class="stringliteral">&quot;Parallel&quot;</span>);
<a name="l02271"></a>02271   }
<a name="l02272"></a>02272 
<a name="l02273"></a>02273 
<a name="l02274"></a>02274 <span class="preprocessor">#else // LIBMESH_HAVE_MPI</span>
<a name="l02275"></a>02275 <span class="preprocessor"></span>
<a name="l02276"></a>02276   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02277"></a>02277   <span class="keyword">inline</span> <span class="keywordtype">bool</span> verify(<span class="keyword">const</span> T &amp;) { <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l02278"></a>02278 
<a name="l02279"></a>02279   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02280"></a>02280   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(T &amp;) {}
<a name="l02281"></a>02281 
<a name="l02282"></a>02282   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02283"></a>02283   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(std::vector&lt;T&gt; &amp;) {}
<a name="l02284"></a>02284 
<a name="l02285"></a>02285   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02286"></a>02286   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(T &amp;) {}
<a name="l02287"></a>02287 
<a name="l02288"></a>02288   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02289"></a>02289   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(std::vector&lt;T&gt; &amp;) {}
<a name="l02290"></a>02290 
<a name="l02291"></a>02291   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02292"></a>02292   <span class="keyword">inline</span> <span class="keywordtype">void</span> sum(T &amp;) {}
<a name="l02293"></a>02293 
<a name="l02294"></a>02294   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02295"></a>02295   <span class="keyword">inline</span> <span class="keywordtype">void</span> sum(std::vector&lt;T&gt; &amp;) {}
<a name="l02296"></a>02296 
<a name="l02297"></a>02297  <span class="comment">//-------------------------------------------------------------------</span>
<a name="l02304"></a>02304 <span class="comment"></span>  <span class="keyword">inline</span> status probe (<span class="keyword">const</span> <span class="keywordtype">int</span>,
<a name="l02305"></a>02305                        <span class="keyword">const</span> <span class="keywordtype">int</span>)
<a name="l02306"></a>02306   { libmesh_error(); status status; <span class="keywordflow">return</span> status; }
<a name="l02307"></a>02307 
<a name="l02308"></a>02308   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l02314"></a>02314 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02315"></a>02315   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l02316"></a>02316                     std::vector&lt;T&gt; &amp;,
<a name="l02317"></a>02317                     <span class="keyword">const</span> DataType &amp;,
<a name="l02318"></a>02318                     <span class="keyword">const</span> <span class="keywordtype">int</span>)
<a name="l02319"></a>02319   { libmesh_error(); }
<a name="l02320"></a>02320 
<a name="l02321"></a>02321   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l02327"></a>02327 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02328"></a>02328   <span class="keyword">inline</span> <span class="keywordtype">void</span> send (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l02329"></a>02329                     std::vector&lt;T&gt; &amp;,
<a name="l02330"></a>02330                     <span class="keyword">const</span> DataType &amp;,
<a name="l02331"></a>02331                     request &amp;,
<a name="l02332"></a>02332                     <span class="keyword">const</span> <span class="keywordtype">int</span>)
<a name="l02333"></a>02333   { libmesh_error(); }
<a name="l02334"></a>02334 
<a name="l02335"></a>02335   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l02341"></a>02341 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02342"></a>02342   <span class="keyword">inline</span> Status receive (<span class="keyword">const</span> <span class="keywordtype">int</span>,
<a name="l02343"></a>02343                          std::vector&lt;T&gt; &amp;,
<a name="l02344"></a>02344                          <span class="keyword">const</span> DataType &amp;,
<a name="l02345"></a>02345                          <span class="keyword">const</span> <span class="keywordtype">int</span>)
<a name="l02346"></a>02346   { libmesh_error(); <span class="keywordflow">return</span> Status(); }
<a name="l02347"></a>02347 
<a name="l02348"></a>02348   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l02354"></a>02354 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02355"></a>02355   <span class="keyword">inline</span> <span class="keywordtype">void</span> receive (<span class="keyword">const</span> <span class="keywordtype">int</span>,
<a name="l02356"></a>02356                        std::vector&lt;T&gt; &amp;,
<a name="l02357"></a>02357                        <span class="keyword">const</span> DataType &amp;,
<a name="l02358"></a>02358                        request &amp;,
<a name="l02359"></a>02359                        <span class="keyword">const</span> <span class="keywordtype">int</span>)
<a name="l02360"></a>02360   { libmesh_error(); }
<a name="l02361"></a>02361 
<a name="l02362"></a>02362 
<a name="l02363"></a>02363 <span class="comment">//   // on one processor a blocking probe can only be used to </span>
<a name="l02364"></a>02364 <span class="comment">//   // test a nonblocking send, which we don&#39;t really support</span>
<a name="l02365"></a>02365 <span class="comment">//   inline status probe (const int,</span>
<a name="l02366"></a>02366 <span class="comment">//                     const int)</span>
<a name="l02367"></a>02367 <span class="comment">//   { libmesh_error(); status status; return status; }</span>
<a name="l02368"></a>02368 
<a name="l02369"></a>02369 
<a name="l02370"></a>02370 <span class="comment">//   // Blocking sends don&#39;t make sense on one processor</span>
<a name="l02371"></a>02371 <span class="comment">//   template &lt;typename T&gt;</span>
<a name="l02372"></a>02372 <span class="comment">//   inline void send (const unsigned int,</span>
<a name="l02373"></a>02373 <span class="comment">//                  std::vector&lt;T&gt; &amp;,</span>
<a name="l02374"></a>02374 <span class="comment">//                  const unsigned int) { libmesh_error(); }</span>
<a name="l02375"></a>02375 
<a name="l02376"></a>02376 <span class="comment">//   template &lt;typename T&gt;</span>
<a name="l02377"></a>02377 <span class="comment">//   inline void nonblocking_send (const unsigned int,</span>
<a name="l02378"></a>02378 <span class="comment">//                              std::vector&lt;T&gt; &amp;,</span>
<a name="l02379"></a>02379 <span class="comment">//                              request &amp;,</span>
<a name="l02380"></a>02380 <span class="comment">//                              const int) {}</span>
<a name="l02381"></a>02381 
<a name="l02382"></a>02382 <span class="comment">//   // Blocking receives don&#39;t make sense on one processor</span>
<a name="l02383"></a>02383 <span class="comment">//   template &lt;typename T&gt;</span>
<a name="l02384"></a>02384 <span class="comment">//   inline Status receive (const int,</span>
<a name="l02385"></a>02385 <span class="comment">//                       std::vector&lt;T&gt; &amp;,</span>
<a name="l02386"></a>02386 <span class="comment">//                       const int) { libmesh_error(); return Status(); }</span>
<a name="l02387"></a>02387 
<a name="l02388"></a>02388 <span class="comment">//   template &lt;typename T&gt;</span>
<a name="l02389"></a>02389 <span class="comment">//   inline void nonblocking_receive (const int,</span>
<a name="l02390"></a>02390 <span class="comment">//                                 std::vector&lt;T&gt; &amp;,</span>
<a name="l02391"></a>02391 <span class="comment">//                                 request &amp;,</span>
<a name="l02392"></a>02392 <span class="comment">//                                 const int) {}</span>
<a name="l02393"></a>02393   
<a name="l02394"></a>02394   <span class="keyword">inline</span> status wait (request &amp;) { status status; <span class="keywordflow">return</span> status; }
<a name="l02395"></a>02395   
<a name="l02396"></a>02396   <span class="keyword">inline</span> <span class="keywordtype">void</span> wait (std::vector&lt;request&gt; &amp;) {}
<a name="l02397"></a>02397   
<a name="l02398"></a>02398   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02399"></a>02399   <span class="keyword">inline</span> <span class="keywordtype">void</span> send_receive (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> send_tgt,
<a name="l02400"></a>02400                             T &amp;send,
<a name="l02401"></a>02401                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> recv_source,
<a name="l02402"></a>02402                             T &amp;recv)
<a name="l02403"></a>02403   {
<a name="l02404"></a>02404     libmesh_assert (send_tgt == recv_source);
<a name="l02405"></a>02405     recv = send;
<a name="l02406"></a>02406   }
<a name="l02407"></a>02407 
<a name="l02408"></a>02408   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02409"></a>02409   <span class="keyword">inline</span> <span class="keywordtype">void</span> gather(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> root_id,
<a name="l02410"></a>02410                      T send,
<a name="l02411"></a>02411                      std::vector&lt;T&gt; &amp;recv)
<a name="l02412"></a>02412   {
<a name="l02413"></a>02413     libmesh_assert (!root_id);
<a name="l02414"></a>02414     recv.resize(1);
<a name="l02415"></a>02415     recv[0] = send;
<a name="l02416"></a>02416   }
<a name="l02417"></a>02417 
<a name="l02418"></a>02418   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02419"></a>02419   <span class="keyword">inline</span> <span class="keywordtype">void</span> gather(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, std::vector&lt;T&gt; &amp;) {}
<a name="l02420"></a>02420 
<a name="l02421"></a>02421   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02422"></a>02422   <span class="keyword">inline</span> <span class="keywordtype">void</span> allgather(T send,
<a name="l02423"></a>02423                         std::vector&lt;T&gt; &amp;recv)
<a name="l02424"></a>02424   {
<a name="l02425"></a>02425     recv.resize(1);
<a name="l02426"></a>02426     recv[0] = send;
<a name="l02427"></a>02427   }
<a name="l02428"></a>02428 
<a name="l02429"></a>02429   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02430"></a>02430   <span class="keyword">inline</span> <span class="keywordtype">void</span> allgather(std::vector&lt;T&gt; &amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span>) {}
<a name="l02431"></a>02431 
<a name="l02432"></a>02432   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02433"></a>02433   <span class="keyword">inline</span> <span class="keywordtype">void</span> alltoall(std::vector&lt;T&gt; &amp;) {}
<a name="l02434"></a>02434 
<a name="l02435"></a>02435   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02436"></a>02436     <span class="keyword">inline</span> <span class="keywordtype">void</span> broadcast (T &amp;, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) {}
<a name="l02437"></a>02437 
<a name="l02438"></a>02438   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l02439"></a>02439     <span class="keyword">inline</span> <span class="keywordtype">void</span> broadcast (std::vector&lt;T&gt; &amp;, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) {}
<a name="l02440"></a>02440 
<a name="l02441"></a>02441 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l02442"></a>02442 <span class="preprocessor"></span>
<a name="l02443"></a>02443 
<a name="l02444"></a>02444 }
<a name="l02445"></a>02445 
<a name="l02446"></a>02446 <span class="preprocessor">#endif // #define __parallel_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
