<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.3 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_315b4fa7f230dc7aee0f871682e801f6.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_c2e5aa429b9110fa734bdc9647d91e10.php">utils</a>      </li>
</div>
<div class="header">
  <div class="headertitle">
<h1>xdr_cxx.C</h1>  </div>
</div>
<div class="contents">
<a href="xdr__cxx_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// &quot;$Id: xdr_cxx.C 3474 2009-09-28 16:20:39Z roystgnr $\n&quot;</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C/C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;xdr_cxx.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;libmesh_logging.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;parallel.h&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;o_f_stream.h&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor"># include &quot;gzstream.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#endif</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Anonymous namespace for implementation details.</span>
<a name="l00035"></a>00035 <span class="keyword">namespace </span>{
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="comment">// Nasty hacks for reading/writing zipped files</span>
<a name="l00038"></a>00038   <span class="keywordtype">void</span> zip_file (<span class="keyword">const</span> std::string &amp;unzipped_name)
<a name="l00039"></a>00039   {
<a name="l00040"></a>00040     <span class="comment">// There&#39;s no parallel bzip2 for us to call</span>
<a name="l00041"></a>00041     libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="preprocessor">#ifdef LIBMESH_HAVE_BZIP</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>    START_LOG(<span class="stringliteral">&quot;system(bzip2)&quot;</span>, <span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046     std::string system_string = <span class="stringliteral">&quot;bzip2 -f &quot;</span>;
<a name="l00047"></a>00047     system_string += unzipped_name;
<a name="l00048"></a>00048     <span class="keywordflow">if</span> (std::system(system_string.c_str()))
<a name="l00049"></a>00049       libmesh_file_error(system_string);
<a name="l00050"></a>00050      
<a name="l00051"></a>00051     STOP_LOG(<span class="stringliteral">&quot;system(bzip2)&quot;</span>, <span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00052"></a>00052 <span class="preprocessor">#else</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>    std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: need bzip2/bunzip2 to handle .bz2 files!!!&quot;</span>
<a name="l00054"></a>00054               &lt;&lt; std::endl;
<a name="l00055"></a>00055     libmesh_error();
<a name="l00056"></a>00056 <span class="preprocessor">#endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>  }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   std::string unzip_file (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>)
<a name="l00060"></a>00060   {
<a name="l00061"></a>00061     <span class="comment">// There&#39;s no parallel bunzip2 for us to call</span>
<a name="l00062"></a>00062     libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     std::string new_name = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00065"></a>00065     <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00066"></a>00066       {
<a name="l00067"></a>00067         new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00068"></a>00068 <span class="preprocessor">#ifdef LIBMESH_HAVE_BZIP</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>        START_LOG(<span class="stringliteral">&quot;system(bunzip2)&quot;</span>, <span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00070"></a>00070         std::string system_string = <span class="stringliteral">&quot;bunzip2 -f -k &quot;</span>;
<a name="l00071"></a>00071         system_string += <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00072"></a>00072         <span class="keywordflow">if</span> (std::system(system_string.c_str()))
<a name="l00073"></a>00073           libmesh_file_error(system_string);
<a name="l00074"></a>00074         STOP_LOG(<span class="stringliteral">&quot;system(bunzip2)&quot;</span>, <span class="stringliteral">&quot;XdrIO&quot;</span>);
<a name="l00075"></a>00075 <span class="preprocessor">#else</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>        std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: need bzip2/bunzip2 to handle .bz2 files!!!&quot;</span>
<a name="l00077"></a>00077                   &lt;&lt; std::endl;
<a name="l00078"></a>00078         libmesh_error();
<a name="l00079"></a>00079 <span class="preprocessor">#endif</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>      }
<a name="l00081"></a>00081     <span class="keywordflow">return</span> new_name;
<a name="l00082"></a>00082   }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">// remove an unzipped file</span>
<a name="l00085"></a>00085   <span class="keywordtype">void</span> remove_unzipped_file (<span class="keyword">const</span> std::string &amp;name)
<a name="l00086"></a>00086   {
<a name="l00087"></a>00087     <span class="comment">// If we temporarily decompressed a .bz2 file, remove the</span>
<a name="l00088"></a>00088     <span class="comment">// uncompressed version</span>
<a name="l00089"></a>00089     <span class="keywordflow">if</span> (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4)
<a name="l00090"></a>00090       {
<a name="l00091"></a>00091         <span class="keyword">const</span> std::string new_name(name.begin(), name.end()-4);
<a name="l00092"></a>00092         std::remove(new_name.c_str());
<a name="l00093"></a>00093       }
<a name="l00094"></a>00094   }
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00098"></a>00098 <span class="comment">// Xdr class implementation</span>
<a name="l00099"></a><a class="code" href="classXdr.php#a71201e933ce19bbd66d1f1cdc7ba0a48">00099</a> <a class="code" href="classXdr.php#a71201e933ce19bbd66d1f1cdc7ba0a48">Xdr::Xdr</a> (<span class="keyword">const</span> std::string&amp; name, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> m) :
<a name="l00100"></a>00100   mode(m),
<a name="l00101"></a>00101   file_name(name),
<a name="l00102"></a>00102 #ifdef LIBMESH_HAVE_XDR
<a name="l00103"></a>00103   xdrs(NULL),
<a name="l00104"></a>00104   fp(NULL),
<a name="l00105"></a>00105 #endif
<a name="l00106"></a>00106   in(NULL),
<a name="l00107"></a>00107   out(NULL),
<a name="l00108"></a>00108   comm_len(xdr_MAX_STRING_LENGTH),
<a name="l00109"></a>00109   gzipped_file(false),
<a name="l00110"></a>00110   bzipped_file(false)
<a name="l00111"></a>00111 {
<a name="l00112"></a>00112   this-&gt;<a class="code" href="classXdr.php#ac8622354e4d5395d4c777fb4062dc334">open</a>(name);
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classXdr.php#a67fc8bd3cd8a85b04e43655a60dffdec">00117</a> <a class="code" href="classXdr.php#a67fc8bd3cd8a85b04e43655a60dffdec">Xdr::~Xdr</a>()
<a name="l00118"></a>00118 {
<a name="l00119"></a>00119   this-&gt;<a class="code" href="classXdr.php#a68dc02dd44f5f69b76813967d1d611cf">close</a>();
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classXdr.php#ac8622354e4d5395d4c777fb4062dc334">00124</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#ac8622354e4d5395d4c777fb4062dc334">Xdr::open</a> (<span class="keyword">const</span> std::string&amp; name)
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126   <a class="code" href="classXdr.php#a991eb4c2747e6cf24ddaf32ff053d35c">file_name</a> = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keywordflow">if</span> (name == <span class="stringliteral">&quot;&quot;</span>)
<a name="l00129"></a>00129     <span class="keywordflow">return</span>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00132"></a>00132     {
<a name="l00133"></a>00133     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00134"></a>00134     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00135"></a>00135       {
<a name="l00136"></a>00136 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
<a name="l00138"></a>00138         <a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">fp</a> = fopen(name.c_str(), (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>) ? <span class="stringliteral">&quot;w&quot;</span> : <span class="stringliteral">&quot;r&quot;</span>);
<a name="l00139"></a>00139         libmesh_assert (<a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">fp</a>);
<a name="l00140"></a>00140         <a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a> = <span class="keyword">new</span> XDR;
<a name="l00141"></a>00141         xdrstdio_create (<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, <a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">fp</a>, (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>) ? XDR_ENCODE : XDR_DECODE);
<a name="l00142"></a>00142 <span class="preprocessor">#else</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>        
<a name="l00144"></a>00144         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00145"></a>00145                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00146"></a>00146                   &lt;&lt; std::endl
<a name="l00147"></a>00147                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00148"></a>00148                   &lt;&lt; std::endl;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150         libmesh_error();
<a name="l00151"></a>00151         
<a name="l00152"></a>00152 <span class="preprocessor">#endif</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155       }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00158"></a>00158       {
<a name="l00159"></a>00159         <a class="code" href="classXdr.php#a64c209ad9346d907ee753635a7480d3f">gzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>)  == 3);
<a name="l00160"></a>00160         <a class="code" href="classXdr.php#a38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a64c209ad9346d907ee753635a7480d3f">gzipped_file</a>)
<a name="l00163"></a>00163           {
<a name="l00164"></a>00164 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00165"></a>00165 <span class="preprocessor"></span>            igzstream *inf = <span class="keyword">new</span> igzstream;
<a name="l00166"></a>00166             libmesh_assert (inf != NULL);
<a name="l00167"></a>00167             <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(inf);
<a name="l00168"></a>00168             inf-&gt;open(name.c_str(), <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">std::ios::in</a>);
<a name="l00169"></a>00169 <span class="preprocessor">#else</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>            std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: need gzstream to handle .gz files!!!&quot;</span>
<a name="l00171"></a>00171                       &lt;&lt; std::endl;
<a name="l00172"></a>00172             libmesh_error();
<a name="l00173"></a>00173 <span class="preprocessor">#endif</span>
<a name="l00174"></a>00174 <span class="preprocessor"></span>          }
<a name="l00175"></a>00175         <span class="keywordflow">else</span>
<a name="l00176"></a>00176           {
<a name="l00177"></a>00177             std::ifstream *inf = <span class="keyword">new</span> std::ifstream;
<a name="l00178"></a>00178             libmesh_assert (inf != NULL);
<a name="l00179"></a>00179             <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(inf);
<a name="l00180"></a>00180             
<a name="l00181"></a>00181             std::string new_name(<a class="code" href="classXdr.php#a38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a> ? unzip_file(name) : name);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183             inf-&gt;open(new_name.c_str(), <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">std::ios::in</a>);
<a name="l00184"></a>00184           }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00187"></a>00187         <span class="keywordflow">return</span>;
<a name="l00188"></a>00188       }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00191"></a>00191       {
<a name="l00192"></a>00192         <a class="code" href="classXdr.php#a64c209ad9346d907ee753635a7480d3f">gzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">&quot;.gz&quot;</span>)  == 3);
<a name="l00193"></a>00193         <a class="code" href="classXdr.php#a38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a> = (name.size() - name.rfind(<span class="stringliteral">&quot;.bz2&quot;</span>) == 4);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a64c209ad9346d907ee753635a7480d3f">gzipped_file</a>)
<a name="l00196"></a>00196           {
<a name="l00197"></a>00197 <span class="preprocessor">#ifdef LIBMESH_HAVE_GZSTREAM</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>            ogzstream *outf = <span class="keyword">new</span> ogzstream;
<a name="l00199"></a>00199             libmesh_assert (outf != NULL);
<a name="l00200"></a>00200             <a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(outf);
<a name="l00201"></a>00201             outf-&gt;open(name.c_str(), <a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">std::ios::out</a>);
<a name="l00202"></a>00202 <span class="preprocessor">#else</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span>            std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: need gzstream to handle .gz files!!!&quot;</span>
<a name="l00204"></a>00204                       &lt;&lt; std::endl;
<a name="l00205"></a>00205             libmesh_error();
<a name="l00206"></a>00206 <span class="preprocessor">#endif</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>          }
<a name="l00208"></a>00208         <span class="keywordflow">else</span>
<a name="l00209"></a>00209           {
<a name="l00210"></a>00210             std::ofstream *outf = <span class="keyword">new</span> std::ofstream;
<a name="l00211"></a>00211             libmesh_assert (outf != NULL);
<a name="l00212"></a>00212             <a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>(outf);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214             std::string new_name = <a class="code" href="namespaceQuality.php#a47f1b8befd1bbd18dfe20c810b9ade23">name</a>;
<a name="l00215"></a>00215 
<a name="l00216"></a>00216             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a>)
<a name="l00217"></a>00217               new_name.erase(new_name.end() - 4, new_name.end());
<a name="l00218"></a>00218 
<a name="l00219"></a>00219             outf-&gt;open(new_name.c_str(), <a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">std::ios::out</a>);
<a name="l00220"></a>00220           }
<a name="l00221"></a>00221         
<a name="l00222"></a>00222         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00223"></a>00223         <span class="keywordflow">return</span>;
<a name="l00224"></a>00224       }
<a name="l00225"></a>00225       
<a name="l00226"></a>00226     <span class="keywordflow">default</span>:
<a name="l00227"></a>00227       libmesh_error();
<a name="l00228"></a>00228     }  
<a name="l00229"></a>00229 }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a><a class="code" href="classXdr.php#a68dc02dd44f5f69b76813967d1d611cf">00233</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a68dc02dd44f5f69b76813967d1d611cf">Xdr::close</a> ()
<a name="l00234"></a>00234 {
<a name="l00235"></a>00235   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00236"></a>00236     {
<a name="l00237"></a>00237     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00238"></a>00238     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00239"></a>00239       {
<a name="l00240"></a>00240 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>
<a name="l00242"></a>00242         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>)
<a name="l00243"></a>00243           {
<a name="l00244"></a>00244             xdr_destroy (<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>);
<a name="l00245"></a>00245             <span class="keyword">delete</span> <a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>;
<a name="l00246"></a>00246             <a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a> = NULL;
<a name="l00247"></a>00247           }
<a name="l00248"></a>00248         
<a name="l00249"></a>00249         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">fp</a>)
<a name="l00250"></a>00250           {
<a name="l00251"></a>00251             fflush(<a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">fp</a>);
<a name="l00252"></a>00252             fclose(<a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">fp</a>);
<a name="l00253"></a>00253             <a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">fp</a> = NULL;
<a name="l00254"></a>00254           }
<a name="l00255"></a>00255 <span class="preprocessor">#else</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>        
<a name="l00257"></a>00257         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00258"></a>00258                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00259"></a>00259                   &lt;&lt; std::endl
<a name="l00260"></a>00260                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00261"></a>00261                   &lt;&lt; std::endl;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263         libmesh_error();
<a name="l00264"></a>00264         
<a name="l00265"></a>00265 <span class="preprocessor">#endif</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span>        <a class="code" href="classXdr.php#a991eb4c2747e6cf24ddaf32ff053d35c">file_name</a> = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00267"></a>00267         <span class="keywordflow">return</span>;
<a name="l00268"></a>00268       }
<a name="l00269"></a>00269       
<a name="l00270"></a>00270     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00271"></a>00271       {
<a name="l00272"></a>00272         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00273"></a>00273           {
<a name="l00274"></a>00274             <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>();    
<a name="l00275"></a>00275             
<a name="l00276"></a>00276             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a>)
<a name="l00277"></a>00277               remove_unzipped_file(<a class="code" href="classXdr.php#a991eb4c2747e6cf24ddaf32ff053d35c">file_name</a>);
<a name="l00278"></a>00278           }
<a name="l00279"></a>00279         <a class="code" href="classXdr.php#a991eb4c2747e6cf24ddaf32ff053d35c">file_name</a> = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00280"></a>00280         <span class="keywordflow">return</span>;
<a name="l00281"></a>00281       }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00284"></a>00284       {
<a name="l00285"></a>00285         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00286"></a>00286           {
<a name="l00287"></a>00287             <a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#afba95dd5fca7f83ababa4eaf6a57c511" title="Forcibly deletes the managed object.">reset</a>();      
<a name="l00288"></a>00288 
<a name="l00289"></a>00289             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a38d1340ec83b8ea9be03b83fe09b92d1">bzipped_file</a>)
<a name="l00290"></a>00290               zip_file(std::string(<a class="code" href="classXdr.php#a991eb4c2747e6cf24ddaf32ff053d35c">file_name</a>.begin(), <a class="code" href="classXdr.php#a991eb4c2747e6cf24ddaf32ff053d35c">file_name</a>.end()-4));
<a name="l00291"></a>00291           }
<a name="l00292"></a>00292         <a class="code" href="classXdr.php#a991eb4c2747e6cf24ddaf32ff053d35c">file_name</a> = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00293"></a>00293         <span class="keywordflow">return</span>;
<a name="l00294"></a>00294       }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296     <span class="keywordflow">default</span>:
<a name="l00297"></a>00297       libmesh_error();
<a name="l00298"></a>00298     }
<a name="l00299"></a>00299 }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a><a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">00303</a> <span class="keywordtype">bool</span> <a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">Xdr::is_open</a>()<span class="keyword"> const</span>
<a name="l00304"></a>00304 <span class="keyword"></span>{
<a name="l00305"></a>00305   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00306"></a>00306     {
<a name="l00307"></a>00307     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00308"></a>00308     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00309"></a>00309       {
<a name="l00310"></a>00310 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span>
<a name="l00312"></a>00312         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#ab3197bdc430b239a1c65e5d656e591d1">fp</a>)
<a name="l00313"></a>00313           <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>)
<a name="l00314"></a>00314             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00315"></a>00315 
<a name="l00316"></a>00316         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="preprocessor">#else</span>
<a name="l00319"></a>00319 <span class="preprocessor"></span>        
<a name="l00320"></a>00320         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00321"></a>00321                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00322"></a>00322                   &lt;&lt; std::endl
<a name="l00323"></a>00323                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00324"></a>00324                   &lt;&lt; std::endl;
<a name="l00325"></a>00325 
<a name="l00326"></a>00326         libmesh_error();
<a name="l00327"></a>00327 
<a name="l00328"></a>00328         <span class="keywordflow">return</span> <span class="keyword">false</span>;   
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="preprocessor">#endif</span>
<a name="l00331"></a>00331 <span class="preprocessor"></span>
<a name="l00332"></a>00332       }
<a name="l00333"></a>00333       
<a name="l00334"></a>00334     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00335"></a>00335       {
<a name="l00336"></a>00336         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00337"></a>00337           <span class="keywordflow">return</span> <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good();
<a name="l00338"></a>00338         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00339"></a>00339       }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00342"></a>00342       {
<a name="l00343"></a>00343         <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL)
<a name="l00344"></a>00344           <span class="keywordflow">return</span> <a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good();
<a name="l00345"></a>00345         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00346"></a>00346       }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348     <span class="keywordflow">default</span>:
<a name="l00349"></a>00349       libmesh_error();
<a name="l00350"></a>00350     }
<a name="l00351"></a>00351 
<a name="l00352"></a>00352   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00353"></a>00353 }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a><a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">00357</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00358"></a>00358 {
<a name="l00359"></a>00359   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00360"></a>00360     {
<a name="l00361"></a>00361     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00362"></a>00362     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00363"></a>00363       {
<a name="l00364"></a>00364 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00365"></a>00365 <span class="preprocessor"></span>
<a name="l00366"></a>00366         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00367"></a>00367 
<a name="l00368"></a>00368         xdr_int(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 <span class="preprocessor">#else</span>
<a name="l00371"></a>00371 <span class="preprocessor"></span>        
<a name="l00372"></a>00372         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00373"></a>00373                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00374"></a>00374                   &lt;&lt; std::endl
<a name="l00375"></a>00375                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00376"></a>00376                   &lt;&lt; std::endl;
<a name="l00377"></a>00377 
<a name="l00378"></a>00378         libmesh_error();
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 <span class="preprocessor">#endif</span>
<a name="l00381"></a>00381 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00382"></a>00382       }
<a name="l00383"></a>00383 
<a name="l00384"></a>00384     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00385"></a>00385       {
<a name="l00386"></a>00386         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00387"></a>00387         
<a name="l00388"></a>00388         *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00389"></a>00389 
<a name="l00390"></a>00390         <span class="keywordflow">return</span>;
<a name="l00391"></a>00391       }
<a name="l00392"></a>00392 
<a name="l00393"></a>00393     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00394"></a>00394       {
<a name="l00395"></a>00395         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00396"></a>00396         
<a name="l00397"></a>00397         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00398"></a>00398 
<a name="l00399"></a>00399         <span class="keywordflow">return</span>;
<a name="l00400"></a>00400       }
<a name="l00401"></a>00401 
<a name="l00402"></a>00402     <span class="keywordflow">default</span>:
<a name="l00403"></a>00403       libmesh_error();
<a name="l00404"></a>00404     }
<a name="l00405"></a>00405 }
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a><a class="code" href="classXdr.php#a608aa9d275764c53a2e16c2f0246d917">00409</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00410"></a>00410 {
<a name="l00411"></a>00411   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00412"></a>00412     {
<a name="l00413"></a>00413     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00414"></a>00414     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00415"></a>00415       {
<a name="l00416"></a>00416 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00417"></a>00417 <span class="preprocessor"></span>
<a name="l00418"></a>00418         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00419"></a>00419 
<a name="l00420"></a>00420         xdr_u_int(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 <span class="preprocessor">#else</span>
<a name="l00423"></a>00423 <span class="preprocessor"></span>        
<a name="l00424"></a>00424         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00425"></a>00425                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00426"></a>00426                   &lt;&lt; std::endl
<a name="l00427"></a>00427                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00428"></a>00428                   &lt;&lt; std::endl;
<a name="l00429"></a>00429 
<a name="l00430"></a>00430         libmesh_error();
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 <span class="preprocessor">#endif</span>
<a name="l00433"></a>00433 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00434"></a>00434       }
<a name="l00435"></a>00435 
<a name="l00436"></a>00436     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00437"></a>00437       {
<a name="l00438"></a>00438         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00439"></a>00439         
<a name="l00440"></a>00440         *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442         <span class="keywordflow">return</span>;
<a name="l00443"></a>00443       }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00446"></a>00446       {
<a name="l00447"></a>00447         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00448"></a>00448 
<a name="l00449"></a>00449         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00450"></a>00450         
<a name="l00451"></a>00451         <span class="keywordflow">return</span>;
<a name="l00452"></a>00452       }
<a name="l00453"></a>00453 
<a name="l00454"></a>00454     <span class="keywordflow">default</span>:
<a name="l00455"></a>00455       libmesh_error();
<a name="l00456"></a>00456     }
<a name="l00457"></a>00457 }
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a><a class="code" href="classXdr.php#aa7df14ebb267c47d9fd40da496fe4d26">00461</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00462"></a>00462 {
<a name="l00463"></a>00463   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00464"></a>00464     {
<a name="l00465"></a>00465     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00466"></a>00466     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00467"></a>00467       {
<a name="l00468"></a>00468 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00469"></a>00469 <span class="preprocessor"></span>
<a name="l00470"></a>00470         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00471"></a>00471 
<a name="l00472"></a>00472         xdr_short(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00473"></a>00473 
<a name="l00474"></a>00474 <span class="preprocessor">#else</span>
<a name="l00475"></a>00475 <span class="preprocessor"></span>        
<a name="l00476"></a>00476         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00477"></a>00477                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00478"></a>00478                   &lt;&lt; std::endl
<a name="l00479"></a>00479                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00480"></a>00480                   &lt;&lt; std::endl;
<a name="l00481"></a>00481 
<a name="l00482"></a>00482         libmesh_error();
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 <span class="preprocessor">#endif</span>
<a name="l00485"></a>00485 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00486"></a>00486       }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00489"></a>00489       {
<a name="l00490"></a>00490         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00491"></a>00491         
<a name="l00492"></a>00492         *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00493"></a>00493 
<a name="l00494"></a>00494         <span class="keywordflow">return</span>;
<a name="l00495"></a>00495       }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00498"></a>00498       {
<a name="l00499"></a>00499         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00500"></a>00500 
<a name="l00501"></a>00501         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00502"></a>00502         
<a name="l00503"></a>00503         <span class="keywordflow">return</span>;
<a name="l00504"></a>00504       }
<a name="l00505"></a>00505 
<a name="l00506"></a>00506     <span class="keywordflow">default</span>:
<a name="l00507"></a>00507       libmesh_error();
<a name="l00508"></a>00508     }
<a name="l00509"></a>00509 }
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 
<a name="l00513"></a><a class="code" href="classXdr.php#a42c24ba2e3b80ed1ac1b75107ec8aa1e">00513</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00514"></a>00514 {
<a name="l00515"></a>00515   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00516"></a>00516     {
<a name="l00517"></a>00517     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00518"></a>00518     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00519"></a>00519       {
<a name="l00520"></a>00520 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00521"></a>00521 <span class="preprocessor"></span>
<a name="l00522"></a>00522         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00523"></a>00523 
<a name="l00524"></a>00524         xdr_u_short(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 <span class="preprocessor">#else</span>
<a name="l00527"></a>00527 <span class="preprocessor"></span>        
<a name="l00528"></a>00528         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00529"></a>00529                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00530"></a>00530                   &lt;&lt; std::endl
<a name="l00531"></a>00531                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00532"></a>00532                   &lt;&lt; std::endl;
<a name="l00533"></a>00533 
<a name="l00534"></a>00534         libmesh_error();
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 <span class="preprocessor">#endif</span>
<a name="l00537"></a>00537 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00538"></a>00538       }
<a name="l00539"></a>00539 
<a name="l00540"></a>00540     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00541"></a>00541       {
<a name="l00542"></a>00542         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00543"></a>00543         
<a name="l00544"></a>00544         *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00545"></a>00545 
<a name="l00546"></a>00546         <span class="keywordflow">return</span>;
<a name="l00547"></a>00547       }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00550"></a>00550       {
<a name="l00551"></a>00551         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00552"></a>00552 
<a name="l00553"></a>00553         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00554"></a>00554         
<a name="l00555"></a>00555         <span class="keywordflow">return</span>;
<a name="l00556"></a>00556       }
<a name="l00557"></a>00557 
<a name="l00558"></a>00558     <span class="keywordflow">default</span>:
<a name="l00559"></a>00559       libmesh_error();
<a name="l00560"></a>00560     }
<a name="l00561"></a>00561 }
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 
<a name="l00564"></a>00564 
<a name="l00565"></a><a class="code" href="classXdr.php#a1a71aba2819becb57f135a1c08d22937">00565</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">float</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00566"></a>00566 {
<a name="l00567"></a>00567   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00568"></a>00568     {
<a name="l00569"></a>00569     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00570"></a>00570     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00571"></a>00571       {
<a name="l00572"></a>00572 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00573"></a>00573 <span class="preprocessor"></span>
<a name="l00574"></a>00574         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00575"></a>00575 
<a name="l00576"></a>00576         xdr_float(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00577"></a>00577 
<a name="l00578"></a>00578 <span class="preprocessor">#else</span>
<a name="l00579"></a>00579 <span class="preprocessor"></span>        
<a name="l00580"></a>00580         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00581"></a>00581                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00582"></a>00582                   &lt;&lt; std::endl
<a name="l00583"></a>00583                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00584"></a>00584                   &lt;&lt; std::endl;
<a name="l00585"></a>00585 
<a name="l00586"></a>00586         libmesh_error();
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 <span class="preprocessor">#endif</span>
<a name="l00589"></a>00589 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00590"></a>00590       }
<a name="l00591"></a>00591 
<a name="l00592"></a>00592     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00593"></a>00593       {
<a name="l00594"></a>00594         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00595"></a>00595         
<a name="l00596"></a>00596         *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00597"></a>00597 
<a name="l00598"></a>00598         <span class="keywordflow">return</span>;
<a name="l00599"></a>00599       }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00602"></a>00602       {
<a name="l00603"></a>00603         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00604"></a>00604 
<a name="l00605"></a>00605         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00606"></a>00606         
<a name="l00607"></a>00607         <span class="keywordflow">return</span>;
<a name="l00608"></a>00608       }
<a name="l00609"></a>00609 
<a name="l00610"></a>00610     <span class="keywordflow">default</span>:
<a name="l00611"></a>00611       libmesh_error();
<a name="l00612"></a>00612     }
<a name="l00613"></a>00613 }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a><a class="code" href="classXdr.php#af6f67518c56aa92c8ac0a20d1ad1a6e6">00617</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (<span class="keywordtype">double</span>&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00618"></a>00618 {
<a name="l00619"></a>00619   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00620"></a>00620     {
<a name="l00621"></a>00621     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00622"></a>00622     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00623"></a>00623       {
<a name="l00624"></a>00624 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00625"></a>00625 <span class="preprocessor"></span>
<a name="l00626"></a>00626         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00627"></a>00627 
<a name="l00628"></a>00628         xdr_double(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;a);
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 <span class="preprocessor">#else</span>
<a name="l00631"></a>00631 <span class="preprocessor"></span>        
<a name="l00632"></a>00632         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00633"></a>00633                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00634"></a>00634                   &lt;&lt; std::endl
<a name="l00635"></a>00635                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00636"></a>00636                   &lt;&lt; std::endl;
<a name="l00637"></a>00637 
<a name="l00638"></a>00638         libmesh_error();
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 <span class="preprocessor">#endif</span>
<a name="l00641"></a>00641 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00642"></a>00642       }
<a name="l00643"></a>00643 
<a name="l00644"></a>00644     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00645"></a>00645       {
<a name="l00646"></a>00646         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00647"></a>00647         
<a name="l00648"></a>00648         *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; a; <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00649"></a>00649 
<a name="l00650"></a>00650         <span class="keywordflow">return</span>;
<a name="l00651"></a>00651       }
<a name="l00652"></a>00652 
<a name="l00653"></a>00653     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00654"></a>00654       {
<a name="l00655"></a>00655         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00656"></a>00656 
<a name="l00657"></a>00657         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00658"></a>00658         
<a name="l00659"></a>00659         <span class="keywordflow">return</span>;
<a name="l00660"></a>00660       }
<a name="l00661"></a>00661 
<a name="l00662"></a>00662     <span class="keywordflow">default</span>:
<a name="l00663"></a>00663       libmesh_error();
<a name="l00664"></a>00664     }
<a name="l00665"></a>00665 }
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00670"></a>00670 <span class="preprocessor"></span>
<a name="l00671"></a><a class="code" href="classXdr.php#a3db4953f7f8c6ae7449f3950656b3f05">00671</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::complex&lt;double&gt;&amp; a, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00672"></a>00672 {
<a name="l00673"></a>00673   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00674"></a>00674     {
<a name="l00675"></a>00675     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00676"></a>00676     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00677"></a>00677       {
<a name="l00678"></a>00678 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00679"></a>00679 <span class="preprocessor"></span>
<a name="l00680"></a>00680         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00681"></a>00681         <span class="keywordtype">double</span>
<a name="l00682"></a>00682           _r=a.real(),
<a name="l00683"></a>00683           _i=a.imag();
<a name="l00684"></a>00684         xdr_double(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;_r);
<a name="l00685"></a>00685         xdr_double(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, &amp;_i);
<a name="l00686"></a>00686         a = std::complex&lt;double&gt;(_r,_i);
<a name="l00687"></a>00687 
<a name="l00688"></a>00688 <span class="preprocessor">#else</span>
<a name="l00689"></a>00689 <span class="preprocessor"></span>        
<a name="l00690"></a>00690         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00691"></a>00691                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00692"></a>00692                   &lt;&lt; std::endl
<a name="l00693"></a>00693                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00694"></a>00694                   &lt;&lt; std::endl;
<a name="l00695"></a>00695 
<a name="l00696"></a>00696         libmesh_error();
<a name="l00697"></a>00697 
<a name="l00698"></a>00698 <span class="preprocessor">#endif</span>
<a name="l00699"></a>00699 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00700"></a>00700       }
<a name="l00701"></a>00701 
<a name="l00702"></a>00702     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00703"></a>00703       {
<a name="l00704"></a>00704         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00705"></a>00705         
<a name="l00706"></a>00706         <span class="keywordtype">double</span> _r, _i;
<a name="l00707"></a>00707         *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; _r;
<a name="l00708"></a>00708         *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; _i;
<a name="l00709"></a>00709         a = std::complex&lt;double&gt;(_r,_i);
<a name="l00710"></a>00710         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00711"></a>00711 
<a name="l00712"></a>00712         <span class="keywordflow">return</span>;
<a name="l00713"></a>00713       }
<a name="l00714"></a>00714 
<a name="l00715"></a>00715     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00716"></a>00716       {
<a name="l00717"></a>00717         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00718"></a>00718 
<a name="l00719"></a>00719         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; a.real() &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> 
<a name="l00720"></a>00720             &lt;&lt; a.imag() &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span>
<a name="l00721"></a>00721             &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00722"></a>00722         
<a name="l00723"></a>00723         <span class="keywordflow">return</span>;
<a name="l00724"></a>00724       }
<a name="l00725"></a>00725 
<a name="l00726"></a>00726     <span class="keywordflow">default</span>:
<a name="l00727"></a>00727       libmesh_error();
<a name="l00728"></a>00728     }
<a name="l00729"></a>00729 }
<a name="l00730"></a>00730 
<a name="l00731"></a>00731 <span class="preprocessor">#endif // LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00732"></a>00732 <span class="preprocessor"></span>
<a name="l00733"></a>00733 
<a name="l00734"></a>00734 
<a name="l00735"></a><a class="code" href="classXdr.php#a411577b0d5e8d933915bafad884f3706">00735</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00736"></a>00736 {
<a name="l00737"></a>00737   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00738"></a>00738     {
<a name="l00739"></a>00739     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00740"></a>00740       {
<a name="l00741"></a>00741 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00742"></a>00742 <span class="preprocessor"></span>
<a name="l00743"></a>00743         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00744"></a>00744 
<a name="l00745"></a>00745         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l00746"></a>00746 
<a name="l00747"></a>00747         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00748"></a>00748 
<a name="l00749"></a>00749         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00750"></a>00750                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00751"></a>00751                    length,
<a name="l00752"></a>00752                    <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),
<a name="l00753"></a>00753                    (xdrproc_t) xdr_int);
<a name="l00754"></a>00754         
<a name="l00755"></a>00755 <span class="preprocessor">#else</span>
<a name="l00756"></a>00756 <span class="preprocessor"></span>        
<a name="l00757"></a>00757         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00758"></a>00758                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00759"></a>00759                   &lt;&lt; std::endl
<a name="l00760"></a>00760                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00761"></a>00761                   &lt;&lt; std::endl;
<a name="l00762"></a>00762 
<a name="l00763"></a>00763         libmesh_error();
<a name="l00764"></a>00764 
<a name="l00765"></a>00765 <span class="preprocessor">#endif</span>
<a name="l00766"></a>00766 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00767"></a>00767       }
<a name="l00768"></a>00768 
<a name="l00769"></a>00769     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00770"></a>00770       {
<a name="l00771"></a>00771 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00772"></a>00772 <span class="preprocessor"></span>
<a name="l00773"></a>00773         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00774"></a>00774 
<a name="l00775"></a>00775         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00776"></a>00776 
<a name="l00777"></a>00777         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00778"></a>00778 
<a name="l00779"></a>00779         v.resize(length);
<a name="l00780"></a>00780 
<a name="l00781"></a>00781         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00782"></a>00782                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00783"></a>00783                    length,
<a name="l00784"></a>00784                    <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),
<a name="l00785"></a>00785                    (xdrproc_t) xdr_int);
<a name="l00786"></a>00786         
<a name="l00787"></a>00787 <span class="preprocessor">#else</span>
<a name="l00788"></a>00788 <span class="preprocessor"></span>        
<a name="l00789"></a>00789         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00790"></a>00790                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00791"></a>00791                   &lt;&lt; std::endl
<a name="l00792"></a>00792                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00793"></a>00793                   &lt;&lt; std::endl;
<a name="l00794"></a>00794 
<a name="l00795"></a>00795         libmesh_error();
<a name="l00796"></a>00796 
<a name="l00797"></a>00797 <span class="preprocessor">#endif</span>
<a name="l00798"></a>00798 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00799"></a>00799       }
<a name="l00800"></a>00800 
<a name="l00801"></a>00801     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00802"></a>00802       {
<a name="l00803"></a>00803         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00804"></a>00804 
<a name="l00805"></a>00805         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00806"></a>00806 
<a name="l00807"></a>00807         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00808"></a>00808 
<a name="l00809"></a>00809         v.resize(length);
<a name="l00810"></a>00810 
<a name="l00811"></a>00811         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00812"></a>00812           {
<a name="l00813"></a>00813             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00814"></a>00814             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l00815"></a>00815           }
<a name="l00816"></a>00816 
<a name="l00817"></a>00817         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00818"></a>00818 
<a name="l00819"></a>00819         <span class="keywordflow">return</span>; 
<a name="l00820"></a>00820       }
<a name="l00821"></a>00821 
<a name="l00822"></a>00822     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00823"></a>00823       {
<a name="l00824"></a>00824         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00825"></a>00825 
<a name="l00826"></a>00826         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l00827"></a>00827 
<a name="l00828"></a>00828         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00829"></a>00829 
<a name="l00830"></a>00830         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00831"></a>00831           {
<a name="l00832"></a>00832             libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00833"></a>00833             *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; v[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00834"></a>00834           }
<a name="l00835"></a>00835 
<a name="l00836"></a>00836         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00837"></a>00837 
<a name="l00838"></a>00838         <span class="keywordflow">return</span>; 
<a name="l00839"></a>00839       }
<a name="l00840"></a>00840 
<a name="l00841"></a>00841     <span class="keywordflow">default</span>:
<a name="l00842"></a>00842       libmesh_error();
<a name="l00843"></a>00843     }
<a name="l00844"></a>00844 }
<a name="l00845"></a>00845 
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 
<a name="l00848"></a><a class="code" href="classXdr.php#a44a44a7a7b4fa4fafbed8562159402a4">00848</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;unsigned int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00849"></a>00849 {
<a name="l00850"></a>00850   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00851"></a>00851     {
<a name="l00852"></a>00852     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00853"></a>00853       {
<a name="l00854"></a>00854 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00855"></a>00855 <span class="preprocessor"></span>
<a name="l00856"></a>00856         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00857"></a>00857 
<a name="l00858"></a>00858         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l00859"></a>00859 
<a name="l00860"></a>00860         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00861"></a>00861 
<a name="l00862"></a>00862         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00863"></a>00863                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00864"></a>00864                    length,
<a name="l00865"></a>00865                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l00866"></a>00866                    (xdrproc_t) xdr_u_int);
<a name="l00867"></a>00867         
<a name="l00868"></a>00868 <span class="preprocessor">#else</span>
<a name="l00869"></a>00869 <span class="preprocessor"></span>        
<a name="l00870"></a>00870         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00871"></a>00871                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00872"></a>00872                   &lt;&lt; std::endl
<a name="l00873"></a>00873                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00874"></a>00874                   &lt;&lt; std::endl;
<a name="l00875"></a>00875 
<a name="l00876"></a>00876         libmesh_error();
<a name="l00877"></a>00877 
<a name="l00878"></a>00878 <span class="preprocessor">#endif</span>
<a name="l00879"></a>00879 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00880"></a>00880       }
<a name="l00881"></a>00881 
<a name="l00882"></a>00882     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00883"></a>00883       {
<a name="l00884"></a>00884 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00885"></a>00885 <span class="preprocessor"></span>
<a name="l00886"></a>00886         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00887"></a>00887 
<a name="l00888"></a>00888         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00889"></a>00889 
<a name="l00890"></a>00890         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00891"></a>00891 
<a name="l00892"></a>00892         v.resize(length);
<a name="l00893"></a>00893 
<a name="l00894"></a>00894         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00895"></a>00895                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00896"></a>00896                    length,
<a name="l00897"></a>00897                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l00898"></a>00898                    (xdrproc_t) xdr_u_int);
<a name="l00899"></a>00899 
<a name="l00900"></a>00900 <span class="preprocessor">#else</span>
<a name="l00901"></a>00901 <span class="preprocessor"></span>        
<a name="l00902"></a>00902         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00903"></a>00903                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00904"></a>00904                   &lt;&lt; std::endl
<a name="l00905"></a>00905                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00906"></a>00906                   &lt;&lt; std::endl;
<a name="l00907"></a>00907 
<a name="l00908"></a>00908         libmesh_error();
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 <span class="preprocessor">#endif  </span>
<a name="l00911"></a>00911 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00912"></a>00912       }
<a name="l00913"></a>00913 
<a name="l00914"></a>00914     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l00915"></a>00915       {
<a name="l00916"></a>00916         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00917"></a>00917 
<a name="l00918"></a>00918         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l00919"></a>00919 
<a name="l00920"></a>00920         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00921"></a>00921 
<a name="l00922"></a>00922         v.resize(length);
<a name="l00923"></a>00923 
<a name="l00924"></a>00924         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00925"></a>00925           {
<a name="l00926"></a>00926             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l00927"></a>00927             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l00928"></a>00928           }
<a name="l00929"></a>00929 
<a name="l00930"></a>00930         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l00931"></a>00931 
<a name="l00932"></a>00932         <span class="keywordflow">return</span>; 
<a name="l00933"></a>00933       }
<a name="l00934"></a>00934 
<a name="l00935"></a>00935     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l00936"></a>00936       {
<a name="l00937"></a>00937         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00938"></a>00938 
<a name="l00939"></a>00939         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l00940"></a>00940 
<a name="l00941"></a>00941         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00942"></a>00942 
<a name="l00943"></a>00943         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00944"></a>00944           {
<a name="l00945"></a>00945             libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l00946"></a>00946             *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; v[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00947"></a>00947           }
<a name="l00948"></a>00948 
<a name="l00949"></a>00949         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00950"></a>00950 
<a name="l00951"></a>00951         <span class="keywordflow">return</span>; 
<a name="l00952"></a>00952       }
<a name="l00953"></a>00953 
<a name="l00954"></a>00954     <span class="keywordflow">default</span>:
<a name="l00955"></a>00955       libmesh_error();
<a name="l00956"></a>00956     }
<a name="l00957"></a>00957 }
<a name="l00958"></a>00958 
<a name="l00959"></a>00959 
<a name="l00960"></a>00960 
<a name="l00961"></a><a class="code" href="classXdr.php#adf4a82ad9f6466191100998f6b167c07">00961</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;short int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l00962"></a>00962 {
<a name="l00963"></a>00963   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l00964"></a>00964     {
<a name="l00965"></a>00965     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l00966"></a>00966       {
<a name="l00967"></a>00967 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00968"></a>00968 <span class="preprocessor"></span>
<a name="l00969"></a>00969         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l00970"></a>00970 
<a name="l00971"></a>00971         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l00972"></a>00972 
<a name="l00973"></a>00973         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l00974"></a>00974 
<a name="l00975"></a>00975         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l00976"></a>00976                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l00977"></a>00977                    length,
<a name="l00978"></a>00978                    <span class="keyword">sizeof</span>(<span class="keywordtype">short</span> <span class="keywordtype">int</span>),
<a name="l00979"></a>00979                    (xdrproc_t) xdr_short);
<a name="l00980"></a>00980         
<a name="l00981"></a>00981 <span class="preprocessor">#else</span>
<a name="l00982"></a>00982 <span class="preprocessor"></span>        
<a name="l00983"></a>00983         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l00984"></a>00984                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l00985"></a>00985                   &lt;&lt; std::endl
<a name="l00986"></a>00986                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l00987"></a>00987                   &lt;&lt; std::endl;
<a name="l00988"></a>00988 
<a name="l00989"></a>00989         libmesh_error();
<a name="l00990"></a>00990 
<a name="l00991"></a>00991 <span class="preprocessor">#endif</span>
<a name="l00992"></a>00992 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l00993"></a>00993       }
<a name="l00994"></a>00994 
<a name="l00995"></a>00995     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l00996"></a>00996       {
<a name="l00997"></a>00997 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l00998"></a>00998 <span class="preprocessor"></span>
<a name="l00999"></a>00999         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01000"></a>01000 
<a name="l01001"></a>01001         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01002"></a>01002 
<a name="l01003"></a>01003         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01004"></a>01004 
<a name="l01005"></a>01005         v.resize(length);
<a name="l01006"></a>01006 
<a name="l01007"></a>01007         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01008"></a>01008                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01009"></a>01009                    length,
<a name="l01010"></a>01010                    <span class="keyword">sizeof</span>(<span class="keywordtype">short</span> <span class="keywordtype">int</span>),
<a name="l01011"></a>01011                    (xdrproc_t) xdr_short);
<a name="l01012"></a>01012         
<a name="l01013"></a>01013 <span class="preprocessor">#else</span>
<a name="l01014"></a>01014 <span class="preprocessor"></span>        
<a name="l01015"></a>01015         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01016"></a>01016                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01017"></a>01017                   &lt;&lt; std::endl
<a name="l01018"></a>01018                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01019"></a>01019                   &lt;&lt; std::endl;
<a name="l01020"></a>01020 
<a name="l01021"></a>01021         libmesh_error();
<a name="l01022"></a>01022 
<a name="l01023"></a>01023 <span class="preprocessor">#endif</span>
<a name="l01024"></a>01024 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01025"></a>01025       }
<a name="l01026"></a>01026 
<a name="l01027"></a>01027     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01028"></a>01028       {
<a name="l01029"></a>01029         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01030"></a>01030 
<a name="l01031"></a>01031         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01032"></a>01032 
<a name="l01033"></a>01033         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01034"></a>01034 
<a name="l01035"></a>01035         v.resize(length);
<a name="l01036"></a>01036 
<a name="l01037"></a>01037         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01038"></a>01038           {
<a name="l01039"></a>01039             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01040"></a>01040             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l01041"></a>01041           }
<a name="l01042"></a>01042 
<a name="l01043"></a>01043         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01044"></a>01044 
<a name="l01045"></a>01045         <span class="keywordflow">return</span>; 
<a name="l01046"></a>01046       }
<a name="l01047"></a>01047 
<a name="l01048"></a>01048     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01049"></a>01049       {
<a name="l01050"></a>01050         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01051"></a>01051 
<a name="l01052"></a>01052         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01053"></a>01053 
<a name="l01054"></a>01054         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01055"></a>01055 
<a name="l01056"></a>01056         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01057"></a>01057           {
<a name="l01058"></a>01058             libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01059"></a>01059             *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; v[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01060"></a>01060           }
<a name="l01061"></a>01061 
<a name="l01062"></a>01062         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01063"></a>01063 
<a name="l01064"></a>01064         <span class="keywordflow">return</span>; 
<a name="l01065"></a>01065       }
<a name="l01066"></a>01066 
<a name="l01067"></a>01067     <span class="keywordflow">default</span>:
<a name="l01068"></a>01068       libmesh_error();
<a name="l01069"></a>01069     }
<a name="l01070"></a>01070 }
<a name="l01071"></a>01071 
<a name="l01072"></a>01072 
<a name="l01073"></a>01073 
<a name="l01074"></a><a class="code" href="classXdr.php#a0d8d605affccd26241ed6c205c394eb2">01074</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;unsigned short int&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01075"></a>01075 {
<a name="l01076"></a>01076   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01077"></a>01077     {
<a name="l01078"></a>01078     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01079"></a>01079       {
<a name="l01080"></a>01080 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01081"></a>01081 <span class="preprocessor"></span>
<a name="l01082"></a>01082         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01083"></a>01083 
<a name="l01084"></a>01084         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l01085"></a>01085 
<a name="l01086"></a>01086         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01087"></a>01087 
<a name="l01088"></a>01088         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01089"></a>01089                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01090"></a>01090                    length,
<a name="l01091"></a>01091                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>),
<a name="l01092"></a>01092                    (xdrproc_t) xdr_u_short);
<a name="l01093"></a>01093 
<a name="l01094"></a>01094 <span class="preprocessor">#else</span>
<a name="l01095"></a>01095 <span class="preprocessor"></span>        
<a name="l01096"></a>01096         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01097"></a>01097                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01098"></a>01098                   &lt;&lt; std::endl
<a name="l01099"></a>01099                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01100"></a>01100                   &lt;&lt; std::endl;
<a name="l01101"></a>01101 
<a name="l01102"></a>01102         libmesh_error();
<a name="l01103"></a>01103 
<a name="l01104"></a>01104 <span class="preprocessor">#endif  </span>
<a name="l01105"></a>01105 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01106"></a>01106       }
<a name="l01107"></a>01107 
<a name="l01108"></a>01108     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01109"></a>01109       {
<a name="l01110"></a>01110 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01111"></a>01111 <span class="preprocessor"></span>
<a name="l01112"></a>01112         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01113"></a>01113 
<a name="l01114"></a>01114         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01115"></a>01115 
<a name="l01116"></a>01116         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01117"></a>01117 
<a name="l01118"></a>01118         v.resize(length);
<a name="l01119"></a>01119 
<a name="l01120"></a>01120         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01121"></a>01121                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01122"></a>01122                    length,
<a name="l01123"></a>01123                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span>),
<a name="l01124"></a>01124                    (xdrproc_t) xdr_u_short);
<a name="l01125"></a>01125         
<a name="l01126"></a>01126 <span class="preprocessor">#else</span>
<a name="l01127"></a>01127 <span class="preprocessor"></span>        
<a name="l01128"></a>01128         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01129"></a>01129                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01130"></a>01130                   &lt;&lt; std::endl
<a name="l01131"></a>01131                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01132"></a>01132                   &lt;&lt; std::endl;
<a name="l01133"></a>01133 
<a name="l01134"></a>01134         libmesh_error();
<a name="l01135"></a>01135 
<a name="l01136"></a>01136 <span class="preprocessor">#endif</span>
<a name="l01137"></a>01137 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01138"></a>01138       }
<a name="l01139"></a>01139 
<a name="l01140"></a>01140     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01141"></a>01141       {
<a name="l01142"></a>01142         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01143"></a>01143 
<a name="l01144"></a>01144         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01145"></a>01145 
<a name="l01146"></a>01146         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01147"></a>01147 
<a name="l01148"></a>01148         v.resize(length);
<a name="l01149"></a>01149 
<a name="l01150"></a>01150         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01151"></a>01151           {
<a name="l01152"></a>01152             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01153"></a>01153             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l01154"></a>01154           }
<a name="l01155"></a>01155 
<a name="l01156"></a>01156         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01157"></a>01157 
<a name="l01158"></a>01158         <span class="keywordflow">return</span>; 
<a name="l01159"></a>01159       }
<a name="l01160"></a>01160 
<a name="l01161"></a>01161     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01162"></a>01162       {
<a name="l01163"></a>01163         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01164"></a>01164 
<a name="l01165"></a>01165         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01166"></a>01166 
<a name="l01167"></a>01167         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01168"></a>01168 
<a name="l01169"></a>01169         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01170"></a>01170           {
<a name="l01171"></a>01171             libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01172"></a>01172             *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; v[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01173"></a>01173           }
<a name="l01174"></a>01174 
<a name="l01175"></a>01175         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01176"></a>01176 
<a name="l01177"></a>01177         <span class="keywordflow">return</span>; 
<a name="l01178"></a>01178       }
<a name="l01179"></a>01179 
<a name="l01180"></a>01180     <span class="keywordflow">default</span>:
<a name="l01181"></a>01181       libmesh_error();
<a name="l01182"></a>01182     }
<a name="l01183"></a>01183 }
<a name="l01184"></a>01184 
<a name="l01185"></a>01185 
<a name="l01186"></a>01186 
<a name="l01187"></a><a class="code" href="classXdr.php#a6cb845dacc1a50fbf143a680d3793059">01187</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;float&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01188"></a>01188 {
<a name="l01189"></a>01189   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01190"></a>01190     {
<a name="l01191"></a>01191     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01192"></a>01192       {
<a name="l01193"></a>01193 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01194"></a>01194 <span class="preprocessor"></span>
<a name="l01195"></a>01195         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01196"></a>01196 
<a name="l01197"></a>01197         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l01198"></a>01198 
<a name="l01199"></a>01199         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01200"></a>01200 
<a name="l01201"></a>01201         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01202"></a>01202                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01203"></a>01203                    length,
<a name="l01204"></a>01204                    <span class="keyword">sizeof</span>(<span class="keywordtype">float</span>),
<a name="l01205"></a>01205                    (xdrproc_t) xdr_float);
<a name="l01206"></a>01206 
<a name="l01207"></a>01207 <span class="preprocessor">#else</span>
<a name="l01208"></a>01208 <span class="preprocessor"></span>        
<a name="l01209"></a>01209         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01210"></a>01210                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01211"></a>01211                   &lt;&lt; std::endl
<a name="l01212"></a>01212                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01213"></a>01213                   &lt;&lt; std::endl;
<a name="l01214"></a>01214 
<a name="l01215"></a>01215         libmesh_error();
<a name="l01216"></a>01216 
<a name="l01217"></a>01217 <span class="preprocessor">#endif  </span>
<a name="l01218"></a>01218 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01219"></a>01219       }
<a name="l01220"></a>01220 
<a name="l01221"></a>01221     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01222"></a>01222       {
<a name="l01223"></a>01223 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01224"></a>01224 <span class="preprocessor"></span>
<a name="l01225"></a>01225         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01226"></a>01226 
<a name="l01227"></a>01227         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01228"></a>01228 
<a name="l01229"></a>01229         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01230"></a>01230 
<a name="l01231"></a>01231         v.resize(length);
<a name="l01232"></a>01232 
<a name="l01233"></a>01233         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01234"></a>01234                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01235"></a>01235                    length,
<a name="l01236"></a>01236                    <span class="keyword">sizeof</span>(<span class="keywordtype">float</span>),
<a name="l01237"></a>01237                    (xdrproc_t) xdr_float);
<a name="l01238"></a>01238         
<a name="l01239"></a>01239 <span class="preprocessor">#else</span>
<a name="l01240"></a>01240 <span class="preprocessor"></span>        
<a name="l01241"></a>01241         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01242"></a>01242                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01243"></a>01243                   &lt;&lt; std::endl
<a name="l01244"></a>01244                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01245"></a>01245                   &lt;&lt; std::endl;
<a name="l01246"></a>01246 
<a name="l01247"></a>01247         libmesh_error();
<a name="l01248"></a>01248 
<a name="l01249"></a>01249 <span class="preprocessor">#endif</span>
<a name="l01250"></a>01250 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01251"></a>01251       }
<a name="l01252"></a>01252 
<a name="l01253"></a>01253     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01254"></a>01254       {
<a name="l01255"></a>01255         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01256"></a>01256 
<a name="l01257"></a>01257         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01258"></a>01258 
<a name="l01259"></a>01259         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01260"></a>01260 
<a name="l01261"></a>01261         v.resize(length);
<a name="l01262"></a>01262 
<a name="l01263"></a>01263         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01264"></a>01264           {
<a name="l01265"></a>01265             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01266"></a>01266             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l01267"></a>01267           }
<a name="l01268"></a>01268 
<a name="l01269"></a>01269         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01270"></a>01270 
<a name="l01271"></a>01271         <span class="keywordflow">return</span>; 
<a name="l01272"></a>01272       }
<a name="l01273"></a>01273 
<a name="l01274"></a>01274     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01275"></a>01275       {
<a name="l01276"></a>01276         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01277"></a>01277 
<a name="l01278"></a>01278         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01279"></a>01279 
<a name="l01280"></a>01280         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01281"></a>01281 
<a name="l01282"></a>01282         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01283"></a>01283           {
<a name="l01284"></a>01284             libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01285"></a>01285             OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,v[i]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01286"></a>01286           }
<a name="l01287"></a>01287 
<a name="l01288"></a>01288         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01289"></a>01289 
<a name="l01290"></a>01290         <span class="keywordflow">return</span>; 
<a name="l01291"></a>01291       }
<a name="l01292"></a>01292 
<a name="l01293"></a>01293     <span class="keywordflow">default</span>:
<a name="l01294"></a>01294       libmesh_error();
<a name="l01295"></a>01295     }
<a name="l01296"></a>01296 }
<a name="l01297"></a>01297 
<a name="l01298"></a>01298 
<a name="l01299"></a>01299 
<a name="l01300"></a><a class="code" href="classXdr.php#a42a903194a8ebc00b6f98bd93674bf83">01300</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt;double&gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01301"></a>01301 {
<a name="l01302"></a>01302   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01303"></a>01303     {
<a name="l01304"></a>01304     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01305"></a>01305       {
<a name="l01306"></a>01306 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01307"></a>01307 <span class="preprocessor"></span>
<a name="l01308"></a>01308         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01309"></a>01309 
<a name="l01310"></a>01310         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l01311"></a>01311 
<a name="l01312"></a>01312         this-&gt;<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01313"></a>01313 
<a name="l01314"></a>01314         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01315"></a>01315                    (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01316"></a>01316                    length,
<a name="l01317"></a>01317                    <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l01318"></a>01318                    (xdrproc_t) xdr_double);
<a name="l01319"></a>01319 
<a name="l01320"></a>01320 <span class="preprocessor">#else</span>
<a name="l01321"></a>01321 <span class="preprocessor"></span>        
<a name="l01322"></a>01322         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01323"></a>01323                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01324"></a>01324                   &lt;&lt; std::endl
<a name="l01325"></a>01325                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01326"></a>01326                   &lt;&lt; std::endl;
<a name="l01327"></a>01327 
<a name="l01328"></a>01328         libmesh_error();
<a name="l01329"></a>01329 
<a name="l01330"></a>01330 <span class="preprocessor">#endif  </span>
<a name="l01331"></a>01331 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01332"></a>01332       }
<a name="l01333"></a>01333 
<a name="l01334"></a>01334     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01335"></a>01335       {
<a name="l01336"></a>01336 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01337"></a>01337 <span class="preprocessor"></span>
<a name="l01338"></a>01338         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01339"></a>01339 
<a name="l01340"></a>01340         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01341"></a>01341 
<a name="l01342"></a>01342         this-&gt;<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01343"></a>01343 
<a name="l01344"></a>01344         v.resize(length);
<a name="l01345"></a>01345 
<a name="l01346"></a>01346         <span class="comment">// Note: GCC 3.4.1 will crash in debug mode here if length</span>
<a name="l01347"></a>01347         <span class="comment">// is zero and you attempt to access the zeroth index of v.</span>
<a name="l01348"></a>01348         <span class="keywordflow">if</span> (length &gt; 0)
<a name="l01349"></a>01349           xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01350"></a>01350                      (<span class="keywordtype">char</span>*) &amp;v[0],
<a name="l01351"></a>01351                      length,
<a name="l01352"></a>01352                      <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l01353"></a>01353                      (xdrproc_t) xdr_double);
<a name="l01354"></a>01354         
<a name="l01355"></a>01355 <span class="preprocessor">#else</span>
<a name="l01356"></a>01356 <span class="preprocessor"></span>        
<a name="l01357"></a>01357         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01358"></a>01358                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01359"></a>01359                   &lt;&lt; std::endl
<a name="l01360"></a>01360                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01361"></a>01361                   &lt;&lt; std::endl;
<a name="l01362"></a>01362 
<a name="l01363"></a>01363         libmesh_error();
<a name="l01364"></a>01364 
<a name="l01365"></a>01365 <span class="preprocessor">#endif</span>
<a name="l01366"></a>01366 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01367"></a>01367       }
<a name="l01368"></a>01368 
<a name="l01369"></a>01369     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01370"></a>01370       {
<a name="l01371"></a>01371         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01372"></a>01372 
<a name="l01373"></a>01373         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01374"></a>01374 
<a name="l01375"></a>01375         this-&gt;<a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01376"></a>01376         
<a name="l01377"></a>01377         <span class="comment">// If you were expecting to read in a vector at this</span>
<a name="l01378"></a>01378         <span class="comment">// point, it&#39;s not going to happen if length == 0!</span>
<a name="l01379"></a>01379         <span class="comment">// libmesh_assert (length != 0);</span>
<a name="l01380"></a>01380         
<a name="l01381"></a>01381         v.resize(length);
<a name="l01382"></a>01382 
<a name="l01383"></a>01383         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01384"></a>01384           {
<a name="l01385"></a>01385             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01386"></a>01386             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; v[i];
<a name="l01387"></a>01387           }
<a name="l01388"></a>01388 
<a name="l01389"></a>01389         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01390"></a>01390 
<a name="l01391"></a>01391         <span class="keywordflow">return</span>; 
<a name="l01392"></a>01392       }
<a name="l01393"></a>01393 
<a name="l01394"></a>01394     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01395"></a>01395       {
<a name="l01396"></a>01396         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01397"></a>01397 
<a name="l01398"></a>01398         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01399"></a>01399 
<a name="l01400"></a>01400         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length&quot;</span>);
<a name="l01401"></a>01401 
<a name="l01402"></a>01402         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01403"></a>01403           {
<a name="l01404"></a>01404             libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01405"></a>01405             OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,v[i]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01406"></a>01406           }
<a name="l01407"></a>01407 
<a name="l01408"></a>01408 
<a name="l01409"></a>01409 
<a name="l01410"></a>01410         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01411"></a>01411 
<a name="l01412"></a>01412         <span class="keywordflow">return</span>; 
<a name="l01413"></a>01413       }
<a name="l01414"></a>01414 
<a name="l01415"></a>01415     <span class="keywordflow">default</span>:
<a name="l01416"></a>01416       libmesh_error();
<a name="l01417"></a>01417     }
<a name="l01418"></a>01418 }
<a name="l01419"></a>01419 
<a name="l01420"></a>01420 
<a name="l01421"></a>01421 
<a name="l01422"></a>01422 
<a name="l01423"></a>01423 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l01424"></a>01424 <span class="preprocessor"></span>
<a name="l01425"></a><a class="code" href="classXdr.php#a50c7427e5e7a0d2602a1c3a516b51571">01425</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::vector&lt; std::complex&lt;double&gt; &gt;&amp; v, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01426"></a>01426 {
<a name="l01427"></a>01427   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01428"></a>01428     {
<a name="l01429"></a>01429     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01430"></a>01430       {
<a name="l01431"></a>01431 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01432"></a>01432 <span class="preprocessor"></span>
<a name="l01433"></a>01433         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01434"></a>01434 
<a name="l01435"></a>01435         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length = v.size();
<a name="l01436"></a>01436 
<a name="l01437"></a>01437         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length x 2 (complex)&quot;</span>);
<a name="l01438"></a>01438 
<a name="l01439"></a>01439         std::vector&lt; std::complex&lt;double&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> iter = v.begin();
<a name="l01440"></a>01440         
<a name="l01441"></a>01441         <span class="keywordflow">for</span> (; iter != v.end(); ++iter)
<a name="l01442"></a>01442             <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(*iter, <span class="stringliteral">&quot;&quot;</span>);
<a name="l01443"></a>01443 
<a name="l01444"></a>01444 <span class="preprocessor">#else</span>
<a name="l01445"></a>01445 <span class="preprocessor"></span>        
<a name="l01446"></a>01446         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01447"></a>01447                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01448"></a>01448                   &lt;&lt; std::endl
<a name="l01449"></a>01449                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01450"></a>01450                   &lt;&lt; std::endl;
<a name="l01451"></a>01451 
<a name="l01452"></a>01452         libmesh_error();
<a name="l01453"></a>01453 
<a name="l01454"></a>01454 <span class="preprocessor">#endif  </span>
<a name="l01455"></a>01455 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01456"></a>01456       }
<a name="l01457"></a>01457 
<a name="l01458"></a>01458     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01459"></a>01459       {
<a name="l01460"></a>01460 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01461"></a>01461 <span class="preprocessor"></span>
<a name="l01462"></a>01462         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01463"></a>01463 
<a name="l01464"></a>01464         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01465"></a>01465 
<a name="l01466"></a>01466         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length x 2 (complex)&quot;</span>);
<a name="l01467"></a>01467 
<a name="l01468"></a>01468         v.resize(length);
<a name="l01469"></a>01469 
<a name="l01470"></a>01470         std::vector&lt; std::complex&lt;double&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> iter = v.begin();
<a name="l01471"></a>01471         
<a name="l01472"></a>01472         <span class="keywordflow">for</span> (; iter != v.end(); ++iter)
<a name="l01473"></a>01473             <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(*iter, <span class="stringliteral">&quot;&quot;</span>);
<a name="l01474"></a>01474         
<a name="l01475"></a>01475 <span class="preprocessor">#else</span>
<a name="l01476"></a>01476 <span class="preprocessor"></span>        
<a name="l01477"></a>01477         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01478"></a>01478                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01479"></a>01479                   &lt;&lt; std::endl
<a name="l01480"></a>01480                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01481"></a>01481                   &lt;&lt; std::endl;
<a name="l01482"></a>01482 
<a name="l01483"></a>01483         libmesh_error();
<a name="l01484"></a>01484 
<a name="l01485"></a>01485 <span class="preprocessor">#endif</span>
<a name="l01486"></a>01486 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01487"></a>01487       }
<a name="l01488"></a>01488 
<a name="l01489"></a>01489     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01490"></a>01490       {
<a name="l01491"></a>01491         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01492"></a>01492 
<a name="l01493"></a>01493         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=0;
<a name="l01494"></a>01494 
<a name="l01495"></a>01495         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length x 2 (complex)&quot;</span>);
<a name="l01496"></a>01496 
<a name="l01497"></a>01497         v.resize(length);
<a name="l01498"></a>01498 
<a name="l01499"></a>01499         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01500"></a>01500           {
<a name="l01501"></a>01501             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01502"></a>01502         
<a name="l01503"></a>01503             <span class="keywordtype">double</span> _r, _i;
<a name="l01504"></a>01504             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; _r;
<a name="l01505"></a>01505             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; _i;
<a name="l01506"></a>01506             v[i] = std::complex&lt;double&gt;(_r,_i);
<a name="l01507"></a>01507           }
<a name="l01508"></a>01508 
<a name="l01509"></a>01509         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01510"></a>01510 
<a name="l01511"></a>01511         <span class="keywordflow">return</span>; 
<a name="l01512"></a>01512       }
<a name="l01513"></a>01513 
<a name="l01514"></a>01514     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01515"></a>01515       {
<a name="l01516"></a>01516         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01517"></a>01517 
<a name="l01518"></a>01518         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> length=v.size();
<a name="l01519"></a>01519 
<a name="l01520"></a>01520         <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">data</a>(length, <span class="stringliteral">&quot;# vector length x 2 (complex)&quot;</span>);
<a name="l01521"></a>01521 
<a name="l01522"></a>01522         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l01523"></a>01523           {
<a name="l01524"></a>01524             libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01525"></a>01525             OFSNumberscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,v[i]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01526"></a>01526           }
<a name="l01527"></a>01527 
<a name="l01528"></a>01528         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01529"></a>01529 
<a name="l01530"></a>01530         <span class="keywordflow">return</span>; 
<a name="l01531"></a>01531       }
<a name="l01532"></a>01532 
<a name="l01533"></a>01533     <span class="keywordflow">default</span>:
<a name="l01534"></a>01534       libmesh_error();
<a name="l01535"></a>01535     }
<a name="l01536"></a>01536 }
<a name="l01537"></a>01537 
<a name="l01538"></a>01538 <span class="preprocessor">#endif // ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l01539"></a>01539 <span class="preprocessor"></span>
<a name="l01540"></a>01540 
<a name="l01541"></a>01541 
<a name="l01542"></a>01542 
<a name="l01543"></a><a class="code" href="classXdr.php#a9a6a8d9c8cd4bee0fe801f3a7ef048a6">01543</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a1912b48ddb491325b6de4c4e3ad11bcc">Xdr::data</a> (std::string&amp; s, <span class="keyword">const</span> <span class="keywordtype">char</span>* comment)
<a name="l01544"></a>01544 {
<a name="l01545"></a>01545   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01546"></a>01546     {
<a name="l01547"></a>01547     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01548"></a>01548       {
<a name="l01549"></a>01549 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01550"></a>01550 <span class="preprocessor"></span>
<a name="l01551"></a>01551         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01552"></a>01552 
<a name="l01553"></a>01553         {
<a name="l01554"></a>01554           <span class="keywordtype">char</span>* sptr = <span class="keyword">new</span> <span class="keywordtype">char</span>[s.size()+1];
<a name="l01555"></a>01555 
<a name="l01556"></a>01556           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;s.size(); c++)
<a name="l01557"></a>01557             sptr[c] = s[c];
<a name="l01558"></a>01558         
<a name="l01559"></a>01559           sptr[s.size()] = <span class="charliteral">&#39;\0&#39;</span>;
<a name="l01560"></a>01560           
<a name="l01561"></a>01561           xdr_string(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>,
<a name="l01562"></a>01562                      &amp;sptr,
<a name="l01563"></a>01563                      std::strlen(sptr));
<a name="l01564"></a>01564 
<a name="l01565"></a>01565           <span class="keyword">delete</span> [] sptr;
<a name="l01566"></a>01566         }
<a name="l01567"></a>01567 
<a name="l01568"></a>01568 <span class="preprocessor">#else</span>
<a name="l01569"></a>01569 <span class="preprocessor"></span>        
<a name="l01570"></a>01570         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01571"></a>01571                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01572"></a>01572                   &lt;&lt; std::endl
<a name="l01573"></a>01573                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01574"></a>01574                   &lt;&lt; std::endl;
<a name="l01575"></a>01575 
<a name="l01576"></a>01576         libmesh_error();
<a name="l01577"></a>01577 
<a name="l01578"></a>01578 <span class="preprocessor">#endif</span>
<a name="l01579"></a>01579 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01580"></a>01580       }
<a name="l01581"></a>01581 
<a name="l01582"></a>01582     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01583"></a>01583       {
<a name="l01584"></a>01584 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01585"></a>01585 <span class="preprocessor"></span>
<a name="l01586"></a>01586         libmesh_assert (<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01587"></a>01587 
<a name="l01588"></a>01588         {
<a name="l01589"></a>01589           <span class="keywordtype">char</span>* sptr = <span class="keyword">new</span> <span class="keywordtype">char</span>[xdr_MAX_STRING_LENGTH];
<a name="l01590"></a>01590           
<a name="l01591"></a>01591           xdr_string(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>,
<a name="l01592"></a>01592                      &amp;sptr,
<a name="l01593"></a>01593                      xdr_MAX_STRING_LENGTH);
<a name="l01594"></a>01594 
<a name="l01595"></a>01595           s.resize(std::strlen(sptr));
<a name="l01596"></a>01596 
<a name="l01597"></a>01597           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;s.size(); c++)
<a name="l01598"></a>01598             s[c] = sptr[c];
<a name="l01599"></a>01599           
<a name="l01600"></a>01600           <span class="keyword">delete</span> [] sptr;  
<a name="l01601"></a>01601         }
<a name="l01602"></a>01602 
<a name="l01603"></a>01603 <span class="preprocessor">#else</span>
<a name="l01604"></a>01604 <span class="preprocessor"></span>        
<a name="l01605"></a>01605         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01606"></a>01606                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01607"></a>01607                   &lt;&lt; std::endl
<a name="l01608"></a>01608                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01609"></a>01609                   &lt;&lt; std::endl;
<a name="l01610"></a>01610 
<a name="l01611"></a>01611         libmesh_error();
<a name="l01612"></a>01612 
<a name="l01613"></a>01613 <span class="preprocessor">#endif</span>
<a name="l01614"></a>01614 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01615"></a>01615       }
<a name="l01616"></a>01616 
<a name="l01617"></a>01617     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01618"></a>01618       {
<a name="l01619"></a>01619         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01620"></a>01620 
<a name="l01621"></a>01621         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l01622"></a>01622 
<a name="l01623"></a>01623 <span class="comment">//#ifndef LIBMESH_BROKEN_IOSTREAM</span>
<a name="l01624"></a>01624 <span class="comment">//      s.clear();</span>
<a name="l01625"></a>01625 <span class="comment">//#else</span>
<a name="l01626"></a>01626         s = <span class="stringliteral">&quot;&quot;</span>;
<a name="l01627"></a>01627 <span class="comment">//#endif</span>
<a name="l01628"></a>01628 
<a name="l01629"></a>01629         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;std::strlen(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>); c++)
<a name="l01630"></a>01630           {
<a name="l01631"></a>01631             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>[c] == <span class="charliteral">&#39;\t&#39;</span>) 
<a name="l01632"></a>01632               <span class="keywordflow">break</span>;
<a name="l01633"></a>01633             
<a name="l01634"></a>01634             s.push_back(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>[c]);
<a name="l01635"></a>01635           }
<a name="l01636"></a>01636 
<a name="l01637"></a>01637         <span class="keywordflow">return</span>; 
<a name="l01638"></a>01638       }
<a name="l01639"></a>01639 
<a name="l01640"></a>01640     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01641"></a>01641       {
<a name="l01642"></a>01642         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01643"></a>01643 
<a name="l01644"></a>01644         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; s &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01645"></a>01645 
<a name="l01646"></a>01646         <span class="keywordflow">return</span>; 
<a name="l01647"></a>01647       }
<a name="l01648"></a>01648 
<a name="l01649"></a>01649     <span class="keywordflow">default</span>:
<a name="l01650"></a>01650       libmesh_error();
<a name="l01651"></a>01651     }
<a name="l01652"></a>01652 }
<a name="l01653"></a>01653 
<a name="l01654"></a>01654 
<a name="l01655"></a>01655 
<a name="l01656"></a>01656 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01657"></a><a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">01657</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">Xdr::data_stream</a> (T *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l01658"></a>01658 {
<a name="l01659"></a>01659   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01660"></a>01660     {
<a name="l01661"></a>01661     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01662"></a>01662       {
<a name="l01663"></a>01663 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01664"></a>01664 <span class="preprocessor"></span>
<a name="l01665"></a>01665         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01666"></a>01666 
<a name="l01667"></a>01667 
<a name="l01668"></a>01668         xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01669"></a>01669                    (<span class="keywordtype">char</span>*) val,
<a name="l01670"></a>01670                    len,
<a name="l01671"></a>01671                    <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l01672"></a>01672                    (xdrproc_t) xdr_u_int);
<a name="l01673"></a>01673 
<a name="l01674"></a>01674 <span class="preprocessor">#else</span>
<a name="l01675"></a>01675 <span class="preprocessor"></span>        
<a name="l01676"></a>01676         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01677"></a>01677                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01678"></a>01678                   &lt;&lt; std::endl
<a name="l01679"></a>01679                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01680"></a>01680                   &lt;&lt; std::endl;
<a name="l01681"></a>01681 
<a name="l01682"></a>01682         libmesh_error();
<a name="l01683"></a>01683 
<a name="l01684"></a>01684 <span class="preprocessor">#endif  </span>
<a name="l01685"></a>01685 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01686"></a>01686       }
<a name="l01687"></a>01687 
<a name="l01688"></a>01688     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01689"></a>01689       {
<a name="l01690"></a>01690 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01691"></a>01691 <span class="preprocessor"></span>
<a name="l01692"></a>01692         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01693"></a>01693 
<a name="l01694"></a>01694         <span class="keywordflow">if</span> (len &gt; 0)
<a name="l01695"></a>01695           xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01696"></a>01696                      (<span class="keywordtype">char</span>*) val,
<a name="l01697"></a>01697                      len,
<a name="l01698"></a>01698                      <span class="keyword">sizeof</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>),
<a name="l01699"></a>01699                      (xdrproc_t) xdr_u_int);
<a name="l01700"></a>01700         
<a name="l01701"></a>01701 <span class="preprocessor">#else</span>
<a name="l01702"></a>01702 <span class="preprocessor"></span>        
<a name="l01703"></a>01703         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01704"></a>01704                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01705"></a>01705                   &lt;&lt; std::endl
<a name="l01706"></a>01706                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01707"></a>01707                   &lt;&lt; std::endl;
<a name="l01708"></a>01708 
<a name="l01709"></a>01709         libmesh_error();
<a name="l01710"></a>01710 
<a name="l01711"></a>01711 <span class="preprocessor">#endif</span>
<a name="l01712"></a>01712 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01713"></a>01713       }
<a name="l01714"></a>01714 
<a name="l01715"></a>01715     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01716"></a>01716       {
<a name="l01717"></a>01717         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01718"></a>01718 
<a name="l01719"></a>01719         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01720"></a>01720           {
<a name="l01721"></a>01721             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01722"></a>01722             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; val[i];
<a name="l01723"></a>01723           }
<a name="l01724"></a>01724 
<a name="l01725"></a>01725         <span class="keywordflow">return</span>; 
<a name="l01726"></a>01726       }
<a name="l01727"></a>01727 
<a name="l01728"></a>01728     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01729"></a>01729       {
<a name="l01730"></a>01730         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01731"></a>01731 
<a name="l01732"></a>01732         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l01733"></a>01733           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01734"></a>01734             {
<a name="l01735"></a>01735               libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01736"></a>01736               *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; val[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01737"></a>01737             }
<a name="l01738"></a>01738         <span class="keywordflow">else</span>
<a name="l01739"></a>01739           {
<a name="l01740"></a>01740             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01741"></a>01741             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l01742"></a>01742               {
<a name="l01743"></a>01743                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l01744"></a>01744                   {
<a name="l01745"></a>01745                     libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01746"></a>01746                     *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; val[cnt++] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01747"></a>01747                   }
<a name="l01748"></a>01748                 libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01749"></a>01749                 *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01750"></a>01750               }
<a name="l01751"></a>01751           }
<a name="l01752"></a>01752 
<a name="l01753"></a>01753         <span class="keywordflow">return</span>; 
<a name="l01754"></a>01754       }
<a name="l01755"></a>01755 
<a name="l01756"></a>01756     <span class="keywordflow">default</span>:
<a name="l01757"></a>01757       libmesh_error();
<a name="l01758"></a>01758     }
<a name="l01759"></a>01759 }
<a name="l01760"></a>01760 
<a name="l01761"></a>01761 
<a name="l01762"></a>01762 
<a name="l01763"></a>01763 <span class="keyword">template</span> &lt;&gt;
<a name="l01764"></a><a class="code" href="classXdr.php#a1386a6bba8f20650d34bd3d1172e9fad">01764</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">Xdr::data_stream</a> (<span class="keywordtype">double</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l01765"></a>01765 {
<a name="l01766"></a>01766   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01767"></a>01767     {
<a name="l01768"></a>01768     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01769"></a>01769     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01770"></a>01770       {
<a name="l01771"></a>01771 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01772"></a>01772 <span class="preprocessor"></span>
<a name="l01773"></a>01773         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01774"></a>01774 
<a name="l01775"></a>01775         <span class="keywordflow">if</span> (len &gt; 0)
<a name="l01776"></a>01776           xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01777"></a>01777                      (<span class="keywordtype">char</span>*) val,
<a name="l01778"></a>01778                      len,
<a name="l01779"></a>01779                      <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l01780"></a>01780                      (xdrproc_t) xdr_double);
<a name="l01781"></a>01781         
<a name="l01782"></a>01782 <span class="preprocessor">#else</span>
<a name="l01783"></a>01783 <span class="preprocessor"></span>        
<a name="l01784"></a>01784         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01785"></a>01785                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01786"></a>01786                   &lt;&lt; std::endl
<a name="l01787"></a>01787                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01788"></a>01788                   &lt;&lt; std::endl;
<a name="l01789"></a>01789 
<a name="l01790"></a>01790         libmesh_error();
<a name="l01791"></a>01791 
<a name="l01792"></a>01792 <span class="preprocessor">#endif</span>
<a name="l01793"></a>01793 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01794"></a>01794       }
<a name="l01795"></a>01795 
<a name="l01796"></a>01796     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01797"></a>01797       {
<a name="l01798"></a>01798         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01799"></a>01799 
<a name="l01800"></a>01800         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01801"></a>01801           {
<a name="l01802"></a>01802             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01803"></a>01803             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; val[i];
<a name="l01804"></a>01804           }
<a name="l01805"></a>01805 
<a name="l01806"></a>01806         <span class="keywordflow">return</span>; 
<a name="l01807"></a>01807       }
<a name="l01808"></a>01808 
<a name="l01809"></a>01809     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01810"></a>01810       {
<a name="l01811"></a>01811         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01812"></a>01812 
<a name="l01813"></a>01813         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l01814"></a>01814           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01815"></a>01815             {
<a name="l01816"></a>01816               libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01817"></a>01817               OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[i]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01818"></a>01818             }
<a name="l01819"></a>01819         <span class="keywordflow">else</span>
<a name="l01820"></a>01820           {
<a name="l01821"></a>01821             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01822"></a>01822             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l01823"></a>01823               {
<a name="l01824"></a>01824                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l01825"></a>01825                   {
<a name="l01826"></a>01826                     libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01827"></a>01827                     OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[cnt++]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01828"></a>01828                   }
<a name="l01829"></a>01829                 libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01830"></a>01830                 *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01831"></a>01831               }
<a name="l01832"></a>01832           }
<a name="l01833"></a>01833 
<a name="l01834"></a>01834         <span class="keywordflow">return</span>; 
<a name="l01835"></a>01835       }
<a name="l01836"></a>01836 
<a name="l01837"></a>01837     <span class="keywordflow">default</span>:
<a name="l01838"></a>01838       libmesh_error();
<a name="l01839"></a>01839     }
<a name="l01840"></a>01840 }
<a name="l01841"></a>01841 
<a name="l01842"></a>01842 
<a name="l01843"></a>01843 <span class="keyword">template</span> &lt;&gt;
<a name="l01844"></a><a class="code" href="classXdr.php#ab3cd01ff5491a68202a851c926727c81">01844</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">Xdr::data_stream</a> (<span class="keywordtype">long</span> <span class="keywordtype">double</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l01845"></a>01845 {
<a name="l01846"></a>01846   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01847"></a>01847     {
<a name="l01848"></a>01848     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01849"></a>01849     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01850"></a>01850       {
<a name="l01851"></a>01851 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01852"></a>01852 <span class="preprocessor"></span>
<a name="l01853"></a>01853         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01854"></a>01854 
<a name="l01855"></a>01855         <span class="comment">// FIXME[JWP]: How to implement this for long double?  Mac OS</span>
<a name="l01856"></a>01856         <span class="comment">// X defines &#39;xdr_quadruple&#39; but AFAICT, it does not exist for</span>
<a name="l01857"></a>01857         <span class="comment">// Linux... for now, reading/writing XDR files with long</span>
<a name="l01858"></a>01858         <span class="comment">// doubles is disabled, but you can still write long double</span>
<a name="l01859"></a>01859         <span class="comment">// ASCII files of course.</span>
<a name="l01860"></a>01860         <span class="comment">// if (len &gt; 0)</span>
<a name="l01861"></a>01861         <span class="comment">//   xdr_vector(xdrs, </span>
<a name="l01862"></a>01862         <span class="comment">//           (char*) val,</span>
<a name="l01863"></a>01863         <span class="comment">//           len,</span>
<a name="l01864"></a>01864         <span class="comment">//           sizeof(double),</span>
<a name="l01865"></a>01865         <span class="comment">//           (xdrproc_t) xdr_quadruple);</span>
<a name="l01866"></a>01866 
<a name="l01867"></a>01867         std::cerr &lt;&lt; <span class="stringliteral">&quot;Writing binary XDR files with long double&#39;s is not\n&quot;</span>
<a name="l01868"></a>01868                   &lt;&lt; <span class="stringliteral">&quot;currently supported on all platforms.&quot;</span> &lt;&lt; std::endl;
<a name="l01869"></a>01869 
<a name="l01870"></a>01870         libmesh_error();
<a name="l01871"></a>01871         
<a name="l01872"></a>01872 <span class="preprocessor">#else</span>
<a name="l01873"></a>01873 <span class="preprocessor"></span>        
<a name="l01874"></a>01874         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01875"></a>01875                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01876"></a>01876                   &lt;&lt; std::endl
<a name="l01877"></a>01877                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01878"></a>01878                   &lt;&lt; std::endl;
<a name="l01879"></a>01879 
<a name="l01880"></a>01880         libmesh_error();
<a name="l01881"></a>01881 
<a name="l01882"></a>01882 <span class="preprocessor">#endif</span>
<a name="l01883"></a>01883 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01884"></a>01884       }
<a name="l01885"></a>01885 
<a name="l01886"></a>01886     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01887"></a>01887       {
<a name="l01888"></a>01888         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01889"></a>01889 
<a name="l01890"></a>01890         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01891"></a>01891           {
<a name="l01892"></a>01892             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01893"></a>01893             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; val[i];
<a name="l01894"></a>01894           }
<a name="l01895"></a>01895 
<a name="l01896"></a>01896         <span class="keywordflow">return</span>; 
<a name="l01897"></a>01897       }
<a name="l01898"></a>01898 
<a name="l01899"></a>01899     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l01900"></a>01900       {
<a name="l01901"></a>01901         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01902"></a>01902 
<a name="l01903"></a>01903         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l01904"></a>01904           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01905"></a>01905             {
<a name="l01906"></a>01906               libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01907"></a>01907               OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[i]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01908"></a>01908             }
<a name="l01909"></a>01909         <span class="keywordflow">else</span>
<a name="l01910"></a>01910           {
<a name="l01911"></a>01911             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l01912"></a>01912             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l01913"></a>01913               {
<a name="l01914"></a>01914                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l01915"></a>01915                   {
<a name="l01916"></a>01916                     libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01917"></a>01917                     OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[cnt++]) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l01918"></a>01918                   }
<a name="l01919"></a>01919                 libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l01920"></a>01920                 *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l01921"></a>01921               }
<a name="l01922"></a>01922           }
<a name="l01923"></a>01923 
<a name="l01924"></a>01924         <span class="keywordflow">return</span>; 
<a name="l01925"></a>01925       }
<a name="l01926"></a>01926 
<a name="l01927"></a>01927     <span class="keywordflow">default</span>:
<a name="l01928"></a>01928       libmesh_error();
<a name="l01929"></a>01929     }
<a name="l01930"></a>01930 }
<a name="l01931"></a>01931 
<a name="l01932"></a>01932 
<a name="l01933"></a>01933 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l01934"></a>01934 <span class="preprocessor"></span><span class="keyword">template</span> &lt;&gt;
<a name="l01935"></a><a class="code" href="classXdr.php#a0b690f56adeb8a7f1a4f6944891e8354">01935</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#a4078d136e6c78973c278ff3e073a8e7a">Xdr::data_stream</a> (std::complex&lt;double&gt; *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break)
<a name="l01936"></a>01936 {
<a name="l01937"></a>01937   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l01938"></a>01938     {
<a name="l01939"></a>01939     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l01940"></a>01940     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l01941"></a>01941       {
<a name="l01942"></a>01942 <span class="preprocessor">#ifdef LIBMESH_HAVE_XDR</span>
<a name="l01943"></a>01943 <span class="preprocessor"></span>
<a name="l01944"></a>01944         libmesh_assert (this-&gt;<a class="code" href="classXdr.php#ae11106c94888dd6b9eb65a565665307a">is_open</a>());
<a name="l01945"></a>01945 
<a name="l01946"></a>01946 
<a name="l01947"></a>01947         <span class="keywordflow">if</span> (len &gt; 0)
<a name="l01948"></a>01948           {
<a name="l01949"></a>01949             std::vector&lt;double&gt; io_buffer (2*len);
<a name="l01950"></a>01950             
<a name="l01951"></a>01951             <span class="comment">// Fill io_buffer if we are writing.</span>
<a name="l01952"></a>01952             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>)
<a name="l01953"></a>01953               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, cnt=0; i&lt;len; i++)
<a name="l01954"></a>01954                 {
<a name="l01955"></a>01955                   io_buffer[cnt++] = val[i].real();
<a name="l01956"></a>01956                   io_buffer[cnt++] = val[i].imag();
<a name="l01957"></a>01957                 } 
<a name="l01958"></a>01958               
<a name="l01959"></a>01959             xdr_vector(<a class="code" href="classXdr.php#a21ca4d7fc244188c003f25eb2835aaff">xdrs</a>, 
<a name="l01960"></a>01960                        (<span class="keywordtype">char</span>*) &amp;io_buffer[0],
<a name="l01961"></a>01961                        2*len,
<a name="l01962"></a>01962                        <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>),
<a name="l01963"></a>01963                        (xdrproc_t) xdr_double);
<a name="l01964"></a>01964             
<a name="l01965"></a>01965             <span class="comment">// Fill val array if we are reading.</span>
<a name="l01966"></a>01966             <span class="keywordflow">if</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a> == <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>)
<a name="l01967"></a>01967               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, cnt=0; i&lt;len; i++)
<a name="l01968"></a>01968                 {
<a name="l01969"></a>01969                   val[i].real() = io_buffer[cnt++];
<a name="l01970"></a>01970                   val[i].imag() = io_buffer[cnt++];
<a name="l01971"></a>01971                 } 
<a name="l01972"></a>01972           }
<a name="l01973"></a>01973 <span class="preprocessor">#else</span>
<a name="l01974"></a>01974 <span class="preprocessor"></span>        
<a name="l01975"></a>01975         std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: Functionality is not available.&quot;</span> &lt;&lt; std::endl
<a name="l01976"></a>01976                   &lt;&lt; <span class="stringliteral">&quot;Make sure LIBMESH_HAVE_XDR is defined at build time&quot;</span> 
<a name="l01977"></a>01977                   &lt;&lt; std::endl
<a name="l01978"></a>01978                   &lt;&lt; <span class="stringliteral">&quot;The XDR interface is not available in this installation&quot;</span>
<a name="l01979"></a>01979                   &lt;&lt; std::endl;
<a name="l01980"></a>01980 
<a name="l01981"></a>01981         libmesh_error();
<a name="l01982"></a>01982 
<a name="l01983"></a>01983 <span class="preprocessor">#endif</span>
<a name="l01984"></a>01984 <span class="preprocessor"></span>        <span class="keywordflow">return</span>;
<a name="l01985"></a>01985       }
<a name="l01986"></a>01986 
<a name="l01987"></a>01987     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l01988"></a>01988       {
<a name="l01989"></a>01989         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01990"></a>01990 
<a name="l01991"></a>01991         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l01992"></a>01992           {
<a name="l01993"></a>01993             libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l01994"></a>01994             *<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a> &gt;&gt; val[i].real() &gt;&gt; val[i].imag();
<a name="l01995"></a>01995           }
<a name="l01996"></a>01996 
<a name="l01997"></a>01997         <span class="keywordflow">return</span>; 
<a name="l01998"></a>01998       }
<a name="l01999"></a>01999 
<a name="l02000"></a>02000     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l02001"></a>02001       {
<a name="l02002"></a>02002         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02003"></a>02003 
<a name="l02004"></a>02004         <span class="keywordflow">if</span> (line_break == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l02005"></a>02005           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;len; i++)
<a name="l02006"></a>02006             {
<a name="l02007"></a>02007               libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02008"></a>02008               OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[i].real()) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02009"></a>02009               OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[i].imag()) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02010"></a>02010             }
<a name="l02011"></a>02011         <span class="keywordflow">else</span>
<a name="l02012"></a>02012           {
<a name="l02013"></a>02013             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0;
<a name="l02014"></a>02014             <span class="keywordflow">while</span> (cnt &lt; len)
<a name="l02015"></a>02015               {
<a name="l02016"></a>02016                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(line_break,len); i++)
<a name="l02017"></a>02017                   {
<a name="l02018"></a>02018                     libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02019"></a>02019                     OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[cnt].real()) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02020"></a>02020                     OFSRealscientific(*<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>,17,val[cnt].imag()) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l02021"></a>02021                     cnt++;
<a name="l02022"></a>02022                   }
<a name="l02023"></a>02023                 libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02024"></a>02024                 *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l02025"></a>02025               }
<a name="l02026"></a>02026           }
<a name="l02027"></a>02027 
<a name="l02028"></a>02028         <span class="keywordflow">return</span>; 
<a name="l02029"></a>02029       }
<a name="l02030"></a>02030 
<a name="l02031"></a>02031     <span class="keywordflow">default</span>:
<a name="l02032"></a>02032       libmesh_error();
<a name="l02033"></a>02033     }
<a name="l02034"></a>02034 }
<a name="l02035"></a>02035 <span class="preprocessor">#endif // # LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l02036"></a>02036 <span class="preprocessor"></span>
<a name="l02037"></a><a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">02037</a> <span class="keywordtype">void</span> <a class="code" href="classXdr.php#ae207fb366547ff14903d254281b535d6">Xdr::comment</a> (std::string &amp;comment)
<a name="l02038"></a>02038 {
<a name="l02039"></a>02039   <span class="keywordflow">switch</span> (<a class="code" href="classXdr.php#a03cdd5dcc8d5a7f5ce281882c6732104">mode</a>)
<a name="l02040"></a>02040     {
<a name="l02041"></a>02041     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>:
<a name="l02042"></a>02042     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>:
<a name="l02043"></a>02043       {
<a name="l02044"></a>02044         <span class="keywordflow">return</span>;
<a name="l02045"></a>02045       }
<a name="l02046"></a>02046 
<a name="l02047"></a>02047     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>:
<a name="l02048"></a>02048       {
<a name="l02049"></a>02049         libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;good());
<a name="l02050"></a>02050         <a class="code" href="classXdr.php#a29440f2215f33f7a1b7392727e2cd0fc">in</a>-&gt;getline(<a class="code" href="classXdr.php#a81450b392666e82559afab3676c1adda">comm</a>, <a class="code" href="classXdr.php#a4165407163334f62a2c3f6996bac9285">comm_len</a>);
<a name="l02051"></a>02051         <span class="keywordflow">return</span>; 
<a name="l02052"></a>02052       }
<a name="l02053"></a>02053 
<a name="l02054"></a>02054     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>:
<a name="l02055"></a>02055       {
<a name="l02056"></a>02056         libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>.<a class="code" href="classAutoPtr.php#a32de0542c58dce03bffe7c83a1dc20ce" title="Bypassing the smart pointer.">get</a>() != NULL); libmesh_assert (<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a>-&gt;good());
<a name="l02057"></a>02057         *<a class="code" href="classXdr.php#ac8b99a9e0ba83b13331df17e56f49b1e">out</a> &lt;&lt; <span class="stringliteral">&quot;\t &quot;</span> &lt;&lt; comment &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l02058"></a>02058         <span class="keywordflow">return</span>; 
<a name="l02059"></a>02059       }
<a name="l02060"></a>02060 
<a name="l02061"></a>02061     <span class="keywordflow">default</span>:
<a name="l02062"></a>02062       libmesh_error();
<a name="l02063"></a>02063     }
<a name="l02064"></a>02064 }
<a name="l02065"></a>02065 
<a name="l02066"></a>02066 
<a name="l02067"></a>02067 <span class="preprocessor">#undef xdr_REAL</span>
<a name="l02068"></a>02068 <span class="preprocessor"></span>
<a name="l02069"></a>02069 
<a name="l02070"></a>02070 <span class="comment">//</span>
<a name="l02071"></a>02071 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data_stream&lt;int&gt;          (<span class="keywordtype">int</span> *val,          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break);
<a name="l02072"></a>02072 <span class="keyword">template</span> <span class="keywordtype">void</span> Xdr::data_stream&lt;unsigned int&gt; (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *val, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> line_break);
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
